/*
 * Copyright (C) Jan 2013 Mellanox Technologies Ltd. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/***
 *** This file was generated at "2015-06-17 12:05:31"
 *** by:
 ***    > /mswg/release/eat_me/last_release/adabe_plugins/adb2c/adb2pack.py --input adb/connectib/connectib.adb --file-prefix connectib --prefix connectib_
 ***/
#include "connectib_layouts.h"

void connectib_dw_pack(const struct connectib_dw *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dw);

}

void connectib_dw_unpack(struct connectib_dw *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dw = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_dw_print(const struct connectib_dw *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dw ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dw                   : "U32H_FMT"\n", ptr_struct->dw);

}

int connectib_dw_size(void){
	 return 4;
}

void connectib_dw_dump(const struct connectib_dw *ptr_struct, FILE* file) {
	connectib_dw_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_nvlog_pack(const struct connectib_nv_tlv_type_nvlog *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->parameter_index);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sub_class);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_nvlog_unpack(struct connectib_nv_tlv_type_nvlog *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->parameter_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=8;
	ptr_struct->sub_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_nvlog_print(const struct connectib_nv_tlv_type_nvlog *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_nvlog ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_class            : "UH_FMT"\n", ptr_struct->sub_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_nvlog_size(void){
	 return 4;
}

void connectib_nv_tlv_type_nvlog_dump(const struct connectib_nv_tlv_type_nvlog *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_nvlog_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_eswitch_pack(const struct connectib_nv_tlv_type_eswitch *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->parameter_index);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->port);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->host);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_eswitch_unpack(struct connectib_nv_tlv_type_eswitch *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->parameter_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=14;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->host = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_eswitch_print(const struct connectib_nv_tlv_type_eswitch *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_eswitch ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host                 : "UH_FMT"\n", ptr_struct->host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_eswitch_size(void){
	 return 4;
}

void connectib_nv_tlv_type_eswitch_dump(const struct connectib_nv_tlv_type_eswitch *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_eswitch_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_per_host_pack(const struct connectib_nv_tlv_type_per_host *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->parameter_index);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->function);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->host);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_per_host_unpack(struct connectib_nv_tlv_type_per_host *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	ptr_struct->parameter_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=14;
	ptr_struct->function = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->host = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_per_host_print(const struct connectib_nv_tlv_type_per_host *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_per_host ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "function             : "UH_FMT"\n", ptr_struct->function);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host                 : "UH_FMT"\n", ptr_struct->host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_per_host_size(void){
	 return 4;
}

void connectib_nv_tlv_type_per_host_dump(const struct connectib_nv_tlv_type_per_host *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_per_host_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_bmc_pack(const struct connectib_nv_tlv_type_bmc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->parameter_index);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->channel);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->host);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_bmc_unpack(struct connectib_nv_tlv_type_bmc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=19;
	ptr_struct->parameter_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset=14;
	ptr_struct->channel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=8;
	ptr_struct->host = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_bmc_print(const struct connectib_nv_tlv_type_bmc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_bmc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "channel              : "UH_FMT"\n", ptr_struct->channel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host                 : "UH_FMT"\n", ptr_struct->host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_bmc_size(void){
	 return 4;
}

void connectib_nv_tlv_type_bmc_dump(const struct connectib_nv_tlv_type_bmc *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_bmc_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_physical_port_pack(const struct connectib_nv_tlv_type_physical_port *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->parameter_index);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_physical_port_unpack(struct connectib_nv_tlv_type_physical_port *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->parameter_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=8;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_physical_port_print(const struct connectib_nv_tlv_type_physical_port *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_physical_port ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_physical_port_size(void){
	 return 4;
}

void connectib_nv_tlv_type_physical_port_dump(const struct connectib_nv_tlv_type_physical_port *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_physical_port_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_global_pack(const struct connectib_nv_tlv_type_global *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->parameter_index);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

}

void connectib_nv_tlv_type_global_unpack(struct connectib_nv_tlv_type_global *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->parameter_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_nv_tlv_type_global_print(const struct connectib_nv_tlv_type_global *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type_global ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parameter_index      : "UH_FMT"\n", ptr_struct->parameter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

}

int connectib_nv_tlv_type_global_size(void){
	 return 4;
}

void connectib_nv_tlv_type_global_dump(const struct connectib_nv_tlv_type_global *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_global_print(ptr_struct, file, 0);
}

void connectib_uint64_pack(const struct connectib_uint64 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hi);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->lo);

}

void connectib_uint64_unpack(struct connectib_uint64 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_uint64_print(const struct connectib_uint64 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_uint64 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hi                   : "U32H_FMT"\n", ptr_struct->hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lo                   : "U32H_FMT"\n", ptr_struct->lo);

}

int connectib_uint64_size(void){
	 return 8;
}

void connectib_uint64_dump(const struct connectib_uint64 *ptr_struct, FILE* file) {
	connectib_uint64_print(ptr_struct, file, 0);
}

void connectib_dcr_qp_pack(const struct connectib_dcr_qp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gb_first_psn);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gb_last_psn);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_gb);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->reconnect_ack_psn);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dcr_heartbeat_clr_timestamp);

}

void connectib_dcr_qp_unpack(struct connectib_dcr_qp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->gb_first_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=40;
	ptr_struct->gb_last_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=39;
	ptr_struct->is_gb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=72;
	ptr_struct->reconnect_ack_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->dcr_heartbeat_clr_timestamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_dcr_qp_print(const struct connectib_dcr_qp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dcr_qp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gb_first_psn         : "UH_FMT"\n", ptr_struct->gb_first_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gb_last_psn          : "UH_FMT"\n", ptr_struct->gb_last_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_gb                : "UH_FMT"\n", ptr_struct->is_gb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reconnect_ack_psn    : "UH_FMT"\n", ptr_struct->reconnect_ack_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_heartbeat_clr_timestamp : "U32H_FMT"\n", ptr_struct->dcr_heartbeat_clr_timestamp);

}

int connectib_dcr_qp_size(void){
	 return 16;
}

void connectib_dcr_qp_dump(const struct connectib_dcr_qp *ptr_struct, FILE* file) {
	connectib_dcr_qp_print(ptr_struct, file, 0);
}

void connectib_regular_qp_pack(const struct connectib_regular_qp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ds_exceeds_pi_retries);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_access_key_violation_count_state);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pm_state);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->req_retrans_is_rdma_read);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invalid_user_index);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->xport_retry_counter);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->xport_retry_limit);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rnr_retry_counter);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rnr_retry_limit);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rq_head_qpn);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cmdif_entry_ix);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dc_access_key_violation_count);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sw_uar);

}

void connectib_regular_qp_unpack(struct connectib_regular_qp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->ds_exceeds_pi_retries = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=26;
	ptr_struct->dc_access_key_violation_count_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->pm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=21;
	ptr_struct->req_retrans_is_rdma_read = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->invalid_user_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->xport_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=8;
	ptr_struct->xport_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=4;
	ptr_struct->rnr_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->rnr_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=40;
	ptr_struct->rq_head_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->cmdif_entry_ix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->dc_access_key_violation_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=104;
	ptr_struct->sw_uar = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_regular_qp_print(const struct connectib_regular_qp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_regular_qp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ds_exceeds_pi_retries : "UH_FMT"\n", ptr_struct->ds_exceeds_pi_retries);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_access_key_violation_count_state : "UH_FMT"\n", ptr_struct->dc_access_key_violation_count_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pm_state             : "UH_FMT"\n", ptr_struct->pm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_retrans_is_rdma_read : "UH_FMT"\n", ptr_struct->req_retrans_is_rdma_read);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invalid_user_index   : "UH_FMT"\n", ptr_struct->invalid_user_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xport_retry_counter  : "UH_FMT"\n", ptr_struct->xport_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xport_retry_limit    : "UH_FMT"\n", ptr_struct->xport_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_retry_counter    : "UH_FMT"\n", ptr_struct->rnr_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_retry_limit      : "UH_FMT"\n", ptr_struct->rnr_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq_head_qpn          : "UH_FMT"\n", ptr_struct->rq_head_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmdif_entry_ix       : "UH_FMT"\n", ptr_struct->cmdif_entry_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_access_key_violation_count : "U32H_FMT"\n", ptr_struct->dc_access_key_violation_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_uar               : "UH_FMT"\n", ptr_struct->sw_uar);

}

int connectib_regular_qp_size(void){
	 return 16;
}

void connectib_regular_qp_dump(const struct connectib_regular_qp *ptr_struct, FILE* file) {
	connectib_regular_qp_print(ptr_struct, file, 0);
}

void connectib_schedint_cause_pack(const struct connectib_schedint_cause *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clear_all_causes);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->schedint_destroy_qp);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->schedint_qp_flush);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->schedint_apm);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->schedint_duplicate);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->schedint_ud_sl_diff);

}

void connectib_schedint_cause_unpack(struct connectib_schedint_cause *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	ptr_struct->clear_all_causes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->schedint_destroy_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->schedint_qp_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->schedint_apm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->schedint_duplicate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->schedint_ud_sl_diff = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_schedint_cause_print(const struct connectib_schedint_cause *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_schedint_cause ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clear_all_causes     : "UH_FMT"\n", ptr_struct->clear_all_causes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_destroy_qp  : "UH_FMT"\n", ptr_struct->schedint_destroy_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_qp_flush    : "UH_FMT"\n", ptr_struct->schedint_qp_flush);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_apm         : "UH_FMT"\n", ptr_struct->schedint_apm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_duplicate   : "UH_FMT"\n", ptr_struct->schedint_duplicate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_ud_sl_diff  : "UH_FMT"\n", ptr_struct->schedint_ud_sl_diff);

}

int connectib_schedint_cause_size(void){
	 return 1;
}

void connectib_schedint_cause_dump(const struct connectib_schedint_cause *ptr_struct, FILE* file) {
	connectib_schedint_cause_print(ptr_struct, file, 0);
}

void connectib_hw_msix_context_data0_pack(const struct connectib_hw_msix_context_data0 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data);

}

void connectib_hw_msix_context_data0_unpack(struct connectib_hw_msix_context_data0 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_msix_context_data0_print(const struct connectib_hw_msix_context_data0 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_msix_context_data0 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data                 : "U32H_FMT"\n", ptr_struct->data);

}

int connectib_hw_msix_context_data0_size(void){
	 return 4;
}

void connectib_hw_msix_context_data0_dump(const struct connectib_hw_msix_context_data0 *ptr_struct, FILE* file) {
	connectib_hw_msix_context_data0_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_generic_headers_pack(const struct connectib_hw_ste_tag_generic_headers *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->dword_select_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword_select);

}

void connectib_hw_ste_tag_generic_headers_unpack(struct connectib_hw_ste_tag_generic_headers *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dword_select_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->dword_select = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_ste_tag_generic_headers_print(const struct connectib_hw_ste_tag_generic_headers *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_generic_headers ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_select_valid   : "UH_FMT"\n", ptr_struct->dword_select_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_select         : "U32H_FMT"\n", ptr_struct->dword_select);

}

int connectib_hw_ste_tag_generic_headers_size(void){
	 return 16;
}

void connectib_hw_ste_tag_generic_headers_dump(const struct connectib_hw_ste_tag_generic_headers *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_generic_headers_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_port_pack(const struct connectib_hw_ste_tag_port *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bth);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->qp_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_sniffer);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_lb);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->func_lb);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->multicast);

}

void connectib_hw_ste_tag_port_unpack(struct connectib_hw_ste_tag_port *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=19;
	ptr_struct->grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->bth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->qp_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->sx_sniffer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->force_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->func_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_ste_tag_port_print(const struct connectib_hw_ste_tag_port *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_port ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh                  : "UH_FMT"\n", ptr_struct->grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bth                  : "UH_FMT"\n", ptr_struct->bth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_type              : "UH_FMT"\n", ptr_struct->qp_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_sniffer           : "UH_FMT"\n", ptr_struct->sx_sniffer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_lb             : "UH_FMT"\n", ptr_struct->force_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "func_lb              : "UH_FMT"\n", ptr_struct->func_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "multicast            : "UH_FMT"\n", ptr_struct->multicast);

}

int connectib_hw_ste_tag_port_size(void){
	 return 16;
}

void connectib_hw_ste_tag_port_dump(const struct connectib_hw_ste_tag_port *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_port_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_source_gvmi_qp_pack(const struct connectib_hw_ste_tag_source_gvmi_qp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->source_gvmi);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->source_qp);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->source_is_requestor);

}

void connectib_hw_ste_tag_source_gvmi_qp_unpack(struct connectib_hw_ste_tag_source_gvmi_qp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->source_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->source_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=39;
	ptr_struct->source_is_requestor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_ste_tag_source_gvmi_qp_print(const struct connectib_hw_ste_tag_source_gvmi_qp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_source_gvmi_qp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_gvmi          : "UH_FMT"\n", ptr_struct->source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_qp            : "UH_FMT"\n", ptr_struct->source_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_is_requestor  : "UH_FMT"\n", ptr_struct->source_is_requestor);

}

int connectib_hw_ste_tag_source_gvmi_qp_size(void){
	 return 16;
}

void connectib_hw_ste_tag_source_gvmi_qp_dump(const struct connectib_hw_ste_tag_source_gvmi_qp *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_source_gvmi_qp_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_ib_l4_pack(const struct connectib_hw_ste_tag_ib_l4 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dest_qp);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

}

void connectib_hw_ste_tag_ib_l4_unpack(struct connectib_hw_ste_tag_ib_l4 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->dest_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=48;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_hw_ste_tag_ib_l4_print(const struct connectib_hw_ste_tag_ib_l4 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_ib_l4 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dest_qp              : "UH_FMT"\n", ptr_struct->dest_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : "UH_FMT"\n", ptr_struct->pkey);

}

int connectib_hw_ste_tag_ib_l4_size(void){
	 return 16;
}

void connectib_hw_ste_tag_ib_l4_dump(const struct connectib_hw_ste_tag_ib_l4 *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_ib_l4_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_ib_l3_pack(const struct connectib_hw_ste_tag_ib_l3 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dgid_127_96);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dgid_95_64);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dgid_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dgid_31_0);

}

void connectib_hw_ste_tag_ib_l3_unpack(struct connectib_hw_ste_tag_ib_l3 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dgid_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->dgid_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->dgid_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->dgid_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_ste_tag_ib_l3_print(const struct connectib_hw_ste_tag_ib_l3 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_ib_l3 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid_127_96          : "U32H_FMT"\n", ptr_struct->dgid_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid_95_64           : "U32H_FMT"\n", ptr_struct->dgid_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid_63_32           : "U32H_FMT"\n", ptr_struct->dgid_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid_31_0            : "U32H_FMT"\n", ptr_struct->dgid_31_0);

}

int connectib_hw_ste_tag_ib_l3_size(void){
	 return 16;
}

void connectib_hw_ste_tag_ib_l3_dump(const struct connectib_hw_ste_tag_ib_l3 *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_ib_l3_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_ib_l3_extended_pack(const struct connectib_hw_ste_tag_ib_l3_extended *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->traffic_class);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dceth_complete);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->deth_complete);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bth_complete);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ip_version);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qkey_dc_access_key_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qkey_dc_access_key_31_0);

}

void connectib_hw_ste_tag_ib_l3_extended_unpack(struct connectib_hw_ste_tag_ib_l3_extended *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=8;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->traffic_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=35;
	ptr_struct->dceth_complete = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=34;
	ptr_struct->deth_complete = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->bth_complete = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->ip_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->qkey_dc_access_key_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->qkey_dc_access_key_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_ste_tag_ib_l3_extended_print(const struct connectib_hw_ste_tag_ib_l3_extended *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_ib_l3_extended ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "traffic_class        : "UH_FMT"\n", ptr_struct->traffic_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : "UH_FMT"\n", ptr_struct->pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dceth_complete       : "UH_FMT"\n", ptr_struct->dceth_complete);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "deth_complete        : "UH_FMT"\n", ptr_struct->deth_complete);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bth_complete         : "UH_FMT"\n", ptr_struct->bth_complete);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ip_version           : "UH_FMT"\n", ptr_struct->ip_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey_dc_access_key_63_32 : "U32H_FMT"\n", ptr_struct->qkey_dc_access_key_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey_dc_access_key_31_0 : "U32H_FMT"\n", ptr_struct->qkey_dc_access_key_31_0);

}

int connectib_hw_ste_tag_ib_l3_extended_size(void){
	 return 16;
}

void connectib_hw_ste_tag_ib_l3_extended_dump(const struct connectib_hw_ste_tag_ib_l3_extended *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_ib_l3_extended_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_ib_l2_pack(const struct connectib_hw_ste_tag_ib_l2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dlid);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bth);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->qp_type);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->multicast);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwh_ethertype);

}

void connectib_hw_ste_tag_ib_l2_unpack(struct connectib_hw_ste_tag_ib_l2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->dlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=15;
	ptr_struct->grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->bth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->qp_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=76;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=112;
	ptr_struct->rwh_ethertype = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_hw_ste_tag_ib_l2_print(const struct connectib_hw_ste_tag_ib_l2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_ib_l2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dlid                 : "UH_FMT"\n", ptr_struct->dlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh                  : "UH_FMT"\n", ptr_struct->grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bth                  : "UH_FMT"\n", ptr_struct->bth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_type              : "UH_FMT"\n", ptr_struct->qp_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "multicast            : "UH_FMT"\n", ptr_struct->multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwh_ethertype        : "UH_FMT"\n", ptr_struct->rwh_ethertype);

}

int connectib_hw_ste_tag_ib_l2_size(void){
	 return 16;
}

void connectib_hw_ste_tag_ib_l2_dump(const struct connectib_hw_ste_tag_ib_l2 *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_ib_l2_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_bulk_pack(const struct connectib_hw_ste_tag_bulk *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tag_127_96);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tag_95_64);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tag_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tag_31_0);

}

void connectib_hw_ste_tag_bulk_unpack(struct connectib_hw_ste_tag_bulk *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->tag_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->tag_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->tag_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->tag_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_ste_tag_bulk_print(const struct connectib_hw_ste_tag_bulk *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag_bulk ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_127_96           : "U32H_FMT"\n", ptr_struct->tag_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_95_64            : "U32H_FMT"\n", ptr_struct->tag_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_63_32            : "U32H_FMT"\n", ptr_struct->tag_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_31_0             : "U32H_FMT"\n", ptr_struct->tag_31_0);

}

int connectib_hw_ste_tag_bulk_size(void){
	 return 16;
}

void connectib_hw_ste_tag_bulk_dump(const struct connectib_hw_ste_tag_bulk *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_bulk_print(ptr_struct, file, 0);
}

void connectib_hw_transaction_pdf_pack(const struct connectib_hw_transaction_pdf *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invert_data_bits);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_data_bits);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->seed);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_crc_bytes);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_crc_bits);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invert_crc);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sig_zones_covered);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sig_type);

}

void connectib_hw_transaction_pdf_unpack(struct connectib_hw_transaction_pdf *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	ptr_struct->invert_data_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->swap_data_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->seed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->swap_crc_bytes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->swap_crc_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->invert_crc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->sig_zones_covered = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->sig_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_transaction_pdf_print(const struct connectib_hw_transaction_pdf *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_transaction_pdf ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invert_data_bits     : "UH_FMT"\n", ptr_struct->invert_data_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_bits       : "UH_FMT"\n", ptr_struct->swap_data_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "seed                 : "UH_FMT"\n", ptr_struct->seed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_crc_bytes       : "UH_FMT"\n", ptr_struct->swap_crc_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_crc_bits        : "UH_FMT"\n", ptr_struct->swap_crc_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invert_crc           : "UH_FMT"\n", ptr_struct->invert_crc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sig_zones_covered    : "UH_FMT"\n", ptr_struct->sig_zones_covered);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sig_type             : "UH_FMT"\n", ptr_struct->sig_type);

}

int connectib_hw_transaction_pdf_size(void){
	 return 8;
}

void connectib_hw_transaction_pdf_dump(const struct connectib_hw_transaction_pdf *ptr_struct, FILE* file) {
	connectib_hw_transaction_pdf_print(ptr_struct, file, 0);
}

void connectib_hw_pdf_decoder_pack(const struct connectib_hw_pdf_decoder *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invert_data_bits);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_data_bits);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->seed);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_crc_bytes);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->swap_crc_bits);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invert_crc);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->regular);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sig_type);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dif_app_tag_bit_check_en);

	offset=46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dif_guard_check_type);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dif_learn_mode);

	offset=43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dif_learn_app_tag);

	offset=42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dif_learn_ref_tag);

	offset=41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dif_inc_ref_tag);

}

void connectib_hw_pdf_decoder_unpack(struct connectib_hw_pdf_decoder *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	ptr_struct->invert_data_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->swap_data_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->seed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->swap_crc_bytes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->swap_crc_bits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->invert_crc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->regular = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->sig_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->dif_app_tag_bit_check_en = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=46;
	ptr_struct->dif_guard_check_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=44;
	ptr_struct->dif_learn_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=43;
	ptr_struct->dif_learn_app_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=42;
	ptr_struct->dif_learn_ref_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=41;
	ptr_struct->dif_inc_ref_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_pdf_decoder_print(const struct connectib_hw_pdf_decoder *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_pdf_decoder ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invert_data_bits     : "UH_FMT"\n", ptr_struct->invert_data_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_bits       : "UH_FMT"\n", ptr_struct->swap_data_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "seed                 : "UH_FMT"\n", ptr_struct->seed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_crc_bytes       : "UH_FMT"\n", ptr_struct->swap_crc_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_crc_bits        : "UH_FMT"\n", ptr_struct->swap_crc_bits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invert_crc           : "UH_FMT"\n", ptr_struct->invert_crc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "regular              : "UH_FMT"\n", ptr_struct->regular);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sig_type             : "UH_FMT"\n", ptr_struct->sig_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_app_tag_bit_check_en : "UH_FMT"\n", ptr_struct->dif_app_tag_bit_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_guard_check_type : "UH_FMT"\n", ptr_struct->dif_guard_check_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_learn_mode       : "UH_FMT"\n", ptr_struct->dif_learn_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_learn_app_tag    : "UH_FMT"\n", ptr_struct->dif_learn_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_learn_ref_tag    : "UH_FMT"\n", ptr_struct->dif_learn_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dif_inc_ref_tag      : "UH_FMT"\n", ptr_struct->dif_inc_ref_tag);

}

int connectib_hw_pdf_decoder_size(void){
	 return 8;
}

void connectib_hw_pdf_decoder_dump(const struct connectib_hw_pdf_decoder *ptr_struct, FILE* file) {
	connectib_hw_pdf_decoder_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_tx_set_ini_pack(const struct connectib_serdes_conf_tx_set_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ob_preemp_pre);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pre_polarity);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ob_preemp_post);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_polarity);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ob_preemp_main);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->main_polarity);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->preemp_mode);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ob_bias);

}

void connectib_serdes_conf_tx_set_ini_unpack(struct connectib_serdes_conf_tx_set_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	ptr_struct->ob_preemp_pre = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=24;
	ptr_struct->pre_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->ob_preemp_post = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=16;
	ptr_struct->post_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->ob_preemp_main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=8;
	ptr_struct->main_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->preemp_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=2;
	ptr_struct->ob_bias = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_serdes_conf_tx_set_ini_print(const struct connectib_serdes_conf_tx_set_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_tx_set_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_preemp_pre        : "UH_FMT"\n", ptr_struct->ob_preemp_pre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_polarity         : "UH_FMT"\n", ptr_struct->pre_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_preemp_post       : "UH_FMT"\n", ptr_struct->ob_preemp_post);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_polarity        : "UH_FMT"\n", ptr_struct->post_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_preemp_main       : "UH_FMT"\n", ptr_struct->ob_preemp_main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "main_polarity        : "UH_FMT"\n", ptr_struct->main_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preemp_mode          : "UH_FMT"\n", ptr_struct->preemp_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bias              : "UH_FMT"\n", ptr_struct->ob_bias);

}

int connectib_serdes_conf_tx_set_ini_size(void){
	 return 4;
}

void connectib_serdes_conf_tx_set_ini_dump(const struct connectib_serdes_conf_tx_set_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_tx_set_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_rx_set_ini_pack(const struct connectib_serdes_conf_rx_set_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->slicer_ind_en);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->slicer1_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->slicer2_enable);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

}

void connectib_serdes_conf_rx_set_ini_unpack(struct connectib_serdes_conf_rx_set_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->slicer_ind_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=20;
	ptr_struct->slicer1_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=16;
	ptr_struct->slicer2_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=8;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=56;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=40;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_serdes_conf_rx_set_ini_print(const struct connectib_serdes_conf_rx_set_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_rx_set_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_ind_en        : "UH_FMT"\n", ptr_struct->slicer_ind_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer1_enable       : "UH_FMT"\n", ptr_struct->slicer1_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer2_enable       : "UH_FMT"\n", ptr_struct->slicer2_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : "UH_FMT"\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : "UH_FMT"\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : "UH_FMT"\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : "UH_FMT"\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : "UH_FMT"\n", ptr_struct->ffe_tap4);

}

int connectib_serdes_conf_rx_set_ini_size(void){
	 return 8;
}

void connectib_serdes_conf_rx_set_ini_dump(const struct connectib_serdes_conf_rx_set_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_rx_set_ini_print(ptr_struct, file, 0);
}

void connectib_aba_index_pack(const struct connectib_aba_index *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index0_start);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index0_end);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index0);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index1_start);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index1_end);

	offset=58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index1);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index2_start);

	offset=46;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index2_end);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index2);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index3_start);

	offset=90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index3_end);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index3);

	offset=78;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index4_start);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index4_end);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index4);

	offset=122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index5_start);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index5_end);

	offset=110;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->aba_index5);

}

void connectib_aba_index_unpack(struct connectib_aba_index *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->aba_index0_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=20;
	ptr_struct->aba_index0_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=14;
	ptr_struct->aba_index0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=8;
	ptr_struct->aba_index1_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=2;
	ptr_struct->aba_index1_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=58;
	ptr_struct->aba_index1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=52;
	ptr_struct->aba_index2_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=46;
	ptr_struct->aba_index2_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=40;
	ptr_struct->aba_index2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=34;
	ptr_struct->aba_index3_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=90;
	ptr_struct->aba_index3_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=84;
	ptr_struct->aba_index3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=78;
	ptr_struct->aba_index4_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=72;
	ptr_struct->aba_index4_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=66;
	ptr_struct->aba_index4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=122;
	ptr_struct->aba_index5_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=116;
	ptr_struct->aba_index5_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=110;
	ptr_struct->aba_index5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void connectib_aba_index_print(const struct connectib_aba_index *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_aba_index ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index0_start     : "UH_FMT"\n", ptr_struct->aba_index0_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index0_end       : "UH_FMT"\n", ptr_struct->aba_index0_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index0           : "UH_FMT"\n", ptr_struct->aba_index0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index1_start     : "UH_FMT"\n", ptr_struct->aba_index1_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index1_end       : "UH_FMT"\n", ptr_struct->aba_index1_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index1           : "UH_FMT"\n", ptr_struct->aba_index1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index2_start     : "UH_FMT"\n", ptr_struct->aba_index2_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index2_end       : "UH_FMT"\n", ptr_struct->aba_index2_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index2           : "UH_FMT"\n", ptr_struct->aba_index2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index3_start     : "UH_FMT"\n", ptr_struct->aba_index3_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index3_end       : "UH_FMT"\n", ptr_struct->aba_index3_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index3           : "UH_FMT"\n", ptr_struct->aba_index3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index4_start     : "UH_FMT"\n", ptr_struct->aba_index4_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index4_end       : "UH_FMT"\n", ptr_struct->aba_index4_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index4           : "UH_FMT"\n", ptr_struct->aba_index4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index5_start     : "UH_FMT"\n", ptr_struct->aba_index5_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index5_end       : "UH_FMT"\n", ptr_struct->aba_index5_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_index5           : "UH_FMT"\n", ptr_struct->aba_index5);

}

int connectib_aba_index_size(void){
	 return 16;
}

void connectib_aba_index_dump(const struct connectib_aba_index *ptr_struct, FILE* file) {
	connectib_aba_index_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_type_pack(const union connectib_nv_tlv_type *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_dw_pack(&(ptr_struct->as_dw), ptr_buff);
}

void connectib_nv_tlv_type_unpack(union connectib_nv_tlv_type *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_dw_unpack(&(ptr_struct->as_dw), ptr_buff);
}

void connectib_nv_tlv_type_print(const union connectib_nv_tlv_type *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_type ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global:\n");
	connectib_nv_tlv_type_global_print(&(ptr_struct->global), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "physical_port:\n");
	connectib_nv_tlv_type_physical_port_print(&(ptr_struct->physical_port), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bmc:\n");
	connectib_nv_tlv_type_bmc_print(&(ptr_struct->bmc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "per_host:\n");
	connectib_nv_tlv_type_per_host_print(&(ptr_struct->per_host), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eswitch:\n");
	connectib_nv_tlv_type_eswitch_print(&(ptr_struct->eswitch), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvlog:\n");
	connectib_nv_tlv_type_nvlog_print(&(ptr_struct->nvlog), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_dw:\n");
	connectib_dw_print(&(ptr_struct->as_dw), file, indent_level + 1);

}

int connectib_nv_tlv_type_size(void){
	 return 4;
}

void connectib_nv_tlv_type_dump(const union connectib_nv_tlv_type *ptr_struct, FILE* file) {
	connectib_nv_tlv_type_print(ptr_struct, file, 0);
}

void connectib_register_access_data_pack(const struct connectib_register_access_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_register_access_data_unpack(struct connectib_register_access_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_register_access_data_print(const struct connectib_register_access_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_register_access_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_register_access_data_size(void){
	 return 32;
}

void connectib_register_access_data_dump(const struct connectib_register_access_data *ptr_struct, FILE* file) {
	connectib_register_access_data_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_hdr_pack(const struct connectib_nv_tlv_hdr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->length);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->shadow);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rd_en);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ovr_en);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->header_type);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->priority);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->type);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->crc16);

}

void connectib_nv_tlv_hdr_unpack(struct connectib_nv_tlv_hdr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=23;
	ptr_struct->length = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=20;
	ptr_struct->shadow = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=8;
	ptr_struct->rd_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->ovr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=4;
	ptr_struct->header_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=2;
	ptr_struct->priority = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->crc16 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_nv_tlv_hdr_print(const struct connectib_nv_tlv_hdr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_hdr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length               : "UH_FMT"\n", ptr_struct->length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shadow               : "UH_FMT"\n", ptr_struct->shadow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rd_en                : "UH_FMT"\n", ptr_struct->rd_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ovr_en               : "UH_FMT"\n", ptr_struct->ovr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header_type          : "UH_FMT"\n", ptr_struct->header_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "priority             : "UH_FMT"\n", ptr_struct->priority);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "U32H_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc16                : "UH_FMT"\n", ptr_struct->crc16);

}

int connectib_nv_tlv_hdr_size(void){
	 return 12;
}

void connectib_nv_tlv_hdr_dump(const struct connectib_nv_tlv_hdr *ptr_struct, FILE* file) {
	connectib_nv_tlv_hdr_print(ptr_struct, file, 0);
}

void connectib_mfba_header_pack(const struct connectib_mfba_header *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fs);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->p);

	offset=55;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->address);

}

void connectib_mfba_header_unpack(struct connectib_mfba_header *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->fs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=55;
	ptr_struct->size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=72;
	ptr_struct->address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_mfba_header_print(const struct connectib_mfba_header *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mfba_header ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fs                   : "UH_FMT"\n", ptr_struct->fs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "p                    : "UH_FMT"\n", ptr_struct->p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : "UH_FMT"\n", ptr_struct->address);

}

int connectib_mfba_header_size(void){
	 return 12;
}

void connectib_mfba_header_dump(const struct connectib_mfba_header *ptr_struct, FILE* file) {
	connectib_mfba_header_print(ptr_struct, file, 0);
}

void connectib_fw_ref_count_pack(const struct connectib_fw_ref_count *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 28, (u_int32_t)ptr_struct->ref_counter);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ref_valid_cre_type);

}

void connectib_fw_ref_count_unpack(struct connectib_fw_ref_count *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=4;
	ptr_struct->ref_counter = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 28);

	offset=0;
	ptr_struct->ref_valid_cre_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_fw_ref_count_print(const struct connectib_fw_ref_count *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_ref_count ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_counter          : "UH_FMT"\n", ptr_struct->ref_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_valid_cre_type   : "UH_FMT"\n", ptr_struct->ref_valid_cre_type);

}

int connectib_fw_ref_count_size(void){
	 return 4;
}

void connectib_fw_ref_count_dump(const struct connectib_fw_ref_count *ptr_struct, FILE* file) {
	connectib_fw_ref_count_print(ptr_struct, file, 0);
}

void connectib_tir_dmfs_pack(const struct connectib_tir_dmfs *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ste_ix);

}

void connectib_tir_dmfs_unpack(struct connectib_tir_dmfs *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->ste_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_tir_dmfs_print(const struct connectib_tir_dmfs *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_tir_dmfs ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ste_ix               : "U64H_FMT"\n", ptr_struct->ste_ix);

}

int connectib_tir_dmfs_size(void){
	 return 8;
}

void connectib_tir_dmfs_dump(const struct connectib_tir_dmfs *ptr_struct, FILE* file) {
	connectib_tir_dmfs_print(ptr_struct, file, 0);
}

void connectib_rx_hash_field_select_pack(const struct connectib_rx_hash_field_select *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->selected_fields);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l4_prot_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l3_prot_type);

}

void connectib_rx_hash_field_select_unpack(struct connectib_rx_hash_field_select *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	ptr_struct->selected_fields = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

	offset=1;
	ptr_struct->l4_prot_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->l3_prot_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_rx_hash_field_select_print(const struct connectib_rx_hash_field_select *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rx_hash_field_select ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selected_fields      : %s ("UH_FMT")\n", (ptr_struct->selected_fields == 0 ? ("SRC_IP") : ((ptr_struct->selected_fields == 1 ? ("DST_IP") : ((ptr_struct->selected_fields == 2 ? ("L4_SPORT") : ((ptr_struct->selected_fields == 3 ? ("L4_DPORT") : ((ptr_struct->selected_fields == 4 ? ("IPSEC_SPI") : ("unknown")))))))))), ptr_struct->selected_fields);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l4_prot_type         : "UH_FMT"\n", ptr_struct->l4_prot_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l3_prot_type         : "UH_FMT"\n", ptr_struct->l3_prot_type);

}

int connectib_rx_hash_field_select_size(void){
	 return 4;
}

void connectib_rx_hash_field_select_dump(const struct connectib_rx_hash_field_select *ptr_struct, FILE* file) {
	connectib_rx_hash_field_select_print(ptr_struct, file, 0);
}

void connectib_fw_qpc_special_pack(const union connectib_fw_qpc_special *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_dcr_qp_pack(&(ptr_struct->dcr_qp), ptr_buff);
}

void connectib_fw_qpc_special_unpack(union connectib_fw_qpc_special *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_dcr_qp_unpack(&(ptr_struct->dcr_qp), ptr_buff);
}

void connectib_fw_qpc_special_print(const union connectib_fw_qpc_special *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_qpc_special ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "regular_qp:\n");
	connectib_regular_qp_print(&(ptr_struct->regular_qp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_qp:\n");
	connectib_dcr_qp_print(&(ptr_struct->dcr_qp), file, indent_level + 1);

}

int connectib_fw_qpc_special_size(void){
	 return 16;
}

void connectib_fw_qpc_special_dump(const union connectib_fw_qpc_special *ptr_struct, FILE* file) {
	connectib_fw_qpc_special_print(ptr_struct, file, 0);
}

void connectib_fw_qpc_q_pack(const struct connectib_fw_qpc_q *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->qp_state);

	offset=16;
	connectib_schedint_cause_pack(&(ptr_struct->schedint_cause), ptr_buff + offset/8);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sxdc_valid);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qpc_valid);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dct_cleanup_state);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_in_linked_list);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cmdif_awaiting);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dup_sx_flush_kill_qp_arb_disabled);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->broken_wq_buffer);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->broken_cq);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->catas_event_generated);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_wqe_event_generated);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->async_event_generated);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->flushed_in_error);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->disable_flushed_in_error);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vendor_syndrome);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->hw_syndrome);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->trap_reason);

	offset=122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->connect_sent_to_ctrl_dct);

	offset=121;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->needed_events_generated);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_progress_after_retry);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->retransmission_state);

	offset=115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_fault_event_fired);

	offset=114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_progress_after_fault);

	offset=113;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_fault_event_fired);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_progress_after_fault);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->trap_data);

}

void connectib_fw_qpc_q_unpack(struct connectib_fw_qpc_q *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->qp_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	connectib_schedint_cause_unpack(&(ptr_struct->schedint_cause), ptr_buff + offset/8);

	offset=15;
	ptr_struct->sxdc_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->qpc_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->dct_cleanup_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=11;
	ptr_struct->qp_in_linked_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->cmdif_awaiting = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->dup_sx_flush_kill_qp_arb_disabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->broken_wq_buffer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->broken_cq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->catas_event_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->last_wqe_event_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->async_event_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->flushed_in_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->disable_flushed_in_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->vendor_syndrome = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->hw_syndrome = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=123;
	ptr_struct->trap_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=122;
	ptr_struct->connect_sent_to_ctrl_dct = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=121;
	ptr_struct->needed_events_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=120;
	ptr_struct->rx_progress_after_retry = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=116;
	ptr_struct->retransmission_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=115;
	ptr_struct->rx_fault_event_fired = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=114;
	ptr_struct->rx_progress_after_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=113;
	ptr_struct->sx_fault_event_fired = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->sx_progress_after_fault = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->trap_data = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_fw_qpc_q_print(const struct connectib_fw_qpc_q *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_qpc_q ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "schedint_cause:\n");
	connectib_schedint_cause_print(&(ptr_struct->schedint_cause), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sxdc_valid           : "UH_FMT"\n", ptr_struct->sxdc_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpc_valid            : "UH_FMT"\n", ptr_struct->qpc_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_cleanup_state    : "UH_FMT"\n", ptr_struct->dct_cleanup_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_in_linked_list    : "UH_FMT"\n", ptr_struct->qp_in_linked_list);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmdif_awaiting       : "UH_FMT"\n", ptr_struct->cmdif_awaiting);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dup_sx_flush_kill_qp_arb_disabled : "UH_FMT"\n", ptr_struct->dup_sx_flush_kill_qp_arb_disabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "broken_wq_buffer     : "UH_FMT"\n", ptr_struct->broken_wq_buffer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "broken_cq            : "UH_FMT"\n", ptr_struct->broken_cq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "catas_event_generated : "UH_FMT"\n", ptr_struct->catas_event_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_wqe_event_generated : "UH_FMT"\n", ptr_struct->last_wqe_event_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "async_event_generated : "UH_FMT"\n", ptr_struct->async_event_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flushed_in_error     : "UH_FMT"\n", ptr_struct->flushed_in_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_flushed_in_error : "UH_FMT"\n", ptr_struct->disable_flushed_in_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_syndrome      : "UH_FMT"\n", ptr_struct->vendor_syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_syndrome          : "UH_FMT"\n", ptr_struct->hw_syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_reason          : %s ("UH_FMT")\n", (ptr_struct->trap_reason == 0 ? ("NORMAL") : ((ptr_struct->trap_reason == 1 ? ("SET_LIMIT") : ((ptr_struct->trap_reason == 2 ? ("DCR_OVERFLOW") : ((ptr_struct->trap_reason == 3 ? ("DCR_DUP_WA") : ((ptr_struct->trap_reason == 4 ? ("DCI_RECONNECT") : ("unknown")))))))))), ptr_struct->trap_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connect_sent_to_ctrl_dct : "UH_FMT"\n", ptr_struct->connect_sent_to_ctrl_dct);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "needed_events_generated : "UH_FMT"\n", ptr_struct->needed_events_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_progress_after_retry : "UH_FMT"\n", ptr_struct->rx_progress_after_retry);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retransmission_state : "UH_FMT"\n", ptr_struct->retransmission_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_fault_event_fired : "UH_FMT"\n", ptr_struct->rx_fault_event_fired);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_progress_after_fault : "UH_FMT"\n", ptr_struct->rx_progress_after_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_fault_event_fired : "UH_FMT"\n", ptr_struct->sx_fault_event_fired);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_progress_after_fault : "UH_FMT"\n", ptr_struct->sx_progress_after_fault);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_data            : "UH_FMT"\n", ptr_struct->trap_data);

}

int connectib_fw_qpc_q_size(void){
	 return 16;
}

void connectib_fw_qpc_q_dump(const struct connectib_fw_qpc_q *ptr_struct, FILE* file) {
	connectib_fw_qpc_q_print(ptr_struct, file, 0);
}

void connectib_hw_msix_context_data_pack(const union connectib_hw_msix_context_data *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_msix_context_data0_pack(&(ptr_struct->regular), ptr_buff);
}

void connectib_hw_msix_context_data_unpack(union connectib_hw_msix_context_data *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_msix_context_data0_unpack(&(ptr_struct->regular), ptr_buff);
}

void connectib_hw_msix_context_data_print(const union connectib_hw_msix_context_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_msix_context_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "regular:\n");
	connectib_hw_msix_context_data0_print(&(ptr_struct->regular), file, indent_level + 1);

}

int connectib_hw_msix_context_data_size(void){
	 return 4;
}

void connectib_hw_msix_context_data_dump(const union connectib_hw_msix_context_data *ptr_struct, FILE* file) {
	connectib_hw_msix_context_data_print(ptr_struct, file, 0);
}

void connectib_steering_qp_entry_pack(const struct connectib_steering_qp_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qp_number);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_responder);

}

void connectib_steering_qp_entry_unpack(struct connectib_steering_qp_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->qp_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->force_responder = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_steering_qp_entry_print(const struct connectib_steering_qp_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_steering_qp_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_number            : "UH_FMT"\n", ptr_struct->qp_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_responder      : "UH_FMT"\n", ptr_struct->force_responder);

}

int connectib_steering_qp_entry_size(void){
	 return 4;
}

void connectib_steering_qp_entry_dump(const struct connectib_steering_qp_entry *ptr_struct, FILE* file) {
	connectib_steering_qp_entry_print(ptr_struct, file, 0);
}

void connectib_hw_ste_tag_pack(const union connectib_hw_ste_tag *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_ste_tag_generic_headers_pack(&(ptr_struct->generic_headers), ptr_buff);
}

void connectib_hw_ste_tag_unpack(union connectib_hw_ste_tag *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_ste_tag_generic_headers_unpack(&(ptr_struct->generic_headers), ptr_buff);
}

void connectib_hw_ste_tag_print(const union connectib_hw_ste_tag *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste_tag ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bulk:\n");
	connectib_hw_ste_tag_bulk_print(&(ptr_struct->bulk), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibl2:\n");
	connectib_hw_ste_tag_ib_l2_print(&(ptr_struct->ibl2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibl3_extended:\n");
	connectib_hw_ste_tag_ib_l3_extended_print(&(ptr_struct->ibl3_extended), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibl3:\n");
	connectib_hw_ste_tag_ib_l3_print(&(ptr_struct->ibl3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibl4:\n");
	connectib_hw_ste_tag_ib_l4_print(&(ptr_struct->ibl4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_gvmi_qp:\n");
	connectib_hw_ste_tag_source_gvmi_qp_print(&(ptr_struct->source_gvmi_qp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port:\n");
	connectib_hw_ste_tag_port_print(&(ptr_struct->port), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generic_headers:\n");
	connectib_hw_ste_tag_generic_headers_print(&(ptr_struct->generic_headers), file, indent_level + 1);

}

int connectib_hw_ste_tag_size(void){
	 return 16;
}

void connectib_hw_ste_tag_dump(const union connectib_hw_ste_tag *ptr_struct, FILE* file) {
	connectib_hw_ste_tag_print(ptr_struct, file, 0);
}

void connectib_hw_pdf_entry_pack(const union connectib_hw_pdf_entry *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_transaction_pdf_pack(&(ptr_struct->transaction_pdf), ptr_buff);
}

void connectib_hw_pdf_entry_unpack(union connectib_hw_pdf_entry *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_transaction_pdf_unpack(&(ptr_struct->transaction_pdf), ptr_buff);
}

void connectib_hw_pdf_entry_print(const union connectib_hw_pdf_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_pdf_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pdf_decoder:\n");
	connectib_hw_pdf_decoder_print(&(ptr_struct->pdf_decoder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transaction_pdf:\n");
	connectib_hw_transaction_pdf_print(&(ptr_struct->transaction_pdf), file, indent_level + 1);

}

int connectib_hw_pdf_entry_size(void){
	 return 8;
}

void connectib_hw_pdf_entry_dump(const union connectib_hw_pdf_entry *ptr_struct, FILE* file) {
	connectib_hw_pdf_entry_print(ptr_struct, file, 0);
}

void connectib_pf_vf_vpd_pack(const struct connectib_pf_vf_vpd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->vpd_address);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->F);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->vpd_data);

}

void connectib_pf_vf_vpd_unpack(struct connectib_pf_vf_vpd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	ptr_struct->vpd_address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset=0;
	ptr_struct->F = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->vpd_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_pf_vf_vpd_print(const struct connectib_pf_vf_vpd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pf_vf_vpd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_address          : "UH_FMT"\n", ptr_struct->vpd_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "F                    : "UH_FMT"\n", ptr_struct->F);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_data             : "U32H_FMT"\n", ptr_struct->vpd_data);

}

int connectib_pf_vf_vpd_size(void){
	 return 8;
}

void connectib_pf_vf_vpd_dump(const struct connectib_pf_vf_vpd *ptr_struct, FILE* file) {
	connectib_pf_vf_vpd_print(ptr_struct, file, 0);
}

void connectib_pf_vf_sriov_pack(const struct connectib_pf_vf_sriov *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_enable);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_migration_en);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_migration_int_en);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_mse);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ari_capable_hierarchy);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_system_page_size);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->num_vfs);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->not_in_use);

}

void connectib_pf_vf_sriov_unpack(struct connectib_pf_vf_sriov *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->vf_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->vf_migration_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->vf_migration_int_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->vf_mse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->ari_capable_hierarchy = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->log_system_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=6;
	ptr_struct->num_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=32;
	ptr_struct->not_in_use = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_pf_vf_sriov_print(const struct connectib_pf_vf_sriov *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pf_vf_sriov ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_enable            : "UH_FMT"\n", ptr_struct->vf_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_migration_en      : "UH_FMT"\n", ptr_struct->vf_migration_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_migration_int_en  : "UH_FMT"\n", ptr_struct->vf_migration_int_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_mse               : "UH_FMT"\n", ptr_struct->vf_mse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_capable_hierarchy : "UH_FMT"\n", ptr_struct->ari_capable_hierarchy);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_system_page_size : "UH_FMT"\n", ptr_struct->log_system_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vfs              : "UH_FMT"\n", ptr_struct->num_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "not_in_use           : "U32H_FMT"\n", ptr_struct->not_in_use);

}

int connectib_pf_vf_sriov_size(void){
	 return 8;
}

void connectib_pf_vf_sriov_dump(const struct connectib_pf_vf_sriov *ptr_struct, FILE* file) {
	connectib_pf_vf_sriov_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_preset_tx_ini_pack(const struct connectib_serdes_conf_preset_tx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_serdes_conf_tx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_preset_tx_ini_unpack(struct connectib_serdes_conf_preset_tx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_serdes_conf_tx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_preset_tx_ini_print(const struct connectib_serdes_conf_preset_tx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_preset_tx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_tx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_conf_preset_tx_ini_size(void){
	 return 64;
}

void connectib_serdes_conf_preset_tx_ini_dump(const struct connectib_serdes_conf_preset_tx_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_preset_tx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_active_tx_ini_pack(const struct connectib_serdes_active_tx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	connectib_serdes_conf_tx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_active_tx_ini_unpack(struct connectib_serdes_active_tx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	connectib_serdes_conf_tx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_active_tx_ini_print(const struct connectib_serdes_active_tx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_active_tx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_tx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_active_tx_ini_size(void){
	 return 16;
}

void connectib_serdes_active_tx_ini_dump(const struct connectib_serdes_active_tx_ini *ptr_struct, FILE* file) {
	connectib_serdes_active_tx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_active_rx_ini_pack(const struct connectib_serdes_active_rx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 256, 1);
	connectib_serdes_conf_rx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_active_rx_ini_unpack(struct connectib_serdes_active_rx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 256, 1);
	connectib_serdes_conf_rx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_active_rx_ini_print(const struct connectib_serdes_active_rx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_active_rx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_rx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_active_rx_ini_size(void){
	 return 32;
}

void connectib_serdes_active_rx_ini_dump(const struct connectib_serdes_active_rx_ini *ptr_struct, FILE* file) {
	connectib_serdes_active_rx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_force_tx_ini_pack(const struct connectib_serdes_force_tx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 320, 1);
	connectib_serdes_conf_tx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_force_tx_ini_unpack(struct connectib_serdes_force_tx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 320, 1);
	connectib_serdes_conf_tx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_force_tx_ini_print(const struct connectib_serdes_force_tx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_force_tx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 10; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_tx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_force_tx_ini_size(void){
	 return 40;
}

void connectib_serdes_force_tx_ini_dump(const struct connectib_serdes_force_tx_ini *ptr_struct, FILE* file) {
	connectib_serdes_force_tx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_force_rx_ini_pack(const struct connectib_serdes_force_rx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 640, 1);
	connectib_serdes_conf_rx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_force_rx_ini_unpack(struct connectib_serdes_force_rx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 640, 1);
	connectib_serdes_conf_rx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_force_rx_ini_print(const struct connectib_serdes_force_rx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_force_rx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 10; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_rx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_force_rx_ini_size(void){
	 return 80;
}

void connectib_serdes_force_rx_ini_dump(const struct connectib_serdes_force_rx_ini *ptr_struct, FILE* file) {
	connectib_serdes_force_rx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_aba_tx_ini_pack(const struct connectib_serdes_conf_aba_tx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_serdes_conf_tx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_aba_tx_ini_unpack(struct connectib_serdes_conf_aba_tx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_serdes_conf_tx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_aba_tx_ini_print(const struct connectib_serdes_conf_aba_tx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_aba_tx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_tx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_conf_aba_tx_ini_size(void){
	 return 128;
}

void connectib_serdes_conf_aba_tx_ini_dump(const struct connectib_serdes_conf_aba_tx_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_aba_tx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_aba_rx_ini_pack(const struct connectib_serdes_conf_aba_rx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 2048, 1);
	connectib_serdes_conf_rx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_aba_rx_ini_unpack(struct connectib_serdes_conf_aba_rx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 2048, 1);
	connectib_serdes_conf_rx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_aba_rx_ini_print(const struct connectib_serdes_conf_aba_rx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_aba_rx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_rx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_conf_aba_rx_ini_size(void){
	 return 256;
}

void connectib_serdes_conf_aba_rx_ini_dump(const struct connectib_serdes_conf_aba_rx_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_aba_rx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_autoneg_tx_ini_pack(const struct connectib_serdes_conf_autoneg_tx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_serdes_conf_tx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_autoneg_tx_ini_unpack(struct connectib_serdes_conf_autoneg_tx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_serdes_conf_tx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_autoneg_tx_ini_print(const struct connectib_serdes_conf_autoneg_tx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_autoneg_tx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_tx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_conf_autoneg_tx_ini_size(void){
	 return 128;
}

void connectib_serdes_conf_autoneg_tx_ini_dump(const struct connectib_serdes_conf_autoneg_tx_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_autoneg_tx_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_autoneg_rx_ini_pack(const struct connectib_serdes_conf_autoneg_rx_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 2048, 1);
	connectib_serdes_conf_rx_set_ini_pack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_autoneg_rx_ini_unpack(struct connectib_serdes_conf_autoneg_rx_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 2048, 1);
	connectib_serdes_conf_rx_set_ini_unpack(&(ptr_struct->set[i]), ptr_buff + offset/8);
	}

}

void connectib_serdes_conf_autoneg_rx_ini_print(const struct connectib_serdes_conf_autoneg_rx_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_autoneg_rx_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_%03d:\n", i);
	connectib_serdes_conf_rx_set_ini_print(&(ptr_struct->set[i]), file, indent_level + 1);
	}

}

int connectib_serdes_conf_autoneg_rx_ini_size(void){
	 return 256;
}

void connectib_serdes_conf_autoneg_rx_ini_dump(const struct connectib_serdes_conf_autoneg_rx_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_autoneg_rx_ini_print(ptr_struct, file, 0);
}

void connectib_aba_indexes_pack(const struct connectib_aba_indexes *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_aba_index_pack(&(ptr_struct->encode_64_66), ptr_buff + offset/8);

	offset=128;
	connectib_aba_index_pack(&(ptr_struct->encode_8_10), ptr_buff + offset/8);

	offset=256;
	connectib_aba_index_pack(&(ptr_struct->encode_8_10_legacy), ptr_buff + offset/8);

}

void connectib_aba_indexes_unpack(struct connectib_aba_indexes *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_aba_index_unpack(&(ptr_struct->encode_64_66), ptr_buff + offset/8);

	offset=128;
	connectib_aba_index_unpack(&(ptr_struct->encode_8_10), ptr_buff + offset/8);

	offset=256;
	connectib_aba_index_unpack(&(ptr_struct->encode_8_10_legacy), ptr_buff + offset/8);

}

void connectib_aba_indexes_print(const struct connectib_aba_indexes *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_aba_indexes ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_64_66:\n");
	connectib_aba_index_print(&(ptr_struct->encode_64_66), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_8_10:\n");
	connectib_aba_index_print(&(ptr_struct->encode_8_10), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_8_10_legacy:\n");
	connectib_aba_index_print(&(ptr_struct->encode_8_10_legacy), file, indent_level + 1);

}

int connectib_aba_indexes_size(void){
	 return 48;
}

void connectib_aba_indexes_dump(const struct connectib_aba_indexes *ptr_struct, FILE* file) {
	connectib_aba_indexes_print(ptr_struct, file, 0);
}

void connectib_serdes_param_mask_per_proto_ini_pack(const struct connectib_serdes_param_mask_per_proto_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx);

}

void connectib_serdes_param_mask_per_proto_ini_unpack(struct connectib_serdes_param_mask_per_proto_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rx = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_serdes_param_mask_per_proto_ini_print(const struct connectib_serdes_param_mask_per_proto_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_param_mask_per_proto_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx                   : "U32H_FMT"\n", ptr_struct->rx);

}

int connectib_serdes_param_mask_per_proto_ini_size(void){
	 return 4;
}

void connectib_serdes_param_mask_per_proto_ini_dump(const struct connectib_serdes_param_mask_per_proto_ini *ptr_struct, FILE* file) {
	connectib_serdes_param_mask_per_proto_ini_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_dmfs_pack(const struct connectib_cmdif_ctx_dmfs *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->gc_hash_meta_ix);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->copied_dest_ctr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dealloc_ste_ix);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ft_hw_ix);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ft_fw_ix);

}

void connectib_cmdif_ctx_dmfs_unpack(struct connectib_cmdif_ctx_dmfs *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->gc_hash_meta_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=48;
	ptr_struct->copied_dest_ctr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->dealloc_ste_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->ft_hw_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->ft_fw_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_dmfs_print(const struct connectib_cmdif_ctx_dmfs *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_dmfs ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gc_hash_meta_ix      : "U32H_FMT"\n", ptr_struct->gc_hash_meta_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "copied_dest_ctr      : "UH_FMT"\n", ptr_struct->copied_dest_ctr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dealloc_ste_ix       : "U64H_FMT"\n", ptr_struct->dealloc_ste_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ft_hw_ix             : "U64H_FMT"\n", ptr_struct->ft_hw_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ft_fw_ix             : "U32H_FMT"\n", ptr_struct->ft_fw_ix);

}

int connectib_cmdif_ctx_dmfs_size(void){
	 return 32;
}

void connectib_cmdif_ctx_dmfs_dump(const struct connectib_cmdif_ctx_dmfs *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_dmfs_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_create_mtt_pack(const struct connectib_cmdif_ctx_create_mtt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->mtt_ix);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_mtts);

}

void connectib_cmdif_ctx_create_mtt_unpack(struct connectib_cmdif_ctx_create_mtt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->mtt_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->num_mtts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_create_mtt_print(const struct connectib_cmdif_ctx_create_mtt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_create_mtt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_ix               : "U64H_FMT"\n", ptr_struct->mtt_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_mtts             : "U32H_FMT"\n", ptr_struct->num_mtts);

}

int connectib_cmdif_ctx_create_mtt_size(void){
	 return 32;
}

void connectib_cmdif_ctx_create_mtt_dump(const struct connectib_cmdif_ctx_create_mtt *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_create_mtt_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_psv_pack(const struct connectib_cmdif_ctx_psv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_psv);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_alloced_psv);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pd);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->psv_ix[i]);
	}

}

void connectib_cmdif_ctx_psv_unpack(struct connectib_cmdif_ctx_psv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->num_psv = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->num_alloced_psv = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->pd = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	ptr_struct->psv_ix[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_cmdif_ctx_psv_print(const struct connectib_cmdif_ctx_psv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_psv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_psv              : "U32H_FMT"\n", ptr_struct->num_psv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_alloced_psv      : "U32H_FMT"\n", ptr_struct->num_alloced_psv);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "U32H_FMT"\n", ptr_struct->pd);

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psv_ix_%03d          : "U32H_FMT"\n", i, ptr_struct->psv_ix[i]);
	}

}

int connectib_cmdif_ctx_psv_size(void){
	 return 32;
}

void connectib_cmdif_ctx_psv_dump(const struct connectib_cmdif_ctx_psv *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_psv_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_mcg_pack(const struct connectib_cmdif_ctx_mcg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->mcg_index);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->gid_msb);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->gid_lsb);

}

void connectib_cmdif_ctx_mcg_unpack(struct connectib_cmdif_ctx_mcg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->mcg_index = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->gid_msb = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->gid_lsb = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_cmdif_ctx_mcg_print(const struct connectib_cmdif_ctx_mcg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_mcg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mcg_index            : "U64H_FMT"\n", ptr_struct->mcg_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid_msb              : "U64H_FMT"\n", ptr_struct->gid_msb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid_lsb              : "U64H_FMT"\n", ptr_struct->gid_lsb);

}

int connectib_cmdif_ctx_mcg_size(void){
	 return 32;
}

void connectib_cmdif_ctx_mcg_dump(const struct connectib_cmdif_ctx_mcg *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_mcg_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_sniffer_pack(const struct connectib_cmdif_ctx_sniffer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_0_1);

}

void connectib_cmdif_ctx_sniffer_unpack(struct connectib_cmdif_ctx_sniffer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->port_0_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_cmdif_ctx_sniffer_print(const struct connectib_cmdif_ctx_sniffer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_sniffer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_0_1             : "UH_FMT"\n", ptr_struct->port_0_1);

}

int connectib_cmdif_ctx_sniffer_size(void){
	 return 32;
}

void connectib_cmdif_ctx_sniffer_dump(const struct connectib_cmdif_ctx_sniffer *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_sniffer_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_modify_rmp_pack(const struct connectib_cmdif_ctx_special_modify_rmp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->bitmask);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->lwm);

}

void connectib_cmdif_ctx_special_modify_rmp_unpack(struct connectib_cmdif_ctx_special_modify_rmp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->bitmask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->lwm = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_modify_rmp_print(const struct connectib_cmdif_ctx_special_modify_rmp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_modify_rmp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bitmask              : "U64H_FMT"\n", ptr_struct->bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lwm                  : "U32H_FMT"\n", ptr_struct->lwm);

}

int connectib_cmdif_ctx_special_modify_rmp_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_modify_rmp_dump(const struct connectib_cmdif_ctx_special_modify_rmp *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_modify_rmp_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_arm_rq_pack(const struct connectib_cmdif_ctx_special_arm_rq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->lwm);

}

void connectib_cmdif_ctx_special_arm_rq_unpack(struct connectib_cmdif_ctx_special_arm_rq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->lwm = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_arm_rq_print(const struct connectib_cmdif_ctx_special_arm_rq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_arm_rq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lwm                  : "U32H_FMT"\n", ptr_struct->lwm);

}

int connectib_cmdif_ctx_special_arm_rq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_arm_rq_dump(const struct connectib_cmdif_ctx_special_arm_rq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_arm_rq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_mkey_pack(const struct connectib_cmdif_ctx_special_mkey *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hw_addr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_addr);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->octoword_actual_size_mtt);

}

void connectib_cmdif_ctx_special_mkey_unpack(struct connectib_cmdif_ctx_special_mkey *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->hw_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->fw_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->octoword_actual_size_mtt = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_mkey_print(const struct connectib_cmdif_ctx_special_mkey *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_mkey ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_addr              : "U64H_FMT"\n", ptr_struct->hw_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_addr              : "U64H_FMT"\n", ptr_struct->fw_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "octoword_actual_size_mtt : "U32H_FMT"\n", ptr_struct->octoword_actual_size_mtt);

}

int connectib_cmdif_ctx_special_mkey_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_mkey_dump(const struct connectib_cmdif_ctx_special_mkey *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_mkey_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_modify_cq_pack(const struct connectib_cmdif_ctx_special_modify_cq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->mtt_ix);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->producer_index);

	offset=127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cqe_128b_size);

	offset=122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log2_size);

	offset=117;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=111;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->cq_page_offset);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fence_slice);

}

void connectib_cmdif_ctx_special_modify_cq_unpack(struct connectib_cmdif_ctx_special_modify_cq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->mtt_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->producer_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=127;
	ptr_struct->cqe_128b_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=122;
	ptr_struct->log2_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=117;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=111;
	ptr_struct->cq_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->fence_slice = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_modify_cq_print(const struct connectib_cmdif_ctx_special_modify_cq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_modify_cq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_ix               : "U64H_FMT"\n", ptr_struct->mtt_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "producer_index       : "UH_FMT"\n", ptr_struct->producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_128b_size        : "UH_FMT"\n", ptr_struct->cqe_128b_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_size            : "UH_FMT"\n", ptr_struct->log2_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_page_offset       : "UH_FMT"\n", ptr_struct->cq_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fence_slice          : "U32H_FMT"\n", ptr_struct->fence_slice);

}

int connectib_cmdif_ctx_special_modify_cq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_modify_cq_dump(const struct connectib_cmdif_ctx_special_modify_cq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_modify_cq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_cq_pack(const struct connectib_cmdif_ctx_special_create_cq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_addr);

}

void connectib_cmdif_ctx_special_create_cq_unpack(struct connectib_cmdif_ctx_special_create_cq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->fw_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_cmdif_ctx_special_create_cq_print(const struct connectib_cmdif_ctx_special_create_cq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create_cq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_addr              : "U64H_FMT"\n", ptr_struct->fw_addr);

}

int connectib_cmdif_ctx_special_create_cq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_cq_dump(const struct connectib_cmdif_ctx_special_create_cq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_cq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_eq_pack(const struct connectib_cmdif_ctx_special_create_eq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_eqc_addr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->hw_eqc_addr);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->event_bitmask);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hw_eqn);

}

void connectib_cmdif_ctx_special_create_eq_unpack(struct connectib_cmdif_ctx_special_create_eq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->fw_eqc_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->hw_eqc_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->event_bitmask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->hw_eqn = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_create_eq_print(const struct connectib_cmdif_ctx_special_create_eq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create_eq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_eqc_addr          : "U64H_FMT"\n", ptr_struct->fw_eqc_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_eqc_addr          : "U64H_FMT"\n", ptr_struct->hw_eqc_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_bitmask        : "U64H_FMT"\n", ptr_struct->event_bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_eqn               : "U32H_FMT"\n", ptr_struct->hw_eqn);

}

int connectib_cmdif_ctx_special_create_eq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_eq_dump(const struct connectib_cmdif_ctx_special_create_eq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_eq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_rqt_pack(const struct connectib_cmdif_ctx_rqt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rqt_fw_data_ix);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rqt_hw_data_ix);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_rqs_to_dec);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rqt_max_size);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rqt_actual_size);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rqt_actual_size_old);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rqt_fw_data_ix_old);

}

void connectib_cmdif_ctx_rqt_unpack(struct connectib_cmdif_ctx_rqt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rqt_fw_data_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rqt_hw_data_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->num_rqs_to_dec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->rqt_max_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=176;
	ptr_struct->rqt_actual_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->rqt_actual_size_old = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rqt_fw_data_ix_old = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_rqt_print(const struct connectib_cmdif_ctx_rqt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_rqt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_fw_data_ix       : "U32H_FMT"\n", ptr_struct->rqt_fw_data_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_hw_data_ix       : "U32H_FMT"\n", ptr_struct->rqt_hw_data_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_rqs_to_dec       : "U32H_FMT"\n", ptr_struct->num_rqs_to_dec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_max_size         : "UH_FMT"\n", ptr_struct->rqt_max_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_actual_size      : "UH_FMT"\n", ptr_struct->rqt_actual_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_actual_size_old  : "UH_FMT"\n", ptr_struct->rqt_actual_size_old);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_fw_data_ix_old   : "U32H_FMT"\n", ptr_struct->rqt_fw_data_ix_old);

}

int connectib_cmdif_ctx_rqt_size(void){
	 return 32;
}

void connectib_cmdif_ctx_rqt_dump(const struct connectib_cmdif_ctx_rqt *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_rqt_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_srq_pack(const struct connectib_cmdif_ctx_special_create_srq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_addr);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srqi);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cont_srq);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pas_offset);

}

void connectib_cmdif_ctx_special_create_srq_unpack(struct connectib_cmdif_ctx_special_create_srq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->fw_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->srqi = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->cont_srq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->pas_offset = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_create_srq_print(const struct connectib_cmdif_ctx_special_create_srq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create_srq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_addr              : "U64H_FMT"\n", ptr_struct->fw_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srqi                 : "UH_FMT"\n", ptr_struct->srqi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cont_srq             : "UH_FMT"\n", ptr_struct->cont_srq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pas_offset           : "U32H_FMT"\n", ptr_struct->pas_offset);

}

int connectib_cmdif_ctx_special_create_srq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_srq_dump(const struct connectib_cmdif_ctx_special_create_srq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_srq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_rq_pack(const struct connectib_cmdif_ctx_special_create_rq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_qpc_addr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->no_lro_qpn);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_max_qp);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->wq_type);

}

void connectib_cmdif_ctx_special_create_rq_unpack(struct connectib_cmdif_ctx_special_create_rq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->fw_qpc_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->no_lro_qpn = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=123;
	ptr_struct->log_max_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=116;
	ptr_struct->wq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_create_rq_print(const struct connectib_cmdif_ctx_special_create_rq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create_rq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_qpc_addr          : "U64H_FMT"\n", ptr_struct->fw_qpc_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_lro_qpn           : "U32H_FMT"\n", ptr_struct->no_lro_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_qp           : "UH_FMT"\n", ptr_struct->log_max_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_type              : "UH_FMT"\n", ptr_struct->wq_type);

}

int connectib_cmdif_ctx_special_create_rq_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_rq_dump(const struct connectib_cmdif_ctx_special_create_rq *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_rq_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_qp_pack(const struct connectib_cmdif_ctx_special_create_qp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->fw_qpc_addr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qpi);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_max_qp);

	offset=122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_dci);

}

void connectib_cmdif_ctx_special_create_qp_unpack(struct connectib_cmdif_ctx_special_create_qp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->fw_qpc_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->qpi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=123;
	ptr_struct->log_max_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=122;
	ptr_struct->is_dci = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_cmdif_ctx_special_create_qp_print(const struct connectib_cmdif_ctx_special_create_qp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create_qp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_qpc_addr          : "U64H_FMT"\n", ptr_struct->fw_qpc_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpi                  : "U32H_FMT"\n", ptr_struct->qpi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_qp           : "UH_FMT"\n", ptr_struct->log_max_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_dci               : "UH_FMT"\n", ptr_struct->is_dci);

}

int connectib_cmdif_ctx_special_create_qp_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_qp_dump(const struct connectib_cmdif_ctx_special_create_qp *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_qp_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_modify_tir_pack(const struct connectib_cmdif_ctx_special_modify_tir *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->bitmask);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ste_ix);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rqt_number);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->old_rqt_number);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->inline_rqn);

	offset=196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->disp_type);

}

void connectib_cmdif_ctx_special_modify_tir_unpack(struct connectib_cmdif_ctx_special_modify_tir *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->bitmask = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->ste_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->rqt_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=168;
	ptr_struct->old_rqt_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->inline_rqn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=196;
	ptr_struct->disp_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_modify_tir_print(const struct connectib_cmdif_ctx_special_modify_tir *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_modify_tir ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bitmask              : "U64H_FMT"\n", ptr_struct->bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ste_ix               : "U64H_FMT"\n", ptr_struct->ste_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_number           : "UH_FMT"\n", ptr_struct->rqt_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "old_rqt_number       : "UH_FMT"\n", ptr_struct->old_rqt_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_rqn           : "UH_FMT"\n", ptr_struct->inline_rqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disp_type            : "UH_FMT"\n", ptr_struct->disp_type);

}

int connectib_cmdif_ctx_special_modify_tir_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_modify_tir_dump(const struct connectib_cmdif_ctx_special_modify_tir *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_modify_tir_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_create_pack(const struct connectib_cmdif_ctx_special_create *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_mapped_mtts);

}

void connectib_cmdif_ctx_special_create_unpack(struct connectib_cmdif_ctx_special_create *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->num_mapped_mtts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_cmdif_ctx_special_create_print(const struct connectib_cmdif_ctx_special_create *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special_create ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_mapped_mtts      : "U32H_FMT"\n", ptr_struct->num_mapped_mtts);

}

int connectib_cmdif_ctx_special_create_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_create_dump(const struct connectib_cmdif_ctx_special_create *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_create_print(ptr_struct, file, 0);
}

void connectib_flush_type_bitmask_pack(const struct connectib_flush_type_bitmask *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword);

}

void connectib_flush_type_bitmask_unpack(struct connectib_flush_type_bitmask *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dword = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_flush_type_bitmask_print(const struct connectib_flush_type_bitmask *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_flush_type_bitmask ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword                : "U32H_FMT"\n", ptr_struct->dword);

}

int connectib_flush_type_bitmask_size(void){
	 return 4;
}

void connectib_flush_type_bitmask_dump(const struct connectib_flush_type_bitmask *ptr_struct, FILE* file) {
	connectib_flush_type_bitmask_print(ptr_struct, file, 0);
}

void connectib_flush_type_bits_pack(const struct connectib_flush_type_bits *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mkey_flush);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_s_flush);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_r_flush);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_flush);

}

void connectib_flush_type_bits_unpack(struct connectib_flush_type_bits *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->mkey_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->qp_s_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->qp_r_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->rx_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_flush_type_bits_print(const struct connectib_flush_type_bits *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_flush_type_bits ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mkey_flush           : "UH_FMT"\n", ptr_struct->mkey_flush);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_s_flush           : "UH_FMT"\n", ptr_struct->qp_s_flush);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_r_flush           : "UH_FMT"\n", ptr_struct->qp_r_flush);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_flush             : "UH_FMT"\n", ptr_struct->rx_flush);

}

int connectib_flush_type_bits_size(void){
	 return 4;
}

void connectib_flush_type_bits_dump(const struct connectib_flush_type_bits *ptr_struct, FILE* file) {
	connectib_flush_type_bits_print(ptr_struct, file, 0);
}

void connectib_project_nvqc_pack(const struct connectib_project_nvqc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_type_pack(&(ptr_struct->type), ptr_buff + offset/8);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->support_rd);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->support_wr);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

}

void connectib_project_nvqc_unpack(struct connectib_project_nvqc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_type_unpack(&(ptr_struct->type), ptr_buff + offset/8);

	offset=63;
	ptr_struct->support_rd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->support_wr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_project_nvqc_print(const struct connectib_project_nvqc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_project_nvqc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type:\n");
	connectib_nv_tlv_type_print(&(ptr_struct->type), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "support_rd           : "UH_FMT"\n", ptr_struct->support_rd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "support_wr           : "UH_FMT"\n", ptr_struct->support_wr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

}

int connectib_project_nvqc_size(void){
	 return 8;
}

void connectib_project_nvqc_dump(const struct connectib_project_nvqc *ptr_struct, FILE* file) {
	connectib_project_nvqc_print(ptr_struct, file, 0);
}

void connectib_project_nvda_pack(const struct connectib_project_nvda *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_hdr_pack(&(ptr_struct->tlv_header), ptr_buff + offset/8);

	offset=96;
	connectib_register_access_data_pack(&(ptr_struct->nvda_data), ptr_buff + offset/8);

}

void connectib_project_nvda_unpack(struct connectib_project_nvda *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_hdr_unpack(&(ptr_struct->tlv_header), ptr_buff + offset/8);

	offset=96;
	connectib_register_access_data_unpack(&(ptr_struct->nvda_data), ptr_buff + offset/8);

}

void connectib_project_nvda_print(const struct connectib_project_nvda *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_project_nvda ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tlv_header:\n");
	connectib_nv_tlv_hdr_print(&(ptr_struct->tlv_header), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvda_data:\n");
	connectib_register_access_data_print(&(ptr_struct->nvda_data), file, indent_level + 1);

}

int connectib_project_nvda_size(void){
	 return 44;
}

void connectib_project_nvda_dump(const struct connectib_project_nvda *ptr_struct, FILE* file) {
	connectib_project_nvda_print(ptr_struct, file, 0);
}

void connectib_pmtu_reg_pack(const struct connectib_pmtu_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_mtu);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->admin_mtu);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->oper_mtu);

}

void connectib_pmtu_reg_unpack(struct connectib_pmtu_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->max_mtu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->admin_mtu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->oper_mtu = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_pmtu_reg_print(const struct connectib_pmtu_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pmtu_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : "UH_FMT"\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_mtu              : "UH_FMT"\n", ptr_struct->max_mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "admin_mtu            : "UH_FMT"\n", ptr_struct->admin_mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oper_mtu             : "UH_FMT"\n", ptr_struct->oper_mtu);

}

int connectib_pmtu_reg_size(void){
	 return 16;
}

void connectib_pmtu_reg_dump(const struct connectib_pmtu_reg *ptr_struct, FILE* file) {
	connectib_pmtu_reg_print(ptr_struct, file, 0);
}

void connectib_pamp_reg_pack(const struct connectib_pamp_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_pamp_reg_unpack(struct connectib_pamp_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_pamp_reg_print(const struct connectib_pamp_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pamp_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_pamp_reg_size(void){
	 return 44;
}

void connectib_pamp_reg_dump(const struct connectib_pamp_reg *ptr_struct, FILE* file) {
	connectib_pamp_reg_print(ptr_struct, file, 0);
}

void connectib_slrg_reg_pack(const struct connectib_slrg_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_slrg_reg_unpack(struct connectib_slrg_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_slrg_reg_print(const struct connectib_slrg_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_slrg_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_slrg_reg_size(void){
	 return 40;
}

void connectib_slrg_reg_dump(const struct connectib_slrg_reg *ptr_struct, FILE* file) {
	connectib_slrg_reg_print(ptr_struct, file, 0);
}

void connectib_ptas_reg_pack(const struct connectib_ptas_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_ptas_reg_unpack(struct connectib_ptas_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_ptas_reg_print(const struct connectib_ptas_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ptas_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_ptas_reg_size(void){
	 return 44;
}

void connectib_ptas_reg_dump(const struct connectib_ptas_reg *ptr_struct, FILE* file) {
	connectib_ptas_reg_print(ptr_struct, file, 0);
}

void connectib_sltp_reg_pack(const struct connectib_sltp_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_sltp_reg_unpack(struct connectib_sltp_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_sltp_reg_print(const struct connectib_sltp_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sltp_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_sltp_reg_size(void){
	 return 20;
}

void connectib_sltp_reg_dump(const struct connectib_sltp_reg *ptr_struct, FILE* file) {
	connectib_sltp_reg_print(ptr_struct, file, 0);
}

void connectib_slrp_reg_pack(const struct connectib_slrp_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_slrp_reg_unpack(struct connectib_slrp_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_slrp_reg_print(const struct connectib_slrp_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_slrp_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_slrp_reg_size(void){
	 return 40;
}

void connectib_slrp_reg_dump(const struct connectib_slrp_reg *ptr_struct, FILE* file) {
	connectib_slrp_reg_print(ptr_struct, file, 0);
}

void connectib_paos_reg_pack(const struct connectib_paos_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->oper_status);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->admin_status);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swid);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->e);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ee);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ase);

}

void connectib_paos_reg_unpack(struct connectib_paos_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->oper_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=20;
	ptr_struct->admin_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=62;
	ptr_struct->e = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=33;
	ptr_struct->ee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->ase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_paos_reg_print(const struct connectib_paos_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_paos_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oper_status          : "UH_FMT"\n", ptr_struct->oper_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "admin_status         : "UH_FMT"\n", ptr_struct->admin_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : "UH_FMT"\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : "UH_FMT"\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e                    : "UH_FMT"\n", ptr_struct->e);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ee                   : "UH_FMT"\n", ptr_struct->ee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ase                  : "UH_FMT"\n", ptr_struct->ase);

}

int connectib_paos_reg_size(void){
	 return 16;
}

void connectib_paos_reg_dump(const struct connectib_paos_reg *ptr_struct, FILE* file) {
	connectib_paos_reg_print(ptr_struct, file, 0);
}

void connectib_mjtag_pack(const struct connectib_mjtag *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->size);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sequence_number);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cmd);

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 352, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_mjtag_unpack(struct connectib_mjtag *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=4;
	ptr_struct->sequence_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->cmd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	for (i=0; i < 10; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 352, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_mjtag_print(const struct connectib_mjtag *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mjtag ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sequence_number      : "UH_FMT"\n", ptr_struct->sequence_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmd                  : "UH_FMT"\n", ptr_struct->cmd);

	for (i=0; i < 10; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_mjtag_size(void){
	 return 44;
}

void connectib_mjtag_dump(const struct connectib_mjtag *ptr_struct, FILE* file) {
	connectib_mjtag_print(ptr_struct, file, 0);
}

void connectib_mfbe_pack(const struct connectib_mfbe *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fs);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->p);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->address);

}

void connectib_mfbe_unpack(struct connectib_mfbe *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->fs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=72;
	ptr_struct->address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_mfbe_print(const struct connectib_mfbe *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mfbe ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fs                   : "UH_FMT"\n", ptr_struct->fs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "p                    : "UH_FMT"\n", ptr_struct->p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : "UH_FMT"\n", ptr_struct->address);

}

int connectib_mfbe_size(void){
	 return 12;
}

void connectib_mfbe_dump(const struct connectib_mfbe *ptr_struct, FILE* file) {
	connectib_mfbe_print(ptr_struct, file, 0);
}

void connectib_project_mfba_pack(const struct connectib_project_mfba *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mfba_header_pack(&(ptr_struct->mfba_header), ptr_buff + offset/8);

	offset=96;
	connectib_register_access_data_pack(&(ptr_struct->mfba_data), ptr_buff + offset/8);

}

void connectib_project_mfba_unpack(struct connectib_project_mfba *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mfba_header_unpack(&(ptr_struct->mfba_header), ptr_buff + offset/8);

	offset=96;
	connectib_register_access_data_unpack(&(ptr_struct->mfba_data), ptr_buff + offset/8);

}

void connectib_project_mfba_print(const struct connectib_project_mfba *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_project_mfba ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfba_header:\n");
	connectib_mfba_header_print(&(ptr_struct->mfba_header), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfba_data:\n");
	connectib_register_access_data_print(&(ptr_struct->mfba_data), file, indent_level + 1);

}

int connectib_project_mfba_size(void){
	 return 44;
}

void connectib_project_mfba_dump(const struct connectib_project_mfba *ptr_struct, FILE* file) {
	connectib_project_mfba_print(ptr_struct, file, 0);
}

void connectib_register_misc_counters_pack(const struct connectib_register_misc_counters *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->counter_select);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ecc);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ldb_silent_drop);

}

void connectib_register_misc_counters_unpack(struct connectib_register_misc_counters *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	ptr_struct->counter_select = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->ecc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->ldb_silent_drop = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_register_misc_counters_print(const struct connectib_register_misc_counters *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_register_misc_counters ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_select       : "U32H_FMT"\n", ptr_struct->counter_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecc                  : "U32H_FMT"\n", ptr_struct->ecc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ldb_silent_drop      : "U32H_FMT"\n", ptr_struct->ldb_silent_drop);

}

int connectib_register_misc_counters_size(void){
	 return 32;
}

void connectib_register_misc_counters_dump(const struct connectib_register_misc_counters *ptr_struct, FILE* file) {
	connectib_register_misc_counters_print(ptr_struct, file, 0);
}

void connectib_mtmp_pack(const struct connectib_mtmp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->sensor_index);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->internal_diodes_query);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_temperture);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mtr);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mte);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_hi);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tee);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->temperature_threshold_lo);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->name_lo);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->name_hi);

}

void connectib_mtmp_unpack(struct connectib_mtmp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	ptr_struct->sensor_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=0;
	ptr_struct->internal_diodes_query = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->temperature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=80;
	ptr_struct->max_temperture = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=65;
	ptr_struct->mtr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->mte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->temperature_threshold_hi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->tee = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=144;
	ptr_struct->temperature_threshold_lo = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->name_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->name_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_mtmp_print(const struct connectib_mtmp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mtmp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sensor_index         : "UH_FMT"\n", ptr_struct->sensor_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_diodes_query : "UH_FMT"\n", ptr_struct->internal_diodes_query);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature          : "UH_FMT"\n", ptr_struct->temperature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_temperture       : "UH_FMT"\n", ptr_struct->max_temperture);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtr                  : "UH_FMT"\n", ptr_struct->mtr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mte                  : "UH_FMT"\n", ptr_struct->mte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_hi : "UH_FMT"\n", ptr_struct->temperature_threshold_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tee                  : "UH_FMT"\n", ptr_struct->tee);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temperature_threshold_lo : "UH_FMT"\n", ptr_struct->temperature_threshold_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "name_lo              : "U32H_FMT"\n", ptr_struct->name_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "name_hi              : "U32H_FMT"\n", ptr_struct->name_hi);

}

int connectib_mtmp_size(void){
	 return 28;
}

void connectib_mtmp_dump(const struct connectib_mtmp *ptr_struct, FILE* file) {
	connectib_mtmp_print(ptr_struct, file, 0);
}

void connectib_register_mfrl_pack(const struct connectib_register_mfrl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->reset_level);

}

void connectib_register_mfrl_unpack(struct connectib_register_mfrl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=56;
	ptr_struct->reset_level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_register_mfrl_print(const struct connectib_register_mfrl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_register_mfrl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_level          : "UH_FMT"\n", ptr_struct->reset_level);

}

int connectib_register_mfrl_size(void){
	 return 16;
}

void connectib_register_mfrl_dump(const struct connectib_register_mfrl *ptr_struct, FILE* file) {
	connectib_register_mfrl_print(ptr_struct, file, 0);
}

void connectib_register_mfai_pack(const struct connectib_register_mfai *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->address);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->permanent);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->use_address);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->use_image_id);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->image_id);

}

void connectib_register_mfai_unpack(struct connectib_register_mfai *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=2;
	ptr_struct->permanent = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->use_address = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->use_image_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->image_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_register_mfai_print(const struct connectib_register_mfai *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_register_mfai ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : "UH_FMT"\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "permanent            : "UH_FMT"\n", ptr_struct->permanent);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "use_address          : "UH_FMT"\n", ptr_struct->use_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "use_image_id         : "UH_FMT"\n", ptr_struct->use_image_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "image_id             : "UH_FMT"\n", ptr_struct->image_id);

}

int connectib_register_mfai_size(void){
	 return 16;
}

void connectib_register_mfai_dump(const struct connectib_register_mfai *ptr_struct, FILE* file) {
	connectib_register_mfai_print(ptr_struct, file, 0);
}

void connectib_mfpa_pack(const struct connectib_mfpa *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->fs);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->p);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->boot_address);

	offset=156;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->flash_num);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wip);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->jedec_id);

	offset=214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->sector_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->block_allignment);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->block_size);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->capability_mask);

}

void connectib_mfpa_unpack(struct connectib_mfpa *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->fs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->p = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=40;
	ptr_struct->boot_address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=156;
	ptr_struct->flash_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->wip = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->jedec_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=214;
	ptr_struct->sector_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=200;
	ptr_struct->block_allignment = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->block_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=224;
	ptr_struct->capability_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_mfpa_print(const struct connectib_mfpa *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mfpa ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fs                   : "UH_FMT"\n", ptr_struct->fs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "p                    : "UH_FMT"\n", ptr_struct->p);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "boot_address         : "UH_FMT"\n", ptr_struct->boot_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flash_num            : "UH_FMT"\n", ptr_struct->flash_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wip                  : "UH_FMT"\n", ptr_struct->wip);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "jedec_id             : "UH_FMT"\n", ptr_struct->jedec_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sector_size          : "UH_FMT"\n", ptr_struct->sector_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "block_allignment     : "UH_FMT"\n", ptr_struct->block_allignment);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "block_size           : "UH_FMT"\n", ptr_struct->block_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capability_mask      : "U32H_FMT"\n", ptr_struct->capability_mask);

}

int connectib_mfpa_size(void){
	 return 32;
}

void connectib_mfpa_dump(const struct connectib_mfpa *ptr_struct, FILE* file) {
	connectib_mfpa_print(ptr_struct, file, 0);
}

void connectib_ib_gid_pack(const struct connectib_ib_gid *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_ib_gid_unpack(struct connectib_ib_gid *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_ib_gid_print(const struct connectib_ib_gid *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ib_gid ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_ib_gid_size(void){
	 return 16;
}

void connectib_ib_gid_dump(const struct connectib_ib_gid *ptr_struct, FILE* file) {
	connectib_ib_gid_print(ptr_struct, file, 0);
}

void connectib_dmfs_hash_meta_pack(const struct connectib_dmfs_hash_meta *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_hash_entries);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->entry_count);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->descendant_count);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->default_ste_ix);

}

void connectib_dmfs_hash_meta_unpack(struct connectib_dmfs_hash_meta *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->log_hash_entries = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=48;
	ptr_struct->entry_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->descendant_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->default_ste_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_dmfs_hash_meta_print(const struct connectib_dmfs_hash_meta *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dmfs_hash_meta ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_hash_entries     : "UH_FMT"\n", ptr_struct->log_hash_entries);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "entry_count          : "UH_FMT"\n", ptr_struct->entry_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "descendant_count     : "UH_FMT"\n", ptr_struct->descendant_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "default_ste_ix       : "U64H_FMT"\n", ptr_struct->default_ste_ix);

}

int connectib_dmfs_hash_meta_size(void){
	 return 16;
}

void connectib_dmfs_hash_meta_dump(const struct connectib_dmfs_hash_meta *ptr_struct, FILE* file) {
	connectib_dmfs_hash_meta_print(ptr_struct, file, 0);
}

void connectib_dmfs_fte_meta_pack(const struct connectib_dmfs_fte_meta *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dest_iter_ix);

}

void connectib_dmfs_fte_meta_unpack(struct connectib_dmfs_fte_meta *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dest_iter_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_dmfs_fte_meta_print(const struct connectib_dmfs_fte_meta *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dmfs_fte_meta ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dest_iter_ix         : "U64H_FMT"\n", ptr_struct->dest_iter_ix);

}

int connectib_dmfs_fte_meta_size(void){
	 return 8;
}

void connectib_dmfs_fte_meta_dump(const struct connectib_dmfs_fte_meta *ptr_struct, FILE* file) {
	connectib_dmfs_fte_meta_print(ptr_struct, file, 0);
}

void connectib_dmfs_ft_meta_pack(const struct connectib_dmfs_ft_meta *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->table_type);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log2_table_size);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->level);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->other_vport);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_number);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->groups_list_head);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->total_ref_count);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->iter_rule_count);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->groups_member_count);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ft_head_ix);

}

void connectib_dmfs_ft_meta_unpack(struct connectib_dmfs_ft_meta *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->table_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->log2_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->other_vport = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->vport_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->groups_list_head = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->total_ref_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->iter_rule_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->groups_member_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->ft_head_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_dmfs_ft_meta_print(const struct connectib_dmfs_ft_meta *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dmfs_ft_meta ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_type           : "UH_FMT"\n", ptr_struct->table_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_table_size      : "UH_FMT"\n", ptr_struct->log2_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "level                : "UH_FMT"\n", ptr_struct->level);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "other_vport          : "UH_FMT"\n", ptr_struct->other_vport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_number         : "UH_FMT"\n", ptr_struct->vport_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "groups_list_head     : "U32H_FMT"\n", ptr_struct->groups_list_head);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_ref_count      : "UH_FMT"\n", ptr_struct->total_ref_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iter_rule_count      : "UH_FMT"\n", ptr_struct->iter_rule_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "groups_member_count  : "U32H_FMT"\n", ptr_struct->groups_member_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ft_head_ix           : "U64H_FMT"\n", ptr_struct->ft_head_ix);

}

int connectib_dmfs_ft_meta_size(void){
	 return 32;
}

void connectib_dmfs_ft_meta_dump(const struct connectib_dmfs_ft_meta *ptr_struct, FILE* file) {
	connectib_dmfs_ft_meta_print(ptr_struct, file, 0);
}

void connectib_dmfs_group_meta_pack(const struct connectib_dmfs_group_meta *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->table_type);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->match_criteria_enable);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->other_vport);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_number);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->start_flow_index);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->end_flow_index);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->prev_group_id);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->next_group_id);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->root_hash_meta_ix);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->end_ste_ix);

}

void connectib_dmfs_group_meta_unpack(struct connectib_dmfs_group_meta *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	ptr_struct->table_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=88;
	ptr_struct->match_criteria_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=80;
	ptr_struct->other_vport = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->vport_number = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->start_flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->end_flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->prev_group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->next_group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->root_hash_meta_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->end_ste_ix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_dmfs_group_meta_print(const struct connectib_dmfs_group_meta *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dmfs_group_meta ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_type           : "UH_FMT"\n", ptr_struct->table_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "match_criteria_enable : "UH_FMT"\n", ptr_struct->match_criteria_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "other_vport          : "UH_FMT"\n", ptr_struct->other_vport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_number         : "UH_FMT"\n", ptr_struct->vport_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_flow_index     : "U32H_FMT"\n", ptr_struct->start_flow_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_flow_index       : "U32H_FMT"\n", ptr_struct->end_flow_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prev_group_id        : "U32H_FMT"\n", ptr_struct->prev_group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_group_id        : "U32H_FMT"\n", ptr_struct->next_group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "root_hash_meta_ix    : "U32H_FMT"\n", ptr_struct->root_hash_meta_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_ste_ix           : "U64H_FMT"\n", ptr_struct->end_ste_ix);

}

int connectib_dmfs_group_meta_size(void){
	 return 64;
}

void connectib_dmfs_group_meta_dump(const struct connectib_dmfs_group_meta *ptr_struct, FILE* file) {
	connectib_dmfs_group_meta_print(ptr_struct, file, 0);
}

void connectib_mkey_dump_pack(const struct connectib_mkey_dump *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ready_4_dump);

}

void connectib_mkey_dump_unpack(struct connectib_mkey_dump *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->ready_4_dump = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_mkey_dump_print(const struct connectib_mkey_dump *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mkey_dump ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ready_4_dump         : "UH_FMT"\n", ptr_struct->ready_4_dump);

}

int connectib_mkey_dump_size(void){
	 return 4;
}

void connectib_mkey_dump_dump(const struct connectib_mkey_dump *ptr_struct, FILE* file) {
	connectib_mkey_dump_print(ptr_struct, file, 0);
}

void connectib_fw_tis_pack(const struct connectib_fw_tis *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->prio);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sqn_head);

}

void connectib_fw_tis_unpack(struct connectib_fw_tis *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=48;
	ptr_struct->prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->sqn_head = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_fw_tis_print(const struct connectib_fw_tis *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_tis ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prio                 : "UH_FMT"\n", ptr_struct->prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn_head             : "UH_FMT"\n", ptr_struct->sqn_head);

}

int connectib_fw_tis_size(void){
	 return 64;
}

void connectib_fw_tis_dump(const struct connectib_fw_tis *ptr_struct, FILE* file) {
	connectib_fw_tis_print(ptr_struct, file, 0);
}

void connectib_fw_tir_pack(const struct connectib_fw_tir *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->inline_rqn);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->disp_type);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lro_max_ip_payload_size);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->lro_enable_mask);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lro_timeout_period_usecs);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rqt_number);

	offset=100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rx_hash_fn);

	offset=99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tunneled_offload_en);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_hash_symmetric);

	offset=128;
	connectib_rx_hash_field_select_pack(&(ptr_struct->rx_hash_field_selector_outer), ptr_buff + offset/8);

	offset=160;
	connectib_rx_hash_field_select_pack(&(ptr_struct->rx_hash_field_selector_inner), ptr_buff + offset/8);

	offset=384;
	connectib_tir_dmfs_pack(&(ptr_struct->dmfs), ptr_buff + offset/8);

}

void connectib_fw_tir_unpack(struct connectib_fw_tir *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=40;
	ptr_struct->inline_rqn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=36;
	ptr_struct->disp_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=88;
	ptr_struct->lro_max_ip_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=84;
	ptr_struct->lro_enable_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->lro_timeout_period_usecs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=104;
	ptr_struct->rqt_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=100;
	ptr_struct->rx_hash_fn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=99;
	ptr_struct->tunneled_offload_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=97;
	ptr_struct->rx_hash_symmetric = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=128;
	connectib_rx_hash_field_select_unpack(&(ptr_struct->rx_hash_field_selector_outer), ptr_buff + offset/8);

	offset=160;
	connectib_rx_hash_field_select_unpack(&(ptr_struct->rx_hash_field_selector_inner), ptr_buff + offset/8);

	offset=384;
	connectib_tir_dmfs_unpack(&(ptr_struct->dmfs), ptr_buff + offset/8);

}

void connectib_fw_tir_print(const struct connectib_fw_tir *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_tir ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_rqn           : "UH_FMT"\n", ptr_struct->inline_rqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disp_type            : "UH_FMT"\n", ptr_struct->disp_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lro_max_ip_payload_size : "UH_FMT"\n", ptr_struct->lro_max_ip_payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lro_enable_mask      : "UH_FMT"\n", ptr_struct->lro_enable_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lro_timeout_period_usecs : "UH_FMT"\n", ptr_struct->lro_timeout_period_usecs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_number           : "UH_FMT"\n", ptr_struct->rqt_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_hash_fn           : "UH_FMT"\n", ptr_struct->rx_hash_fn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tunneled_offload_en  : "UH_FMT"\n", ptr_struct->tunneled_offload_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_hash_symmetric    : "UH_FMT"\n", ptr_struct->rx_hash_symmetric);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_hash_field_selector_outer:\n");
	connectib_rx_hash_field_select_print(&(ptr_struct->rx_hash_field_selector_outer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_hash_field_selector_inner:\n");
	connectib_rx_hash_field_select_print(&(ptr_struct->rx_hash_field_selector_inner), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmfs:\n");
	connectib_tir_dmfs_print(&(ptr_struct->dmfs), file, indent_level + 1);

}

int connectib_fw_tir_size(void){
	 return 64;
}

void connectib_fw_tir_dump(const struct connectib_fw_tir *ptr_struct, FILE* file) {
	connectib_fw_tir_print(ptr_struct, file, 0);
}

void connectib_fw_qpc_pack(const struct connectib_fw_qpc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sw_st);

	offset=53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->sw_rwq_type);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_sq);

	offset=50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sw_rq_type);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_dual_write);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ack_fence_req);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ack_slice_to_fence);

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->sw_timer_granularity);

	offset=86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->chilling_timer_granularity);

	offset=85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->one_side_flush);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->apm_path_validation_failed);

	offset=83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cd_slave_send);

	offset=82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cd_slave_receive);

	offset=81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cd_master);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sqd_on_sigerr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->tis_num);

	offset=128;
	connectib_fw_qpc_q_pack(&(ptr_struct->responder), ptr_buff + offset/8);

	offset=256;
	connectib_fw_qpc_q_pack(&(ptr_struct->requestor), ptr_buff + offset/8);

	offset=384;
	connectib_fw_qpc_special_pack(&(ptr_struct->fw_qpc_special), ptr_buff + offset/8);

}

void connectib_fw_qpc_unpack(struct connectib_fw_qpc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	ptr_struct->sw_st = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=53;
	ptr_struct->sw_rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=52;
	ptr_struct->no_sq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=50;
	ptr_struct->sw_rq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=49;
	ptr_struct->qp_dual_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->ack_fence_req = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=40;
	ptr_struct->ack_slice_to_fence = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=91;
	ptr_struct->sw_timer_granularity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=86;
	ptr_struct->chilling_timer_granularity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=85;
	ptr_struct->one_side_flush = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=84;
	ptr_struct->apm_path_validation_failed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=83;
	ptr_struct->cd_slave_send = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=82;
	ptr_struct->cd_slave_receive = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=81;
	ptr_struct->cd_master = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->sqd_on_sigerr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=104;
	ptr_struct->tis_num = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=128;
	connectib_fw_qpc_q_unpack(&(ptr_struct->responder), ptr_buff + offset/8);

	offset=256;
	connectib_fw_qpc_q_unpack(&(ptr_struct->requestor), ptr_buff + offset/8);

	offset=384;
	connectib_fw_qpc_special_unpack(&(ptr_struct->fw_qpc_special), ptr_buff + offset/8);

}

void connectib_fw_qpc_print(const struct connectib_fw_qpc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_qpc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_st                : "UH_FMT"\n", ptr_struct->sw_st);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_rwq_type          : "UH_FMT"\n", ptr_struct->sw_rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_sq                : "UH_FMT"\n", ptr_struct->no_sq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_rq_type           : "UH_FMT"\n", ptr_struct->sw_rq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_dual_write        : "UH_FMT"\n", ptr_struct->qp_dual_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_fence_req        : "UH_FMT"\n", ptr_struct->ack_fence_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_slice_to_fence   : "UH_FMT"\n", ptr_struct->ack_slice_to_fence);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_timer_granularity : "UH_FMT"\n", ptr_struct->sw_timer_granularity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "chilling_timer_granularity : "UH_FMT"\n", ptr_struct->chilling_timer_granularity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "one_side_flush       : "UH_FMT"\n", ptr_struct->one_side_flush);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "apm_path_validation_failed : "UH_FMT"\n", ptr_struct->apm_path_validation_failed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cd_slave_send        : "UH_FMT"\n", ptr_struct->cd_slave_send);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cd_slave_receive     : "UH_FMT"\n", ptr_struct->cd_slave_receive);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cd_master            : "UH_FMT"\n", ptr_struct->cd_master);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqd_on_sigerr        : "UH_FMT"\n", ptr_struct->sqd_on_sigerr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tis_num              : "UH_FMT"\n", ptr_struct->tis_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder:\n");
	connectib_fw_qpc_q_print(&(ptr_struct->responder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requestor:\n");
	connectib_fw_qpc_q_print(&(ptr_struct->requestor), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_qpc_special:\n");
	connectib_fw_qpc_special_print(&(ptr_struct->fw_qpc_special), file, indent_level + 1);

}

int connectib_fw_qpc_size(void){
	 return 64;
}

void connectib_fw_qpc_dump(const struct connectib_fw_qpc *ptr_struct, FILE* file) {
	connectib_fw_qpc_print(ptr_struct, file, 0);
}

void connectib_fw_srqc_pack(const struct connectib_fw_srqc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->catas_event_generated);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->basic_cyclic_rcv_wqe);

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->invalid_user_index);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->trap_reason);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->trap_data);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->no_lro_qpn);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->memory_rq_state);

}

void connectib_fw_srqc_unpack(struct connectib_fw_srqc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=63;
	ptr_struct->catas_event_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->basic_cyclic_rcv_wqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=61;
	ptr_struct->invalid_user_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->trap_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->trap_data = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=136;
	ptr_struct->no_lro_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=128;
	ptr_struct->memory_rq_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_fw_srqc_print(const struct connectib_fw_srqc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_srqc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "catas_event_generated : "UH_FMT"\n", ptr_struct->catas_event_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "basic_cyclic_rcv_wqe : "UH_FMT"\n", ptr_struct->basic_cyclic_rcv_wqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invalid_user_index   : "UH_FMT"\n", ptr_struct->invalid_user_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_reason          : %s ("UH_FMT")\n", (ptr_struct->trap_reason == 1 ? ("NOP") : ((ptr_struct->trap_reason == 2 ? ("SET_LIMIT") : ("unknown")))), ptr_struct->trap_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_data            : "UH_FMT"\n", ptr_struct->trap_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_lro_qpn           : "UH_FMT"\n", ptr_struct->no_lro_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_rq_state      : "UH_FMT"\n", ptr_struct->memory_rq_state);

}

int connectib_fw_srqc_size(void){
	 return 64;
}

void connectib_fw_srqc_dump(const struct connectib_fw_srqc *ptr_struct, FILE* file) {
	connectib_fw_srqc_print(ptr_struct, file, 0);
}

void connectib_sw_ads_pack(const struct connectib_sw_ads *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey_index);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->free_ar);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fl);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rlid);

	offset=41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->mlid);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->stat_rate);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->src_addr_index);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ack_timeout);

	offset=108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(152, 8, i, 352, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rgid_rip[i]);
	}

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->udp_sport);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->dscp);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ecn);

	offset=263;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->f_eth_prio);

	offset=261;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->f_ecn);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->f_dscp);

	offset=304;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rmac_47_32);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset=292;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=289;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->eth_prio);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dei_cfi);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rmac_31_0);

}

void connectib_sw_ads_unpack(struct connectib_sw_ads *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->pkey_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=1;
	ptr_struct->free_ar = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->fl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->rlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=41;
	ptr_struct->mlid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=40;
	ptr_struct->grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=84;
	ptr_struct->stat_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->src_addr_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->ack_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=108;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=100;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(152, 8, i, 352, 1);
	ptr_struct->rgid_rip[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	offset=272;
	ptr_struct->udp_sport = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=266;
	ptr_struct->dscp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=264;
	ptr_struct->ecn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=263;
	ptr_struct->f_eth_prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=261;
	ptr_struct->f_ecn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->f_dscp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=304;
	ptr_struct->rmac_47_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=296;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=292;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=289;
	ptr_struct->eth_prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=288;
	ptr_struct->dei_cfi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=320;
	ptr_struct->rmac_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_sw_ads_print(const struct connectib_sw_ads *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_ads ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_index           : "UH_FMT"\n", ptr_struct->pkey_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "free_ar              : "UH_FMT"\n", ptr_struct->free_ar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fl                   : "UH_FMT"\n", ptr_struct->fl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rlid                 : "UH_FMT"\n", ptr_struct->rlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlid                 : "UH_FMT"\n", ptr_struct->mlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh                  : "UH_FMT"\n", ptr_struct->grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stat_rate            : %s ("UH_FMT")\n", (ptr_struct->stat_rate == 0 ? ("no_limit") : ((ptr_struct->stat_rate == 7 ? ("2_5Gbps") : ((ptr_struct->stat_rate == 8 ? ("10Gbps") : ((ptr_struct->stat_rate == 9 ? ("30Gbps") : ((ptr_struct->stat_rate == 10 ? ("5Gbps") : ((ptr_struct->stat_rate == 11 ? ("20Gbps") : ((ptr_struct->stat_rate == 12 ? ("40Gbps") : ((ptr_struct->stat_rate == 13 ? ("60Gbps") : ((ptr_struct->stat_rate == 14 ? ("80Gbps") : ((ptr_struct->stat_rate == 15 ? ("120Gbps") : ("unknown")))))))))))))))))))), ptr_struct->stat_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_addr_index       : "UH_FMT"\n", ptr_struct->src_addr_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_timeout          : "UH_FMT"\n", ptr_struct->ack_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_rip_%03d        : "UH_FMT"\n", i, ptr_struct->rgid_rip[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "udp_sport            : "UH_FMT"\n", ptr_struct->udp_sport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dscp                 : "UH_FMT"\n", ptr_struct->dscp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecn                  : "UH_FMT"\n", ptr_struct->ecn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f_eth_prio           : "UH_FMT"\n", ptr_struct->f_eth_prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f_ecn                : "UH_FMT"\n", ptr_struct->f_ecn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "f_dscp               : "UH_FMT"\n", ptr_struct->f_dscp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rmac_47_32           : "UH_FMT"\n", ptr_struct->rmac_47_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_prio             : "UH_FMT"\n", ptr_struct->eth_prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dei_cfi              : "UH_FMT"\n", ptr_struct->dei_cfi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rmac_31_0            : "U32H_FMT"\n", ptr_struct->rmac_31_0);

}

int connectib_sw_ads_size(void){
	 return 44;
}

void connectib_sw_ads_dump(const struct connectib_sw_ads *ptr_struct, FILE* file) {
	connectib_sw_ads_print(ptr_struct, file, 0);
}

void connectib_hw_msix_ext_context_pack(const struct connectib_hw_msix_ext_context *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mask_3_0);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->disable_3_0);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->need);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->timestamp_51_32);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->min_wait);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_31_0);

}

void connectib_hw_msix_ext_context_unpack(struct connectib_hw_msix_ext_context *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->mask_3_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=24;
	ptr_struct->disable_3_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=23;
	ptr_struct->need = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=76;
	ptr_struct->timestamp_51_32 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=64;
	ptr_struct->min_wait = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=96;
	ptr_struct->timestamp_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_msix_ext_context_print(const struct connectib_hw_msix_ext_context *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_msix_ext_context ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mask_3_0             : "UH_FMT"\n", ptr_struct->mask_3_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_3_0          : "UH_FMT"\n", ptr_struct->disable_3_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "need                 : "UH_FMT"\n", ptr_struct->need);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_51_32      : "UH_FMT"\n", ptr_struct->timestamp_51_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_wait             : "UH_FMT"\n", ptr_struct->min_wait);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_31_0       : "U32H_FMT"\n", ptr_struct->timestamp_31_0);

}

int connectib_hw_msix_ext_context_size(void){
	 return 16;
}

void connectib_hw_msix_ext_context_dump(const struct connectib_hw_msix_ext_context *ptr_struct, FILE* file) {
	connectib_hw_msix_ext_context_print(ptr_struct, file, 0);
}

void connectib_hw_msix_context_pack(const struct connectib_hw_msix_context *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->addr_31_2_);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->addr_63_32_);

	offset=64;
	connectib_hw_msix_context_data_pack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spec_mask);

}

void connectib_hw_msix_context_unpack(struct connectib_hw_msix_context *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->addr_31_2_ = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

	offset=32;
	ptr_struct->addr_63_32_ = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	connectib_hw_msix_context_data_unpack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=127;
	ptr_struct->spec_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_msix_context_print(const struct connectib_hw_msix_context *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_msix_context ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_31_2_           : "UH_FMT"\n", ptr_struct->addr_31_2_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_63_32_          : "U32H_FMT"\n", ptr_struct->addr_63_32_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data:\n");
	connectib_hw_msix_context_data_print(&(ptr_struct->data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec_mask            : "UH_FMT"\n", ptr_struct->spec_mask);

}

int connectib_hw_msix_context_size(void){
	 return 16;
}

void connectib_hw_msix_context_dump(const struct connectib_hw_msix_context *ptr_struct, FILE* file) {
	connectib_hw_msix_context_print(ptr_struct, file, 0);
}

void connectib_hw_rdb_atomic_data_pack(const struct connectib_hw_rdb_atomic_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->atomic_data[i]);
	}

}

void connectib_hw_rdb_atomic_data_unpack(struct connectib_hw_rdb_atomic_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	ptr_struct->atomic_data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_hw_rdb_atomic_data_print(const struct connectib_hw_rdb_atomic_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_rdb_atomic_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_data_%03d     : "U32H_FMT"\n", i, ptr_struct->atomic_data[i]);
	}

}

int connectib_hw_rdb_atomic_data_size(void){
	 return 32;
}

void connectib_hw_rdb_atomic_data_dump(const struct connectib_hw_rdb_atomic_data *ptr_struct, FILE* file) {
	connectib_hw_rdb_atomic_data_print(ptr_struct, file, 0);
}

void connectib_hw_mtt2_pack(const struct connectib_hw_mtt2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hi);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->lo);

}

void connectib_hw_mtt2_unpack(struct connectib_hw_mtt2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_mtt2_print(const struct connectib_hw_mtt2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_mtt2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hi                   : "U32H_FMT"\n", ptr_struct->hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lo                   : "U32H_FMT"\n", ptr_struct->lo);

}

int connectib_hw_mtt2_size(void){
	 return 8;
}

void connectib_hw_mtt2_dump(const struct connectib_hw_mtt2 *ptr_struct, FILE* file) {
	connectib_hw_mtt2_print(ptr_struct, file, 0);
}

void connectib_hw_mtt_pack(const struct connectib_hw_mtt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pas_63_32);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rd_en);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wr_en);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->pas_31_3);

}

void connectib_hw_mtt_unpack(struct connectib_hw_mtt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->pas_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=63;
	ptr_struct->rd_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->wr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->pas_31_3 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

}

void connectib_hw_mtt_print(const struct connectib_hw_mtt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_mtt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pas_63_32            : "U32H_FMT"\n", ptr_struct->pas_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rd_en                : "UH_FMT"\n", ptr_struct->rd_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wr_en                : "UH_FMT"\n", ptr_struct->wr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pas_31_3             : "UH_FMT"\n", ptr_struct->pas_31_3);

}

int connectib_hw_mtt_size(void){
	 return 8;
}

void connectib_hw_mtt_dump(const struct connectib_hw_mtt *ptr_struct, FILE* file) {
	connectib_hw_mtt_print(ptr_struct, file, 0);
}

void connectib_steering_qp_list_pack(const struct connectib_steering_qp_list *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry0), ptr_buff + offset/8);

	offset=32;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry1), ptr_buff + offset/8);

	offset=64;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry2), ptr_buff + offset/8);

	offset=96;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry3), ptr_buff + offset/8);

	offset=128;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry4), ptr_buff + offset/8);

	offset=160;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry5), ptr_buff + offset/8);

	offset=192;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry6), ptr_buff + offset/8);

	offset=224;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry7), ptr_buff + offset/8);

	offset=256;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry8), ptr_buff + offset/8);

	offset=288;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry9), ptr_buff + offset/8);

	offset=320;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry10), ptr_buff + offset/8);

	offset=352;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry11), ptr_buff + offset/8);

	offset=384;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry12), ptr_buff + offset/8);

	offset=416;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry13), ptr_buff + offset/8);

	offset=448;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry14), ptr_buff + offset/8);

	offset=480;
	connectib_steering_qp_entry_pack(&(ptr_struct->steering_qp_entry15), ptr_buff + offset/8);

}

void connectib_steering_qp_list_unpack(struct connectib_steering_qp_list *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry0), ptr_buff + offset/8);

	offset=32;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry1), ptr_buff + offset/8);

	offset=64;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry2), ptr_buff + offset/8);

	offset=96;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry3), ptr_buff + offset/8);

	offset=128;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry4), ptr_buff + offset/8);

	offset=160;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry5), ptr_buff + offset/8);

	offset=192;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry6), ptr_buff + offset/8);

	offset=224;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry7), ptr_buff + offset/8);

	offset=256;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry8), ptr_buff + offset/8);

	offset=288;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry9), ptr_buff + offset/8);

	offset=320;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry10), ptr_buff + offset/8);

	offset=352;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry11), ptr_buff + offset/8);

	offset=384;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry12), ptr_buff + offset/8);

	offset=416;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry13), ptr_buff + offset/8);

	offset=448;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry14), ptr_buff + offset/8);

	offset=480;
	connectib_steering_qp_entry_unpack(&(ptr_struct->steering_qp_entry15), ptr_buff + offset/8);

}

void connectib_steering_qp_list_print(const struct connectib_steering_qp_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_steering_qp_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry0:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry1:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry2:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry3:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry4:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry5:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry5), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry6:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry6), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry7:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry7), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry8:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry8), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry9:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry9), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry10:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry10), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry11:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry11), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry12:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry12), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry13:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry13), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry14:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry14), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_entry15:\n");
	connectib_steering_qp_entry_print(&(ptr_struct->steering_qp_entry15), file, indent_level + 1);

}

int connectib_steering_qp_list_size(void){
	 return 64;
}

void connectib_steering_qp_list_dump(const struct connectib_steering_qp_list *ptr_struct, FILE* file) {
	connectib_steering_qp_list_print(ptr_struct, file, 0);
}

void connectib_hw_ste_pack(const struct connectib_hw_ste *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->member_count);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_packet_qp);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_fw_int);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rx_cmd);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pport_byte_counters_trigger);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pport_packet_counters_trigger);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_byte_counters_trigger);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_packet_counters_trigger);

	offset=37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_sniffer);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_func_lb);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_wire);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_fw_int);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->sx_cmd);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_lookup_type);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hit_lookup_type_hash_field_mask);

	offset=114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_hit_entry_size);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hit_base_address_63_32);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hit_lookup_type);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->hit_base_address_31_8);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->miss_address_63_32);

	offset=250;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_hit_table_size);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 26, (u_int32_t)ptr_struct->miss_address_31_6);

	offset=256;
	connectib_hw_ste_tag_pack(&(ptr_struct->tag_data), ptr_buff + offset/8);

	offset=384;
	connectib_hw_ste_tag_pack(&(ptr_struct->tag_mask), ptr_buff + offset/8);

}

void connectib_hw_ste_unpack(struct connectib_hw_ste *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->member_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=3;
	ptr_struct->rx_packet_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->rx_fw_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->rx_cmd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=56;
	ptr_struct->pport_byte_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->pport_packet_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=44;
	ptr_struct->vport_byte_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=40;
	ptr_struct->vport_packet_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=37;
	ptr_struct->sx_sniffer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=36;
	ptr_struct->sx_func_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=35;
	ptr_struct->sx_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=34;
	ptr_struct->sx_fw_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->sx_cmd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=64;
	ptr_struct->my_lookup_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=120;
	ptr_struct->hit_lookup_type_hash_field_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=114;
	ptr_struct->log2_hit_entry_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=96;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->hit_base_address_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=184;
	ptr_struct->hit_lookup_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=160;
	ptr_struct->hit_base_address_31_8 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->miss_address_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=250;
	ptr_struct->log2_hit_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=224;
	ptr_struct->miss_address_31_6 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 26);

	offset=256;
	connectib_hw_ste_tag_unpack(&(ptr_struct->tag_data), ptr_buff + offset/8);

	offset=384;
	connectib_hw_ste_tag_unpack(&(ptr_struct->tag_mask), ptr_buff + offset/8);

}

void connectib_hw_ste_print(const struct connectib_hw_ste *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_ste ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "member_count         : "UH_FMT"\n", ptr_struct->member_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_packet_qp         : "UH_FMT"\n", ptr_struct->rx_packet_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_fw_int            : "UH_FMT"\n", ptr_struct->rx_fw_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_cmd               : "UH_FMT"\n", ptr_struct->rx_cmd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport_byte_counters_trigger : "UH_FMT"\n", ptr_struct->pport_byte_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport_packet_counters_trigger : "UH_FMT"\n", ptr_struct->pport_packet_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_byte_counters_trigger : "UH_FMT"\n", ptr_struct->vport_byte_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_packet_counters_trigger : "UH_FMT"\n", ptr_struct->vport_packet_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_sniffer           : "UH_FMT"\n", ptr_struct->sx_sniffer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_func_lb           : "UH_FMT"\n", ptr_struct->sx_func_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_wire              : "UH_FMT"\n", ptr_struct->sx_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_fw_int            : "UH_FMT"\n", ptr_struct->sx_fw_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_cmd               : "UH_FMT"\n", ptr_struct->sx_cmd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lookup_type       : "UH_FMT"\n", ptr_struct->my_lookup_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hit_lookup_type_hash_field_mask : "UH_FMT"\n", ptr_struct->hit_lookup_type_hash_field_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_hit_entry_size  : "UH_FMT"\n", ptr_struct->log2_hit_entry_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hit_base_address_63_32 : "U32H_FMT"\n", ptr_struct->hit_base_address_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hit_lookup_type      : "UH_FMT"\n", ptr_struct->hit_lookup_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hit_base_address_31_8 : "UH_FMT"\n", ptr_struct->hit_base_address_31_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "miss_address_63_32   : "U32H_FMT"\n", ptr_struct->miss_address_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_hit_table_size  : "UH_FMT"\n", ptr_struct->log2_hit_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "miss_address_31_6    : "UH_FMT"\n", ptr_struct->miss_address_31_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_data:\n");
	connectib_hw_ste_tag_print(&(ptr_struct->tag_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tag_mask:\n");
	connectib_hw_ste_tag_print(&(ptr_struct->tag_mask), file, indent_level + 1);

}

int connectib_hw_ste_size(void){
	 return 64;
}

void connectib_hw_ste_dump(const struct connectib_hw_ste *ptr_struct, FILE* file) {
	connectib_hw_ste_print(ptr_struct, file, 0);
}

void connectib_hw_timer_pack(const struct connectib_hw_timer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->timer_granularity);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->timer_state);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->timer_valid);

}

void connectib_hw_timer_unpack(struct connectib_hw_timer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	ptr_struct->timer_granularity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->timer_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=0;
	ptr_struct->timer_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_timer_print(const struct connectib_hw_timer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_timer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_granularity    : "UH_FMT"\n", ptr_struct->timer_granularity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_state          : "UH_FMT"\n", ptr_struct->timer_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_valid          : "UH_FMT"\n", ptr_struct->timer_valid);

}

int connectib_hw_timer_size(void){
	 return 1;
}

void connectib_hw_timer_dump(const struct connectib_hw_timer *ptr_struct, FILE* file) {
	connectib_hw_timer_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_pack(const struct connectib_hw_bsf_entry_w_non_repeating_m_non_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_check_gen);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_init);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->m_pad);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_check_gen);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_init);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->w_pad);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_unpack(struct connectib_hw_bsf_entry_w_non_repeating_m_non_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->m_check_gen = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->m_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->m_pad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->w_check_gen = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->w_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->w_pad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_print(const struct connectib_hw_bsf_entry_w_non_repeating_m_non_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_w_non_repeating_m_non_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_check_gen          : "UH_FMT"\n", ptr_struct->m_check_gen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_init               : "UH_FMT"\n", ptr_struct->m_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_pad                : "UH_FMT"\n", ptr_struct->m_pad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_check_gen          : "UH_FMT"\n", ptr_struct->w_check_gen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_init               : "UH_FMT"\n", ptr_struct->w_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_pad                : "UH_FMT"\n", ptr_struct->w_pad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_dump(const struct connectib_hw_bsf_entry_w_non_repeating_m_non_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_w_non_repeating_m_repeating_pack(const struct connectib_hw_bsf_entry_w_non_repeating_m_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_block_size_selector);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_check_gen);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_init);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->w_pad);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_non_repeating_m_repeating_unpack(struct connectib_hw_bsf_entry_w_non_repeating_m_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->m_block_size_selector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=23;
	ptr_struct->w_check_gen = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->w_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->w_pad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_non_repeating_m_repeating_print(const struct connectib_hw_bsf_entry_w_non_repeating_m_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_w_non_repeating_m_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_block_size_selector : "UH_FMT"\n", ptr_struct->m_block_size_selector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_check_gen          : "UH_FMT"\n", ptr_struct->w_check_gen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_init               : "UH_FMT"\n", ptr_struct->w_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_pad                : "UH_FMT"\n", ptr_struct->w_pad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_w_non_repeating_m_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_w_non_repeating_m_repeating_dump(const struct connectib_hw_bsf_entry_w_non_repeating_m_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_w_non_repeating_m_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_w_repeating_m_non_repeating_pack(const struct connectib_hw_bsf_entry_w_repeating_m_non_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_check_gen);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_init);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->m_pad);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_block_size_selector);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_repeating_m_non_repeating_unpack(struct connectib_hw_bsf_entry_w_repeating_m_non_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->m_check_gen = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->m_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->m_pad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=16;
	ptr_struct->w_block_size_selector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_repeating_m_non_repeating_print(const struct connectib_hw_bsf_entry_w_repeating_m_non_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_w_repeating_m_non_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_check_gen          : "UH_FMT"\n", ptr_struct->m_check_gen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_init               : "UH_FMT"\n", ptr_struct->m_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_pad                : "UH_FMT"\n", ptr_struct->m_pad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_block_size_selector : "UH_FMT"\n", ptr_struct->w_block_size_selector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_w_repeating_m_non_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_w_repeating_m_non_repeating_dump(const struct connectib_hw_bsf_entry_w_repeating_m_non_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_w_repeating_m_non_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_w_repeating_m_repeating_pack(const struct connectib_hw_bsf_entry_w_repeating_m_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_block_size_selector);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_block_size_selector);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_repeating_m_repeating_unpack(struct connectib_hw_bsf_entry_w_repeating_m_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->m_block_size_selector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->w_block_size_selector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_w_repeating_m_repeating_print(const struct connectib_hw_bsf_entry_w_repeating_m_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_w_repeating_m_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_block_size_selector : "UH_FMT"\n", ptr_struct->m_block_size_selector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_block_size_selector : "UH_FMT"\n", ptr_struct->w_block_size_selector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_w_repeating_m_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_w_repeating_m_repeating_dump(const struct connectib_hw_bsf_entry_w_repeating_m_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_w_repeating_m_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_same_block_non_repeating_pack(const struct connectib_hw_bsf_entry_same_block_non_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_check_gen);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_init);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->m_pad);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->copy_byte_mask);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_same_block_non_repeating_unpack(struct connectib_hw_bsf_entry_same_block_non_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->m_check_gen = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->m_init = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->m_pad = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=16;
	ptr_struct->copy_byte_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_same_block_non_repeating_print(const struct connectib_hw_bsf_entry_same_block_non_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_same_block_non_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_check_gen          : "UH_FMT"\n", ptr_struct->m_check_gen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_init               : "UH_FMT"\n", ptr_struct->m_init);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_pad                : "UH_FMT"\n", ptr_struct->m_pad);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "copy_byte_mask       : "UH_FMT"\n", ptr_struct->copy_byte_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_same_block_non_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_same_block_non_repeating_dump(const struct connectib_hw_bsf_entry_same_block_non_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_same_block_non_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_same_block_repeating_pack(const struct connectib_hw_bsf_entry_same_block_repeating *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_block_size_selector);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->copy_byte_mask);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->byte_check_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aligned);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->size);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_b_psv_pointer);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_b_pdf_ptr);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_b_psv_pointer);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_b_pdf_ptr);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->prologue_size);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_end);

	offset=134;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_t_start);

	offset=131;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_end);

	offset=130;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_t_start);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->epilogue_size);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->w_t_psv_pointer);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->w_t_pdf_ptr);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->m_t_psv_pointer);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->m_t_pdf_ptr);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->w_dif_app_tag);

	offset=257;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_refresh_dif_params);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->w_in_line_vld);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_dif_ref_tag);

	offset=320;
	connectib_hw_pdf_entry_pack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->m_dif_app_tag);

	offset=385;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_refresh_dif_params);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->m_in_line_vld);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_dif_ref_tag);

	offset=448;
	connectib_hw_pdf_entry_pack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_same_block_repeating_unpack(struct connectib_hw_bsf_entry_same_block_repeating *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->m_block_size_selector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->copy_byte_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->byte_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=3;
	ptr_struct->aligned = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->raw_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->w_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->w_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->m_b_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->m_b_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->prologue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=135;
	ptr_struct->m_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=134;
	ptr_struct->m_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=131;
	ptr_struct->w_t_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=130;
	ptr_struct->w_t_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->epilogue_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->w_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->w_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->m_t_psv_pointer = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->m_t_pdf_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=272;
	ptr_struct->w_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=257;
	ptr_struct->w_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	ptr_struct->w_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=288;
	ptr_struct->w_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->w_in_line_pdf), ptr_buff + offset/8);

	offset=400;
	ptr_struct->m_dif_app_tag = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=385;
	ptr_struct->m_refresh_dif_params = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->m_in_line_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=416;
	ptr_struct->m_dif_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	connectib_hw_pdf_entry_unpack(&(ptr_struct->m_in_line_pdf), ptr_buff + offset/8);

}

void connectib_hw_bsf_entry_same_block_repeating_print(const struct connectib_hw_bsf_entry_same_block_repeating *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry_same_block_repeating ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_block_size_selector : "UH_FMT"\n", ptr_struct->m_block_size_selector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "copy_byte_mask       : "UH_FMT"\n", ptr_struct->copy_byte_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_check_en        : "UH_FMT"\n", ptr_struct->byte_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aligned              : "UH_FMT"\n", ptr_struct->aligned);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_size             : "U32H_FMT"\n", ptr_struct->raw_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_psv_pointer      : "UH_FMT"\n", ptr_struct->w_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_psv_pointer      : "UH_FMT"\n", ptr_struct->m_b_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_b_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_b_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prologue_size        : "UH_FMT"\n", ptr_struct->prologue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_end              : "UH_FMT"\n", ptr_struct->m_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_start            : "UH_FMT"\n", ptr_struct->m_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_end              : "UH_FMT"\n", ptr_struct->w_t_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_start            : "UH_FMT"\n", ptr_struct->w_t_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "epilogue_size        : "UH_FMT"\n", ptr_struct->epilogue_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_psv_pointer      : "UH_FMT"\n", ptr_struct->w_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->w_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_psv_pointer      : "UH_FMT"\n", ptr_struct->m_t_psv_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_t_pdf_ptr          : "UH_FMT"\n", ptr_struct->m_t_pdf_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_app_tag        : "UH_FMT"\n", ptr_struct->w_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_refresh_dif_params : "UH_FMT"\n", ptr_struct->w_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_vld        : "UH_FMT"\n", ptr_struct->w_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->w_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->w_in_line_pdf), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_app_tag        : "UH_FMT"\n", ptr_struct->m_dif_app_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_refresh_dif_params : "UH_FMT"\n", ptr_struct->m_refresh_dif_params);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_vld        : "UH_FMT"\n", ptr_struct->m_in_line_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_dif_ref_tag        : "U32H_FMT"\n", ptr_struct->m_dif_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_in_line_pdf:\n");
	connectib_hw_pdf_entry_print(&(ptr_struct->m_in_line_pdf), file, indent_level + 1);

}

int connectib_hw_bsf_entry_same_block_repeating_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_same_block_repeating_dump(const struct connectib_hw_bsf_entry_same_block_repeating *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_same_block_repeating_print(ptr_struct, file, 0);
}

void connectib_hw_dct_pack(const struct connectib_hw_dct *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->complete_to_64B_eyald);

	offset=283;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=282;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=275;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->max_message_size);

	offset=274;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=273;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=269;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtu);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dc_access_key_log_num_byte);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=263;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=262;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=261;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=300;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=297;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=289;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->my_lid);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_number);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=372;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dc_access_key);

}

void connectib_hw_dct_unpack(struct connectib_hw_dct *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->complete_to_64B_eyald = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=283;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=282;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=280;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=275;
	ptr_struct->max_message_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=274;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=273;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=272;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=269;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=268;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->dc_access_key_log_num_byte = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=264;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=263;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=262;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=261;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=300;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=297;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=296;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=289;
	ptr_struct->my_lid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=288;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=328;
	ptr_struct->srq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=320;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=372;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=368;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=356;
	ptr_struct->ipd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=392;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=384;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=424;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=416;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->dc_access_key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_dct_print(const struct connectib_hw_dct *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_dct ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "complete_to_64B_eyald : "U32H_FMT"\n", ptr_struct->complete_to_64B_eyald);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_message_size     : "UH_FMT"\n", ptr_struct->max_message_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : "UH_FMT"\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_access_key_log_num_byte : "UH_FMT"\n", ptr_struct->dc_access_key_log_num_byte);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lid               : "UH_FMT"\n", ptr_struct->my_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number           : "UH_FMT"\n", ptr_struct->srq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipd                  : "UH_FMT"\n", ptr_struct->ipd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_access_key        : "U64H_FMT"\n", ptr_struct->dc_access_key);

}

int connectib_hw_dct_size(void){
	 return 64;
}

void connectib_hw_dct_dump(const struct connectib_hw_dct *ptr_struct, FILE* file) {
	connectib_hw_dct_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_ud_l2_cd_pack(const struct connectib_hw_r_qpc_ud_l2_cd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_wire);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_gvmi);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_lb);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_lb);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_my_self_multicast);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_to_cqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->no_wqe_drop_count);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_wire);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->mpi_uar);

}

void connectib_hw_r_qpc_ud_l2_cd_unpack(struct connectib_hw_r_qpc_ud_l2_cd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->check_source_uc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->check_source_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->check_source_mc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->check_source_uc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->drop_my_self_multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->grh_to_cqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=368;
	ptr_struct->no_wqe_drop_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->check_source_mc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=480;
	ptr_struct->mpi_uar = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_hw_r_qpc_ud_l2_cd_print(const struct connectib_hw_r_qpc_ud_l2_cd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_ud_l2_cd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_wire : "UH_FMT"\n", ptr_struct->check_source_uc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_gvmi    : "UH_FMT"\n", ptr_struct->check_source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_lb   : "UH_FMT"\n", ptr_struct->check_source_mc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_lb   : "UH_FMT"\n", ptr_struct->check_source_uc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_my_self_multicast : "UH_FMT"\n", ptr_struct->drop_my_self_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_to_cqe           : "UH_FMT"\n", ptr_struct->grh_to_cqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_wqe_drop_count    : "UH_FMT"\n", ptr_struct->no_wqe_drop_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_wire : "UH_FMT"\n", ptr_struct->check_source_mc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpi_uar              : "UH_FMT"\n", ptr_struct->mpi_uar);

}

int connectib_hw_r_qpc_ud_l2_cd_size(void){
	 return 64;
}

void connectib_hw_r_qpc_ud_l2_cd_dump(const struct connectib_hw_r_qpc_ud_l2_cd *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_ud_l2_cd_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_ud_l2_2srq_pack(const struct connectib_hw_r_qpc_ud_l2_2srq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_wire);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_gvmi);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_lb);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_lb);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_my_self_multicast);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_to_cqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->no_wqe_drop_count);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_number);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_wire);

}

void connectib_hw_r_qpc_ud_l2_2srq_unpack(struct connectib_hw_r_qpc_ud_l2_2srq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->check_source_uc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->check_source_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->check_source_mc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->check_source_uc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->drop_my_self_multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->grh_to_cqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=368;
	ptr_struct->no_wqe_drop_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=456;
	ptr_struct->srq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=510;
	ptr_struct->check_source_mc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_r_qpc_ud_l2_2srq_print(const struct connectib_hw_r_qpc_ud_l2_2srq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_ud_l2_2srq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_wire : "UH_FMT"\n", ptr_struct->check_source_uc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_gvmi    : "UH_FMT"\n", ptr_struct->check_source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_lb   : "UH_FMT"\n", ptr_struct->check_source_mc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_lb   : "UH_FMT"\n", ptr_struct->check_source_uc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_my_self_multicast : "UH_FMT"\n", ptr_struct->drop_my_self_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_to_cqe           : "UH_FMT"\n", ptr_struct->grh_to_cqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_wqe_drop_count    : "UH_FMT"\n", ptr_struct->no_wqe_drop_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number           : "UH_FMT"\n", ptr_struct->srq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_wire : "UH_FMT"\n", ptr_struct->check_source_mc_wire);

}

int connectib_hw_r_qpc_ud_l2_2srq_size(void){
	 return 64;
}

void connectib_hw_r_qpc_ud_l2_2srq_dump(const struct connectib_hw_r_qpc_ud_l2_2srq *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_ud_l2_2srq_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_ud_l2_2cyclicbuff_pack(const struct connectib_hw_r_qpc_ud_l2_2cyclicbuff *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_wire);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_gvmi);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_lb);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_lb);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_my_self_multicast);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_to_cqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_producer);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->no_wqe_drop_count);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->e2e_pa_63_32);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_wire);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->e2e_pa_31_2);

}

void connectib_hw_r_qpc_ud_l2_2cyclicbuff_unpack(struct connectib_hw_r_qpc_ud_l2_2cyclicbuff *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->check_source_uc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->check_source_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->check_source_mc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->check_source_uc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->drop_my_self_multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->grh_to_cqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rcyclic_producer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=368;
	ptr_struct->no_wqe_drop_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->e2e_pa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->check_source_mc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=480;
	ptr_struct->e2e_pa_31_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

}

void connectib_hw_r_qpc_ud_l2_2cyclicbuff_print(const struct connectib_hw_r_qpc_ud_l2_2cyclicbuff *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_ud_l2_2cyclicbuff ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_wire : "UH_FMT"\n", ptr_struct->check_source_uc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_gvmi    : "UH_FMT"\n", ptr_struct->check_source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_lb   : "UH_FMT"\n", ptr_struct->check_source_mc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_lb   : "UH_FMT"\n", ptr_struct->check_source_uc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_my_self_multicast : "UH_FMT"\n", ptr_struct->drop_my_self_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_to_cqe           : "UH_FMT"\n", ptr_struct->grh_to_cqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_producer     : "U32H_FMT"\n", ptr_struct->rcyclic_producer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_wqe_drop_count    : "UH_FMT"\n", ptr_struct->no_wqe_drop_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_63_32         : "U32H_FMT"\n", ptr_struct->e2e_pa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_wire : "UH_FMT"\n", ptr_struct->check_source_mc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_31_2          : "UH_FMT"\n", ptr_struct->e2e_pa_31_2);

}

int connectib_hw_r_qpc_ud_l2_2cyclicbuff_size(void){
	 return 64;
}

void connectib_hw_r_qpc_ud_l2_2cyclicbuff_dump(const struct connectib_hw_r_qpc_ud_l2_2cyclicbuff *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_ud_l2_2cyclicbuff_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_ud_l2_pack(const struct connectib_hw_r_qpc_ud_l2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_wire);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_gvmi);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_lb);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_lb);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_my_self_multicast);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_to_cqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->no_wqe_drop_count);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->e2e_pa_63_32);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_wire);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->e2e_pa_31_2);

}

void connectib_hw_r_qpc_ud_l2_unpack(struct connectib_hw_r_qpc_ud_l2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->check_source_uc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->check_source_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->check_source_mc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->check_source_uc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->drop_my_self_multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->grh_to_cqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=368;
	ptr_struct->no_wqe_drop_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->e2e_pa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->check_source_mc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=480;
	ptr_struct->e2e_pa_31_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

}

void connectib_hw_r_qpc_ud_l2_print(const struct connectib_hw_r_qpc_ud_l2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_ud_l2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_wire : "UH_FMT"\n", ptr_struct->check_source_uc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_gvmi    : "UH_FMT"\n", ptr_struct->check_source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_lb   : "UH_FMT"\n", ptr_struct->check_source_mc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_lb   : "UH_FMT"\n", ptr_struct->check_source_uc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_my_self_multicast : "UH_FMT"\n", ptr_struct->drop_my_self_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_to_cqe           : "UH_FMT"\n", ptr_struct->grh_to_cqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_wqe_drop_count    : "UH_FMT"\n", ptr_struct->no_wqe_drop_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_63_32         : "U32H_FMT"\n", ptr_struct->e2e_pa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_wire : "UH_FMT"\n", ptr_struct->check_source_mc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_31_2          : "UH_FMT"\n", ptr_struct->e2e_pa_31_2);

}

int connectib_hw_r_qpc_ud_l2_size(void){
	 return 64;
}

void connectib_hw_r_qpc_ud_l2_dump(const struct connectib_hw_r_qpc_ud_l2 *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_ud_l2_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_unconnected_common_pack(const struct connectib_hw_r_qpc_unconnected_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_wire);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_gvmi);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_lb);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_uc_lb);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_my_self_multicast);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_to_cqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->no_wqe_drop_count);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->check_source_mc_wire);

}

void connectib_hw_r_qpc_unconnected_common_unpack(struct connectib_hw_r_qpc_unconnected_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->check_source_uc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=23;
	ptr_struct->check_source_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->check_source_mc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->check_source_uc_lb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->drop_my_self_multicast = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->grh_to_cqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=368;
	ptr_struct->no_wqe_drop_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->check_source_mc_wire = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_r_qpc_unconnected_common_print(const struct connectib_hw_r_qpc_unconnected_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_unconnected_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_wire : "UH_FMT"\n", ptr_struct->check_source_uc_wire);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_gvmi    : "UH_FMT"\n", ptr_struct->check_source_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_lb   : "UH_FMT"\n", ptr_struct->check_source_mc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_uc_lb   : "UH_FMT"\n", ptr_struct->check_source_uc_lb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_my_self_multicast : "UH_FMT"\n", ptr_struct->drop_my_self_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_to_cqe           : "UH_FMT"\n", ptr_struct->grh_to_cqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_wqe_drop_count    : "UH_FMT"\n", ptr_struct->no_wqe_drop_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_source_mc_wire : "UH_FMT"\n", ptr_struct->check_source_mc_wire);

}

int connectib_hw_r_qpc_unconnected_common_size(void){
	 return 64;
}

void connectib_hw_r_qpc_unconnected_common_dump(const struct connectib_hw_r_qpc_unconnected_common *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_unconnected_common_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_xrc_pack(const struct connectib_hw_r_qpc_xrc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->msn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_number);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->xrc_domain);

}

void connectib_hw_r_qpc_xrc_unpack(struct connectib_hw_r_qpc_xrc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->msn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=456;
	ptr_struct->srq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=480;
	ptr_struct->xrc_domain = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_hw_r_qpc_xrc_print(const struct connectib_hw_r_qpc_xrc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_xrc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msn                  : "UH_FMT"\n", ptr_struct->msn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number           : "UH_FMT"\n", ptr_struct->srq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xrc_domain           : "UH_FMT"\n", ptr_struct->xrc_domain);

}

int connectib_hw_r_qpc_xrc_size(void){
	 return 64;
}

void connectib_hw_r_qpc_xrc_dump(const struct connectib_hw_r_qpc_xrc *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_xrc_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_dcr_pack(const struct connectib_hw_r_qpc_dcr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->msn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dct_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_dcr);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

	offset=509;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dcr_connected);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->responder_session_id);

}

void connectib_hw_r_qpc_dcr_unpack(struct connectib_hw_r_qpc_dcr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->msn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->dct_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=456;
	ptr_struct->next_dcr = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=509;
	ptr_struct->dcr_connected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=480;
	ptr_struct->responder_session_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_hw_r_qpc_dcr_print(const struct connectib_hw_r_qpc_dcr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_dcr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msn                  : "UH_FMT"\n", ptr_struct->msn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_number           : "UH_FMT"\n", ptr_struct->dct_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_dcr             : "UH_FMT"\n", ptr_struct->next_dcr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_connected        : "UH_FMT"\n", ptr_struct->dcr_connected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_session_id : "UH_FMT"\n", ptr_struct->responder_session_id);

}

int connectib_hw_r_qpc_dcr_size(void){
	 return 64;
}

void connectib_hw_r_qpc_dcr_dump(const struct connectib_hw_r_qpc_dcr *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_dcr_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_rc_uc_2srq_pack(const struct connectib_hw_r_qpc_rc_uc_2srq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->msn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_number);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

}

void connectib_hw_r_qpc_rc_uc_2srq_unpack(struct connectib_hw_r_qpc_rc_uc_2srq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->msn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=456;
	ptr_struct->srq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_hw_r_qpc_rc_uc_2srq_print(const struct connectib_hw_r_qpc_rc_uc_2srq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_rc_uc_2srq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msn                  : "UH_FMT"\n", ptr_struct->msn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number           : "UH_FMT"\n", ptr_struct->srq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

}

int connectib_hw_r_qpc_rc_uc_2srq_size(void){
	 return 64;
}

void connectib_hw_r_qpc_rc_uc_2srq_dump(const struct connectib_hw_r_qpc_rc_uc_2srq *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_rc_uc_2srq_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_rc_uc_2cycbuff_pack(const struct connectib_hw_r_qpc_rc_uc_2cycbuff *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_producer);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rcyclic_consumer);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->e2e_pa_63_32);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->e2e_pa_31_2);

}

void connectib_hw_r_qpc_rc_uc_2cycbuff_unpack(struct connectib_hw_r_qpc_rc_uc_2cycbuff *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rcyclic_producer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->rcyclic_consumer = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->e2e_pa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=480;
	ptr_struct->e2e_pa_31_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

}

void connectib_hw_r_qpc_rc_uc_2cycbuff_print(const struct connectib_hw_r_qpc_rc_uc_2cycbuff *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_rc_uc_2cycbuff ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_producer     : "U32H_FMT"\n", ptr_struct->rcyclic_producer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_consumer     : "U32H_FMT"\n", ptr_struct->rcyclic_consumer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_63_32         : "U32H_FMT"\n", ptr_struct->e2e_pa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_31_2          : "UH_FMT"\n", ptr_struct->e2e_pa_31_2);

}

int connectib_hw_r_qpc_rc_uc_2cycbuff_size(void){
	 return 64;
}

void connectib_hw_r_qpc_rc_uc_2cycbuff_dump(const struct connectib_hw_r_qpc_rc_uc_2cycbuff *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_rc_uc_2cycbuff_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_rc_uc_cd_pack(const struct connectib_hw_r_qpc_rc_uc_cd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->msn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->mpi_uar);

}

void connectib_hw_r_qpc_rc_uc_cd_unpack(struct connectib_hw_r_qpc_rc_uc_cd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->msn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=480;
	ptr_struct->mpi_uar = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_hw_r_qpc_rc_uc_cd_print(const struct connectib_hw_r_qpc_rc_uc_cd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_rc_uc_cd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msn                  : "UH_FMT"\n", ptr_struct->msn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mpi_uar              : "UH_FMT"\n", ptr_struct->mpi_uar);

}

int connectib_hw_r_qpc_rc_uc_cd_size(void){
	 return 64;
}

void connectib_hw_r_qpc_rc_uc_cd_dump(const struct connectib_hw_r_qpc_rc_uc_cd *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_rc_uc_cd_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_rc_uc_dci_pack(const struct connectib_hw_r_qpc_rc_uc_dci *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_producer_index);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->msn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->e2e_pa_63_32);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->e2e_pa_31_2);

}

void connectib_hw_r_qpc_rc_uc_dci_unpack(struct connectib_hw_r_qpc_rc_uc_dci *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rwqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->msn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->e2e_pa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=480;
	ptr_struct->e2e_pa_31_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

}

void connectib_hw_r_qpc_rc_uc_dci_print(const struct connectib_hw_r_qpc_rc_uc_dci *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_rc_uc_dci ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_producer_index  : "UH_FMT"\n", ptr_struct->rwqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msn                  : "UH_FMT"\n", ptr_struct->msn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_63_32         : "U32H_FMT"\n", ptr_struct->e2e_pa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_31_2          : "UH_FMT"\n", ptr_struct->e2e_pa_31_2);

}

int connectib_hw_r_qpc_rc_uc_dci_size(void){
	 return 64;
}

void connectib_hw_r_qpc_rc_uc_dci_dump(const struct connectib_hw_r_qpc_rc_uc_dci *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_rc_uc_dci_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_connected_common_pack(const struct connectib_hw_r_qpc_connected_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_opcode);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->read_enable);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->send_with_invalidate_enable);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->atomic_like_write);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ack_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->write_rkey);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rnr_timer);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=312;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_read_pointer);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_length_committed);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->sqn);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_va);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->connection_state);

}

void connectib_hw_r_qpc_connected_common_unpack(struct connectib_hw_r_qpc_connected_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->last_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->read_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->send_with_invalidate_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->write_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->atomic_like_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ack_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->write_rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=75;
	ptr_struct->rnr_timer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->first_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=312;
	ptr_struct->rdb_read_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=320;
	ptr_struct->rx_length_committed = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=368;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=357;
	ptr_struct->sqn = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->write_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=510;
	ptr_struct->connection_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_hw_r_qpc_connected_common_print(const struct connectib_hw_r_qpc_connected_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_connected_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_opcode          : "UH_FMT"\n", ptr_struct->last_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_enable          : "UH_FMT"\n", ptr_struct->read_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "send_with_invalidate_enable : "UH_FMT"\n", ptr_struct->send_with_invalidate_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_enable         : "UH_FMT"\n", ptr_struct->write_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_like_write    : "UH_FMT"\n", ptr_struct->atomic_like_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_type             : "UH_FMT"\n", ptr_struct->ack_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_rkey           : "U32H_FMT"\n", ptr_struct->write_rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_timer            : "UH_FMT"\n", ptr_struct->rnr_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_non_acked_psn  : "UH_FMT"\n", ptr_struct->first_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_read_pointer     : "UH_FMT"\n", ptr_struct->rdb_read_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_length_committed  : "UH_FMT"\n", ptr_struct->rx_length_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sqn                  : "UH_FMT"\n", ptr_struct->sqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_va             : "U64H_FMT"\n", ptr_struct->write_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connection_state     : "UH_FMT"\n", ptr_struct->connection_state);

}

int connectib_hw_r_qpc_connected_common_size(void){
	 return 64;
}

void connectib_hw_r_qpc_connected_common_dump(const struct connectib_hw_r_qpc_connected_common *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_connected_common_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_common_pack(const struct connectib_hw_r_qpc_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_link_type);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->post_receive_slave_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->expected_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

}

void connectib_hw_r_qpc_common_unpack(struct connectib_hw_r_qpc_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->fw_link_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->post_receive_slave_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=68;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->expected_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_r_qpc_common_print(const struct connectib_hw_r_qpc_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_link_type         : "UH_FMT"\n", ptr_struct->fw_link_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post_receive_slave_enable : "UH_FMT"\n", ptr_struct->post_receive_slave_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_psn         : "UH_FMT"\n", ptr_struct->expected_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

}

int connectib_hw_r_qpc_common_size(void){
	 return 64;
}

void connectib_hw_r_qpc_common_dump(const struct connectib_hw_r_qpc_common *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_common_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_ud_l2_pack(const struct connectib_hw_s_qpc_ud_l2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->umr_permission_select);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->packet_allowed);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_enable);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frwr_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_consumer_index);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->deth_sqpn);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_to_send_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh_tclass);

	offset=361;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->sx_gather_commit);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_my_gid_index);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vl15);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh);

}

void connectib_hw_s_qpc_ud_l2_unpack(struct connectib_hw_s_qpc_ud_l2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->umr_permission_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=2;
	ptr_struct->packet_allowed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->umr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=66;
	ptr_struct->frwr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->swqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->deth_sqpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->next_to_send_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=336;
	ptr_struct->force_grh_tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=361;
	ptr_struct->sx_gather_commit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset=360;
	ptr_struct->force_my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=449;
	ptr_struct->vl15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=448;
	ptr_struct->force_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_s_qpc_ud_l2_print(const struct connectib_hw_s_qpc_ud_l2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc_ud_l2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_permission_select : "UH_FMT"\n", ptr_struct->umr_permission_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_allowed       : "UH_FMT"\n", ptr_struct->packet_allowed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_enable           : "UH_FMT"\n", ptr_struct->umr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frwr_enable          : "UH_FMT"\n", ptr_struct->frwr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_consumer_index  : "UH_FMT"\n", ptr_struct->swqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "deth_sqpn            : "UH_FMT"\n", ptr_struct->deth_sqpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_to_send_psn     : "UH_FMT"\n", ptr_struct->next_to_send_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh_tclass     : "UH_FMT"\n", ptr_struct->force_grh_tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_gather_commit     : "UH_FMT"\n", ptr_struct->sx_gather_commit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_my_gid_index   : "UH_FMT"\n", ptr_struct->force_my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl15                 : "UH_FMT"\n", ptr_struct->vl15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh            : "UH_FMT"\n", ptr_struct->force_grh);

}

int connectib_hw_s_qpc_ud_l2_size(void){
	 return 64;
}

void connectib_hw_s_qpc_ud_l2_dump(const struct connectib_hw_s_qpc_ud_l2 *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_ud_l2_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_dci_pack(const struct connectib_hw_s_qpc_dci *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ldb_int);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_limit);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_counter);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->umr_permission_select);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dc_full_handshake);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->uncompleted_non_wire_wqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_state);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->limited_qp);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ack_req_frequency);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_enable);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frwr_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->currently_completing_wqe_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_consumer_index);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->oldest_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->psn_since_ackreq);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->responder_session_id);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_to_send_psn);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ssn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh_tclass);

	offset=332;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reverse_sl);

	offset=329;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_counter);

	offset=361;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->sx_gather_commit);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_my_gid_index);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_limit);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dc_access_key);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_psn_of_message_currently_completing);

	offset=450;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->currently_completing_ds);

	offset=449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->timer_enable);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh);

	offset=488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_unsent_psn);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->number_outstanding_reads);

}

void connectib_hw_s_qpc_dci_unpack(struct connectib_hw_s_qpc_dci *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->ldb_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=21;
	ptr_struct->rnr_nak_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->rnr_nak_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=6;
	ptr_struct->umr_permission_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->dc_full_handshake = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->uncompleted_non_wire_wqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->dc_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=76;
	ptr_struct->limited_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=72;
	ptr_struct->ack_req_frequency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->umr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=66;
	ptr_struct->frwr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->currently_completing_wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->swqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->oldest_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->psn_since_ackreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->responder_session_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->next_to_send_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=296;
	ptr_struct->ssn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=336;
	ptr_struct->force_grh_tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=332;
	ptr_struct->reverse_sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=329;
	ptr_struct->to_sequence_error_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=361;
	ptr_struct->sx_gather_commit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset=360;
	ptr_struct->force_my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=357;
	ptr_struct->to_sequence_error_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->dc_access_key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=456;
	ptr_struct->first_psn_of_message_currently_completing = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=450;
	ptr_struct->currently_completing_ds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=449;
	ptr_struct->timer_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=448;
	ptr_struct->force_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=488;
	ptr_struct->first_unsent_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=480;
	ptr_struct->number_outstanding_reads = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_s_qpc_dci_print(const struct connectib_hw_s_qpc_dci *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc_dci ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ldb_int              : "UH_FMT"\n", ptr_struct->ldb_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_limit  : "UH_FMT"\n", ptr_struct->rnr_nak_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_counter : "UH_FMT"\n", ptr_struct->rnr_nak_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_permission_select : "UH_FMT"\n", ptr_struct->umr_permission_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_full_handshake    : "UH_FMT"\n", ptr_struct->dc_full_handshake);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncompleted_non_wire_wqe : "UH_FMT"\n", ptr_struct->uncompleted_non_wire_wqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_state             : "UH_FMT"\n", ptr_struct->dc_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "limited_qp           : "UH_FMT"\n", ptr_struct->limited_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_req_frequency    : "UH_FMT"\n", ptr_struct->ack_req_frequency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_enable           : "UH_FMT"\n", ptr_struct->umr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frwr_enable          : "UH_FMT"\n", ptr_struct->frwr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_wqe_index : "UH_FMT"\n", ptr_struct->currently_completing_wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_consumer_index  : "UH_FMT"\n", ptr_struct->swqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oldest_non_acked_psn : "UH_FMT"\n", ptr_struct->oldest_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn_since_ackreq     : "UH_FMT"\n", ptr_struct->psn_since_ackreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_session_id : "UH_FMT"\n", ptr_struct->responder_session_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_to_send_psn     : "UH_FMT"\n", ptr_struct->next_to_send_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ssn                  : "UH_FMT"\n", ptr_struct->ssn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh_tclass     : "UH_FMT"\n", ptr_struct->force_grh_tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reverse_sl           : "UH_FMT"\n", ptr_struct->reverse_sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_counter : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_gather_commit     : "UH_FMT"\n", ptr_struct->sx_gather_commit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_my_gid_index   : "UH_FMT"\n", ptr_struct->force_my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_limit : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_access_key        : "U64H_FMT"\n", ptr_struct->dc_access_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_psn_of_message_currently_completing : "UH_FMT"\n", ptr_struct->first_psn_of_message_currently_completing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_ds : "UH_FMT"\n", ptr_struct->currently_completing_ds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_enable         : "UH_FMT"\n", ptr_struct->timer_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh            : "UH_FMT"\n", ptr_struct->force_grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_unsent_psn     : "UH_FMT"\n", ptr_struct->first_unsent_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_outstanding_reads : "UH_FMT"\n", ptr_struct->number_outstanding_reads);

}

int connectib_hw_s_qpc_dci_size(void){
	 return 64;
}

void connectib_hw_s_qpc_dci_dump(const struct connectib_hw_s_qpc_dci *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_dci_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_rc_uc_dcr_pack(const struct connectib_hw_s_qpc_rc_uc_dcr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ldb_int);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_limit);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_counter);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->umr_permission_select);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dc_full_handshake);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->uncompleted_non_wire_wqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_state);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->limited_qp);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ack_req_frequency);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_enable);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frwr_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->currently_completing_wqe_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_consumer_index);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->oldest_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->psn_since_ackreq);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->responder_session_id);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_to_send_psn);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ssn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh_tclass);

	offset=332;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reverse_sl);

	offset=329;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_counter);

	offset=361;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->sx_gather_commit);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_my_gid_index);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_limit);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=392;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->lsn);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_psn_of_message_currently_completing);

	offset=450;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->currently_completing_ds);

	offset=449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->timer_enable);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh);

	offset=488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_unsent_psn);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->number_outstanding_reads);

}

void connectib_hw_s_qpc_rc_uc_dcr_unpack(struct connectib_hw_s_qpc_rc_uc_dcr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->ldb_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=21;
	ptr_struct->rnr_nak_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->rnr_nak_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=6;
	ptr_struct->umr_permission_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->dc_full_handshake = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->uncompleted_non_wire_wqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->dc_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=76;
	ptr_struct->limited_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=72;
	ptr_struct->ack_req_frequency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->umr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=66;
	ptr_struct->frwr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->currently_completing_wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->swqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->oldest_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->psn_since_ackreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->responder_session_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->next_to_send_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=296;
	ptr_struct->ssn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=336;
	ptr_struct->force_grh_tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=332;
	ptr_struct->reverse_sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=329;
	ptr_struct->to_sequence_error_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=361;
	ptr_struct->sx_gather_commit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset=360;
	ptr_struct->force_my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=357;
	ptr_struct->to_sequence_error_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=392;
	ptr_struct->lsn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=456;
	ptr_struct->first_psn_of_message_currently_completing = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=450;
	ptr_struct->currently_completing_ds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=449;
	ptr_struct->timer_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=448;
	ptr_struct->force_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=488;
	ptr_struct->first_unsent_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=480;
	ptr_struct->number_outstanding_reads = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_s_qpc_rc_uc_dcr_print(const struct connectib_hw_s_qpc_rc_uc_dcr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc_rc_uc_dcr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ldb_int              : "UH_FMT"\n", ptr_struct->ldb_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_limit  : "UH_FMT"\n", ptr_struct->rnr_nak_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_counter : "UH_FMT"\n", ptr_struct->rnr_nak_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_permission_select : "UH_FMT"\n", ptr_struct->umr_permission_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_full_handshake    : "UH_FMT"\n", ptr_struct->dc_full_handshake);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncompleted_non_wire_wqe : "UH_FMT"\n", ptr_struct->uncompleted_non_wire_wqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_state             : "UH_FMT"\n", ptr_struct->dc_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "limited_qp           : "UH_FMT"\n", ptr_struct->limited_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_req_frequency    : "UH_FMT"\n", ptr_struct->ack_req_frequency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_enable           : "UH_FMT"\n", ptr_struct->umr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frwr_enable          : "UH_FMT"\n", ptr_struct->frwr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_wqe_index : "UH_FMT"\n", ptr_struct->currently_completing_wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_consumer_index  : "UH_FMT"\n", ptr_struct->swqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oldest_non_acked_psn : "UH_FMT"\n", ptr_struct->oldest_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn_since_ackreq     : "UH_FMT"\n", ptr_struct->psn_since_ackreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_session_id : "UH_FMT"\n", ptr_struct->responder_session_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_to_send_psn     : "UH_FMT"\n", ptr_struct->next_to_send_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ssn                  : "UH_FMT"\n", ptr_struct->ssn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh_tclass     : "UH_FMT"\n", ptr_struct->force_grh_tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reverse_sl           : "UH_FMT"\n", ptr_struct->reverse_sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_counter : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_gather_commit     : "UH_FMT"\n", ptr_struct->sx_gather_commit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_my_gid_index   : "UH_FMT"\n", ptr_struct->force_my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_limit : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lsn                  : "UH_FMT"\n", ptr_struct->lsn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_psn_of_message_currently_completing : "UH_FMT"\n", ptr_struct->first_psn_of_message_currently_completing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_ds : "UH_FMT"\n", ptr_struct->currently_completing_ds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_enable         : "UH_FMT"\n", ptr_struct->timer_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh            : "UH_FMT"\n", ptr_struct->force_grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_unsent_psn     : "UH_FMT"\n", ptr_struct->first_unsent_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_outstanding_reads : "UH_FMT"\n", ptr_struct->number_outstanding_reads);

}

int connectib_hw_s_qpc_rc_uc_dcr_size(void){
	 return 64;
}

void connectib_hw_s_qpc_rc_uc_dcr_dump(const struct connectib_hw_s_qpc_rc_uc_dcr *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_rc_uc_dcr_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_connected_common_pack(const struct connectib_hw_s_qpc_connected_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ldb_int);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_limit);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rnr_nak_retry_counter);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ignore_pkey_check);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_atomic);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_atomic);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->umr_permission_select);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_direct_access);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_credits_enabled);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dc_full_handshake);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->uncompleted_non_wire_wqe);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->dc_state);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->limited_qp);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ack_req_frequency);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_enable);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frwr_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->currently_completing_wqe_index);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_consumer_index);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->oldest_non_acked_psn);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->psn_since_ackreq);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->responder_session_id);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_to_send_psn);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ssn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh_tclass);

	offset=332;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reverse_sl);

	offset=329;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_counter);

	offset=361;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->sx_gather_commit);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_my_gid_index);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->to_sequence_error_retry_limit);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_psn_of_message_currently_completing);

	offset=450;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->currently_completing_ds);

	offset=449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->timer_enable);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh);

	offset=488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->first_unsent_psn);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->number_outstanding_reads);

}

void connectib_hw_s_qpc_connected_common_unpack(struct connectib_hw_s_qpc_connected_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->ldb_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=21;
	ptr_struct->rnr_nak_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->rnr_nak_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=16;
	ptr_struct->ignore_pkey_check = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->extended_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->max_read_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=6;
	ptr_struct->umr_permission_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=5;
	ptr_struct->no_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->e2e_credits_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->dc_full_handshake = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->uncompleted_non_wire_wqe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->dc_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=76;
	ptr_struct->limited_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=72;
	ptr_struct->ack_req_frequency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=71;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=69;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->umr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=66;
	ptr_struct->frwr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->currently_completing_wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->swqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=168;
	ptr_struct->oldest_non_acked_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->psn_since_ackreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->responder_session_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->next_to_send_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=296;
	ptr_struct->ssn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=336;
	ptr_struct->force_grh_tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=332;
	ptr_struct->reverse_sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=329;
	ptr_struct->to_sequence_error_retry_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=361;
	ptr_struct->sx_gather_commit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset=360;
	ptr_struct->force_my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=357;
	ptr_struct->to_sequence_error_retry_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=456;
	ptr_struct->first_psn_of_message_currently_completing = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=450;
	ptr_struct->currently_completing_ds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=449;
	ptr_struct->timer_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=448;
	ptr_struct->force_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=488;
	ptr_struct->first_unsent_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=480;
	ptr_struct->number_outstanding_reads = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_s_qpc_connected_common_print(const struct connectib_hw_s_qpc_connected_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc_connected_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ldb_int              : "UH_FMT"\n", ptr_struct->ldb_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_limit  : "UH_FMT"\n", ptr_struct->rnr_nak_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rnr_nak_retry_counter : "UH_FMT"\n", ptr_struct->rnr_nak_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ignore_pkey_check    : "UH_FMT"\n", ptr_struct->ignore_pkey_check);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_atomic      : "UH_FMT"\n", ptr_struct->extended_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_atomic      : "UH_FMT"\n", ptr_struct->max_read_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_permission_select : "UH_FMT"\n", ptr_struct->umr_permission_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_direct_access     : "UH_FMT"\n", ptr_struct->no_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_enabled  : "UH_FMT"\n", ptr_struct->e2e_credits_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_full_handshake    : "UH_FMT"\n", ptr_struct->dc_full_handshake);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncompleted_non_wire_wqe : "UH_FMT"\n", ptr_struct->uncompleted_non_wire_wqe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_state             : "UH_FMT"\n", ptr_struct->dc_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "limited_qp           : "UH_FMT"\n", ptr_struct->limited_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ack_req_frequency    : "UH_FMT"\n", ptr_struct->ack_req_frequency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_enable           : "UH_FMT"\n", ptr_struct->umr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frwr_enable          : "UH_FMT"\n", ptr_struct->frwr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_wqe_index : "UH_FMT"\n", ptr_struct->currently_completing_wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_consumer_index  : "UH_FMT"\n", ptr_struct->swqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oldest_non_acked_psn : "UH_FMT"\n", ptr_struct->oldest_non_acked_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn_since_ackreq     : "UH_FMT"\n", ptr_struct->psn_since_ackreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_session_id : "UH_FMT"\n", ptr_struct->responder_session_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_to_send_psn     : "UH_FMT"\n", ptr_struct->next_to_send_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ssn                  : "UH_FMT"\n", ptr_struct->ssn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh_tclass     : "UH_FMT"\n", ptr_struct->force_grh_tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reverse_sl           : "UH_FMT"\n", ptr_struct->reverse_sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_counter : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_gather_commit     : "UH_FMT"\n", ptr_struct->sx_gather_commit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_my_gid_index   : "UH_FMT"\n", ptr_struct->force_my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "to_sequence_error_retry_limit : "UH_FMT"\n", ptr_struct->to_sequence_error_retry_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_psn_of_message_currently_completing : "UH_FMT"\n", ptr_struct->first_psn_of_message_currently_completing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "currently_completing_ds : "UH_FMT"\n", ptr_struct->currently_completing_ds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer_enable         : "UH_FMT"\n", ptr_struct->timer_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh            : "UH_FMT"\n", ptr_struct->force_grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_unsent_psn     : "UH_FMT"\n", ptr_struct->first_unsent_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_outstanding_reads : "UH_FMT"\n", ptr_struct->number_outstanding_reads);

}

int connectib_hw_s_qpc_connected_common_size(void){
	 return 64;
}

void connectib_hw_s_qpc_connected_common_dump(const struct connectib_hw_s_qpc_connected_common *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_connected_common_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_common_pack(const struct connectib_hw_s_qpc_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->umr_permission_select);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qp_valid);

	offset=70;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_enable);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frwr_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->qp_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_consumer_index);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=280;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_syndrom);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_to_send_psn);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->counter_index);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh_tclass);

	offset=361;
	adb2c_push_bits_to_buff(ptr_buff, offset, 23, (u_int32_t)ptr_struct->sx_gather_commit);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_my_gid_index);

	offset=356;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_heartbeat);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ts);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_grh);

}

void connectib_hw_s_qpc_common_unpack(struct connectib_hw_s_qpc_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=20;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->umr_permission_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=0;
	ptr_struct->qp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=70;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->umr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=66;
	ptr_struct->frwr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->qp_state = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->swqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=232;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=280;
	ptr_struct->flush_syndrom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->next_to_send_psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->counter_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=336;
	ptr_struct->force_grh_tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=361;
	ptr_struct->sx_gather_commit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 23);

	offset=360;
	ptr_struct->force_my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=356;
	ptr_struct->sx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->ts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->force_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_s_qpc_common_print(const struct connectib_hw_s_qpc_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_permission_select : "UH_FMT"\n", ptr_struct->umr_permission_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_valid             : "UH_FMT"\n", ptr_struct->qp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_enable           : "UH_FMT"\n", ptr_struct->umr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frwr_enable          : "UH_FMT"\n", ptr_struct->frwr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_state             : "UH_FMT"\n", ptr_struct->qp_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_consumer_index  : "UH_FMT"\n", ptr_struct->swqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_syndrom        : "UH_FMT"\n", ptr_struct->flush_syndrom);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_to_send_psn     : "UH_FMT"\n", ptr_struct->next_to_send_psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_index        : "UH_FMT"\n", ptr_struct->counter_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh_tclass     : "UH_FMT"\n", ptr_struct->force_grh_tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_gather_commit     : "UH_FMT"\n", ptr_struct->sx_gather_commit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_my_gid_index   : "UH_FMT"\n", ptr_struct->force_my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_heartbeat         : "UH_FMT"\n", ptr_struct->sx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts                   : "UH_FMT"\n", ptr_struct->ts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_grh            : "UH_FMT"\n", ptr_struct->force_grh);

}

int connectib_hw_s_qpc_common_size(void){
	 return 64;
}

void connectib_hw_s_qpc_common_dump(const struct connectib_hw_s_qpc_common *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_common_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_unconnected_2cycbuff_pack(const struct connectib_hw_c_qpc_unconnected_2cycbuff *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rcyclic_size);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qkey);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

}

void connectib_hw_c_qpc_unconnected_2cycbuff_unpack(struct connectib_hw_c_qpc_unconnected_2cycbuff *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=51;
	ptr_struct->rcyclic_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=160;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_hw_c_qpc_unconnected_2cycbuff_print(const struct connectib_hw_c_qpc_unconnected_2cycbuff *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_unconnected_2cycbuff ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_size         : "UH_FMT"\n", ptr_struct->rcyclic_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : "U32H_FMT"\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

}

int connectib_hw_c_qpc_unconnected_2cycbuff_size(void){
	 return 64;
}

void connectib_hw_c_qpc_unconnected_2cycbuff_dump(const struct connectib_hw_c_qpc_unconnected_2cycbuff *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_unconnected_2cycbuff_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_unconnected_pack(const struct connectib_hw_c_qpc_unconnected *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_buffer_size);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rwqe_stride);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qkey);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

}

void connectib_hw_c_qpc_unconnected_unpack(struct connectib_hw_c_qpc_unconnected *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=52;
	ptr_struct->rwqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=49;
	ptr_struct->rwqe_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=160;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_hw_c_qpc_unconnected_print(const struct connectib_hw_c_qpc_unconnected *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_unconnected ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_buffer_size     : "UH_FMT"\n", ptr_struct->rwqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_stride          : "UH_FMT"\n", ptr_struct->rwqe_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : "U32H_FMT"\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

}

int connectib_hw_c_qpc_unconnected_size(void){
	 return 64;
}

void connectib_hw_c_qpc_unconnected_dump(const struct connectib_hw_c_qpc_unconnected *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_unconnected_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_unconnected_common_pack(const struct connectib_hw_c_qpc_unconnected_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qkey);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

}

void connectib_hw_c_qpc_unconnected_common_unpack(struct connectib_hw_c_qpc_unconnected_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=160;
	ptr_struct->qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_hw_c_qpc_unconnected_common_print(const struct connectib_hw_c_qpc_unconnected_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_unconnected_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qkey                 : "U32H_FMT"\n", ptr_struct->qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

}

int connectib_hw_c_qpc_unconnected_common_size(void){
	 return 64;
}

void connectib_hw_c_qpc_unconnected_common_dump(const struct connectib_hw_c_qpc_unconnected_common *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_unconnected_common_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_connected_dual_pack(const struct connectib_hw_c_qpc_connected_dual *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dual_write);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_buffer_size);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rwqe_stride);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipd);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->peer_qp);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_migreq);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_migreq);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=195;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->max_message_size);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtu);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->peer_lid);

	offset=233;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->my_lid);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->peer_qp2);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->peer_lid2);

}

void connectib_hw_c_qpc_connected_dual_unpack(struct connectib_hw_c_qpc_connected_dual *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2;
	ptr_struct->dual_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=52;
	ptr_struct->rwqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=49;
	ptr_struct->rwqe_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=44;
	ptr_struct->ipd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->peer_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=97;
	ptr_struct->sx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=140;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=195;
	ptr_struct->max_message_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=240;
	ptr_struct->peer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=233;
	ptr_struct->my_lid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=456;
	ptr_struct->peer_qp2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=496;
	ptr_struct->peer_lid2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_hw_c_qpc_connected_dual_print(const struct connectib_hw_c_qpc_connected_dual *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_connected_dual ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dual_write           : "UH_FMT"\n", ptr_struct->dual_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_buffer_size     : "UH_FMT"\n", ptr_struct->rwqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_stride          : "UH_FMT"\n", ptr_struct->rwqe_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipd                  : "UH_FMT"\n", ptr_struct->ipd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_qp              : "UH_FMT"\n", ptr_struct->peer_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_migreq            : "UH_FMT"\n", ptr_struct->sx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_migreq            : "UH_FMT"\n", ptr_struct->rx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_message_size     : "UH_FMT"\n", ptr_struct->max_message_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : "UH_FMT"\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_lid             : "UH_FMT"\n", ptr_struct->peer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lid               : "UH_FMT"\n", ptr_struct->my_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_qp2             : "UH_FMT"\n", ptr_struct->peer_qp2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_lid2            : "UH_FMT"\n", ptr_struct->peer_lid2);

}

int connectib_hw_c_qpc_connected_dual_size(void){
	 return 64;
}

void connectib_hw_c_qpc_connected_dual_dump(const struct connectib_hw_c_qpc_connected_dual *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_connected_dual_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_connected_2cycbuff_pack(const struct connectib_hw_c_qpc_connected_2cycbuff *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dual_write);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->rcyclic_size);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipd);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->peer_qp);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_migreq);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_migreq);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=195;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->max_message_size);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtu);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->peer_lid);

	offset=233;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->my_lid);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->peer_gid_127_64);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->peer_gid_63_0);

}

void connectib_hw_c_qpc_connected_2cycbuff_unpack(struct connectib_hw_c_qpc_connected_2cycbuff *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2;
	ptr_struct->dual_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=51;
	ptr_struct->rcyclic_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=44;
	ptr_struct->ipd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->peer_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=97;
	ptr_struct->sx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=140;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=195;
	ptr_struct->max_message_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=240;
	ptr_struct->peer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=233;
	ptr_struct->my_lid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=384;
	ptr_struct->peer_gid_127_64 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->peer_gid_63_0 = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_c_qpc_connected_2cycbuff_print(const struct connectib_hw_c_qpc_connected_2cycbuff *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_connected_2cycbuff ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dual_write           : "UH_FMT"\n", ptr_struct->dual_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcyclic_size         : "UH_FMT"\n", ptr_struct->rcyclic_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipd                  : "UH_FMT"\n", ptr_struct->ipd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_qp              : "UH_FMT"\n", ptr_struct->peer_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_migreq            : "UH_FMT"\n", ptr_struct->sx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_migreq            : "UH_FMT"\n", ptr_struct->rx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_message_size     : "UH_FMT"\n", ptr_struct->max_message_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : "UH_FMT"\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_lid             : "UH_FMT"\n", ptr_struct->peer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lid               : "UH_FMT"\n", ptr_struct->my_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_127_64      : "U64H_FMT"\n", ptr_struct->peer_gid_127_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_63_0        : "U64H_FMT"\n", ptr_struct->peer_gid_63_0);

}

int connectib_hw_c_qpc_connected_2cycbuff_size(void){
	 return 64;
}

void connectib_hw_c_qpc_connected_2cycbuff_dump(const struct connectib_hw_c_qpc_connected_2cycbuff *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_connected_2cycbuff_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_connected_pack(const struct connectib_hw_c_qpc_connected *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dual_write);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_buffer_size);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rwqe_stride);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipd);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->peer_qp);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_migreq);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_migreq);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=195;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->max_message_size);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtu);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->peer_lid);

	offset=233;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->my_lid);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->peer_gid_127_96);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->peer_gid_95_64);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->peer_gid_63_32);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->peer_gid_31_0);

}

void connectib_hw_c_qpc_connected_unpack(struct connectib_hw_c_qpc_connected *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2;
	ptr_struct->dual_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=52;
	ptr_struct->rwqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=49;
	ptr_struct->rwqe_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=44;
	ptr_struct->ipd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->peer_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=97;
	ptr_struct->sx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=140;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=195;
	ptr_struct->max_message_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=240;
	ptr_struct->peer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=233;
	ptr_struct->my_lid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=384;
	ptr_struct->peer_gid_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->peer_gid_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->peer_gid_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->peer_gid_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_c_qpc_connected_print(const struct connectib_hw_c_qpc_connected *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_connected ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dual_write           : "UH_FMT"\n", ptr_struct->dual_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_buffer_size     : "UH_FMT"\n", ptr_struct->rwqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_stride          : "UH_FMT"\n", ptr_struct->rwqe_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipd                  : "UH_FMT"\n", ptr_struct->ipd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_qp              : "UH_FMT"\n", ptr_struct->peer_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_migreq            : "UH_FMT"\n", ptr_struct->sx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_migreq            : "UH_FMT"\n", ptr_struct->rx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_message_size     : "UH_FMT"\n", ptr_struct->max_message_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : "UH_FMT"\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_lid             : "UH_FMT"\n", ptr_struct->peer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lid               : "UH_FMT"\n", ptr_struct->my_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_127_96      : "U32H_FMT"\n", ptr_struct->peer_gid_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_95_64       : "U32H_FMT"\n", ptr_struct->peer_gid_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_63_32       : "U32H_FMT"\n", ptr_struct->peer_gid_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_gid_31_0        : "U32H_FMT"\n", ptr_struct->peer_gid_31_0);

}

int connectib_hw_c_qpc_connected_size(void){
	 return 64;
}

void connectib_hw_c_qpc_connected_dump(const struct connectib_hw_c_qpc_connected *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_connected_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_connected_common_pack(const struct connectib_hw_c_qpc_connected_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dual_write);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ipd);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->peer_qp);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_migreq);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_migreq);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=195;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->max_message_size);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtu);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->peer_lid);

	offset=233;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->my_lid);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

}

void connectib_hw_c_qpc_connected_common_unpack(struct connectib_hw_c_qpc_connected_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2;
	ptr_struct->dual_write = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=44;
	ptr_struct->ipd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->peer_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=97;
	ptr_struct->sx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->rx_migreq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=140;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=195;
	ptr_struct->max_message_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=240;
	ptr_struct->peer_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=233;
	ptr_struct->my_lid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_hw_c_qpc_connected_common_print(const struct connectib_hw_c_qpc_connected_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_connected_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dual_write           : "UH_FMT"\n", ptr_struct->dual_write);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipd                  : "UH_FMT"\n", ptr_struct->ipd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_qp              : "UH_FMT"\n", ptr_struct->peer_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_migreq            : "UH_FMT"\n", ptr_struct->sx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_migreq            : "UH_FMT"\n", ptr_struct->rx_migreq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_message_size     : "UH_FMT"\n", ptr_struct->max_message_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu                  : "UH_FMT"\n", ptr_struct->mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "peer_lid             : "UH_FMT"\n", ptr_struct->peer_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_lid               : "UH_FMT"\n", ptr_struct->my_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

}

int connectib_hw_c_qpc_connected_common_size(void){
	 return 64;
}

void connectib_hw_c_qpc_connected_common_dump(const struct connectib_hw_c_qpc_connected_common *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_connected_common_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_common_pack(const struct connectib_hw_c_qpc_common *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->rwq_type);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_table_index);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_mac_index);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=267;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh_bit);

	offset=266;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=265;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->adaptive_routing);

	offset=260;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->swqe_buffer_size);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

}

void connectib_hw_c_qpc_common_unpack(struct connectib_hw_c_qpc_common *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->rwq_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->common_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=98;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->pkey_table_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=200;
	ptr_struct->my_gid_mac_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=268;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=267;
	ptr_struct->grh_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=266;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=265;
	ptr_struct->adaptive_routing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=260;
	ptr_struct->swqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_hw_c_qpc_common_print(const struct connectib_hw_c_qpc_common *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc_common ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwq_type             : "UH_FMT"\n", ptr_struct->rwq_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_valid         : "UH_FMT"\n", ptr_struct->common_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_table_index     : "UH_FMT"\n", ptr_struct->pkey_table_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_mac_index     : "UH_FMT"\n", ptr_struct->my_gid_mac_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_bit              : "UH_FMT"\n", ptr_struct->grh_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "adaptive_routing     : "UH_FMT"\n", ptr_struct->adaptive_routing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_buffer_size     : "UH_FMT"\n", ptr_struct->swqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

}

int connectib_hw_c_qpc_common_size(void){
	 return 64;
}

void connectib_hw_c_qpc_common_dump(const struct connectib_hw_c_qpc_common *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_common_print(ptr_struct, file, 0);
}

void connectib_pf_vf_cfg_space_pack(const struct connectib_pf_vf_cfg_space *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pf_vf_sriov_pack(&(ptr_struct->sriov), ptr_buff + offset/8);

	offset=64;
	connectib_pf_vf_vpd_pack(&(ptr_struct->vpd), ptr_buff + offset/8);

	offset=150;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->hw_msix_vec0);

	offset=149;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->msix_func_mask);

	offset=148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->msix_enable);

	offset=147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bus_master_en);

	offset=146;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->memory_space);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->serr_status);

	offset=143;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->serr_enable);

	offset=142;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->perr_enable);

	offset=141;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->int_disable);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->need_to_fire_flr_event);

	offset=139;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->in_middle_of_flr);

	offset=138;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hide);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->power_state);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cache_line);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->interrupt_line);

	offset=181;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->exp_rom_en);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 21, (u_int32_t)ptr_struct->exp_rom_addr_31_11);

	offset=223;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_correctable_error_report_en);

	offset=222;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_nonfatal_error_report_en);

	offset=221;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_fatal_error_report_en);

	offset=220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_ur_error_report_en);

	offset=219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_enable_relaxed_ordering);

	offset=216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->device_control_max_payload_size);

	offset=215;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_extended_tag_en);

	offset=214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_control_enable_no_snoop);

	offset=211;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->device_control_max_read_request_size);

	offset=210;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_status_correctable_error_detected);

	offset=209;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_status_nonfatal_error_detected);

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_status_fatal_error_detected);

	offset=207;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_status_ur_error_detected);

	offset=206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->command_register_memory_space);

	offset=205;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->command_register_bus_master_en);

	offset=204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->command_register_perr_report_en);

	offset=203;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->command_register_serr_report_en);

	offset=202;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->command_register_interrupt_disable);

	offset=201;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_interrupt_status);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_perr);

	offset=199;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_serr);

	offset=198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_received_master_abort);

	offset=197;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_received_target_abort);

	offset=196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->status_register_detected_parity_error);

}

void connectib_pf_vf_cfg_space_unpack(struct connectib_pf_vf_cfg_space *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pf_vf_sriov_unpack(&(ptr_struct->sriov), ptr_buff + offset/8);

	offset=64;
	connectib_pf_vf_vpd_unpack(&(ptr_struct->vpd), ptr_buff + offset/8);

	offset=150;
	ptr_struct->hw_msix_vec0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=149;
	ptr_struct->msix_func_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=148;
	ptr_struct->msix_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=147;
	ptr_struct->bus_master_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=146;
	ptr_struct->memory_space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->serr_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=143;
	ptr_struct->serr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=142;
	ptr_struct->perr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=141;
	ptr_struct->int_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=140;
	ptr_struct->need_to_fire_flr_event = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=139;
	ptr_struct->in_middle_of_flr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=138;
	ptr_struct->hide = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=136;
	ptr_struct->power_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=128;
	ptr_struct->cache_line = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=184;
	ptr_struct->interrupt_line = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=181;
	ptr_struct->exp_rom_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=160;
	ptr_struct->exp_rom_addr_31_11 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 21);

	offset=223;
	ptr_struct->device_control_correctable_error_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=222;
	ptr_struct->device_control_nonfatal_error_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=221;
	ptr_struct->device_control_fatal_error_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=220;
	ptr_struct->device_control_ur_error_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=219;
	ptr_struct->device_control_enable_relaxed_ordering = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=216;
	ptr_struct->device_control_max_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=215;
	ptr_struct->device_control_extended_tag_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=214;
	ptr_struct->device_control_enable_no_snoop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=211;
	ptr_struct->device_control_max_read_request_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=210;
	ptr_struct->device_status_correctable_error_detected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=209;
	ptr_struct->device_status_nonfatal_error_detected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=208;
	ptr_struct->device_status_fatal_error_detected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=207;
	ptr_struct->device_status_ur_error_detected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=206;
	ptr_struct->command_register_memory_space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=205;
	ptr_struct->command_register_bus_master_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=204;
	ptr_struct->command_register_perr_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=203;
	ptr_struct->command_register_serr_report_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=202;
	ptr_struct->command_register_interrupt_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=201;
	ptr_struct->status_register_interrupt_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=200;
	ptr_struct->status_register_perr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=199;
	ptr_struct->status_register_serr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=198;
	ptr_struct->status_register_received_master_abort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=197;
	ptr_struct->status_register_received_target_abort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=196;
	ptr_struct->status_register_detected_parity_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_pf_vf_cfg_space_print(const struct connectib_pf_vf_cfg_space *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pf_vf_cfg_space ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov:\n");
	connectib_pf_vf_sriov_print(&(ptr_struct->sriov), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd:\n");
	connectib_pf_vf_vpd_print(&(ptr_struct->vpd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_msix_vec0         : "UH_FMT"\n", ptr_struct->hw_msix_vec0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_func_mask       : "UH_FMT"\n", ptr_struct->msix_func_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_enable          : "UH_FMT"\n", ptr_struct->msix_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bus_master_en        : "UH_FMT"\n", ptr_struct->bus_master_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_space         : "UH_FMT"\n", ptr_struct->memory_space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serr_status          : "UH_FMT"\n", ptr_struct->serr_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serr_enable          : "UH_FMT"\n", ptr_struct->serr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perr_enable          : "UH_FMT"\n", ptr_struct->perr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_disable          : "UH_FMT"\n", ptr_struct->int_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "need_to_fire_flr_event : "UH_FMT"\n", ptr_struct->need_to_fire_flr_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_middle_of_flr     : "UH_FMT"\n", ptr_struct->in_middle_of_flr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hide                 : "UH_FMT"\n", ptr_struct->hide);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_state          : "UH_FMT"\n", ptr_struct->power_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cache_line           : "UH_FMT"\n", ptr_struct->cache_line);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "interrupt_line       : "UH_FMT"\n", ptr_struct->interrupt_line);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "exp_rom_en           : "UH_FMT"\n", ptr_struct->exp_rom_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "exp_rom_addr_31_11   : "UH_FMT"\n", ptr_struct->exp_rom_addr_31_11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_correctable_error_report_en : "UH_FMT"\n", ptr_struct->device_control_correctable_error_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_nonfatal_error_report_en : "UH_FMT"\n", ptr_struct->device_control_nonfatal_error_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_fatal_error_report_en : "UH_FMT"\n", ptr_struct->device_control_fatal_error_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_ur_error_report_en : "UH_FMT"\n", ptr_struct->device_control_ur_error_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_enable_relaxed_ordering : "UH_FMT"\n", ptr_struct->device_control_enable_relaxed_ordering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_max_payload_size : "UH_FMT"\n", ptr_struct->device_control_max_payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_extended_tag_en : "UH_FMT"\n", ptr_struct->device_control_extended_tag_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_enable_no_snoop : "UH_FMT"\n", ptr_struct->device_control_enable_no_snoop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_control_max_read_request_size : "UH_FMT"\n", ptr_struct->device_control_max_read_request_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status_correctable_error_detected : "UH_FMT"\n", ptr_struct->device_status_correctable_error_detected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status_nonfatal_error_detected : "UH_FMT"\n", ptr_struct->device_status_nonfatal_error_detected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status_fatal_error_detected : "UH_FMT"\n", ptr_struct->device_status_fatal_error_detected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_status_ur_error_detected : "UH_FMT"\n", ptr_struct->device_status_ur_error_detected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "command_register_memory_space : "UH_FMT"\n", ptr_struct->command_register_memory_space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "command_register_bus_master_en : "UH_FMT"\n", ptr_struct->command_register_bus_master_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "command_register_perr_report_en : "UH_FMT"\n", ptr_struct->command_register_perr_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "command_register_serr_report_en : "UH_FMT"\n", ptr_struct->command_register_serr_report_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "command_register_interrupt_disable : "UH_FMT"\n", ptr_struct->command_register_interrupt_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_interrupt_status : "UH_FMT"\n", ptr_struct->status_register_interrupt_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_perr : "UH_FMT"\n", ptr_struct->status_register_perr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_serr : "UH_FMT"\n", ptr_struct->status_register_serr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_received_master_abort : "UH_FMT"\n", ptr_struct->status_register_received_master_abort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_received_target_abort : "UH_FMT"\n", ptr_struct->status_register_received_target_abort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status_register_detected_parity_error : "UH_FMT"\n", ptr_struct->status_register_detected_parity_error);

}

int connectib_pf_vf_cfg_space_size(void){
	 return 28;
}

void connectib_pf_vf_cfg_space_dump(const struct connectib_pf_vf_cfg_space *ptr_struct, FILE* file) {
	connectib_pf_vf_cfg_space_print(ptr_struct, file, 0);
}

void connectib_hw_init_info_pack(const struct connectib_hw_init_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->init_state);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->init_lock);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->owner_pf);

}

void connectib_hw_init_info_unpack(struct connectib_hw_init_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->init_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=29;
	ptr_struct->init_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->owner_pf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_init_info_print(const struct connectib_hw_init_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_init_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_state           : "UH_FMT"\n", ptr_struct->init_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_lock            : "UH_FMT"\n", ptr_struct->init_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner_pf             : "UH_FMT"\n", ptr_struct->owner_pf);

}

int connectib_hw_init_info_size(void){
	 return 4;
}

void connectib_hw_init_info_dump(const struct connectib_hw_init_info *ptr_struct, FILE* file) {
	connectib_hw_init_info_print(ptr_struct, file, 0);
}

void connectib_mlnx_enhanced_equal_info_ini_pack(const struct connectib_mlnx_enhanced_equal_info_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_100kr4_extended_time_sup);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_100cr4_extended_time_sup);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_40cr4_extended_time_sup);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_40kr4_extended_time_sup);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_kr_extended_time_sup);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->edr_rx_atten_sup);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->edr_rx_atten);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fdr_rx_atten_sup);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->fdr_rx_atten);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qdr_ddr_ts3_rev);

}

void connectib_mlnx_enhanced_equal_info_ini_unpack(struct connectib_mlnx_enhanced_equal_info_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->mlpn_100kr4_extended_time_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->mlpn_100cr4_extended_time_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->mlpn_40cr4_extended_time_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->mlpn_40kr4_extended_time_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->mlpn_kr_extended_time_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->edr_rx_atten_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->edr_rx_atten = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=20;
	ptr_struct->fdr_rx_atten_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->fdr_rx_atten = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=14;
	ptr_struct->qdr_ddr_ts3_rev = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_mlnx_enhanced_equal_info_ini_print(const struct connectib_mlnx_enhanced_equal_info_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mlnx_enhanced_equal_info_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_100kr4_extended_time_sup : "UH_FMT"\n", ptr_struct->mlpn_100kr4_extended_time_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_100cr4_extended_time_sup : "UH_FMT"\n", ptr_struct->mlpn_100cr4_extended_time_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_40cr4_extended_time_sup : "UH_FMT"\n", ptr_struct->mlpn_40cr4_extended_time_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_40kr4_extended_time_sup : "UH_FMT"\n", ptr_struct->mlpn_40kr4_extended_time_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_kr_extended_time_sup : "UH_FMT"\n", ptr_struct->mlpn_kr_extended_time_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edr_rx_atten_sup     : "UH_FMT"\n", ptr_struct->edr_rx_atten_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edr_rx_atten         : "UH_FMT"\n", ptr_struct->edr_rx_atten);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fdr_rx_atten_sup     : "UH_FMT"\n", ptr_struct->fdr_rx_atten_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fdr_rx_atten         : "UH_FMT"\n", ptr_struct->fdr_rx_atten);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qdr_ddr_ts3_rev      : "UH_FMT"\n", ptr_struct->qdr_ddr_ts3_rev);

}

int connectib_mlnx_enhanced_equal_info_ini_size(void){
	 return 4;
}

void connectib_mlnx_enhanced_equal_info_ini_dump(const struct connectib_mlnx_enhanced_equal_info_ini *ptr_struct, FILE* file) {
	connectib_mlnx_enhanced_equal_info_ini_print(ptr_struct, file, 0);
}

void connectib_mlpn_database_all_protocol_bits_ini_pack(const struct connectib_mlpn_database_all_protocol_bits_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fdr_8_10);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlx_kr2);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eth_56gb);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fdr10);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->speed_reduction);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->width_reduction);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eth_cbf);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ib_64b_credits);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_edr);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_fdr);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_fdr10);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_qdr);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_ddr);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_ib_sdr);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_56_kr4);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_56_kx4);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_kr4);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_cr4);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_slr4);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_kr);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_cr);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_slr);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_xaui);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_sgmii);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fc_protocol);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eth_protocol);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ib_protocol);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ib_64_66_spec_recovery);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ib_128b_llr);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ll_llr);

}

void connectib_mlpn_database_all_protocol_bits_ini_unpack(struct connectib_mlpn_database_all_protocol_bits_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->fdr_8_10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->mlx_kr2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->eth_56gb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->fdr10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->speed_reduction = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->width_reduction = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->eth_cbf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->ib_64b_credits = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->llr_ib_edr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->llr_ib_fdr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->llr_ib_fdr10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->llr_ib_qdr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->llr_ib_ddr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->llr_ib_sdr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->llr_56_kr4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->llr_56_kx4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->llr_kr4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->llr_cr4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->llr_slr4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->llr_kr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->llr_cr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->llr_slr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->llr_xaui = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->llr_sgmii = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->fc_protocol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->eth_protocol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->ib_protocol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->ib_64_66_spec_recovery = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->ib_128b_llr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->ll_llr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_mlpn_database_all_protocol_bits_ini_print(const struct connectib_mlpn_database_all_protocol_bits_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mlpn_database_all_protocol_bits_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fdr_8_10             : "UH_FMT"\n", ptr_struct->fdr_8_10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlx_kr2              : "UH_FMT"\n", ptr_struct->mlx_kr2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_56gb             : "UH_FMT"\n", ptr_struct->eth_56gb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fdr10                : "UH_FMT"\n", ptr_struct->fdr10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speed_reduction      : "UH_FMT"\n", ptr_struct->speed_reduction);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "width_reduction      : "UH_FMT"\n", ptr_struct->width_reduction);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_cbf              : "UH_FMT"\n", ptr_struct->eth_cbf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_64b_credits       : "UH_FMT"\n", ptr_struct->ib_64b_credits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_edr           : "UH_FMT"\n", ptr_struct->llr_ib_edr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_fdr           : "UH_FMT"\n", ptr_struct->llr_ib_fdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_fdr10         : "UH_FMT"\n", ptr_struct->llr_ib_fdr10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_qdr           : "UH_FMT"\n", ptr_struct->llr_ib_qdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_ddr           : "UH_FMT"\n", ptr_struct->llr_ib_ddr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_ib_sdr           : "UH_FMT"\n", ptr_struct->llr_ib_sdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_56_kr4           : "UH_FMT"\n", ptr_struct->llr_56_kr4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_56_kx4           : "UH_FMT"\n", ptr_struct->llr_56_kx4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_kr4              : "UH_FMT"\n", ptr_struct->llr_kr4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_cr4              : "UH_FMT"\n", ptr_struct->llr_cr4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_slr4             : "UH_FMT"\n", ptr_struct->llr_slr4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_kr               : "UH_FMT"\n", ptr_struct->llr_kr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_cr               : "UH_FMT"\n", ptr_struct->llr_cr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_slr              : "UH_FMT"\n", ptr_struct->llr_slr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_xaui             : "UH_FMT"\n", ptr_struct->llr_xaui);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_sgmii            : "UH_FMT"\n", ptr_struct->llr_sgmii);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_protocol          : "UH_FMT"\n", ptr_struct->fc_protocol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_protocol         : "UH_FMT"\n", ptr_struct->eth_protocol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_protocol          : "UH_FMT"\n", ptr_struct->ib_protocol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_64_66_spec_recovery : "UH_FMT"\n", ptr_struct->ib_64_66_spec_recovery);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_128b_llr          : "UH_FMT"\n", ptr_struct->ib_128b_llr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ll_llr               : "UH_FMT"\n", ptr_struct->ll_llr);

}

int connectib_mlpn_database_all_protocol_bits_ini_size(void){
	 return 4;
}

void connectib_mlpn_database_all_protocol_bits_ini_dump(const struct connectib_mlpn_database_all_protocol_bits_ini *ptr_struct, FILE* file) {
	connectib_mlpn_database_all_protocol_bits_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_preset_sets_ini_pack(const struct connectib_serdes_preset_sets_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_preset_tx_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_preset_sets_ini_unpack(struct connectib_serdes_preset_sets_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_preset_tx_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_preset_sets_ini_print(const struct connectib_serdes_preset_sets_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_preset_sets_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_serdes_conf_preset_tx_ini_print(&(ptr_struct->tx), file, indent_level + 1);

}

int connectib_serdes_preset_sets_ini_size(void){
	 return 64;
}

void connectib_serdes_preset_sets_ini_dump(const struct connectib_serdes_preset_sets_ini *ptr_struct, FILE* file) {
	connectib_serdes_preset_sets_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_active_sets_ini_pack(const struct connectib_serdes_active_sets_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_active_rx_ini_pack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=256;
	connectib_serdes_active_tx_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_active_sets_ini_unpack(struct connectib_serdes_active_sets_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_active_rx_ini_unpack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=256;
	connectib_serdes_active_tx_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_active_sets_ini_print(const struct connectib_serdes_active_sets_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_active_sets_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx:\n");
	connectib_serdes_active_rx_ini_print(&(ptr_struct->rx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_serdes_active_tx_ini_print(&(ptr_struct->tx), file, indent_level + 1);

}

int connectib_serdes_active_sets_ini_size(void){
	 return 48;
}

void connectib_serdes_active_sets_ini_dump(const struct connectib_serdes_active_sets_ini *ptr_struct, FILE* file) {
	connectib_serdes_active_sets_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_force_sets_ini_pack(const struct connectib_serdes_force_sets_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_force_rx_ini_pack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=640;
	connectib_serdes_force_tx_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_force_sets_ini_unpack(struct connectib_serdes_force_sets_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_force_rx_ini_unpack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=640;
	connectib_serdes_force_tx_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_force_sets_ini_print(const struct connectib_serdes_force_sets_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_force_sets_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx:\n");
	connectib_serdes_force_rx_ini_print(&(ptr_struct->rx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_serdes_force_tx_ini_print(&(ptr_struct->tx), file, indent_level + 1);

}

int connectib_serdes_force_sets_ini_size(void){
	 return 120;
}

void connectib_serdes_force_sets_ini_dump(const struct connectib_serdes_force_sets_ini *ptr_struct, FILE* file) {
	connectib_serdes_force_sets_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_aba_sets_ini_pack(const struct connectib_serdes_aba_sets_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_aba_rx_ini_pack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=2048;
	connectib_serdes_conf_aba_tx_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_aba_sets_ini_unpack(struct connectib_serdes_aba_sets_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_aba_rx_ini_unpack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=2048;
	connectib_serdes_conf_aba_tx_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_aba_sets_ini_print(const struct connectib_serdes_aba_sets_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_aba_sets_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx:\n");
	connectib_serdes_conf_aba_rx_ini_print(&(ptr_struct->rx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_serdes_conf_aba_tx_ini_print(&(ptr_struct->tx), file, indent_level + 1);

}

int connectib_serdes_aba_sets_ini_size(void){
	 return 384;
}

void connectib_serdes_aba_sets_ini_dump(const struct connectib_serdes_aba_sets_ini *ptr_struct, FILE* file) {
	connectib_serdes_aba_sets_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_autoneg_sets_ini_pack(const struct connectib_serdes_autoneg_sets_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_autoneg_rx_ini_pack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=2048;
	connectib_serdes_conf_autoneg_tx_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_autoneg_sets_ini_unpack(struct connectib_serdes_autoneg_sets_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_conf_autoneg_rx_ini_unpack(&(ptr_struct->rx), ptr_buff + offset/8);

	offset=2048;
	connectib_serdes_conf_autoneg_tx_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

}

void connectib_serdes_autoneg_sets_ini_print(const struct connectib_serdes_autoneg_sets_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_autoneg_sets_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx:\n");
	connectib_serdes_conf_autoneg_rx_ini_print(&(ptr_struct->rx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_serdes_conf_autoneg_tx_ini_print(&(ptr_struct->tx), file, indent_level + 1);

}

int connectib_serdes_autoneg_sets_ini_size(void){
	 return 384;
}

void connectib_serdes_autoneg_sets_ini_dump(const struct connectib_serdes_autoneg_sets_ini *ptr_struct, FILE* file) {
	connectib_serdes_autoneg_sets_ini_print(ptr_struct, file, 0);
}

void connectib_spec1_3_preset_ini_pack(const struct connectib_spec1_3_preset_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->preset_tx_mask_internal);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->preset_tx_mask);

	offset=59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask0_start);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask0_end);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_ABA_en_mask);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask0);

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask1_start);

	offset=83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask1_end);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tx_ABA_mode_mask);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask1);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask2_start);

	offset=115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask2_end);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask2);

	offset=155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask3_start);

	offset=147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask3_end);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask3);

	offset=187;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask4_start);

	offset=179;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask4_end);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask4);

	offset=219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask5_start);

	offset=211;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->aba_mask5_end);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->aba_mask5);

	offset=224;
	connectib_aba_indexes_pack(&(ptr_struct->aba_indexes), ptr_buff + offset/8);

}

void connectib_spec1_3_preset_ini_unpack(struct connectib_spec1_3_preset_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->preset_tx_mask_internal = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->preset_tx_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=59;
	ptr_struct->aba_mask0_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=51;
	ptr_struct->aba_mask0_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=48;
	ptr_struct->tx_ABA_en_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->aba_mask0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=91;
	ptr_struct->aba_mask1_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=83;
	ptr_struct->aba_mask1_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=80;
	ptr_struct->tx_ABA_mode_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=64;
	ptr_struct->aba_mask1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=123;
	ptr_struct->aba_mask2_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=115;
	ptr_struct->aba_mask2_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=96;
	ptr_struct->aba_mask2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=155;
	ptr_struct->aba_mask3_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=147;
	ptr_struct->aba_mask3_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=128;
	ptr_struct->aba_mask3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=187;
	ptr_struct->aba_mask4_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=179;
	ptr_struct->aba_mask4_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=160;
	ptr_struct->aba_mask4 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=219;
	ptr_struct->aba_mask5_start = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=211;
	ptr_struct->aba_mask5_end = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->aba_mask5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	connectib_aba_indexes_unpack(&(ptr_struct->aba_indexes), ptr_buff + offset/8);

}

void connectib_spec1_3_preset_ini_print(const struct connectib_spec1_3_preset_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_spec1_3_preset_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset_tx_mask_internal : "UH_FMT"\n", ptr_struct->preset_tx_mask_internal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset_tx_mask       : "UH_FMT"\n", ptr_struct->preset_tx_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask0_start      : "UH_FMT"\n", ptr_struct->aba_mask0_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask0_end        : "UH_FMT"\n", ptr_struct->aba_mask0_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_ABA_en_mask       : "UH_FMT"\n", ptr_struct->tx_ABA_en_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask0            : "UH_FMT"\n", ptr_struct->aba_mask0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask1_start      : "UH_FMT"\n", ptr_struct->aba_mask1_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask1_end        : "UH_FMT"\n", ptr_struct->aba_mask1_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_ABA_mode_mask     : "UH_FMT"\n", ptr_struct->tx_ABA_mode_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask1            : "UH_FMT"\n", ptr_struct->aba_mask1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask2_start      : "UH_FMT"\n", ptr_struct->aba_mask2_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask2_end        : "UH_FMT"\n", ptr_struct->aba_mask2_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask2            : "UH_FMT"\n", ptr_struct->aba_mask2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask3_start      : "UH_FMT"\n", ptr_struct->aba_mask3_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask3_end        : "UH_FMT"\n", ptr_struct->aba_mask3_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask3            : "UH_FMT"\n", ptr_struct->aba_mask3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask4_start      : "UH_FMT"\n", ptr_struct->aba_mask4_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask4_end        : "UH_FMT"\n", ptr_struct->aba_mask4_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask4            : "UH_FMT"\n", ptr_struct->aba_mask4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask5_start      : "UH_FMT"\n", ptr_struct->aba_mask5_start);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask5_end        : "UH_FMT"\n", ptr_struct->aba_mask5_end);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_mask5            : "UH_FMT"\n", ptr_struct->aba_mask5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba_indexes:\n");
	connectib_aba_indexes_print(&(ptr_struct->aba_indexes), file, indent_level + 1);

}

int connectib_spec1_3_preset_ini_size(void){
	 return 76;
}

void connectib_spec1_3_preset_ini_dump(const struct connectib_spec1_3_preset_ini *ptr_struct, FILE* file) {
	connectib_spec1_3_preset_ini_print(ptr_struct, file, 0);
}

void connectib_ib_ini_per_lcl_ini_pack(const struct connectib_ib_ini_per_lcl_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spec1_2_ib_support);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spec1_3_ib_support);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fec_request_fdr);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fec_request_fdr10);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->heartbeat_enable);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->force_speed_val);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_speed_en);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->force_width_val);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_width_en);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_qdr_is_fdr10_val);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_qdr_is_fdr10_en);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_llr_fdr_en);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_llr_fdr_val);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_llr_fdr10_en);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_llr_fdr10_val);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlpn_en);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_cell_size);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->speed_reduction_force);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->width_reduction_force);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_fdr10_force);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_fdr_force);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spec1_2_legacy_mode);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_disable_failsafe);

}

void connectib_ib_ini_per_lcl_ini_unpack(struct connectib_ib_ini_per_lcl_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->spec1_2_ib_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->spec1_3_ib_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->fec_request_fdr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->fec_request_fdr10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->heartbeat_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->force_speed_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=22;
	ptr_struct->force_speed_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->force_width_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=17;
	ptr_struct->force_width_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->force_qdr_is_fdr10_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->force_qdr_is_fdr10_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->force_llr_fdr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->force_llr_fdr_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->force_llr_fdr10_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->force_llr_fdr10_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->mlpn_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->llr_cell_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->speed_reduction_force = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->width_reduction_force = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->llr_fdr10_force = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->llr_fdr_force = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->spec1_2_legacy_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->llr_disable_failsafe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_ib_ini_per_lcl_ini_print(const struct connectib_ib_ini_per_lcl_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ib_ini_per_lcl_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec1_2_ib_support   : "UH_FMT"\n", ptr_struct->spec1_2_ib_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec1_3_ib_support   : "UH_FMT"\n", ptr_struct->spec1_3_ib_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_request_fdr      : "UH_FMT"\n", ptr_struct->fec_request_fdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_request_fdr10    : "UH_FMT"\n", ptr_struct->fec_request_fdr10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "heartbeat_enable     : "UH_FMT"\n", ptr_struct->heartbeat_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_speed_val      : "UH_FMT"\n", ptr_struct->force_speed_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_speed_en       : "UH_FMT"\n", ptr_struct->force_speed_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_width_val      : "UH_FMT"\n", ptr_struct->force_width_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_width_en       : "UH_FMT"\n", ptr_struct->force_width_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_qdr_is_fdr10_val : "UH_FMT"\n", ptr_struct->force_qdr_is_fdr10_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_qdr_is_fdr10_en : "UH_FMT"\n", ptr_struct->force_qdr_is_fdr10_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_llr_fdr_en     : "UH_FMT"\n", ptr_struct->force_llr_fdr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_llr_fdr_val    : "UH_FMT"\n", ptr_struct->force_llr_fdr_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_llr_fdr10_en   : "UH_FMT"\n", ptr_struct->force_llr_fdr10_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_llr_fdr10_val  : "UH_FMT"\n", ptr_struct->force_llr_fdr10_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_en              : "UH_FMT"\n", ptr_struct->mlpn_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_cell_size        : "UH_FMT"\n", ptr_struct->llr_cell_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speed_reduction_force : "UH_FMT"\n", ptr_struct->speed_reduction_force);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "width_reduction_force : "UH_FMT"\n", ptr_struct->width_reduction_force);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_fdr10_force      : "UH_FMT"\n", ptr_struct->llr_fdr10_force);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_fdr_force        : "UH_FMT"\n", ptr_struct->llr_fdr_force);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec1_2_legacy_mode  : "UH_FMT"\n", ptr_struct->spec1_2_legacy_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_disable_failsafe : "UH_FMT"\n", ptr_struct->llr_disable_failsafe);

}

int connectib_ib_ini_per_lcl_ini_size(void){
	 return 4;
}

void connectib_ib_ini_per_lcl_ini_dump(const struct connectib_ib_ini_per_lcl_ini *ptr_struct, FILE* file) {
	connectib_ib_ini_per_lcl_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_param_mask_ini_pack(const struct connectib_serdes_param_mask_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_param_mask_per_proto_ini_pack(&(ptr_struct->encode_8_10), ptr_buff + offset/8);

	offset=32;
	connectib_serdes_param_mask_per_proto_ini_pack(&(ptr_struct->encode_64_66), ptr_buff + offset/8);

	offset=64;
	connectib_serdes_param_mask_per_proto_ini_pack(&(ptr_struct->encode_kr), ptr_buff + offset/8);

	offset=96;
	connectib_serdes_param_mask_per_proto_ini_pack(&(ptr_struct->fdr), ptr_buff + offset/8);

}

void connectib_serdes_param_mask_ini_unpack(struct connectib_serdes_param_mask_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_param_mask_per_proto_ini_unpack(&(ptr_struct->encode_8_10), ptr_buff + offset/8);

	offset=32;
	connectib_serdes_param_mask_per_proto_ini_unpack(&(ptr_struct->encode_64_66), ptr_buff + offset/8);

	offset=64;
	connectib_serdes_param_mask_per_proto_ini_unpack(&(ptr_struct->encode_kr), ptr_buff + offset/8);

	offset=96;
	connectib_serdes_param_mask_per_proto_ini_unpack(&(ptr_struct->fdr), ptr_buff + offset/8);

}

void connectib_serdes_param_mask_ini_print(const struct connectib_serdes_param_mask_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_param_mask_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_8_10:\n");
	connectib_serdes_param_mask_per_proto_ini_print(&(ptr_struct->encode_8_10), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_64_66:\n");
	connectib_serdes_param_mask_per_proto_ini_print(&(ptr_struct->encode_64_66), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "encode_kr:\n");
	connectib_serdes_param_mask_per_proto_ini_print(&(ptr_struct->encode_kr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fdr:\n");
	connectib_serdes_param_mask_per_proto_ini_print(&(ptr_struct->fdr), file, indent_level + 1);

}

int connectib_serdes_param_mask_ini_size(void){
	 return 16;
}

void connectib_serdes_param_mask_ini_dump(const struct connectib_serdes_param_mask_ini *ptr_struct, FILE* file) {
	connectib_serdes_param_mask_ini_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_data_tpt_capabilities_pack(const struct connectib_nv_tlv_data_tpt_capabilities *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->log_max_payload_size_supported);

}

void connectib_nv_tlv_data_tpt_capabilities_unpack(struct connectib_nv_tlv_data_tpt_capabilities *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->log_max_payload_size_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_nv_tlv_data_tpt_capabilities_print(const struct connectib_nv_tlv_data_tpt_capabilities *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_data_tpt_capabilities ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_payload_size_supported : "UH_FMT"\n", ptr_struct->log_max_payload_size_supported);

}

int connectib_nv_tlv_data_tpt_capabilities_size(void){
	 return 4;
}

void connectib_nv_tlv_data_tpt_capabilities_dump(const struct connectib_nv_tlv_data_tpt_capabilities *ptr_struct, FILE* file) {
	connectib_nv_tlv_data_tpt_capabilities_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_data_tpt_settings_pack(const struct connectib_nv_tlv_data_tpt_settings *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->log_max_payload_size);

}

void connectib_nv_tlv_data_tpt_settings_unpack(struct connectib_nv_tlv_data_tpt_settings *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->log_max_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_nv_tlv_data_tpt_settings_print(const struct connectib_nv_tlv_data_tpt_settings *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_data_tpt_settings ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_payload_size : "UH_FMT"\n", ptr_struct->log_max_payload_size);

}

int connectib_nv_tlv_data_tpt_settings_size(void){
	 return 4;
}

void connectib_nv_tlv_data_tpt_settings_dump(const struct connectib_nv_tlv_data_tpt_settings *ptr_struct, FILE* file) {
	connectib_nv_tlv_data_tpt_settings_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_data_pci_capabilities_pack(const struct connectib_nv_tlv_data_pci_capabilities *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pf_bar_size_supported);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_bar_size_supported);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_pf_msix_supported);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_vf_msix_supported);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_pfs_supported);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->max_log_total_bar_valid);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->max_total_msix_valid);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->max_vfs_per_pf_valid);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_vfs_per_pf);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_num_pfs);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fpp_support);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_qos_control_support);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sriov_support);

	offset=90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->max_log_pf_uar_bar_size);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->max_log_vf_uar_bar_size);

	offset=74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->max_num_pf_msix);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->max_num_vf_msix);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->max_total_msix);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->max_total_bar_MB);

}

void connectib_nv_tlv_data_pci_capabilities_unpack(struct connectib_nv_tlv_data_pci_capabilities *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	ptr_struct->pf_bar_size_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->vf_bar_size_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->num_pf_msix_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->num_vf_msix_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->num_pfs_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->max_log_total_bar_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->max_total_msix_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->max_vfs_per_pf_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->max_vfs_per_pf = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=44;
	ptr_struct->max_num_pfs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=34;
	ptr_struct->fpp_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->vf_qos_control_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->sriov_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=90;
	ptr_struct->max_log_pf_uar_bar_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=84;
	ptr_struct->max_log_vf_uar_bar_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=74;
	ptr_struct->max_num_pf_msix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=64;
	ptr_struct->max_num_vf_msix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=96;
	ptr_struct->max_total_msix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->max_total_bar_MB = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_nv_tlv_data_pci_capabilities_print(const struct connectib_nv_tlv_data_pci_capabilities *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_data_pci_capabilities ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_bar_size_supported : "UH_FMT"\n", ptr_struct->pf_bar_size_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar_size_supported : "UH_FMT"\n", ptr_struct->vf_bar_size_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pf_msix_supported : "UH_FMT"\n", ptr_struct->num_pf_msix_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vf_msix_supported : "UH_FMT"\n", ptr_struct->num_vf_msix_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pfs_supported    : "UH_FMT"\n", ptr_struct->num_pfs_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_log_total_bar_valid : "UH_FMT"\n", ptr_struct->max_log_total_bar_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_total_msix_valid : "UH_FMT"\n", ptr_struct->max_total_msix_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vfs_per_pf_valid : "UH_FMT"\n", ptr_struct->max_vfs_per_pf_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_vfs_per_pf       : "UH_FMT"\n", ptr_struct->max_vfs_per_pf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_pfs          : "UH_FMT"\n", ptr_struct->max_num_pfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fpp_support          : "UH_FMT"\n", ptr_struct->fpp_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_qos_control_support : "UH_FMT"\n", ptr_struct->vf_qos_control_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov_support        : "UH_FMT"\n", ptr_struct->sriov_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_log_pf_uar_bar_size : "UH_FMT"\n", ptr_struct->max_log_pf_uar_bar_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_log_vf_uar_bar_size : "UH_FMT"\n", ptr_struct->max_log_vf_uar_bar_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_pf_msix      : "UH_FMT"\n", ptr_struct->max_num_pf_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_vf_msix      : "UH_FMT"\n", ptr_struct->max_num_vf_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_total_msix       : "U32H_FMT"\n", ptr_struct->max_total_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_total_bar_MB     : "U32H_FMT"\n", ptr_struct->max_total_bar_MB);

}

int connectib_nv_tlv_data_pci_capabilities_size(void){
	 return 20;
}

void connectib_nv_tlv_data_pci_capabilities_dump(const struct connectib_nv_tlv_data_pci_capabilities *ptr_struct, FILE* file) {
	connectib_nv_tlv_data_pci_capabilities_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_data_pci_settings_pack(const struct connectib_nv_tlv_data_pci_settings *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pf_bar_size_valid);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_bar_size_valid);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_pf_msix_valid);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_vf_msix_valid);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_pfs_valid);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fpp_valid);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->full_vf_qos_valid);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sriov_valid);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->total_vfs);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_pfs);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fpp_en);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->full_vf_qos);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sriov_en);

	offset=90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_pf_uar_bar_size);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_vf_uar_bar_size);

	offset=74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->num_pf_msix);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->num_vf_msix);

}

void connectib_nv_tlv_data_pci_settings_unpack(struct connectib_nv_tlv_data_pci_settings *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	ptr_struct->pf_bar_size_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->vf_bar_size_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->num_pf_msix_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->num_vf_msix_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->num_pfs_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->fpp_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->full_vf_qos_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->sriov_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->total_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=44;
	ptr_struct->num_pfs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=34;
	ptr_struct->fpp_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->full_vf_qos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->sriov_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=90;
	ptr_struct->log_pf_uar_bar_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=84;
	ptr_struct->log_vf_uar_bar_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=74;
	ptr_struct->num_pf_msix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=64;
	ptr_struct->num_vf_msix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void connectib_nv_tlv_data_pci_settings_print(const struct connectib_nv_tlv_data_pci_settings *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_data_pci_settings ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_bar_size_valid    : "UH_FMT"\n", ptr_struct->pf_bar_size_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar_size_valid    : "UH_FMT"\n", ptr_struct->vf_bar_size_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pf_msix_valid    : "UH_FMT"\n", ptr_struct->num_pf_msix_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vf_msix_valid    : "UH_FMT"\n", ptr_struct->num_vf_msix_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pfs_valid        : "UH_FMT"\n", ptr_struct->num_pfs_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fpp_valid            : "UH_FMT"\n", ptr_struct->fpp_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "full_vf_qos_valid    : "UH_FMT"\n", ptr_struct->full_vf_qos_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov_valid          : "UH_FMT"\n", ptr_struct->sriov_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_vfs            : "UH_FMT"\n", ptr_struct->total_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pfs              : "UH_FMT"\n", ptr_struct->num_pfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fpp_en               : "UH_FMT"\n", ptr_struct->fpp_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "full_vf_qos          : "UH_FMT"\n", ptr_struct->full_vf_qos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov_en             : "UH_FMT"\n", ptr_struct->sriov_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_pf_uar_bar_size  : "UH_FMT"\n", ptr_struct->log_pf_uar_bar_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_vf_uar_bar_size  : "UH_FMT"\n", ptr_struct->log_vf_uar_bar_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pf_msix          : "UH_FMT"\n", ptr_struct->num_pf_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vf_msix          : "UH_FMT"\n", ptr_struct->num_vf_msix);

}

int connectib_nv_tlv_data_pci_settings_size(void){
	 return 12;
}

void connectib_nv_tlv_data_pci_settings_dump(const struct connectib_nv_tlv_data_pci_settings *ptr_struct, FILE* file) {
	connectib_nv_tlv_data_pci_settings_print(ptr_struct, file, 0);
}

void connectib_header_log_pack(const struct connectib_header_log *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hdr_127_96);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hdr_95_64);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hdr_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->hdr_31_0);

}

void connectib_header_log_unpack(struct connectib_header_log *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->hdr_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->hdr_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->hdr_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->hdr_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_header_log_print(const struct connectib_header_log *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_header_log ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr_127_96           : "U32H_FMT"\n", ptr_struct->hdr_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr_95_64            : "U32H_FMT"\n", ptr_struct->hdr_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr_63_32            : "U32H_FMT"\n", ptr_struct->hdr_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr_31_0             : "U32H_FMT"\n", ptr_struct->hdr_31_0);

}

int connectib_header_log_size(void){
	 return 16;
}

void connectib_header_log_dump(const struct connectib_header_log *ptr_struct, FILE* file) {
	connectib_header_log_print(ptr_struct, file, 0);
}

void connectib_advanced_error_cap_ctl_pack(const struct connectib_advanced_error_cap_ctl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->first_error_pointer);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_generation_cap);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_generation_enable);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_check_cap);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_check_enable);

}

void connectib_advanced_error_cap_ctl_unpack(struct connectib_advanced_error_cap_ctl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=27;
	ptr_struct->first_error_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=26;
	ptr_struct->ecrc_generation_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->ecrc_generation_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->ecrc_check_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->ecrc_check_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_advanced_error_cap_ctl_print(const struct connectib_advanced_error_cap_ctl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_advanced_error_cap_ctl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_error_pointer  : "UH_FMT"\n", ptr_struct->first_error_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_generation_cap  : "UH_FMT"\n", ptr_struct->ecrc_generation_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_generation_enable : "UH_FMT"\n", ptr_struct->ecrc_generation_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_check_cap       : "UH_FMT"\n", ptr_struct->ecrc_check_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_check_enable    : "UH_FMT"\n", ptr_struct->ecrc_check_enable);

}

int connectib_advanced_error_cap_ctl_size(void){
	 return 4;
}

void connectib_advanced_error_cap_ctl_dump(const struct connectib_advanced_error_cap_ctl *ptr_struct, FILE* file) {
	connectib_advanced_error_cap_ctl_print(ptr_struct, file, 0);
}

void connectib_correctable_error_mask_pack(const struct connectib_correctable_error_mask *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_error_mask);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved1);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved2);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved3);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved4);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved5);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bad_tlp_mask);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bad_dllp_mask);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->replay_num_rollover_mask);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved9);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved10);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved11);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->replay_timer_timeout_mask);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->advisory_non_fatal_err_mask);

}

void connectib_correctable_error_mask_unpack(struct connectib_correctable_error_mask *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->receiver_error_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->reserved3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->reserved4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->reserved5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->bad_tlp_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->bad_dllp_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->replay_num_rollover_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->reserved9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->reserved10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->reserved11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->replay_timer_timeout_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->advisory_non_fatal_err_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_correctable_error_mask_print(const struct connectib_correctable_error_mask *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_correctable_error_mask ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_error_mask  : "UH_FMT"\n", ptr_struct->receiver_error_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved1            : "UH_FMT"\n", ptr_struct->reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved2            : "UH_FMT"\n", ptr_struct->reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved3            : "UH_FMT"\n", ptr_struct->reserved3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved4            : "UH_FMT"\n", ptr_struct->reserved4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved5            : "UH_FMT"\n", ptr_struct->reserved5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bad_tlp_mask         : "UH_FMT"\n", ptr_struct->bad_tlp_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bad_dllp_mask        : "UH_FMT"\n", ptr_struct->bad_dllp_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "replay_num_rollover_mask : "UH_FMT"\n", ptr_struct->replay_num_rollover_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved9            : "UH_FMT"\n", ptr_struct->reserved9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved10           : "UH_FMT"\n", ptr_struct->reserved10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved11           : "UH_FMT"\n", ptr_struct->reserved11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "replay_timer_timeout_mask : "UH_FMT"\n", ptr_struct->replay_timer_timeout_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advisory_non_fatal_err_mask : "UH_FMT"\n", ptr_struct->advisory_non_fatal_err_mask);

}

int connectib_correctable_error_mask_size(void){
	 return 4;
}

void connectib_correctable_error_mask_dump(const struct connectib_correctable_error_mask *ptr_struct, FILE* file) {
	connectib_correctable_error_mask_print(ptr_struct, file, 0);
}

void connectib_correctable_error_status_pack(const struct connectib_correctable_error_status *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_error_status);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bad_tlp_status);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bad_dllp_status);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->replay_num_rollover_status);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->replay_timer_timeout_status);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->advisory_nonftl_err_status);

}

void connectib_correctable_error_status_unpack(struct connectib_correctable_error_status *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->receiver_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->bad_tlp_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->bad_dllp_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->replay_num_rollover_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->replay_timer_timeout_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->advisory_nonftl_err_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_correctable_error_status_print(const struct connectib_correctable_error_status *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_correctable_error_status ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_error_status : "UH_FMT"\n", ptr_struct->receiver_error_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bad_tlp_status       : "UH_FMT"\n", ptr_struct->bad_tlp_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bad_dllp_status      : "UH_FMT"\n", ptr_struct->bad_dllp_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "replay_num_rollover_status : "UH_FMT"\n", ptr_struct->replay_num_rollover_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "replay_timer_timeout_status : "UH_FMT"\n", ptr_struct->replay_timer_timeout_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advisory_nonftl_err_status : "UH_FMT"\n", ptr_struct->advisory_nonftl_err_status);

}

int connectib_correctable_error_status_size(void){
	 return 4;
}

void connectib_correctable_error_status_dump(const struct connectib_correctable_error_status *ptr_struct, FILE* file) {
	connectib_correctable_error_status_print(ptr_struct, file, 0);
}

void connectib_uncorrectable_error_severity_pack(const struct connectib_uncorrectable_error_severity *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->training_error_severity);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved1);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved2);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved3);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->data_link_protocol_error);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved5);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved6);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved7);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved8);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved9);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved10);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved11);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->poisoned_tlp);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->flow_control_protocol_error);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completion_timeout);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completer_abort);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unexpected_completion);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_overflow);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->malformed_tlp);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_error);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unsupported_request_error);

}

void connectib_uncorrectable_error_severity_unpack(struct connectib_uncorrectable_error_severity *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->training_error_severity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->reserved3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->data_link_protocol_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->reserved5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->reserved6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->reserved7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->reserved8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->reserved9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->reserved10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->reserved11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->poisoned_tlp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->flow_control_protocol_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->completion_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->completer_abort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->unexpected_completion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->receiver_overflow = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->malformed_tlp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->ecrc_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->unsupported_request_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_uncorrectable_error_severity_print(const struct connectib_uncorrectable_error_severity *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_uncorrectable_error_severity ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "training_error_severity : "UH_FMT"\n", ptr_struct->training_error_severity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved1            : "UH_FMT"\n", ptr_struct->reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved2            : "UH_FMT"\n", ptr_struct->reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved3            : "UH_FMT"\n", ptr_struct->reserved3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_link_protocol_error : "UH_FMT"\n", ptr_struct->data_link_protocol_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved5            : "UH_FMT"\n", ptr_struct->reserved5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved6            : "UH_FMT"\n", ptr_struct->reserved6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved7            : "UH_FMT"\n", ptr_struct->reserved7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved8            : "UH_FMT"\n", ptr_struct->reserved8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved9            : "UH_FMT"\n", ptr_struct->reserved9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved10           : "UH_FMT"\n", ptr_struct->reserved10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved11           : "UH_FMT"\n", ptr_struct->reserved11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "poisoned_tlp         : "UH_FMT"\n", ptr_struct->poisoned_tlp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_control_protocol_error : "UH_FMT"\n", ptr_struct->flow_control_protocol_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout   : "UH_FMT"\n", ptr_struct->completion_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completer_abort      : "UH_FMT"\n", ptr_struct->completer_abort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unexpected_completion : "UH_FMT"\n", ptr_struct->unexpected_completion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_overflow    : "UH_FMT"\n", ptr_struct->receiver_overflow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "malformed_tlp        : "UH_FMT"\n", ptr_struct->malformed_tlp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_error           : "UH_FMT"\n", ptr_struct->ecrc_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unsupported_request_error : "UH_FMT"\n", ptr_struct->unsupported_request_error);

}

int connectib_uncorrectable_error_severity_size(void){
	 return 4;
}

void connectib_uncorrectable_error_severity_dump(const struct connectib_uncorrectable_error_severity *ptr_struct, FILE* file) {
	connectib_uncorrectable_error_severity_print(ptr_struct, file, 0);
}

void connectib_uncorrectable_error_mask_pack(const struct connectib_uncorrectable_error_mask *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->training_error_mask);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved1);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved2);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved3);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->data_link_protocol_error);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved5);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved6);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved7);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved8);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved9);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved10);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reserved11);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->poisoned_tlp);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->flow_control_protocol_error);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completion_timeout);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completer_abort);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unexpected_completion);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_overflow);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->malformed_tlp);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_error);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unsupported_request_error);

}

void connectib_uncorrectable_error_mask_unpack(struct connectib_uncorrectable_error_mask *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->training_error_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->reserved3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->data_link_protocol_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->reserved5 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->reserved6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->reserved7 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->reserved8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->reserved9 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->reserved10 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->reserved11 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->poisoned_tlp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->flow_control_protocol_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->completion_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->completer_abort = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->unexpected_completion = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->receiver_overflow = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->malformed_tlp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->ecrc_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->unsupported_request_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_uncorrectable_error_mask_print(const struct connectib_uncorrectable_error_mask *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_uncorrectable_error_mask ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "training_error_mask  : "UH_FMT"\n", ptr_struct->training_error_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved1            : "UH_FMT"\n", ptr_struct->reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved2            : "UH_FMT"\n", ptr_struct->reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved3            : "UH_FMT"\n", ptr_struct->reserved3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_link_protocol_error : "UH_FMT"\n", ptr_struct->data_link_protocol_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved5            : "UH_FMT"\n", ptr_struct->reserved5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved6            : "UH_FMT"\n", ptr_struct->reserved6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved7            : "UH_FMT"\n", ptr_struct->reserved7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved8            : "UH_FMT"\n", ptr_struct->reserved8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved9            : "UH_FMT"\n", ptr_struct->reserved9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved10           : "UH_FMT"\n", ptr_struct->reserved10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved11           : "UH_FMT"\n", ptr_struct->reserved11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "poisoned_tlp         : "UH_FMT"\n", ptr_struct->poisoned_tlp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_control_protocol_error : "UH_FMT"\n", ptr_struct->flow_control_protocol_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout   : "UH_FMT"\n", ptr_struct->completion_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completer_abort      : "UH_FMT"\n", ptr_struct->completer_abort);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unexpected_completion : "UH_FMT"\n", ptr_struct->unexpected_completion);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_overflow    : "UH_FMT"\n", ptr_struct->receiver_overflow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "malformed_tlp        : "UH_FMT"\n", ptr_struct->malformed_tlp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_error           : "UH_FMT"\n", ptr_struct->ecrc_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unsupported_request_error : "UH_FMT"\n", ptr_struct->unsupported_request_error);

}

int connectib_uncorrectable_error_mask_size(void){
	 return 4;
}

void connectib_uncorrectable_error_mask_dump(const struct connectib_uncorrectable_error_mask *ptr_struct, FILE* file) {
	connectib_uncorrectable_error_mask_print(ptr_struct, file, 0);
}

void connectib_uncorrectable_error_status_pack(const struct connectib_uncorrectable_error_status *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->training_error_status);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->data_link_protocol_error_status);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->poisoned_tlp_status);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->flow_control_protocol_error_status);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completion_timeout_status);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completer_abort_status);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unexpected_completion_status);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_overflow_status);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->malformed_tlp_status);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ecrc_error_status);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unsupported_request_error_status);

}

void connectib_uncorrectable_error_status_unpack(struct connectib_uncorrectable_error_status *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->training_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->data_link_protocol_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->poisoned_tlp_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->flow_control_protocol_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->completion_timeout_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->completer_abort_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->unexpected_completion_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->receiver_overflow_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->malformed_tlp_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->ecrc_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->unsupported_request_error_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_uncorrectable_error_status_print(const struct connectib_uncorrectable_error_status *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_uncorrectable_error_status ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "training_error_status : "UH_FMT"\n", ptr_struct->training_error_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_link_protocol_error_status : "UH_FMT"\n", ptr_struct->data_link_protocol_error_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "poisoned_tlp_status  : "UH_FMT"\n", ptr_struct->poisoned_tlp_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_control_protocol_error_status : "UH_FMT"\n", ptr_struct->flow_control_protocol_error_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout_status : "UH_FMT"\n", ptr_struct->completion_timeout_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completer_abort_status : "UH_FMT"\n", ptr_struct->completer_abort_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unexpected_completion_status : "UH_FMT"\n", ptr_struct->unexpected_completion_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_overflow_status : "UH_FMT"\n", ptr_struct->receiver_overflow_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "malformed_tlp_status : "UH_FMT"\n", ptr_struct->malformed_tlp_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ecrc_error_status    : "UH_FMT"\n", ptr_struct->ecrc_error_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unsupported_request_error_status : "UH_FMT"\n", ptr_struct->unsupported_request_error_status);

}

int connectib_uncorrectable_error_status_size(void){
	 return 4;
}

void connectib_uncorrectable_error_status_dump(const struct connectib_uncorrectable_error_status *ptr_struct, FILE* file) {
	connectib_uncorrectable_error_status_print(ptr_struct, file, 0);
}

void connectib_bar_high_pack(const struct connectib_bar_high *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->addr_63_32);

}

void connectib_bar_high_unpack(struct connectib_bar_high *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->addr_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_bar_high_print(const struct connectib_bar_high *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_bar_high ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_63_32           : "U32H_FMT"\n", ptr_struct->addr_63_32);

}

int connectib_bar_high_size(void){
	 return 4;
}

void connectib_bar_high_dump(const struct connectib_bar_high *ptr_struct, FILE* file) {
	connectib_bar_high_print(ptr_struct, file, 0);
}

void connectib_bar_low_pack(const struct connectib_bar_low *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->memory_or_io);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->type);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->prefetchable);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 28, (u_int32_t)ptr_struct->addr_31_4);

}

void connectib_bar_low_unpack(struct connectib_bar_low *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->memory_or_io = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=28;
	ptr_struct->prefetchable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->addr_31_4 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 28);

}

void connectib_bar_low_print(const struct connectib_bar_low *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_bar_low ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_or_io         : "UH_FMT"\n", ptr_struct->memory_or_io);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prefetchable         : "UH_FMT"\n", ptr_struct->prefetchable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_31_4            : "UH_FMT"\n", ptr_struct->addr_31_4);

}

int connectib_bar_low_size(void){
	 return 4;
}

void connectib_bar_low_dump(const struct connectib_bar_low *ptr_struct, FILE* file) {
	connectib_bar_low_print(ptr_struct, file, 0);
}

void connectib_sriov_status_pack(const struct connectib_sriov_status *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_mig_status);

}

void connectib_sriov_status_unpack(struct connectib_sriov_status *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->vf_mig_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_sriov_status_print(const struct connectib_sriov_status *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sriov_status ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_mig_status        : "UH_FMT"\n", ptr_struct->vf_mig_status);

}

int connectib_sriov_status_size(void){
	 return 2;
}

void connectib_sriov_status_dump(const struct connectib_sriov_status *ptr_struct, FILE* file) {
	connectib_sriov_status_print(ptr_struct, file, 0);
}

void connectib_sriov_control_pack(const struct connectib_sriov_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_enable);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_migration_en);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_migration_int_en);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_mse);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ari_capable_hierarchy);

}

void connectib_sriov_control_unpack(struct connectib_sriov_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->vf_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->vf_migration_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->vf_migration_int_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->vf_mse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->ari_capable_hierarchy = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_sriov_control_print(const struct connectib_sriov_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sriov_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_enable            : "UH_FMT"\n", ptr_struct->vf_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_migration_en      : "UH_FMT"\n", ptr_struct->vf_migration_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_migration_int_en  : "UH_FMT"\n", ptr_struct->vf_migration_int_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_mse               : "UH_FMT"\n", ptr_struct->vf_mse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_capable_hierarchy : "UH_FMT"\n", ptr_struct->ari_capable_hierarchy);

}

int connectib_sriov_control_size(void){
	 return 2;
}

void connectib_sriov_control_dump(const struct connectib_sriov_control *ptr_struct, FILE* file) {
	connectib_sriov_control_print(ptr_struct, file, 0);
}

void connectib_sriov_capabilities_pack(const struct connectib_sriov_capabilities *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_mig_capable);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ari_cap_hier_preserved);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->vf_mig_int_msg_num);

}

void connectib_sriov_capabilities_unpack(struct connectib_sriov_capabilities *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->vf_mig_capable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->ari_cap_hier_preserved = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->vf_mig_int_msg_num = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void connectib_sriov_capabilities_print(const struct connectib_sriov_capabilities *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sriov_capabilities ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_mig_capable       : "UH_FMT"\n", ptr_struct->vf_mig_capable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_cap_hier_preserved : "UH_FMT"\n", ptr_struct->ari_cap_hier_preserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_mig_int_msg_num   : "UH_FMT"\n", ptr_struct->vf_mig_int_msg_num);

}

int connectib_sriov_capabilities_size(void){
	 return 4;
}

void connectib_sriov_capabilities_dump(const struct connectib_sriov_capabilities *ptr_struct, FILE* file) {
	connectib_sriov_capabilities_print(ptr_struct, file, 0);
}

void connectib_ari_control_pack(const struct connectib_ari_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mfvc_en);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->acs_en);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->func_group);

}

void connectib_ari_control_unpack(struct connectib_ari_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->mfvc_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->acs_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->func_group = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

}

void connectib_ari_control_print(const struct connectib_ari_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ari_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfvc_en              : "UH_FMT"\n", ptr_struct->mfvc_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "acs_en               : "UH_FMT"\n", ptr_struct->acs_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "func_group           : "UH_FMT"\n", ptr_struct->func_group);

}

int connectib_ari_control_size(void){
	 return 2;
}

void connectib_ari_control_dump(const struct connectib_ari_control *ptr_struct, FILE* file) {
	connectib_ari_control_print(ptr_struct, file, 0);
}

void connectib_ari_capabilities_pack(const struct connectib_ari_capabilities *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mfvc);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->acs);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->next_func_num);

}

void connectib_ari_capabilities_unpack(struct connectib_ari_capabilities *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->mfvc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->acs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->next_func_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_ari_capabilities_print(const struct connectib_ari_capabilities *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ari_capabilities ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfvc                 : "UH_FMT"\n", ptr_struct->mfvc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "acs                  : "UH_FMT"\n", ptr_struct->acs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_func_num        : "UH_FMT"\n", ptr_struct->next_func_num);

}

int connectib_ari_capabilities_size(void){
	 return 2;
}

void connectib_ari_capabilities_dump(const struct connectib_ari_capabilities *ptr_struct, FILE* file) {
	connectib_ari_capabilities_print(ptr_struct, file, 0);
}

void connectib_lane_eql_ctl_pack(const struct connectib_lane_eql_ctl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->downstream_port_transmitter_preset0);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->downstream_port_receiver_preset_hint0);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->upstream_port_transmitter_preset0);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->upstream_port_receiver_preset_hint0);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->downstream_port_transmitter_preset1);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->downstream_port_receiver_preset_hint1);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->upstream_port_transmitter_preset1);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->upstream_port_receiver_preset_hint1);

}

void connectib_lane_eql_ctl_unpack(struct connectib_lane_eql_ctl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->downstream_port_transmitter_preset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=25;
	ptr_struct->downstream_port_receiver_preset_hint0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=20;
	ptr_struct->upstream_port_transmitter_preset0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=17;
	ptr_struct->upstream_port_receiver_preset_hint0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=12;
	ptr_struct->downstream_port_transmitter_preset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=9;
	ptr_struct->downstream_port_receiver_preset_hint1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=4;
	ptr_struct->upstream_port_transmitter_preset1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=1;
	ptr_struct->upstream_port_receiver_preset_hint1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

}

void connectib_lane_eql_ctl_print(const struct connectib_lane_eql_ctl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_lane_eql_ctl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "downstream_port_transmitter_preset0 : "UH_FMT"\n", ptr_struct->downstream_port_transmitter_preset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "downstream_port_receiver_preset_hint0 : "UH_FMT"\n", ptr_struct->downstream_port_receiver_preset_hint0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upstream_port_transmitter_preset0 : "UH_FMT"\n", ptr_struct->upstream_port_transmitter_preset0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upstream_port_receiver_preset_hint0 : "UH_FMT"\n", ptr_struct->upstream_port_receiver_preset_hint0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "downstream_port_transmitter_preset1 : "UH_FMT"\n", ptr_struct->downstream_port_transmitter_preset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "downstream_port_receiver_preset_hint1 : "UH_FMT"\n", ptr_struct->downstream_port_receiver_preset_hint1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upstream_port_transmitter_preset1 : "UH_FMT"\n", ptr_struct->upstream_port_transmitter_preset1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upstream_port_receiver_preset_hint1 : "UH_FMT"\n", ptr_struct->upstream_port_receiver_preset_hint1);

}

int connectib_lane_eql_ctl_size(void){
	 return 4;
}

void connectib_lane_eql_ctl_dump(const struct connectib_lane_eql_ctl *ptr_struct, FILE* file) {
	connectib_lane_eql_ctl_print(ptr_struct, file, 0);
}

void connectib_pciex_link_ctl3_pack(const struct connectib_pciex_link_ctl3 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->perform_equalization);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_equalization_req_int_en);

}

void connectib_pciex_link_ctl3_unpack(struct connectib_pciex_link_ctl3 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->perform_equalization = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->link_equalization_req_int_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_pciex_link_ctl3_print(const struct connectib_pciex_link_ctl3 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pciex_link_ctl3 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perform_equalization : "UH_FMT"\n", ptr_struct->perform_equalization);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_equalization_req_int_en : "UH_FMT"\n", ptr_struct->link_equalization_req_int_en);

}

int connectib_pciex_link_ctl3_size(void){
	 return 4;
}

void connectib_pciex_link_ctl3_dump(const struct connectib_pciex_link_ctl3 *ptr_struct, FILE* file) {
	connectib_pciex_link_ctl3_print(ptr_struct, file, 0);
}

void connectib_message_control_pack(const struct connectib_message_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->table_size);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->function_mask);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->msix_en);

}

void connectib_message_control_unpack(struct connectib_message_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=5;
	ptr_struct->table_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=1;
	ptr_struct->function_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->msix_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_message_control_print(const struct connectib_message_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_message_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_size           : "UH_FMT"\n", ptr_struct->table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "function_mask        : "UH_FMT"\n", ptr_struct->function_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_en              : "UH_FMT"\n", ptr_struct->msix_en);

}

int connectib_message_control_size(void){
	 return 2;
}

void connectib_message_control_dump(const struct connectib_message_control *ptr_struct, FILE* file) {
	connectib_message_control_print(ptr_struct, file, 0);
}

void connectib_link_stat2_pack(const struct connectib_link_stat2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->current_de_emphasis_level);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->equalization_complete);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->equalization_phase1_successful);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->equalization_phase2_successful);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->equalization_phase3_successful);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_equalization_request);

}

void connectib_link_stat2_unpack(struct connectib_link_stat2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->current_de_emphasis_level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->equalization_complete = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->equalization_phase1_successful = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->equalization_phase2_successful = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->equalization_phase3_successful = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->link_equalization_request = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_link_stat2_print(const struct connectib_link_stat2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_stat2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_de_emphasis_level : "UH_FMT"\n", ptr_struct->current_de_emphasis_level);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "equalization_complete : "UH_FMT"\n", ptr_struct->equalization_complete);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "equalization_phase1_successful : "UH_FMT"\n", ptr_struct->equalization_phase1_successful);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "equalization_phase2_successful : "UH_FMT"\n", ptr_struct->equalization_phase2_successful);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "equalization_phase3_successful : "UH_FMT"\n", ptr_struct->equalization_phase3_successful);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_equalization_request : "UH_FMT"\n", ptr_struct->link_equalization_request);

}

int connectib_link_stat2_size(void){
	 return 2;
}

void connectib_link_stat2_dump(const struct connectib_link_stat2 *ptr_struct, FILE* file) {
	connectib_link_stat2_print(ptr_struct, file, 0);
}

void connectib_link_ctl2_pack(const struct connectib_link_ctl2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->target_link_speed);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enter_compliance);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hardware_autonomus_speed_disable);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->selectable_de_emphasis);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->transmit_margin);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->modified_compliance);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->compliance_sos);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->compliance_preset_de_emphasis);

}

void connectib_link_ctl2_unpack(struct connectib_link_ctl2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->target_link_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=11;
	ptr_struct->enter_compliance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->hardware_autonomus_speed_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->selectable_de_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->transmit_margin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=5;
	ptr_struct->modified_compliance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->compliance_sos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->compliance_preset_de_emphasis = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_link_ctl2_print(const struct connectib_link_ctl2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_ctl2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "target_link_speed    : "UH_FMT"\n", ptr_struct->target_link_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enter_compliance     : "UH_FMT"\n", ptr_struct->enter_compliance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hardware_autonomus_speed_disable : "UH_FMT"\n", ptr_struct->hardware_autonomus_speed_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "selectable_de_emphasis : "UH_FMT"\n", ptr_struct->selectable_de_emphasis);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transmit_margin      : "UH_FMT"\n", ptr_struct->transmit_margin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modified_compliance  : "UH_FMT"\n", ptr_struct->modified_compliance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compliance_sos       : "UH_FMT"\n", ptr_struct->compliance_sos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compliance_preset_de_emphasis : "UH_FMT"\n", ptr_struct->compliance_preset_de_emphasis);

}

int connectib_link_ctl2_size(void){
	 return 2;
}

void connectib_link_ctl2_dump(const struct connectib_link_ctl2 *ptr_struct, FILE* file) {
	connectib_link_ctl2_print(ptr_struct, file, 0);
}

void connectib_link_caps2_pack(const struct connectib_link_caps2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->supported_link_speed_vector);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cross_link_supported);

}

void connectib_link_caps2_unpack(struct connectib_link_caps2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->supported_link_speed_vector = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=23;
	ptr_struct->cross_link_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_link_caps2_print(const struct connectib_link_caps2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_caps2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "supported_link_speed_vector : "UH_FMT"\n", ptr_struct->supported_link_speed_vector);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cross_link_supported : "UH_FMT"\n", ptr_struct->cross_link_supported);

}

int connectib_link_caps2_size(void){
	 return 4;
}

void connectib_link_caps2_dump(const struct connectib_link_caps2 *ptr_struct, FILE* file) {
	connectib_link_caps2_print(ptr_struct, file, 0);
}

void connectib_device_stat2_pack(const struct connectib_device_stat2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_device_stat2_unpack(struct connectib_device_stat2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

}

void connectib_device_stat2_print(const struct connectib_device_stat2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_stat2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

}

int connectib_device_stat2_size(void){
	 return 2;
}

void connectib_device_stat2_dump(const struct connectib_device_stat2 *ptr_struct, FILE* file) {
	connectib_device_stat2_print(ptr_struct, file, 0);
}

void connectib_device_ctl2_pack(const struct connectib_device_ctl2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->completion_timeout_value);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completion_timeout_disable);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ari_forwarding_enable);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->obff_enable);

}

void connectib_device_ctl2_unpack(struct connectib_device_ctl2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->completion_timeout_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=11;
	ptr_struct->completion_timeout_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->ari_forwarding_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->obff_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_device_ctl2_print(const struct connectib_device_ctl2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_ctl2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout_value : "UH_FMT"\n", ptr_struct->completion_timeout_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout_disable : "UH_FMT"\n", ptr_struct->completion_timeout_disable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_forwarding_enable : "UH_FMT"\n", ptr_struct->ari_forwarding_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "obff_enable          : "UH_FMT"\n", ptr_struct->obff_enable);

}

int connectib_device_ctl2_size(void){
	 return 2;
}

void connectib_device_ctl2_dump(const struct connectib_device_ctl2 *ptr_struct, FILE* file) {
	connectib_device_ctl2_print(ptr_struct, file, 0);
}

void connectib_device_caps2_pack(const struct connectib_device_caps2 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->completion_timeout_ranges_supported);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->completion_timeout_disable_supported);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ari_forwarding_supported);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->obff_supported);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->extended_fmt_field_supported);

}

void connectib_device_caps2_unpack(struct connectib_device_caps2 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->completion_timeout_ranges_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=27;
	ptr_struct->completion_timeout_disable_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->ari_forwarding_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=12;
	ptr_struct->obff_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=11;
	ptr_struct->extended_fmt_field_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_device_caps2_print(const struct connectib_device_caps2 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_caps2 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout_ranges_supported : "UH_FMT"\n", ptr_struct->completion_timeout_ranges_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "completion_timeout_disable_supported : "UH_FMT"\n", ptr_struct->completion_timeout_disable_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_forwarding_supported : "UH_FMT"\n", ptr_struct->ari_forwarding_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "obff_supported       : "UH_FMT"\n", ptr_struct->obff_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_fmt_field_supported : "UH_FMT"\n", ptr_struct->extended_fmt_field_supported);

}

int connectib_device_caps2_size(void){
	 return 4;
}

void connectib_device_caps2_dump(const struct connectib_device_caps2 *ptr_struct, FILE* file) {
	connectib_device_caps2_print(ptr_struct, file, 0);
}

void connectib_link_stat_pack(const struct connectib_link_stat *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_speed);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->negotiated_link_width);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->training_error);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_training);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slot_clock_cfg);

}

void connectib_link_stat_unpack(struct connectib_link_stat *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->link_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=6;
	ptr_struct->negotiated_link_width = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=5;
	ptr_struct->training_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->link_training = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->slot_clock_cfg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_link_stat_print(const struct connectib_link_stat *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_stat ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed           : "UH_FMT"\n", ptr_struct->link_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "negotiated_link_width : "UH_FMT"\n", ptr_struct->negotiated_link_width);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "training_error       : "UH_FMT"\n", ptr_struct->training_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_training        : "UH_FMT"\n", ptr_struct->link_training);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_clock_cfg       : "UH_FMT"\n", ptr_struct->slot_clock_cfg);

}

int connectib_link_stat_size(void){
	 return 2;
}

void connectib_link_stat_dump(const struct connectib_link_stat *ptr_struct, FILE* file) {
	connectib_link_stat_print(ptr_struct, file, 0);
}

void connectib_link_ctl_pack(const struct connectib_link_ctl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->aspm_control);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rcb);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->common_clock_configuration);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->extended_synch);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_clock_power_management);

}

void connectib_link_ctl_unpack(struct connectib_link_ctl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	ptr_struct->aspm_control = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=12;
	ptr_struct->rcb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->common_clock_configuration = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->extended_synch = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->enable_clock_power_management = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_link_ctl_print(const struct connectib_link_ctl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_ctl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aspm_control         : "UH_FMT"\n", ptr_struct->aspm_control);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rcb                  : "UH_FMT"\n", ptr_struct->rcb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "common_clock_configuration : "UH_FMT"\n", ptr_struct->common_clock_configuration);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_synch       : "UH_FMT"\n", ptr_struct->extended_synch);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_clock_power_management : "UH_FMT"\n", ptr_struct->enable_clock_power_management);

}

int connectib_link_ctl_size(void){
	 return 2;
}

void connectib_link_ctl_dump(const struct connectib_link_ctl *ptr_struct, FILE* file) {
	connectib_link_ctl_print(ptr_struct, file, 0);
}

void connectib_link_caps_pack(const struct connectib_link_caps *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->max_link_speed);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->max_link_width);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->aspm_support);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->l0s_exit_latency);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->l1_exit_latency);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clock_power_management);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->surprise_down_error_reporting_cap);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_active_reporting_cap);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_bw_notification_cap);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aspm_optionality_compliance);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_number);

}

void connectib_link_caps_unpack(struct connectib_link_caps *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->max_link_speed = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=22;
	ptr_struct->max_link_width = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=20;
	ptr_struct->aspm_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=17;
	ptr_struct->l0s_exit_latency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=14;
	ptr_struct->l1_exit_latency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=13;
	ptr_struct->clock_power_management = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->surprise_down_error_reporting_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->link_active_reporting_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->link_bw_notification_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->aspm_optionality_compliance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_link_caps_print(const struct connectib_link_caps *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_link_caps ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_link_speed       : "UH_FMT"\n", ptr_struct->max_link_speed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_link_width       : "UH_FMT"\n", ptr_struct->max_link_width);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aspm_support         : "UH_FMT"\n", ptr_struct->aspm_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0s_exit_latency     : "UH_FMT"\n", ptr_struct->l0s_exit_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l1_exit_latency      : "UH_FMT"\n", ptr_struct->l1_exit_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clock_power_management : "UH_FMT"\n", ptr_struct->clock_power_management);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "surprise_down_error_reporting_cap : "UH_FMT"\n", ptr_struct->surprise_down_error_reporting_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_active_reporting_cap : "UH_FMT"\n", ptr_struct->link_active_reporting_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_bw_notification_cap : "UH_FMT"\n", ptr_struct->link_bw_notification_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aspm_optionality_compliance : "UH_FMT"\n", ptr_struct->aspm_optionality_compliance);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

}

int connectib_link_caps_size(void){
	 return 4;
}

void connectib_link_caps_dump(const struct connectib_link_caps *ptr_struct, FILE* file) {
	connectib_link_caps_print(ptr_struct, file, 0);
}

void connectib_device_stat_pack(const struct connectib_device_stat *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->correctable_error);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->non_fatal_error);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fatal_error);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unsupported_request);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aux_power);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->transactions_pending);

}

void connectib_device_stat_unpack(struct connectib_device_stat *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->correctable_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->non_fatal_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->fatal_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->unsupported_request = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->aux_power = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->transactions_pending = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_device_stat_print(const struct connectib_device_stat *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_stat ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "correctable_error    : "UH_FMT"\n", ptr_struct->correctable_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "non_fatal_error      : "UH_FMT"\n", ptr_struct->non_fatal_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fatal_error          : "UH_FMT"\n", ptr_struct->fatal_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unsupported_request  : "UH_FMT"\n", ptr_struct->unsupported_request);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aux_power            : "UH_FMT"\n", ptr_struct->aux_power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transactions_pending : "UH_FMT"\n", ptr_struct->transactions_pending);

}

int connectib_device_stat_size(void){
	 return 2;
}

void connectib_device_stat_dump(const struct connectib_device_stat *ptr_struct, FILE* file) {
	connectib_device_stat_print(ptr_struct, file, 0);
}

void connectib_device_ctl_pack(const struct connectib_device_ctl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->correctable_error_report);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->non_fatal_error_report);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fatal_error_report);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->unsupported_request_report);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->relaxed_ordering);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_payload_size);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->extended_tag_field_en);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->phantom_funcs);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aux_power);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_snoop);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_read_request_size);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->initiate_function_level_reset);

}

void connectib_device_ctl_unpack(struct connectib_device_ctl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->correctable_error_report = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->non_fatal_error_report = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->fatal_error_report = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->unsupported_request_report = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->relaxed_ordering = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->max_payload_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=7;
	ptr_struct->extended_tag_field_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->phantom_funcs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->aux_power = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->no_snoop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->max_read_request_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->initiate_function_level_reset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_device_ctl_print(const struct connectib_device_ctl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_ctl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "correctable_error_report : "UH_FMT"\n", ptr_struct->correctable_error_report);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "non_fatal_error_report : "UH_FMT"\n", ptr_struct->non_fatal_error_report);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fatal_error_report   : "UH_FMT"\n", ptr_struct->fatal_error_report);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unsupported_request_report : "UH_FMT"\n", ptr_struct->unsupported_request_report);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "relaxed_ordering     : "UH_FMT"\n", ptr_struct->relaxed_ordering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_payload_size     : "UH_FMT"\n", ptr_struct->max_payload_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_tag_field_en : "UH_FMT"\n", ptr_struct->extended_tag_field_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phantom_funcs        : "UH_FMT"\n", ptr_struct->phantom_funcs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aux_power            : "UH_FMT"\n", ptr_struct->aux_power);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_snoop             : "UH_FMT"\n", ptr_struct->no_snoop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_read_request_size : "UH_FMT"\n", ptr_struct->max_read_request_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initiate_function_level_reset : "UH_FMT"\n", ptr_struct->initiate_function_level_reset);

}

int connectib_device_ctl_size(void){
	 return 2;
}

void connectib_device_ctl_dump(const struct connectib_device_ctl *ptr_struct, FILE* file) {
	connectib_device_ctl_print(ptr_struct, file, 0);
}

void connectib_device_caps_pack(const struct connectib_device_caps *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_payload_size_supported);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->phantom_funcs);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->extended_tag_field_sup);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->l0s_acceptable_latency);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->l1_acceptable_latency);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->role_based_error_reporting);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->captured_slot_power_limit_value);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->captured_slot_power_limit_scale);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->function_level_reset_capability);

}

void connectib_device_caps_unpack(struct connectib_device_caps *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->max_payload_size_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=27;
	ptr_struct->phantom_funcs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=26;
	ptr_struct->extended_tag_field_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->l0s_acceptable_latency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=20;
	ptr_struct->l1_acceptable_latency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=16;
	ptr_struct->role_based_error_reporting = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->captured_slot_power_limit_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=4;
	ptr_struct->captured_slot_power_limit_scale = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->function_level_reset_capability = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_device_caps_print(const struct connectib_device_caps *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_caps ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_payload_size_supported : "UH_FMT"\n", ptr_struct->max_payload_size_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phantom_funcs        : "UH_FMT"\n", ptr_struct->phantom_funcs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_tag_field_sup : "UH_FMT"\n", ptr_struct->extended_tag_field_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l0s_acceptable_latency : "UH_FMT"\n", ptr_struct->l0s_acceptable_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l1_acceptable_latency : "UH_FMT"\n", ptr_struct->l1_acceptable_latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "role_based_error_reporting : "UH_FMT"\n", ptr_struct->role_based_error_reporting);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "captured_slot_power_limit_value : "UH_FMT"\n", ptr_struct->captured_slot_power_limit_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "captured_slot_power_limit_scale : "UH_FMT"\n", ptr_struct->captured_slot_power_limit_scale);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "function_level_reset_capability : "UH_FMT"\n", ptr_struct->function_level_reset_capability);

}

int connectib_device_caps_size(void){
	 return 4;
}

void connectib_device_caps_dump(const struct connectib_device_caps *ptr_struct, FILE* file) {
	connectib_device_caps_print(ptr_struct, file, 0);
}

void connectib_pciex_cap_pack(const struct connectib_pciex_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->device_port_type);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slot);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->int_message_num);

}

void connectib_pciex_cap_unpack(struct connectib_pciex_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=8;
	ptr_struct->device_port_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=6;
	ptr_struct->slot = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->int_message_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_pciex_cap_print(const struct connectib_pciex_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pciex_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_port_type     : "UH_FMT"\n", ptr_struct->device_port_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot                 : "UH_FMT"\n", ptr_struct->slot);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_message_num      : "UH_FMT"\n", ptr_struct->int_message_num);

}

int connectib_pciex_cap_size(void){
	 return 2;
}

void connectib_pciex_cap_dump(const struct connectib_pciex_cap *ptr_struct, FILE* file) {
	connectib_pciex_cap_print(ptr_struct, file, 0);
}

void connectib_exp_rom_pack(const struct connectib_exp_rom *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->exp_rom_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 21, (u_int32_t)ptr_struct->addr_31_11);

}

void connectib_exp_rom_unpack(struct connectib_exp_rom *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->exp_rom_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->addr_31_11 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 21);

}

void connectib_exp_rom_print(const struct connectib_exp_rom *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_exp_rom ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "exp_rom_en           : "UH_FMT"\n", ptr_struct->exp_rom_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_31_11           : "UH_FMT"\n", ptr_struct->addr_31_11);

}

int connectib_exp_rom_size(void){
	 return 4;
}

void connectib_exp_rom_dump(const struct connectib_exp_rom *ptr_struct, FILE* file) {
	connectib_exp_rom_print(ptr_struct, file, 0);
}

void connectib_stat_reg1_pack(const struct connectib_stat_reg1 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->int_status);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->capabilities_list);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->master_data_perr);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->signaled_ta);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->received_ta);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->received_ma);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->signaled_serr);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->detected_perr);

}

void connectib_stat_reg1_unpack(struct connectib_stat_reg1 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=12;
	ptr_struct->int_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->capabilities_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->master_data_perr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->signaled_ta = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->received_ta = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->received_ma = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->signaled_serr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->detected_perr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_stat_reg1_print(const struct connectib_stat_reg1 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_stat_reg1 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_status           : "UH_FMT"\n", ptr_struct->int_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capabilities_list    : "UH_FMT"\n", ptr_struct->capabilities_list);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "master_data_perr     : "UH_FMT"\n", ptr_struct->master_data_perr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signaled_ta          : "UH_FMT"\n", ptr_struct->signaled_ta);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "received_ta          : "UH_FMT"\n", ptr_struct->received_ta);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "received_ma          : "UH_FMT"\n", ptr_struct->received_ma);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signaled_serr        : "UH_FMT"\n", ptr_struct->signaled_serr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "detected_perr        : "UH_FMT"\n", ptr_struct->detected_perr);

}

int connectib_stat_reg1_size(void){
	 return 2;
}

void connectib_stat_reg1_dump(const struct connectib_stat_reg1 *ptr_struct, FILE* file) {
	connectib_stat_reg1_print(ptr_struct, file, 0);
}

void connectib_cmd_reg1_pack(const struct connectib_cmd_reg1 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->io_space);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->memory_space);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bus_master_en);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->perr_enable);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->serr_enable);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->int_disable);

}

void connectib_cmd_reg1_unpack(struct connectib_cmd_reg1 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=15;
	ptr_struct->io_space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->memory_space = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->bus_master_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->perr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->serr_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->int_disable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_cmd_reg1_print(const struct connectib_cmd_reg1 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmd_reg1 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "io_space             : "UH_FMT"\n", ptr_struct->io_space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "memory_space         : "UH_FMT"\n", ptr_struct->memory_space);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bus_master_en        : "UH_FMT"\n", ptr_struct->bus_master_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perr_enable          : "UH_FMT"\n", ptr_struct->perr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serr_enable          : "UH_FMT"\n", ptr_struct->serr_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_disable          : "UH_FMT"\n", ptr_struct->int_disable);

}

int connectib_cmd_reg1_size(void){
	 return 2;
}

void connectib_cmd_reg1_dump(const struct connectib_cmd_reg1 *ptr_struct, FILE* file) {
	connectib_cmd_reg1_print(ptr_struct, file, 0);
}

void connectib_nv_tlv_data_vpi_settings_pack(const struct connectib_nv_tlv_data_vpi_settings *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->network_link_type_ib);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->network_link_type_eth);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->default_link_type_ib);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->default_link_type_eth);

}

void connectib_nv_tlv_data_vpi_settings_unpack(struct connectib_nv_tlv_data_vpi_settings *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->network_link_type_ib = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->network_link_type_eth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->default_link_type_ib = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->default_link_type_eth = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_nv_tlv_data_vpi_settings_print(const struct connectib_nv_tlv_data_vpi_settings *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_tlv_data_vpi_settings ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "network_link_type_ib : "UH_FMT"\n", ptr_struct->network_link_type_ib);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "network_link_type_eth : "UH_FMT"\n", ptr_struct->network_link_type_eth);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "default_link_type_ib : "UH_FMT"\n", ptr_struct->default_link_type_ib);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "default_link_type_eth : "UH_FMT"\n", ptr_struct->default_link_type_eth);

}

int connectib_nv_tlv_data_vpi_settings_size(void){
	 return 4;
}

void connectib_nv_tlv_data_vpi_settings_dump(const struct connectib_nv_tlv_data_vpi_settings *ptr_struct, FILE* file) {
	connectib_nv_tlv_data_vpi_settings_print(ptr_struct, file, 0);
}

void connectib_dword_val_pack(const struct connectib_dword_val *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->val);

}

void connectib_dword_val_unpack(struct connectib_dword_val *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->val = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_dword_val_print(const struct connectib_dword_val *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dword_val ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "val                  : "U32H_FMT"\n", ptr_struct->val);

}

int connectib_dword_val_size(void){
	 return 4;
}

void connectib_dword_val_dump(const struct connectib_dword_val *ptr_struct, FILE* file) {
	connectib_dword_val_print(ptr_struct, file, 0);
}

void connectib_port_cap_mask1_fields_pack(const struct connectib_port_cap_mask1_fields *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_sm);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_notice_sup);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_trap_sup);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_optional_ipd_sup);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_automatic_migration_sup);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_sl_mapping_sup);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_mkey_nvram);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_pkey_nvram);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_led_info_sup);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_sm_disabled);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_system_image_guid_sup);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_pkey_switch_external_port_trap_sup);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_cable_info_supported);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_extended_speed_sup);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_capability_mask2_supported);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_communication_management_sup);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_snmp_tunneling_sup);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_reinit_sup);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_device_management_sup);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_vendor_class_sup);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_dr_notice_sup);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_capability_mask_notice_sup);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_boot_management_sup);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_link_round_trip_latency_sup);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_client_reregistration_sup);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_other_local_changes_notice_supported);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_link_speed_width_pairs_table_supported);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_vendor_specific_mads_table_supported);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_multicast_pkey_trap_suppression_supported);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_multicast_fdb_top_supported);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_hierarchy_info_supported);

}

void connectib_port_cap_mask1_fields_unpack(struct connectib_port_cap_mask1_fields *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->is_sm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->is_notice_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->is_trap_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->is_optional_ipd_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->is_automatic_migration_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->is_sl_mapping_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->is_mkey_nvram = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->is_pkey_nvram = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->is_led_info_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->is_sm_disabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->is_system_image_guid_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->is_pkey_switch_external_port_trap_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->is_cable_info_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->is_extended_speed_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->is_capability_mask2_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->is_communication_management_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->is_snmp_tunneling_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->is_reinit_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->is_device_management_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->is_vendor_class_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->is_dr_notice_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->is_capability_mask_notice_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->is_boot_management_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=7;
	ptr_struct->is_link_round_trip_latency_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->is_client_reregistration_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->is_other_local_changes_notice_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->is_link_speed_width_pairs_table_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->is_vendor_specific_mads_table_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2;
	ptr_struct->is_multicast_pkey_trap_suppression_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->is_multicast_fdb_top_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->is_hierarchy_info_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_port_cap_mask1_fields_print(const struct connectib_port_cap_mask1_fields *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_cap_mask1_fields ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_sm                : "UH_FMT"\n", ptr_struct->is_sm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_notice_sup        : "UH_FMT"\n", ptr_struct->is_notice_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_trap_sup          : "UH_FMT"\n", ptr_struct->is_trap_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_optional_ipd_sup  : "UH_FMT"\n", ptr_struct->is_optional_ipd_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_automatic_migration_sup : "UH_FMT"\n", ptr_struct->is_automatic_migration_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_sl_mapping_sup    : "UH_FMT"\n", ptr_struct->is_sl_mapping_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_mkey_nvram        : "UH_FMT"\n", ptr_struct->is_mkey_nvram);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_pkey_nvram        : "UH_FMT"\n", ptr_struct->is_pkey_nvram);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_led_info_sup      : "UH_FMT"\n", ptr_struct->is_led_info_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_sm_disabled       : "UH_FMT"\n", ptr_struct->is_sm_disabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_system_image_guid_sup : "UH_FMT"\n", ptr_struct->is_system_image_guid_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_pkey_switch_external_port_trap_sup : "UH_FMT"\n", ptr_struct->is_pkey_switch_external_port_trap_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_cable_info_supported : "UH_FMT"\n", ptr_struct->is_cable_info_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_extended_speed_sup : "UH_FMT"\n", ptr_struct->is_extended_speed_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_capability_mask2_supported : "UH_FMT"\n", ptr_struct->is_capability_mask2_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_communication_management_sup : "UH_FMT"\n", ptr_struct->is_communication_management_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_snmp_tunneling_sup : "UH_FMT"\n", ptr_struct->is_snmp_tunneling_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_reinit_sup        : "UH_FMT"\n", ptr_struct->is_reinit_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_device_management_sup : "UH_FMT"\n", ptr_struct->is_device_management_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_vendor_class_sup  : "UH_FMT"\n", ptr_struct->is_vendor_class_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_dr_notice_sup     : "UH_FMT"\n", ptr_struct->is_dr_notice_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_capability_mask_notice_sup : "UH_FMT"\n", ptr_struct->is_capability_mask_notice_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_boot_management_sup : "UH_FMT"\n", ptr_struct->is_boot_management_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_link_round_trip_latency_sup : "UH_FMT"\n", ptr_struct->is_link_round_trip_latency_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_client_reregistration_sup : "UH_FMT"\n", ptr_struct->is_client_reregistration_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_other_local_changes_notice_supported : "UH_FMT"\n", ptr_struct->is_other_local_changes_notice_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_link_speed_width_pairs_table_supported : "UH_FMT"\n", ptr_struct->is_link_speed_width_pairs_table_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_vendor_specific_mads_table_supported : "UH_FMT"\n", ptr_struct->is_vendor_specific_mads_table_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_multicast_pkey_trap_suppression_supported : "UH_FMT"\n", ptr_struct->is_multicast_pkey_trap_suppression_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_multicast_fdb_top_supported : "UH_FMT"\n", ptr_struct->is_multicast_fdb_top_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_hierarchy_info_supported : "UH_FMT"\n", ptr_struct->is_hierarchy_info_supported);

}

int connectib_port_cap_mask1_fields_size(void){
	 return 4;
}

void connectib_port_cap_mask1_fields_dump(const struct connectib_port_cap_mask1_fields *ptr_struct, FILE* file) {
	connectib_port_cap_mask1_fields_print(ptr_struct, file, 0);
}

void connectib_ib_port_counters_pack(const struct connectib_ib_port_counters *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_downed_counter);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_error_recovery_counter);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->symbol_error_counter);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_rcv_remote_physical_errors);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_rcv_errors);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_xmit_discards);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->port_rcv_switch_relay_errors);

	offset=124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->excessive_buffer_overrun_errors);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->local_link_integrity_errors);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_rcv_constraint_errors);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_xmit_constraint_errors);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vl15_dropped);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_xmit_data);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_rcv_data);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_xmit_pkts);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_rcv_pkts);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_xmit_wait);

}

void connectib_ib_port_counters_unpack(struct connectib_ib_port_counters *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->link_downed_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->link_error_recovery_counter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->symbol_error_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	ptr_struct->port_rcv_remote_physical_errors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->port_rcv_errors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=80;
	ptr_struct->port_xmit_discards = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->port_rcv_switch_relay_errors = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=124;
	ptr_struct->excessive_buffer_overrun_errors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=120;
	ptr_struct->local_link_integrity_errors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=104;
	ptr_struct->port_rcv_constraint_errors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->port_xmit_constraint_errors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=144;
	ptr_struct->vl15_dropped = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->port_xmit_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->port_rcv_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->port_xmit_pkts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->port_rcv_pkts = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->port_xmit_wait = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_ib_port_counters_print(const struct connectib_ib_port_counters *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ib_port_counters ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_downed_counter  : "UH_FMT"\n", ptr_struct->link_downed_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_error_recovery_counter : "UH_FMT"\n", ptr_struct->link_error_recovery_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_error_counter : "UH_FMT"\n", ptr_struct->symbol_error_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_remote_physical_errors : "UH_FMT"\n", ptr_struct->port_rcv_remote_physical_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_errors      : "UH_FMT"\n", ptr_struct->port_rcv_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_discards   : "UH_FMT"\n", ptr_struct->port_xmit_discards);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_switch_relay_errors : "UH_FMT"\n", ptr_struct->port_rcv_switch_relay_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "excessive_buffer_overrun_errors : "UH_FMT"\n", ptr_struct->excessive_buffer_overrun_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_link_integrity_errors : "UH_FMT"\n", ptr_struct->local_link_integrity_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_constraint_errors : "UH_FMT"\n", ptr_struct->port_rcv_constraint_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_constraint_errors : "UH_FMT"\n", ptr_struct->port_xmit_constraint_errors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl15_dropped         : "UH_FMT"\n", ptr_struct->vl15_dropped);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_data       : "U32H_FMT"\n", ptr_struct->port_xmit_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_data        : "U32H_FMT"\n", ptr_struct->port_rcv_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_pkts       : "U32H_FMT"\n", ptr_struct->port_xmit_pkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_rcv_pkts        : "U32H_FMT"\n", ptr_struct->port_rcv_pkts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_xmit_wait       : "U32H_FMT"\n", ptr_struct->port_xmit_wait);

}

int connectib_ib_port_counters_size(void){
	 return 248;
}

void connectib_ib_port_counters_dump(const struct connectib_ib_port_counters *ptr_struct, FILE* file) {
	connectib_ib_port_counters_print(ptr_struct, file, 0);
}

void connectib_llr_counters_pack(const struct connectib_llr_counters *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_cells_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_cells_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_error_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_error_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_crc_error_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_rx_crc_error_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_cells_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_cells_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_ret_cells_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_ret_cells_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_ret_events_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->llr_tx_ret_events_low);

}

void connectib_llr_counters_unpack(struct connectib_llr_counters *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->llr_rx_cells_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->llr_rx_cells_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->llr_rx_error_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->llr_rx_error_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->llr_rx_crc_error_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->llr_rx_crc_error_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->llr_tx_cells_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->llr_tx_cells_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->llr_tx_ret_cells_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->llr_tx_ret_cells_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->llr_tx_ret_events_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->llr_tx_ret_events_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_llr_counters_print(const struct connectib_llr_counters *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_llr_counters ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_cells_high    : "U32H_FMT"\n", ptr_struct->llr_rx_cells_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_cells_low     : "U32H_FMT"\n", ptr_struct->llr_rx_cells_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_error_high    : "U32H_FMT"\n", ptr_struct->llr_rx_error_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_error_low     : "U32H_FMT"\n", ptr_struct->llr_rx_error_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_crc_error_high : "U32H_FMT"\n", ptr_struct->llr_rx_crc_error_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_crc_error_low : "U32H_FMT"\n", ptr_struct->llr_rx_crc_error_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_cells_high    : "U32H_FMT"\n", ptr_struct->llr_tx_cells_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_cells_low     : "U32H_FMT"\n", ptr_struct->llr_tx_cells_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_ret_cells_high : "U32H_FMT"\n", ptr_struct->llr_tx_ret_cells_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_ret_cells_low : "U32H_FMT"\n", ptr_struct->llr_tx_ret_cells_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_ret_events_high : "U32H_FMT"\n", ptr_struct->llr_tx_ret_events_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_tx_ret_events_low : "U32H_FMT"\n", ptr_struct->llr_tx_ret_events_low);

}

int connectib_llr_counters_size(void){
	 return 248;
}

void connectib_llr_counters_dump(const struct connectib_llr_counters *ptr_struct, FILE* file) {
	connectib_llr_counters_print(ptr_struct, file, 0);
}

void connectib_discard_cntrs_grp_data_pack(const struct connectib_discard_cntrs_grp_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_general_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_general_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_policy_engine_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_policy_engine_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_vlan_membership_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_vlan_membership_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_tag_frame_type_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ingress_tag_frame_type_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_vlan_membership_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_vlan_membership_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->loopback_filter_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->loopback_filter_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_general_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_general_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_link_down_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_link_down_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_hoq_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_hoq_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_isolation_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_isolation_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_policy_engine_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->egress_policy_engine_low);

}

void connectib_discard_cntrs_grp_data_unpack(struct connectib_discard_cntrs_grp_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->ingress_general_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->ingress_general_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->ingress_policy_engine_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->ingress_policy_engine_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->ingress_vlan_membership_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->ingress_vlan_membership_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->ingress_tag_frame_type_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->ingress_tag_frame_type_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->egress_vlan_membership_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->egress_vlan_membership_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->loopback_filter_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->loopback_filter_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->egress_general_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->egress_general_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->egress_link_down_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->egress_link_down_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->egress_hoq_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->egress_hoq_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->port_isolation_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->port_isolation_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->egress_policy_engine_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->egress_policy_engine_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_discard_cntrs_grp_data_print(const struct connectib_discard_cntrs_grp_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_discard_cntrs_grp_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_general_high : "U32H_FMT"\n", ptr_struct->ingress_general_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_general_low  : "U32H_FMT"\n", ptr_struct->ingress_general_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_policy_engine_high : "U32H_FMT"\n", ptr_struct->ingress_policy_engine_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_policy_engine_low : "U32H_FMT"\n", ptr_struct->ingress_policy_engine_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_vlan_membership_high : "U32H_FMT"\n", ptr_struct->ingress_vlan_membership_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_vlan_membership_low : "U32H_FMT"\n", ptr_struct->ingress_vlan_membership_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_tag_frame_type_high : "U32H_FMT"\n", ptr_struct->ingress_tag_frame_type_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ingress_tag_frame_type_low : "U32H_FMT"\n", ptr_struct->ingress_tag_frame_type_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_vlan_membership_high : "U32H_FMT"\n", ptr_struct->egress_vlan_membership_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_vlan_membership_low : "U32H_FMT"\n", ptr_struct->egress_vlan_membership_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "loopback_filter_high : "U32H_FMT"\n", ptr_struct->loopback_filter_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "loopback_filter_low  : "U32H_FMT"\n", ptr_struct->loopback_filter_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_general_high  : "U32H_FMT"\n", ptr_struct->egress_general_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_general_low   : "U32H_FMT"\n", ptr_struct->egress_general_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_link_down_high : "U32H_FMT"\n", ptr_struct->egress_link_down_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_link_down_low : "U32H_FMT"\n", ptr_struct->egress_link_down_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_hoq_high      : "U32H_FMT"\n", ptr_struct->egress_hoq_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_hoq_low       : "U32H_FMT"\n", ptr_struct->egress_hoq_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_isolation_high  : "U32H_FMT"\n", ptr_struct->port_isolation_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_isolation_low   : "U32H_FMT"\n", ptr_struct->port_isolation_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_policy_engine_high : "U32H_FMT"\n", ptr_struct->egress_policy_engine_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "egress_policy_engine_low : "U32H_FMT"\n", ptr_struct->egress_policy_engine_low);

}

int connectib_discard_cntrs_grp_data_size(void){
	 return 248;
}

void connectib_discard_cntrs_grp_data_dump(const struct connectib_discard_cntrs_grp_data *ptr_struct, FILE* file) {
	connectib_discard_cntrs_grp_data_print(ptr_struct, file, 0);
}

void connectib_phys_layer_cntrs_pack(const struct connectib_phys_layer_cntrs *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->time_since_last_clear_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->time_since_last_clear_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->symbol_errors_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->symbol_errors_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sync_headers_errors_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sync_headers_errors_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane0_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane0_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane1_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane1_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane2_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane2_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane3_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->edpl_bip_errors_lane3_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane0_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane0_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane1_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane1_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane2_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane2_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane3_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_corrected_blocks_lane3_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane0_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane0_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane1_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane1_low);

	offset=832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane2_high);

	offset=864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane2_low);

	offset=896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane3_high);

	offset=928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fc_fec_uncorrectable_blocks_lane3_low);

	offset=960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_blocks_high);

	offset=992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_blocks_low);

	offset=1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_uncorrectable_blocks_high);

	offset=1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_uncorrectable_blocks_low);

	offset=1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_no_errors_blocks_high);

	offset=1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_no_errors_blocks_low);

	offset=1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_single_error_blocks_high);

	offset=1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_single_error_blocks_low);

	offset=1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_total_high);

	offset=1248;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_total_low);

	offset=1280;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane0_high);

	offset=1312;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane0_low);

	offset=1344;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane1_high);

	offset=1376;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane1_low);

	offset=1408;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane2_high);

	offset=1440;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane2_low);

	offset=1472;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane3_high);

	offset=1504;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rs_fec_corrected_symbols_lane3_low);

	offset=1536;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->link_down_events);

	offset=1568;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->successful_recovery_events);

}

void connectib_phys_layer_cntrs_unpack(struct connectib_phys_layer_cntrs *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->time_since_last_clear_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->time_since_last_clear_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->symbol_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->symbol_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->sync_headers_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->sync_headers_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->edpl_bip_errors_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->edpl_bip_errors_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->edpl_bip_errors_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->edpl_bip_errors_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->edpl_bip_errors_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->edpl_bip_errors_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->edpl_bip_errors_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->edpl_bip_errors_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->fc_fec_corrected_blocks_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->fc_fec_corrected_blocks_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->fc_fec_corrected_blocks_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->fc_fec_corrected_blocks_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->fc_fec_corrected_blocks_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->fc_fec_corrected_blocks_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->fc_fec_corrected_blocks_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->fc_fec_corrected_blocks_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->fc_fec_uncorrectable_blocks_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->fc_fec_uncorrectable_blocks_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->fc_fec_uncorrectable_blocks_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->fc_fec_uncorrectable_blocks_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=832;
	ptr_struct->fc_fec_uncorrectable_blocks_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=864;
	ptr_struct->fc_fec_uncorrectable_blocks_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=896;
	ptr_struct->fc_fec_uncorrectable_blocks_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=928;
	ptr_struct->fc_fec_uncorrectable_blocks_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=960;
	ptr_struct->rs_fec_corrected_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=992;
	ptr_struct->rs_fec_corrected_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1024;
	ptr_struct->rs_fec_uncorrectable_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1056;
	ptr_struct->rs_fec_uncorrectable_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1088;
	ptr_struct->rs_fec_no_errors_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1120;
	ptr_struct->rs_fec_no_errors_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1152;
	ptr_struct->rs_fec_single_error_blocks_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1184;
	ptr_struct->rs_fec_single_error_blocks_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1216;
	ptr_struct->rs_fec_corrected_symbols_total_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1248;
	ptr_struct->rs_fec_corrected_symbols_total_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1280;
	ptr_struct->rs_fec_corrected_symbols_lane0_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1312;
	ptr_struct->rs_fec_corrected_symbols_lane0_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1344;
	ptr_struct->rs_fec_corrected_symbols_lane1_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1376;
	ptr_struct->rs_fec_corrected_symbols_lane1_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1408;
	ptr_struct->rs_fec_corrected_symbols_lane2_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1440;
	ptr_struct->rs_fec_corrected_symbols_lane2_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1472;
	ptr_struct->rs_fec_corrected_symbols_lane3_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1504;
	ptr_struct->rs_fec_corrected_symbols_lane3_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1536;
	ptr_struct->link_down_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1568;
	ptr_struct->successful_recovery_events = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_phys_layer_cntrs_print(const struct connectib_phys_layer_cntrs *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phys_layer_cntrs ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_high : "U32H_FMT"\n", ptr_struct->time_since_last_clear_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_since_last_clear_low : "U32H_FMT"\n", ptr_struct->time_since_last_clear_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_errors_high   : "U32H_FMT"\n", ptr_struct->symbol_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "symbol_errors_low    : "U32H_FMT"\n", ptr_struct->symbol_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_headers_errors_high : "U32H_FMT"\n", ptr_struct->sync_headers_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_headers_errors_low : "U32H_FMT"\n", ptr_struct->sync_headers_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane0_high : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane0_low : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane1_high : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane1_low : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane2_high : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane2_low : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane3_high : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "edpl_bip_errors_lane3_low : "U32H_FMT"\n", ptr_struct->edpl_bip_errors_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane0_high : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane0_low : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane1_high : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane1_low : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane2_high : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane2_low : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane3_high : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_corrected_blocks_lane3_low : "U32H_FMT"\n", ptr_struct->fc_fec_corrected_blocks_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane0_high : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane0_low : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane1_high : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane1_low : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane2_high : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane2_low : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane3_high : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc_fec_uncorrectable_blocks_lane3_low : "U32H_FMT"\n", ptr_struct->fc_fec_uncorrectable_blocks_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_blocks_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_blocks_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_uncorrectable_blocks_high : "U32H_FMT"\n", ptr_struct->rs_fec_uncorrectable_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_uncorrectable_blocks_low : "U32H_FMT"\n", ptr_struct->rs_fec_uncorrectable_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_no_errors_blocks_high : "U32H_FMT"\n", ptr_struct->rs_fec_no_errors_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_no_errors_blocks_low : "U32H_FMT"\n", ptr_struct->rs_fec_no_errors_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_single_error_blocks_high : "U32H_FMT"\n", ptr_struct->rs_fec_single_error_blocks_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_single_error_blocks_low : "U32H_FMT"\n", ptr_struct->rs_fec_single_error_blocks_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_total_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_total_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_total_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_total_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane0_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane0_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane0_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane0_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane1_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane1_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane1_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane1_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane2_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane2_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane2_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane2_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane3_high : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane3_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rs_fec_corrected_symbols_lane3_low : "U32H_FMT"\n", ptr_struct->rs_fec_corrected_symbols_lane3_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_down_events     : "U32H_FMT"\n", ptr_struct->link_down_events);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "successful_recovery_events : "U32H_FMT"\n", ptr_struct->successful_recovery_events);

}

int connectib_phys_layer_cntrs_size(void){
	 return 200;
}

void connectib_phys_layer_cntrs_dump(const struct connectib_phys_layer_cntrs *ptr_struct, FILE* file) {
	connectib_phys_layer_cntrs_print(ptr_struct, file, 0);
}

void connectib_eth_per_traffic_grp_data_layout_pack(const struct connectib_eth_per_traffic_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->transmit_queue_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->transmit_queue_low);

}

void connectib_eth_per_traffic_grp_data_layout_unpack(struct connectib_eth_per_traffic_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->transmit_queue_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->transmit_queue_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_per_traffic_grp_data_layout_print(const struct connectib_eth_per_traffic_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_per_traffic_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transmit_queue_high  : "U32H_FMT"\n", ptr_struct->transmit_queue_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transmit_queue_low   : "U32H_FMT"\n", ptr_struct->transmit_queue_low);

}

int connectib_eth_per_traffic_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_per_traffic_grp_data_layout_dump(const struct connectib_eth_per_traffic_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_per_traffic_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_per_prio_grp_data_layout_pack(const struct connectib_eth_per_prio_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_octets_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_octets_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_frames_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_frames_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_octets_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_octets_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_frames_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_frames_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_duration_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_duration_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_pause_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_pause_low);

	offset=832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_pause_duration_high);

	offset=864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->tx_pause_duration_low);

	offset=896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_transition_high);

	offset=928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rx_pause_transition_low);

}

void connectib_eth_per_prio_grp_data_layout_unpack(struct connectib_eth_per_prio_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rx_octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rx_octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->rx_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->rx_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->tx_octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->tx_octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->tx_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->tx_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->rx_pause_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->rx_pause_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->rx_pause_duration_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->rx_pause_duration_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->tx_pause_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->tx_pause_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=832;
	ptr_struct->tx_pause_duration_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=864;
	ptr_struct->tx_pause_duration_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=896;
	ptr_struct->rx_pause_transition_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=928;
	ptr_struct->rx_pause_transition_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_per_prio_grp_data_layout_print(const struct connectib_eth_per_prio_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_per_prio_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_octets_high       : "U32H_FMT"\n", ptr_struct->rx_octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_octets_low        : "U32H_FMT"\n", ptr_struct->rx_octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_frames_high       : "U32H_FMT"\n", ptr_struct->rx_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_frames_low        : "U32H_FMT"\n", ptr_struct->rx_frames_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_octets_high       : "U32H_FMT"\n", ptr_struct->tx_octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_octets_low        : "U32H_FMT"\n", ptr_struct->tx_octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_frames_high       : "U32H_FMT"\n", ptr_struct->tx_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_frames_low        : "U32H_FMT"\n", ptr_struct->tx_frames_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_high        : "U32H_FMT"\n", ptr_struct->rx_pause_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_low         : "U32H_FMT"\n", ptr_struct->rx_pause_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_duration_high : "U32H_FMT"\n", ptr_struct->rx_pause_duration_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_duration_low : "U32H_FMT"\n", ptr_struct->rx_pause_duration_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pause_high        : "U32H_FMT"\n", ptr_struct->tx_pause_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pause_low         : "U32H_FMT"\n", ptr_struct->tx_pause_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pause_duration_high : "U32H_FMT"\n", ptr_struct->tx_pause_duration_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_pause_duration_low : "U32H_FMT"\n", ptr_struct->tx_pause_duration_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_transition_high : "U32H_FMT"\n", ptr_struct->rx_pause_transition_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_pause_transition_low : "U32H_FMT"\n", ptr_struct->rx_pause_transition_low);

}

int connectib_eth_per_prio_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_per_prio_grp_data_layout_dump(const struct connectib_eth_per_prio_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_per_prio_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_extended_cntrs_grp_data_layout_pack(const struct connectib_eth_extended_cntrs_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_transmit_wait_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_transmit_wait_low);

}

void connectib_eth_extended_cntrs_grp_data_layout_unpack(struct connectib_eth_extended_cntrs_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->port_transmit_wait_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->port_transmit_wait_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_extended_cntrs_grp_data_layout_print(const struct connectib_eth_extended_cntrs_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_extended_cntrs_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_transmit_wait_high : "U32H_FMT"\n", ptr_struct->port_transmit_wait_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_transmit_wait_low : "U32H_FMT"\n", ptr_struct->port_transmit_wait_low);

}

int connectib_eth_extended_cntrs_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_extended_cntrs_grp_data_layout_dump(const struct connectib_eth_extended_cntrs_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_extended_cntrs_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_3635_cntrs_grp_data_layout_pack(const struct connectib_eth_3635_cntrs_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_alignment_errors_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_alignment_errors_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_fcs_errors_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_fcs_errors_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_single_collision_frames_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_single_collision_frames_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_multiple_collision_frames_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_multiple_collision_frames_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_sqe_test_errors_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_sqe_test_errors_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_deferred_transmissions_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_deferred_transmissions_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_late_collisions_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_late_collisions_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_excessive_collisions_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_excessive_collisions_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_internal_mac_transmit_errors_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_internal_mac_transmit_errors_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_carrier_sense_errors_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_carrier_sense_errors_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_frame_too_longs_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_frame_too_longs_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_internal_mac_receive_errors_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_internal_mac_receive_errors_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_symbol_errors_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3stats_symbol_errors_low);

	offset=832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3control_in_unknown_opcodes_high);

	offset=864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3control_in_unknown_opcodes_low);

	offset=896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3in_pause_frames_high);

	offset=928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3in_pause_frames_low);

	offset=960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3out_pause_frames_high);

	offset=992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dot3out_pause_frames_low);

}

void connectib_eth_3635_cntrs_grp_data_layout_unpack(struct connectib_eth_3635_cntrs_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dot3stats_alignment_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->dot3stats_alignment_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->dot3stats_fcs_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->dot3stats_fcs_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->dot3stats_single_collision_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->dot3stats_single_collision_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->dot3stats_multiple_collision_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->dot3stats_multiple_collision_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->dot3stats_sqe_test_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->dot3stats_sqe_test_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->dot3stats_deferred_transmissions_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->dot3stats_deferred_transmissions_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->dot3stats_late_collisions_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->dot3stats_late_collisions_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->dot3stats_excessive_collisions_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->dot3stats_excessive_collisions_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->dot3stats_internal_mac_transmit_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->dot3stats_internal_mac_transmit_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->dot3stats_carrier_sense_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->dot3stats_carrier_sense_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->dot3stats_frame_too_longs_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->dot3stats_frame_too_longs_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->dot3stats_internal_mac_receive_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->dot3stats_internal_mac_receive_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->dot3stats_symbol_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->dot3stats_symbol_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=832;
	ptr_struct->dot3control_in_unknown_opcodes_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=864;
	ptr_struct->dot3control_in_unknown_opcodes_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=896;
	ptr_struct->dot3in_pause_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=928;
	ptr_struct->dot3in_pause_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=960;
	ptr_struct->dot3out_pause_frames_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=992;
	ptr_struct->dot3out_pause_frames_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_3635_cntrs_grp_data_layout_print(const struct connectib_eth_3635_cntrs_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_3635_cntrs_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_alignment_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_alignment_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_alignment_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_alignment_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_fcs_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_fcs_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_fcs_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_fcs_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_single_collision_frames_high : "U32H_FMT"\n", ptr_struct->dot3stats_single_collision_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_single_collision_frames_low : "U32H_FMT"\n", ptr_struct->dot3stats_single_collision_frames_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_multiple_collision_frames_high : "U32H_FMT"\n", ptr_struct->dot3stats_multiple_collision_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_multiple_collision_frames_low : "U32H_FMT"\n", ptr_struct->dot3stats_multiple_collision_frames_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_sqe_test_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_sqe_test_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_sqe_test_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_sqe_test_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_deferred_transmissions_high : "U32H_FMT"\n", ptr_struct->dot3stats_deferred_transmissions_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_deferred_transmissions_low : "U32H_FMT"\n", ptr_struct->dot3stats_deferred_transmissions_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_late_collisions_high : "U32H_FMT"\n", ptr_struct->dot3stats_late_collisions_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_late_collisions_low : "U32H_FMT"\n", ptr_struct->dot3stats_late_collisions_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_excessive_collisions_high : "U32H_FMT"\n", ptr_struct->dot3stats_excessive_collisions_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_excessive_collisions_low : "U32H_FMT"\n", ptr_struct->dot3stats_excessive_collisions_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_internal_mac_transmit_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_internal_mac_transmit_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_internal_mac_transmit_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_internal_mac_transmit_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_carrier_sense_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_carrier_sense_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_carrier_sense_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_carrier_sense_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_frame_too_longs_high : "U32H_FMT"\n", ptr_struct->dot3stats_frame_too_longs_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_frame_too_longs_low : "U32H_FMT"\n", ptr_struct->dot3stats_frame_too_longs_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_internal_mac_receive_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_internal_mac_receive_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_internal_mac_receive_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_internal_mac_receive_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_symbol_errors_high : "U32H_FMT"\n", ptr_struct->dot3stats_symbol_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3stats_symbol_errors_low : "U32H_FMT"\n", ptr_struct->dot3stats_symbol_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3control_in_unknown_opcodes_high : "U32H_FMT"\n", ptr_struct->dot3control_in_unknown_opcodes_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3control_in_unknown_opcodes_low : "U32H_FMT"\n", ptr_struct->dot3control_in_unknown_opcodes_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3in_pause_frames_high : "U32H_FMT"\n", ptr_struct->dot3in_pause_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3in_pause_frames_low : "U32H_FMT"\n", ptr_struct->dot3in_pause_frames_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3out_pause_frames_high : "U32H_FMT"\n", ptr_struct->dot3out_pause_frames_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dot3out_pause_frames_low : "U32H_FMT"\n", ptr_struct->dot3out_pause_frames_low);

}

int connectib_eth_3635_cntrs_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_3635_cntrs_grp_data_layout_dump(const struct connectib_eth_3635_cntrs_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_3635_cntrs_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_2819_cntrs_grp_data_layout_pack(const struct connectib_eth_2819_cntrs_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_drop_events_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_drop_events_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_octets_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_octets_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_broadcast_pkts_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_broadcast_pkts_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_multicast_pkts_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_multicast_pkts_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_crc_align_errors_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_crc_align_errors_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_undersize_pkts_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_undersize_pkts_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_oversize_pkts_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_oversize_pkts_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_fragments_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_fragments_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_jabbers_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_jabbers_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_collisions_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_collisions_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts64octets_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts64octets_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts65to127octets_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts65to127octets_low);

	offset=832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts128to255octets_high);

	offset=864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts128to255octets_low);

	offset=896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts256to511octets_high);

	offset=928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts256to511octets_low);

	offset=960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts512to1023octets_high);

	offset=992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts512to1023octets_low);

	offset=1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts1024to1518octets_high);

	offset=1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts1024to1518octets_low);

	offset=1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts1519to2047octets_high);

	offset=1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts1519to2047octets_low);

	offset=1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts2048to4095octets_high);

	offset=1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts2048to4095octets_low);

	offset=1216;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts4096to8191octets_high);

	offset=1248;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts4096to8191octets_low);

	offset=1280;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts8192to10239octets_high);

	offset=1312;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ether_stats_pkts8192to10239octets_low);

}

void connectib_eth_2819_cntrs_grp_data_layout_unpack(struct connectib_eth_2819_cntrs_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->ether_stats_drop_events_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->ether_stats_drop_events_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->ether_stats_octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->ether_stats_octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->ether_stats_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->ether_stats_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->ether_stats_broadcast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->ether_stats_broadcast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->ether_stats_multicast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->ether_stats_multicast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->ether_stats_crc_align_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->ether_stats_crc_align_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->ether_stats_undersize_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->ether_stats_undersize_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->ether_stats_oversize_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->ether_stats_oversize_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->ether_stats_fragments_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->ether_stats_fragments_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->ether_stats_jabbers_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->ether_stats_jabbers_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->ether_stats_collisions_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->ether_stats_collisions_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->ether_stats_pkts64octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->ether_stats_pkts64octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->ether_stats_pkts65to127octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->ether_stats_pkts65to127octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=832;
	ptr_struct->ether_stats_pkts128to255octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=864;
	ptr_struct->ether_stats_pkts128to255octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=896;
	ptr_struct->ether_stats_pkts256to511octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=928;
	ptr_struct->ether_stats_pkts256to511octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=960;
	ptr_struct->ether_stats_pkts512to1023octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=992;
	ptr_struct->ether_stats_pkts512to1023octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1024;
	ptr_struct->ether_stats_pkts1024to1518octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1056;
	ptr_struct->ether_stats_pkts1024to1518octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1088;
	ptr_struct->ether_stats_pkts1519to2047octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1120;
	ptr_struct->ether_stats_pkts1519to2047octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1152;
	ptr_struct->ether_stats_pkts2048to4095octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1184;
	ptr_struct->ether_stats_pkts2048to4095octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1216;
	ptr_struct->ether_stats_pkts4096to8191octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1248;
	ptr_struct->ether_stats_pkts4096to8191octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1280;
	ptr_struct->ether_stats_pkts8192to10239octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1312;
	ptr_struct->ether_stats_pkts8192to10239octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_2819_cntrs_grp_data_layout_print(const struct connectib_eth_2819_cntrs_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_2819_cntrs_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_drop_events_high : "U32H_FMT"\n", ptr_struct->ether_stats_drop_events_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_drop_events_low : "U32H_FMT"\n", ptr_struct->ether_stats_drop_events_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_broadcast_pkts_high : "U32H_FMT"\n", ptr_struct->ether_stats_broadcast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_broadcast_pkts_low : "U32H_FMT"\n", ptr_struct->ether_stats_broadcast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_multicast_pkts_high : "U32H_FMT"\n", ptr_struct->ether_stats_multicast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_multicast_pkts_low : "U32H_FMT"\n", ptr_struct->ether_stats_multicast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_crc_align_errors_high : "U32H_FMT"\n", ptr_struct->ether_stats_crc_align_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_crc_align_errors_low : "U32H_FMT"\n", ptr_struct->ether_stats_crc_align_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_undersize_pkts_high : "U32H_FMT"\n", ptr_struct->ether_stats_undersize_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_undersize_pkts_low : "U32H_FMT"\n", ptr_struct->ether_stats_undersize_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_oversize_pkts_high : "U32H_FMT"\n", ptr_struct->ether_stats_oversize_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_oversize_pkts_low : "U32H_FMT"\n", ptr_struct->ether_stats_oversize_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_fragments_high : "U32H_FMT"\n", ptr_struct->ether_stats_fragments_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_fragments_low : "U32H_FMT"\n", ptr_struct->ether_stats_fragments_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_jabbers_high : "U32H_FMT"\n", ptr_struct->ether_stats_jabbers_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_jabbers_low : "U32H_FMT"\n", ptr_struct->ether_stats_jabbers_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_collisions_high : "U32H_FMT"\n", ptr_struct->ether_stats_collisions_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_collisions_low : "U32H_FMT"\n", ptr_struct->ether_stats_collisions_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts64octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts64octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts64octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts64octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts65to127octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts65to127octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts65to127octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts65to127octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts128to255octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts128to255octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts128to255octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts128to255octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts256to511octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts256to511octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts256to511octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts256to511octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts512to1023octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts512to1023octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts512to1023octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts512to1023octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts1024to1518octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts1024to1518octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts1024to1518octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts1024to1518octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts1519to2047octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts1519to2047octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts1519to2047octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts1519to2047octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts2048to4095octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts2048to4095octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts2048to4095octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts2048to4095octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts4096to8191octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts4096to8191octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts4096to8191octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts4096to8191octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts8192to10239octets_high : "U32H_FMT"\n", ptr_struct->ether_stats_pkts8192to10239octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ether_stats_pkts8192to10239octets_low : "U32H_FMT"\n", ptr_struct->ether_stats_pkts8192to10239octets_low);

}

int connectib_eth_2819_cntrs_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_2819_cntrs_grp_data_layout_dump(const struct connectib_eth_2819_cntrs_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_2819_cntrs_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_2863_cntrs_grp_data_layout_pack(const struct connectib_eth_2863_cntrs_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_octets_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_octets_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_ucast_pkts_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_ucast_pkts_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_discards_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_discards_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_errors_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_errors_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_unknown_protos_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_unknown_protos_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_octets_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_octets_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_ucast_pkts_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_ucast_pkts_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_discards_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_discards_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_errors_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_errors_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_multicast_pkts_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_multicast_pkts_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_broadcast_pkts_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_in_broadcast_pkts_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_multicast_pkts_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_multicast_pkts_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_broadcast_pkts_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->if_out_broadcast_pkts_low);

}

void connectib_eth_2863_cntrs_grp_data_layout_unpack(struct connectib_eth_2863_cntrs_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->if_in_octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->if_in_octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->if_in_ucast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->if_in_ucast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->if_in_discards_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->if_in_discards_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->if_in_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->if_in_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->if_in_unknown_protos_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->if_in_unknown_protos_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->if_out_octets_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->if_out_octets_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->if_out_ucast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->if_out_ucast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->if_out_discards_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->if_out_discards_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->if_out_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->if_out_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->if_in_multicast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->if_in_multicast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->if_in_broadcast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->if_in_broadcast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->if_out_multicast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->if_out_multicast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->if_out_broadcast_pkts_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->if_out_broadcast_pkts_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_2863_cntrs_grp_data_layout_print(const struct connectib_eth_2863_cntrs_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_2863_cntrs_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_octets_high    : "U32H_FMT"\n", ptr_struct->if_in_octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_octets_low     : "U32H_FMT"\n", ptr_struct->if_in_octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_ucast_pkts_high : "U32H_FMT"\n", ptr_struct->if_in_ucast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_ucast_pkts_low : "U32H_FMT"\n", ptr_struct->if_in_ucast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_discards_high  : "U32H_FMT"\n", ptr_struct->if_in_discards_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_discards_low   : "U32H_FMT"\n", ptr_struct->if_in_discards_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_errors_high    : "U32H_FMT"\n", ptr_struct->if_in_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_errors_low     : "U32H_FMT"\n", ptr_struct->if_in_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_unknown_protos_high : "U32H_FMT"\n", ptr_struct->if_in_unknown_protos_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_unknown_protos_low : "U32H_FMT"\n", ptr_struct->if_in_unknown_protos_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_octets_high   : "U32H_FMT"\n", ptr_struct->if_out_octets_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_octets_low    : "U32H_FMT"\n", ptr_struct->if_out_octets_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_ucast_pkts_high : "U32H_FMT"\n", ptr_struct->if_out_ucast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_ucast_pkts_low : "U32H_FMT"\n", ptr_struct->if_out_ucast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_discards_high : "U32H_FMT"\n", ptr_struct->if_out_discards_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_discards_low  : "U32H_FMT"\n", ptr_struct->if_out_discards_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_errors_high   : "U32H_FMT"\n", ptr_struct->if_out_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_errors_low    : "U32H_FMT"\n", ptr_struct->if_out_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_multicast_pkts_high : "U32H_FMT"\n", ptr_struct->if_in_multicast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_multicast_pkts_low : "U32H_FMT"\n", ptr_struct->if_in_multicast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_broadcast_pkts_high : "U32H_FMT"\n", ptr_struct->if_in_broadcast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_in_broadcast_pkts_low : "U32H_FMT"\n", ptr_struct->if_in_broadcast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_multicast_pkts_high : "U32H_FMT"\n", ptr_struct->if_out_multicast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_multicast_pkts_low : "U32H_FMT"\n", ptr_struct->if_out_multicast_pkts_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_broadcast_pkts_high : "U32H_FMT"\n", ptr_struct->if_out_broadcast_pkts_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "if_out_broadcast_pkts_low : "U32H_FMT"\n", ptr_struct->if_out_broadcast_pkts_low);

}

int connectib_eth_2863_cntrs_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_2863_cntrs_grp_data_layout_dump(const struct connectib_eth_2863_cntrs_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_2863_cntrs_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_eth_802_3_cntrs_grp_data_layout_pack(const struct connectib_eth_802_3_cntrs_grp_data_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frames_transmitted_ok_high);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frames_transmitted_ok_low);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frames_received_ok_high);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frames_received_ok_low);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frame_check_sequence_errors_high);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frame_check_sequence_errors_low);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_alignment_errors_high);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_alignment_errors_low);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_octets_transmitted_ok_high);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_octets_transmitted_ok_low);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_octets_received_ok_high);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_octets_received_ok_low);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_multicast_frames_xmitted_ok_high);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_multicast_frames_xmitted_ok_low);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_broadcast_frames_xmitted_ok_high);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_broadcast_frames_xmitted_ok_low);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_multicast_frames_received_ok_high);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_multicast_frames_received_ok_low);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_broadcast_frames_recieved_ok_high);

	offset=608;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_broadcast_frames_recieved_ok_low);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_in_range_length_errors_high);

	offset=672;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_in_range_length_errors_low);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_out_of_range_length_field_high);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_out_of_range_length_field_low);

	offset=768;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frame_too_long_errors_high);

	offset=800;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_frame_too_long_errors_low);

	offset=832;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_symbol_error_during_carrier_high);

	offset=864;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_symbol_error_during_carrier_low);

	offset=896;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_mac_control_frames_transmitted_high);

	offset=928;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_mac_control_frames_transmitted_low);

	offset=960;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_mac_control_frames_received_high);

	offset=992;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_mac_control_frames_received_low);

	offset=1024;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_unsupported_opcodes_received_high);

	offset=1056;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_unsupported_opcodes_received_low);

	offset=1088;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_pause_mac_ctrl_frames_received_high);

	offset=1120;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_pause_mac_ctrl_frames_received_low);

	offset=1152;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_pause_mac_ctrl_frames_transmitted_high);

	offset=1184;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->a_pause_mac_ctrl_frames_transmitted_low);

}

void connectib_eth_802_3_cntrs_grp_data_layout_unpack(struct connectib_eth_802_3_cntrs_grp_data_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->a_frames_transmitted_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->a_frames_transmitted_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->a_frames_received_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->a_frames_received_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->a_frame_check_sequence_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->a_frame_check_sequence_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->a_alignment_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->a_alignment_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->a_octets_transmitted_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->a_octets_transmitted_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->a_octets_received_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->a_octets_received_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->a_multicast_frames_xmitted_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->a_multicast_frames_xmitted_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->a_broadcast_frames_xmitted_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->a_broadcast_frames_xmitted_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->a_multicast_frames_received_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->a_multicast_frames_received_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->a_broadcast_frames_recieved_ok_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=608;
	ptr_struct->a_broadcast_frames_recieved_ok_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=640;
	ptr_struct->a_in_range_length_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=672;
	ptr_struct->a_in_range_length_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->a_out_of_range_length_field_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->a_out_of_range_length_field_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	ptr_struct->a_frame_too_long_errors_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=800;
	ptr_struct->a_frame_too_long_errors_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=832;
	ptr_struct->a_symbol_error_during_carrier_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=864;
	ptr_struct->a_symbol_error_during_carrier_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=896;
	ptr_struct->a_mac_control_frames_transmitted_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=928;
	ptr_struct->a_mac_control_frames_transmitted_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=960;
	ptr_struct->a_mac_control_frames_received_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=992;
	ptr_struct->a_mac_control_frames_received_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1024;
	ptr_struct->a_unsupported_opcodes_received_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1056;
	ptr_struct->a_unsupported_opcodes_received_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1088;
	ptr_struct->a_pause_mac_ctrl_frames_received_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1120;
	ptr_struct->a_pause_mac_ctrl_frames_received_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1152;
	ptr_struct->a_pause_mac_ctrl_frames_transmitted_high = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=1184;
	ptr_struct->a_pause_mac_ctrl_frames_transmitted_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_eth_802_3_cntrs_grp_data_layout_print(const struct connectib_eth_802_3_cntrs_grp_data_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_802_3_cntrs_grp_data_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frames_transmitted_ok_high : "U32H_FMT"\n", ptr_struct->a_frames_transmitted_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frames_transmitted_ok_low : "U32H_FMT"\n", ptr_struct->a_frames_transmitted_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frames_received_ok_high : "U32H_FMT"\n", ptr_struct->a_frames_received_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frames_received_ok_low : "U32H_FMT"\n", ptr_struct->a_frames_received_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frame_check_sequence_errors_high : "U32H_FMT"\n", ptr_struct->a_frame_check_sequence_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frame_check_sequence_errors_low : "U32H_FMT"\n", ptr_struct->a_frame_check_sequence_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_alignment_errors_high : "U32H_FMT"\n", ptr_struct->a_alignment_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_alignment_errors_low : "U32H_FMT"\n", ptr_struct->a_alignment_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_octets_transmitted_ok_high : "U32H_FMT"\n", ptr_struct->a_octets_transmitted_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_octets_transmitted_ok_low : "U32H_FMT"\n", ptr_struct->a_octets_transmitted_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_octets_received_ok_high : "U32H_FMT"\n", ptr_struct->a_octets_received_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_octets_received_ok_low : "U32H_FMT"\n", ptr_struct->a_octets_received_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_multicast_frames_xmitted_ok_high : "U32H_FMT"\n", ptr_struct->a_multicast_frames_xmitted_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_multicast_frames_xmitted_ok_low : "U32H_FMT"\n", ptr_struct->a_multicast_frames_xmitted_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_broadcast_frames_xmitted_ok_high : "U32H_FMT"\n", ptr_struct->a_broadcast_frames_xmitted_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_broadcast_frames_xmitted_ok_low : "U32H_FMT"\n", ptr_struct->a_broadcast_frames_xmitted_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_multicast_frames_received_ok_high : "U32H_FMT"\n", ptr_struct->a_multicast_frames_received_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_multicast_frames_received_ok_low : "U32H_FMT"\n", ptr_struct->a_multicast_frames_received_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_broadcast_frames_recieved_ok_high : "U32H_FMT"\n", ptr_struct->a_broadcast_frames_recieved_ok_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_broadcast_frames_recieved_ok_low : "U32H_FMT"\n", ptr_struct->a_broadcast_frames_recieved_ok_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_in_range_length_errors_high : "U32H_FMT"\n", ptr_struct->a_in_range_length_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_in_range_length_errors_low : "U32H_FMT"\n", ptr_struct->a_in_range_length_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_out_of_range_length_field_high : "U32H_FMT"\n", ptr_struct->a_out_of_range_length_field_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_out_of_range_length_field_low : "U32H_FMT"\n", ptr_struct->a_out_of_range_length_field_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frame_too_long_errors_high : "U32H_FMT"\n", ptr_struct->a_frame_too_long_errors_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_frame_too_long_errors_low : "U32H_FMT"\n", ptr_struct->a_frame_too_long_errors_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_symbol_error_during_carrier_high : "U32H_FMT"\n", ptr_struct->a_symbol_error_during_carrier_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_symbol_error_during_carrier_low : "U32H_FMT"\n", ptr_struct->a_symbol_error_during_carrier_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_mac_control_frames_transmitted_high : "U32H_FMT"\n", ptr_struct->a_mac_control_frames_transmitted_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_mac_control_frames_transmitted_low : "U32H_FMT"\n", ptr_struct->a_mac_control_frames_transmitted_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_mac_control_frames_received_high : "U32H_FMT"\n", ptr_struct->a_mac_control_frames_received_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_mac_control_frames_received_low : "U32H_FMT"\n", ptr_struct->a_mac_control_frames_received_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_unsupported_opcodes_received_high : "U32H_FMT"\n", ptr_struct->a_unsupported_opcodes_received_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_unsupported_opcodes_received_low : "U32H_FMT"\n", ptr_struct->a_unsupported_opcodes_received_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_pause_mac_ctrl_frames_received_high : "U32H_FMT"\n", ptr_struct->a_pause_mac_ctrl_frames_received_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_pause_mac_ctrl_frames_received_low : "U32H_FMT"\n", ptr_struct->a_pause_mac_ctrl_frames_received_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_pause_mac_ctrl_frames_transmitted_high : "U32H_FMT"\n", ptr_struct->a_pause_mac_ctrl_frames_transmitted_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a_pause_mac_ctrl_frames_transmitted_low : "U32H_FMT"\n", ptr_struct->a_pause_mac_ctrl_frames_transmitted_low);

}

int connectib_eth_802_3_cntrs_grp_data_layout_size(void){
	 return 248;
}

void connectib_eth_802_3_cntrs_grp_data_layout_dump(const struct connectib_eth_802_3_cntrs_grp_data_layout *ptr_struct, FILE* file) {
	connectib_eth_802_3_cntrs_grp_data_layout_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_special_pack(const union connectib_cmdif_ctx_special *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_cmdif_ctx_dmfs_pack(&(ptr_struct->dmfs), ptr_buff);
}

void connectib_cmdif_ctx_special_unpack(union connectib_cmdif_ctx_special *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_cmdif_ctx_dmfs_unpack(&(ptr_struct->dmfs), ptr_buff);
}

void connectib_cmdif_ctx_special_print(const union connectib_cmdif_ctx_special *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx_special ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c:\n");
	connectib_cmdif_ctx_special_create_print(&(ptr_struct->c), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tir:\n");
	connectib_cmdif_ctx_special_modify_tir_print(&(ptr_struct->tir), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp:\n");
	connectib_cmdif_ctx_special_create_qp_print(&(ptr_struct->qp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rq:\n");
	connectib_cmdif_ctx_special_create_rq_print(&(ptr_struct->rq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq:\n");
	connectib_cmdif_ctx_special_create_srq_print(&(ptr_struct->srq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt:\n");
	connectib_cmdif_ctx_rqt_print(&(ptr_struct->rqt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eq:\n");
	connectib_cmdif_ctx_special_create_eq_print(&(ptr_struct->eq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c_cq:\n");
	connectib_cmdif_ctx_special_create_cq_print(&(ptr_struct->c_cq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_cq:\n");
	connectib_cmdif_ctx_special_modify_cq_print(&(ptr_struct->m_cq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mkey:\n");
	connectib_cmdif_ctx_special_mkey_print(&(ptr_struct->mkey), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "arm_rq:\n");
	connectib_cmdif_ctx_special_arm_rq_print(&(ptr_struct->arm_rq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modify_rmp:\n");
	connectib_cmdif_ctx_special_modify_rmp_print(&(ptr_struct->modify_rmp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sniffer:\n");
	connectib_cmdif_ctx_sniffer_print(&(ptr_struct->sniffer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mcg:\n");
	connectib_cmdif_ctx_mcg_print(&(ptr_struct->mcg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psv:\n");
	connectib_cmdif_ctx_psv_print(&(ptr_struct->psv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt:\n");
	connectib_cmdif_ctx_create_mtt_print(&(ptr_struct->mtt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmfs:\n");
	connectib_cmdif_ctx_dmfs_print(&(ptr_struct->dmfs), file, indent_level + 1);

}

int connectib_cmdif_ctx_special_size(void){
	 return 32;
}

void connectib_cmdif_ctx_special_dump(const union connectib_cmdif_ctx_special *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_special_print(ptr_struct, file, 0);
}

void connectib_flush_type_pack(const union connectib_flush_type *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_flush_type_bitmask_pack(&(ptr_struct->bitmask), ptr_buff);
}

void connectib_flush_type_unpack(union connectib_flush_type *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_flush_type_bitmask_unpack(&(ptr_struct->bitmask), ptr_buff);
}

void connectib_flush_type_print(const union connectib_flush_type *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_flush_type ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bits:\n");
	connectib_flush_type_bits_print(&(ptr_struct->bits), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bitmask:\n");
	connectib_flush_type_bitmask_print(&(ptr_struct->bitmask), file, indent_level + 1);

}

int connectib_flush_type_size(void){
	 return 4;
}

void connectib_flush_type_dump(const union connectib_flush_type *ptr_struct, FILE* file) {
	connectib_flush_type_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_flat_data_pack(const struct connectib_sw_eqe_flat_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 7; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 224, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

}

void connectib_sw_eqe_flat_data_unpack(struct connectib_sw_eqe_flat_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 7; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 224, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_sw_eqe_flat_data_print(const struct connectib_sw_eqe_flat_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe_flat_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 7; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

}

int connectib_sw_eqe_flat_data_size(void){
	 return 28;
}

void connectib_sw_eqe_flat_data_dump(const struct connectib_sw_eqe_flat_data *ptr_struct, FILE* file) {
	connectib_sw_eqe_flat_data_print(ptr_struct, file, 0);
}

void connectib_db_bf_congestion_event_pack(const struct connectib_db_bf_congestion_event *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->congestion_level);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->event_subtype);

}

void connectib_db_bf_congestion_event_unpack(struct connectib_db_bf_congestion_event *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->congestion_level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->event_subtype = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_db_bf_congestion_event_print(const struct connectib_db_bf_congestion_event *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_db_bf_congestion_event ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "congestion_level     : "UH_FMT"\n", ptr_struct->congestion_level);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_subtype        : "UH_FMT"\n", ptr_struct->event_subtype);

}

int connectib_db_bf_congestion_event_size(void){
	 return 24;
}

void connectib_db_bf_congestion_event_dump(const struct connectib_db_bf_congestion_event *ptr_struct, FILE* file) {
	connectib_db_bf_congestion_event_print(ptr_struct, file, 0);
}

void connectib_rdma_page_fault_event_pack(const struct connectib_rdma_page_fault_event *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->bytes_committed);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->r_key);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->packet_len);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rdma_op_len);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rdma_va_hi);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rdma_va_lo);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=199;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->requestor);

	offset=198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_read_);

	offset=197;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rdma);

}

void connectib_rdma_page_fault_event_unpack(struct connectib_rdma_page_fault_event *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->bytes_committed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->r_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->packet_len = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rdma_op_len = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->rdma_va_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->rdma_va_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=200;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=199;
	ptr_struct->requestor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=198;
	ptr_struct->write_read_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=197;
	ptr_struct->rdma = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_rdma_page_fault_event_print(const struct connectib_rdma_page_fault_event *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rdma_page_fault_event ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bytes_committed      : "U32H_FMT"\n", ptr_struct->bytes_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r_key                : "U32H_FMT"\n", ptr_struct->r_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_len           : "UH_FMT"\n", ptr_struct->packet_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma_op_len          : "U32H_FMT"\n", ptr_struct->rdma_op_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma_va_hi           : "U32H_FMT"\n", ptr_struct->rdma_va_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma_va_lo           : "U32H_FMT"\n", ptr_struct->rdma_va_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requestor            : "UH_FMT"\n", ptr_struct->requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_read_          : "UH_FMT"\n", ptr_struct->write_read_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma                 : "UH_FMT"\n", ptr_struct->rdma);

}

int connectib_rdma_page_fault_event_size(void){
	 return 28;
}

void connectib_rdma_page_fault_event_dump(const struct connectib_rdma_page_fault_event *ptr_struct, FILE* file) {
	connectib_rdma_page_fault_event_print(ptr_struct, file, 0);
}

void connectib_wqe_page_fault_event_pack(const struct connectib_wqe_page_fault_event *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->bytes_committed);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wqe_index);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->packet_len);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=199;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->req_res_);

	offset=198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->write_read_);

	offset=197;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rdma);

}

void connectib_wqe_page_fault_event_unpack(struct connectib_wqe_page_fault_event *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->bytes_committed = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=48;
	ptr_struct->wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=80;
	ptr_struct->packet_len = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=200;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=199;
	ptr_struct->req_res_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=198;
	ptr_struct->write_read_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=197;
	ptr_struct->rdma = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_wqe_page_fault_event_print(const struct connectib_wqe_page_fault_event *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_page_fault_event ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bytes_committed      : "U32H_FMT"\n", ptr_struct->bytes_committed);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_index            : "UH_FMT"\n", ptr_struct->wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_len           : "UH_FMT"\n", ptr_struct->packet_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_res_             : "UH_FMT"\n", ptr_struct->req_res_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_read_          : "UH_FMT"\n", ptr_struct->write_read_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma                 : "UH_FMT"\n", ptr_struct->rdma);

}

int connectib_wqe_page_fault_event_size(void){
	 return 28;
}

void connectib_wqe_page_fault_event_dump(const struct connectib_wqe_page_fault_event *ptr_struct, FILE* file) {
	connectib_wqe_page_fault_event_print(ptr_struct, file, 0);
}

void connectib_page_request_event_pack(const struct connectib_page_request_event *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->function_id);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_pages);

}

void connectib_page_request_event_unpack(struct connectib_page_request_event *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->function_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->num_pages = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_page_request_event_print(const struct connectib_page_request_event *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_page_request_event ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "function_id          : "UH_FMT"\n", ptr_struct->function_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_pages            : "U32H_FMT"\n", ptr_struct->num_pages);

}

int connectib_page_request_event_size(void){
	 return 28;
}

void connectib_page_request_event_dump(const struct connectib_page_request_event *ptr_struct, FILE* file) {
	connectib_page_request_event_print(ptr_struct, file, 0);
}

void connectib_port_state_change_event_pack(const struct connectib_port_state_change_event *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port_num);

}

void connectib_port_state_change_event_unpack(struct connectib_port_state_change_event *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=64;
	ptr_struct->port_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_port_state_change_event_print(const struct connectib_port_state_change_event *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_state_change_event ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_num             : "UH_FMT"\n", ptr_struct->port_num);

}

int connectib_port_state_change_event_size(void){
	 return 28;
}

void connectib_port_state_change_event_dump(const struct connectib_port_state_change_event *ptr_struct, FILE* file) {
	connectib_port_state_change_event_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_qp_data_pack(const struct connectib_sw_eqe_qp_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

}

void connectib_sw_eqe_qp_data_unpack(struct connectib_sw_eqe_qp_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=200;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_sw_eqe_qp_data_print(const struct connectib_sw_eqe_qp_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe_qp_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

}

int connectib_sw_eqe_qp_data_size(void){
	 return 28;
}

void connectib_sw_eqe_qp_data_dump(const struct connectib_sw_eqe_qp_data *ptr_struct, FILE* file) {
	connectib_sw_eqe_qp_data_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_error_data_pack(const struct connectib_sw_eqe_error_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cqn);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrome);

}

void connectib_sw_eqe_error_data_unpack(struct connectib_sw_eqe_error_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->cqn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=88;
	ptr_struct->syndrome = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_sw_eqe_error_data_print(const struct connectib_sw_eqe_error_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe_error_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqn                  : "UH_FMT"\n", ptr_struct->cqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrome             : "UH_FMT"\n", ptr_struct->syndrome);

}

int connectib_sw_eqe_error_data_size(void){
	 return 28;
}

void connectib_sw_eqe_error_data_dump(const struct connectib_sw_eqe_error_data *ptr_struct, FILE* file) {
	connectib_sw_eqe_error_data_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_cq_data_pack(const struct connectib_sw_eqe_cq_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cqn);

}

void connectib_sw_eqe_cq_data_unpack(struct connectib_sw_eqe_cq_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=200;
	ptr_struct->cqn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_sw_eqe_cq_data_print(const struct connectib_sw_eqe_cq_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe_cq_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqn                  : "UH_FMT"\n", ptr_struct->cqn);

}

int connectib_sw_eqe_cq_data_size(void){
	 return 28;
}

void connectib_sw_eqe_cq_data_dump(const struct connectib_sw_eqe_cq_data *ptr_struct, FILE* file) {
	connectib_sw_eqe_cq_data_print(ptr_struct, file, 0);
}

void connectib_reg_access_reg_tlv_data_pack(const union connectib_reg_access_reg_tlv_data *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_project_nvqc_pack(&(ptr_struct->nvqc), ptr_buff);
}

void connectib_reg_access_reg_tlv_data_unpack(union connectib_reg_access_reg_tlv_data *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_project_nvqc_unpack(&(ptr_struct->nvqc), ptr_buff);
}

void connectib_reg_access_reg_tlv_data_print(const union connectib_reg_access_reg_tlv_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_reg_tlv_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfpa:\n");
	connectib_mfpa_print(&(ptr_struct->mfpa), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfai:\n");
	connectib_register_mfai_print(&(ptr_struct->mfai), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfrl:\n");
	connectib_register_mfrl_print(&(ptr_struct->mfrl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtmp:\n");
	connectib_mtmp_print(&(ptr_struct->mtmp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "misc_counters:\n");
	connectib_register_misc_counters_print(&(ptr_struct->misc_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfba:\n");
	connectib_project_mfba_print(&(ptr_struct->mfba), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfbe:\n");
	connectib_mfbe_print(&(ptr_struct->mfbe), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mjtag:\n");
	connectib_mjtag_print(&(ptr_struct->mjtag), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "paos:\n");
	connectib_paos_reg_print(&(ptr_struct->paos), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp:\n");
	connectib_slrp_reg_print(&(ptr_struct->slrp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp:\n");
	connectib_sltp_reg_print(&(ptr_struct->sltp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptas:\n");
	connectib_ptas_reg_print(&(ptr_struct->ptas), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg:\n");
	connectib_slrg_reg_print(&(ptr_struct->slrg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppamp:\n");
	connectib_pamp_reg_print(&(ptr_struct->ppamp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmtu:\n");
	connectib_pmtu_reg_print(&(ptr_struct->pmtu), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvda:\n");
	connectib_project_nvda_print(&(ptr_struct->nvda), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvdi:\n");
	connectib_nv_tlv_hdr_print(&(ptr_struct->nvdi), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nvqc:\n");
	connectib_project_nvqc_print(&(ptr_struct->nvqc), file, indent_level + 1);

}

int connectib_reg_access_reg_tlv_data_size(void){
	 return 44;
}

void connectib_reg_access_reg_tlv_data_dump(const union connectib_reg_access_reg_tlv_data *ptr_struct, FILE* file) {
	connectib_reg_access_reg_tlv_data_print(ptr_struct, file, 0);
}

void connectib_reg_access_tlv_pack(const struct connectib_reg_access_tlv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->len);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->type);

}

void connectib_reg_access_tlv_unpack(struct connectib_reg_access_tlv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=5;
	ptr_struct->len = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=0;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_reg_access_tlv_print(const struct connectib_reg_access_tlv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_tlv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "len                  : "UH_FMT"\n", ptr_struct->len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

}

int connectib_reg_access_tlv_size(void){
	 return 4;
}

void connectib_reg_access_tlv_dump(const struct connectib_reg_access_tlv *ptr_struct, FILE* file) {
	connectib_reg_access_tlv_print(ptr_struct, file, 0);
}

void connectib_IB_TID_pack(const struct connectib_IB_TID *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->High);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->Low);

}

void connectib_IB_TID_unpack(struct connectib_IB_TID *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->High = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->Low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_IB_TID_print(const struct connectib_IB_TID *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_IB_TID ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "High                 : "U32H_FMT"\n", ptr_struct->High);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Low                  : "U32H_FMT"\n", ptr_struct->Low);

}

int connectib_IB_TID_size(void){
	 return 8;
}

void connectib_IB_TID_dump(const struct connectib_IB_TID *ptr_struct, FILE* file) {
	connectib_IB_TID_print(ptr_struct, file, 0);
}

void connectib_dc_control_packet_desc_pack(const struct connectib_dc_control_packet_desc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dlid);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slid);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->source_qp);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dest_qp);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->psn);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=139;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_id);

	offset=138;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->has_grh);

	offset=137;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dct_gvmi);

	offset=216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->flow_label);

	offset=256;
	connectib_ib_gid_pack(&(ptr_struct->dgid), ptr_buff + offset/8);

	offset=384;
	connectib_ib_gid_pack(&(ptr_struct->sgid), ptr_buff + offset/8);

}

void connectib_dc_control_packet_desc_unpack(struct connectib_dc_control_packet_desc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->dlid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->slid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->source_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=39;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=72;
	ptr_struct->dest_qp = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=144;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=140;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=139;
	ptr_struct->port_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=138;
	ptr_struct->has_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=137;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=176;
	ptr_struct->dct_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=216;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=208;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->flow_label = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=256;
	connectib_ib_gid_unpack(&(ptr_struct->dgid), ptr_buff + offset/8);

	offset=384;
	connectib_ib_gid_unpack(&(ptr_struct->sgid), ptr_buff + offset/8);

}

void connectib_dc_control_packet_desc_print(const struct connectib_dc_control_packet_desc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dc_control_packet_desc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dlid                 : "UH_FMT"\n", ptr_struct->dlid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid                 : "UH_FMT"\n", ptr_struct->slid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_qp            : "UH_FMT"\n", ptr_struct->source_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dest_qp              : "UH_FMT"\n", ptr_struct->dest_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn                  : "UH_FMT"\n", ptr_struct->psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : "UH_FMT"\n", ptr_struct->pkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_id              : "UH_FMT"\n", ptr_struct->port_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "has_grh              : "UH_FMT"\n", ptr_struct->has_grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct_gvmi             : "UH_FMT"\n", ptr_struct->dct_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dgid:\n");
	connectib_ib_gid_print(&(ptr_struct->dgid), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sgid:\n");
	connectib_ib_gid_print(&(ptr_struct->sgid), file, indent_level + 1);

}

int connectib_dc_control_packet_desc_size(void){
	 return 64;
}

void connectib_dc_control_packet_desc_dump(const struct connectib_dc_control_packet_desc *ptr_struct, FILE* file) {
	connectib_dc_control_packet_desc_print(ptr_struct, file, 0);
}

void connectib_dmfs_resources_pack(const union connectib_dmfs_resources *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_dmfs_hash_meta_pack(&(ptr_struct->hash_meta), ptr_buff);
}

void connectib_dmfs_resources_unpack(union connectib_dmfs_resources *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_dmfs_hash_meta_unpack(&(ptr_struct->hash_meta), ptr_buff);
}

void connectib_dmfs_resources_print(const union connectib_dmfs_resources *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dmfs_resources ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_meta:\n");
	connectib_dmfs_group_meta_print(&(ptr_struct->group_meta), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ft_meta:\n");
	connectib_dmfs_ft_meta_print(&(ptr_struct->ft_meta), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fte_meta:\n");
	connectib_dmfs_fte_meta_print(&(ptr_struct->fte_meta), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hash_meta:\n");
	connectib_dmfs_hash_meta_print(&(ptr_struct->hash_meta), file, indent_level + 1);

}

int connectib_dmfs_resources_size(void){
	 return 64;
}

void connectib_dmfs_resources_dump(const union connectib_dmfs_resources *ptr_struct, FILE* file) {
	connectib_dmfs_resources_print(ptr_struct, file, 0);
}

void connectib_list_element_pack(const struct connectib_list_element *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->next);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->in_list);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->prev);

}

void connectib_list_element_unpack(struct connectib_list_element *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	ptr_struct->next = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=0;
	ptr_struct->in_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=39;
	ptr_struct->prev = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

}

void connectib_list_element_print(const struct connectib_list_element *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_list_element ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next                 : "UH_FMT"\n", ptr_struct->next);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_list              : "UH_FMT"\n", ptr_struct->in_list);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prev                 : "UH_FMT"\n", ptr_struct->prev);

}

int connectib_list_element_size(void){
	 return 8;
}

void connectib_list_element_dump(const struct connectib_list_element *ptr_struct, FILE* file) {
	connectib_list_element_print(ptr_struct, file, 0);
}

void connectib_fw_rqt_pack(const struct connectib_fw_rqt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rqt_max_size);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rqt_actual_size);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rqt_hw_data_ix);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rqt_fw_data_ix);

}

void connectib_fw_rqt_unpack(struct connectib_fw_rqt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=48;
	ptr_struct->rqt_max_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->rqt_actual_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->rqt_hw_data_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->rqt_fw_data_ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_fw_rqt_print(const struct connectib_fw_rqt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_rqt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_max_size         : "UH_FMT"\n", ptr_struct->rqt_max_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_actual_size      : "UH_FMT"\n", ptr_struct->rqt_actual_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_hw_data_ix       : "U32H_FMT"\n", ptr_struct->rqt_hw_data_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqt_fw_data_ix       : "U32H_FMT"\n", ptr_struct->rqt_fw_data_ix);

}

int connectib_fw_rqt_size(void){
	 return 32;
}

void connectib_fw_rqt_dump(const struct connectib_fw_rqt *ptr_struct, FILE* file) {
	connectib_fw_rqt_print(ptr_struct, file, 0);
}

void connectib_fw_cqc_pack(const struct connectib_fw_cqc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cq_status);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->trap_reason);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->in_cq_overrun_list);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->in_eq_overrun_list);

}

void connectib_fw_cqc_unpack(struct connectib_fw_cqc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	ptr_struct->cq_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=52;
	ptr_struct->trap_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=33;
	ptr_struct->in_cq_overrun_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->in_eq_overrun_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_fw_cqc_print(const struct connectib_fw_cqc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_cqc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_status            : "UH_FMT"\n", ptr_struct->cq_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_reason          : "UH_FMT"\n", ptr_struct->trap_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_cq_overrun_list   : "UH_FMT"\n", ptr_struct->in_cq_overrun_list);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_eq_overrun_list   : "UH_FMT"\n", ptr_struct->in_eq_overrun_list);

}

int connectib_fw_cqc_size(void){
	 return 16;
}

void connectib_fw_cqc_dump(const struct connectib_fw_cqc *ptr_struct, FILE* file) {
	connectib_fw_cqc_print(ptr_struct, file, 0);
}

void connectib_fw_psv_pack(const struct connectib_fw_psv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_marked_sigerr);

}

void connectib_fw_psv_unpack(struct connectib_fw_psv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=7;
	ptr_struct->fw_marked_sigerr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_fw_psv_print(const struct connectib_fw_psv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_psv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_marked_sigerr     : "UH_FMT"\n", ptr_struct->fw_marked_sigerr);

}

int connectib_fw_psv_size(void){
	 return 4;
}

void connectib_fw_psv_dump(const struct connectib_fw_psv *ptr_struct, FILE* file) {
	connectib_fw_psv_print(ptr_struct, file, 0);
}

void connectib_fw_mkc_pack(const struct connectib_fw_mkc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 31, (u_int32_t)ptr_struct->state);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sync_umr);

	offset=64;
	connectib_mkey_dump_pack(&(ptr_struct->mkey_dump), ptr_buff + offset/8);

	offset=127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->next_num_of_sigerr);

	offset=126;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pg_access);

}

void connectib_fw_mkc_unpack(struct connectib_fw_mkc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=33;
	ptr_struct->state = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 31);

	offset=32;
	ptr_struct->sync_umr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	connectib_mkey_dump_unpack(&(ptr_struct->mkey_dump), ptr_buff + offset/8);

	offset=127;
	ptr_struct->next_num_of_sigerr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=126;
	ptr_struct->pg_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_fw_mkc_print(const struct connectib_fw_mkc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_mkc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "state                : "UH_FMT"\n", ptr_struct->state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_umr             : "UH_FMT"\n", ptr_struct->sync_umr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mkey_dump:\n");
	connectib_mkey_dump_print(&(ptr_struct->mkey_dump), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_num_of_sigerr   : "UH_FMT"\n", ptr_struct->next_num_of_sigerr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pg_access            : "UH_FMT"\n", ptr_struct->pg_access);

}

int connectib_fw_mkc_size(void){
	 return 16;
}

void connectib_fw_mkc_dump(const struct connectib_fw_mkc *ptr_struct, FILE* file) {
	connectib_fw_mkc_print(ptr_struct, file, 0);
}

void connectib_fw_cre_pack(const union connectib_fw_cre *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_fw_tis_pack(&(ptr_struct->fw_tis), ptr_buff);
}

void connectib_fw_cre_unpack(union connectib_fw_cre *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_fw_tis_unpack(&(ptr_struct->fw_tis), ptr_buff);
}

void connectib_fw_cre_print(const union connectib_fw_cre *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_cre ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_srqc:\n");
	connectib_fw_srqc_print(&(ptr_struct->fw_srqc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_qpc:\n");
	connectib_fw_qpc_print(&(ptr_struct->fw_qpc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_tir:\n");
	connectib_fw_tir_print(&(ptr_struct->fw_tir), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_tis:\n");
	connectib_fw_tis_print(&(ptr_struct->fw_tis), file, indent_level + 1);

}

int connectib_fw_cre_size(void){
	 return 64;
}

void connectib_fw_cre_dump(const union connectib_fw_cre *ptr_struct, FILE* file) {
	connectib_fw_cre_print(ptr_struct, file, 0);
}

void connectib_fw_basic_res_ctx_pack(const struct connectib_fw_basic_res_ctx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

}

void connectib_fw_basic_res_ctx_unpack(struct connectib_fw_basic_res_ctx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

}

void connectib_fw_basic_res_ctx_print(const struct connectib_fw_basic_res_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_basic_res_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

}

int connectib_fw_basic_res_ctx_size(void){
	 return 4;
}

void connectib_fw_basic_res_ctx_dump(const struct connectib_fw_basic_res_ctx *ptr_struct, FILE* file) {
	connectib_fw_basic_res_ctx_print(ptr_struct, file, 0);
}

void connectib_fw_alt_path_pack(const struct connectib_fw_alt_path *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_sw_ads_pack(&(ptr_struct->alt), ptr_buff + offset/8);

}

void connectib_fw_alt_path_unpack(struct connectib_fw_alt_path *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_sw_ads_unpack(&(ptr_struct->alt), ptr_buff + offset/8);

}

void connectib_fw_alt_path_print(const struct connectib_fw_alt_path *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_alt_path ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alt:\n");
	connectib_sw_ads_print(&(ptr_struct->alt), file, indent_level + 1);

}

int connectib_fw_alt_path_size(void){
	 return 48;
}

void connectib_fw_alt_path_dump(const struct connectib_fw_alt_path *ptr_struct, FILE* file) {
	connectib_fw_alt_path_print(ptr_struct, file, 0);
}

void connectib_fw_eqc_pack(const struct connectib_fw_eqc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_pack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eq_status);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->trap_reason);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->needs_eq_probe);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->in_eq_overrun_list);

}

void connectib_fw_eqc_unpack(struct connectib_fw_eqc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_ref_count_unpack(&(ptr_struct->fw_ref_count), ptr_buff + offset/8);

	offset=56;
	ptr_struct->eq_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=52;
	ptr_struct->trap_reason = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=33;
	ptr_struct->needs_eq_probe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->in_eq_overrun_list = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_fw_eqc_print(const struct connectib_fw_eqc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_eqc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ref_count:\n");
	connectib_fw_ref_count_print(&(ptr_struct->fw_ref_count), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eq_status            : "UH_FMT"\n", ptr_struct->eq_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_reason          : "UH_FMT"\n", ptr_struct->trap_reason);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "needs_eq_probe       : "UH_FMT"\n", ptr_struct->needs_eq_probe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_eq_overrun_list   : "UH_FMT"\n", ptr_struct->in_eq_overrun_list);

}

int connectib_fw_eqc_size(void){
	 return 16;
}

void connectib_fw_eqc_dump(const struct connectib_fw_eqc *ptr_struct, FILE* file) {
	connectib_fw_eqc_print(ptr_struct, file, 0);
}

void connectib_hw_qp_counter_pack(const struct connectib_hw_qp_counter *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pkt_nobuffer_drop);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pkt_good_unicast);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pkt_good_multicast);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pkt_dropped);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->msg_write_req);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->msg_rnr_nack);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->msg_read);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->msg_dct_connect);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->msg_atomic);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->fw_reserved);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->bytes_rdma_frame);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->bytes_good_unicast);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->bytes_good_multicast);

}

void connectib_hw_qp_counter_unpack(struct connectib_hw_qp_counter *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->pkt_nobuffer_drop = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->pkt_good_unicast = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->pkt_good_multicast = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->pkt_dropped = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->msg_write_req = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->msg_rnr_nack = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->msg_read = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->msg_dct_connect = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->msg_atomic = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->fw_reserved = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->bytes_rdma_frame = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=384;
	ptr_struct->bytes_good_unicast = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->bytes_good_multicast = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_qp_counter_print(const struct connectib_hw_qp_counter *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_qp_counter ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkt_nobuffer_drop    : "U32H_FMT"\n", ptr_struct->pkt_nobuffer_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkt_good_unicast     : "U32H_FMT"\n", ptr_struct->pkt_good_unicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkt_good_multicast   : "U32H_FMT"\n", ptr_struct->pkt_good_multicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkt_dropped          : "U32H_FMT"\n", ptr_struct->pkt_dropped);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msg_write_req        : "U32H_FMT"\n", ptr_struct->msg_write_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msg_rnr_nack         : "U32H_FMT"\n", ptr_struct->msg_rnr_nack);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msg_read             : "U32H_FMT"\n", ptr_struct->msg_read);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msg_dct_connect      : "U32H_FMT"\n", ptr_struct->msg_dct_connect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msg_atomic           : "U32H_FMT"\n", ptr_struct->msg_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_reserved          : "U32H_FMT"\n", ptr_struct->fw_reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bytes_rdma_frame     : "U64H_FMT"\n", ptr_struct->bytes_rdma_frame);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bytes_good_unicast   : "U64H_FMT"\n", ptr_struct->bytes_good_unicast);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bytes_good_multicast : "U64H_FMT"\n", ptr_struct->bytes_good_multicast);

}

int connectib_hw_qp_counter_size(void){
	 return 64;
}

void connectib_hw_qp_counter_dump(const struct connectib_hw_qp_counter *ptr_struct, FILE* file) {
	connectib_hw_qp_counter_print(ptr_struct, file, 0);
}

void connectib_hw_msix_pack(const struct connectib_hw_msix *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_msix_context_pack(&(ptr_struct->msix_context), ptr_buff + offset/8);

	offset=128;
	connectib_hw_msix_ext_context_pack(&(ptr_struct->msix_ext_context), ptr_buff + offset/8);

}

void connectib_hw_msix_unpack(struct connectib_hw_msix *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_msix_context_unpack(&(ptr_struct->msix_context), ptr_buff + offset/8);

	offset=128;
	connectib_hw_msix_ext_context_unpack(&(ptr_struct->msix_ext_context), ptr_buff + offset/8);

}

void connectib_hw_msix_print(const struct connectib_hw_msix *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_msix ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_context:\n");
	connectib_hw_msix_context_print(&(ptr_struct->msix_context), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_ext_context:\n");
	connectib_hw_msix_ext_context_print(&(ptr_struct->msix_ext_context), file, indent_level + 1);

}

int connectib_hw_msix_size(void){
	 return 32;
}

void connectib_hw_msix_dump(const struct connectib_hw_msix *ptr_struct, FILE* file) {
	connectib_hw_msix_print(ptr_struct, file, 0);
}

void connectib_hw_rdb_pack(const struct connectib_hw_rdb *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->psn);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->r_key);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->address_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->address_31_0);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->byte_count);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=213;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->protection_ffser);

	offset=255;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_marked_as_read);

	offset=256;
	connectib_hw_rdb_atomic_data_pack(&(ptr_struct->atomic_data), ptr_buff + offset/8);

}

void connectib_hw_rdb_unpack(struct connectib_hw_rdb *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->r_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->address_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->address_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->byte_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=184;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=160;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=213;
	ptr_struct->protection_ffser = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=255;
	ptr_struct->fw_marked_as_read = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=256;
	connectib_hw_rdb_atomic_data_unpack(&(ptr_struct->atomic_data), ptr_buff + offset/8);

}

void connectib_hw_rdb_print(const struct connectib_hw_rdb *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_rdb ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn                  : "UH_FMT"\n", ptr_struct->psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r_key                : "U32H_FMT"\n", ptr_struct->r_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address_63_32        : "U32H_FMT"\n", ptr_struct->address_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address_31_0         : "U32H_FMT"\n", ptr_struct->address_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_count           : "U32H_FMT"\n", ptr_struct->byte_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "protection_ffser     : "UH_FMT"\n", ptr_struct->protection_ffser);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_marked_as_read    : "UH_FMT"\n", ptr_struct->fw_marked_as_read);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_data:\n");
	connectib_hw_rdb_atomic_data_print(&(ptr_struct->atomic_data), file, indent_level + 1);

}

int connectib_hw_rdb_size(void){
	 return 64;
}

void connectib_hw_rdb_dump(const struct connectib_hw_rdb *ptr_struct, FILE* file) {
	connectib_hw_rdb_print(ptr_struct, file, 0);
}

void connectib_icm_mtt_pack(const union connectib_icm_mtt *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_mtt2_pack(&(ptr_struct->as_dw), ptr_buff);
}

void connectib_icm_mtt_unpack(union connectib_icm_mtt *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_mtt2_unpack(&(ptr_struct->as_dw), ptr_buff);
}

void connectib_icm_mtt_print(const union connectib_icm_mtt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icm_mtt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw:\n");
	connectib_hw_mtt_print(&(ptr_struct->hw), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_dw:\n");
	connectib_hw_mtt2_print(&(ptr_struct->as_dw), file, indent_level + 1);

}

int connectib_icm_mtt_size(void){
	 return 8;
}

void connectib_icm_mtt_dump(const union connectib_icm_mtt *ptr_struct, FILE* file) {
	connectib_icm_mtt_print(ptr_struct, file, 0);
}

void connectib_steering_entry_icmc_pack(const union connectib_steering_entry_icmc *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_steering_qp_list_pack(&(ptr_struct->steering_qp_list), ptr_buff);
}

void connectib_steering_entry_icmc_unpack(union connectib_steering_entry_icmc *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_steering_qp_list_unpack(&(ptr_struct->steering_qp_list), ptr_buff);
}

void connectib_steering_entry_icmc_print(const union connectib_steering_entry_icmc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_steering_entry_icmc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_ste:\n");
	connectib_hw_ste_print(&(ptr_struct->hw_ste), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_qp_list:\n");
	connectib_steering_qp_list_print(&(ptr_struct->steering_qp_list), file, indent_level + 1);

}

int connectib_steering_entry_icmc_size(void){
	 return 64;
}

void connectib_steering_entry_icmc_dump(const union connectib_steering_entry_icmc *ptr_struct, FILE* file) {
	connectib_steering_entry_icmc_print(ptr_struct, file, 0);
}

void connectib_hw_pkey_pack(const struct connectib_hw_pkey *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pkey);

}

void connectib_hw_pkey_unpack(struct connectib_hw_pkey *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->pkey = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_hw_pkey_print(const struct connectib_hw_pkey *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_pkey ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey                 : "UH_FMT"\n", ptr_struct->pkey);

}

int connectib_hw_pkey_size(void){
	 return 4;
}

void connectib_hw_pkey_dump(const struct connectib_hw_pkey *ptr_struct, FILE* file) {
	connectib_hw_pkey_print(ptr_struct, file, 0);
}

void connectib_hw_timer_32_pack(const struct connectib_hw_timer_32 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	connectib_hw_timer_pack(&(ptr_struct->hw_timer), ptr_buff + offset/8);

}

void connectib_hw_timer_32_unpack(struct connectib_hw_timer_32 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	connectib_hw_timer_unpack(&(ptr_struct->hw_timer), ptr_buff + offset/8);

}

void connectib_hw_timer_32_print(const struct connectib_hw_timer_32 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_timer_32 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_timer:\n");
	connectib_hw_timer_print(&(ptr_struct->hw_timer), file, indent_level + 1);

}

int connectib_hw_timer_32_size(void){
	 return 4;
}

void connectib_hw_timer_32_dump(const struct connectib_hw_timer_32 *ptr_struct, FILE* file) {
	connectib_hw_timer_32_print(ptr_struct, file, 0);
}

void connectib_hw_sq_qp_list_pack(const struct connectib_hw_sq_qp_list *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->global_gvmi);

}

void connectib_hw_sq_qp_list_unpack(struct connectib_hw_sq_qp_list *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->qpi = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->global_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_sq_qp_list_print(const struct connectib_hw_sq_qp_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_sq_qp_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpi                  : "UH_FMT"\n", ptr_struct->qpi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_gvmi          : "UH_FMT"\n", ptr_struct->global_gvmi);

}

int connectib_hw_sq_qp_list_size(void){
	 return 4;
}

void connectib_hw_sq_qp_list_dump(const struct connectib_hw_sq_qp_list *ptr_struct, FILE* file) {
	connectib_hw_sq_qp_list_print(ptr_struct, file, 0);
}

void connectib_hw_pipa_pack(const struct connectib_hw_pipa *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pa_63_32);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->recovery_en);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->always_zero);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->pa_31_2);

}

void connectib_hw_pipa_unpack(struct connectib_hw_pipa *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->pa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=63;
	ptr_struct->recovery_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->always_zero = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->pa_31_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

}

void connectib_hw_pipa_print(const struct connectib_hw_pipa *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_pipa ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa_63_32             : "U32H_FMT"\n", ptr_struct->pa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "recovery_en          : "UH_FMT"\n", ptr_struct->recovery_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "always_zero          : "UH_FMT"\n", ptr_struct->always_zero);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa_31_2              : "UH_FMT"\n", ptr_struct->pa_31_2);

}

int connectib_hw_pipa_size(void){
	 return 8;
}

void connectib_hw_pipa_dump(const struct connectib_hw_pipa *ptr_struct, FILE* file) {
	connectib_hw_pipa_print(ptr_struct, file, 0);
}

void connectib_hw_sxdc_pack(const struct connectib_hw_sxdc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sq);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->swqe_producer_index);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->uar);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->requestor_in_sq);

	offset=38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->responder_in_sq);

	offset=37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->scheduling_interrupt);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->doorbell_int);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_path);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->external_db_en);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

}

void connectib_hw_sxdc_unpack(struct connectib_hw_sxdc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->sq = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->swqe_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->uar = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=39;
	ptr_struct->requestor_in_sq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=38;
	ptr_struct->responder_in_sq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=37;
	ptr_struct->scheduling_interrupt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=35;
	ptr_struct->doorbell_int = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=34;
	ptr_struct->fast_path = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->external_db_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_sxdc_print(const struct connectib_hw_sxdc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_sxdc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq                   : "UH_FMT"\n", ptr_struct->sq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_producer_index  : "UH_FMT"\n", ptr_struct->swqe_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uar                  : "UH_FMT"\n", ptr_struct->uar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requestor_in_sq      : "UH_FMT"\n", ptr_struct->requestor_in_sq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_in_sq      : "UH_FMT"\n", ptr_struct->responder_in_sq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "scheduling_interrupt : "UH_FMT"\n", ptr_struct->scheduling_interrupt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "doorbell_int         : "UH_FMT"\n", ptr_struct->doorbell_int);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_path            : "UH_FMT"\n", ptr_struct->fast_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "external_db_en       : "UH_FMT"\n", ptr_struct->external_db_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

}

int connectib_hw_sxdc_size(void){
	 return 8;
}

void connectib_hw_sxdc_dump(const struct connectib_hw_sxdc *ptr_struct, FILE* file) {
	connectib_hw_sxdc_print(ptr_struct, file, 0);
}

void connectib_hw_klm_entry_pack(const struct connectib_hw_klm_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->length);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->key);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->va);

}

void connectib_hw_klm_entry_unpack(struct connectib_hw_klm_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_klm_entry_print(const struct connectib_hw_klm_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_klm_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length               : "U32H_FMT"\n", ptr_struct->length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key                  : "U32H_FMT"\n", ptr_struct->key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "va                   : "U64H_FMT"\n", ptr_struct->va);

}

int connectib_hw_klm_entry_size(void){
	 return 16;
}

void connectib_hw_klm_entry_dump(const struct connectib_hw_klm_entry *ptr_struct, FILE* file) {
	connectib_hw_klm_entry_print(ptr_struct, file, 0);
}

void connectib_hw_sq_tokens_pack(const struct connectib_hw_sq_tokens *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ware_house_burst_size_23_8);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->responder_burst_size);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ware_house_burst_size_7_0);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->requestor_burst_size);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gvmi_vl_weight);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gvmi_vl_token_count);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gvmi_vl_saturation);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dwrr_weight);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->dwrr_token_count);

	offset=228;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl);

	offset=225;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->vlg);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port);

}

void connectib_hw_sq_tokens_unpack(struct connectib_hw_sq_tokens *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->ware_house_burst_size_23_8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->responder_burst_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->ware_house_burst_size_7_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->requestor_burst_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->gvmi_vl_weight = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=136;
	ptr_struct->gvmi_vl_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=168;
	ptr_struct->gvmi_vl_saturation = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=200;
	ptr_struct->dwrr_weight = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=232;
	ptr_struct->dwrr_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=228;
	ptr_struct->vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=225;
	ptr_struct->vlg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=224;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_sq_tokens_print(const struct connectib_hw_sq_tokens *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_sq_tokens ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ware_house_burst_size_23_8 : "UH_FMT"\n", ptr_struct->ware_house_burst_size_23_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "responder_burst_size : "UH_FMT"\n", ptr_struct->responder_burst_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ware_house_burst_size_7_0 : "UH_FMT"\n", ptr_struct->ware_house_burst_size_7_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requestor_burst_size : "UH_FMT"\n", ptr_struct->requestor_burst_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi_vl_weight       : "UH_FMT"\n", ptr_struct->gvmi_vl_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi_vl_token_count  : "UH_FMT"\n", ptr_struct->gvmi_vl_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi_vl_saturation   : "UH_FMT"\n", ptr_struct->gvmi_vl_saturation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dwrr_weight          : "UH_FMT"\n", ptr_struct->dwrr_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dwrr_token_count     : "UH_FMT"\n", ptr_struct->dwrr_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl                   : "UH_FMT"\n", ptr_struct->vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vlg                  : "UH_FMT"\n", ptr_struct->vlg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

}

int connectib_hw_sq_tokens_size(void){
	 return 32;
}

void connectib_hw_sq_tokens_dump(const struct connectib_hw_sq_tokens *ptr_struct, FILE* file) {
	connectib_hw_sq_tokens_print(ptr_struct, file, 0);
}

void connectib_hw_gvmi_tokens_pack(const struct connectib_hw_gvmi_tokens *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port1_avg_saturation);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port1_high_vlg_req_token);

	offset=83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port1_log2avg_time);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port1_max_weight_exp);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port1_log2max_time);

	offset=74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port0_has_token);

	offset=73;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port0_vlg_req_vld);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port1_has_token);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port1_max_saturation);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port1_vlg_req_vld);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port0_avg_saturation);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port0_avg_weight_exp);

	offset=115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port0_log2avg_time);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port0_high_vlg_req_token);

	offset=107;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port0_log2max_time);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port0_max_weight_exp);

	offset=99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->port0_max_saturation);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->port1_avg_weight_exp);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->port1_max_token_count);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port1_max_weight_mantissa);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->port1_avg_token_count);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port1_avg_weight_mantissa);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->port0_max_token_count);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port0_max_weight_mantissa);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->port0_avg_token_count);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port0_avg_weight_mantissa);

}

void connectib_hw_gvmi_tokens_unpack(struct connectib_hw_gvmi_tokens *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=91;
	ptr_struct->port1_avg_saturation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=88;
	ptr_struct->port1_high_vlg_req_token = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=83;
	ptr_struct->port1_log2avg_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=80;
	ptr_struct->port1_max_weight_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=75;
	ptr_struct->port1_log2max_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=74;
	ptr_struct->port0_has_token = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=73;
	ptr_struct->port0_vlg_req_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=72;
	ptr_struct->port1_has_token = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=67;
	ptr_struct->port1_max_saturation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=66;
	ptr_struct->port1_vlg_req_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=123;
	ptr_struct->port0_avg_saturation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=120;
	ptr_struct->port0_avg_weight_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=115;
	ptr_struct->port0_log2avg_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=112;
	ptr_struct->port0_high_vlg_req_token = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=107;
	ptr_struct->port0_log2max_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=104;
	ptr_struct->port0_max_weight_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=99;
	ptr_struct->port0_max_saturation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=96;
	ptr_struct->port1_avg_weight_exp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=136;
	ptr_struct->port1_max_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=128;
	ptr_struct->port1_max_weight_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=168;
	ptr_struct->port1_avg_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->port1_avg_weight_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=200;
	ptr_struct->port0_max_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->port0_max_weight_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=232;
	ptr_struct->port0_avg_token_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=224;
	ptr_struct->port0_avg_weight_mantissa = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_gvmi_tokens_print(const struct connectib_hw_gvmi_tokens *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_gvmi_tokens ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_avg_saturation : "UH_FMT"\n", ptr_struct->port1_avg_saturation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_high_vlg_req_token : "UH_FMT"\n", ptr_struct->port1_high_vlg_req_token);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_log2avg_time   : "UH_FMT"\n", ptr_struct->port1_log2avg_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_max_weight_exp : "UH_FMT"\n", ptr_struct->port1_max_weight_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_log2max_time   : "UH_FMT"\n", ptr_struct->port1_log2max_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_has_token      : "UH_FMT"\n", ptr_struct->port0_has_token);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_vlg_req_vld    : "UH_FMT"\n", ptr_struct->port0_vlg_req_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_has_token      : "UH_FMT"\n", ptr_struct->port1_has_token);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_max_saturation : "UH_FMT"\n", ptr_struct->port1_max_saturation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_vlg_req_vld    : "UH_FMT"\n", ptr_struct->port1_vlg_req_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_avg_saturation : "UH_FMT"\n", ptr_struct->port0_avg_saturation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_avg_weight_exp : "UH_FMT"\n", ptr_struct->port0_avg_weight_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_log2avg_time   : "UH_FMT"\n", ptr_struct->port0_log2avg_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_high_vlg_req_token : "UH_FMT"\n", ptr_struct->port0_high_vlg_req_token);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_log2max_time   : "UH_FMT"\n", ptr_struct->port0_log2max_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_max_weight_exp : "UH_FMT"\n", ptr_struct->port0_max_weight_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_max_saturation : "UH_FMT"\n", ptr_struct->port0_max_saturation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_avg_weight_exp : "UH_FMT"\n", ptr_struct->port1_avg_weight_exp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_max_token_count : "UH_FMT"\n", ptr_struct->port1_max_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_max_weight_mantissa : "UH_FMT"\n", ptr_struct->port1_max_weight_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_avg_token_count : "UH_FMT"\n", ptr_struct->port1_avg_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port1_avg_weight_mantissa : "UH_FMT"\n", ptr_struct->port1_avg_weight_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_max_token_count : "UH_FMT"\n", ptr_struct->port0_max_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_max_weight_mantissa : "UH_FMT"\n", ptr_struct->port0_max_weight_mantissa);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_avg_token_count : "UH_FMT"\n", ptr_struct->port0_avg_token_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port0_avg_weight_mantissa : "UH_FMT"\n", ptr_struct->port0_avg_weight_mantissa);

}

int connectib_hw_gvmi_tokens_size(void){
	 return 32;
}

void connectib_hw_gvmi_tokens_dump(const struct connectib_hw_gvmi_tokens *ptr_struct, FILE* file) {
	connectib_hw_gvmi_tokens_print(ptr_struct, file, 0);
}

void connectib_hw_sq_pointers_pack(const struct connectib_hw_sq_pointers *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->weight_requestor);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->sq_offset_11_6);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->weight_responder);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->token);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->sq_offset_5_0);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->ware_house_counter_responder);

	offset=103;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->ware_house_counter_requestor);

	offset=135;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->push_pointer_responder);

	offset=167;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->push_pointer_requestor);

	offset=166;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port);

	offset=165;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->scheduling_interrupt);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl);

	offset=199;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->pop_pointer_responder);

	offset=198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_gnt_requestor);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_max_num_of_qp_responder);

	offset=231;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->pop_pointer_requestor);

	offset=230;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->db_interrupt);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_max_num_of_qp_requestor);

}

void connectib_hw_sq_pointers_unpack(struct connectib_hw_sq_pointers *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	ptr_struct->weight_requestor = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=16;
	ptr_struct->sq_offset_11_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=6;
	ptr_struct->weight_responder = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=38;
	ptr_struct->token = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=32;
	ptr_struct->sq_offset_5_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=71;
	ptr_struct->ware_house_counter_responder = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=103;
	ptr_struct->ware_house_counter_requestor = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=135;
	ptr_struct->push_pointer_responder = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=167;
	ptr_struct->push_pointer_requestor = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=166;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=165;
	ptr_struct->scheduling_interrupt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=160;
	ptr_struct->vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=199;
	ptr_struct->pop_pointer_responder = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=198;
	ptr_struct->last_gnt_requestor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=192;
	ptr_struct->log2_max_num_of_qp_responder = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=231;
	ptr_struct->pop_pointer_requestor = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=230;
	ptr_struct->db_interrupt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=224;
	ptr_struct->log2_max_num_of_qp_requestor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void connectib_hw_sq_pointers_print(const struct connectib_hw_sq_pointers *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_sq_pointers ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "weight_requestor     : "UH_FMT"\n", ptr_struct->weight_requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_offset_11_6       : "UH_FMT"\n", ptr_struct->sq_offset_11_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "weight_responder     : "UH_FMT"\n", ptr_struct->weight_responder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "token                : "UH_FMT"\n", ptr_struct->token);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_offset_5_0        : "UH_FMT"\n", ptr_struct->sq_offset_5_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ware_house_counter_responder : "UH_FMT"\n", ptr_struct->ware_house_counter_responder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ware_house_counter_requestor : "UH_FMT"\n", ptr_struct->ware_house_counter_requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "push_pointer_responder : "UH_FMT"\n", ptr_struct->push_pointer_responder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "push_pointer_requestor : "UH_FMT"\n", ptr_struct->push_pointer_requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "scheduling_interrupt : "UH_FMT"\n", ptr_struct->scheduling_interrupt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl                   : "UH_FMT"\n", ptr_struct->vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pop_pointer_responder : "UH_FMT"\n", ptr_struct->pop_pointer_responder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_gnt_requestor   : "UH_FMT"\n", ptr_struct->last_gnt_requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_max_num_of_qp_responder : "UH_FMT"\n", ptr_struct->log2_max_num_of_qp_responder);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pop_pointer_requestor : "UH_FMT"\n", ptr_struct->pop_pointer_requestor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_interrupt         : "UH_FMT"\n", ptr_struct->db_interrupt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_max_num_of_qp_requestor : "UH_FMT"\n", ptr_struct->log2_max_num_of_qp_requestor);

}

int connectib_hw_sq_pointers_size(void){
	 return 32;
}

void connectib_hw_sq_pointers_dump(const struct connectib_hw_sq_pointers *ptr_struct, FILE* file) {
	connectib_hw_sq_pointers_print(ptr_struct, file, 0);
}

void connectib_hw_trasta_pack(const struct connectib_hw_trasta *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->va_offset_63_32);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->va_offset_31_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->klm_index);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->invalidation_counter);

	offset=111;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

}

void connectib_hw_trasta_unpack(struct connectib_hw_trasta *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->va_offset_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->va_offset_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->klm_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=112;
	ptr_struct->invalidation_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=111;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_hw_trasta_print(const struct connectib_hw_trasta *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_trasta ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "va_offset_63_32      : "U32H_FMT"\n", ptr_struct->va_offset_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "va_offset_31_0       : "U32H_FMT"\n", ptr_struct->va_offset_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "klm_index            : "U32H_FMT"\n", ptr_struct->klm_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "invalidation_counter : "UH_FMT"\n", ptr_struct->invalidation_counter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

}

int connectib_hw_trasta_size(void){
	 return 16;
}

void connectib_hw_trasta_dump(const struct connectib_hw_trasta *ptr_struct, FILE* file) {
	connectib_hw_trasta_print(ptr_struct, file, 0);
}

void connectib_hw_trastb_pack(const struct connectib_hw_trastb *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->generation_count);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->bsf_offset);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->m_fbo);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->w_fbo);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->m_va);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->w_va);

}

void connectib_hw_trastb_unpack(struct connectib_hw_trastb *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->generation_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->bsf_offset = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->m_fbo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->w_fbo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->m_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->w_va = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_trastb_print(const struct connectib_hw_trastb *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_trastb ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generation_count     : "UH_FMT"\n", ptr_struct->generation_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_offset           : "U32H_FMT"\n", ptr_struct->bsf_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_fbo                : "U32H_FMT"\n", ptr_struct->m_fbo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_fbo                : "U32H_FMT"\n", ptr_struct->w_fbo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_va                 : "U64H_FMT"\n", ptr_struct->m_va);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "w_va                 : "U64H_FMT"\n", ptr_struct->w_va);

}

int connectib_hw_trastb_size(void){
	 return 32;
}

void connectib_hw_trastb_dump(const struct connectib_hw_trastb *ptr_struct, FILE* file) {
	connectib_hw_trastb_print(ptr_struct, file, 0);
}

void connectib_hw_base_psv_pack(const struct connectib_hw_base_psv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->data_heart_beat);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wqe_heart_beat);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->status);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->syndrome);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->transient_signature);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->reference_tag);

}

void connectib_hw_base_psv_unpack(struct connectib_hw_base_psv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=2;
	ptr_struct->data_heart_beat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->wqe_heart_beat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->syndrome = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->transient_signature = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->reference_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_base_psv_print(const struct connectib_hw_base_psv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_base_psv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_heart_beat      : "UH_FMT"\n", ptr_struct->data_heart_beat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_heart_beat       : "UH_FMT"\n", ptr_struct->wqe_heart_beat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : "UH_FMT"\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrome             : "UH_FMT"\n", ptr_struct->syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "transient_signature  : "U32H_FMT"\n", ptr_struct->transient_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reference_tag        : "U32H_FMT"\n", ptr_struct->reference_tag);

}

int connectib_hw_base_psv_size(void){
	 return 16;
}

void connectib_hw_base_psv_dump(const struct connectib_hw_base_psv *ptr_struct, FILE* file) {
	connectib_hw_base_psv_print(ptr_struct, file, 0);
}

void connectib_hw_bsf_entry_pack(const union connectib_hw_bsf_entry *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_pack(&(ptr_struct->hw_bsf_entry_w_non_repeating_m_non_repeating), ptr_buff);
}

void connectib_hw_bsf_entry_unpack(union connectib_hw_bsf_entry *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_unpack(&(ptr_struct->hw_bsf_entry_w_non_repeating_m_non_repeating), ptr_buff);
}

void connectib_hw_bsf_entry_print(const union connectib_hw_bsf_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_bsf_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "same_block_repeating:\n");
	connectib_hw_bsf_entry_same_block_repeating_print(&(ptr_struct->same_block_repeating), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "same_block_non_repeating:\n");
	connectib_hw_bsf_entry_same_block_non_repeating_print(&(ptr_struct->same_block_non_repeating), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_bsf_entry_w_repeating_m_repeating:\n");
	connectib_hw_bsf_entry_w_repeating_m_repeating_print(&(ptr_struct->hw_bsf_entry_w_repeating_m_repeating), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_bsf_entry_w_repeating_m_non_repeating:\n");
	connectib_hw_bsf_entry_w_repeating_m_non_repeating_print(&(ptr_struct->hw_bsf_entry_w_repeating_m_non_repeating), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_bsf_entry_w_non_repeating_m_repeating:\n");
	connectib_hw_bsf_entry_w_non_repeating_m_repeating_print(&(ptr_struct->hw_bsf_entry_w_non_repeating_m_repeating), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_bsf_entry_w_non_repeating_m_non_repeating:\n");
	connectib_hw_bsf_entry_w_non_repeating_m_non_repeating_print(&(ptr_struct->hw_bsf_entry_w_non_repeating_m_non_repeating), file, indent_level + 1);

}

int connectib_hw_bsf_entry_size(void){
	 return 64;
}

void connectib_hw_bsf_entry_dump(const union connectib_hw_bsf_entry *ptr_struct, FILE* file) {
	connectib_hw_bsf_entry_print(ptr_struct, file, 0);
}

void connectib_hw_port_info_pack(const struct connectib_hw_port_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lmc);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mad_filter);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->gid_prefix);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(272, 16, i, 512, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dc_rsl2sq_map[i]);
	}

}

void connectib_hw_port_info_unpack(struct connectib_hw_port_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->lmc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=2;
	ptr_struct->mad_filter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=48;
	ptr_struct->lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->gid_prefix = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(272, 16, i, 512, 1);
	ptr_struct->dc_rsl2sq_map[i] = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);
	}

}

void connectib_hw_port_info_print(const struct connectib_hw_port_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_port_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lmc                  : "UH_FMT"\n", ptr_struct->lmc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad_filter           : "UH_FMT"\n", ptr_struct->mad_filter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid                  : "UH_FMT"\n", ptr_struct->lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gid_prefix           : "U64H_FMT"\n", ptr_struct->gid_prefix);

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_rsl2sq_map_%03d   : "UH_FMT"\n", i, ptr_struct->dc_rsl2sq_map[i]);
	}

}

int connectib_hw_port_info_size(void){
	 return 64;
}

void connectib_hw_port_info_dump(const struct connectib_hw_port_info *ptr_struct, FILE* file) {
	connectib_hw_port_info_print(ptr_struct, file, 0);
}

void connectib_hw_r_qpc_pack(const union connectib_hw_r_qpc *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_dct_pack(&(ptr_struct->dct), ptr_buff);
}

void connectib_hw_r_qpc_unpack(union connectib_hw_r_qpc *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_dct_unpack(&(ptr_struct->dct), ptr_buff);
}

void connectib_hw_r_qpc_print(const union connectib_hw_r_qpc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_r_qpc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared:\n");
	connectib_hw_r_qpc_common_print(&(ptr_struct->shared), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared_connected:\n");
	connectib_hw_r_qpc_connected_common_print(&(ptr_struct->shared_connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected:\n");
	connectib_hw_r_qpc_rc_uc_dci_print(&(ptr_struct->connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_cd:\n");
	connectib_hw_r_qpc_rc_uc_cd_print(&(ptr_struct->connected_cd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_2cycbuff:\n");
	connectib_hw_r_qpc_rc_uc_2cycbuff_print(&(ptr_struct->connected_2cycbuff), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_2srq:\n");
	connectib_hw_r_qpc_rc_uc_2srq_print(&(ptr_struct->connected_2srq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_dcr:\n");
	connectib_hw_r_qpc_dcr_print(&(ptr_struct->connected_dcr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_xrc:\n");
	connectib_hw_r_qpc_xrc_print(&(ptr_struct->connected_xrc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared_unconnected:\n");
	connectib_hw_r_qpc_unconnected_common_print(&(ptr_struct->shared_unconnected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected:\n");
	connectib_hw_r_qpc_ud_l2_print(&(ptr_struct->unconnected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected_2cyclicbuff:\n");
	connectib_hw_r_qpc_ud_l2_2cyclicbuff_print(&(ptr_struct->unconnected_2cyclicbuff), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected_2srq:\n");
	connectib_hw_r_qpc_ud_l2_2srq_print(&(ptr_struct->unconnected_2srq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected_cd:\n");
	connectib_hw_r_qpc_ud_l2_cd_print(&(ptr_struct->unconnected_cd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct:\n");
	connectib_hw_dct_print(&(ptr_struct->dct), file, indent_level + 1);

}

int connectib_hw_r_qpc_size(void){
	 return 64;
}

void connectib_hw_r_qpc_dump(const union connectib_hw_r_qpc *ptr_struct, FILE* file) {
	connectib_hw_r_qpc_print(ptr_struct, file, 0);
}

void connectib_hw_s_qpc_pack(const union connectib_hw_s_qpc *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_s_qpc_ud_l2_pack(&(ptr_struct->unconnected), ptr_buff);
}

void connectib_hw_s_qpc_unpack(union connectib_hw_s_qpc *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_s_qpc_ud_l2_unpack(&(ptr_struct->unconnected), ptr_buff);
}

void connectib_hw_s_qpc_print(const union connectib_hw_s_qpc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_s_qpc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared:\n");
	connectib_hw_s_qpc_common_print(&(ptr_struct->shared), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared_connected:\n");
	connectib_hw_s_qpc_connected_common_print(&(ptr_struct->shared_connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected:\n");
	connectib_hw_s_qpc_rc_uc_dcr_print(&(ptr_struct->connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_dci:\n");
	connectib_hw_s_qpc_dci_print(&(ptr_struct->connected_dci), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected:\n");
	connectib_hw_s_qpc_ud_l2_print(&(ptr_struct->unconnected), file, indent_level + 1);

}

int connectib_hw_s_qpc_size(void){
	 return 64;
}

void connectib_hw_s_qpc_dump(const union connectib_hw_s_qpc *ptr_struct, FILE* file) {
	connectib_hw_s_qpc_print(ptr_struct, file, 0);
}

void connectib_hw_c_qpc_pack(const union connectib_hw_c_qpc *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_c_qpc_unconnected_2cycbuff_pack(&(ptr_struct->unconnected_2cycbuff), ptr_buff);
}

void connectib_hw_c_qpc_unpack(union connectib_hw_c_qpc *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_c_qpc_unconnected_2cycbuff_unpack(&(ptr_struct->unconnected_2cycbuff), ptr_buff);
}

void connectib_hw_c_qpc_print(const union connectib_hw_c_qpc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_c_qpc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared:\n");
	connectib_hw_c_qpc_common_print(&(ptr_struct->shared), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared_connected:\n");
	connectib_hw_c_qpc_connected_common_print(&(ptr_struct->shared_connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected:\n");
	connectib_hw_c_qpc_connected_print(&(ptr_struct->connected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_2cycbuff:\n");
	connectib_hw_c_qpc_connected_2cycbuff_print(&(ptr_struct->connected_2cycbuff), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_dual:\n");
	connectib_hw_c_qpc_connected_dual_print(&(ptr_struct->connected_dual), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shared_unconnected:\n");
	connectib_hw_c_qpc_unconnected_common_print(&(ptr_struct->shared_unconnected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected:\n");
	connectib_hw_c_qpc_unconnected_print(&(ptr_struct->unconnected), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unconnected_2cycbuff:\n");
	connectib_hw_c_qpc_unconnected_2cycbuff_print(&(ptr_struct->unconnected_2cycbuff), file, indent_level + 1);

}

int connectib_hw_c_qpc_size(void){
	 return 64;
}

void connectib_hw_c_qpc_dump(const union connectib_hw_c_qpc *ptr_struct, FILE* file) {
	connectib_hw_c_qpc_print(ptr_struct, file, 0);
}

void connectib_hw_srq_pack(const struct connectib_hw_srq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->e2e_consumer_index);

	offset=198;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->srq_fw);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_consumer_index);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->e2e_producer_index);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->xrc_domain);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=293;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->e2e_credits_prefetch_threshold);

	offset=328;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->cq_number);

	offset=324;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_buffer_size);

	offset=321;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rwqe_stride);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->context_number);

	offset=355;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=354;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_drop);

	offset=353;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tcu_trap);

	offset=408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mtt_pointer_39_32);

	offset=402;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->wqe_page_offset);

	offset=401;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rx_heartbeat);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->e2e_fetch_enable);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rwqe_limit_event);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_31_0);

	offset=450;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->e2e_pa_63_34);

	offset=449;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->srq_valid);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wq_signature);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->e2e_pa_33_2);

}

void connectib_hw_srq_unpack(struct connectib_hw_srq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=208;
	ptr_struct->e2e_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=198;
	ptr_struct->srq_fw = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=240;
	ptr_struct->rwqe_consumer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->e2e_producer_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=264;
	ptr_struct->xrc_domain = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=296;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=293;
	ptr_struct->e2e_credits_prefetch_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=328;
	ptr_struct->cq_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=324;
	ptr_struct->rwqe_buffer_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=321;
	ptr_struct->rwqe_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=360;
	ptr_struct->context_number = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=355;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=354;
	ptr_struct->tcu_drop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=353;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->tcu_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=408;
	ptr_struct->mtt_pointer_39_32 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=402;
	ptr_struct->wqe_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=401;
	ptr_struct->rx_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=400;
	ptr_struct->e2e_fetch_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=384;
	ptr_struct->rwqe_limit_event = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=416;
	ptr_struct->mtt_pointer_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=450;
	ptr_struct->e2e_pa_63_34 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

	offset=449;
	ptr_struct->srq_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=448;
	ptr_struct->wq_signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=480;
	ptr_struct->e2e_pa_33_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_hw_srq_print(const struct connectib_hw_srq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_srq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_consumer_index   : "UH_FMT"\n", ptr_struct->e2e_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_fw               : "UH_FMT"\n", ptr_struct->srq_fw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_consumer_index  : "UH_FMT"\n", ptr_struct->rwqe_consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_producer_index   : "UH_FMT"\n", ptr_struct->e2e_producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xrc_domain           : "UH_FMT"\n", ptr_struct->xrc_domain);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_credits_prefetch_threshold : "UH_FMT"\n", ptr_struct->e2e_credits_prefetch_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_number            : "UH_FMT"\n", ptr_struct->cq_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_buffer_size     : "UH_FMT"\n", ptr_struct->rwqe_buffer_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_stride          : "UH_FMT"\n", ptr_struct->rwqe_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "context_number       : "UH_FMT"\n", ptr_struct->context_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_drop             : "UH_FMT"\n", ptr_struct->tcu_drop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcu_trap             : "UH_FMT"\n", ptr_struct->tcu_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_32    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_offset      : "UH_FMT"\n", ptr_struct->wqe_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_heartbeat         : "UH_FMT"\n", ptr_struct->rx_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_fetch_enable     : "UH_FMT"\n", ptr_struct->e2e_fetch_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_limit_event     : "UH_FMT"\n", ptr_struct->rwqe_limit_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_31_0     : "U32H_FMT"\n", ptr_struct->mtt_pointer_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_63_34         : "UH_FMT"\n", ptr_struct->e2e_pa_63_34);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_valid            : "UH_FMT"\n", ptr_struct->srq_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wq_signature         : "UH_FMT"\n", ptr_struct->wq_signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "e2e_pa_33_2          : "U32H_FMT"\n", ptr_struct->e2e_pa_33_2);

}

int connectib_hw_srq_size(void){
	 return 64;
}

void connectib_hw_srq_dump(const struct connectib_hw_srq *ptr_struct, FILE* file) {
	connectib_hw_srq_print(ptr_struct, file, 0);
}

void connectib_hw_toc_pack(const struct connectib_hw_toc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->eqn_offset);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->msix_offset);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->doorbell_record);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->cmdq_phy_addr);

	offset=128;
	connectib_hw_init_info_pack(&(ptr_struct->init_info), ptr_buff + offset/8);

	offset=160;
	connectib_pf_vf_cfg_space_pack(&(ptr_struct->pci_cfg_space), ptr_buff + offset/8);

	offset=408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sw_cmd_eq);

	offset=406;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->csum);

	offset=405;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ext_mod);

	offset=404;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->teardown_event);

	offset=403;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pre_icm_driver_refused);

	offset=402;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->initializing);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->flr_state);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->issi);

	offset=440;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hca_state);

	offset=438;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->nic_interface_type);

	offset=436;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->nic_interface_type_sw);

	offset=477;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->nodnic_idx);

}

void connectib_hw_toc_unpack(struct connectib_hw_toc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->eqn_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->msix_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->doorbell_record = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->cmdq_phy_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_hw_init_info_unpack(&(ptr_struct->init_info), ptr_buff + offset/8);

	offset=160;
	connectib_pf_vf_cfg_space_unpack(&(ptr_struct->pci_cfg_space), ptr_buff + offset/8);

	offset=408;
	ptr_struct->sw_cmd_eq = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=406;
	ptr_struct->csum = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=405;
	ptr_struct->ext_mod = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=404;
	ptr_struct->teardown_event = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=403;
	ptr_struct->pre_icm_driver_refused = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=402;
	ptr_struct->initializing = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=400;
	ptr_struct->flr_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=384;
	ptr_struct->issi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=440;
	ptr_struct->hca_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=438;
	ptr_struct->nic_interface_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=436;
	ptr_struct->nic_interface_type_sw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=477;
	ptr_struct->nodnic_idx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

}

void connectib_hw_toc_print(const struct connectib_hw_toc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_toc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqn_offset           : "UH_FMT"\n", ptr_struct->eqn_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_offset          : "UH_FMT"\n", ptr_struct->msix_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "doorbell_record      : "U32H_FMT"\n", ptr_struct->doorbell_record);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmdq_phy_addr        : "U64H_FMT"\n", ptr_struct->cmdq_phy_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_info:\n");
	connectib_hw_init_info_print(&(ptr_struct->init_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_cfg_space:\n");
	connectib_pf_vf_cfg_space_print(&(ptr_struct->pci_cfg_space), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_cmd_eq            : "UH_FMT"\n", ptr_struct->sw_cmd_eq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "csum                 : "UH_FMT"\n", ptr_struct->csum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_mod              : "UH_FMT"\n", ptr_struct->ext_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "teardown_event       : "UH_FMT"\n", ptr_struct->teardown_event);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre_icm_driver_refused : "UH_FMT"\n", ptr_struct->pre_icm_driver_refused);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initializing         : "UH_FMT"\n", ptr_struct->initializing);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flr_state            : "UH_FMT"\n", ptr_struct->flr_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "issi                 : "UH_FMT"\n", ptr_struct->issi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hca_state            : "UH_FMT"\n", ptr_struct->hca_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nic_interface_type   : "UH_FMT"\n", ptr_struct->nic_interface_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nic_interface_type_sw : "UH_FMT"\n", ptr_struct->nic_interface_type_sw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nodnic_idx           : "UH_FMT"\n", ptr_struct->nodnic_idx);

}

int connectib_hw_toc_size(void){
	 return 64;
}

void connectib_hw_toc_dump(const struct connectib_hw_toc *ptr_struct, FILE* file) {
	connectib_hw_toc_print(ptr_struct, file, 0);
}

void connectib_hw_mkc_pack(const struct connectib_hw_mkc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->access_mode);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lr);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lw);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rr);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->a);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->umr_en);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->small_fence_on_rdma_read_response);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->goto_pci);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->relaxed_ordering);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_snoop);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->tlp_processing_hints);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->tlp_processing_hints_en);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->free);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->mem_key);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=103;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->en_rinval);

	offset=101;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->num_of_sigerr);

	offset=99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trast_a_en);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trast_b_en);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bsf_enabled);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->length_64);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->start_address);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->length);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->bsf_octoword_count);

	offset=305;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->bsf_first_index_46_32);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 28, (u_int32_t)ptr_struct->bsf_first_index_31_4);

	offset=369;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->mtt_first_index_46_32);

	offset=384;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->mtt_first_index_31_3);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_octoword_count);

	offset=475;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->entity_size);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->generation_counter);

}

void connectib_hw_mkc_unpack(struct connectib_hw_mkc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=22;
	ptr_struct->access_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=21;
	ptr_struct->lr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->lw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->rr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->a = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->umr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->small_fence_on_rdma_read_response = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->goto_pci = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->relaxed_ordering = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->no_snoop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->tlp_processing_hints = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=9;
	ptr_struct->tlp_processing_hints_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->free = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->mem_key = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=103;
	ptr_struct->en_rinval = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=101;
	ptr_struct->num_of_sigerr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=99;
	ptr_struct->trast_a_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=98;
	ptr_struct->trast_b_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=97;
	ptr_struct->bsf_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->length_64 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=128;
	ptr_struct->start_address = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->length = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=256;
	ptr_struct->bsf_octoword_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=305;
	ptr_struct->bsf_first_index_46_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset=320;
	ptr_struct->bsf_first_index_31_4 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 28);

	offset=369;
	ptr_struct->mtt_first_index_46_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset=384;
	ptr_struct->mtt_first_index_31_3 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

	offset=416;
	ptr_struct->mtt_octoword_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=475;
	ptr_struct->entity_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=496;
	ptr_struct->generation_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_hw_mkc_print(const struct connectib_hw_mkc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_mkc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_mode          : "UH_FMT"\n", ptr_struct->access_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lr                   : "UH_FMT"\n", ptr_struct->lr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lw                   : "UH_FMT"\n", ptr_struct->lw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rr                   : "UH_FMT"\n", ptr_struct->rr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a                    : "UH_FMT"\n", ptr_struct->a);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "umr_en               : "UH_FMT"\n", ptr_struct->umr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "small_fence_on_rdma_read_response : "UH_FMT"\n", ptr_struct->small_fence_on_rdma_read_response);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "goto_pci             : "UH_FMT"\n", ptr_struct->goto_pci);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "relaxed_ordering     : "UH_FMT"\n", ptr_struct->relaxed_ordering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_snoop             : "UH_FMT"\n", ptr_struct->no_snoop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tlp_processing_hints : "UH_FMT"\n", ptr_struct->tlp_processing_hints);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tlp_processing_hints_en : "UH_FMT"\n", ptr_struct->tlp_processing_hints_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "free                 : "UH_FMT"\n", ptr_struct->free);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mem_key              : "UH_FMT"\n", ptr_struct->mem_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "en_rinval            : "UH_FMT"\n", ptr_struct->en_rinval);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_sigerr        : "UH_FMT"\n", ptr_struct->num_of_sigerr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trast_a_en           : "UH_FMT"\n", ptr_struct->trast_a_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trast_b_en           : "UH_FMT"\n", ptr_struct->trast_b_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_enabled          : "UH_FMT"\n", ptr_struct->bsf_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length_64            : "UH_FMT"\n", ptr_struct->length_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_address        : "U64H_FMT"\n", ptr_struct->start_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length               : "U64H_FMT"\n", ptr_struct->length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_octoword_count   : "U32H_FMT"\n", ptr_struct->bsf_octoword_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_first_index_46_32 : "UH_FMT"\n", ptr_struct->bsf_first_index_46_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_first_index_31_4 : "UH_FMT"\n", ptr_struct->bsf_first_index_31_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_first_index_46_32 : "UH_FMT"\n", ptr_struct->mtt_first_index_46_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_first_index_31_3 : "UH_FMT"\n", ptr_struct->mtt_first_index_31_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_octoword_count   : "U32H_FMT"\n", ptr_struct->mtt_octoword_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "entity_size          : "UH_FMT"\n", ptr_struct->entity_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "generation_counter   : "UH_FMT"\n", ptr_struct->generation_counter);

}

int connectib_hw_mkc_size(void){
	 return 64;
}

void connectib_hw_mkc_dump(const struct connectib_hw_mkc *ptr_struct, FILE* file) {
	connectib_hw_mkc_print(ptr_struct, file, 0);
}

void connectib_hw_cqc_pack(const struct connectib_hw_cqc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lookahead_size_23_8);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cqc_valid);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cqe_128b_size);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cqe_coalesce_checksum_msix);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pa_error);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_page_size);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->poll_cq_cqe_with_error_generated_on_this_queue);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->poll_cq_queue_in_error_state);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last_notified_check_for_arm_en);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->last_solicited_index);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lookahead_size_7_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pa0_63_32);

	offset=122;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->cq_page_offset);

	offset=121;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->db_recovery_enable);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cqe_heartbeat);

	offset=118;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pa_mode);

	offset=117;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->shrink);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cq_trap);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->pa0_31_12);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->moderation_cnt_limit_15_8);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->last_notified_index);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->producer_index);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->moderation_cnt_limit_7_0);

	offset=204;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->eqn_msix);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->moderation_min_wait_time);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->db_ci);

	offset=227;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log2_size);

	offset=226;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->db_heartbeat);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->number_of_events_generated);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->cipa_63_32);

	offset=317;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mtt_pointer_39_37);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->cipa_31_3);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mtt_pointer_36_5);

	offset=360;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->consumer_index);

	offset=358;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cq_state);

	offset=357;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->overrun_ignore);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->mtt_pointer_4_0);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pa1_63_32);

	offset=436;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->moderation_timestamp_51_40);

	offset=416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->pa1_31_12);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->moderation_timestamp_39_8);

	offset=488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->uar);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->moderation_timestamp_7_0);

}

void connectib_hw_cqc_unpack(struct connectib_hw_cqc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->lookahead_size_23_8 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=15;
	ptr_struct->cqc_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->cqe_128b_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->cqe_coalesce_checksum_msix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->pa_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=3;
	ptr_struct->log_page_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2;
	ptr_struct->poll_cq_cqe_with_error_generated_on_this_queue = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->poll_cq_queue_in_error_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->last_notified_check_for_arm_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=40;
	ptr_struct->last_solicited_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->lookahead_size_7_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->pa0_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=122;
	ptr_struct->cq_page_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=121;
	ptr_struct->db_recovery_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=120;
	ptr_struct->cqe_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=118;
	ptr_struct->pa_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=117;
	ptr_struct->shrink = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=116;
	ptr_struct->cq_trap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->pa0_31_12 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=152;
	ptr_struct->moderation_cnt_limit_15_8 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->last_notified_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=168;
	ptr_struct->producer_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->moderation_cnt_limit_7_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=204;
	ptr_struct->eqn_msix = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=192;
	ptr_struct->moderation_min_wait_time = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=232;
	ptr_struct->db_ci = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=227;
	ptr_struct->log2_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=226;
	ptr_struct->db_heartbeat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=224;
	ptr_struct->number_of_events_generated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=256;
	ptr_struct->cipa_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=317;
	ptr_struct->mtt_pointer_39_37 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=288;
	ptr_struct->cipa_31_3 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

	offset=320;
	ptr_struct->mtt_pointer_36_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=360;
	ptr_struct->consumer_index = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=358;
	ptr_struct->cq_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=357;
	ptr_struct->overrun_ignore = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=352;
	ptr_struct->mtt_pointer_4_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=384;
	ptr_struct->pa1_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=436;
	ptr_struct->moderation_timestamp_51_40 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=416;
	ptr_struct->pa1_31_12 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=448;
	ptr_struct->moderation_timestamp_39_8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=488;
	ptr_struct->uar = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=480;
	ptr_struct->moderation_timestamp_7_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_hw_cqc_print(const struct connectib_hw_cqc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_cqc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lookahead_size_23_8  : "UH_FMT"\n", ptr_struct->lookahead_size_23_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqc_valid            : "UH_FMT"\n", ptr_struct->cqc_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_128b_size        : "UH_FMT"\n", ptr_struct->cqe_128b_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_coalesce_checksum_msix : "UH_FMT"\n", ptr_struct->cqe_coalesce_checksum_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa_error             : "UH_FMT"\n", ptr_struct->pa_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_page_size        : "UH_FMT"\n", ptr_struct->log_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "poll_cq_cqe_with_error_generated_on_this_queue : "UH_FMT"\n", ptr_struct->poll_cq_cqe_with_error_generated_on_this_queue);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "poll_cq_queue_in_error_state : "UH_FMT"\n", ptr_struct->poll_cq_queue_in_error_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_notified_check_for_arm_en : "UH_FMT"\n", ptr_struct->last_notified_check_for_arm_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_solicited_index : "UH_FMT"\n", ptr_struct->last_solicited_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lookahead_size_7_0   : "UH_FMT"\n", ptr_struct->lookahead_size_7_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa0_63_32            : "U32H_FMT"\n", ptr_struct->pa0_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_page_offset       : "UH_FMT"\n", ptr_struct->cq_page_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_recovery_enable   : "UH_FMT"\n", ptr_struct->db_recovery_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_heartbeat        : "UH_FMT"\n", ptr_struct->cqe_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa_mode              : "UH_FMT"\n", ptr_struct->pa_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "shrink               : "UH_FMT"\n", ptr_struct->shrink);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_trap              : "UH_FMT"\n", ptr_struct->cq_trap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa0_31_12            : "UH_FMT"\n", ptr_struct->pa0_31_12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_cnt_limit_15_8 : "UH_FMT"\n", ptr_struct->moderation_cnt_limit_15_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_notified_index  : "UH_FMT"\n", ptr_struct->last_notified_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "producer_index       : "UH_FMT"\n", ptr_struct->producer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_cnt_limit_7_0 : "UH_FMT"\n", ptr_struct->moderation_cnt_limit_7_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqn_msix             : "UH_FMT"\n", ptr_struct->eqn_msix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_min_wait_time : "UH_FMT"\n", ptr_struct->moderation_min_wait_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_ci                : "UH_FMT"\n", ptr_struct->db_ci);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_size            : "UH_FMT"\n", ptr_struct->log2_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_heartbeat         : "UH_FMT"\n", ptr_struct->db_heartbeat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_of_events_generated : "UH_FMT"\n", ptr_struct->number_of_events_generated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cipa_63_32           : "U32H_FMT"\n", ptr_struct->cipa_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_39_37    : "UH_FMT"\n", ptr_struct->mtt_pointer_39_37);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cipa_31_3            : "UH_FMT"\n", ptr_struct->cipa_31_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_36_5     : "U32H_FMT"\n", ptr_struct->mtt_pointer_36_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "consumer_index       : "UH_FMT"\n", ptr_struct->consumer_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_state             : "UH_FMT"\n", ptr_struct->cq_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "overrun_ignore       : "UH_FMT"\n", ptr_struct->overrun_ignore);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt_pointer_4_0      : "UH_FMT"\n", ptr_struct->mtt_pointer_4_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa1_63_32            : "U32H_FMT"\n", ptr_struct->pa1_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_timestamp_51_40 : "UH_FMT"\n", ptr_struct->moderation_timestamp_51_40);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pa1_31_12            : "UH_FMT"\n", ptr_struct->pa1_31_12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_timestamp_39_8 : "U32H_FMT"\n", ptr_struct->moderation_timestamp_39_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uar                  : "UH_FMT"\n", ptr_struct->uar);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "moderation_timestamp_7_0 : "UH_FMT"\n", ptr_struct->moderation_timestamp_7_0);

}

int connectib_hw_cqc_size(void){
	 return 64;
}

void connectib_hw_cqc_dump(const struct connectib_hw_cqc *ptr_struct, FILE* file) {
	connectib_hw_cqc_print(ptr_struct, file, 0);
}

void connectib_ffe_tap_set_pack(const struct connectib_ffe_tap_set *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap0);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap1);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap2);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap3);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ffe_tap4);

}

void connectib_ffe_tap_set_unpack(struct connectib_ffe_tap_set *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->ffe_tap0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->ffe_tap1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->ffe_tap2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->ffe_tap3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=56;
	ptr_struct->ffe_tap4 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_ffe_tap_set_print(const struct connectib_ffe_tap_set *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ffe_tap_set ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap0             : "UH_FMT"\n", ptr_struct->ffe_tap0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap1             : "UH_FMT"\n", ptr_struct->ffe_tap1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap2             : "UH_FMT"\n", ptr_struct->ffe_tap2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap3             : "UH_FMT"\n", ptr_struct->ffe_tap3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap4             : "UH_FMT"\n", ptr_struct->ffe_tap4);

}

int connectib_ffe_tap_set_size(void){
	 return 8;
}

void connectib_ffe_tap_set_dump(const struct connectib_ffe_tap_set *ptr_struct, FILE* file) {
	connectib_ffe_tap_set_print(ptr_struct, file, 0);
}

void connectib_GEN3_TRANSMITTER_SETTING_pack(const struct connectib_GEN3_TRANSMITTER_SETTING *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->post);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reject_coeff);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->parity);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->main);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->pre);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ec);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reset_eieos);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->preset);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->use_preset);

}

void connectib_GEN3_TRANSMITTER_SETTING_unpack(struct connectib_GEN3_TRANSMITTER_SETTING *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->post = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=25;
	ptr_struct->reject_coeff = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->parity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=10;
	ptr_struct->pre = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=6;
	ptr_struct->ec = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=5;
	ptr_struct->reset_eieos = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->preset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->use_preset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_GEN3_TRANSMITTER_SETTING_print(const struct connectib_GEN3_TRANSMITTER_SETTING *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_GEN3_TRANSMITTER_SETTING ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "post                 : "UH_FMT"\n", ptr_struct->post);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reject_coeff         : "UH_FMT"\n", ptr_struct->reject_coeff);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parity               : "UH_FMT"\n", ptr_struct->parity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "main                 : "UH_FMT"\n", ptr_struct->main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pre                  : "UH_FMT"\n", ptr_struct->pre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ec                   : "UH_FMT"\n", ptr_struct->ec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_eieos          : "UH_FMT"\n", ptr_struct->reset_eieos);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset               : "UH_FMT"\n", ptr_struct->preset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "use_preset           : "UH_FMT"\n", ptr_struct->use_preset);

}

int connectib_GEN3_TRANSMITTER_SETTING_size(void){
	 return 4;
}

void connectib_GEN3_TRANSMITTER_SETTING_dump(const struct connectib_GEN3_TRANSMITTER_SETTING *ptr_struct, FILE* file) {
	connectib_GEN3_TRANSMITTER_SETTING_print(ptr_struct, file, 0);
}

void connectib_gpio_config_pack(const struct connectib_gpio_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mode0);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mode1);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->def_val);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pull_up);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pull_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->masked);

}

void connectib_gpio_config_unpack(struct connectib_gpio_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=7;
	ptr_struct->mode0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->mode1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->def_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->pull_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->pull_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->masked = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_gpio_config_print(const struct connectib_gpio_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_gpio_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mode0                : "UH_FMT"\n", ptr_struct->mode0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mode1                : "UH_FMT"\n", ptr_struct->mode1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "def_val              : "UH_FMT"\n", ptr_struct->def_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pull_up              : "UH_FMT"\n", ptr_struct->pull_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pull_en              : "UH_FMT"\n", ptr_struct->pull_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "masked               : "UH_FMT"\n", ptr_struct->masked);

}

int connectib_gpio_config_size(void){
	 return 1;
}

void connectib_gpio_config_dump(const struct connectib_gpio_config *ptr_struct, FILE* file) {
	connectib_gpio_config_print(ptr_struct, file, 0);
}

void connectib_gpio_function_pack(const struct connectib_gpio_function *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mapping);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reverse_polarity);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->masked);

}

void connectib_gpio_function_unpack(struct connectib_gpio_function *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	ptr_struct->mapping = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=1;
	ptr_struct->reverse_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->masked = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_gpio_function_print(const struct connectib_gpio_function *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_gpio_function ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mapping              : "UH_FMT"\n", ptr_struct->mapping);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reverse_polarity     : "UH_FMT"\n", ptr_struct->reverse_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "masked               : "UH_FMT"\n", ptr_struct->masked);

}

int connectib_gpio_function_size(void){
	 return 1;
}

void connectib_gpio_function_dump(const struct connectib_gpio_function *ptr_struct, FILE* file) {
	connectib_gpio_function_print(ptr_struct, file, 0);
}

void connectib_mlpn_enhanced_database_ini_pack(const struct connectib_mlpn_enhanced_database_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlnx_enhanced_equal_info_ini_pack(&(ptr_struct->as_bits), ptr_buff + offset/8);

}

void connectib_mlpn_enhanced_database_ini_unpack(struct connectib_mlpn_enhanced_database_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlnx_enhanced_equal_info_ini_unpack(&(ptr_struct->as_bits), ptr_buff + offset/8);

}

void connectib_mlpn_enhanced_database_ini_print(const struct connectib_mlpn_enhanced_database_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mlpn_enhanced_database_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_bits:\n");
	connectib_mlnx_enhanced_equal_info_ini_print(&(ptr_struct->as_bits), file, indent_level + 1);

}

int connectib_mlpn_enhanced_database_ini_size(void){
	 return 4;
}

void connectib_mlpn_enhanced_database_ini_dump(const struct connectib_mlpn_enhanced_database_ini *ptr_struct, FILE* file) {
	connectib_mlpn_enhanced_database_ini_print(ptr_struct, file, 0);
}

void connectib_mlpn_database_all_protocol_ini_pack(const struct connectib_mlpn_database_all_protocol_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlpn_database_all_protocol_bits_ini_pack(&(ptr_struct->as_bits), ptr_buff + offset/8);

}

void connectib_mlpn_database_all_protocol_ini_unpack(struct connectib_mlpn_database_all_protocol_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlpn_database_all_protocol_bits_ini_unpack(&(ptr_struct->as_bits), ptr_buff + offset/8);

}

void connectib_mlpn_database_all_protocol_ini_print(const struct connectib_mlpn_database_all_protocol_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mlpn_database_all_protocol_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_bits:\n");
	connectib_mlpn_database_all_protocol_bits_ini_print(&(ptr_struct->as_bits), file, indent_level + 1);

}

int connectib_mlpn_database_all_protocol_ini_size(void){
	 return 4;
}

void connectib_mlpn_database_all_protocol_ini_dump(const struct connectib_mlpn_database_all_protocol_ini *ptr_struct, FILE* file) {
	connectib_mlpn_database_all_protocol_ini_print(ptr_struct, file, 0);
}

void connectib_tx_rx_logic_serdes_mapping_node_ini_pack(const struct connectib_tx_rx_logic_serdes_mapping_node_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->logic_to_serdes[i]);
	}

}

void connectib_tx_rx_logic_serdes_mapping_node_ini_unpack(struct connectib_tx_rx_logic_serdes_mapping_node_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	ptr_struct->logic_to_serdes[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_tx_rx_logic_serdes_mapping_node_ini_print(const struct connectib_tx_rx_logic_serdes_mapping_node_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_tx_rx_logic_serdes_mapping_node_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "logic_to_serdes_%03d : "U32H_FMT"\n", i, ptr_struct->logic_to_serdes[i]);
	}

}

int connectib_tx_rx_logic_serdes_mapping_node_ini_size(void){
	 return 32;
}

void connectib_tx_rx_logic_serdes_mapping_node_ini_dump(const struct connectib_tx_rx_logic_serdes_mapping_node_ini *ptr_struct, FILE* file) {
	connectib_tx_rx_logic_serdes_mapping_node_ini_print(ptr_struct, file, 0);
}

void connectib_serdes_conf_ini_pack(const struct connectib_serdes_conf_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_autoneg_sets_ini_pack(&(ptr_struct->nego), ptr_buff + offset/8);

	offset=3072;
	connectib_serdes_aba_sets_ini_pack(&(ptr_struct->aba), ptr_buff + offset/8);

	offset=6144;
	connectib_serdes_force_sets_ini_pack(&(ptr_struct->force), ptr_buff + offset/8);

	offset=7104;
	connectib_serdes_active_sets_ini_pack(&(ptr_struct->active), ptr_buff + offset/8);

	offset=7488;
	connectib_serdes_preset_sets_ini_pack(&(ptr_struct->preset_tx_fdr), ptr_buff + offset/8);

	offset=8000;
	connectib_serdes_preset_sets_ini_pack(&(ptr_struct->preset_tx_qdr), ptr_buff + offset/8);

}

void connectib_serdes_conf_ini_unpack(struct connectib_serdes_conf_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_autoneg_sets_ini_unpack(&(ptr_struct->nego), ptr_buff + offset/8);

	offset=3072;
	connectib_serdes_aba_sets_ini_unpack(&(ptr_struct->aba), ptr_buff + offset/8);

	offset=6144;
	connectib_serdes_force_sets_ini_unpack(&(ptr_struct->force), ptr_buff + offset/8);

	offset=7104;
	connectib_serdes_active_sets_ini_unpack(&(ptr_struct->active), ptr_buff + offset/8);

	offset=7488;
	connectib_serdes_preset_sets_ini_unpack(&(ptr_struct->preset_tx_fdr), ptr_buff + offset/8);

	offset=8000;
	connectib_serdes_preset_sets_ini_unpack(&(ptr_struct->preset_tx_qdr), ptr_buff + offset/8);

}

void connectib_serdes_conf_ini_print(const struct connectib_serdes_conf_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_serdes_conf_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nego:\n");
	connectib_serdes_autoneg_sets_ini_print(&(ptr_struct->nego), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aba:\n");
	connectib_serdes_aba_sets_ini_print(&(ptr_struct->aba), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force:\n");
	connectib_serdes_force_sets_ini_print(&(ptr_struct->force), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active:\n");
	connectib_serdes_active_sets_ini_print(&(ptr_struct->active), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset_tx_fdr:\n");
	connectib_serdes_preset_sets_ini_print(&(ptr_struct->preset_tx_fdr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset_tx_qdr:\n");
	connectib_serdes_preset_sets_ini_print(&(ptr_struct->preset_tx_qdr), file, indent_level + 1);

}

int connectib_serdes_conf_ini_size(void){
	 return 1088;
}

void connectib_serdes_conf_ini_dump(const struct connectib_serdes_conf_ini *ptr_struct, FILE* file) {
	connectib_serdes_conf_ini_print(ptr_struct, file, 0);
}

void connectib_rx_adapt_ini_pack(const struct connectib_rx_adapt_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->max_num_ffe_search);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->num_of_ffe_taps);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->num_of_ffe_hw_steps);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_hw_ffe_before_open_eye);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->skip_ffe_srch);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->skip_rx_srch);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->offset_eye_opener_range);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mixer_offset_grade_margin);

	offset=60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->jump_size_ffe_level1);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->jump_size_ffe_level2);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->jump_size_ffe_level3);

	offset=47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->delta_from_edges_phase);

	offset=41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->delta_from_edges_offst);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->offset_penalty_en);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->offset_penalty_weight);

	offset=95;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->center_mix90phase);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->disable_calib_in_QDR_rev0);

	offset=93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->center_mixer_offset);

	offset=92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grade_mixer_margin_en);

	offset=87;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->eye_open_machine_measure_time);

	offset=82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->eye_open_machine_stab_time);

	offset=74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->best_grade_th);

	offset=69;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->eye_open_machine_stab_time_extended);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eye_phase_diff_min);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eye_offset_diff_min);

	offset=111;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->min_eye_en);

	offset=110;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grade_eye_from_center);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->offset_zero_grade_threshold);

	offset=99;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->eye_open_machine_measure_time_in_stab_extend);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->offset_max_grade);

	offset=147;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phase_limit);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rx_adaptation_reattempts);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_weight);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->offset_weight);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rx_taps_norm_val);

}

void connectib_rx_adapt_ini_unpack(struct connectib_rx_adapt_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->max_num_ffe_search = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=23;
	ptr_struct->num_of_ffe_taps = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=17;
	ptr_struct->num_of_ffe_hw_steps = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=13;
	ptr_struct->num_hw_ffe_before_open_eye = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=12;
	ptr_struct->skip_ffe_srch = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->skip_rx_srch = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=4;
	ptr_struct->offset_eye_opener_range = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=0;
	ptr_struct->mixer_offset_grade_margin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=60;
	ptr_struct->jump_size_ffe_level1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=56;
	ptr_struct->jump_size_ffe_level2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=52;
	ptr_struct->jump_size_ffe_level3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=47;
	ptr_struct->delta_from_edges_phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=41;
	ptr_struct->delta_from_edges_offst = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=40;
	ptr_struct->offset_penalty_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->offset_penalty_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=95;
	ptr_struct->center_mix90phase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->disable_calib_in_QDR_rev0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=93;
	ptr_struct->center_mixer_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=92;
	ptr_struct->grade_mixer_margin_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=87;
	ptr_struct->eye_open_machine_measure_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=82;
	ptr_struct->eye_open_machine_stab_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=74;
	ptr_struct->best_grade_th = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=69;
	ptr_struct->eye_open_machine_stab_time_extended = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=120;
	ptr_struct->eye_phase_diff_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=112;
	ptr_struct->eye_offset_diff_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=111;
	ptr_struct->min_eye_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=110;
	ptr_struct->grade_eye_from_center = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=104;
	ptr_struct->offset_zero_grade_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=99;
	ptr_struct->eye_open_machine_measure_time_in_stab_extend = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=152;
	ptr_struct->offset_max_grade = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=147;
	ptr_struct->phase_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=144;
	ptr_struct->rx_adaptation_reattempts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=136;
	ptr_struct->phase_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->offset_weight = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=184;
	ptr_struct->rx_taps_norm_val = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_rx_adapt_ini_print(const struct connectib_rx_adapt_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rx_adapt_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_num_ffe_search   : "UH_FMT"\n", ptr_struct->max_num_ffe_search);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_ffe_taps      : "UH_FMT"\n", ptr_struct->num_of_ffe_taps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_ffe_hw_steps  : "UH_FMT"\n", ptr_struct->num_of_ffe_hw_steps);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_hw_ffe_before_open_eye : "UH_FMT"\n", ptr_struct->num_hw_ffe_before_open_eye);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "skip_ffe_srch        : "UH_FMT"\n", ptr_struct->skip_ffe_srch);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "skip_rx_srch         : "UH_FMT"\n", ptr_struct->skip_rx_srch);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_eye_opener_range : "UH_FMT"\n", ptr_struct->offset_eye_opener_range);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mixer_offset_grade_margin : "UH_FMT"\n", ptr_struct->mixer_offset_grade_margin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "jump_size_ffe_level1 : "UH_FMT"\n", ptr_struct->jump_size_ffe_level1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "jump_size_ffe_level2 : "UH_FMT"\n", ptr_struct->jump_size_ffe_level2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "jump_size_ffe_level3 : "UH_FMT"\n", ptr_struct->jump_size_ffe_level3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "delta_from_edges_phase : "UH_FMT"\n", ptr_struct->delta_from_edges_phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "delta_from_edges_offst : "UH_FMT"\n", ptr_struct->delta_from_edges_offst);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_penalty_en    : "UH_FMT"\n", ptr_struct->offset_penalty_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_penalty_weight : "UH_FMT"\n", ptr_struct->offset_penalty_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "center_mix90phase    : "UH_FMT"\n", ptr_struct->center_mix90phase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_calib_in_QDR_rev0 : "UH_FMT"\n", ptr_struct->disable_calib_in_QDR_rev0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "center_mixer_offset  : "UH_FMT"\n", ptr_struct->center_mixer_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_mixer_margin_en : "UH_FMT"\n", ptr_struct->grade_mixer_margin_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_open_machine_measure_time : "UH_FMT"\n", ptr_struct->eye_open_machine_measure_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_open_machine_stab_time : "UH_FMT"\n", ptr_struct->eye_open_machine_stab_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "best_grade_th        : "UH_FMT"\n", ptr_struct->best_grade_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_open_machine_stab_time_extended : "UH_FMT"\n", ptr_struct->eye_open_machine_stab_time_extended);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_phase_diff_min   : "UH_FMT"\n", ptr_struct->eye_phase_diff_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_offset_diff_min  : "UH_FMT"\n", ptr_struct->eye_offset_diff_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_eye_en           : "UH_FMT"\n", ptr_struct->min_eye_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grade_eye_from_center : "UH_FMT"\n", ptr_struct->grade_eye_from_center);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_zero_grade_threshold : "UH_FMT"\n", ptr_struct->offset_zero_grade_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_open_machine_measure_time_in_stab_extend : "UH_FMT"\n", ptr_struct->eye_open_machine_measure_time_in_stab_extend);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_max_grade     : "UH_FMT"\n", ptr_struct->offset_max_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_limit          : "UH_FMT"\n", ptr_struct->phase_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_adaptation_reattempts : "UH_FMT"\n", ptr_struct->rx_adaptation_reattempts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_weight         : "UH_FMT"\n", ptr_struct->phase_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_weight        : "UH_FMT"\n", ptr_struct->offset_weight);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_taps_norm_val     : "UH_FMT"\n", ptr_struct->rx_taps_norm_val);

}

int connectib_rx_adapt_ini_size(void){
	 return 24;
}

void connectib_rx_adapt_ini_dump(const struct connectib_rx_adapt_ini *ptr_struct, FILE* file) {
	connectib_rx_adapt_ini_print(ptr_struct, file, 0);
}

void connectib_ib_ini_ini_pack(const struct connectib_ib_ini_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->llr_wait_time);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spec1_3_ignore_peer_tx_req);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qdr_tx_aggressor_en);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->equal_req_en);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ts3_fcu);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ts3_hbr);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ts3_sct);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ts3_tp);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ts3_mpr);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ts3_ft);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->min_ib_grade);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_polarity_port0);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_polarity_port1);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->Mloop_en_mask);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 768, 1);
	connectib_ib_ini_per_lcl_ini_pack(&(ptr_struct->lcl[i]), ptr_buff + offset/8);
	}

	offset=121;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->retry_counter_threshold);

	offset=113;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->time_2_clear_err_after_linkup);

	offset=128;
	connectib_spec1_3_preset_ini_pack(&(ptr_struct->spec1_3_preset), ptr_buff + offset/8);

	offset=767;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->disable_llr_on_long_optic);

	offset=760;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->llr_max_cable_length);

	offset=759;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->terminate_pkt_timeout);

	offset=758;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_rx_check_en);

	offset=757;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_fec_on_long_optic);

	offset=750;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->fec_min_cable_length);

}

void connectib_ib_ini_ini_unpack(struct connectib_ib_ini_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->llr_wait_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=25;
	ptr_struct->spec1_3_ignore_peer_tx_req = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->qdr_tx_aggressor_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->equal_req_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->ts3_fcu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=20;
	ptr_struct->ts3_hbr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->ts3_sct = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->ts3_tp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->ts3_mpr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->ts3_ft = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=11;
	ptr_struct->min_ib_grade = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=7;
	ptr_struct->tx_polarity_port0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=3;
	ptr_struct->tx_polarity_port1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=1;
	ptr_struct->Mloop_en_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 768, 1);
	connectib_ib_ini_per_lcl_ini_unpack(&(ptr_struct->lcl[i]), ptr_buff + offset/8);
	}

	offset=121;
	ptr_struct->retry_counter_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=113;
	ptr_struct->time_2_clear_err_after_linkup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_spec1_3_preset_ini_unpack(&(ptr_struct->spec1_3_preset), ptr_buff + offset/8);

	offset=767;
	ptr_struct->disable_llr_on_long_optic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=760;
	ptr_struct->llr_max_cable_length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=759;
	ptr_struct->terminate_pkt_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=758;
	ptr_struct->llr_rx_check_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=757;
	ptr_struct->enable_fec_on_long_optic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=750;
	ptr_struct->fec_min_cable_length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void connectib_ib_ini_ini_print(const struct connectib_ib_ini_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ib_ini_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_wait_time        : "UH_FMT"\n", ptr_struct->llr_wait_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec1_3_ignore_peer_tx_req : "UH_FMT"\n", ptr_struct->spec1_3_ignore_peer_tx_req);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qdr_tx_aggressor_en  : "UH_FMT"\n", ptr_struct->qdr_tx_aggressor_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "equal_req_en         : "UH_FMT"\n", ptr_struct->equal_req_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_fcu              : "UH_FMT"\n", ptr_struct->ts3_fcu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_hbr              : "UH_FMT"\n", ptr_struct->ts3_hbr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_sct              : "UH_FMT"\n", ptr_struct->ts3_sct);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_tp               : "UH_FMT"\n", ptr_struct->ts3_tp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_mpr              : "UH_FMT"\n", ptr_struct->ts3_mpr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ts3_ft               : "UH_FMT"\n", ptr_struct->ts3_ft);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_ib_grade         : "UH_FMT"\n", ptr_struct->min_ib_grade);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_polarity_port0    : "UH_FMT"\n", ptr_struct->tx_polarity_port0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_polarity_port1    : "UH_FMT"\n", ptr_struct->tx_polarity_port1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Mloop_en_mask        : "UH_FMT"\n", ptr_struct->Mloop_en_mask);

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lcl_%03d:\n", i);
	connectib_ib_ini_per_lcl_ini_print(&(ptr_struct->lcl[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "retry_counter_threshold : "UH_FMT"\n", ptr_struct->retry_counter_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "time_2_clear_err_after_linkup : "UH_FMT"\n", ptr_struct->time_2_clear_err_after_linkup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spec1_3_preset:\n");
	connectib_spec1_3_preset_ini_print(&(ptr_struct->spec1_3_preset), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_llr_on_long_optic : "UH_FMT"\n", ptr_struct->disable_llr_on_long_optic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_max_cable_length : "UH_FMT"\n", ptr_struct->llr_max_cable_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "terminate_pkt_timeout : "UH_FMT"\n", ptr_struct->terminate_pkt_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_rx_check_en      : "UH_FMT"\n", ptr_struct->llr_rx_check_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_fec_on_long_optic : "UH_FMT"\n", ptr_struct->enable_fec_on_long_optic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fec_min_cable_length : "UH_FMT"\n", ptr_struct->fec_min_cable_length);

}

int connectib_ib_ini_ini_size(void){
	 return 96;
}

void connectib_ib_ini_ini_dump(const struct connectib_ib_ini_ini *ptr_struct, FILE* file) {
	connectib_ib_ini_ini_print(ptr_struct, file, 0);
}

void connectib_PORT_PHY_ini_pack(const struct connectib_PORT_PHY_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_param_mask_ini_pack(&(ptr_struct->serdes_param_mask), ptr_buff + offset/8);

}

void connectib_PORT_PHY_ini_unpack(struct connectib_PORT_PHY_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_serdes_param_mask_ini_unpack(&(ptr_struct->serdes_param_mask), ptr_buff + offset/8);

}

void connectib_PORT_PHY_ini_print(const struct connectib_PORT_PHY_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_PORT_PHY_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serdes_param_mask:\n");
	connectib_serdes_param_mask_ini_print(&(ptr_struct->serdes_param_mask), file, indent_level + 1);

}

int connectib_PORT_PHY_ini_size(void){
	 return 16;
}

void connectib_PORT_PHY_ini_dump(const struct connectib_PORT_PHY_ini *ptr_struct, FILE* file) {
	connectib_PORT_PHY_ini_print(ptr_struct, file, 0);
}

void connectib_nv_config_tpt_pack(const struct connectib_nv_config_tpt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_tpt_settings_pack(&(ptr_struct->settings), ptr_buff + offset/8);

	offset=32;
	connectib_nv_tlv_data_tpt_capabilities_pack(&(ptr_struct->capabilities), ptr_buff + offset/8);

}

void connectib_nv_config_tpt_unpack(struct connectib_nv_config_tpt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_tpt_settings_unpack(&(ptr_struct->settings), ptr_buff + offset/8);

	offset=32;
	connectib_nv_tlv_data_tpt_capabilities_unpack(&(ptr_struct->capabilities), ptr_buff + offset/8);

}

void connectib_nv_config_tpt_print(const struct connectib_nv_config_tpt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_tpt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "settings:\n");
	connectib_nv_tlv_data_tpt_settings_print(&(ptr_struct->settings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capabilities:\n");
	connectib_nv_tlv_data_tpt_capabilities_print(&(ptr_struct->capabilities), file, indent_level + 1);

}

int connectib_nv_config_tpt_size(void){
	 return 8;
}

void connectib_nv_config_tpt_dump(const struct connectib_nv_config_tpt *ptr_struct, FILE* file) {
	connectib_nv_config_tpt_print(ptr_struct, file, 0);
}

void connectib_nv_config_pci_pack(const struct connectib_nv_config_pci *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_pci_settings_pack(&(ptr_struct->settings), ptr_buff + offset/8);

	offset=96;
	connectib_nv_tlv_data_pci_capabilities_pack(&(ptr_struct->capabilities), ptr_buff + offset/8);

}

void connectib_nv_config_pci_unpack(struct connectib_nv_config_pci *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_pci_settings_unpack(&(ptr_struct->settings), ptr_buff + offset/8);

	offset=96;
	connectib_nv_tlv_data_pci_capabilities_unpack(&(ptr_struct->capabilities), ptr_buff + offset/8);

}

void connectib_nv_config_pci_print(const struct connectib_nv_config_pci *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_pci ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "settings:\n");
	connectib_nv_tlv_data_pci_settings_print(&(ptr_struct->settings), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capabilities:\n");
	connectib_nv_tlv_data_pci_capabilities_print(&(ptr_struct->capabilities), file, indent_level + 1);

}

int connectib_nv_config_pci_size(void){
	 return 32;
}

void connectib_nv_config_pci_dump(const struct connectib_nv_config_pci *ptr_struct, FILE* file) {
	connectib_nv_config_pci_print(ptr_struct, file, 0);
}

void connectib_advanced_error_reporting_pack(const struct connectib_advanced_error_reporting *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_id);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->nxt_ptr);

	offset=32;
	connectib_uncorrectable_error_status_pack(&(ptr_struct->uncorrectable_error_status), ptr_buff + offset/8);

	offset=64;
	connectib_uncorrectable_error_mask_pack(&(ptr_struct->uncorrectable_error_mask), ptr_buff + offset/8);

	offset=96;
	connectib_uncorrectable_error_severity_pack(&(ptr_struct->uncorrectable_error_severity), ptr_buff + offset/8);

	offset=128;
	connectib_correctable_error_status_pack(&(ptr_struct->correctable_error_status), ptr_buff + offset/8);

	offset=160;
	connectib_correctable_error_mask_pack(&(ptr_struct->correctable_error_mask), ptr_buff + offset/8);

	offset=192;
	connectib_advanced_error_cap_ctl_pack(&(ptr_struct->advanced_error_cap_ctl), ptr_buff + offset/8);

	offset=224;
	connectib_header_log_pack(&(ptr_struct->header_log), ptr_buff + offset/8);

}

void connectib_advanced_error_reporting_unpack(struct connectib_advanced_error_reporting *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->nxt_ptr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=32;
	connectib_uncorrectable_error_status_unpack(&(ptr_struct->uncorrectable_error_status), ptr_buff + offset/8);

	offset=64;
	connectib_uncorrectable_error_mask_unpack(&(ptr_struct->uncorrectable_error_mask), ptr_buff + offset/8);

	offset=96;
	connectib_uncorrectable_error_severity_unpack(&(ptr_struct->uncorrectable_error_severity), ptr_buff + offset/8);

	offset=128;
	connectib_correctable_error_status_unpack(&(ptr_struct->correctable_error_status), ptr_buff + offset/8);

	offset=160;
	connectib_correctable_error_mask_unpack(&(ptr_struct->correctable_error_mask), ptr_buff + offset/8);

	offset=192;
	connectib_advanced_error_cap_ctl_unpack(&(ptr_struct->advanced_error_cap_ctl), ptr_buff + offset/8);

	offset=224;
	connectib_header_log_unpack(&(ptr_struct->header_log), ptr_buff + offset/8);

}

void connectib_advanced_error_reporting_print(const struct connectib_advanced_error_reporting *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_advanced_error_reporting ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncorrectable_error_status:\n");
	connectib_uncorrectable_error_status_print(&(ptr_struct->uncorrectable_error_status), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncorrectable_error_mask:\n");
	connectib_uncorrectable_error_mask_print(&(ptr_struct->uncorrectable_error_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uncorrectable_error_severity:\n");
	connectib_uncorrectable_error_severity_print(&(ptr_struct->uncorrectable_error_severity), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "correctable_error_status:\n");
	connectib_correctable_error_status_print(&(ptr_struct->correctable_error_status), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "correctable_error_mask:\n");
	connectib_correctable_error_mask_print(&(ptr_struct->correctable_error_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advanced_error_cap_ctl:\n");
	connectib_advanced_error_cap_ctl_print(&(ptr_struct->advanced_error_cap_ctl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header_log:\n");
	connectib_header_log_print(&(ptr_struct->header_log), file, indent_level + 1);

}

int connectib_advanced_error_reporting_size(void){
	 return 56;
}

void connectib_advanced_error_reporting_dump(const struct connectib_advanced_error_reporting *ptr_struct, FILE* file) {
	connectib_advanced_error_reporting_print(ptr_struct, file, 0);
}

void connectib_dev_serial_num_cap_pack(const struct connectib_dev_serial_num_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_id);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->nxt_ptr);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->serial_number_31_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->serial_number_63_32);

}

void connectib_dev_serial_num_cap_unpack(struct connectib_dev_serial_num_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->nxt_ptr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=32;
	ptr_struct->serial_number_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->serial_number_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_dev_serial_num_cap_print(const struct connectib_dev_serial_num_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dev_serial_num_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serial_number_31_0   : "U32H_FMT"\n", ptr_struct->serial_number_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serial_number_63_32  : "U32H_FMT"\n", ptr_struct->serial_number_63_32);

}

int connectib_dev_serial_num_cap_size(void){
	 return 12;
}

void connectib_dev_serial_num_cap_dump(const struct connectib_dev_serial_num_cap *ptr_struct, FILE* file) {
	connectib_dev_serial_num_cap_print(ptr_struct, file, 0);
}

void connectib_sriov_cap_pack(const struct connectib_sriov_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_id);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->nxt_ptr);

	offset=32;
	connectib_sriov_capabilities_pack(&(ptr_struct->capabilities), ptr_buff + offset/8);

	offset=80;
	connectib_sriov_control_pack(&(ptr_struct->ctrl), ptr_buff + offset/8);

	offset=64;
	connectib_sriov_status_pack(&(ptr_struct->status), ptr_buff + offset/8);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->initial_vfs);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->total_vfs);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_vfs);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->func_dependency_link);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->first_vf_offset);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vf_stride);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vf_device_id);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->supported_page_sizes);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->system_page_size);

	offset=288;
	connectib_bar_low_pack(&(ptr_struct->vf_bar0), ptr_buff + offset/8);

	offset=320;
	connectib_bar_high_pack(&(ptr_struct->vf_bar1), ptr_buff + offset/8);

	offset=352;
	connectib_bar_low_pack(&(ptr_struct->vf_bar2), ptr_buff + offset/8);

	offset=384;
	connectib_bar_high_pack(&(ptr_struct->vf_bar3), ptr_buff + offset/8);

	offset=416;
	connectib_bar_low_pack(&(ptr_struct->vf_bar4), ptr_buff + offset/8);

	offset=448;
	connectib_bar_high_pack(&(ptr_struct->vf_bar5), ptr_buff + offset/8);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->vf_migstate_arrayofst);

}

void connectib_sriov_cap_unpack(struct connectib_sriov_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->nxt_ptr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=32;
	connectib_sriov_capabilities_unpack(&(ptr_struct->capabilities), ptr_buff + offset/8);

	offset=80;
	connectib_sriov_control_unpack(&(ptr_struct->ctrl), ptr_buff + offset/8);

	offset=64;
	connectib_sriov_status_unpack(&(ptr_struct->status), ptr_buff + offset/8);

	offset=112;
	ptr_struct->initial_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->total_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=144;
	ptr_struct->num_vfs = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=136;
	ptr_struct->func_dependency_link = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=176;
	ptr_struct->first_vf_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->vf_stride = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->vf_device_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->supported_page_sizes = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->system_page_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	connectib_bar_low_unpack(&(ptr_struct->vf_bar0), ptr_buff + offset/8);

	offset=320;
	connectib_bar_high_unpack(&(ptr_struct->vf_bar1), ptr_buff + offset/8);

	offset=352;
	connectib_bar_low_unpack(&(ptr_struct->vf_bar2), ptr_buff + offset/8);

	offset=384;
	connectib_bar_high_unpack(&(ptr_struct->vf_bar3), ptr_buff + offset/8);

	offset=416;
	connectib_bar_low_unpack(&(ptr_struct->vf_bar4), ptr_buff + offset/8);

	offset=448;
	connectib_bar_high_unpack(&(ptr_struct->vf_bar5), ptr_buff + offset/8);

	offset=480;
	ptr_struct->vf_migstate_arrayofst = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_sriov_cap_print(const struct connectib_sriov_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sriov_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "capabilities:\n");
	connectib_sriov_capabilities_print(&(ptr_struct->capabilities), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctrl:\n");
	connectib_sriov_control_print(&(ptr_struct->ctrl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status:\n");
	connectib_sriov_status_print(&(ptr_struct->status), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_vfs          : "UH_FMT"\n", ptr_struct->initial_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "total_vfs            : "UH_FMT"\n", ptr_struct->total_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vfs              : "UH_FMT"\n", ptr_struct->num_vfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "func_dependency_link : "UH_FMT"\n", ptr_struct->func_dependency_link);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_vf_offset      : "UH_FMT"\n", ptr_struct->first_vf_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_stride            : "UH_FMT"\n", ptr_struct->vf_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_device_id         : "UH_FMT"\n", ptr_struct->vf_device_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "supported_page_sizes : "U32H_FMT"\n", ptr_struct->supported_page_sizes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "system_page_size     : "U32H_FMT"\n", ptr_struct->system_page_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar0:\n");
	connectib_bar_low_print(&(ptr_struct->vf_bar0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar1:\n");
	connectib_bar_high_print(&(ptr_struct->vf_bar1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar2:\n");
	connectib_bar_low_print(&(ptr_struct->vf_bar2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar3:\n");
	connectib_bar_high_print(&(ptr_struct->vf_bar3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar4:\n");
	connectib_bar_low_print(&(ptr_struct->vf_bar4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_bar5:\n");
	connectib_bar_high_print(&(ptr_struct->vf_bar5), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_migstate_arrayofst : "U32H_FMT"\n", ptr_struct->vf_migstate_arrayofst);

}

int connectib_sriov_cap_size(void){
	 return 64;
}

void connectib_sriov_cap_dump(const struct connectib_sriov_cap *ptr_struct, FILE* file) {
	connectib_sriov_cap_print(ptr_struct, file, 0);
}

void connectib_ari_cap_pack(const struct connectib_ari_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_id);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->nxt_ptr);

	offset=48;
	connectib_ari_capabilities_pack(&(ptr_struct->ari_capabilities), ptr_buff + offset/8);

	offset=32;
	connectib_ari_control_pack(&(ptr_struct->ari_control), ptr_buff + offset/8);

}

void connectib_ari_cap_unpack(struct connectib_ari_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->nxt_ptr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=48;
	connectib_ari_capabilities_unpack(&(ptr_struct->ari_capabilities), ptr_buff + offset/8);

	offset=32;
	connectib_ari_control_unpack(&(ptr_struct->ari_control), ptr_buff + offset/8);

}

void connectib_ari_cap_print(const struct connectib_ari_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ari_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_capabilities:\n");
	connectib_ari_capabilities_print(&(ptr_struct->ari_capabilities), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_control:\n");
	connectib_ari_control_print(&(ptr_struct->ari_control), file, indent_level + 1);

}

int connectib_ari_cap_size(void){
	 return 8;
}

void connectib_ari_cap_dump(const struct connectib_ari_cap *ptr_struct, FILE* file) {
	connectib_ari_cap_print(ptr_struct, file, 0);
}

void connectib_secondary_pciex_ext_cap_pack(const struct connectib_secondary_pciex_ext_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_id);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->nxt_ptr);

	offset=32;
	connectib_pciex_link_ctl3_pack(&(ptr_struct->pciex_link_ctl3), ptr_buff + offset/8);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lane_err_bits);

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(96, 32, i, 352, 1);
	connectib_lane_eql_ctl_pack(&(ptr_struct->lane_eql_ctl[i]), ptr_buff + offset/8);
	}

}

void connectib_secondary_pciex_ext_cap_unpack(struct connectib_secondary_pciex_ext_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->nxt_ptr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=32;
	connectib_pciex_link_ctl3_unpack(&(ptr_struct->pciex_link_ctl3), ptr_buff + offset/8);

	offset=80;
	ptr_struct->lane_err_bits = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(96, 32, i, 352, 1);
	connectib_lane_eql_ctl_unpack(&(ptr_struct->lane_eql_ctl[i]), ptr_buff + offset/8);
	}

}

void connectib_secondary_pciex_ext_cap_print(const struct connectib_secondary_pciex_ext_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_secondary_pciex_ext_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pciex_link_ctl3:\n");
	connectib_pciex_link_ctl3_print(&(ptr_struct->pciex_link_ctl3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_err_bits        : "UH_FMT"\n", ptr_struct->lane_err_bits);

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_eql_ctl_%03d:\n", i);
	connectib_lane_eql_ctl_print(&(ptr_struct->lane_eql_ctl[i]), file, indent_level + 1);
	}

}

int connectib_secondary_pciex_ext_cap_size(void){
	 return 44;
}

void connectib_secondary_pciex_ext_cap_dump(const struct connectib_secondary_pciex_ext_cap *ptr_struct, FILE* file) {
	connectib_secondary_pciex_ext_cap_print(ptr_struct, file, 0);
}

void connectib_msix_cap_pack(const struct connectib_msix_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->msix_cap_id);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nxt_ptr);

	offset=0;
	connectib_message_control_pack(&(ptr_struct->message_control), ptr_buff + offset/8);

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->Table_BIR);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->Table_Offset);

	offset=93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->PBA_BIR);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->PBA_Offset);

}

void connectib_msix_cap_unpack(struct connectib_msix_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->msix_cap_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->nxt_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	connectib_message_control_unpack(&(ptr_struct->message_control), ptr_buff + offset/8);

	offset=61;
	ptr_struct->Table_BIR = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=32;
	ptr_struct->Table_Offset = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

	offset=93;
	ptr_struct->PBA_BIR = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=64;
	ptr_struct->PBA_Offset = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

}

void connectib_msix_cap_print(const struct connectib_msix_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_msix_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix_cap_id          : "UH_FMT"\n", ptr_struct->msix_cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "message_control:\n");
	connectib_message_control_print(&(ptr_struct->message_control), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Table_BIR            : "UH_FMT"\n", ptr_struct->Table_BIR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Table_Offset         : "UH_FMT"\n", ptr_struct->Table_Offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PBA_BIR              : "UH_FMT"\n", ptr_struct->PBA_BIR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PBA_Offset           : "UH_FMT"\n", ptr_struct->PBA_Offset);

}

int connectib_msix_cap_size(void){
	 return 12;
}

void connectib_msix_cap_dump(const struct connectib_msix_cap *ptr_struct, FILE* file) {
	connectib_msix_cap_print(ptr_struct, file, 0);
}

void connectib_pciex_cap_block_pack(const struct connectib_pciex_cap_block *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pciex_cap_id);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nxt_ptr);

	offset=0;
	connectib_pciex_cap_pack(&(ptr_struct->pciex_cap), ptr_buff + offset/8);

	offset=32;
	connectib_device_caps_pack(&(ptr_struct->device_caps), ptr_buff + offset/8);

	offset=80;
	connectib_device_ctl_pack(&(ptr_struct->device_ctl), ptr_buff + offset/8);

	offset=64;
	connectib_device_stat_pack(&(ptr_struct->device_stat), ptr_buff + offset/8);

	offset=96;
	connectib_link_caps_pack(&(ptr_struct->link_caps), ptr_buff + offset/8);

	offset=144;
	connectib_link_ctl_pack(&(ptr_struct->link_ctl), ptr_buff + offset/8);

	offset=128;
	connectib_link_stat_pack(&(ptr_struct->link_stat), ptr_buff + offset/8);

	offset=288;
	connectib_device_caps2_pack(&(ptr_struct->device_caps2), ptr_buff + offset/8);

	offset=336;
	connectib_device_ctl2_pack(&(ptr_struct->device_ctl2), ptr_buff + offset/8);

	offset=320;
	connectib_device_stat2_pack(&(ptr_struct->device_stat2), ptr_buff + offset/8);

	offset=352;
	connectib_link_caps2_pack(&(ptr_struct->link_caps2), ptr_buff + offset/8);

	offset=400;
	connectib_link_ctl2_pack(&(ptr_struct->link_ctl2), ptr_buff + offset/8);

	offset=384;
	connectib_link_stat2_pack(&(ptr_struct->link_stat2), ptr_buff + offset/8);

}

void connectib_pciex_cap_block_unpack(struct connectib_pciex_cap_block *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->pciex_cap_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->nxt_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	connectib_pciex_cap_unpack(&(ptr_struct->pciex_cap), ptr_buff + offset/8);

	offset=32;
	connectib_device_caps_unpack(&(ptr_struct->device_caps), ptr_buff + offset/8);

	offset=80;
	connectib_device_ctl_unpack(&(ptr_struct->device_ctl), ptr_buff + offset/8);

	offset=64;
	connectib_device_stat_unpack(&(ptr_struct->device_stat), ptr_buff + offset/8);

	offset=96;
	connectib_link_caps_unpack(&(ptr_struct->link_caps), ptr_buff + offset/8);

	offset=144;
	connectib_link_ctl_unpack(&(ptr_struct->link_ctl), ptr_buff + offset/8);

	offset=128;
	connectib_link_stat_unpack(&(ptr_struct->link_stat), ptr_buff + offset/8);

	offset=288;
	connectib_device_caps2_unpack(&(ptr_struct->device_caps2), ptr_buff + offset/8);

	offset=336;
	connectib_device_ctl2_unpack(&(ptr_struct->device_ctl2), ptr_buff + offset/8);

	offset=320;
	connectib_device_stat2_unpack(&(ptr_struct->device_stat2), ptr_buff + offset/8);

	offset=352;
	connectib_link_caps2_unpack(&(ptr_struct->link_caps2), ptr_buff + offset/8);

	offset=400;
	connectib_link_ctl2_unpack(&(ptr_struct->link_ctl2), ptr_buff + offset/8);

	offset=384;
	connectib_link_stat2_unpack(&(ptr_struct->link_stat2), ptr_buff + offset/8);

}

void connectib_pciex_cap_block_print(const struct connectib_pciex_cap_block *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pciex_cap_block ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pciex_cap_id         : "UH_FMT"\n", ptr_struct->pciex_cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pciex_cap:\n");
	connectib_pciex_cap_print(&(ptr_struct->pciex_cap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_caps:\n");
	connectib_device_caps_print(&(ptr_struct->device_caps), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_ctl:\n");
	connectib_device_ctl_print(&(ptr_struct->device_ctl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_stat:\n");
	connectib_device_stat_print(&(ptr_struct->device_stat), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_caps:\n");
	connectib_link_caps_print(&(ptr_struct->link_caps), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_ctl:\n");
	connectib_link_ctl_print(&(ptr_struct->link_ctl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_stat:\n");
	connectib_link_stat_print(&(ptr_struct->link_stat), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_caps2:\n");
	connectib_device_caps2_print(&(ptr_struct->device_caps2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_ctl2:\n");
	connectib_device_ctl2_print(&(ptr_struct->device_ctl2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_stat2:\n");
	connectib_device_stat2_print(&(ptr_struct->device_stat2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_caps2:\n");
	connectib_link_caps2_print(&(ptr_struct->link_caps2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_ctl2:\n");
	connectib_link_ctl2_print(&(ptr_struct->link_ctl2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_stat2:\n");
	connectib_link_stat2_print(&(ptr_struct->link_stat2), file, indent_level + 1);

}

int connectib_pciex_cap_block_size(void){
	 return 60;
}

void connectib_pciex_cap_block_dump(const struct connectib_pciex_cap_block *ptr_struct, FILE* file) {
	connectib_pciex_cap_block_print(ptr_struct, file, 0);
}

void connectib_vpd_cap_pack(const struct connectib_vpd_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vpd_cap_id);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nxt_ptr);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->vpd_address);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->F);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->vpd_data);

}

void connectib_vpd_cap_unpack(struct connectib_vpd_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->vpd_cap_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->nxt_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=1;
	ptr_struct->vpd_address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset=0;
	ptr_struct->F = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->vpd_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_vpd_cap_print(const struct connectib_vpd_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vpd_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_cap_id           : "UH_FMT"\n", ptr_struct->vpd_cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_address          : "UH_FMT"\n", ptr_struct->vpd_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "F                    : "UH_FMT"\n", ptr_struct->F);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_data             : "U32H_FMT"\n", ptr_struct->vpd_data);

}

int connectib_vpd_cap_size(void){
	 return 8;
}

void connectib_vpd_cap_dump(const struct connectib_vpd_cap *ptr_struct, FILE* file) {
	connectib_vpd_cap_print(ptr_struct, file, 0);
}

void connectib_pci_power_management_cap_pack(const struct connectib_pci_power_management_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_id);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->nxt_ptr);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->version);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pme_clock);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_specific);

	offset=9;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aux_current);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->d1_support);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->d2_support);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pme_support);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->power_state);

	offset=60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_soft_reset);

	offset=55;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pme_enable);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->data_select);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->data_scale);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pme_status);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pmcsr_bse);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->data);

}

void connectib_pci_power_management_cap_unpack(struct connectib_pci_power_management_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->cap_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->nxt_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=13;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=12;
	ptr_struct->pme_clock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=10;
	ptr_struct->device_specific = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=9;
	ptr_struct->aux_current = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->d1_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->d2_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->pme_support = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=62;
	ptr_struct->power_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=60;
	ptr_struct->no_soft_reset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=55;
	ptr_struct->pme_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=51;
	ptr_struct->data_select = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=49;
	ptr_struct->data_scale = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=48;
	ptr_struct->pme_status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=40;
	ptr_struct->pmcsr_bse = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->data = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_pci_power_management_cap_print(const struct connectib_pci_power_management_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pci_power_management_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_id               : "UH_FMT"\n", ptr_struct->cap_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nxt_ptr              : "UH_FMT"\n", ptr_struct->nxt_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pme_clock            : "UH_FMT"\n", ptr_struct->pme_clock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_specific      : "UH_FMT"\n", ptr_struct->device_specific);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aux_current          : "UH_FMT"\n", ptr_struct->aux_current);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "d1_support           : "UH_FMT"\n", ptr_struct->d1_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "d2_support           : "UH_FMT"\n", ptr_struct->d2_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pme_support          : "UH_FMT"\n", ptr_struct->pme_support);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_state          : "UH_FMT"\n", ptr_struct->power_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_soft_reset        : "UH_FMT"\n", ptr_struct->no_soft_reset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pme_enable           : "UH_FMT"\n", ptr_struct->pme_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_select          : "UH_FMT"\n", ptr_struct->data_select);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_scale           : "UH_FMT"\n", ptr_struct->data_scale);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pme_status           : "UH_FMT"\n", ptr_struct->pme_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmcsr_bse            : "UH_FMT"\n", ptr_struct->pmcsr_bse);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data                 : "UH_FMT"\n", ptr_struct->data);

}

int connectib_pci_power_management_cap_size(void){
	 return 8;
}

void connectib_pci_power_management_cap_dump(const struct connectib_pci_power_management_cap *ptr_struct, FILE* file) {
	connectib_pci_power_management_cap_print(ptr_struct, file, 0);
}

void connectib_pci_cfg_hdr_pack(const struct connectib_pci_cfg_hdr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vendor_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->device_id);

	offset=48;
	connectib_cmd_reg1_pack(&(ptr_struct->cmd), ptr_buff + offset/8);

	offset=32;
	connectib_stat_reg1_pack(&(ptr_struct->status), ptr_buff + offset/8);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rev_id);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->class_code);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cache_line);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->latency);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hdr_type);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->bist);

	offset=128;
	connectib_bar_low_pack(&(ptr_struct->reg4), ptr_buff + offset/8);

	offset=160;
	connectib_bar_high_pack(&(ptr_struct->reg5), ptr_buff + offset/8);

	offset=192;
	connectib_bar_low_pack(&(ptr_struct->reg6), ptr_buff + offset/8);

	offset=224;
	connectib_bar_high_pack(&(ptr_struct->reg7), ptr_buff + offset/8);

	offset=256;
	connectib_bar_low_pack(&(ptr_struct->reg8), ptr_buff + offset/8);

	offset=288;
	connectib_bar_high_pack(&(ptr_struct->reg9), ptr_buff + offset/8);

	offset=368;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sub_vendor_id);

	offset=352;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->subsystem_id);

	offset=384;
	connectib_exp_rom_pack(&(ptr_struct->reg12), ptr_buff + offset/8);

	offset=440;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cap_ptr);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->interrupt_line);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->interrupt_pin);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->min_gnt_max_lat);

}

void connectib_pci_cfg_hdr_unpack(struct connectib_pci_cfg_hdr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->vendor_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->device_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	connectib_cmd_reg1_unpack(&(ptr_struct->cmd), ptr_buff + offset/8);

	offset=32;
	connectib_stat_reg1_unpack(&(ptr_struct->status), ptr_buff + offset/8);

	offset=88;
	ptr_struct->rev_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->class_code = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=120;
	ptr_struct->cache_line = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=112;
	ptr_struct->latency = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->hdr_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->bist = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_bar_low_unpack(&(ptr_struct->reg4), ptr_buff + offset/8);

	offset=160;
	connectib_bar_high_unpack(&(ptr_struct->reg5), ptr_buff + offset/8);

	offset=192;
	connectib_bar_low_unpack(&(ptr_struct->reg6), ptr_buff + offset/8);

	offset=224;
	connectib_bar_high_unpack(&(ptr_struct->reg7), ptr_buff + offset/8);

	offset=256;
	connectib_bar_low_unpack(&(ptr_struct->reg8), ptr_buff + offset/8);

	offset=288;
	connectib_bar_high_unpack(&(ptr_struct->reg9), ptr_buff + offset/8);

	offset=368;
	ptr_struct->sub_vendor_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=352;
	ptr_struct->subsystem_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=384;
	connectib_exp_rom_unpack(&(ptr_struct->reg12), ptr_buff + offset/8);

	offset=440;
	ptr_struct->cap_ptr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=504;
	ptr_struct->interrupt_line = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=496;
	ptr_struct->interrupt_pin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->min_gnt_max_lat = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_pci_cfg_hdr_print(const struct connectib_pci_cfg_hdr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pci_cfg_hdr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_id            : "UH_FMT"\n", ptr_struct->vendor_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_id            : "UH_FMT"\n", ptr_struct->device_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmd:\n");
	connectib_cmd_reg1_print(&(ptr_struct->cmd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status:\n");
	connectib_stat_reg1_print(&(ptr_struct->status), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rev_id               : "UH_FMT"\n", ptr_struct->rev_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_code           : "UH_FMT"\n", ptr_struct->class_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cache_line           : "UH_FMT"\n", ptr_struct->cache_line);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "latency              : "UH_FMT"\n", ptr_struct->latency);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr_type             : "UH_FMT"\n", ptr_struct->hdr_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bist                 : "UH_FMT"\n", ptr_struct->bist);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg4:\n");
	connectib_bar_low_print(&(ptr_struct->reg4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg5:\n");
	connectib_bar_high_print(&(ptr_struct->reg5), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg6:\n");
	connectib_bar_low_print(&(ptr_struct->reg6), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg7:\n");
	connectib_bar_high_print(&(ptr_struct->reg7), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg8:\n");
	connectib_bar_low_print(&(ptr_struct->reg8), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg9:\n");
	connectib_bar_high_print(&(ptr_struct->reg9), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_vendor_id        : "UH_FMT"\n", ptr_struct->sub_vendor_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "subsystem_id         : "UH_FMT"\n", ptr_struct->subsystem_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg12:\n");
	connectib_exp_rom_print(&(ptr_struct->reg12), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_ptr              : "UH_FMT"\n", ptr_struct->cap_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "interrupt_line       : "UH_FMT"\n", ptr_struct->interrupt_line);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "interrupt_pin        : "UH_FMT"\n", ptr_struct->interrupt_pin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "min_gnt_max_lat      : "UH_FMT"\n", ptr_struct->min_gnt_max_lat);

}

int connectib_pci_cfg_hdr_size(void){
	 return 64;
}

void connectib_pci_cfg_hdr_dump(const struct connectib_pci_cfg_hdr *ptr_struct, FILE* file) {
	connectib_pci_cfg_hdr_print(ptr_struct, file, 0);
}

void connectib_port_settings_pack(const struct connectib_port_settings *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_vpi_settings_pack(&(ptr_struct->vpi), ptr_buff + offset/8);

}

void connectib_port_settings_unpack(struct connectib_port_settings *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_tlv_data_vpi_settings_unpack(&(ptr_struct->vpi), ptr_buff + offset/8);

}

void connectib_port_settings_print(const struct connectib_port_settings *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_settings ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpi:\n");
	connectib_nv_tlv_data_vpi_settings_print(&(ptr_struct->vpi), file, indent_level + 1);

}

int connectib_port_settings_size(void){
	 return 4;
}

void connectib_port_settings_dump(const struct connectib_port_settings *ptr_struct, FILE* file) {
	connectib_port_settings_print(ptr_struct, file, 0);
}

void connectib_phy_lcl_ini_pack(const struct connectib_phy_lcl_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->PlaceHolder);

}

void connectib_phy_lcl_ini_unpack(struct connectib_phy_lcl_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->PlaceHolder = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_phy_lcl_ini_print(const struct connectib_phy_lcl_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_lcl_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PlaceHolder          : "U32H_FMT"\n", ptr_struct->PlaceHolder);

}

int connectib_phy_lcl_ini_size(void){
	 return 4;
}

void connectib_phy_lcl_ini_dump(const struct connectib_phy_lcl_ini *ptr_struct, FILE* file) {
	connectib_phy_lcl_ini_print(ptr_struct, file, 0);
}

void connectib_port_cap_mask1_pack(const union connectib_port_cap_mask1 *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_dword_val_pack(&(ptr_struct->dword), ptr_buff);
}

void connectib_port_cap_mask1_unpack(union connectib_port_cap_mask1 *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_dword_val_unpack(&(ptr_struct->dword), ptr_buff);
}

void connectib_port_cap_mask1_print(const union connectib_port_cap_mask1 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_cap_mask1 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fields:\n");
	connectib_port_cap_mask1_fields_print(&(ptr_struct->fields), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword:\n");
	connectib_dword_val_print(&(ptr_struct->dword), file, indent_level + 1);

}

int connectib_port_cap_mask1_size(void){
	 return 4;
}

void connectib_port_cap_mask1_dump(const union connectib_port_cap_mask1 *ptr_struct, FILE* file) {
	connectib_port_cap_mask1_print(ptr_struct, file, 0);
}

void connectib_reset_version_pack(const struct connectib_reset_version *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->minor);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->major);

}

void connectib_reset_version_unpack(struct connectib_reset_version *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->minor = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=0;
	ptr_struct->major = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_reset_version_print(const struct connectib_reset_version *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reset_version ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minor                : "UH_FMT"\n", ptr_struct->minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "major                : "UH_FMT"\n", ptr_struct->major);

}

int connectib_reset_version_size(void){
	 return 4;
}

void connectib_reset_version_dump(const struct connectib_reset_version *ptr_struct, FILE* file) {
	connectib_reset_version_print(ptr_struct, file, 0);
}

void connectib_mac_address_layout_pack(const struct connectib_mac_address_layout *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->mac_addr_47_32);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mac_addr_31_0);

}

void connectib_mac_address_layout_unpack(struct connectib_mac_address_layout *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->mac_addr_47_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->mac_addr_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_mac_address_layout_print(const struct connectib_mac_address_layout *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mac_address_layout ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mac_addr_47_32       : "UH_FMT"\n", ptr_struct->mac_addr_47_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mac_addr_31_0        : "U32H_FMT"\n", ptr_struct->mac_addr_31_0);

}

int connectib_mac_address_layout_size(void){
	 return 8;
}

void connectib_mac_address_layout_dump(const struct connectib_mac_address_layout *ptr_struct, FILE* file) {
	connectib_mac_address_layout_print(ptr_struct, file, 0);
}

void connectib_resource_type_entry_pack(const struct connectib_resource_type_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->locked);

}

void connectib_resource_type_entry_unpack(struct connectib_resource_type_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->type = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->locked = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_resource_type_entry_print(const struct connectib_resource_type_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_resource_type_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "locked               : "UH_FMT"\n", ptr_struct->locked);

}

int connectib_resource_type_entry_size(void){
	 return 4;
}

void connectib_resource_type_entry_dump(const struct connectib_resource_type_entry *ptr_struct, FILE* file) {
	connectib_resource_type_entry_print(ptr_struct, file, 0);
}

void connectib_index_and_length_pack(const struct connectib_index_and_length *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->index);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->length);

}

void connectib_index_and_length_unpack(struct connectib_index_and_length *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->index = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_index_and_length_print(const struct connectib_index_and_length *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_index_and_length ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "index                : "U64H_FMT"\n", ptr_struct->index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length               : "U32H_FMT"\n", ptr_struct->length);

}

int connectib_index_and_length_size(void){
	 return 16;
}

void connectib_index_and_length_dump(const struct connectib_index_and_length *ptr_struct, FILE* file) {
	connectib_index_and_length_print(ptr_struct, file, 0);
}

void connectib_dest_format_struct_pack(const struct connectib_dest_format_struct *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->destination_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->destination_type);

}

void connectib_dest_format_struct_unpack(struct connectib_dest_format_struct *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->destination_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->destination_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_dest_format_struct_print(const struct connectib_dest_format_struct *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dest_format_struct ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destination_id       : "UH_FMT"\n", ptr_struct->destination_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destination_type     : %s ("UH_FMT")\n", (ptr_struct->destination_type == 1 ? ("FLOW_TABLE_") : ((ptr_struct->destination_type == 2 ? ("TIR") : ("unknown")))), ptr_struct->destination_type);

}

int connectib_dest_format_struct_size(void){
	 return 8;
}

void connectib_dest_format_struct_dump(const struct connectib_dest_format_struct *ptr_struct, FILE* file) {
	connectib_dest_format_struct_print(ptr_struct, file, 0);
}

void connectib_flow_table_entry_match_set_lyr_2_4_pack(const struct connectib_flow_table_entry_match_set_lyr_2_4 *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->smac_47_16);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ethertype);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->smac_15_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dmac_47_16);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->first_vid);

	offset=115;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->first_cfi);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->first_prio);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dmac_15_0);

	offset=151;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->tcp_flags);

	offset=146;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->frag);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vlan_tag);

	offset=142;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ip_ecn);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ip_dscp);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ip_protocol);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tcp_dport);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tcp_sport);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->udp_dport);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->udp_sport);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->src_ip_127_96);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->src_ip_95_64);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->src_ip_63_32);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->src_ip_31_0);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dst_ip_127_96);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dst_ip_95_64);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dst_ip_63_32);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dst_ip_31_0);

}

void connectib_flow_table_entry_match_set_lyr_2_4_unpack(struct connectib_flow_table_entry_match_set_lyr_2_4 *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->smac_47_16 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=48;
	ptr_struct->ethertype = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->smac_15_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->dmac_47_16 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=116;
	ptr_struct->first_vid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=115;
	ptr_struct->first_cfi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->first_prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=96;
	ptr_struct->dmac_15_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=151;
	ptr_struct->tcp_flags = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=146;
	ptr_struct->frag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=144;
	ptr_struct->vlan_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=142;
	ptr_struct->ip_ecn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=136;
	ptr_struct->ip_dscp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=128;
	ptr_struct->ip_protocol = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=176;
	ptr_struct->tcp_dport = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->tcp_sport = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=240;
	ptr_struct->udp_dport = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->udp_sport = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=256;
	ptr_struct->src_ip_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->src_ip_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->src_ip_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->src_ip_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->dst_ip_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->dst_ip_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->dst_ip_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->dst_ip_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_flow_table_entry_match_set_lyr_2_4_print(const struct connectib_flow_table_entry_match_set_lyr_2_4 *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_flow_table_entry_match_set_lyr_2_4 ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "smac_47_16           : "U32H_FMT"\n", ptr_struct->smac_47_16);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ethertype            : "UH_FMT"\n", ptr_struct->ethertype);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "smac_15_0            : "UH_FMT"\n", ptr_struct->smac_15_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmac_47_16           : "U32H_FMT"\n", ptr_struct->dmac_47_16);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_vid            : "UH_FMT"\n", ptr_struct->first_vid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_cfi            : "UH_FMT"\n", ptr_struct->first_cfi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_prio           : "UH_FMT"\n", ptr_struct->first_prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmac_15_0            : "UH_FMT"\n", ptr_struct->dmac_15_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcp_flags            : "UH_FMT"\n", ptr_struct->tcp_flags);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frag                 : "UH_FMT"\n", ptr_struct->frag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vlan_tag             : "UH_FMT"\n", ptr_struct->vlan_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ip_ecn               : "UH_FMT"\n", ptr_struct->ip_ecn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ip_dscp              : "UH_FMT"\n", ptr_struct->ip_dscp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ip_protocol          : "UH_FMT"\n", ptr_struct->ip_protocol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcp_dport            : "UH_FMT"\n", ptr_struct->tcp_dport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tcp_sport            : "UH_FMT"\n", ptr_struct->tcp_sport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "udp_dport            : "UH_FMT"\n", ptr_struct->udp_dport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "udp_sport            : "UH_FMT"\n", ptr_struct->udp_sport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_ip_127_96        : "U32H_FMT"\n", ptr_struct->src_ip_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_ip_95_64         : "U32H_FMT"\n", ptr_struct->src_ip_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_ip_63_32         : "U32H_FMT"\n", ptr_struct->src_ip_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "src_ip_31_0          : "U32H_FMT"\n", ptr_struct->src_ip_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dst_ip_127_96        : "U32H_FMT"\n", ptr_struct->dst_ip_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dst_ip_95_64         : "U32H_FMT"\n", ptr_struct->dst_ip_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dst_ip_63_32         : "U32H_FMT"\n", ptr_struct->dst_ip_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dst_ip_31_0          : "U32H_FMT"\n", ptr_struct->dst_ip_31_0);

}

int connectib_flow_table_entry_match_set_lyr_2_4_size(void){
	 return 64;
}

void connectib_flow_table_entry_match_set_lyr_2_4_dump(const struct connectib_flow_table_entry_match_set_lyr_2_4 *ptr_struct, FILE* file) {
	connectib_flow_table_entry_match_set_lyr_2_4_print(ptr_struct, file, 0);
}

void connectib_flow_table_entry_match_set_misc_pack(const struct connectib_flow_table_entry_match_set_misc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->source_port);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->inner_second_vid);

	offset=83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->inner_second_cfi);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->inner_second_prio);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->outer_second_vid);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->outer_second_cfi);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->outer_second_prio);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gre_protocol);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->inner_second_vlan_tag);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->outer_second_vlan_tag);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->gre_key_l);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->gre_key_h);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vxlan_vni);

	offset=236;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->outer_ipv6_flow_label);

	offset=268;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->inner_ipv6_flow_label);

}

void connectib_flow_table_entry_match_set_misc_unpack(struct connectib_flow_table_entry_match_set_misc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=48;
	ptr_struct->source_port = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=84;
	ptr_struct->inner_second_vid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=83;
	ptr_struct->inner_second_cfi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->inner_second_prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=68;
	ptr_struct->outer_second_vid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=67;
	ptr_struct->outer_second_cfi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->outer_second_prio = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=112;
	ptr_struct->gre_protocol = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=97;
	ptr_struct->inner_second_vlan_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->outer_second_vlan_tag = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=152;
	ptr_struct->gre_key_l = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->gre_key_h = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->vxlan_vni = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=236;
	ptr_struct->outer_ipv6_flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=268;
	ptr_struct->inner_ipv6_flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

}

void connectib_flow_table_entry_match_set_misc_print(const struct connectib_flow_table_entry_match_set_misc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_flow_table_entry_match_set_misc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_port          : "UH_FMT"\n", ptr_struct->source_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_second_vid     : "UH_FMT"\n", ptr_struct->inner_second_vid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_second_cfi     : "UH_FMT"\n", ptr_struct->inner_second_cfi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_second_prio    : "UH_FMT"\n", ptr_struct->inner_second_prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_second_vid     : "UH_FMT"\n", ptr_struct->outer_second_vid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_second_cfi     : "UH_FMT"\n", ptr_struct->outer_second_cfi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_second_prio    : "UH_FMT"\n", ptr_struct->outer_second_prio);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gre_protocol         : "UH_FMT"\n", ptr_struct->gre_protocol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_second_vlan_tag : "UH_FMT"\n", ptr_struct->inner_second_vlan_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_second_vlan_tag : "UH_FMT"\n", ptr_struct->outer_second_vlan_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gre_key_l            : "UH_FMT"\n", ptr_struct->gre_key_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gre_key_h            : "UH_FMT"\n", ptr_struct->gre_key_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vxlan_vni            : "UH_FMT"\n", ptr_struct->vxlan_vni);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_ipv6_flow_label : "UH_FMT"\n", ptr_struct->outer_ipv6_flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_ipv6_flow_label : "UH_FMT"\n", ptr_struct->inner_ipv6_flow_label);

}

int connectib_flow_table_entry_match_set_misc_size(void){
	 return 64;
}

void connectib_flow_table_entry_match_set_misc_dump(const struct connectib_flow_table_entry_match_set_misc *ptr_struct, FILE* file) {
	connectib_flow_table_entry_match_set_misc_print(ptr_struct, file, 0);
}

void connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_pack(const union connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_ib_port_counters_pack(&(ptr_struct->ib_port_counters), ptr_buff);
}

void connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_unpack(union connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_ib_port_counters_unpack(&(ptr_struct->ib_port_counters), ptr_buff);
}

void connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_print(const union connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_802_3_cntrs_grp_data_layout:\n");
	connectib_eth_802_3_cntrs_grp_data_layout_print(&(ptr_struct->eth_802_3_cntrs_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_2863_cntrs_grp_data_layout:\n");
	connectib_eth_2863_cntrs_grp_data_layout_print(&(ptr_struct->eth_2863_cntrs_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_2819_cntrs_grp_data_layout:\n");
	connectib_eth_2819_cntrs_grp_data_layout_print(&(ptr_struct->eth_2819_cntrs_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_3635_cntrs_grp_data_layout:\n");
	connectib_eth_3635_cntrs_grp_data_layout_print(&(ptr_struct->eth_3635_cntrs_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_extended_cntrs_grp_data_layout:\n");
	connectib_eth_extended_cntrs_grp_data_layout_print(&(ptr_struct->eth_extended_cntrs_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_per_prio_grp_data_layout:\n");
	connectib_eth_per_prio_grp_data_layout_print(&(ptr_struct->eth_per_prio_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_per_traffic_grp_data_layout:\n");
	connectib_eth_per_traffic_grp_data_layout_print(&(ptr_struct->eth_per_traffic_grp_data_layout), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phys_layer_cntrs:\n");
	connectib_phys_layer_cntrs_print(&(ptr_struct->phys_layer_cntrs), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "discard:\n");
	connectib_discard_cntrs_grp_data_print(&(ptr_struct->discard), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_counters:\n");
	connectib_llr_counters_print(&(ptr_struct->llr_counters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_port_counters:\n");
	connectib_ib_port_counters_print(&(ptr_struct->ib_port_counters), file, indent_level + 1);

}

int connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_size(void){
	 return 248;
}

void connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_dump(const union connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto *ptr_struct, FILE* file) {
	connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_print(ptr_struct, file, 0);
}

void connectib_fw_vport_ctx_pack(const struct connectib_fw_vport_ctx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->esw_state);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->nic_state);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->connected_2_steering);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->event_mask);

}

void connectib_fw_vport_ctx_unpack(struct connectib_fw_vport_ctx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=14;
	ptr_struct->esw_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=11;
	ptr_struct->nic_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->connected_2_steering = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->event_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_fw_vport_ctx_print(const struct connectib_fw_vport_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_vport_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "esw_state            : "UH_FMT"\n", ptr_struct->esw_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nic_state            : "UH_FMT"\n", ptr_struct->nic_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected_2_steering : "UH_FMT"\n", ptr_struct->connected_2_steering);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_mask           : "UH_FMT"\n", ptr_struct->event_mask);

}

int connectib_fw_vport_ctx_size(void){
	 return 2;
}

void connectib_fw_vport_ctx_dump(const struct connectib_fw_vport_ctx *ptr_struct, FILE* file) {
	connectib_fw_vport_ctx_print(ptr_struct, file, 0);
}

void connectib_vf_pages_list_pack(const struct connectib_vf_pages_list *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->pages[i]);
	}

}

void connectib_vf_pages_list_unpack(struct connectib_vf_pages_list *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 512, 1);
	ptr_struct->pages[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

}

void connectib_vf_pages_list_print(const struct connectib_vf_pages_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vf_pages_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pages_%03d           : "U64H_FMT"\n", i, ptr_struct->pages[i]);
	}

}

int connectib_vf_pages_list_size(void){
	 return 64;
}

void connectib_vf_pages_list_dump(const struct connectib_vf_pages_list *ptr_struct, FILE* file) {
	connectib_vf_pages_list_print(ptr_struct, file, 0);
}

void connectib_icm_page_manager_pack(const struct connectib_icm_page_manager *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->page_list);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->free_count);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->used_count);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->page_list_length);

	offset=191;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock);

	offset=190;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->event_pending);

	offset=189;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->driver_refused);

	offset=187;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->state);

	offset=186;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_vf_pages);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vf_page_ix);

}

void connectib_icm_page_manager_unpack(struct connectib_icm_page_manager *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->page_list = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->free_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->used_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->page_list_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=191;
	ptr_struct->lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=190;
	ptr_struct->event_pending = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=189;
	ptr_struct->driver_refused = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=187;
	ptr_struct->state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=186;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=168;
	ptr_struct->num_vf_pages = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=160;
	ptr_struct->vf_page_ix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_icm_page_manager_print(const struct connectib_icm_page_manager *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icm_page_manager ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_list            : "U64H_FMT"\n", ptr_struct->page_list);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "free_count           : "U32H_FMT"\n", ptr_struct->free_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "used_count           : "U32H_FMT"\n", ptr_struct->used_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_list_length     : "U32H_FMT"\n", ptr_struct->page_list_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock                 : "UH_FMT"\n", ptr_struct->lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_pending        : "UH_FMT"\n", ptr_struct->event_pending);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "driver_refused       : "UH_FMT"\n", ptr_struct->driver_refused);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "state                : "UH_FMT"\n", ptr_struct->state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_vf_pages         : "UH_FMT"\n", ptr_struct->num_vf_pages);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_page_ix           : "UH_FMT"\n", ptr_struct->vf_page_ix);

}

int connectib_icm_page_manager_size(void){
	 return 24;
}

void connectib_icm_page_manager_dump(const struct connectib_icm_page_manager *ptr_struct, FILE* file) {
	connectib_icm_page_manager_print(ptr_struct, file, 0);
}

void connectib_hca_params_pack(const struct connectib_hca_params *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->partition_cap);

	offset=67;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_max_qp);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->phy_port_owner);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eswitch_owner);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dct);

	offset=114;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_max_ra_res_qp);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_max_ra_req_qp);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_ports);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->log_uar_page_sz);

	offset=170;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log_gid_table_size);

	offset=213;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->log_max_mac_uc_lst_sz);

}

void connectib_hca_params_unpack(struct connectib_hca_params *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=80;
	ptr_struct->partition_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=67;
	ptr_struct->log_max_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=66;
	ptr_struct->phy_port_owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->eswitch_owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->dct = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=114;
	ptr_struct->log_max_ra_res_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=98;
	ptr_struct->log_max_ra_req_qp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=144;
	ptr_struct->num_ports = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=176;
	ptr_struct->log_uar_page_sz = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=170;
	ptr_struct->log_gid_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=213;
	ptr_struct->log_max_mac_uc_lst_sz = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void connectib_hca_params_print(const struct connectib_hca_params *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hca_params ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "partition_cap        : "UH_FMT"\n", ptr_struct->partition_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_qp           : "UH_FMT"\n", ptr_struct->log_max_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_port_owner       : "UH_FMT"\n", ptr_struct->phy_port_owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eswitch_owner        : "UH_FMT"\n", ptr_struct->eswitch_owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct                  : "UH_FMT"\n", ptr_struct->dct);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_ra_res_qp    : "UH_FMT"\n", ptr_struct->log_max_ra_res_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_ra_req_qp    : "UH_FMT"\n", ptr_struct->log_max_ra_req_qp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_ports            : "UH_FMT"\n", ptr_struct->num_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_uar_page_sz      : "UH_FMT"\n", ptr_struct->log_uar_page_sz);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_gid_table_size   : "UH_FMT"\n", ptr_struct->log_gid_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_mac_uc_lst_sz : "UH_FMT"\n", ptr_struct->log_max_mac_uc_lst_sz);

}

int connectib_hca_params_size(void){
	 return 32;
}

void connectib_hca_params_dump(const struct connectib_hca_params *ptr_struct, FILE* file) {
	connectib_hca_params_print(ptr_struct, file, 0);
}

void connectib_dummy_addresses_one_cache_line_pack(const struct connectib_dummy_addresses_one_cache_line *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ix[i]);
	}

}

void connectib_dummy_addresses_one_cache_line_unpack(struct connectib_dummy_addresses_one_cache_line *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 512, 1);
	ptr_struct->ix[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

}

void connectib_dummy_addresses_one_cache_line_print(const struct connectib_dummy_addresses_one_cache_line *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dummy_addresses_one_cache_line ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ix_%03d              : "U64H_FMT"\n", i, ptr_struct->ix[i]);
	}

}

int connectib_dummy_addresses_one_cache_line_size(void){
	 return 64;
}

void connectib_dummy_addresses_one_cache_line_dump(const struct connectib_dummy_addresses_one_cache_line *ptr_struct, FILE* file) {
	connectib_dummy_addresses_one_cache_line_print(ptr_struct, file, 0);
}

void connectib_cmdif_ctx_pack(const struct connectib_cmdif_ctx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->done_missions);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 25, (u_int32_t)ptr_struct->res_num);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cmd_valid);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->opcode);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->op_mod);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->allocated_pages);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->needed_pages);

	offset=160;
	connectib_flush_type_pack(&(ptr_struct->flush_type), ptr_buff + offset/8);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->flush_qpn);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->flush_synd);

	offset=256;
	connectib_cmdif_ctx_special_pack(&(ptr_struct->s), ptr_buff + offset/8);

}

void connectib_cmdif_ctx_unpack(struct connectib_cmdif_ctx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->done_missions = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=39;
	ptr_struct->res_num = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 25);

	offset=32;
	ptr_struct->cmd_valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->op_mod = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->allocated_pages = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->needed_pages = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	connectib_flush_type_unpack(&(ptr_struct->flush_type), ptr_buff + offset/8);

	offset=200;
	ptr_struct->flush_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=192;
	ptr_struct->flush_synd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	connectib_cmdif_ctx_special_unpack(&(ptr_struct->s), ptr_buff + offset/8);

}

void connectib_cmdif_ctx_print(const struct connectib_cmdif_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "done_missions        : "U32H_FMT"\n", ptr_struct->done_missions);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "res_num              : "UH_FMT"\n", ptr_struct->res_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmd_valid            : "UH_FMT"\n", ptr_struct->cmd_valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "op_mod               : "UH_FMT"\n", ptr_struct->op_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "allocated_pages      : "U32H_FMT"\n", ptr_struct->allocated_pages);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "needed_pages         : "U32H_FMT"\n", ptr_struct->needed_pages);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_type:\n");
	connectib_flush_type_print(&(ptr_struct->flush_type), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_qpn            : "UH_FMT"\n", ptr_struct->flush_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flush_synd           : "UH_FMT"\n", ptr_struct->flush_synd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "s:\n");
	connectib_cmdif_ctx_special_print(&(ptr_struct->s), file, indent_level + 1);

}

int connectib_cmdif_ctx_size(void){
	 return 64;
}

void connectib_cmdif_ctx_dump(const struct connectib_cmdif_ctx *ptr_struct, FILE* file) {
	connectib_cmdif_ctx_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_data_pack(const union connectib_sw_eqe_data *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_sw_eqe_flat_data_pack(&(ptr_struct->flat_data), ptr_buff);
}

void connectib_sw_eqe_data_unpack(union connectib_sw_eqe_data *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_sw_eqe_flat_data_unpack(&(ptr_struct->flat_data), ptr_buff);
}

void connectib_sw_eqe_data_print(const union connectib_sw_eqe_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cq_data:\n");
	connectib_sw_eqe_cq_data_print(&(ptr_struct->cq_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error_data:\n");
	connectib_sw_eqe_error_data_print(&(ptr_struct->error_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_data:\n");
	connectib_sw_eqe_qp_data_print(&(ptr_struct->qp_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_change:\n");
	connectib_port_state_change_event_print(&(ptr_struct->port_change), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_request:\n");
	connectib_page_request_event_print(&(ptr_struct->page_request), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_page_fault:\n");
	connectib_wqe_page_fault_event_print(&(ptr_struct->wqe_page_fault), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma_page_fault:\n");
	connectib_rdma_page_fault_event_print(&(ptr_struct->rdma_page_fault), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_bf_congestion_event:\n");
	connectib_db_bf_congestion_event_print(&(ptr_struct->db_bf_congestion_event), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flat_data:\n");
	connectib_sw_eqe_flat_data_print(&(ptr_struct->flat_data), file, indent_level + 1);

}

int connectib_sw_eqe_data_size(void){
	 return 28;
}

void connectib_sw_eqe_data_dump(const union connectib_sw_eqe_data *ptr_struct, FILE* file) {
	connectib_sw_eqe_data_print(ptr_struct, file, 0);
}

void connectib_reg_access_reg_tlv_pack(const struct connectib_reg_access_reg_tlv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_tlv_pack(&(ptr_struct->hdr), ptr_buff + offset/8);

	offset=32;
	connectib_reg_access_reg_tlv_data_pack(&(ptr_struct->reg_tlv_data), ptr_buff + offset/8);

}

void connectib_reg_access_reg_tlv_unpack(struct connectib_reg_access_reg_tlv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_tlv_unpack(&(ptr_struct->hdr), ptr_buff + offset/8);

	offset=32;
	connectib_reg_access_reg_tlv_data_unpack(&(ptr_struct->reg_tlv_data), ptr_buff + offset/8);

}

void connectib_reg_access_reg_tlv_print(const struct connectib_reg_access_reg_tlv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_reg_tlv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hdr:\n");
	connectib_reg_access_tlv_print(&(ptr_struct->hdr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg_tlv_data:\n");
	connectib_reg_access_reg_tlv_data_print(&(ptr_struct->reg_tlv_data), file, indent_level + 1);

}

int connectib_reg_access_reg_tlv_size(void){
	 return 48;
}

void connectib_reg_access_reg_tlv_dump(const struct connectib_reg_access_reg_tlv *ptr_struct, FILE* file) {
	connectib_reg_access_reg_tlv_print(ptr_struct, file, 0);
}

void connectib_reg_access_oper_tlv_pack(const struct connectib_reg_access_oper_tlv *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->Status);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dr);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->len);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->type);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->Method);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->r);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->register_id);

	offset=64;
	connectib_IB_TID_pack(&(ptr_struct->TID), ptr_buff + offset/8);

}

void connectib_reg_access_oper_tlv_unpack(struct connectib_reg_access_oper_tlv *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=17;
	ptr_struct->Status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=16;
	ptr_struct->dr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->len = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=0;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=56;
	ptr_struct->class_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=49;
	ptr_struct->Method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=48;
	ptr_struct->r = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->register_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	connectib_IB_TID_unpack(&(ptr_struct->TID), ptr_buff + offset/8);

}

void connectib_reg_access_oper_tlv_print(const struct connectib_reg_access_oper_tlv *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_oper_tlv ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Status               : "UH_FMT"\n", ptr_struct->Status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dr                   : "UH_FMT"\n", ptr_struct->dr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "len                  : "UH_FMT"\n", ptr_struct->len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_               : "UH_FMT"\n", ptr_struct->class_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Method               : "UH_FMT"\n", ptr_struct->Method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r                    : "UH_FMT"\n", ptr_struct->r);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "register_id          : "UH_FMT"\n", ptr_struct->register_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "TID:\n");
	connectib_IB_TID_print(&(ptr_struct->TID), file, indent_level + 1);

}

int connectib_reg_access_oper_tlv_size(void){
	 return 16;
}

void connectib_reg_access_oper_tlv_dump(const struct connectib_reg_access_oper_tlv *ptr_struct, FILE* file) {
	connectib_reg_access_oper_tlv_print(ptr_struct, file, 0);
}

void connectib_output_inline_standart_pack(const struct connectib_output_inline_standart *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->auto_1);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->status);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->syndrome);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ix);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->auto_2);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->auto_3);

}

void connectib_output_inline_standart_unpack(struct connectib_output_inline_standart *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->auto_1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->syndrome = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->ix = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->auto_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->auto_3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_output_inline_standart_print(const struct connectib_output_inline_standart *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_output_inline_standart ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "auto_1               : "UH_FMT"\n", ptr_struct->auto_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : "UH_FMT"\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrome             : "U32H_FMT"\n", ptr_struct->syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ix                   : "UH_FMT"\n", ptr_struct->ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "auto_2               : "UH_FMT"\n", ptr_struct->auto_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "auto_3               : "U32H_FMT"\n", ptr_struct->auto_3);

}

int connectib_output_inline_standart_size(void){
	 return 16;
}

void connectib_output_inline_standart_dump(const struct connectib_output_inline_standart *ptr_struct, FILE* file) {
	connectib_output_inline_standart_print(ptr_struct, file, 0);
}

void connectib_input_inline_standart_pack(const struct connectib_input_inline_standart *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->reserved_0);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->opcode);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->opcode_mod);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->reserved_1);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ix);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->reserved_2);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->reserved_3);

}

void connectib_input_inline_standart_unpack(struct connectib_input_inline_standart *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->reserved_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	ptr_struct->opcode_mod = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->reserved_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=72;
	ptr_struct->ix = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=64;
	ptr_struct->reserved_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->reserved_3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_input_inline_standart_print(const struct connectib_input_inline_standart *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_input_inline_standart ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_0           : "UH_FMT"\n", ptr_struct->reserved_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode_mod           : "UH_FMT"\n", ptr_struct->opcode_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_1           : "UH_FMT"\n", ptr_struct->reserved_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ix                   : "UH_FMT"\n", ptr_struct->ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_2           : "UH_FMT"\n", ptr_struct->reserved_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_3           : "U32H_FMT"\n", ptr_struct->reserved_3);

}

int connectib_input_inline_standart_size(void){
	 return 16;
}

void connectib_input_inline_standart_dump(const struct connectib_input_inline_standart *ptr_struct, FILE* file) {
	connectib_input_inline_standart_print(ptr_struct, file, 0);
}

void connectib_g_rse_decoders_as_dwords_pack(const struct connectib_g_rse_decoders_as_dwords *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_g_rse_decoders_as_dwords_unpack(struct connectib_g_rse_decoders_as_dwords *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_g_rse_decoders_as_dwords_print(const struct connectib_g_rse_decoders_as_dwords *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_g_rse_decoders_as_dwords ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_g_rse_decoders_as_dwords_size(void){
	 return 256;
}

void connectib_g_rse_decoders_as_dwords_dump(const struct connectib_g_rse_decoders_as_dwords *ptr_struct, FILE* file) {
	connectib_g_rse_decoders_as_dwords_print(ptr_struct, file, 0);
}

void connectib_rxs_rxt_desc_decoder_pack(const struct connectib_rxs_rxt_desc_decoder *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 14, (u_int32_t)ptr_struct->payload_end_offset);

	offset=49;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mask_px_icmc_tpt_vld);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->need_invalidation);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->extended_rdb_size);

	offset=41;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->max_rdma_atomic);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->scatter_grh);

	offset=37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->packet_type);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->can_use_reserved_lkey);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->use_dcr_gvmi_for_rdb);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=66;
	adb2c_push_bits_to_buff(ptr_buff, offset, 14, (u_int32_t)ptr_struct->packet_len);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->free_line);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->header_capture);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rdb_write_pointer);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->psn);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->payload_offset);

	offset=168;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->pd);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->grh_offset);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rkey);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dma_length);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->va_63_32);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->va_31_0);

}

void connectib_rxs_rxt_desc_decoder_unpack(struct connectib_rxs_rxt_desc_decoder *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=50;
	ptr_struct->payload_end_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 14);

	offset=49;
	ptr_struct->mask_px_icmc_tpt_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->need_invalidation = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=44;
	ptr_struct->extended_rdb_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=41;
	ptr_struct->max_rdma_atomic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=40;
	ptr_struct->scatter_grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=37;
	ptr_struct->packet_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=36;
	ptr_struct->can_use_reserved_lkey = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=35;
	ptr_struct->use_dcr_gvmi_for_rdb = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=66;
	ptr_struct->packet_len = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 14);

	offset=65;
	ptr_struct->free_line = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->header_capture = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=104;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=96;
	ptr_struct->rdb_write_pointer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=136;
	ptr_struct->psn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=128;
	ptr_struct->payload_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=168;
	ptr_struct->pd = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=160;
	ptr_struct->grh_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=192;
	ptr_struct->rkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->dma_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->va_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->va_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_rxs_rxt_desc_decoder_print(const struct connectib_rxs_rxt_desc_decoder *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rxs_rxt_desc_decoder ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_end_offset   : "UH_FMT"\n", ptr_struct->payload_end_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mask_px_icmc_tpt_vld : "UH_FMT"\n", ptr_struct->mask_px_icmc_tpt_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "need_invalidation    : "UH_FMT"\n", ptr_struct->need_invalidation);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_rdb_size    : "UH_FMT"\n", ptr_struct->extended_rdb_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_rdma_atomic      : "UH_FMT"\n", ptr_struct->max_rdma_atomic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "scatter_grh          : "UH_FMT"\n", ptr_struct->scatter_grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_type          : "UH_FMT"\n", ptr_struct->packet_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "can_use_reserved_lkey : "UH_FMT"\n", ptr_struct->can_use_reserved_lkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "use_dcr_gvmi_for_rdb : "UH_FMT"\n", ptr_struct->use_dcr_gvmi_for_rdb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_len           : "UH_FMT"\n", ptr_struct->packet_len);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "free_line            : "UH_FMT"\n", ptr_struct->free_line);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header_capture       : "UH_FMT"\n", ptr_struct->header_capture);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb_write_pointer    : "UH_FMT"\n", ptr_struct->rdb_write_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "psn                  : "UH_FMT"\n", ptr_struct->psn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_offset       : "UH_FMT"\n", ptr_struct->payload_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pd                   : "UH_FMT"\n", ptr_struct->pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_offset           : "UH_FMT"\n", ptr_struct->grh_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rkey                 : "U32H_FMT"\n", ptr_struct->rkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dma_length           : "U32H_FMT"\n", ptr_struct->dma_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "va_63_32             : "U32H_FMT"\n", ptr_struct->va_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "va_31_0              : "U32H_FMT"\n", ptr_struct->va_31_0);

}

int connectib_rxs_rxt_desc_decoder_size(void){
	 return 64;
}

void connectib_rxs_rxt_desc_decoder_dump(const struct connectib_rxs_rxt_desc_decoder *ptr_struct, FILE* file) {
	connectib_rxs_rxt_desc_decoder_print(ptr_struct, file, 0);
}

void connectib_rxt_checks_packet_descriptor_decoder_pack(const struct connectib_rxt_checks_packet_descriptor_decoder *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->timestamp_version);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_loopback);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->functional_loopback);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->inner_crc_ok);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mad_baseversion_error);

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mad_classversion_error);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mad_send2host);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->outer_crc_ok);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_error);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_sniffer);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->timestamp_vld);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->payload_offset);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->custom_dw0_vld);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->custom_dw1_vld);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->custom_dw2_vld);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->custom_dw3_vld);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->custom_dw3);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->custom_dw2);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->custom_dw1);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->custom_dw0);

	offset=215;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->source_xqpn_40_32);

	offset=214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dummy_packet);

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->mad_qp1_class);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->packet_end_offset);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->source_xqpn_31_0);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_63_32);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_31_0);

}

void connectib_rxt_checks_packet_descriptor_decoder_unpack(struct connectib_rxt_checks_packet_descriptor_decoder *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->timestamp_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=29;
	ptr_struct->force_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->functional_loopback = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=27;
	ptr_struct->inner_crc_ok = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->mad_baseversion_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=25;
	ptr_struct->mad_classversion_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->mad_send2host = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->outer_crc_ok = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->port_error = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->sx_sniffer = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->timestamp_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->payload_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=44;
	ptr_struct->custom_dw0_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=40;
	ptr_struct->custom_dw1_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=36;
	ptr_struct->custom_dw2_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->custom_dw3_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->custom_dw3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->custom_dw2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->custom_dw1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->custom_dw0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=215;
	ptr_struct->source_xqpn_40_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=214;
	ptr_struct->dummy_packet = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=208;
	ptr_struct->mad_qp1_class = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=192;
	ptr_struct->packet_end_offset = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->source_xqpn_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->timestamp_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->timestamp_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_rxt_checks_packet_descriptor_decoder_print(const struct connectib_rxt_checks_packet_descriptor_decoder *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rxt_checks_packet_descriptor_decoder ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_version    : "UH_FMT"\n", ptr_struct->timestamp_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_loopback       : "UH_FMT"\n", ptr_struct->force_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "functional_loopback  : "UH_FMT"\n", ptr_struct->functional_loopback);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_crc_ok         : "UH_FMT"\n", ptr_struct->inner_crc_ok);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad_baseversion_error : "UH_FMT"\n", ptr_struct->mad_baseversion_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad_classversion_error : "UH_FMT"\n", ptr_struct->mad_classversion_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad_send2host        : "UH_FMT"\n", ptr_struct->mad_send2host);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_crc_ok         : "UH_FMT"\n", ptr_struct->outer_crc_ok);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_error           : "UH_FMT"\n", ptr_struct->port_error);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_sniffer           : "UH_FMT"\n", ptr_struct->sx_sniffer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_vld        : "UH_FMT"\n", ptr_struct->timestamp_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "payload_offset       : "UH_FMT"\n", ptr_struct->payload_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw0_vld       : "UH_FMT"\n", ptr_struct->custom_dw0_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw1_vld       : "UH_FMT"\n", ptr_struct->custom_dw1_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw2_vld       : "UH_FMT"\n", ptr_struct->custom_dw2_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw3_vld       : "UH_FMT"\n", ptr_struct->custom_dw3_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw3           : "U32H_FMT"\n", ptr_struct->custom_dw3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw2           : "U32H_FMT"\n", ptr_struct->custom_dw2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw1           : "U32H_FMT"\n", ptr_struct->custom_dw1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "custom_dw0           : "U32H_FMT"\n", ptr_struct->custom_dw0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_xqpn_40_32    : "UH_FMT"\n", ptr_struct->source_xqpn_40_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dummy_packet         : "UH_FMT"\n", ptr_struct->dummy_packet);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad_qp1_class        : "UH_FMT"\n", ptr_struct->mad_qp1_class);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_end_offset    : "UH_FMT"\n", ptr_struct->packet_end_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "source_xqpn_31_0     : "U32H_FMT"\n", ptr_struct->source_xqpn_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_63_32      : "U32H_FMT"\n", ptr_struct->timestamp_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_31_0       : "U32H_FMT"\n", ptr_struct->timestamp_31_0);

}

int connectib_rxt_checks_packet_descriptor_decoder_size(void){
	 return 64;
}

void connectib_rxt_checks_packet_descriptor_decoder_dump(const struct connectib_rxt_checks_packet_descriptor_decoder *ptr_struct, FILE* file) {
	connectib_rxt_checks_packet_descriptor_decoder_print(ptr_struct, file, 0);
}

void connectib_rxt_context_fetch_qp_desc_decoder_pack(const struct connectib_rxt_context_fetch_qp_desc_decoder *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qpc_ts_3_3);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_number);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->srq_number_23_11);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->qpc_ts_2_0);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->pkey_index);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_index);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->srq_vld);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->srq_number_10_0);

}

void connectib_rxt_context_fetch_qp_desc_decoder_unpack(struct connectib_rxt_context_fetch_qp_desc_decoder *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->qpc_ts_3_3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=51;
	ptr_struct->srq_number_23_11 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset=35;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->qpc_ts_2_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=84;
	ptr_struct->pkey_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=76;
	ptr_struct->my_gid_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=75;
	ptr_struct->srq_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->srq_number_10_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void connectib_rxt_context_fetch_qp_desc_decoder_print(const struct connectib_rxt_context_fetch_qp_desc_decoder *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rxt_context_fetch_qp_desc_decoder ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpc_ts_3_3           : "UH_FMT"\n", ptr_struct->qpc_ts_3_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number_23_11     : "UH_FMT"\n", ptr_struct->srq_number_23_11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpc_ts_2_0           : "UH_FMT"\n", ptr_struct->qpc_ts_2_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey_index           : "UH_FMT"\n", ptr_struct->pkey_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_index         : "UH_FMT"\n", ptr_struct->my_gid_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_vld              : "UH_FMT"\n", ptr_struct->srq_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_number_10_0      : "UH_FMT"\n", ptr_struct->srq_number_10_0);

}

int connectib_rxt_context_fetch_qp_desc_decoder_size(void){
	 return 16;
}

void connectib_rxt_context_fetch_qp_desc_decoder_dump(const struct connectib_rxt_context_fetch_qp_desc_decoder *ptr_struct, FILE* file) {
	connectib_rxt_context_fetch_qp_desc_decoder_print(ptr_struct, file, 0);
}

void connectib_rxt_checks_steering_results_decoder_pack(const struct connectib_rxt_checks_steering_results_decoder *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_packet_counters_trigger);

	offset=55;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->xqpn_40_32);

	offset=54;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pport_counters_trigger_vld);

	offset=53;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->qpn_direct_access);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vport_counters_trigger_vld);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vport_byte_counters_trigger);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pport_byte_counters_trigger);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pport_packet_counters_trigger);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->xqpn_31_0);

}

void connectib_rxt_checks_steering_results_decoder_unpack(struct connectib_rxt_checks_steering_results_decoder *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->vport_packet_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=55;
	ptr_struct->xqpn_40_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=54;
	ptr_struct->pport_counters_trigger_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=53;
	ptr_struct->qpn_direct_access = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=52;
	ptr_struct->vport_counters_trigger_vld = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->vport_byte_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=40;
	ptr_struct->pport_byte_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->pport_packet_counters_trigger = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->xqpn_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_rxt_checks_steering_results_decoder_print(const struct connectib_rxt_checks_steering_results_decoder *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rxt_checks_steering_results_decoder ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_packet_counters_trigger : "UH_FMT"\n", ptr_struct->vport_packet_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xqpn_40_32           : "UH_FMT"\n", ptr_struct->xqpn_40_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport_counters_trigger_vld : "UH_FMT"\n", ptr_struct->pport_counters_trigger_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn_direct_access    : "UH_FMT"\n", ptr_struct->qpn_direct_access);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_counters_trigger_vld : "UH_FMT"\n", ptr_struct->vport_counters_trigger_vld);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_byte_counters_trigger : "UH_FMT"\n", ptr_struct->vport_byte_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport_byte_counters_trigger : "UH_FMT"\n", ptr_struct->pport_byte_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pport_packet_counters_trigger : "UH_FMT"\n", ptr_struct->pport_packet_counters_trigger);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xqpn_31_0            : "U32H_FMT"\n", ptr_struct->xqpn_31_0);

}

int connectib_rxt_checks_steering_results_decoder_size(void){
	 return 16;
}

void connectib_rxt_checks_steering_results_decoder_dump(const struct connectib_rxt_checks_steering_results_decoder *ptr_struct, FILE* file) {
	connectib_rxt_checks_steering_results_decoder_print(ptr_struct, file, 0);
}

void connectib_ctx_as_dwords_pack(const struct connectib_ctx_as_dwords *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dwords[i]);
	}

}

void connectib_ctx_as_dwords_unpack(struct connectib_ctx_as_dwords *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->dwords[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_ctx_as_dwords_print(const struct connectib_ctx_as_dwords *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ctx_as_dwords ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dwords_%03d          : "U32H_FMT"\n", i, ptr_struct->dwords[i]);
	}

}

int connectib_ctx_as_dwords_size(void){
	 return 64;
}

void connectib_ctx_as_dwords_dump(const struct connectib_ctx_as_dwords *ptr_struct, FILE* file) {
	connectib_ctx_as_dwords_print(ptr_struct, file, 0);
}

void connectib_fw_resource_context_pack(const union connectib_fw_resource_context *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_dc_control_packet_desc_pack(&(ptr_struct->dc_control_packet_desc), ptr_buff);
}

void connectib_fw_resource_context_unpack(union connectib_fw_resource_context *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_dc_control_packet_desc_unpack(&(ptr_struct->dc_control_packet_desc), ptr_buff);
}

void connectib_fw_resource_context_print(const union connectib_fw_resource_context *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_resource_context ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_eqc:\n");
	connectib_fw_eqc_print(&(ptr_struct->fw_eqc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_alt_path:\n");
	connectib_fw_alt_path_print(&(ptr_struct->fw_alt_path), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_basic:\n");
	connectib_fw_basic_res_ctx_print(&(ptr_struct->fw_basic), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_cre:\n");
	connectib_fw_cre_print(&(ptr_struct->fw_cre), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_mkc:\n");
	connectib_fw_mkc_print(&(ptr_struct->fw_mkc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_psv:\n");
	connectib_fw_psv_print(&(ptr_struct->fw_psv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_cqc:\n");
	connectib_fw_cqc_print(&(ptr_struct->fw_cqc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_rqt:\n");
	connectib_fw_rqt_print(&(ptr_struct->fw_rqt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "list_element:\n");
	connectib_list_element_print(&(ptr_struct->list_element), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmfs_resources:\n");
	connectib_dmfs_resources_print(&(ptr_struct->dmfs_resources), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_control_packet_desc:\n");
	connectib_dc_control_packet_desc_print(&(ptr_struct->dc_control_packet_desc), file, indent_level + 1);

}

int connectib_fw_resource_context_size(void){
	 return 64;
}

void connectib_fw_resource_context_dump(const union connectib_fw_resource_context *ptr_struct, FILE* file) {
	connectib_fw_resource_context_print(ptr_struct, file, 0);
}

void connectib_hw_hca_contexts_pack(const union connectib_hw_hca_contexts *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_hw_qp_counter_pack(&(ptr_struct->qp_counter), ptr_buff);
}

void connectib_hw_hca_contexts_unpack(union connectib_hw_hca_contexts *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_hw_qp_counter_unpack(&(ptr_struct->qp_counter), ptr_buff);
}

void connectib_hw_hca_contexts_print(const union connectib_hw_hca_contexts *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_hca_contexts ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqc:\n");
	connectib_hw_cqc_print(&(ptr_struct->cqc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mkc:\n");
	connectib_hw_mkc_print(&(ptr_struct->mkc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "toc:\n");
	connectib_hw_toc_print(&(ptr_struct->toc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq:\n");
	connectib_hw_srq_print(&(ptr_struct->srq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dct:\n");
	connectib_hw_dct_print(&(ptr_struct->dct), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "c_qpc:\n");
	connectib_hw_c_qpc_print(&(ptr_struct->c_qpc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "s_qpc:\n");
	connectib_hw_s_qpc_print(&(ptr_struct->s_qpc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "r_qpc:\n");
	connectib_hw_r_qpc_print(&(ptr_struct->r_qpc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_info:\n");
	connectib_hw_port_info_print(&(ptr_struct->port_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bsf_entry:\n");
	connectib_hw_bsf_entry_print(&(ptr_struct->bsf_entry), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "base_psv:\n");
	connectib_hw_base_psv_print(&(ptr_struct->base_psv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trastb:\n");
	connectib_hw_trastb_print(&(ptr_struct->trastb), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trasta:\n");
	connectib_hw_trasta_print(&(ptr_struct->trasta), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_pointers:\n");
	connectib_hw_sq_pointers_print(&(ptr_struct->sq_pointers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi_tokens:\n");
	connectib_hw_gvmi_tokens_print(&(ptr_struct->gvmi_tokens), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_tokens:\n");
	connectib_hw_sq_tokens_print(&(ptr_struct->sq_tokens), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "klm_entry:\n");
	connectib_hw_klm_entry_print(&(ptr_struct->klm_entry), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sxdc:\n");
	connectib_hw_sxdc_print(&(ptr_struct->sxdc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pipa:\n");
	connectib_hw_pipa_print(&(ptr_struct->pipa), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sq_qp_list:\n");
	connectib_hw_sq_qp_list_print(&(ptr_struct->sq_qp_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timer:\n");
	connectib_hw_timer_32_print(&(ptr_struct->timer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pkey:\n");
	connectib_hw_pkey_print(&(ptr_struct->pkey), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_ste:\n");
	connectib_hw_ste_print(&(ptr_struct->hw_ste), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_entry_icmc:\n");
	connectib_steering_entry_icmc_print(&(ptr_struct->steering_entry_icmc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtt:\n");
	connectib_icm_mtt_print(&(ptr_struct->mtt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdb:\n");
	connectib_hw_rdb_print(&(ptr_struct->rdb), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix:\n");
	connectib_hw_msix_print(&(ptr_struct->msix), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp_counter:\n");
	connectib_hw_qp_counter_print(&(ptr_struct->qp_counter), file, indent_level + 1);

}

int connectib_hw_hca_contexts_size(void){
	 return 64;
}

void connectib_hw_hca_contexts_dump(const union connectib_hw_hca_contexts *ptr_struct, FILE* file) {
	connectib_hw_hca_contexts_print(ptr_struct, file, 0);
}

void connectib_field_boundary_pack(const struct connectib_field_boundary *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->field_boundary);

}

void connectib_field_boundary_unpack(struct connectib_field_boundary *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->field_boundary = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_field_boundary_print(const struct connectib_field_boundary *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_field_boundary ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary       : "U32H_FMT"\n", ptr_struct->field_boundary);

}

int connectib_field_boundary_size(void){
	 return 4;
}

void connectib_field_boundary_dump(const struct connectib_field_boundary *ptr_struct, FILE* file) {
	connectib_field_boundary_print(ptr_struct, file, 0);
}

void connectib_add_data_pack(const struct connectib_add_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->add_data);

}

void connectib_add_data_unpack(struct connectib_add_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->add_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_add_data_print(const struct connectib_add_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_add_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data             : "U32H_FMT"\n", ptr_struct->add_data);

}

int connectib_add_data_size(void){
	 return 4;
}

void connectib_add_data_dump(const struct connectib_add_data *ptr_struct, FILE* file) {
	connectib_add_data_print(ptr_struct, file, 0);
}

void connectib_compare_mask_data_pack(const struct connectib_compare_mask_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_mask_data);

}

void connectib_compare_mask_data_unpack(struct connectib_compare_mask_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->compare_mask_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_compare_mask_data_print(const struct connectib_compare_mask_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_compare_mask_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data    : "U32H_FMT"\n", ptr_struct->compare_mask_data);

}

int connectib_compare_mask_data_size(void){
	 return 4;
}

void connectib_compare_mask_data_dump(const struct connectib_compare_mask_data *ptr_struct, FILE* file) {
	connectib_compare_mask_data_print(ptr_struct, file, 0);
}

void connectib_swap_mask_data_pack(const struct connectib_swap_mask_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_mask_data);

}

void connectib_swap_mask_data_unpack(struct connectib_swap_mask_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->swap_mask_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_swap_mask_data_print(const struct connectib_swap_mask_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_swap_mask_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data       : "U32H_FMT"\n", ptr_struct->swap_mask_data);

}

int connectib_swap_mask_data_size(void){
	 return 4;
}

void connectib_swap_mask_data_dump(const struct connectib_swap_mask_data *ptr_struct, FILE* file) {
	connectib_swap_mask_data_print(ptr_struct, file, 0);
}

void connectib_compare_data_pack(const struct connectib_compare_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_data);

}

void connectib_compare_data_unpack(struct connectib_compare_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->compare_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_compare_data_print(const struct connectib_compare_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_compare_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data         : "U32H_FMT"\n", ptr_struct->compare_data);

}

int connectib_compare_data_size(void){
	 return 4;
}

void connectib_compare_data_dump(const struct connectib_compare_data *ptr_struct, FILE* file) {
	connectib_compare_data_print(ptr_struct, file, 0);
}

void connectib_swap_data_pack(const struct connectib_swap_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_data);

}

void connectib_swap_data_unpack(struct connectib_swap_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->swap_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_swap_data_print(const struct connectib_swap_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_swap_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data            : "U32H_FMT"\n", ptr_struct->swap_data);

}

int connectib_swap_data_size(void){
	 return 4;
}

void connectib_swap_data_dump(const struct connectib_swap_data *ptr_struct, FILE* file) {
	connectib_swap_data_print(ptr_struct, file, 0);
}

void connectib_nv_data_pointer_pack(const struct connectib_nv_data_pointer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->offset_in_64_bytes);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->size_in_64_bytes);

}

void connectib_nv_data_pointer_unpack(struct connectib_nv_data_pointer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->offset_in_64_bytes = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=6;
	ptr_struct->size_in_64_bytes = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void connectib_nv_data_pointer_print(const struct connectib_nv_data_pointer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_data_pointer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_in_64_bytes   : "UH_FMT"\n", ptr_struct->offset_in_64_bytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size_in_64_bytes     : "UH_FMT"\n", ptr_struct->size_in_64_bytes);

}

int connectib_nv_data_pointer_size(void){
	 return 4;
}

void connectib_nv_data_pointer_dump(const struct connectib_nv_data_pointer *ptr_struct, FILE* file) {
	connectib_nv_data_pointer_print(ptr_struct, file, 0);
}

void connectib_jump_addresses_pack(const struct connectib_jump_addresses *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->plastic);

}

void connectib_jump_addresses_unpack(struct connectib_jump_addresses *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->plastic = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_jump_addresses_print(const struct connectib_jump_addresses *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_jump_addresses ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plastic              : "UH_FMT"\n", ptr_struct->plastic);

}

int connectib_jump_addresses_size(void){
	 return 28;
}

void connectib_jump_addresses_dump(const struct connectib_jump_addresses *ptr_struct, FILE* file) {
	connectib_jump_addresses_print(ptr_struct, file, 0);
}

void connectib_pcie_rx_adaptation_cfg_pack(const struct connectib_pcie_rx_adaptation_cfg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->actual_ffe_tap_config_num);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ffe_tap_value_lifting_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->redo_calibration);

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(32, 64, i, 544, 1);
	connectib_ffe_tap_set_pack(&(ptr_struct->ffe_tap_config[i]), ptr_buff + offset/8);
	}

}

void connectib_pcie_rx_adaptation_cfg_unpack(struct connectib_pcie_rx_adaptation_cfg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->actual_ffe_tap_config_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=27;
	ptr_struct->ffe_tap_value_lifting_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->redo_calibration = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(32, 64, i, 544, 1);
	connectib_ffe_tap_set_unpack(&(ptr_struct->ffe_tap_config[i]), ptr_buff + offset/8);
	}

}

void connectib_pcie_rx_adaptation_cfg_print(const struct connectib_pcie_rx_adaptation_cfg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_rx_adaptation_cfg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "actual_ffe_tap_config_num : "UH_FMT"\n", ptr_struct->actual_ffe_tap_config_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_value_lifting_en : "UH_FMT"\n", ptr_struct->ffe_tap_value_lifting_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "redo_calibration     : "UH_FMT"\n", ptr_struct->redo_calibration);

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffe_tap_config_%03d:\n", i);
	connectib_ffe_tap_set_print(&(ptr_struct->ffe_tap_config[i]), file, indent_level + 1);
	}

}

int connectib_pcie_rx_adaptation_cfg_size(void){
	 return 68;
}

void connectib_pcie_rx_adaptation_cfg_dump(const struct connectib_pcie_rx_adaptation_cfg *ptr_struct, FILE* file) {
	connectib_pcie_rx_adaptation_cfg_print(ptr_struct, file, 0);
}

void connectib_pcie_tx_adaptation_cfg_pack(const struct connectib_pcie_tx_adaptation_cfg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->tx_adaptation_config_num);

	for (i=0; i < 3; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 128, 1);
	connectib_GEN3_TRANSMITTER_SETTING_pack(&(ptr_struct->tx_adaptation_ts_param[i]), ptr_buff + offset/8);
	}

}

void connectib_pcie_tx_adaptation_cfg_unpack(struct connectib_pcie_tx_adaptation_cfg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->tx_adaptation_config_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 3; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 128, 1);
	connectib_GEN3_TRANSMITTER_SETTING_unpack(&(ptr_struct->tx_adaptation_ts_param[i]), ptr_buff + offset/8);
	}

}

void connectib_pcie_tx_adaptation_cfg_print(const struct connectib_pcie_tx_adaptation_cfg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_tx_adaptation_cfg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_adaptation_config_num : "UH_FMT"\n", ptr_struct->tx_adaptation_config_num);

	for (i=0; i < 3; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_adaptation_ts_param_%03d:\n", i);
	connectib_GEN3_TRANSMITTER_SETTING_print(&(ptr_struct->tx_adaptation_ts_param[i]), file, indent_level + 1);
	}

}

int connectib_pcie_tx_adaptation_cfg_size(void){
	 return 16;
}

void connectib_pcie_tx_adaptation_cfg_dump(const struct connectib_pcie_tx_adaptation_cfg *ptr_struct, FILE* file) {
	connectib_pcie_tx_adaptation_cfg_print(ptr_struct, file, 0);
}

void connectib_pcie_debug_cap_pack(const struct connectib_pcie_debug_cap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 13, (u_int32_t)ptr_struct->internal_cause_mask);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->width_debug_en);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->speed_debug_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->internal_cause_en);

}

void connectib_pcie_debug_cap_unpack(struct connectib_pcie_debug_cap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=19;
	ptr_struct->internal_cause_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 13);

	offset=2;
	ptr_struct->width_debug_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->speed_debug_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->internal_cause_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_pcie_debug_cap_print(const struct connectib_pcie_debug_cap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_debug_cap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_cause_mask  : "UH_FMT"\n", ptr_struct->internal_cause_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "width_debug_en       : "UH_FMT"\n", ptr_struct->width_debug_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "speed_debug_en       : "UH_FMT"\n", ptr_struct->speed_debug_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_cause_en    : "UH_FMT"\n", ptr_struct->internal_cause_en);

}

int connectib_pcie_debug_cap_size(void){
	 return 4;
}

void connectib_pcie_debug_cap_dump(const struct connectib_pcie_debug_cap *ptr_struct, FILE* file) {
	connectib_pcie_debug_cap_print(ptr_struct, file, 0);
}

void connectib_pcie_equalization_and_eye_pack(const struct connectib_pcie_equalization_and_eye *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->local_fs);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->local_lf);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->preset);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_preset);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phase0_timeout);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->phase2_timeout);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fast_x1_eql_for_compliance);

	for (i=0; i < 11; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 416, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->gen3_preset[i]);
	}

	offset=411;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->eye_center_mixer_offset);

	offset=410;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eye_center_mix90_en);

	offset=409;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eye_center_offset_en);

	offset=408;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->first_offset_phase_second);

	offset=400;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->phase_err_wait_time);

	offset=396;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->phase_stabilize_time);

}

void connectib_pcie_equalization_and_eye_unpack(struct connectib_pcie_equalization_and_eye *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->local_fs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=19;
	ptr_struct->local_lf = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=12;
	ptr_struct->preset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=11;
	ptr_struct->force_preset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->phase0_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=1;
	ptr_struct->phase2_timeout = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=0;
	ptr_struct->fast_x1_eql_for_compliance = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i=0; i < 11; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 416, 1);
	ptr_struct->gen3_preset[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=411;
	ptr_struct->eye_center_mixer_offset = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=410;
	ptr_struct->eye_center_mix90_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=409;
	ptr_struct->eye_center_offset_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=408;
	ptr_struct->first_offset_phase_second = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=400;
	ptr_struct->phase_err_wait_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=396;
	ptr_struct->phase_stabilize_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_pcie_equalization_and_eye_print(const struct connectib_pcie_equalization_and_eye *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_equalization_and_eye ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_fs             : "UH_FMT"\n", ptr_struct->local_fs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_lf             : "UH_FMT"\n", ptr_struct->local_lf);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "preset               : "UH_FMT"\n", ptr_struct->preset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_preset         : "UH_FMT"\n", ptr_struct->force_preset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase0_timeout       : "UH_FMT"\n", ptr_struct->phase0_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase2_timeout       : "UH_FMT"\n", ptr_struct->phase2_timeout);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fast_x1_eql_for_compliance : "UH_FMT"\n", ptr_struct->fast_x1_eql_for_compliance);

	for (i=0; i < 11; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen3_preset_%03d     : "U32H_FMT"\n", i, ptr_struct->gen3_preset[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_center_mixer_offset : "UH_FMT"\n", ptr_struct->eye_center_mixer_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_center_mix90_en  : "UH_FMT"\n", ptr_struct->eye_center_mix90_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_center_offset_en : "UH_FMT"\n", ptr_struct->eye_center_offset_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_offset_phase_second : "UH_FMT"\n", ptr_struct->first_offset_phase_second);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_err_wait_time  : "UH_FMT"\n", ptr_struct->phase_err_wait_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_stabilize_time : "UH_FMT"\n", ptr_struct->phase_stabilize_time);

}

int connectib_pcie_equalization_and_eye_size(void){
	 return 52;
}

void connectib_pcie_equalization_and_eye_dump(const struct connectib_pcie_equalization_and_eye *ptr_struct, FILE* file) {
	connectib_pcie_equalization_and_eye_print(ptr_struct, file, 0);
}

void connectib_pcie_serdes_cfg_pack(const struct connectib_pcie_serdes_cfg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->sdr_preemp);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sdr_preemp_pre);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sdr_preemp_post);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->sdr_preemp_main);

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ddr_6_db_preemp);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_6_db_preemp_pre);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_6_db_preemp_post);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_6_db_preemp_main);

	offset=93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->ddr_3_dot_5_db_preemp);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_3_dot_5_db_preemp_pre);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_3_dot_5_db_preemp_post);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ddr_3_dot_5_db_preemp_main);

	offset=96;
	connectib_GEN3_TRANSMITTER_SETTING_pack(&(ptr_struct->gen3_def_tx_preset), ptr_buff + offset/8);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->slicer_ind_en);

	offset=148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->slicer1_enable);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->slicer2_enable);

	offset=185;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->signal_detect_threshold);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->signal_detect_en);

	offset=180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->ob_bias);

	offset=192;
	connectib_ffe_tap_set_pack(&(ptr_struct->default_ffe_tap_set), ptr_buff + offset/8);

}

void connectib_pcie_serdes_cfg_unpack(struct connectib_pcie_serdes_cfg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->sdr_preemp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=16;
	ptr_struct->sdr_preemp_pre = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->sdr_preemp_post = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->sdr_preemp_main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=61;
	ptr_struct->ddr_6_db_preemp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=48;
	ptr_struct->ddr_6_db_preemp_pre = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=40;
	ptr_struct->ddr_6_db_preemp_post = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->ddr_6_db_preemp_main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=93;
	ptr_struct->ddr_3_dot_5_db_preemp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=80;
	ptr_struct->ddr_3_dot_5_db_preemp_pre = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->ddr_3_dot_5_db_preemp_post = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->ddr_3_dot_5_db_preemp_main = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	connectib_GEN3_TRANSMITTER_SETTING_unpack(&(ptr_struct->gen3_def_tx_preset), ptr_buff + offset/8);

	offset=152;
	ptr_struct->slicer_ind_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=148;
	ptr_struct->slicer1_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->slicer2_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=185;
	ptr_struct->signal_detect_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=184;
	ptr_struct->signal_detect_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=180;
	ptr_struct->ob_bias = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=192;
	connectib_ffe_tap_set_unpack(&(ptr_struct->default_ffe_tap_set), ptr_buff + offset/8);

}

void connectib_pcie_serdes_cfg_print(const struct connectib_pcie_serdes_cfg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_serdes_cfg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdr_preemp           : "UH_FMT"\n", ptr_struct->sdr_preemp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdr_preemp_pre       : "UH_FMT"\n", ptr_struct->sdr_preemp_pre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdr_preemp_post      : "UH_FMT"\n", ptr_struct->sdr_preemp_post);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sdr_preemp_main      : "UH_FMT"\n", ptr_struct->sdr_preemp_main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_6_db_preemp      : "UH_FMT"\n", ptr_struct->ddr_6_db_preemp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_6_db_preemp_pre  : "UH_FMT"\n", ptr_struct->ddr_6_db_preemp_pre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_6_db_preemp_post : "UH_FMT"\n", ptr_struct->ddr_6_db_preemp_post);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_6_db_preemp_main : "UH_FMT"\n", ptr_struct->ddr_6_db_preemp_main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_3_dot_5_db_preemp : "UH_FMT"\n", ptr_struct->ddr_3_dot_5_db_preemp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_3_dot_5_db_preemp_pre : "UH_FMT"\n", ptr_struct->ddr_3_dot_5_db_preemp_pre);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_3_dot_5_db_preemp_post : "UH_FMT"\n", ptr_struct->ddr_3_dot_5_db_preemp_post);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ddr_3_dot_5_db_preemp_main : "UH_FMT"\n", ptr_struct->ddr_3_dot_5_db_preemp_main);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen3_def_tx_preset:\n");
	connectib_GEN3_TRANSMITTER_SETTING_print(&(ptr_struct->gen3_def_tx_preset), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer_ind_en        : "UH_FMT"\n", ptr_struct->slicer_ind_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer1_enable       : "UH_FMT"\n", ptr_struct->slicer1_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slicer2_enable       : "UH_FMT"\n", ptr_struct->slicer2_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signal_detect_threshold : "UH_FMT"\n", ptr_struct->signal_detect_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signal_detect_en     : "UH_FMT"\n", ptr_struct->signal_detect_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ob_bias              : "UH_FMT"\n", ptr_struct->ob_bias);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "default_ffe_tap_set:\n");
	connectib_ffe_tap_set_print(&(ptr_struct->default_ffe_tap_set), file, indent_level + 1);

}

int connectib_pcie_serdes_cfg_size(void){
	 return 32;
}

void connectib_pcie_serdes_cfg_dump(const struct connectib_pcie_serdes_cfg *ptr_struct, FILE* file) {
	connectib_pcie_serdes_cfg_print(ptr_struct, file, 0);
}

void connectib_gpio_configurations_pack(const struct connectib_gpio_configurations *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 48; i++) {
	offset=adb2c_calc_array_field_address(24, 8, i, 384, 1);
	connectib_gpio_config_pack(&(ptr_struct->gpio[i]), ptr_buff + offset/8);
	}

}

void connectib_gpio_configurations_unpack(struct connectib_gpio_configurations *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 48; i++) {
	offset=adb2c_calc_array_field_address(24, 8, i, 384, 1);
	connectib_gpio_config_unpack(&(ptr_struct->gpio[i]), ptr_buff + offset/8);
	}

}

void connectib_gpio_configurations_print(const struct connectib_gpio_configurations *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_gpio_configurations ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 48; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_%03d:\n", i);
	connectib_gpio_config_print(&(ptr_struct->gpio[i]), file, indent_level + 1);
	}

}

int connectib_gpio_configurations_size(void){
	 return 48;
}

void connectib_gpio_configurations_dump(const struct connectib_gpio_configurations *ptr_struct, FILE* file) {
	connectib_gpio_configurations_print(ptr_struct, file, 0);
}

void connectib_gpio_functions_pack(const struct connectib_gpio_functions *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	connectib_gpio_function_pack(&(ptr_struct->physical_led_p1), ptr_buff + offset/8);

	offset=16;
	connectib_gpio_function_pack(&(ptr_struct->physical_led_p2), ptr_buff + offset/8);

	offset=8;
	connectib_gpio_function_pack(&(ptr_struct->logical_led_p1), ptr_buff + offset/8);

	offset=0;
	connectib_gpio_function_pack(&(ptr_struct->logical_led_p2), ptr_buff + offset/8);

	offset=56;
	connectib_gpio_function_pack(&(ptr_struct->gp_lv), ptr_buff + offset/8);

	offset=48;
	connectib_gpio_function_pack(&(ptr_struct->int_p1_l), ptr_buff + offset/8);

	offset=40;
	connectib_gpio_function_pack(&(ptr_struct->int_p2_l), ptr_buff + offset/8);

	offset=32;
	connectib_gpio_function_pack(&(ptr_struct->modprs_p1_l), ptr_buff + offset/8);

	offset=88;
	connectib_gpio_function_pack(&(ptr_struct->modprs_p2_l), ptr_buff + offset/8);

	offset=80;
	connectib_gpio_function_pack(&(ptr_struct->modsel_p1_l), ptr_buff + offset/8);

	offset=72;
	connectib_gpio_function_pack(&(ptr_struct->modsel_p2_l), ptr_buff + offset/8);

	offset=64;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_arb_in), ptr_buff + offset/8);

	offset=120;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_arb_out), ptr_buff + offset/8);

	offset=112;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_crs_dv), ptr_buff + offset/8);

	offset=104;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_rxd0), ptr_buff + offset/8);

	offset=96;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_rxd1), ptr_buff + offset/8);

	offset=152;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_txd0), ptr_buff + offset/8);

	offset=144;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_txd1), ptr_buff + offset/8);

	offset=136;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_ref_clk), ptr_buff + offset/8);

	offset=128;
	connectib_gpio_function_pack(&(ptr_struct->ncsi_tx_en), ptr_buff + offset/8);

	offset=184;
	connectib_gpio_function_pack(&(ptr_struct->oc_int_l), ptr_buff + offset/8);

	offset=176;
	connectib_gpio_function_pack(&(ptr_struct->ovt_wrng), ptr_buff + offset/8);

	offset=168;
	connectib_gpio_function_pack(&(ptr_struct->ovt_shtdn), ptr_buff + offset/8);

	offset=160;
	connectib_gpio_function_pack(&(ptr_struct->pe_rst_l), ptr_buff + offset/8);

	offset=216;
	connectib_gpio_function_pack(&(ptr_struct->gpio_func_reserved), ptr_buff + offset/8);

	offset=208;
	connectib_gpio_function_pack(&(ptr_struct->reset_p1_l), ptr_buff + offset/8);

	offset=200;
	connectib_gpio_function_pack(&(ptr_struct->reset_p2_l), ptr_buff + offset/8);

	offset=192;
	connectib_gpio_function_pack(&(ptr_struct->spi_clk), ptr_buff + offset/8);

	offset=248;
	connectib_gpio_function_pack(&(ptr_struct->spi_cs0_l), ptr_buff + offset/8);

	offset=240;
	connectib_gpio_function_pack(&(ptr_struct->spi_cs1_l), ptr_buff + offset/8);

	offset=232;
	connectib_gpio_function_pack(&(ptr_struct->spi_io0), ptr_buff + offset/8);

	offset=224;
	connectib_gpio_function_pack(&(ptr_struct->spi_io1), ptr_buff + offset/8);

	offset=280;
	connectib_gpio_function_pack(&(ptr_struct->spi_io2), ptr_buff + offset/8);

	offset=272;
	connectib_gpio_function_pack(&(ptr_struct->spi_io3), ptr_buff + offset/8);

	offset=264;
	connectib_gpio_function_pack(&(ptr_struct->i2c_scl1), ptr_buff + offset/8);

	offset=256;
	connectib_gpio_function_pack(&(ptr_struct->i2c_scl2), ptr_buff + offset/8);

	offset=312;
	connectib_gpio_function_pack(&(ptr_struct->i2c_scl3), ptr_buff + offset/8);

	offset=304;
	connectib_gpio_function_pack(&(ptr_struct->i2c_sda1), ptr_buff + offset/8);

	offset=296;
	connectib_gpio_function_pack(&(ptr_struct->i2c_sda2), ptr_buff + offset/8);

	offset=288;
	connectib_gpio_function_pack(&(ptr_struct->i2c_sda3), ptr_buff + offset/8);

	offset=344;
	connectib_gpio_function_pack(&(ptr_struct->i2c_int_l), ptr_buff + offset/8);

	offset=336;
	connectib_gpio_function_pack(&(ptr_struct->i2c_rst_l), ptr_buff + offset/8);

	offset=328;
	connectib_gpio_function_pack(&(ptr_struct->vdd_mod), ptr_buff + offset/8);

	offset=320;
	connectib_gpio_function_pack(&(ptr_struct->wake_l), ptr_buff + offset/8);

	offset=376;
	connectib_gpio_function_pack(&(ptr_struct->ibm_mezz_fault_l), ptr_buff + offset/8);

	offset=368;
	connectib_gpio_function_pack(&(ptr_struct->ibm_ite_all_pgood), ptr_buff + offset/8);

	offset=360;
	connectib_gpio_function_pack(&(ptr_struct->ibm_t_control_l), ptr_buff + offset/8);

	offset=352;
	connectib_gpio_function_pack(&(ptr_struct->ibm_t_warning_l), ptr_buff + offset/8);

	offset=408;
	connectib_gpio_function_pack(&(ptr_struct->ibm_t_critical_l), ptr_buff + offset/8);

	offset=400;
	connectib_gpio_function_pack(&(ptr_struct->ibm_cib_slot_id_0), ptr_buff + offset/8);

	offset=392;
	connectib_gpio_function_pack(&(ptr_struct->ibm_cib_slot_id_1), ptr_buff + offset/8);

	offset=384;
	connectib_gpio_function_pack(&(ptr_struct->ibm_vpd_update_l), ptr_buff + offset/8);

	offset=440;
	connectib_gpio_function_pack(&(ptr_struct->ibm_vpd_cache_comp), ptr_buff + offset/8);

	offset=432;
	connectib_gpio_function_pack(&(ptr_struct->ibm_vpd_ctrl), ptr_buff + offset/8);

	offset=424;
	connectib_gpio_function_pack(&(ptr_struct->gpio_port_swap), ptr_buff + offset/8);

	offset=416;
	connectib_gpio_function_pack(&(ptr_struct->gpio_func_reserved_1), ptr_buff + offset/8);

}

void connectib_gpio_functions_unpack(struct connectib_gpio_functions *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	connectib_gpio_function_unpack(&(ptr_struct->physical_led_p1), ptr_buff + offset/8);

	offset=16;
	connectib_gpio_function_unpack(&(ptr_struct->physical_led_p2), ptr_buff + offset/8);

	offset=8;
	connectib_gpio_function_unpack(&(ptr_struct->logical_led_p1), ptr_buff + offset/8);

	offset=0;
	connectib_gpio_function_unpack(&(ptr_struct->logical_led_p2), ptr_buff + offset/8);

	offset=56;
	connectib_gpio_function_unpack(&(ptr_struct->gp_lv), ptr_buff + offset/8);

	offset=48;
	connectib_gpio_function_unpack(&(ptr_struct->int_p1_l), ptr_buff + offset/8);

	offset=40;
	connectib_gpio_function_unpack(&(ptr_struct->int_p2_l), ptr_buff + offset/8);

	offset=32;
	connectib_gpio_function_unpack(&(ptr_struct->modprs_p1_l), ptr_buff + offset/8);

	offset=88;
	connectib_gpio_function_unpack(&(ptr_struct->modprs_p2_l), ptr_buff + offset/8);

	offset=80;
	connectib_gpio_function_unpack(&(ptr_struct->modsel_p1_l), ptr_buff + offset/8);

	offset=72;
	connectib_gpio_function_unpack(&(ptr_struct->modsel_p2_l), ptr_buff + offset/8);

	offset=64;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_arb_in), ptr_buff + offset/8);

	offset=120;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_arb_out), ptr_buff + offset/8);

	offset=112;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_crs_dv), ptr_buff + offset/8);

	offset=104;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_rxd0), ptr_buff + offset/8);

	offset=96;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_rxd1), ptr_buff + offset/8);

	offset=152;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_txd0), ptr_buff + offset/8);

	offset=144;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_txd1), ptr_buff + offset/8);

	offset=136;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_ref_clk), ptr_buff + offset/8);

	offset=128;
	connectib_gpio_function_unpack(&(ptr_struct->ncsi_tx_en), ptr_buff + offset/8);

	offset=184;
	connectib_gpio_function_unpack(&(ptr_struct->oc_int_l), ptr_buff + offset/8);

	offset=176;
	connectib_gpio_function_unpack(&(ptr_struct->ovt_wrng), ptr_buff + offset/8);

	offset=168;
	connectib_gpio_function_unpack(&(ptr_struct->ovt_shtdn), ptr_buff + offset/8);

	offset=160;
	connectib_gpio_function_unpack(&(ptr_struct->pe_rst_l), ptr_buff + offset/8);

	offset=216;
	connectib_gpio_function_unpack(&(ptr_struct->gpio_func_reserved), ptr_buff + offset/8);

	offset=208;
	connectib_gpio_function_unpack(&(ptr_struct->reset_p1_l), ptr_buff + offset/8);

	offset=200;
	connectib_gpio_function_unpack(&(ptr_struct->reset_p2_l), ptr_buff + offset/8);

	offset=192;
	connectib_gpio_function_unpack(&(ptr_struct->spi_clk), ptr_buff + offset/8);

	offset=248;
	connectib_gpio_function_unpack(&(ptr_struct->spi_cs0_l), ptr_buff + offset/8);

	offset=240;
	connectib_gpio_function_unpack(&(ptr_struct->spi_cs1_l), ptr_buff + offset/8);

	offset=232;
	connectib_gpio_function_unpack(&(ptr_struct->spi_io0), ptr_buff + offset/8);

	offset=224;
	connectib_gpio_function_unpack(&(ptr_struct->spi_io1), ptr_buff + offset/8);

	offset=280;
	connectib_gpio_function_unpack(&(ptr_struct->spi_io2), ptr_buff + offset/8);

	offset=272;
	connectib_gpio_function_unpack(&(ptr_struct->spi_io3), ptr_buff + offset/8);

	offset=264;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_scl1), ptr_buff + offset/8);

	offset=256;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_scl2), ptr_buff + offset/8);

	offset=312;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_scl3), ptr_buff + offset/8);

	offset=304;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_sda1), ptr_buff + offset/8);

	offset=296;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_sda2), ptr_buff + offset/8);

	offset=288;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_sda3), ptr_buff + offset/8);

	offset=344;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_int_l), ptr_buff + offset/8);

	offset=336;
	connectib_gpio_function_unpack(&(ptr_struct->i2c_rst_l), ptr_buff + offset/8);

	offset=328;
	connectib_gpio_function_unpack(&(ptr_struct->vdd_mod), ptr_buff + offset/8);

	offset=320;
	connectib_gpio_function_unpack(&(ptr_struct->wake_l), ptr_buff + offset/8);

	offset=376;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_mezz_fault_l), ptr_buff + offset/8);

	offset=368;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_ite_all_pgood), ptr_buff + offset/8);

	offset=360;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_t_control_l), ptr_buff + offset/8);

	offset=352;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_t_warning_l), ptr_buff + offset/8);

	offset=408;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_t_critical_l), ptr_buff + offset/8);

	offset=400;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_cib_slot_id_0), ptr_buff + offset/8);

	offset=392;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_cib_slot_id_1), ptr_buff + offset/8);

	offset=384;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_vpd_update_l), ptr_buff + offset/8);

	offset=440;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_vpd_cache_comp), ptr_buff + offset/8);

	offset=432;
	connectib_gpio_function_unpack(&(ptr_struct->ibm_vpd_ctrl), ptr_buff + offset/8);

	offset=424;
	connectib_gpio_function_unpack(&(ptr_struct->gpio_port_swap), ptr_buff + offset/8);

	offset=416;
	connectib_gpio_function_unpack(&(ptr_struct->gpio_func_reserved_1), ptr_buff + offset/8);

}

void connectib_gpio_functions_print(const struct connectib_gpio_functions *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_gpio_functions ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "physical_led_p1:\n");
	connectib_gpio_function_print(&(ptr_struct->physical_led_p1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "physical_led_p2:\n");
	connectib_gpio_function_print(&(ptr_struct->physical_led_p2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "logical_led_p1:\n");
	connectib_gpio_function_print(&(ptr_struct->logical_led_p1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "logical_led_p2:\n");
	connectib_gpio_function_print(&(ptr_struct->logical_led_p2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gp_lv:\n");
	connectib_gpio_function_print(&(ptr_struct->gp_lv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_p1_l:\n");
	connectib_gpio_function_print(&(ptr_struct->int_p1_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "int_p2_l:\n");
	connectib_gpio_function_print(&(ptr_struct->int_p2_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modprs_p1_l:\n");
	connectib_gpio_function_print(&(ptr_struct->modprs_p1_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modprs_p2_l:\n");
	connectib_gpio_function_print(&(ptr_struct->modprs_p2_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modsel_p1_l:\n");
	connectib_gpio_function_print(&(ptr_struct->modsel_p1_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "modsel_p2_l:\n");
	connectib_gpio_function_print(&(ptr_struct->modsel_p2_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_arb_in:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_arb_in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_arb_out:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_arb_out), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_crs_dv:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_crs_dv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_rxd0:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_rxd0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_rxd1:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_rxd1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_txd0:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_txd0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_txd1:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_txd1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_ref_clk:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_ref_clk), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ncsi_tx_en:\n");
	connectib_gpio_function_print(&(ptr_struct->ncsi_tx_en), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oc_int_l:\n");
	connectib_gpio_function_print(&(ptr_struct->oc_int_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ovt_wrng:\n");
	connectib_gpio_function_print(&(ptr_struct->ovt_wrng), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ovt_shtdn:\n");
	connectib_gpio_function_print(&(ptr_struct->ovt_shtdn), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pe_rst_l:\n");
	connectib_gpio_function_print(&(ptr_struct->pe_rst_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_func_reserved:\n");
	connectib_gpio_function_print(&(ptr_struct->gpio_func_reserved), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_p1_l:\n");
	connectib_gpio_function_print(&(ptr_struct->reset_p1_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_p2_l:\n");
	connectib_gpio_function_print(&(ptr_struct->reset_p2_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_clk:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_clk), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_cs0_l:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_cs0_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_cs1_l:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_cs1_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_io0:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_io0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_io1:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_io1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_io2:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_io2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spi_io3:\n");
	connectib_gpio_function_print(&(ptr_struct->spi_io3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_scl1:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_scl1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_scl2:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_scl2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_scl3:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_scl3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_sda1:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_sda1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_sda2:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_sda2), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_sda3:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_sda3), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_int_l:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_int_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_rst_l:\n");
	connectib_gpio_function_print(&(ptr_struct->i2c_rst_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vdd_mod:\n");
	connectib_gpio_function_print(&(ptr_struct->vdd_mod), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wake_l:\n");
	connectib_gpio_function_print(&(ptr_struct->wake_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_mezz_fault_l:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_mezz_fault_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_ite_all_pgood:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_ite_all_pgood), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_t_control_l:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_t_control_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_t_warning_l:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_t_warning_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_t_critical_l:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_t_critical_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_cib_slot_id_0:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_cib_slot_id_0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_cib_slot_id_1:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_cib_slot_id_1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_vpd_update_l:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_vpd_update_l), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_vpd_cache_comp:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_vpd_cache_comp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_vpd_ctrl:\n");
	connectib_gpio_function_print(&(ptr_struct->ibm_vpd_ctrl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_port_swap:\n");
	connectib_gpio_function_print(&(ptr_struct->gpio_port_swap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_func_reserved_1:\n");
	connectib_gpio_function_print(&(ptr_struct->gpio_func_reserved_1), file, indent_level + 1);

}

int connectib_gpio_functions_size(void){
	 return 84;
}

void connectib_gpio_functions_dump(const struct connectib_gpio_functions *ptr_struct, FILE* file) {
	connectib_gpio_functions_print(ptr_struct, file, 0);
}

void connectib_i2c_device_entry_pack(const struct connectib_i2c_device_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->slave_addr);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->bus_id);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->addr_size);

}

void connectib_i2c_device_entry_unpack(struct connectib_i2c_device_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	ptr_struct->slave_addr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=22;
	ptr_struct->bus_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=13;
	ptr_struct->addr_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

}

void connectib_i2c_device_entry_print(const struct connectib_i2c_device_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_i2c_device_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slave_addr           : "UH_FMT"\n", ptr_struct->slave_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bus_id               : "UH_FMT"\n", ptr_struct->bus_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_size            : "UH_FMT"\n", ptr_struct->addr_size);

}

int connectib_i2c_device_entry_size(void){
	 return 4;
}

void connectib_i2c_device_entry_dump(const struct connectib_i2c_device_entry *ptr_struct, FILE* file) {
	connectib_i2c_device_entry_print(ptr_struct, file, 0);
}

void connectib_module_config_st_pack(const struct connectib_module_config_st *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->module_power_level_supported);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->module_mlnx_sub_power_supported);

}

void connectib_module_config_st_unpack(struct connectib_module_config_st *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->module_power_level_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=24;
	ptr_struct->module_mlnx_sub_power_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

}

void connectib_module_config_st_print(const struct connectib_module_config_st *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_module_config_st ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_power_level_supported : "UH_FMT"\n", ptr_struct->module_power_level_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_mlnx_sub_power_supported : "UH_FMT"\n", ptr_struct->module_mlnx_sub_power_supported);

}

int connectib_module_config_st_size(void){
	 return 4;
}

void connectib_module_config_st_dump(const struct connectib_module_config_st *ptr_struct, FILE* file) {
	connectib_module_config_st_print(ptr_struct, file, 0);
}

void connectib_iopx_power_pack(const struct connectib_iopx_power *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ref_clk_right_left_);

}

void connectib_iopx_power_unpack(struct connectib_iopx_power *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->ref_clk_right_left_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_iopx_power_print(const struct connectib_iopx_power *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_iopx_power ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_clk_right_left_  : "UH_FMT"\n", ptr_struct->ref_clk_right_left_);

}

int connectib_iopx_power_size(void){
	 return 4;
}

void connectib_iopx_power_dump(const struct connectib_iopx_power *ptr_struct, FILE* file) {
	connectib_iopx_power_print(ptr_struct, file, 0);
}

void connectib_iopl_power_pack(const struct connectib_iopl_power *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ref_clk_right_left_);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dynamic_pll_manage_en);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dynamic_serdes_manage_en);

}

void connectib_iopl_power_unpack(struct connectib_iopl_power *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->ref_clk_right_left_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->dynamic_pll_manage_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->dynamic_serdes_manage_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_iopl_power_print(const struct connectib_iopl_power *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_iopl_power ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ref_clk_right_left_  : "UH_FMT"\n", ptr_struct->ref_clk_right_left_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dynamic_pll_manage_en : "UH_FMT"\n", ptr_struct->dynamic_pll_manage_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dynamic_serdes_manage_en : "UH_FMT"\n", ptr_struct->dynamic_serdes_manage_en);

}

int connectib_iopl_power_size(void){
	 return 4;
}

void connectib_iopl_power_dump(const struct connectib_iopl_power *ptr_struct, FILE* file) {
	connectib_iopl_power_print(ptr_struct, file, 0);
}

void connectib_port_mlpn_db_pack(const struct connectib_port_mlpn_db *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlpn_database_all_protocol_ini_pack(&(ptr_struct->mlpn_supported), ptr_buff + offset/8);

	offset=32;
	connectib_mlpn_database_all_protocol_ini_pack(&(ptr_struct->mlpn_request), ptr_buff + offset/8);

	offset=64;
	connectib_mlpn_enhanced_database_ini_pack(&(ptr_struct->mlpn_enhanced_database), ptr_buff + offset/8);

}

void connectib_port_mlpn_db_unpack(struct connectib_port_mlpn_db *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_mlpn_database_all_protocol_ini_unpack(&(ptr_struct->mlpn_supported), ptr_buff + offset/8);

	offset=32;
	connectib_mlpn_database_all_protocol_ini_unpack(&(ptr_struct->mlpn_request), ptr_buff + offset/8);

	offset=64;
	connectib_mlpn_enhanced_database_ini_unpack(&(ptr_struct->mlpn_enhanced_database), ptr_buff + offset/8);

}

void connectib_port_mlpn_db_print(const struct connectib_port_mlpn_db *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_mlpn_db ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_supported:\n");
	connectib_mlpn_database_all_protocol_ini_print(&(ptr_struct->mlpn_supported), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_request:\n");
	connectib_mlpn_database_all_protocol_ini_print(&(ptr_struct->mlpn_request), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_enhanced_database:\n");
	connectib_mlpn_enhanced_database_ini_print(&(ptr_struct->mlpn_enhanced_database), file, indent_level + 1);

}

int connectib_port_mlpn_db_size(void){
	 return 16;
}

void connectib_port_mlpn_db_dump(const struct connectib_port_mlpn_db *ptr_struct, FILE* file) {
	connectib_port_mlpn_db_print(ptr_struct, file, 0);
}

void connectib_pll_params_pack(const struct connectib_pll_params *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pll_fctrl_th);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_phy_varactor_calibration);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 288, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pll_fctrl_var[i]);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(160, 32, i, 288, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pll_fctrl_val[i]);
	}

}

void connectib_pll_params_unpack(struct connectib_pll_params *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->pll_fctrl_th = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->enable_phy_varactor_calibration = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 288, 1);
	ptr_struct->pll_fctrl_var[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(160, 32, i, 288, 1);
	ptr_struct->pll_fctrl_val[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_pll_params_print(const struct connectib_pll_params *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pll_params ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_fctrl_th         : "UH_FMT"\n", ptr_struct->pll_fctrl_th);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_phy_varactor_calibration : "UH_FMT"\n", ptr_struct->enable_phy_varactor_calibration);

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_fctrl_var_%03d   : "U32H_FMT"\n", i, ptr_struct->pll_fctrl_var[i]);
	}

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_fctrl_val_%03d   : "U32H_FMT"\n", i, ptr_struct->pll_fctrl_val[i]);
	}

}

int connectib_pll_params_size(void){
	 return 36;
}

void connectib_pll_params_dump(const struct connectib_pll_params *ptr_struct, FILE* file) {
	connectib_pll_params_print(ptr_struct, file, 0);
}

void connectib_logic_serdes_mapping_node_ini_pack(const struct connectib_logic_serdes_mapping_node_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_tx_rx_logic_serdes_mapping_node_ini_pack(&(ptr_struct->tx), ptr_buff + offset/8);

	offset=256;
	connectib_tx_rx_logic_serdes_mapping_node_ini_pack(&(ptr_struct->rx), ptr_buff + offset/8);

}

void connectib_logic_serdes_mapping_node_ini_unpack(struct connectib_logic_serdes_mapping_node_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_tx_rx_logic_serdes_mapping_node_ini_unpack(&(ptr_struct->tx), ptr_buff + offset/8);

	offset=256;
	connectib_tx_rx_logic_serdes_mapping_node_ini_unpack(&(ptr_struct->rx), ptr_buff + offset/8);

}

void connectib_logic_serdes_mapping_node_ini_print(const struct connectib_logic_serdes_mapping_node_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_logic_serdes_mapping_node_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx:\n");
	connectib_tx_rx_logic_serdes_mapping_node_ini_print(&(ptr_struct->tx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx:\n");
	connectib_tx_rx_logic_serdes_mapping_node_ini_print(&(ptr_struct->rx), file, indent_level + 1);

}

int connectib_logic_serdes_mapping_node_ini_size(void){
	 return 64;
}

void connectib_logic_serdes_mapping_node_ini_dump(const struct connectib_logic_serdes_mapping_node_ini *ptr_struct, FILE* file) {
	connectib_logic_serdes_mapping_node_ini_print(ptr_struct, file, 0);
}

void connectib_phy_hw_main_config_ip_pack(const struct connectib_phy_hw_main_config_ip *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 11776, 1);
	connectib_PORT_PHY_ini_pack(&(ptr_struct->port[i]), ptr_buff + offset/8);
	}

	offset=256;
	connectib_ib_ini_ini_pack(&(ptr_struct->ib), ptr_buff + offset/8);

	offset=1024;
	connectib_rx_adapt_ini_pack(&(ptr_struct->rx_adapt_ini), ptr_buff + offset/8);

	offset=1280;
	connectib_serdes_conf_ini_pack(&(ptr_struct->serdes_conf), ptr_buff + offset/8);

}

void connectib_phy_hw_main_config_ip_unpack(struct connectib_phy_hw_main_config_ip *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 11776, 1);
	connectib_PORT_PHY_ini_unpack(&(ptr_struct->port[i]), ptr_buff + offset/8);
	}

	offset=256;
	connectib_ib_ini_ini_unpack(&(ptr_struct->ib), ptr_buff + offset/8);

	offset=1024;
	connectib_rx_adapt_ini_unpack(&(ptr_struct->rx_adapt_ini), ptr_buff + offset/8);

	offset=1280;
	connectib_serdes_conf_ini_unpack(&(ptr_struct->serdes_conf), ptr_buff + offset/8);

}

void connectib_phy_hw_main_config_ip_print(const struct connectib_phy_hw_main_config_ip *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_hw_main_config_ip ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_%03d:\n", i);
	connectib_PORT_PHY_ini_print(&(ptr_struct->port[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib:\n");
	connectib_ib_ini_ini_print(&(ptr_struct->ib), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_adapt_ini:\n");
	connectib_rx_adapt_ini_print(&(ptr_struct->rx_adapt_ini), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serdes_conf:\n");
	connectib_serdes_conf_ini_print(&(ptr_struct->serdes_conf), file, indent_level + 1);

}

int connectib_phy_hw_main_config_ip_size(void){
	 return 1472;
}

void connectib_phy_hw_main_config_ip_dump(const struct connectib_phy_hw_main_config_ip *ptr_struct, FILE* file) {
	connectib_phy_hw_main_config_ip_print(ptr_struct, file, 0);
}

void connectib_nv_config_boot_global_pack(const struct connectib_nv_config_boot_global *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_pci_pack(&(ptr_struct->pci), ptr_buff + offset/8);

	offset=256;
	connectib_nv_config_tpt_pack(&(ptr_struct->tpt), ptr_buff + offset/8);

}

void connectib_nv_config_boot_global_unpack(struct connectib_nv_config_boot_global *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_pci_unpack(&(ptr_struct->pci), ptr_buff + offset/8);

	offset=256;
	connectib_nv_config_tpt_unpack(&(ptr_struct->tpt), ptr_buff + offset/8);

}

void connectib_nv_config_boot_global_print(const struct connectib_nv_config_boot_global *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_boot_global ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci:\n");
	connectib_nv_config_pci_print(&(ptr_struct->pci), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tpt:\n");
	connectib_nv_config_tpt_print(&(ptr_struct->tpt), file, indent_level + 1);

}

int connectib_nv_config_boot_global_size(void){
	 return 40;
}

void connectib_nv_config_boot_global_dump(const struct connectib_nv_config_boot_global *ptr_struct, FILE* file) {
	connectib_nv_config_boot_global_print(ptr_struct, file, 0);
}

void connectib_pciex_ext_cfg_space_pack(const struct connectib_pciex_ext_cfg_space *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_secondary_pciex_ext_cap_pack(&(ptr_struct->secondary_pciex_ext_cap), ptr_buff + offset/8);

	offset=352;
	connectib_ari_cap_pack(&(ptr_struct->ari), ptr_buff + offset/8);

	offset=416;
	connectib_sriov_cap_pack(&(ptr_struct->sriov), ptr_buff + offset/8);

	offset=928;
	connectib_dev_serial_num_cap_pack(&(ptr_struct->device_serial_number), ptr_buff + offset/8);

	offset=1024;
	connectib_advanced_error_reporting_pack(&(ptr_struct->advanced_error_reporting), ptr_buff + offset/8);

}

void connectib_pciex_ext_cfg_space_unpack(struct connectib_pciex_ext_cfg_space *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_secondary_pciex_ext_cap_unpack(&(ptr_struct->secondary_pciex_ext_cap), ptr_buff + offset/8);

	offset=352;
	connectib_ari_cap_unpack(&(ptr_struct->ari), ptr_buff + offset/8);

	offset=416;
	connectib_sriov_cap_unpack(&(ptr_struct->sriov), ptr_buff + offset/8);

	offset=928;
	connectib_dev_serial_num_cap_unpack(&(ptr_struct->device_serial_number), ptr_buff + offset/8);

	offset=1024;
	connectib_advanced_error_reporting_unpack(&(ptr_struct->advanced_error_reporting), ptr_buff + offset/8);

}

void connectib_pciex_ext_cfg_space_print(const struct connectib_pciex_ext_cfg_space *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pciex_ext_cfg_space ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "secondary_pciex_ext_cap:\n");
	connectib_secondary_pciex_ext_cap_print(&(ptr_struct->secondary_pciex_ext_cap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari:\n");
	connectib_ari_cap_print(&(ptr_struct->ari), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov:\n");
	connectib_sriov_cap_print(&(ptr_struct->sriov), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_serial_number:\n");
	connectib_dev_serial_num_cap_print(&(ptr_struct->device_serial_number), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advanced_error_reporting:\n");
	connectib_advanced_error_reporting_print(&(ptr_struct->advanced_error_reporting), file, indent_level + 1);

}

int connectib_pciex_ext_cfg_space_size(void){
	 return 256;
}

void connectib_pciex_ext_cfg_space_dump(const struct connectib_pciex_ext_cfg_space *ptr_struct, FILE* file) {
	connectib_pciex_ext_cfg_space_print(ptr_struct, file, 0);
}

void connectib_pci_cfg_space_pack(const struct connectib_pci_cfg_space *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pci_cfg_hdr_pack(&(ptr_struct->cfg_hdr), ptr_buff + offset/8);

	offset=512;
	connectib_pci_power_management_cap_pack(&(ptr_struct->power_management), ptr_buff + offset/8);

	offset=576;
	connectib_vpd_cap_pack(&(ptr_struct->vpd), ptr_buff + offset/8);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->image_status);

	offset=704;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->cr_addr);

	offset=736;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->cr_data);

	offset=768;
	connectib_pciex_cap_block_pack(&(ptr_struct->pciex_cap_block), ptr_buff + offset/8);

	offset=1248;
	connectib_msix_cap_pack(&(ptr_struct->msix), ptr_buff + offset/8);

}

void connectib_pci_cfg_space_unpack(struct connectib_pci_cfg_space *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pci_cfg_hdr_unpack(&(ptr_struct->cfg_hdr), ptr_buff + offset/8);

	offset=512;
	connectib_pci_power_management_cap_unpack(&(ptr_struct->power_management), ptr_buff + offset/8);

	offset=576;
	connectib_vpd_cap_unpack(&(ptr_struct->vpd), ptr_buff + offset/8);

	offset=640;
	ptr_struct->image_status = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=704;
	ptr_struct->cr_addr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=736;
	ptr_struct->cr_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=768;
	connectib_pciex_cap_block_unpack(&(ptr_struct->pciex_cap_block), ptr_buff + offset/8);

	offset=1248;
	connectib_msix_cap_unpack(&(ptr_struct->msix), ptr_buff + offset/8);

}

void connectib_pci_cfg_space_print(const struct connectib_pci_cfg_space *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pci_cfg_space ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cfg_hdr:\n");
	connectib_pci_cfg_hdr_print(&(ptr_struct->cfg_hdr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_management:\n");
	connectib_pci_power_management_cap_print(&(ptr_struct->power_management), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd:\n");
	connectib_vpd_cap_print(&(ptr_struct->vpd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "image_status         : "U32H_FMT"\n", ptr_struct->image_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cr_addr              : "U32H_FMT"\n", ptr_struct->cr_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cr_data              : "U32H_FMT"\n", ptr_struct->cr_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pciex_cap_block:\n");
	connectib_pciex_cap_block_print(&(ptr_struct->pciex_cap_block), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "msix:\n");
	connectib_msix_cap_print(&(ptr_struct->msix), file, indent_level + 1);

}

int connectib_pci_cfg_space_size(void){
	 return 256;
}

void connectib_pci_cfg_space_dump(const struct connectib_pci_cfg_space *ptr_struct, FILE* file) {
	connectib_pci_cfg_space_print(ptr_struct, file, 0);
}

void connectib_nv_config_main_fw_data_pack(const struct connectib_nv_config_main_fw_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_port_settings_pack(&(ptr_struct->port[i]), ptr_buff + offset/8);
	}

}

void connectib_nv_config_main_fw_data_unpack(struct connectib_nv_config_main_fw_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_port_settings_unpack(&(ptr_struct->port[i]), ptr_buff + offset/8);
	}

}

void connectib_nv_config_main_fw_data_print(const struct connectib_nv_config_main_fw_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_main_fw_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_%03d:\n", i);
	connectib_port_settings_print(&(ptr_struct->port[i]), file, indent_level + 1);
	}

}

int connectib_nv_config_main_fw_data_size(void){
	 return 32;
}

void connectib_nv_config_main_fw_data_dump(const struct connectib_nv_config_main_fw_data *ptr_struct, FILE* file) {
	connectib_nv_config_main_fw_data_print(ptr_struct, file, 0);
}

void connectib_phy_fw_main_config_ip_pack(const struct connectib_phy_fw_main_config_ip *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->PlaceHolder);

}

void connectib_phy_fw_main_config_ip_unpack(struct connectib_phy_fw_main_config_ip *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->PlaceHolder = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_phy_fw_main_config_ip_print(const struct connectib_phy_fw_main_config_ip *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_fw_main_config_ip ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "PlaceHolder          : "U32H_FMT"\n", ptr_struct->PlaceHolder);

}

int connectib_phy_fw_main_config_ip_size(void){
	 return 384;
}

void connectib_phy_fw_main_config_ip_dump(const struct connectib_phy_fw_main_config_ip *ptr_struct, FILE* file) {
	connectib_phy_fw_main_config_ip_print(ptr_struct, file, 0);
}

void connectib_phy_fw_main_config_golan_pack(const struct connectib_phy_fw_main_config_golan *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1856, 1);
	connectib_phy_lcl_ini_pack(&(ptr_struct->lcl[i]), ptr_buff + offset/8);
	}

}

void connectib_phy_fw_main_config_golan_unpack(struct connectib_phy_fw_main_config_golan *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1856, 1);
	connectib_phy_lcl_ini_unpack(&(ptr_struct->lcl[i]), ptr_buff + offset/8);
	}

}

void connectib_phy_fw_main_config_golan_print(const struct connectib_phy_fw_main_config_golan *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_fw_main_config_golan ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lcl_%03d:\n", i);
	connectib_phy_lcl_ini_print(&(ptr_struct->lcl[i]), file, indent_level + 1);
	}

}

int connectib_phy_fw_main_config_golan_size(void){
	 return 232;
}

void connectib_phy_fw_main_config_golan_dump(const struct connectib_phy_fw_main_config_golan *ptr_struct, FILE* file) {
	connectib_phy_fw_main_config_golan_print(ptr_struct, file, 0);
}

void connectib_ibm_thermal_config_pack(const struct connectib_ibm_thermal_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_tcontrol);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_tcontrol_low);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_twarning);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_twarning_low);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_tcritical);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->thermal_threshold_tcritical_low);

}

void connectib_ibm_thermal_config_unpack(struct connectib_ibm_thermal_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->thermal_threshold_tcontrol = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->thermal_threshold_tcontrol_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->thermal_threshold_twarning = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->thermal_threshold_twarning_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->thermal_threshold_tcritical = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->thermal_threshold_tcritical_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_ibm_thermal_config_print(const struct connectib_ibm_thermal_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ibm_thermal_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable               : "UH_FMT"\n", ptr_struct->enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_tcontrol : "U32H_FMT"\n", ptr_struct->thermal_threshold_tcontrol);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_tcontrol_low : "U32H_FMT"\n", ptr_struct->thermal_threshold_tcontrol_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_twarning : "U32H_FMT"\n", ptr_struct->thermal_threshold_twarning);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_twarning_low : "U32H_FMT"\n", ptr_struct->thermal_threshold_twarning_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_tcritical : "U32H_FMT"\n", ptr_struct->thermal_threshold_tcritical);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_threshold_tcritical_low : "U32H_FMT"\n", ptr_struct->thermal_threshold_tcritical_low);

}

int connectib_ibm_thermal_config_size(void){
	 return 28;
}

void connectib_ibm_thermal_config_dump(const struct connectib_ibm_thermal_config *ptr_struct, FILE* file) {
	connectib_ibm_thermal_config_print(ptr_struct, file, 0);
}

void connectib_ocsd_config_pack(const struct connectib_ocsd_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->internal_caution_threshold);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->extrenal_caution_threshold);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->internal_max_cont_threshold);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->external_max_cont_threshold);

}

void connectib_ocsd_config_unpack(struct connectib_ocsd_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->internal_caution_threshold = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->extrenal_caution_threshold = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->internal_max_cont_threshold = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->external_max_cont_threshold = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_ocsd_config_print(const struct connectib_ocsd_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ocsd_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable               : "UH_FMT"\n", ptr_struct->enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_caution_threshold : "U32H_FMT"\n", ptr_struct->internal_caution_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extrenal_caution_threshold : "U32H_FMT"\n", ptr_struct->extrenal_caution_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "internal_max_cont_threshold : "U32H_FMT"\n", ptr_struct->internal_max_cont_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "external_max_cont_threshold : "U32H_FMT"\n", ptr_struct->external_max_cont_threshold);

}

int connectib_ocsd_config_size(void){
	 return 20;
}

void connectib_ocsd_config_dump(const struct connectib_ocsd_config *ptr_struct, FILE* file) {
	connectib_ocsd_config_print(ptr_struct, file, 0);
}

void connectib_extended_port_info_ini_pack(const struct connectib_extended_port_info_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_speed_supported);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_speed_enabled);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_64_byte_cell_size);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->llr_128_byte_cell_size);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->link_up_after_boot);

}

void connectib_extended_port_info_ini_unpack(struct connectib_extended_port_info_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->link_speed_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->link_speed_enabled = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=15;
	ptr_struct->llr_64_byte_cell_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->llr_128_byte_cell_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->link_up_after_boot = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_extended_port_info_ini_print(const struct connectib_extended_port_info_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_extended_port_info_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_supported : "UH_FMT"\n", ptr_struct->link_speed_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_enabled   : "UH_FMT"\n", ptr_struct->link_speed_enabled);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_64_byte_cell_size : "UH_FMT"\n", ptr_struct->llr_64_byte_cell_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "llr_128_byte_cell_size : "UH_FMT"\n", ptr_struct->llr_128_byte_cell_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_up_after_boot   : "UH_FMT"\n", ptr_struct->link_up_after_boot);

}

int connectib_extended_port_info_ini_size(void){
	 return 4;
}

void connectib_extended_port_info_ini_dump(const struct connectib_extended_port_info_ini *ptr_struct, FILE* file) {
	connectib_extended_port_info_ini_print(ptr_struct, file, 0);
}

void connectib_ib_port_info_ini_pack(const struct connectib_ib_port_info_ini *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_mask2);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->diag_code);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->link_roundtrip_lat);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->max_credit_hint);

	offset=96;
	connectib_port_cap_mask1_pack(&(ptr_struct->cap_mask), ptr_buff + offset/8);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_sup);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_width_ena);

	offset=140;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_speed_ena);

	offset=136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->down_def_state);

	offset=132;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_speed_sup);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->init_type);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vl_arb_high_cap);

	offset=176;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vl_high_limit);

	offset=172;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl_cap);

	offset=164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vl_arb_low_cap);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->operational_vl);

	offset=220;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->neighbor_mtu);

	offset=216;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mtu_cap);

	offset=214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->mc_pkey_trap_suppress_en);

	offset=206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->guid_cap);

	offset=201;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->resp_time_value);

	offset=196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->link_speed_ext_ena);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->link_speed_ext_sup);

}

void connectib_ib_port_info_ini_unpack(struct connectib_ib_port_info_ini *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->cap_mask2 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->diag_code = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->link_roundtrip_lat = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=80;
	ptr_struct->max_credit_hint = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	connectib_port_cap_mask1_unpack(&(ptr_struct->cap_mask), ptr_buff + offset/8);

	offset=152;
	ptr_struct->link_width_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=144;
	ptr_struct->link_width_ena = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=140;
	ptr_struct->link_speed_ena = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=136;
	ptr_struct->down_def_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=132;
	ptr_struct->link_speed_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->init_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=184;
	ptr_struct->vl_arb_high_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=176;
	ptr_struct->vl_high_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=172;
	ptr_struct->vl_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=164;
	ptr_struct->vl_arb_low_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=160;
	ptr_struct->operational_vl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=220;
	ptr_struct->neighbor_mtu = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=216;
	ptr_struct->mtu_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=214;
	ptr_struct->mc_pkey_trap_suppress_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=206;
	ptr_struct->guid_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=201;
	ptr_struct->resp_time_value = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=196;
	ptr_struct->link_speed_ext_ena = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=192;
	ptr_struct->link_speed_ext_sup = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_ib_port_info_ini_print(const struct connectib_ib_port_info_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ib_port_info_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_mask2            : "UH_FMT"\n", ptr_struct->cap_mask2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "diag_code            : "UH_FMT"\n", ptr_struct->diag_code);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_roundtrip_lat   : "UH_FMT"\n", ptr_struct->link_roundtrip_lat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_credit_hint      : "UH_FMT"\n", ptr_struct->max_credit_hint);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_mask:\n");
	connectib_port_cap_mask1_print(&(ptr_struct->cap_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_sup       : "UH_FMT"\n", ptr_struct->link_width_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_width_ena       : "UH_FMT"\n", ptr_struct->link_width_ena);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_ena       : "UH_FMT"\n", ptr_struct->link_speed_ena);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "down_def_state       : "UH_FMT"\n", ptr_struct->down_def_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_sup       : "UH_FMT"\n", ptr_struct->link_speed_sup);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_type            : "UH_FMT"\n", ptr_struct->init_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_arb_high_cap      : "UH_FMT"\n", ptr_struct->vl_arb_high_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_high_limit        : "UH_FMT"\n", ptr_struct->vl_high_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_cap               : "UH_FMT"\n", ptr_struct->vl_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_arb_low_cap       : "UH_FMT"\n", ptr_struct->vl_arb_low_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "operational_vl       : "UH_FMT"\n", ptr_struct->operational_vl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "neighbor_mtu         : "UH_FMT"\n", ptr_struct->neighbor_mtu);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mtu_cap              : "UH_FMT"\n", ptr_struct->mtu_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mc_pkey_trap_suppress_en : "UH_FMT"\n", ptr_struct->mc_pkey_trap_suppress_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guid_cap             : "UH_FMT"\n", ptr_struct->guid_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "resp_time_value      : "UH_FMT"\n", ptr_struct->resp_time_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_ext_ena   : "UH_FMT"\n", ptr_struct->link_speed_ext_ena);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_speed_ext_sup   : "UH_FMT"\n", ptr_struct->link_speed_ext_sup);

}

int connectib_ib_port_info_ini_size(void){
	 return 28;
}

void connectib_ib_port_info_ini_dump(const struct connectib_ib_port_info_ini *ptr_struct, FILE* file) {
	connectib_ib_port_info_ini_print(ptr_struct, file, 0);
}

void connectib_node_info_pack(const struct connectib_node_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_of_ports);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->node_type);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->class_version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->base_version);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->system_image_guid_hi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->system_image_guid_lo);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->node_guid_hi);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->node_guid_lo);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_guid_hi);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->port_guid_lo);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->device_id);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->partition_cap);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->revision);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vendor_id);

	offset=288;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port_num);

}

void connectib_node_info_unpack(struct connectib_node_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->num_of_ports = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->node_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->class_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->base_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->system_image_guid_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->system_image_guid_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->node_guid_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->node_guid_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->port_guid_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->port_guid_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=240;
	ptr_struct->device_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->partition_cap = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=256;
	ptr_struct->revision = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=296;
	ptr_struct->vendor_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=288;
	ptr_struct->local_port_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_node_info_print(const struct connectib_node_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_node_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_ports         : "UH_FMT"\n", ptr_struct->num_of_ports);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_type            : "UH_FMT"\n", ptr_struct->node_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "class_version        : "UH_FMT"\n", ptr_struct->class_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "base_version         : "UH_FMT"\n", ptr_struct->base_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "system_image_guid_hi : "U32H_FMT"\n", ptr_struct->system_image_guid_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "system_image_guid_lo : "U32H_FMT"\n", ptr_struct->system_image_guid_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_guid_hi         : "U32H_FMT"\n", ptr_struct->node_guid_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_guid_lo         : "U32H_FMT"\n", ptr_struct->node_guid_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_guid_hi         : "U32H_FMT"\n", ptr_struct->port_guid_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_guid_lo         : "U32H_FMT"\n", ptr_struct->port_guid_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_id            : "UH_FMT"\n", ptr_struct->device_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "partition_cap        : "UH_FMT"\n", ptr_struct->partition_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "revision             : "U32H_FMT"\n", ptr_struct->revision);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_id            : "UH_FMT"\n", ptr_struct->vendor_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port_num       : "UH_FMT"\n", ptr_struct->local_port_num);

}

int connectib_node_info_size(void){
	 return 64;
}

void connectib_node_info_dump(const struct connectib_node_info *ptr_struct, FILE* file) {
	connectib_node_info_print(ptr_struct, file, 0);
}

void connectib_led_port_blink_pattern_pack(const struct connectib_led_port_blink_pattern *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phy_pattern);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->log_pattern);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->length);

}

void connectib_led_port_blink_pattern_unpack(struct connectib_led_port_blink_pattern *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->phy_pattern = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->log_pattern = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=56;
	ptr_struct->length = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_led_port_blink_pattern_print(const struct connectib_led_port_blink_pattern *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_led_port_blink_pattern ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_pattern          : "UH_FMT"\n", ptr_struct->phy_pattern);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_pattern          : "UH_FMT"\n", ptr_struct->log_pattern);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "length               : "UH_FMT"\n", ptr_struct->length);

}

int connectib_led_port_blink_pattern_size(void){
	 return 8;
}

void connectib_led_port_blink_pattern_dump(const struct connectib_led_port_blink_pattern *ptr_struct, FILE* file) {
	connectib_led_port_blink_pattern_print(ptr_struct, file, 0);
}

void connectib_uid_entry_pack(const struct connectib_uid_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_allocated);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->step);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->uid);

}

void connectib_uid_entry_unpack(struct connectib_uid_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->num_allocated = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->step = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->uid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_uid_entry_print(const struct connectib_uid_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_uid_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_allocated        : "UH_FMT"\n", ptr_struct->num_allocated);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "step                 : "UH_FMT"\n", ptr_struct->step);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "uid                  : "U64H_FMT"\n", ptr_struct->uid);

}

int connectib_uid_entry_size(void){
	 return 16;
}

void connectib_uid_entry_dump(const struct connectib_uid_entry *ptr_struct, FILE* file) {
	connectib_uid_entry_print(ptr_struct, file, 0);
}

void connectib_module_version_pack(const struct connectib_module_version *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->branch);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->minor);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->major);

}

void connectib_module_version_unpack(struct connectib_module_version *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->branch = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=12;
	ptr_struct->minor = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=0;
	ptr_struct->major = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void connectib_module_version_print(const struct connectib_module_version *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_module_version ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "branch               : "UH_FMT"\n", ptr_struct->branch);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minor                : "UH_FMT"\n", ptr_struct->minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "major                : "UH_FMT"\n", ptr_struct->major);

}

int connectib_module_version_size(void){
	 return 4;
}

void connectib_module_version_dump(const struct connectib_module_version *ptr_struct, FILE* file) {
	connectib_module_version_print(ptr_struct, file, 0);
}

void connectib_reset_level_info_pack(const struct connectib_reset_level_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reset_version_pack(&(ptr_struct->ver), ptr_buff + offset/8);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ini_sig);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->reset_type);

	offset=87;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ini_sig_v);

	offset=86;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ini_sig_ignore);

}

void connectib_reset_level_info_unpack(struct connectib_reset_level_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reset_version_unpack(&(ptr_struct->ver), ptr_buff + offset/8);

	offset=32;
	ptr_struct->ini_sig = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=88;
	ptr_struct->reset_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=87;
	ptr_struct->ini_sig_v = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=86;
	ptr_struct->ini_sig_ignore = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_reset_level_info_print(const struct connectib_reset_level_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reset_level_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ver:\n");
	connectib_reset_version_print(&(ptr_struct->ver), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ini_sig              : "U32H_FMT"\n", ptr_struct->ini_sig);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_type           : "UH_FMT"\n", ptr_struct->reset_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ini_sig_v            : "UH_FMT"\n", ptr_struct->ini_sig_v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ini_sig_ignore       : "UH_FMT"\n", ptr_struct->ini_sig_ignore);

}

int connectib_reset_level_info_size(void){
	 return 16;
}

void connectib_reset_level_info_dump(const struct connectib_reset_level_info *ptr_struct, FILE* file) {
	connectib_reset_level_info_print(ptr_struct, file, 0);
}

void connectib_vport_info_pack(const struct connectib_vport_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_guid);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->node_guid);

	offset=128;
	connectib_mac_address_layout_pack(&(ptr_struct->permanent_address), ptr_buff + offset/8);

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cap_mask);

	offset=196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->allowed_list_size);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->roce_en);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->p_key_violations);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->q_key_violations);

}

void connectib_vport_info_unpack(struct connectib_vport_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->port_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->node_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_mac_address_layout_unpack(&(ptr_struct->permanent_address), ptr_buff + offset/8);

	offset=208;
	ptr_struct->cap_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=196;
	ptr_struct->allowed_list_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=192;
	ptr_struct->roce_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=240;
	ptr_struct->p_key_violations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->q_key_violations = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_vport_info_print(const struct connectib_vport_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vport_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_guid            : "U64H_FMT"\n", ptr_struct->port_guid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_guid            : "U64H_FMT"\n", ptr_struct->node_guid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "permanent_address:\n");
	connectib_mac_address_layout_print(&(ptr_struct->permanent_address), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cap_mask             : "UH_FMT"\n", ptr_struct->cap_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "allowed_list_size    : "UH_FMT"\n", ptr_struct->allowed_list_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "roce_en              : "UH_FMT"\n", ptr_struct->roce_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "p_key_violations     : "UH_FMT"\n", ptr_struct->p_key_violations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "q_key_violations     : "UH_FMT"\n", ptr_struct->q_key_violations);

}

int connectib_vport_info_size(void){
	 return 32;
}

void connectib_vport_info_dump(const struct connectib_vport_info *ptr_struct, FILE* file) {
	connectib_vport_info_print(ptr_struct, file, 0);
}

void connectib_vport_shadow_pack(const struct connectib_vport_shadow *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->port_guid);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->node_guid);

	offset=128;
	connectib_mac_address_layout_pack(&(ptr_struct->permanent_address), ptr_buff + offset/8);

}

void connectib_vport_shadow_unpack(struct connectib_vport_shadow *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->port_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->node_guid = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_mac_address_layout_unpack(&(ptr_struct->permanent_address), ptr_buff + offset/8);

}

void connectib_vport_shadow_print(const struct connectib_vport_shadow *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vport_shadow ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_guid            : "U64H_FMT"\n", ptr_struct->port_guid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_guid            : "U64H_FMT"\n", ptr_struct->node_guid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "permanent_address:\n");
	connectib_mac_address_layout_print(&(ptr_struct->permanent_address), file, indent_level + 1);

}

int connectib_vport_shadow_size(void){
	 return 32;
}

void connectib_vport_shadow_dump(const struct connectib_vport_shadow *ptr_struct, FILE* file) {
	connectib_vport_shadow_print(ptr_struct, file, 0);
}

void connectib_general_fault_injector_pair_pack(const struct connectib_general_fault_injector_pair *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->freq);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->duration);

}

void connectib_general_fault_injector_pair_unpack(struct connectib_general_fault_injector_pair *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->freq = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->duration = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_general_fault_injector_pair_print(const struct connectib_general_fault_injector_pair *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_general_fault_injector_pair ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "freq                 : "UH_FMT"\n", ptr_struct->freq);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "duration             : "UH_FMT"\n", ptr_struct->duration);

}

int connectib_general_fault_injector_pair_size(void){
	 return 4;
}

void connectib_general_fault_injector_pair_dump(const struct connectib_general_fault_injector_pair *ptr_struct, FILE* file) {
	connectib_general_fault_injector_pair_print(ptr_struct, file, 0);
}

void connectib_pvlc_reg_pack(const struct connectib_pvlc_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset=60;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl_hw_cap);

	offset=92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl_admin);

	offset=124;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->vl_operational);

}

void connectib_pvlc_reg_unpack(struct connectib_pvlc_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=60;
	ptr_struct->vl_hw_cap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=92;
	ptr_struct->vl_admin = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=124;
	ptr_struct->vl_operational = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_pvlc_reg_print(const struct connectib_pvlc_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pvlc_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : "UH_FMT"\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_hw_cap            : "UH_FMT"\n", ptr_struct->vl_hw_cap);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_admin             : "UH_FMT"\n", ptr_struct->vl_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl_operational       : "UH_FMT"\n", ptr_struct->vl_operational);

}

int connectib_pvlc_reg_size(void){
	 return 16;
}

void connectib_pvlc_reg_dump(const struct connectib_pvlc_reg *ptr_struct, FILE* file) {
	connectib_pvlc_reg_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_resources_list_out_pack(const struct connectib_icmd_get_ste_resources_list_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->resources_count);

	for (i=0; i < 63; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 2048, 1);
	connectib_resource_type_entry_pack(&(ptr_struct->resource_type[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_ste_resources_list_out_unpack(struct connectib_icmd_get_ste_resources_list_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->resources_count = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i=0; i < 63; i++) {
	offset=adb2c_calc_array_field_address(32, 32, i, 2048, 1);
	connectib_resource_type_entry_unpack(&(ptr_struct->resource_type[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_ste_resources_list_out_print(const struct connectib_icmd_get_ste_resources_list_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_resources_list_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "resources_count      : "UH_FMT"\n", ptr_struct->resources_count);

	for (i=0; i < 63; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "resource_type_%03d:\n", i);
	connectib_resource_type_entry_print(&(ptr_struct->resource_type[i]), file, indent_level + 1);
	}

}

int connectib_icmd_get_ste_resources_list_out_size(void){
	 return 256;
}

void connectib_icmd_get_ste_resources_list_out_dump(const struct connectib_icmd_get_ste_resources_list_out *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_resources_list_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_resources_list_in_pack(const struct connectib_icmd_get_ste_resources_list_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

}

void connectib_icmd_get_ste_resources_list_in_unpack(struct connectib_icmd_get_ste_resources_list_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_ste_resources_list_in_print(const struct connectib_icmd_get_ste_resources_list_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_resources_list_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

}

int connectib_icmd_get_ste_resources_list_in_size(void){
	 return 16;
}

void connectib_icmd_get_ste_resources_list_in_dump(const struct connectib_icmd_get_ste_resources_list_in *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_resources_list_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_open_resources_out_pack(const struct connectib_icmd_get_ste_open_resources_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->more);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->output_size);

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(64, 128, i, 6144, 1);
	connectib_index_and_length_pack(&(ptr_struct->opened_resource[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_ste_open_resources_out_unpack(struct connectib_icmd_get_ste_open_resources_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->more = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->output_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(64, 128, i, 6144, 1);
	connectib_index_and_length_unpack(&(ptr_struct->opened_resource[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_ste_open_resources_out_print(const struct connectib_icmd_get_ste_open_resources_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_open_resources_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "more                 : "UH_FMT"\n", ptr_struct->more);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "output_size          : "U32H_FMT"\n", ptr_struct->output_size);

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opened_resource_%03d:\n", i);
	connectib_index_and_length_print(&(ptr_struct->opened_resource[i]), file, indent_level + 1);
	}

}

int connectib_icmd_get_ste_open_resources_out_size(void){
	 return 768;
}

void connectib_icmd_get_ste_open_resources_out_dump(const struct connectib_icmd_get_ste_open_resources_out *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_open_resources_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_open_resources_in_pack(const struct connectib_icmd_get_ste_open_resources_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_resource_type);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->start_index);

}

void connectib_icmd_get_ste_open_resources_in_unpack(struct connectib_icmd_get_ste_open_resources_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->icm_resource_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->start_index = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_get_ste_open_resources_in_print(const struct connectib_icmd_get_ste_open_resources_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_open_resources_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_resource_type    : "U32H_FMT"\n", ptr_struct->icm_resource_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_index          : "U64H_FMT"\n", ptr_struct->start_index);

}

int connectib_icmd_get_ste_open_resources_in_size(void){
	 return 16;
}

void connectib_icmd_get_ste_open_resources_in_dump(const struct connectib_icmd_get_ste_open_resources_in *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_open_resources_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_out_pack(const struct connectib_icmd_get_fte_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->action);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->group_id);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->flow_tag);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->destination_list_size);

	offset=512;
	connectib_flow_table_entry_match_set_lyr_2_4_pack(&(ptr_struct->outer_headers), ptr_buff + offset/8);

	offset=1024;
	connectib_flow_table_entry_match_set_misc_pack(&(ptr_struct->misc_parameters), ptr_buff + offset/8);

	offset=1536;
	connectib_flow_table_entry_match_set_lyr_2_4_pack(&(ptr_struct->inner_headers), ptr_buff + offset/8);

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(2048, 64, i, 6144, 1);
	connectib_dest_format_struct_pack(&(ptr_struct->destination[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_fte_out_unpack(struct connectib_icmd_get_fte_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->action = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->flow_tag = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->destination_list_size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=512;
	connectib_flow_table_entry_match_set_lyr_2_4_unpack(&(ptr_struct->outer_headers), ptr_buff + offset/8);

	offset=1024;
	connectib_flow_table_entry_match_set_misc_unpack(&(ptr_struct->misc_parameters), ptr_buff + offset/8);

	offset=1536;
	connectib_flow_table_entry_match_set_lyr_2_4_unpack(&(ptr_struct->inner_headers), ptr_buff + offset/8);

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(2048, 64, i, 6144, 1);
	connectib_dest_format_struct_unpack(&(ptr_struct->destination[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_fte_out_print(const struct connectib_icmd_get_fte_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "action               : "UH_FMT"\n", ptr_struct->action);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : "U32H_FMT"\n", ptr_struct->group_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_tag             : "UH_FMT"\n", ptr_struct->flow_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destination_list_size : "UH_FMT"\n", ptr_struct->destination_list_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_headers:\n");
	connectib_flow_table_entry_match_set_lyr_2_4_print(&(ptr_struct->outer_headers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "misc_parameters:\n");
	connectib_flow_table_entry_match_set_misc_print(&(ptr_struct->misc_parameters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_headers:\n");
	connectib_flow_table_entry_match_set_lyr_2_4_print(&(ptr_struct->inner_headers), file, indent_level + 1);

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destination_%03d:\n", i);
	connectib_dest_format_struct_print(&(ptr_struct->destination[i]), file, indent_level + 1);
	}

}

int connectib_icmd_get_fte_out_size(void){
	 return 768;
}

void connectib_icmd_get_fte_out_dump(const struct connectib_icmd_get_fte_out *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_in_pack(const struct connectib_icmd_get_fte_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->flow_index);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->requested_fte_partition);

}

void connectib_icmd_get_fte_in_unpack(struct connectib_icmd_get_fte_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=112;
	ptr_struct->requested_fte_partition = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_fte_in_print(const struct connectib_icmd_get_fte_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_index           : "U32H_FMT"\n", ptr_struct->flow_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "requested_fte_partition : "UH_FMT"\n", ptr_struct->requested_fte_partition);

}

int connectib_icmd_get_fte_in_size(void){
	 return 16;
}

void connectib_icmd_get_fte_in_dump(const struct connectib_icmd_get_fte_in *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_list_out_pack(const struct connectib_icmd_get_fte_list_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->first);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->flow_index);

}

void connectib_icmd_get_fte_list_out_unpack(struct connectib_icmd_get_fte_list_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->last = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->first = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_fte_list_out_print(const struct connectib_icmd_get_fte_list_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte_list_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last                 : "UH_FMT"\n", ptr_struct->last);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first                : "UH_FMT"\n", ptr_struct->first);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_index           : "U32H_FMT"\n", ptr_struct->flow_index);

}

int connectib_icmd_get_fte_list_out_size(void){
	 return 16;
}

void connectib_icmd_get_fte_list_out_dump(const struct connectib_icmd_get_fte_list_out *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_list_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_list_in_pack(const struct connectib_icmd_get_fte_list_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->info);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->flow_index);

}

void connectib_icmd_get_fte_list_in_unpack(struct connectib_icmd_get_fte_list_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->info = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_fte_list_in_print(const struct connectib_icmd_get_fte_list_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte_list_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "info                 : "UH_FMT"\n", ptr_struct->info);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_index           : "U32H_FMT"\n", ptr_struct->flow_index);

}

int connectib_icmd_get_fte_list_in_size(void){
	 return 16;
}

void connectib_icmd_get_fte_list_in_dump(const struct connectib_icmd_get_fte_list_in *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_list_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_out_pack(const struct connectib_icmd_get_fg_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->start_flow_index);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->end_flow_index);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->match_criteria_enable);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=512;
	connectib_flow_table_entry_match_set_lyr_2_4_pack(&(ptr_struct->outer_headers), ptr_buff + offset/8);

	offset=1024;
	connectib_flow_table_entry_match_set_misc_pack(&(ptr_struct->misc_parameters), ptr_buff + offset/8);

	offset=1536;
	connectib_flow_table_entry_match_set_lyr_2_4_pack(&(ptr_struct->inner_headers), ptr_buff + offset/8);

}

void connectib_icmd_get_fg_out_unpack(struct connectib_icmd_get_fg_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->start_flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->end_flow_index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=88;
	ptr_struct->match_criteria_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=512;
	connectib_flow_table_entry_match_set_lyr_2_4_unpack(&(ptr_struct->outer_headers), ptr_buff + offset/8);

	offset=1024;
	connectib_flow_table_entry_match_set_misc_unpack(&(ptr_struct->misc_parameters), ptr_buff + offset/8);

	offset=1536;
	connectib_flow_table_entry_match_set_lyr_2_4_unpack(&(ptr_struct->inner_headers), ptr_buff + offset/8);

}

void connectib_icmd_get_fg_out_print(const struct connectib_icmd_get_fg_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_flow_index     : "U32H_FMT"\n", ptr_struct->start_flow_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "end_flow_index       : "U32H_FMT"\n", ptr_struct->end_flow_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "match_criteria_enable : "UH_FMT"\n", ptr_struct->match_criteria_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "outer_headers:\n");
	connectib_flow_table_entry_match_set_lyr_2_4_print(&(ptr_struct->outer_headers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "misc_parameters:\n");
	connectib_flow_table_entry_match_set_misc_print(&(ptr_struct->misc_parameters), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inner_headers:\n");
	connectib_flow_table_entry_match_set_lyr_2_4_print(&(ptr_struct->inner_headers), file, indent_level + 1);

}

int connectib_icmd_get_fg_out_size(void){
	 return 256;
}

void connectib_icmd_get_fg_out_dump(const struct connectib_icmd_get_fg_out *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_in_pack(const struct connectib_icmd_get_fg_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->group_id);

}

void connectib_icmd_get_fg_in_unpack(struct connectib_icmd_get_fg_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_fg_in_print(const struct connectib_icmd_get_fg_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : "U32H_FMT"\n", ptr_struct->group_id);

}

int connectib_icmd_get_fg_in_size(void){
	 return 16;
}

void connectib_icmd_get_fg_in_dump(const struct connectib_icmd_get_fg_in *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_list_out_pack(const struct connectib_icmd_get_fg_list_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->first);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->group_id);

}

void connectib_icmd_get_fg_list_out_unpack(struct connectib_icmd_get_fg_list_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=3;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->last = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->first = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_fg_list_out_print(const struct connectib_icmd_get_fg_list_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg_list_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last                 : "UH_FMT"\n", ptr_struct->last);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first                : "UH_FMT"\n", ptr_struct->first);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : "U32H_FMT"\n", ptr_struct->group_id);

}

int connectib_icmd_get_fg_list_out_size(void){
	 return 16;
}

void connectib_icmd_get_fg_list_out_dump(const struct connectib_icmd_get_fg_list_out *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_list_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_list_in_pack(const struct connectib_icmd_get_fg_list_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->info);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->group_id);

}

void connectib_icmd_get_fg_list_in_unpack(struct connectib_icmd_get_fg_list_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->info = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->group_id = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_fg_list_in_print(const struct connectib_icmd_get_fg_list_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg_list_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "info                 : "UH_FMT"\n", ptr_struct->info);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "group_id             : "U32H_FMT"\n", ptr_struct->group_id);

}

int connectib_icmd_get_fg_list_in_size(void){
	 return 16;
}

void connectib_icmd_get_fg_list_in_dump(const struct connectib_icmd_get_fg_list_in *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_list_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_info_out_pack(const struct connectib_icmd_get_ft_info_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log_size);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->level);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->table_type);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

}

void connectib_icmd_get_ft_info_out_unpack(struct connectib_icmd_get_ft_info_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->log_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->table_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_get_ft_info_out_print(const struct connectib_icmd_get_ft_info_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_info_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_size             : "UH_FMT"\n", ptr_struct->log_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "level                : "UH_FMT"\n", ptr_struct->level);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_type           : "UH_FMT"\n", ptr_struct->table_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

}

int connectib_icmd_get_ft_info_out_size(void){
	 return 16;
}

void connectib_icmd_get_ft_info_out_dump(const struct connectib_icmd_get_ft_info_out *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_info_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_info_in_pack(const struct connectib_icmd_get_ft_info_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

}

void connectib_icmd_get_ft_info_in_unpack(struct connectib_icmd_get_ft_info_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_ft_info_in_print(const struct connectib_icmd_get_ft_info_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_info_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

}

int connectib_icmd_get_ft_info_in_size(void){
	 return 16;
}

void connectib_icmd_get_ft_info_in_dump(const struct connectib_icmd_get_ft_info_in *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_info_in_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_list_out_pack(const struct connectib_icmd_get_ft_list_out *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->last);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->first);

}

void connectib_icmd_get_ft_list_out_unpack(struct connectib_icmd_get_ft_list_out *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=3;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->last = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->first = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_get_ft_list_out_print(const struct connectib_icmd_get_ft_list_out *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_list_out ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last                 : "UH_FMT"\n", ptr_struct->last);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first                : "UH_FMT"\n", ptr_struct->first);

}

int connectib_icmd_get_ft_list_out_size(void){
	 return 16;
}

void connectib_icmd_get_ft_list_out_dump(const struct connectib_icmd_get_ft_list_out *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_list_out_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_list_in_pack(const struct connectib_icmd_get_ft_list_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->table_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->info);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

}

void connectib_icmd_get_ft_list_in_unpack(struct connectib_icmd_get_ft_list_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->table_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->info = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_ft_list_in_print(const struct connectib_icmd_get_ft_list_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_list_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_id             : "UH_FMT"\n", ptr_struct->table_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "info                 : "UH_FMT"\n", ptr_struct->info);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

}

int connectib_icmd_get_ft_list_in_size(void){
	 return 16;
}

void connectib_icmd_get_ft_list_in_dump(const struct connectib_icmd_get_ft_list_in *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_list_in_print(ptr_struct, file, 0);
}

void connectib_ppcnt_reg_pack(const struct connectib_ppcnt_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->grp);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pnat);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swid);

	offset=59;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->prio_tc);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->clr);

	offset=64;
	connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_pack(&(ptr_struct->counter_set), ptr_buff + offset/8);

}

void connectib_ppcnt_reg_unpack(struct connectib_ppcnt_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=26;
	ptr_struct->grp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=16;
	ptr_struct->pnat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->swid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=59;
	ptr_struct->prio_tc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=32;
	ptr_struct->clr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_unpack(&(ptr_struct->counter_set), ptr_buff + offset/8);

}

void connectib_ppcnt_reg_print(const struct connectib_ppcnt_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ppcnt_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grp                  : "UH_FMT"\n", ptr_struct->grp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pnat                 : "UH_FMT"\n", ptr_struct->pnat);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : "UH_FMT"\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swid                 : "UH_FMT"\n", ptr_struct->swid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prio_tc              : "UH_FMT"\n", ptr_struct->prio_tc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clr                  : "UH_FMT"\n", ptr_struct->clr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "counter_set:\n");
	connectib_eth_802_3_cntrs_grp_data_layout_eth_2863_cntrs_grp_data_layout_eth_2819_cntrs_grp_data_layout_eth_3635_cntrs_grp_data_layout_eth_extended_cntrs_grp_data_layout_eth_per_prio_grp_data_layout_eth_per_traffic_grp_data_layout_phys_layer_cntrs_auto_print(&(ptr_struct->counter_set), file, indent_level + 1);

}

int connectib_ppcnt_reg_size(void){
	 return 256;
}

void connectib_ppcnt_reg_dump(const struct connectib_ppcnt_reg *ptr_struct, FILE* file) {
	connectib_ppcnt_reg_print(ptr_struct, file, 0);
}

void connectib_ptys_reg_pack(const struct connectib_ptys_reg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->proto_mask);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->local_port);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->eth_proto_capability);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_capability);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_capability);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->eth_proto_admin);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_admin);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_admin);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->eth_proto_oper);

	offset=336;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_proto_oper);

	offset=320;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ib_link_width_oper);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->eth_proto_lp_advertise);

}

void connectib_ptys_reg_unpack(struct connectib_ptys_reg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=29;
	ptr_struct->proto_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->local_port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->eth_proto_capability = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->ib_proto_capability = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->ib_link_width_capability = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=192;
	ptr_struct->eth_proto_admin = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=240;
	ptr_struct->ib_proto_admin = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=224;
	ptr_struct->ib_link_width_admin = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=288;
	ptr_struct->eth_proto_oper = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=336;
	ptr_struct->ib_proto_oper = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=320;
	ptr_struct->ib_link_width_oper = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=384;
	ptr_struct->eth_proto_lp_advertise = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_ptys_reg_print(const struct connectib_ptys_reg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ptys_reg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "proto_mask           : "UH_FMT"\n", ptr_struct->proto_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_port           : "UH_FMT"\n", ptr_struct->local_port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_capability : "U32H_FMT"\n", ptr_struct->eth_proto_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_capability  : "UH_FMT"\n", ptr_struct->ib_proto_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_capability : "UH_FMT"\n", ptr_struct->ib_link_width_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_admin      : "U32H_FMT"\n", ptr_struct->eth_proto_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_admin       : "UH_FMT"\n", ptr_struct->ib_proto_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_admin  : "UH_FMT"\n", ptr_struct->ib_link_width_admin);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_oper       : "U32H_FMT"\n", ptr_struct->eth_proto_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_proto_oper        : "UH_FMT"\n", ptr_struct->ib_proto_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_link_width_oper   : "UH_FMT"\n", ptr_struct->ib_link_width_oper);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_proto_lp_advertise : "U32H_FMT"\n", ptr_struct->eth_proto_lp_advertise);

}

int connectib_ptys_reg_size(void){
	 return 64;
}

void connectib_ptys_reg_dump(const struct connectib_ptys_reg *ptr_struct, FILE* file) {
	connectib_ptys_reg_print(ptr_struct, file, 0);
}

void connectib_steering_table_info_pack(const struct connectib_steering_table_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->base_index);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ste_lu_type);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log2_table_size);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log2_entry_size);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->match_mode);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_rx_);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hash_fieldwise_mask);

}

void connectib_steering_table_info_unpack(struct connectib_steering_table_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->base_index = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=88;
	ptr_struct->ste_lu_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=80;
	ptr_struct->log2_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->log2_entry_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=68;
	ptr_struct->match_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->sx_rx_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=120;
	ptr_struct->hash_fieldwise_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_steering_table_info_print(const struct connectib_steering_table_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_steering_table_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "base_index           : "U64H_FMT"\n", ptr_struct->base_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ste_lu_type          : "UH_FMT"\n", ptr_struct->ste_lu_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_table_size      : "UH_FMT"\n", ptr_struct->log2_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_entry_size      : "UH_FMT"\n", ptr_struct->log2_entry_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "match_mode           : "UH_FMT"\n", ptr_struct->match_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_rx_               : "UH_FMT"\n", ptr_struct->sx_rx_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hash_fieldwise_mask  : "UH_FMT"\n", ptr_struct->hash_fieldwise_mask);

}

int connectib_steering_table_info_size(void){
	 return 32;
}

void connectib_steering_table_info_dump(const struct connectib_steering_table_info *ptr_struct, FILE* file) {
	connectib_steering_table_info_print(ptr_struct, file, 0);
}

void connectib_dcr_info_pack(const struct connectib_dcr_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->next_dcri);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->valid);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->connected);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trapped);

}

void connectib_dcr_info_unpack(struct connectib_dcr_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->next_dcri = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=7;
	ptr_struct->valid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->connected = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=5;
	ptr_struct->trapped = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_dcr_info_print(const struct connectib_dcr_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dcr_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_dcri            : "UH_FMT"\n", ptr_struct->next_dcri);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid                : "UH_FMT"\n", ptr_struct->valid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "connected            : "UH_FMT"\n", ptr_struct->connected);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trapped              : "UH_FMT"\n", ptr_struct->trapped);

}

int connectib_dcr_info_size(void){
	 return 4;
}

void connectib_dcr_info_dump(const struct connectib_dcr_info *ptr_struct, FILE* file) {
	connectib_dcr_info_print(ptr_struct, file, 0);
}

void connectib_icmd_pcie_ver_frequency_pack(const struct connectib_icmd_pcie_ver_frequency *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->core_f);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->core_clocks_per_usec);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->core_r);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cx3_count_in_core_clocks);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->usecs_in_high_tick);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vdd_mod_mapping);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->flash_div);

	offset=10;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->core_od);

}

void connectib_icmd_pcie_ver_frequency_unpack(struct connectib_icmd_pcie_ver_frequency *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=25;
	ptr_struct->core_f = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=24;
	ptr_struct->core_clocks_per_usec = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->core_r = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=18;
	ptr_struct->cx3_count_in_core_clocks = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->usecs_in_high_tick = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->vdd_mod_mapping = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->flash_div = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=10;
	ptr_struct->core_od = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_icmd_pcie_ver_frequency_print(const struct connectib_icmd_pcie_ver_frequency *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_pcie_ver_frequency ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_f               : "UH_FMT"\n", ptr_struct->core_f);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_clocks_per_usec : "UH_FMT"\n", ptr_struct->core_clocks_per_usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_r               : "UH_FMT"\n", ptr_struct->core_r);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cx3_count_in_core_clocks : "UH_FMT"\n", ptr_struct->cx3_count_in_core_clocks);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "usecs_in_high_tick   : "UH_FMT"\n", ptr_struct->usecs_in_high_tick);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vdd_mod_mapping      : "UH_FMT"\n", ptr_struct->vdd_mod_mapping);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flash_div            : "UH_FMT"\n", ptr_struct->flash_div);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_od              : "UH_FMT"\n", ptr_struct->core_od);

}

int connectib_icmd_pcie_ver_frequency_size(void){
	 return 16;
}

void connectib_icmd_pcie_ver_frequency_dump(const struct connectib_icmd_pcie_ver_frequency *ptr_struct, FILE* file) {
	connectib_icmd_pcie_ver_frequency_print(ptr_struct, file, 0);
}

void connectib_icmd_pcie_ver_cables_pack(const struct connectib_icmd_pcie_ver_cables *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->identifier);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->extended_identifier);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->device_tech);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->attenuation_5g);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vendor_oui);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->m_fsm_state);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mlnx_cable);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eeprom_present);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->link_length_supported);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eth_com_codes);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->tech);

	offset=121;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->ib_10ge_com_codes);

}

void connectib_icmd_pcie_ver_cables_unpack(struct connectib_icmd_pcie_ver_cables *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->extended_identifier = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->device_tech = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->attenuation_5g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=40;
	ptr_struct->vendor_oui = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=34;
	ptr_struct->m_fsm_state = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=33;
	ptr_struct->mlnx_cable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->eeprom_present = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->link_length_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=80;
	ptr_struct->eth_com_codes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=71;
	ptr_struct->tech = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=121;
	ptr_struct->ib_10ge_com_codes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

}

void connectib_icmd_pcie_ver_cables_print(const struct connectib_icmd_pcie_ver_cables *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_pcie_ver_cables ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "identifier           : "UH_FMT"\n", ptr_struct->identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_identifier  : "UH_FMT"\n", ptr_struct->extended_identifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_tech          : "UH_FMT"\n", ptr_struct->device_tech);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "attenuation_5g       : "UH_FMT"\n", ptr_struct->attenuation_5g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_oui           : "UH_FMT"\n", ptr_struct->vendor_oui);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "m_fsm_state          : "UH_FMT"\n", ptr_struct->m_fsm_state);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlnx_cable           : "UH_FMT"\n", ptr_struct->mlnx_cable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eeprom_present       : "UH_FMT"\n", ptr_struct->eeprom_present);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "link_length_supported : "UH_FMT"\n", ptr_struct->link_length_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_com_codes        : "UH_FMT"\n", ptr_struct->eth_com_codes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tech                 : "UH_FMT"\n", ptr_struct->tech);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ib_10ge_com_codes    : "UH_FMT"\n", ptr_struct->ib_10ge_com_codes);

}

int connectib_icmd_pcie_ver_cables_size(void){
	 return 16;
}

void connectib_icmd_pcie_ver_cables_dump(const struct connectib_icmd_pcie_ver_cables *ptr_struct, FILE* file) {
	connectib_icmd_pcie_ver_cables_print(ptr_struct, file, 0);
}

void connectib_icmd_pcie_ver_device_pack(const struct connectib_icmd_pcie_ver_device *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->devid);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->revid);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->strap_eprom_present);

}

void connectib_icmd_pcie_ver_device_unpack(struct connectib_icmd_pcie_ver_device *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->devid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=12;
	ptr_struct->revid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=11;
	ptr_struct->strap_eprom_present = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_pcie_ver_device_print(const struct connectib_icmd_pcie_ver_device *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_pcie_ver_device ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "devid                : "UH_FMT"\n", ptr_struct->devid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "revid                : "UH_FMT"\n", ptr_struct->revid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "strap_eprom_present  : "UH_FMT"\n", ptr_struct->strap_eprom_present);

}

int connectib_icmd_pcie_ver_device_size(void){
	 return 16;
}

void connectib_icmd_pcie_ver_device_dump(const struct connectib_icmd_pcie_ver_device *ptr_struct, FILE* file) {
	connectib_icmd_pcie_ver_device_print(ptr_struct, file, 0);
}

void connectib_code_coverage_control_pack(const struct connectib_code_coverage_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->window);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_window_size);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->irisc_bitmask);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->bp);

	offset=38;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->all_ips);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->trace_mode);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable);

}

void connectib_code_coverage_control_unpack(struct connectib_code_coverage_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->window = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=3;
	ptr_struct->log_window_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=48;
	ptr_struct->irisc_bitmask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=39;
	ptr_struct->bp = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=38;
	ptr_struct->all_ips = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=36;
	ptr_struct->trace_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=32;
	ptr_struct->enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_code_coverage_control_print(const struct connectib_code_coverage_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_code_coverage_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "window               : "UH_FMT"\n", ptr_struct->window);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_window_size      : "UH_FMT"\n", ptr_struct->log_window_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "irisc_bitmask        : "UH_FMT"\n", ptr_struct->irisc_bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bp                   : "UH_FMT"\n", ptr_struct->bp);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "all_ips              : "UH_FMT"\n", ptr_struct->all_ips);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trace_mode           : "UH_FMT"\n", ptr_struct->trace_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable               : "UH_FMT"\n", ptr_struct->enable);

}

int connectib_code_coverage_control_size(void){
	 return 8;
}

void connectib_code_coverage_control_dump(const struct connectib_code_coverage_control *ptr_struct, FILE* file) {
	connectib_code_coverage_control_print(ptr_struct, file, 0);
}

void connectib_vport_real_state_pack(const struct connectib_vport_real_state *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4096, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->real_state[i]);
	}

}

void connectib_vport_real_state_unpack(struct connectib_vport_real_state *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4096, 1);
	ptr_struct->real_state[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_vport_real_state_print(const struct connectib_vport_real_state *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vport_real_state ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "real_state_%03d      : "U32H_FMT"\n", i, ptr_struct->real_state[i]);
	}

}

int connectib_vport_real_state_size(void){
	 return 512;
}

void connectib_vport_real_state_dump(const struct connectib_vport_real_state *ptr_struct, FILE* file) {
	connectib_vport_real_state_print(ptr_struct, file, 0);
}

void connectib_fw_esw_pack(const struct connectib_fw_esw *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(16, 16, i, 512, 1);
	connectib_fw_vport_ctx_pack(&(ptr_struct->vport_ctx[i]), ptr_buff + offset/8);
	}

}

void connectib_fw_esw_unpack(struct connectib_fw_esw *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(16, 16, i, 512, 1);
	connectib_fw_vport_ctx_unpack(&(ptr_struct->vport_ctx[i]), ptr_buff + offset/8);
	}

}

void connectib_fw_esw_print(const struct connectib_fw_esw *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_esw ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_ctx_%03d:\n", i);
	connectib_fw_vport_ctx_print(&(ptr_struct->vport_ctx[i]), file, indent_level + 1);
	}

}

int connectib_fw_esw_size(void){
	 return 64;
}

void connectib_fw_esw_dump(const struct connectib_fw_esw *ptr_struct, FILE* file) {
	connectib_fw_esw_print(ptr_struct, file, 0);
}

void connectib_gvmix_sub_structs_pack(const union connectib_gvmix_sub_structs *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_vf_pages_list_pack(&(ptr_struct->vf_pages_list), ptr_buff);
}

void connectib_gvmix_sub_structs_unpack(union connectib_gvmix_sub_structs *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_vf_pages_list_unpack(&(ptr_struct->vf_pages_list), ptr_buff);
}

void connectib_gvmix_sub_structs_print(const union connectib_gvmix_sub_structs *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_gvmix_sub_structs ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmdif_ctx:\n");
	connectib_cmdif_ctx_print(&(ptr_struct->cmdif_ctx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dummy_addresses:\n");
	connectib_dummy_addresses_one_cache_line_print(&(ptr_struct->dummy_addresses), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hca_params:\n");
	connectib_hca_params_print(&(ptr_struct->hca_params), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_page_manager:\n");
	connectib_icm_page_manager_print(&(ptr_struct->icm_page_manager), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_pages_list:\n");
	connectib_vf_pages_list_print(&(ptr_struct->vf_pages_list), file, indent_level + 1);

}

int connectib_gvmix_sub_structs_size(void){
	 return 64;
}

void connectib_gvmix_sub_structs_dump(const union connectib_gvmix_sub_structs *ptr_struct, FILE* file) {
	connectib_gvmix_sub_structs_print(ptr_struct, file, 0);
}

void connectib_sw_eqe_pack(const struct connectib_sw_eqe *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->event_sub_type);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->event_type);

	offset=256;
	connectib_sw_eqe_data_pack(&(ptr_struct->event_data), ptr_buff + offset/8);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->owner);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

}

void connectib_sw_eqe_unpack(struct connectib_sw_eqe *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->event_sub_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->event_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	connectib_sw_eqe_data_unpack(&(ptr_struct->event_data), ptr_buff + offset/8);

	offset=511;
	ptr_struct->owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=496;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_sw_eqe_print(const struct connectib_sw_eqe *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_eqe ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_sub_type       : "UH_FMT"\n", ptr_struct->event_sub_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_type           : "UH_FMT"\n", ptr_struct->event_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "event_data:\n");
	connectib_sw_eqe_data_print(&(ptr_struct->event_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner                : "UH_FMT"\n", ptr_struct->owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

}

int connectib_sw_eqe_size(void){
	 return 64;
}

void connectib_sw_eqe_dump(const struct connectib_sw_eqe *ptr_struct, FILE* file) {
	connectib_sw_eqe_print(ptr_struct, file, 0);
}

void connectib_itrace_ctrl_pack(const struct connectib_itrace_ctrl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log_level);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->log_delay);

}

void connectib_itrace_ctrl_unpack(struct connectib_itrace_ctrl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->log_level = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->log_delay = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_itrace_ctrl_print(const struct connectib_itrace_ctrl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_itrace_ctrl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_level            : "UH_FMT"\n", ptr_struct->log_level);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_delay            : "UH_FMT"\n", ptr_struct->log_delay);

}

int connectib_itrace_ctrl_size(void){
	 return 4;
}

void connectib_itrace_ctrl_dump(const struct connectib_itrace_ctrl *ptr_struct, FILE* file) {
	connectib_itrace_ctrl_print(ptr_struct, file, 0);
}

void connectib_lock_tag_pack(const struct connectib_lock_tag *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->resource_id);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->resource_type);

}

void connectib_lock_tag_unpack(struct connectib_lock_tag *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->resource_id = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->resource_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_lock_tag_print(const struct connectib_lock_tag *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_lock_tag ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "resource_id          : "UH_FMT"\n", ptr_struct->resource_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "resource_type        : "UH_FMT"\n", ptr_struct->resource_type);

}

int connectib_lock_tag_size(void){
	 return 4;
}

void connectib_lock_tag_dump(const struct connectib_lock_tag *ptr_struct, FILE* file) {
	connectib_lock_tag_print(ptr_struct, file, 0);
}

void connectib_reg_access_cmd_pack(const struct connectib_reg_access_cmd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_oper_tlv_pack(&(ptr_struct->oper_tlv), ptr_buff + offset/8);

	offset=128;
	connectib_reg_access_reg_tlv_pack(&(ptr_struct->reg_tlv), ptr_buff + offset/8);

}

void connectib_reg_access_cmd_unpack(struct connectib_reg_access_cmd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_oper_tlv_unpack(&(ptr_struct->oper_tlv), ptr_buff + offset/8);

	offset=128;
	connectib_reg_access_reg_tlv_unpack(&(ptr_struct->reg_tlv), ptr_buff + offset/8);

}

void connectib_reg_access_cmd_print(const struct connectib_reg_access_cmd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_cmd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "oper_tlv:\n");
	connectib_reg_access_oper_tlv_print(&(ptr_struct->oper_tlv), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg_tlv:\n");
	connectib_reg_access_reg_tlv_print(&(ptr_struct->reg_tlv), file, indent_level + 1);

}

int connectib_reg_access_cmd_size(void){
	 return 64;
}

void connectib_reg_access_cmd_dump(const struct connectib_reg_access_cmd *ptr_struct, FILE* file) {
	connectib_reg_access_cmd_print(ptr_struct, file, 0);
}

void connectib_cable_info_pack(const struct connectib_cable_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->address);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->page_number);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->device_address);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->size);

	for (i=0; i < 12; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_cable_info_unpack(struct connectib_cable_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->address = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=8;
	ptr_struct->page_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->device_address = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i=0; i < 12; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 512, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_cable_info_print(const struct connectib_cable_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cable_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : "UH_FMT"\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "page_number          : "UH_FMT"\n", ptr_struct->page_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_address       : "UH_FMT"\n", ptr_struct->device_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	for (i=0; i < 12; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_cable_info_size(void){
	 return 64;
}

void connectib_cable_info_dump(const struct connectib_cable_info *ptr_struct, FILE* file) {
	connectib_cable_info_print(ptr_struct, file, 0);
}

void connectib_grepper_dwords_pack(const struct connectib_grepper_dwords *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dwords[i]);
	}

}

void connectib_grepper_dwords_unpack(struct connectib_grepper_dwords *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->dwords[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_grepper_dwords_print(const struct connectib_grepper_dwords *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_grepper_dwords ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dwords_%03d          : "U32H_FMT"\n", i, ptr_struct->dwords[i]);
	}

}

int connectib_grepper_dwords_size(void){
	 return 64;
}

void connectib_grepper_dwords_dump(const struct connectib_grepper_dwords *ptr_struct, FILE* file) {
	connectib_grepper_dwords_print(ptr_struct, file, 0);
}

void connectib_cc_table_entry_pack(const struct connectib_cc_table_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 14, (u_int32_t)ptr_struct->cct_multiplier);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cct_shift);

}

void connectib_cc_table_entry_unpack(struct connectib_cc_table_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=2;
	ptr_struct->cct_multiplier = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 14);

	offset=0;
	ptr_struct->cct_shift = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_cc_table_entry_print(const struct connectib_cc_table_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cc_table_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cct_multiplier       : "UH_FMT"\n", ptr_struct->cct_multiplier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cct_shift            : "UH_FMT"\n", ptr_struct->cct_shift);

}

int connectib_cc_table_entry_size(void){
	 return 2;
}

void connectib_cc_table_entry_dump(const struct connectib_cc_table_entry *ptr_struct, FILE* file) {
	connectib_cc_table_entry_print(ptr_struct, file, 0);
}

void connectib_ca_congestion_entry_pack(const struct connectib_ca_congestion_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->trigger_threshold);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ccti_increase);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ccti_timer);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->ccti_min);

}

void connectib_ca_congestion_entry_unpack(struct connectib_ca_congestion_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->trigger_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->ccti_increase = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->ccti_timer = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->ccti_min = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_ca_congestion_entry_print(const struct connectib_ca_congestion_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ca_congestion_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trigger_threshold    : "UH_FMT"\n", ptr_struct->trigger_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccti_increase        : "UH_FMT"\n", ptr_struct->ccti_increase);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccti_timer           : "UH_FMT"\n", ptr_struct->ccti_timer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccti_min             : "UH_FMT"\n", ptr_struct->ccti_min);

}

int connectib_ca_congestion_entry_size(void){
	 return 8;
}

void connectib_ca_congestion_entry_dump(const struct connectib_ca_congestion_entry *ptr_struct, FILE* file) {
	connectib_ca_congestion_entry_print(ptr_struct, file, 0);
}

void connectib_congestion_log_event_entry_pack(const struct connectib_congestion_log_event_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->service_type);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->local_qpn);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->remote_qpn);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->remote_lid);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp);

}

void connectib_congestion_log_event_entry_unpack(struct connectib_congestion_log_event_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->service_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=24;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=0;
	ptr_struct->local_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->remote_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=80;
	ptr_struct->remote_lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->timestamp = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_congestion_log_event_entry_print(const struct connectib_congestion_log_event_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_congestion_log_event_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "service_type         : "UH_FMT"\n", ptr_struct->service_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_qpn            : "UH_FMT"\n", ptr_struct->local_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_qpn           : "UH_FMT"\n", ptr_struct->remote_qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_lid           : "UH_FMT"\n", ptr_struct->remote_lid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp            : "U32H_FMT"\n", ptr_struct->timestamp);

}

int connectib_congestion_log_event_entry_size(void){
	 return 16;
}

void connectib_congestion_log_event_entry_dump(const struct connectib_congestion_log_event_entry *ptr_struct, FILE* file) {
	connectib_congestion_log_event_entry_print(ptr_struct, file, 0);
}

void connectib_special_qps_pack(const struct connectib_special_qps *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qp0);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->qp1);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->raw);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ipv6);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->reserved);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ptp1588);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sync_umr);

}

void connectib_special_qps_unpack(struct connectib_special_qps *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->qp0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->qp1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->raw = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->ipv6 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->reserved = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->ptp1588 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->sync_umr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_special_qps_print(const struct connectib_special_qps *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_special_qps ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp0                  : "U32H_FMT"\n", ptr_struct->qp0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qp1                  : "U32H_FMT"\n", ptr_struct->qp1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw                  : "U32H_FMT"\n", ptr_struct->raw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ipv6                 : "U32H_FMT"\n", ptr_struct->ipv6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved             : "U32H_FMT"\n", ptr_struct->reserved);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptp1588              : "U32H_FMT"\n", ptr_struct->ptp1588);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sync_umr             : "U32H_FMT"\n", ptr_struct->sync_umr);

}

int connectib_special_qps_size(void){
	 return 32;
}

void connectib_special_qps_dump(const struct connectib_special_qps *ptr_struct, FILE* file) {
	connectib_special_qps_print(ptr_struct, file, 0);
}

void connectib_cmdif_hdr_pack(const struct connectib_cmdif_hdr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->reserved0);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->type);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->input_length);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ibox_pointer);

	offset=128;
	connectib_input_inline_standart_pack(&(ptr_struct->input_inline), ptr_buff + offset/8);

	offset=256;
	connectib_output_inline_standart_pack(&(ptr_struct->output_inline), ptr_buff + offset/8);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->obox_pointer);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->output_length);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ownership);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->status);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->reserved1);

	offset=488;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->token);

}

void connectib_cmdif_hdr_unpack(struct connectib_cmdif_hdr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->reserved0 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=0;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->input_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->ibox_pointer = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_input_inline_standart_unpack(&(ptr_struct->input_inline), ptr_buff + offset/8);

	offset=256;
	connectib_output_inline_standart_unpack(&(ptr_struct->output_inline), ptr_buff + offset/8);

	offset=384;
	ptr_struct->obox_pointer = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=448;
	ptr_struct->output_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=511;
	ptr_struct->ownership = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=504;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=496;
	ptr_struct->reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=488;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->token = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_cmdif_hdr_print(const struct connectib_cmdif_hdr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_cmdif_hdr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved0            : "UH_FMT"\n", ptr_struct->reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "input_length         : "U32H_FMT"\n", ptr_struct->input_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibox_pointer         : "U64H_FMT"\n", ptr_struct->ibox_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "input_inline:\n");
	connectib_input_inline_standart_print(&(ptr_struct->input_inline), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "output_inline:\n");
	connectib_output_inline_standart_print(&(ptr_struct->output_inline), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "obox_pointer         : "U64H_FMT"\n", ptr_struct->obox_pointer);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "output_length        : "U32H_FMT"\n", ptr_struct->output_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ownership            : "UH_FMT"\n", ptr_struct->ownership);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : "UH_FMT"\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved1            : "UH_FMT"\n", ptr_struct->reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "token                : "UH_FMT"\n", ptr_struct->token);

}

int connectib_cmdif_hdr_size(void){
	 return 64;
}

void connectib_cmdif_hdr_dump(const struct connectib_cmdif_hdr *ptr_struct, FILE* file) {
	connectib_cmdif_hdr_print(ptr_struct, file, 0);
}

void connectib_icmd_header_capture_checks_pack(const struct connectib_icmd_header_capture_checks *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->word[i]);
	}

}

void connectib_icmd_header_capture_checks_unpack(struct connectib_icmd_header_capture_checks *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->word[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_icmd_header_capture_checks_print(const struct connectib_icmd_header_capture_checks *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_header_capture_checks ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "word_%03d            : "U32H_FMT"\n", i, ptr_struct->word[i]);
	}

}

int connectib_icmd_header_capture_checks_size(void){
	 return 64;
}

void connectib_icmd_header_capture_checks_dump(const struct connectib_icmd_header_capture_checks *ptr_struct, FILE* file) {
	connectib_icmd_header_capture_checks_print(ptr_struct, file, 0);
}

void connectib_icmd_header_capture_headers_pack(const struct connectib_icmd_header_capture_headers *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->word[i]);
	}

}

void connectib_icmd_header_capture_headers_unpack(struct connectib_icmd_header_capture_headers *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	ptr_struct->word[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_icmd_header_capture_headers_print(const struct connectib_icmd_header_capture_headers *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_header_capture_headers ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "word_%03d            : "U32H_FMT"\n", i, ptr_struct->word[i]);
	}

}

int connectib_icmd_header_capture_headers_size(void){
	 return 128;
}

void connectib_icmd_header_capture_headers_dump(const struct connectib_icmd_header_capture_headers *ptr_struct, FILE* file) {
	connectib_icmd_header_capture_headers_print(ptr_struct, file, 0);
}

void connectib_g_rse_hw_decoders_pack(const union connectib_g_rse_hw_decoders *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_g_rse_decoders_as_dwords_pack(&(ptr_struct->raw_dwords), ptr_buff);
}

void connectib_g_rse_hw_decoders_unpack(union connectib_g_rse_hw_decoders *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_g_rse_decoders_as_dwords_unpack(&(ptr_struct->raw_dwords), ptr_buff);
}

void connectib_g_rse_hw_decoders_print(const union connectib_g_rse_hw_decoders *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_g_rse_hw_decoders ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxt_checks_steering_results_decoder:\n");
	connectib_rxt_checks_steering_results_decoder_print(&(ptr_struct->rxt_checks_steering_results_decoder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxt_context_fetch_qp_desc_decoder:\n");
	connectib_rxt_context_fetch_qp_desc_decoder_print(&(ptr_struct->rxt_context_fetch_qp_desc_decoder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxt_checks_packet_descriptor_decoder:\n");
	connectib_rxt_checks_packet_descriptor_decoder_print(&(ptr_struct->rxt_checks_packet_descriptor_decoder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rxs_rxt_desc_decoder:\n");
	connectib_rxs_rxt_desc_decoder_print(&(ptr_struct->rxs_rxt_desc_decoder), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "raw_dwords:\n");
	connectib_g_rse_decoders_as_dwords_print(&(ptr_struct->raw_dwords), file, indent_level + 1);

}

int connectib_g_rse_hw_decoders_size(void){
	 return 256;
}

void connectib_g_rse_hw_decoders_dump(const union connectib_g_rse_hw_decoders *ptr_struct, FILE* file) {
	connectib_g_rse_hw_decoders_print(ptr_struct, file, 0);
}

void connectib_FW_VERSION_pack(const struct connectib_FW_VERSION *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MAJOR);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SUBMINOR);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MINOR);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Hour);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Minutes);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Seconds);

	offset=120;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Day);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->Month);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->Year);

}

void connectib_FW_VERSION_unpack(struct connectib_FW_VERSION *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->MAJOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	ptr_struct->SUBMINOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->MINOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=80;
	ptr_struct->Hour = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=72;
	ptr_struct->Minutes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=64;
	ptr_struct->Seconds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=120;
	ptr_struct->Day = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=112;
	ptr_struct->Month = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->Year = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_FW_VERSION_print(const struct connectib_FW_VERSION *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_FW_VERSION ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAJOR                : "UH_FMT"\n", ptr_struct->MAJOR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SUBMINOR             : "UH_FMT"\n", ptr_struct->SUBMINOR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MINOR                : "UH_FMT"\n", ptr_struct->MINOR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Hour                 : "UH_FMT"\n", ptr_struct->Hour);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Minutes              : "UH_FMT"\n", ptr_struct->Minutes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Seconds              : "UH_FMT"\n", ptr_struct->Seconds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Day                  : "UH_FMT"\n", ptr_struct->Day);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Month                : "UH_FMT"\n", ptr_struct->Month);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "Year                 : "UH_FMT"\n", ptr_struct->Year);

}

int connectib_FW_VERSION_size(void){
	 return 16;
}

void connectib_FW_VERSION_dump(const struct connectib_FW_VERSION *ptr_struct, FILE* file) {
	connectib_FW_VERSION_print(ptr_struct, file, 0);
}

void connectib_golan_hw_fw_ctx_pack(const union connectib_golan_hw_fw_ctx *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_ctx_as_dwords_pack(&(ptr_struct->as_dwords), ptr_buff);
}

void connectib_golan_hw_fw_ctx_unpack(union connectib_golan_hw_fw_ctx *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_ctx_as_dwords_unpack(&(ptr_struct->as_dwords), ptr_buff);
}

void connectib_golan_hw_fw_ctx_print(const union connectib_golan_hw_fw_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_golan_hw_fw_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_ctx:\n");
	connectib_hw_hca_contexts_print(&(ptr_struct->hw_ctx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_ctx:\n");
	connectib_fw_resource_context_print(&(ptr_struct->fw_ctx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_dwords:\n");
	connectib_ctx_as_dwords_print(&(ptr_struct->as_dwords), file, indent_level + 1);

}

int connectib_golan_hw_fw_ctx_size(void){
	 return 64;
}

void connectib_golan_hw_fw_ctx_dump(const union connectib_golan_hw_fw_ctx *ptr_struct, FILE* file) {
	connectib_golan_hw_fw_ctx_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_128byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_128byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	connectib_add_data_pack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	connectib_field_boundary_pack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_128byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_128byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	connectib_add_data_unpack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	connectib_field_boundary_unpack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_128byte_print(const struct connectib_wqe_extended_atomic_fetch_add_128byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_128byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_%03d:\n", i);
	connectib_add_data_print(&(ptr_struct->add_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary_%03d:\n", i);
	connectib_field_boundary_print(&(ptr_struct->field_boundary[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_fetch_add_128byte_size(void){
	 return 256;
}

void connectib_wqe_extended_atomic_fetch_add_128byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_128byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_128byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_64byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_64byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_add_data_pack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1024, 1);
	connectib_field_boundary_pack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_64byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_64byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_add_data_unpack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1024, 1);
	connectib_field_boundary_unpack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_64byte_print(const struct connectib_wqe_extended_atomic_fetch_add_64byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_64byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_%03d:\n", i);
	connectib_add_data_print(&(ptr_struct->add_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary_%03d:\n", i);
	connectib_field_boundary_print(&(ptr_struct->field_boundary[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_fetch_add_64byte_size(void){
	 return 128;
}

void connectib_wqe_extended_atomic_fetch_add_64byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_64byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_64byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_32byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_32byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_add_data_pack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 512, 1);
	connectib_field_boundary_pack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_32byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_32byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_add_data_unpack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 512, 1);
	connectib_field_boundary_unpack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_32byte_print(const struct connectib_wqe_extended_atomic_fetch_add_32byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_32byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_%03d:\n", i);
	connectib_add_data_print(&(ptr_struct->add_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary_%03d:\n", i);
	connectib_field_boundary_print(&(ptr_struct->field_boundary[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_fetch_add_32byte_size(void){
	 return 64;
}

void connectib_wqe_extended_atomic_fetch_add_32byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_32byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_32byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_16byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_16byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_add_data_pack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	connectib_field_boundary_pack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_16byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_16byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_add_data_unpack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	connectib_field_boundary_unpack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_16byte_print(const struct connectib_wqe_extended_atomic_fetch_add_16byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_16byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_%03d:\n", i);
	connectib_add_data_print(&(ptr_struct->add_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary_%03d:\n", i);
	connectib_field_boundary_print(&(ptr_struct->field_boundary[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_fetch_add_16byte_size(void){
	 return 32;
}

void connectib_wqe_extended_atomic_fetch_add_16byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_16byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_16byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_8byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_8byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	connectib_add_data_pack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(64, 32, i, 128, 1);
	connectib_field_boundary_pack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_8byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_8byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 128, 1);
	connectib_add_data_unpack(&(ptr_struct->add_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(64, 32, i, 128, 1);
	connectib_field_boundary_unpack(&(ptr_struct->field_boundary[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_fetch_add_8byte_print(const struct connectib_wqe_extended_atomic_fetch_add_8byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_8byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_%03d:\n", i);
	connectib_add_data_print(&(ptr_struct->add_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary_%03d:\n", i);
	connectib_field_boundary_print(&(ptr_struct->field_boundary[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_fetch_add_8byte_size(void){
	 return 16;
}

void connectib_wqe_extended_atomic_fetch_add_8byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_8byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_8byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_4byte_pack(const struct connectib_wqe_extended_atomic_fetch_add_4byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->add_data);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->field_boundary);

}

void connectib_wqe_extended_atomic_fetch_add_4byte_unpack(struct connectib_wqe_extended_atomic_fetch_add_4byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->add_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->field_boundary = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_extended_atomic_fetch_add_4byte_print(const struct connectib_wqe_extended_atomic_fetch_add_4byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add_4byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data             : "U32H_FMT"\n", ptr_struct->add_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_boundary       : "U32H_FMT"\n", ptr_struct->field_boundary);

}

int connectib_wqe_extended_atomic_fetch_add_4byte_size(void){
	 return 16;
}

void connectib_wqe_extended_atomic_fetch_add_4byte_dump(const struct connectib_wqe_extended_atomic_fetch_add_4byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_4byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_128byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_128byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4096, 1);
	connectib_swap_data_pack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 4096, 1);
	connectib_compare_data_pack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(2048, 32, i, 4096, 1);
	connectib_swap_mask_data_pack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(3072, 32, i, 4096, 1);
	connectib_compare_mask_data_pack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_128byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_128byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4096, 1);
	connectib_swap_data_unpack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 4096, 1);
	connectib_compare_data_unpack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(2048, 32, i, 4096, 1);
	connectib_swap_mask_data_unpack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(3072, 32, i, 4096, 1);
	connectib_compare_mask_data_unpack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_128byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_128byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_128byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_%03d:\n", i);
	connectib_swap_data_print(&(ptr_struct->swap_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_%03d:\n", i);
	connectib_compare_data_print(&(ptr_struct->compare_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data_%03d:\n", i);
	connectib_swap_mask_data_print(&(ptr_struct->swap_mask_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data_%03d:\n", i);
	connectib_compare_mask_data_print(&(ptr_struct->compare_mask_data[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_cmp_swap_128byte_size(void){
	 return 512;
}

void connectib_wqe_extended_atomic_cmp_swap_128byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_128byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_128byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_64byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_64byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	connectib_swap_data_pack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 2048, 1);
	connectib_compare_data_pack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	connectib_swap_mask_data_pack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(1536, 32, i, 2048, 1);
	connectib_compare_mask_data_pack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_64byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_64byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2048, 1);
	connectib_swap_data_unpack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 2048, 1);
	connectib_compare_data_unpack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(1024, 32, i, 2048, 1);
	connectib_swap_mask_data_unpack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(1536, 32, i, 2048, 1);
	connectib_compare_mask_data_unpack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_64byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_64byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_64byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_%03d:\n", i);
	connectib_swap_data_print(&(ptr_struct->swap_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_%03d:\n", i);
	connectib_compare_data_print(&(ptr_struct->compare_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data_%03d:\n", i);
	connectib_swap_mask_data_print(&(ptr_struct->swap_mask_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data_%03d:\n", i);
	connectib_compare_mask_data_print(&(ptr_struct->compare_mask_data[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_cmp_swap_64byte_size(void){
	 return 256;
}

void connectib_wqe_extended_atomic_cmp_swap_64byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_64byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_64byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_32byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_32byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_swap_data_pack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 1024, 1);
	connectib_compare_data_pack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1024, 1);
	connectib_swap_mask_data_pack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(768, 32, i, 1024, 1);
	connectib_compare_mask_data_pack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_32byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_32byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 1024, 1);
	connectib_swap_data_unpack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 1024, 1);
	connectib_compare_data_unpack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1024, 1);
	connectib_swap_mask_data_unpack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(768, 32, i, 1024, 1);
	connectib_compare_mask_data_unpack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_32byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_32byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_32byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_%03d:\n", i);
	connectib_swap_data_print(&(ptr_struct->swap_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_%03d:\n", i);
	connectib_compare_data_print(&(ptr_struct->compare_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data_%03d:\n", i);
	connectib_swap_mask_data_print(&(ptr_struct->swap_mask_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data_%03d:\n", i);
	connectib_compare_mask_data_print(&(ptr_struct->compare_mask_data[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_cmp_swap_32byte_size(void){
	 return 128;
}

void connectib_wqe_extended_atomic_cmp_swap_32byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_32byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_32byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_16byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_16byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_swap_data_pack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 512, 1);
	connectib_compare_data_pack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 512, 1);
	connectib_swap_mask_data_pack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(384, 32, i, 512, 1);
	connectib_compare_mask_data_pack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_16byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_16byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	connectib_swap_data_unpack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 512, 1);
	connectib_compare_data_unpack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(256, 32, i, 512, 1);
	connectib_swap_mask_data_unpack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(384, 32, i, 512, 1);
	connectib_compare_mask_data_unpack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_16byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_16byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_16byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_%03d:\n", i);
	connectib_swap_data_print(&(ptr_struct->swap_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_%03d:\n", i);
	connectib_compare_data_print(&(ptr_struct->compare_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data_%03d:\n", i);
	connectib_swap_mask_data_print(&(ptr_struct->swap_mask_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data_%03d:\n", i);
	connectib_compare_mask_data_print(&(ptr_struct->compare_mask_data[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_cmp_swap_16byte_size(void){
	 return 64;
}

void connectib_wqe_extended_atomic_cmp_swap_16byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_16byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_16byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_8byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_8byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_swap_data_pack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(64, 32, i, 256, 1);
	connectib_compare_data_pack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	connectib_swap_mask_data_pack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(192, 32, i, 256, 1);
	connectib_compare_mask_data_pack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_8byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_8byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 256, 1);
	connectib_swap_data_unpack(&(ptr_struct->swap_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(64, 32, i, 256, 1);
	connectib_compare_data_unpack(&(ptr_struct->compare_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(128, 32, i, 256, 1);
	connectib_swap_mask_data_unpack(&(ptr_struct->swap_mask_data[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(192, 32, i, 256, 1);
	connectib_compare_mask_data_unpack(&(ptr_struct->compare_mask_data[i]), ptr_buff + offset/8);
	}

}

void connectib_wqe_extended_atomic_cmp_swap_8byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_8byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_8byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_%03d:\n", i);
	connectib_swap_data_print(&(ptr_struct->swap_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_%03d:\n", i);
	connectib_compare_data_print(&(ptr_struct->compare_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data_%03d:\n", i);
	connectib_swap_mask_data_print(&(ptr_struct->swap_mask_data[i]), file, indent_level + 1);
	}

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data_%03d:\n", i);
	connectib_compare_mask_data_print(&(ptr_struct->compare_mask_data[i]), file, indent_level + 1);
	}

}

int connectib_wqe_extended_atomic_cmp_swap_8byte_size(void){
	 return 32;
}

void connectib_wqe_extended_atomic_cmp_swap_8byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_8byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_8byte_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_4byte_pack(const struct connectib_wqe_extended_atomic_cmp_swap_4byte *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_data);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_data);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_mask_data);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_mask_data);

}

void connectib_wqe_extended_atomic_cmp_swap_4byte_unpack(struct connectib_wqe_extended_atomic_cmp_swap_4byte *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->swap_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->compare_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->swap_mask_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->compare_mask_data = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_extended_atomic_cmp_swap_4byte_print(const struct connectib_wqe_extended_atomic_cmp_swap_4byte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap_4byte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data            : "U32H_FMT"\n", ptr_struct->swap_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data         : "U32H_FMT"\n", ptr_struct->compare_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_mask_data       : "U32H_FMT"\n", ptr_struct->swap_mask_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask_data    : "U32H_FMT"\n", ptr_struct->compare_mask_data);

}

int connectib_wqe_extended_atomic_cmp_swap_4byte_size(void){
	 return 16;
}

void connectib_wqe_extended_atomic_cmp_swap_4byte_dump(const struct connectib_wqe_extended_atomic_cmp_swap_4byte *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_4byte_print(ptr_struct, file, 0);
}

void connectib_nv_config_header_pack(const struct connectib_nv_config_header *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->version_minor);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->version_major);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_of_init_cfg_hdr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_of_swaps);

	for (i=0; i < 6; i++) {
	offset=adb2c_calc_array_field_address(96, 32, i, 512, 1);
	connectib_nv_data_pointer_pack(&(ptr_struct->list_pointers[i]), ptr_buff + offset/8);
	}

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->crc16);

}

void connectib_nv_config_header_unpack(struct connectib_nv_config_header *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->signature = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=56;
	ptr_struct->version_minor = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->version_major = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->num_of_init_cfg_hdr = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->num_of_swaps = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 6; i++) {
	offset=adb2c_calc_array_field_address(96, 32, i, 512, 1);
	connectib_nv_data_pointer_unpack(&(ptr_struct->list_pointers[i]), ptr_buff + offset/8);
	}

	offset=496;
	ptr_struct->crc16 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_nv_config_header_print(const struct connectib_nv_config_header *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_header ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "U32H_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version_minor        : "UH_FMT"\n", ptr_struct->version_minor);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version_major        : "UH_FMT"\n", ptr_struct->version_major);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_init_cfg_hdr  : "UH_FMT"\n", ptr_struct->num_of_init_cfg_hdr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_swaps         : "U32H_FMT"\n", ptr_struct->num_of_swaps);

	for (i=0; i < 6; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "list_pointers_%03d:\n", i);
	connectib_nv_data_pointer_print(&(ptr_struct->list_pointers[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "crc16                : "UH_FMT"\n", ptr_struct->crc16);

}

int connectib_nv_config_header_size(void){
	 return 64;
}

void connectib_nv_config_header_dump(const struct connectib_nv_config_header *ptr_struct, FILE* file) {
	connectib_nv_config_header_print(ptr_struct, file, 0);
}

void connectib_fw_image_pack(const struct connectib_fw_image *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->itoc_ptr);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->is_palladium);

	offset=32;
	connectib_jump_addresses_pack(&(ptr_struct->jump_addresses), ptr_buff + offset/8);

}

void connectib_fw_image_unpack(struct connectib_fw_image *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->itoc_ptr = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=7;
	ptr_struct->is_palladium = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_jump_addresses_unpack(&(ptr_struct->jump_addresses), ptr_buff + offset/8);

}

void connectib_fw_image_print(const struct connectib_fw_image *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_image ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "itoc_ptr             : "UH_FMT"\n", ptr_struct->itoc_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "is_palladium         : "UH_FMT"\n", ptr_struct->is_palladium);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "jump_addresses:\n");
	connectib_jump_addresses_print(&(ptr_struct->jump_addresses), file, indent_level + 1);

}

int connectib_fw_image_size(void){
	 return 32;
}

void connectib_fw_image_dump(const struct connectib_fw_image *ptr_struct, FILE* file) {
	connectib_fw_image_print(ptr_struct, file, 0);
}

void connectib_pcie_cfg_golan_pack(const struct connectib_pcie_cfg_golan *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->pcie_max_speed_supported);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pcie_max_width_supported);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->drop_loopback_slave_en);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->disable_automatic_reversal);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->upconfigure_capable);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->px_tx_reversal);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->polling_compliance_en);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pcie_center_phase_optimization_en);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->handle_bar_miss_error_by_cr_handler_en);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dc_ballance_en);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->receiver_detect_en);

	offset=3;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->receiver_detect_time);

	offset=2;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slot_clock_cfg);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dynamic_pll_manage_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->static_width_reduction_en);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->do_mixer0_calibration_optimized);

	offset=57;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->do_mixer0_calibration_delta);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->first_iteration_calibration_mask);

	offset=64;
	connectib_pcie_serdes_cfg_pack(&(ptr_struct->serdes_cfg), ptr_buff + offset/8);

	offset=320;
	connectib_pcie_equalization_and_eye_pack(&(ptr_struct->pcie_equalization_and_eye), ptr_buff + offset/8);

	offset=736;
	connectib_pcie_debug_cap_pack(&(ptr_struct->pcie_debug_cap), ptr_buff + offset/8);

	offset=768;
	connectib_pcie_tx_adaptation_cfg_pack(&(ptr_struct->tx_adaptation_cfg), ptr_buff + offset/8);

	offset=896;
	connectib_pcie_rx_adaptation_cfg_pack(&(ptr_struct->rx_adaptation_cfg), ptr_buff + offset/8);

}

void connectib_pcie_cfg_golan_unpack(struct connectib_pcie_cfg_golan *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->pcie_max_speed_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=23;
	ptr_struct->pcie_max_width_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=22;
	ptr_struct->drop_loopback_slave_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->disable_automatic_reversal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->upconfigure_capable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->px_tx_reversal = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->polling_compliance_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->pcie_center_phase_optimization_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->handle_bar_miss_error_by_cr_handler_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->dc_ballance_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->receiver_detect_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=3;
	ptr_struct->receiver_detect_time = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=2;
	ptr_struct->slot_clock_cfg = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1;
	ptr_struct->dynamic_pll_manage_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->static_width_reduction_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=63;
	ptr_struct->do_mixer0_calibration_optimized = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=57;
	ptr_struct->do_mixer0_calibration_delta = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=32;
	ptr_struct->first_iteration_calibration_mask = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	connectib_pcie_serdes_cfg_unpack(&(ptr_struct->serdes_cfg), ptr_buff + offset/8);

	offset=320;
	connectib_pcie_equalization_and_eye_unpack(&(ptr_struct->pcie_equalization_and_eye), ptr_buff + offset/8);

	offset=736;
	connectib_pcie_debug_cap_unpack(&(ptr_struct->pcie_debug_cap), ptr_buff + offset/8);

	offset=768;
	connectib_pcie_tx_adaptation_cfg_unpack(&(ptr_struct->tx_adaptation_cfg), ptr_buff + offset/8);

	offset=896;
	connectib_pcie_rx_adaptation_cfg_unpack(&(ptr_struct->rx_adaptation_cfg), ptr_buff + offset/8);

}

void connectib_pcie_cfg_golan_print(const struct connectib_pcie_cfg_golan *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_cfg_golan ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_max_speed_supported : "UH_FMT"\n", ptr_struct->pcie_max_speed_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_max_width_supported : "UH_FMT"\n", ptr_struct->pcie_max_width_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "drop_loopback_slave_en : "UH_FMT"\n", ptr_struct->drop_loopback_slave_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "disable_automatic_reversal : "UH_FMT"\n", ptr_struct->disable_automatic_reversal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "upconfigure_capable  : "UH_FMT"\n", ptr_struct->upconfigure_capable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "px_tx_reversal       : "UH_FMT"\n", ptr_struct->px_tx_reversal);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "polling_compliance_en : "UH_FMT"\n", ptr_struct->polling_compliance_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_center_phase_optimization_en : "UH_FMT"\n", ptr_struct->pcie_center_phase_optimization_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "handle_bar_miss_error_by_cr_handler_en : "UH_FMT"\n", ptr_struct->handle_bar_miss_error_by_cr_handler_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_ballance_en       : "UH_FMT"\n", ptr_struct->dc_ballance_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_detect_en   : "UH_FMT"\n", ptr_struct->receiver_detect_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "receiver_detect_time : "UH_FMT"\n", ptr_struct->receiver_detect_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slot_clock_cfg       : "UH_FMT"\n", ptr_struct->slot_clock_cfg);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dynamic_pll_manage_en : "UH_FMT"\n", ptr_struct->dynamic_pll_manage_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "static_width_reduction_en : "UH_FMT"\n", ptr_struct->static_width_reduction_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "do_mixer0_calibration_optimized : "UH_FMT"\n", ptr_struct->do_mixer0_calibration_optimized);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "do_mixer0_calibration_delta : "UH_FMT"\n", ptr_struct->do_mixer0_calibration_delta);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_iteration_calibration_mask : "UH_FMT"\n", ptr_struct->first_iteration_calibration_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "serdes_cfg:\n");
	connectib_pcie_serdes_cfg_print(&(ptr_struct->serdes_cfg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_equalization_and_eye:\n");
	connectib_pcie_equalization_and_eye_print(&(ptr_struct->pcie_equalization_and_eye), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_debug_cap:\n");
	connectib_pcie_debug_cap_print(&(ptr_struct->pcie_debug_cap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_adaptation_cfg:\n");
	connectib_pcie_tx_adaptation_cfg_print(&(ptr_struct->tx_adaptation_cfg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_adaptation_cfg:\n");
	connectib_pcie_rx_adaptation_cfg_print(&(ptr_struct->rx_adaptation_cfg), file, indent_level + 1);

}

int connectib_pcie_cfg_golan_size(void){
	 return 192;
}

void connectib_pcie_cfg_golan_dump(const struct connectib_pcie_cfg_golan *ptr_struct, FILE* file) {
	connectib_pcie_cfg_golan_print(ptr_struct, file, 0);
}

void connectib_vpd_eeprom_info_pack(const struct connectib_vpd_eeprom_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vpd_size);

	offset=11;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log2_vpd_eeprom_size);

	offset=5;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->vpd_num_eeproms);

	offset=4;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vpd_eeprom);

}

void connectib_vpd_eeprom_info_unpack(struct connectib_vpd_eeprom_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->vpd_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=11;
	ptr_struct->log2_vpd_eeprom_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=5;
	ptr_struct->vpd_num_eeproms = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=4;
	ptr_struct->vpd_eeprom = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_vpd_eeprom_info_print(const struct connectib_vpd_eeprom_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_vpd_eeprom_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_size             : "UH_FMT"\n", ptr_struct->vpd_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_vpd_eeprom_size : "UH_FMT"\n", ptr_struct->log2_vpd_eeprom_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_num_eeproms      : "UH_FMT"\n", ptr_struct->vpd_num_eeproms);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_eeprom           : "UH_FMT"\n", ptr_struct->vpd_eeprom);

}

int connectib_vpd_eeprom_info_size(void){
	 return 8;
}

void connectib_vpd_eeprom_info_dump(const struct connectib_vpd_eeprom_info *ptr_struct, FILE* file) {
	connectib_vpd_eeprom_info_print(ptr_struct, file, 0);
}

void connectib_ini_gpios_golan_pack(const struct connectib_ini_gpios_golan *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_gpio_functions_pack(&(ptr_struct->functions), ptr_buff + offset/8);

	offset=672;
	connectib_gpio_configurations_pack(&(ptr_struct->configurations), ptr_buff + offset/8);

}

void connectib_ini_gpios_golan_unpack(struct connectib_ini_gpios_golan *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_gpio_functions_unpack(&(ptr_struct->functions), ptr_buff + offset/8);

	offset=672;
	connectib_gpio_configurations_unpack(&(ptr_struct->configurations), ptr_buff + offset/8);

}

void connectib_ini_gpios_golan_print(const struct connectib_ini_gpios_golan *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ini_gpios_golan ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "functions:\n");
	connectib_gpio_functions_print(&(ptr_struct->functions), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "configurations:\n");
	connectib_gpio_configurations_print(&(ptr_struct->configurations), file, indent_level + 1);

}

int connectib_ini_gpios_golan_size(void){
	 return 132;
}

void connectib_ini_gpios_golan_dump(const struct connectib_ini_gpios_golan *ptr_struct, FILE* file) {
	connectib_ini_gpios_golan_print(ptr_struct, file, 0);
}

void connectib_i2c_devices_db_pack(const struct connectib_i2c_devices_db *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 640, 1);
	connectib_i2c_device_entry_pack(&(ptr_struct->device[i]), ptr_buff + offset/8);
	}

}

void connectib_i2c_devices_db_unpack(struct connectib_i2c_devices_db *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 640, 1);
	connectib_i2c_device_entry_unpack(&(ptr_struct->device[i]), ptr_buff + offset/8);
	}

}

void connectib_i2c_devices_db_print(const struct connectib_i2c_devices_db *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_i2c_devices_db ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_%03d:\n", i);
	connectib_i2c_device_entry_print(&(ptr_struct->device[i]), file, indent_level + 1);
	}

}

int connectib_i2c_devices_db_size(void){
	 return 80;
}

void connectib_i2c_devices_db_dump(const struct connectib_i2c_devices_db *ptr_struct, FILE* file) {
	connectib_i2c_devices_db_print(ptr_struct, file, 0);
}

void connectib_module_config_pack(const struct connectib_module_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 64, 1);
	connectib_module_config_st_pack(&(ptr_struct->module[i]), ptr_buff + offset/8);
	}

}

void connectib_module_config_unpack(struct connectib_module_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 64, 1);
	connectib_module_config_st_unpack(&(ptr_struct->module[i]), ptr_buff + offset/8);
	}

}

void connectib_module_config_print(const struct connectib_module_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_module_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_%03d:\n", i);
	connectib_module_config_st_print(&(ptr_struct->module[i]), file, indent_level + 1);
	}

}

int connectib_module_config_size(void){
	 return 8;
}

void connectib_module_config_dump(const struct connectib_module_config *ptr_struct, FILE* file) {
	connectib_module_config_print(ptr_struct, file, 0);
}

void connectib_thermal_config_golan_pack(const struct connectib_thermal_config_golan *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->warm2cold_threshold);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->cold2warm_threshold);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->fw_shut_down_threshold);

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_shut_down_en);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->gpio_enable);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trap_supported);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->trap_enable);

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fatal_enable);

	offset=52;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->active_ext_sensors);

	offset=45;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->a2d_compare_mask);

	offset=42;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->a2d_measure_mask);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->a2d_compare_and_measure_mask);

}

void connectib_thermal_config_golan_unpack(struct connectib_thermal_config_golan *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->warm2cold_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=16;
	ptr_struct->cold2warm_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->fw_shut_down_threshold = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=1;
	ptr_struct->fw_shut_down_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->gpio_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=63;
	ptr_struct->trap_supported = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->trap_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=61;
	ptr_struct->fatal_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=52;
	ptr_struct->active_ext_sensors = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=45;
	ptr_struct->a2d_compare_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=42;
	ptr_struct->a2d_measure_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=39;
	ptr_struct->a2d_compare_and_measure_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

}

void connectib_thermal_config_golan_print(const struct connectib_thermal_config_golan *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_thermal_config_golan ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "warm2cold_threshold  : "UH_FMT"\n", ptr_struct->warm2cold_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cold2warm_threshold  : "UH_FMT"\n", ptr_struct->cold2warm_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_shut_down_threshold : "UH_FMT"\n", ptr_struct->fw_shut_down_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_shut_down_en      : "UH_FMT"\n", ptr_struct->fw_shut_down_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_enable          : "UH_FMT"\n", ptr_struct->gpio_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_supported       : "UH_FMT"\n", ptr_struct->trap_supported);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "trap_enable          : "UH_FMT"\n", ptr_struct->trap_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fatal_enable         : "UH_FMT"\n", ptr_struct->fatal_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_ext_sensors   : "UH_FMT"\n", ptr_struct->active_ext_sensors);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a2d_compare_mask     : %s ("UH_FMT")\n", (ptr_struct->a2d_compare_mask == 0 ? ("NONE") : ((ptr_struct->a2d_compare_mask == 1 ? ("IOPX") : ((ptr_struct->a2d_compare_mask == 2 ? ("IOPL") : ((ptr_struct->a2d_compare_mask == 4 ? ("YU") : ("unknown")))))))), ptr_struct->a2d_compare_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a2d_measure_mask     : "UH_FMT"\n", ptr_struct->a2d_measure_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a2d_compare_and_measure_mask : "UH_FMT"\n", ptr_struct->a2d_compare_and_measure_mask);

}

int connectib_thermal_config_golan_size(void){
	 return 8;
}

void connectib_thermal_config_golan_dump(const struct connectib_thermal_config_golan *ptr_struct, FILE* file) {
	connectib_thermal_config_golan_print(ptr_struct, file, 0);
}

void connectib_system_mng_pack(const struct connectib_system_mng *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_swap);

}

void connectib_system_mng_unpack(struct connectib_system_mng *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->port_swap = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_system_mng_print(const struct connectib_system_mng *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_system_mng ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_swap            : "UH_FMT"\n", ptr_struct->port_swap);

}

int connectib_system_mng_size(void){
	 return 4;
}

void connectib_system_mng_dump(const struct connectib_system_mng *ptr_struct, FILE* file) {
	connectib_system_mng_print(ptr_struct, file, 0);
}

void connectib_power_pack(const struct connectib_power *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fuse_dvfs);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fuse_dvfs_force);

	offset=32;
	connectib_iopl_power_pack(&(ptr_struct->iopl_power), ptr_buff + offset/8);

	offset=64;
	connectib_iopx_power_pack(&(ptr_struct->iopx_power), ptr_buff + offset/8);

}

void connectib_power_unpack(struct connectib_power *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	ptr_struct->fuse_dvfs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=0;
	ptr_struct->fuse_dvfs_force = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_iopl_power_unpack(&(ptr_struct->iopl_power), ptr_buff + offset/8);

	offset=64;
	connectib_iopx_power_unpack(&(ptr_struct->iopx_power), ptr_buff + offset/8);

}

void connectib_power_print(const struct connectib_power *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_power ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fuse_dvfs            : "UH_FMT"\n", ptr_struct->fuse_dvfs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fuse_dvfs_force      : "UH_FMT"\n", ptr_struct->fuse_dvfs_force);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iopl_power:\n");
	connectib_iopl_power_print(&(ptr_struct->iopl_power), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iopx_power:\n");
	connectib_iopx_power_print(&(ptr_struct->iopx_power), file, indent_level + 1);

}

int connectib_power_size(void){
	 return 16;
}

void connectib_power_dump(const struct connectib_power *ptr_struct, FILE* file) {
	connectib_power_print(ptr_struct, file, 0);
}

void connectib_port_serdes_pack(const struct connectib_port_serdes *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_phy_hw_main_config_ip_pack(&(ptr_struct->phy_hw_main_config_ip), ptr_buff + offset/8);

	offset=11904;
	connectib_logic_serdes_mapping_node_ini_pack(&(ptr_struct->logic_serdes_mapping_node_ini), ptr_buff + offset/8);

	offset=12448;
	connectib_pll_params_pack(&(ptr_struct->pll_params), ptr_buff + offset/8);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(12736, 128, i, 14336, 1);
	connectib_port_mlpn_db_pack(&(ptr_struct->mlpn_port[i]), ptr_buff + offset/8);
	}

}

void connectib_port_serdes_unpack(struct connectib_port_serdes *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_phy_hw_main_config_ip_unpack(&(ptr_struct->phy_hw_main_config_ip), ptr_buff + offset/8);

	offset=11904;
	connectib_logic_serdes_mapping_node_ini_unpack(&(ptr_struct->logic_serdes_mapping_node_ini), ptr_buff + offset/8);

	offset=12448;
	connectib_pll_params_unpack(&(ptr_struct->pll_params), ptr_buff + offset/8);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(12736, 128, i, 14336, 1);
	connectib_port_mlpn_db_unpack(&(ptr_struct->mlpn_port[i]), ptr_buff + offset/8);
	}

}

void connectib_port_serdes_print(const struct connectib_port_serdes *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_port_serdes ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_hw_main_config_ip:\n");
	connectib_phy_hw_main_config_ip_print(&(ptr_struct->phy_hw_main_config_ip), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "logic_serdes_mapping_node_ini:\n");
	connectib_logic_serdes_mapping_node_ini_print(&(ptr_struct->logic_serdes_mapping_node_ini), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_params:\n");
	connectib_pll_params_print(&(ptr_struct->pll_params), file, indent_level + 1);

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlpn_port_%03d:\n", i);
	connectib_port_mlpn_db_print(&(ptr_struct->mlpn_port[i]), file, indent_level + 1);
	}

}

int connectib_port_serdes_size(void){
	 return 1792;
}

void connectib_port_serdes_dump(const struct connectib_port_serdes *ptr_struct, FILE* file) {
	connectib_port_serdes_print(ptr_struct, file, 0);
}

void connectib_nv_config_boot_pack(const struct connectib_nv_config_boot *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_boot_global_pack(&(ptr_struct->global), ptr_buff + offset/8);

}

void connectib_nv_config_boot_unpack(struct connectib_nv_config_boot *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_boot_global_unpack(&(ptr_struct->global), ptr_buff + offset/8);

}

void connectib_nv_config_boot_print(const struct connectib_nv_config_boot *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_boot ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global:\n");
	connectib_nv_config_boot_global_print(&(ptr_struct->global), file, indent_level + 1);

}

int connectib_nv_config_boot_size(void){
	 return 64;
}

void connectib_nv_config_boot_dump(const struct connectib_nv_config_boot *ptr_struct, FILE* file) {
	connectib_nv_config_boot_print(ptr_struct, file, 0);
}

void connectib_pcie_power_management_pack(const struct connectib_pcie_power_management *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->delay_in_recovery_lock);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pcie_l1_en);

}

void connectib_pcie_power_management_unpack(struct connectib_pcie_power_management *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->delay_in_recovery_lock = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=15;
	ptr_struct->pcie_l1_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_pcie_power_management_print(const struct connectib_pcie_power_management *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_power_management ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "delay_in_recovery_lock : "UH_FMT"\n", ptr_struct->delay_in_recovery_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_l1_en           : "UH_FMT"\n", ptr_struct->pcie_l1_en);

}

int connectib_pcie_power_management_size(void){
	 return 4;
}

void connectib_pcie_power_management_dump(const struct connectib_pcie_power_management *ptr_struct, FILE* file) {
	connectib_pcie_power_management_print(ptr_struct, file, 0);
}

void connectib_pci_cfg_pack(const struct connectib_pci_cfg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pci_cfg_space_pack(&(ptr_struct->pci_cfg_space), ptr_buff + offset/8);

	offset=2048;
	connectib_pciex_ext_cfg_space_pack(&(ptr_struct->pciex_ext_cfg_space), ptr_buff + offset/8);

}

void connectib_pci_cfg_unpack(struct connectib_pci_cfg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_pci_cfg_space_unpack(&(ptr_struct->pci_cfg_space), ptr_buff + offset/8);

	offset=2048;
	connectib_pciex_ext_cfg_space_unpack(&(ptr_struct->pciex_ext_cfg_space), ptr_buff + offset/8);

}

void connectib_pci_cfg_print(const struct connectib_pci_cfg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pci_cfg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_cfg_space:\n");
	connectib_pci_cfg_space_print(&(ptr_struct->pci_cfg_space), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pciex_ext_cfg_space:\n");
	connectib_pciex_ext_cfg_space_print(&(ptr_struct->pciex_ext_cfg_space), file, indent_level + 1);

}

int connectib_pci_cfg_size(void){
	 return 512;
}

void connectib_pci_cfg_dump(const struct connectib_pci_cfg *ptr_struct, FILE* file) {
	connectib_pci_cfg_print(ptr_struct, file, 0);
}

void connectib_pcie_transaction_pack(const struct connectib_pcie_transaction *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->global_read_task_limit);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->function_level_reset_capability);

	offset=21;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aer_anf_by_cfg_type_1_en);

	offset=20;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aer_anf_by_bad_func_en);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->advisory_non_fatal_en);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->aer_cap_en);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ari_cap_en);

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sriov_cap_en);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vpd_cap_en);

	offset=14;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pci_crspace_access_en);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pci_vsec_cap_en);

	offset=12;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pcie_vsec_cap_en);

}

void connectib_pcie_transaction_unpack(struct connectib_pcie_transaction *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=23;
	ptr_struct->global_read_task_limit = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=22;
	ptr_struct->function_level_reset_capability = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=21;
	ptr_struct->aer_anf_by_cfg_type_1_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=20;
	ptr_struct->aer_anf_by_bad_func_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=19;
	ptr_struct->advisory_non_fatal_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=18;
	ptr_struct->aer_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=17;
	ptr_struct->ari_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=16;
	ptr_struct->sriov_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=15;
	ptr_struct->vpd_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=14;
	ptr_struct->pci_crspace_access_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->pci_vsec_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=12;
	ptr_struct->pcie_vsec_cap_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_pcie_transaction_print(const struct connectib_pcie_transaction *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_transaction ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "global_read_task_limit : "UH_FMT"\n", ptr_struct->global_read_task_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "function_level_reset_capability : "UH_FMT"\n", ptr_struct->function_level_reset_capability);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aer_anf_by_cfg_type_1_en : "UH_FMT"\n", ptr_struct->aer_anf_by_cfg_type_1_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aer_anf_by_bad_func_en : "UH_FMT"\n", ptr_struct->aer_anf_by_bad_func_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "advisory_non_fatal_en : "UH_FMT"\n", ptr_struct->advisory_non_fatal_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "aer_cap_en           : "UH_FMT"\n", ptr_struct->aer_cap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ari_cap_en           : "UH_FMT"\n", ptr_struct->ari_cap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sriov_cap_en         : "UH_FMT"\n", ptr_struct->sriov_cap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_cap_en           : "UH_FMT"\n", ptr_struct->vpd_cap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_crspace_access_en : "UH_FMT"\n", ptr_struct->pci_crspace_access_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pci_vsec_cap_en      : "UH_FMT"\n", ptr_struct->pci_vsec_cap_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_vsec_cap_en     : "UH_FMT"\n", ptr_struct->pcie_vsec_cap_en);

}

int connectib_pcie_transaction_size(void){
	 return 4;
}

void connectib_pcie_transaction_dump(const struct connectib_pcie_transaction *ptr_struct, FILE* file) {
	connectib_pcie_transaction_print(ptr_struct, file, 0);
}

void connectib_multi_function_pack(const struct connectib_multi_function *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->num_hosts);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->pf_msix_table_size);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vf_msix_table_size);

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->log_max_num_of_eqs);

	offset=90;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_pf_bar_megabytes);

	offset=89;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pf_bar_type);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->pf_bar_prefetchable);

	offset=82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->log2_vf_minibar_megabytes);

	offset=81;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_minibar_type);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vf_minibar_prefetchable);

	offset=76;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->cr_bar_func);

	offset=75;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cr_bar_type);

	offset=74;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cr_bar_en);

}

void connectib_multi_function_unpack(struct connectib_multi_function *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->num_hosts = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=8;
	ptr_struct->pf_msix_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->vf_msix_table_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=44;
	ptr_struct->log_max_num_of_eqs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=90;
	ptr_struct->log2_pf_bar_megabytes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=89;
	ptr_struct->pf_bar_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->pf_bar_prefetchable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=82;
	ptr_struct->log2_vf_minibar_megabytes = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=81;
	ptr_struct->vf_minibar_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->vf_minibar_prefetchable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=76;
	ptr_struct->cr_bar_func = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=75;
	ptr_struct->cr_bar_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=74;
	ptr_struct->cr_bar_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_multi_function_print(const struct connectib_multi_function *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_multi_function ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_hosts            : "UH_FMT"\n", ptr_struct->num_hosts);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_msix_table_size   : "UH_FMT"\n", ptr_struct->pf_msix_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_msix_table_size   : "UH_FMT"\n", ptr_struct->vf_msix_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_num_of_eqs   : "UH_FMT"\n", ptr_struct->log_max_num_of_eqs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_pf_bar_megabytes : "UH_FMT"\n", ptr_struct->log2_pf_bar_megabytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_bar_type          : "UH_FMT"\n", ptr_struct->pf_bar_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_bar_prefetchable  : "UH_FMT"\n", ptr_struct->pf_bar_prefetchable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_vf_minibar_megabytes : "UH_FMT"\n", ptr_struct->log2_vf_minibar_megabytes);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_minibar_type      : "UH_FMT"\n", ptr_struct->vf_minibar_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vf_minibar_prefetchable : "UH_FMT"\n", ptr_struct->vf_minibar_prefetchable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cr_bar_func          : "UH_FMT"\n", ptr_struct->cr_bar_func);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cr_bar_type          : "UH_FMT"\n", ptr_struct->cr_bar_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cr_bar_en            : "UH_FMT"\n", ptr_struct->cr_bar_en);

}

int connectib_multi_function_size(void){
	 return 12;
}

void connectib_multi_function_dump(const struct connectib_multi_function *ptr_struct, FILE* file) {
	connectib_multi_function_print(ptr_struct, file, 0);
}

void connectib_nv_config_main_pack(const struct connectib_nv_config_main *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_main_fw_data_pack(&(ptr_struct->fw_config), ptr_buff + offset/8);

}

void connectib_nv_config_main_unpack(struct connectib_nv_config_main *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_main_fw_data_unpack(&(ptr_struct->fw_config), ptr_buff + offset/8);

}

void connectib_nv_config_main_print(const struct connectib_nv_config_main *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_config_main ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_config:\n");
	connectib_nv_config_main_fw_data_print(&(ptr_struct->fw_config), file, indent_level + 1);

}

int connectib_nv_config_main_size(void){
	 return 256;
}

void connectib_nv_config_main_dump(const struct connectib_nv_config_main *ptr_struct, FILE* file) {
	connectib_nv_config_main_print(ptr_struct, file, 0);
}

void connectib_phy_fw_main_config_pack(const struct connectib_phy_fw_main_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_phy_fw_main_config_golan_pack(&(ptr_struct->phy_golan), ptr_buff + offset/8);

	offset=1856;
	connectib_phy_fw_main_config_ip_pack(&(ptr_struct->phy_ip), ptr_buff + offset/8);

}

void connectib_phy_fw_main_config_unpack(struct connectib_phy_fw_main_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_phy_fw_main_config_golan_unpack(&(ptr_struct->phy_golan), ptr_buff + offset/8);

	offset=1856;
	connectib_phy_fw_main_config_ip_unpack(&(ptr_struct->phy_ip), ptr_buff + offset/8);

}

void connectib_phy_fw_main_config_print(const struct connectib_phy_fw_main_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_fw_main_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_golan:\n");
	connectib_phy_fw_main_config_golan_print(&(ptr_struct->phy_golan), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_ip:\n");
	connectib_phy_fw_main_config_ip_print(&(ptr_struct->phy_ip), file, indent_level + 1);

}

int connectib_phy_fw_main_config_size(void){
	 return 688;
}

void connectib_phy_fw_main_config_dump(const struct connectib_phy_fw_main_config *ptr_struct, FILE* file) {
	connectib_phy_fw_main_config_print(ptr_struct, file, 0);
}

void connectib_host_management_pack(const struct connectib_host_management *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=128;
	connectib_ocsd_config_pack(&(ptr_struct->ocsd_config), ptr_buff + offset/8);

	offset=288;
	connectib_ibm_thermal_config_pack(&(ptr_struct->ibm_thermal_config), ptr_buff + offset/8);

}

void connectib_host_management_unpack(struct connectib_host_management *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=128;
	connectib_ocsd_config_unpack(&(ptr_struct->ocsd_config), ptr_buff + offset/8);

	offset=288;
	connectib_ibm_thermal_config_unpack(&(ptr_struct->ibm_thermal_config), ptr_buff + offset/8);

}

void connectib_host_management_print(const struct connectib_host_management *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_host_management ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ocsd_config:\n");
	connectib_ocsd_config_print(&(ptr_struct->ocsd_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ibm_thermal_config:\n");
	connectib_ibm_thermal_config_print(&(ptr_struct->ibm_thermal_config), file, indent_level + 1);

}

int connectib_host_management_size(void){
	 return 76;
}

void connectib_host_management_dump(const struct connectib_host_management *ptr_struct, FILE* file) {
	connectib_host_management_print(ptr_struct, file, 0);
}

void connectib_management_pack(const struct connectib_management *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_node_info_pack(&(ptr_struct->node_info), ptr_buff + offset/8);

	offset=512;
	connectib_ib_port_info_ini_pack(&(ptr_struct->port_info), ptr_buff + offset/8);

	offset=1567;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eeprom_read_disable_p1);

	offset=1566;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->eeprom_read_disable_p2);

	offset=1565;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fw_stamping_override);

	offset=1564;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cable_speed_override);

	offset=1568;
	connectib_extended_port_info_ini_pack(&(ptr_struct->extended_port_info), ptr_buff + offset/8);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(1624, 8, i, 2048, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->valid_i2c_address[i]);
	}

}

void connectib_management_unpack(struct connectib_management *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_node_info_unpack(&(ptr_struct->node_info), ptr_buff + offset/8);

	offset=512;
	connectib_ib_port_info_ini_unpack(&(ptr_struct->port_info), ptr_buff + offset/8);

	offset=1567;
	ptr_struct->eeprom_read_disable_p1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1566;
	ptr_struct->eeprom_read_disable_p2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1565;
	ptr_struct->fw_stamping_override = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1564;
	ptr_struct->cable_speed_override = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=1568;
	connectib_extended_port_info_ini_unpack(&(ptr_struct->extended_port_info), ptr_buff + offset/8);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(1624, 8, i, 2048, 1);
	ptr_struct->valid_i2c_address[i] = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

}

void connectib_management_print(const struct connectib_management *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_management ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_info:\n");
	connectib_node_info_print(&(ptr_struct->node_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_info:\n");
	connectib_ib_port_info_ini_print(&(ptr_struct->port_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eeprom_read_disable_p1 : "UH_FMT"\n", ptr_struct->eeprom_read_disable_p1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eeprom_read_disable_p2 : "UH_FMT"\n", ptr_struct->eeprom_read_disable_p2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_stamping_override : "UH_FMT"\n", ptr_struct->fw_stamping_override);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_speed_override : "UH_FMT"\n", ptr_struct->cable_speed_override);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "extended_port_info:\n");
	connectib_extended_port_info_ini_print(&(ptr_struct->extended_port_info), file, indent_level + 1);

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "valid_i2c_address_%03d : "UH_FMT"\n", i, ptr_struct->valid_i2c_address[i]);
	}

}

int connectib_management_size(void){
	 return 256;
}

void connectib_management_dump(const struct connectib_management *ptr_struct, FILE* file) {
	connectib_management_print(ptr_struct, file, 0);
}

void connectib_customization_pack(const struct connectib_customization *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->active_amp_range_p1);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->active_amp_range_p2);

}

void connectib_customization_unpack(struct connectib_customization *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->active_amp_range_p1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=24;
	ptr_struct->active_amp_range_p2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_customization_print(const struct connectib_customization *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_customization ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_amp_range_p1  : "UH_FMT"\n", ptr_struct->active_amp_range_p1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "active_amp_range_p2  : "UH_FMT"\n", ptr_struct->active_amp_range_p2);

}

int connectib_customization_size(void){
	 return 64;
}

void connectib_customization_dump(const struct connectib_customization *ptr_struct, FILE* file) {
	connectib_customization_print(ptr_struct, file, 0);
}

void connectib_leds_blink_patterns_pack(const struct connectib_leds_blink_patterns *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_led_port_blink_pattern_pack(&(ptr_struct->no_phy_no_log_link), ptr_buff + offset/8);

	offset=64;
	connectib_led_port_blink_pattern_pack(&(ptr_struct->phy_no_log_link), ptr_buff + offset/8);

	offset=128;
	connectib_led_port_blink_pattern_pack(&(ptr_struct->phy_log_link), ptr_buff + offset/8);

	offset=192;
	connectib_led_port_blink_pattern_pack(&(ptr_struct->phy_log_link_traffic), ptr_buff + offset/8);

	offset=256;
	connectib_led_port_blink_pattern_pack(&(ptr_struct->error), ptr_buff + offset/8);

	for (i=0; i < 15; i++) {
	offset=adb2c_calc_array_field_address(320, 64, i, 1280, 1);
	connectib_led_port_blink_pattern_pack(&(ptr_struct->reserved_pattern[i]), ptr_buff + offset/8);
	}

}

void connectib_leds_blink_patterns_unpack(struct connectib_leds_blink_patterns *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->no_phy_no_log_link), ptr_buff + offset/8);

	offset=64;
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->phy_no_log_link), ptr_buff + offset/8);

	offset=128;
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->phy_log_link), ptr_buff + offset/8);

	offset=192;
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->phy_log_link_traffic), ptr_buff + offset/8);

	offset=256;
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->error), ptr_buff + offset/8);

	for (i=0; i < 15; i++) {
	offset=adb2c_calc_array_field_address(320, 64, i, 1280, 1);
	connectib_led_port_blink_pattern_unpack(&(ptr_struct->reserved_pattern[i]), ptr_buff + offset/8);
	}

}

void connectib_leds_blink_patterns_print(const struct connectib_leds_blink_patterns *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_leds_blink_patterns ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_phy_no_log_link:\n");
	connectib_led_port_blink_pattern_print(&(ptr_struct->no_phy_no_log_link), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_no_log_link:\n");
	connectib_led_port_blink_pattern_print(&(ptr_struct->phy_no_log_link), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_log_link:\n");
	connectib_led_port_blink_pattern_print(&(ptr_struct->phy_log_link), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_log_link_traffic:\n");
	connectib_led_port_blink_pattern_print(&(ptr_struct->phy_log_link_traffic), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "error:\n");
	connectib_led_port_blink_pattern_print(&(ptr_struct->error), file, indent_level + 1);

	for (i=0; i < 15; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reserved_pattern_%03d:\n", i);
	connectib_led_port_blink_pattern_print(&(ptr_struct->reserved_pattern[i]), file, indent_level + 1);
	}

}

int connectib_leds_blink_patterns_size(void){
	 return 160;
}

void connectib_leds_blink_patterns_dump(const struct connectib_leds_blink_patterns *ptr_struct, FILE* file) {
	connectib_leds_blink_patterns_print(ptr_struct, file, 0);
}

void connectib_static_config_pack(const struct connectib_static_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->dwrr_en);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ifarm_en);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ffser_en);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->prio_g_0_ix_mask_no_ifarm);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->prio_g_1_ix_mask_no_ifarm);

}

void connectib_static_config_unpack(struct connectib_static_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->dwrr_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->ifarm_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=23;
	ptr_struct->ffser_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=56;
	ptr_struct->prio_g_0_ix_mask_no_ifarm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->prio_g_1_ix_mask_no_ifarm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_static_config_print(const struct connectib_static_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_static_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dwrr_en              : "UH_FMT"\n", ptr_struct->dwrr_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ifarm_en             : "UH_FMT"\n", ptr_struct->ifarm_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ffser_en             : "UH_FMT"\n", ptr_struct->ffser_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prio_g_0_ix_mask_no_ifarm : "UH_FMT"\n", ptr_struct->prio_g_0_ix_mask_no_ifarm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "prio_g_1_ix_mask_no_ifarm : "UH_FMT"\n", ptr_struct->prio_g_1_ix_mask_no_ifarm);

}

int connectib_static_config_size(void){
	 return 16;
}

void connectib_static_config_dump(const struct connectib_static_config *ptr_struct, FILE* file) {
	connectib_static_config_print(ptr_struct, file, 0);
}

void connectib_guids_pack(const struct connectib_guids *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 512, 1);
	connectib_uid_entry_pack(&(ptr_struct->guids[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(256, 128, i, 512, 1);
	connectib_uid_entry_pack(&(ptr_struct->macs[i]), ptr_buff + offset/8);
	}

}

void connectib_guids_unpack(struct connectib_guids *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 512, 1);
	connectib_uid_entry_unpack(&(ptr_struct->guids[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(256, 128, i, 512, 1);
	connectib_uid_entry_unpack(&(ptr_struct->macs[i]), ptr_buff + offset/8);
	}

}

void connectib_guids_print(const struct connectib_guids *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_guids ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guids_%03d:\n", i);
	connectib_uid_entry_print(&(ptr_struct->guids[i]), file, indent_level + 1);
	}

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "macs_%03d:\n", i);
	connectib_uid_entry_print(&(ptr_struct->macs[i]), file, indent_level + 1);
	}

}

int connectib_guids_size(void){
	 return 64;
}

void connectib_guids_dump(const struct connectib_guids *ptr_struct, FILE* file) {
	connectib_guids_print(ptr_struct, file, 0);
}

void connectib_module_versions_pack(const struct connectib_module_versions *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_module_version_pack(&(ptr_struct->core), ptr_buff + offset/8);

	offset=32;
	connectib_module_version_pack(&(ptr_struct->phy), ptr_buff + offset/8);

	offset=64;
	connectib_module_version_pack(&(ptr_struct->kernel), ptr_buff + offset/8);

	offset=96;
	connectib_module_version_pack(&(ptr_struct->iron_image), ptr_buff + offset/8);

	offset=128;
	connectib_module_version_pack(&(ptr_struct->host_management), ptr_buff + offset/8);

	offset=160;
	connectib_module_version_pack(&(ptr_struct->mad), ptr_buff + offset/8);

}

void connectib_module_versions_unpack(struct connectib_module_versions *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_module_version_unpack(&(ptr_struct->core), ptr_buff + offset/8);

	offset=32;
	connectib_module_version_unpack(&(ptr_struct->phy), ptr_buff + offset/8);

	offset=64;
	connectib_module_version_unpack(&(ptr_struct->kernel), ptr_buff + offset/8);

	offset=96;
	connectib_module_version_unpack(&(ptr_struct->iron_image), ptr_buff + offset/8);

	offset=128;
	connectib_module_version_unpack(&(ptr_struct->host_management), ptr_buff + offset/8);

	offset=160;
	connectib_module_version_unpack(&(ptr_struct->mad), ptr_buff + offset/8);

}

void connectib_module_versions_print(const struct connectib_module_versions *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_module_versions ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core:\n");
	connectib_module_version_print(&(ptr_struct->core), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy:\n");
	connectib_module_version_print(&(ptr_struct->phy), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "kernel:\n");
	connectib_module_version_print(&(ptr_struct->kernel), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iron_image:\n");
	connectib_module_version_print(&(ptr_struct->iron_image), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host_management:\n");
	connectib_module_version_print(&(ptr_struct->host_management), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mad:\n");
	connectib_module_version_print(&(ptr_struct->mad), file, indent_level + 1);

}

int connectib_module_versions_size(void){
	 return 64;
}

void connectib_module_versions_dump(const struct connectib_module_versions *ptr_struct, FILE* file) {
	connectib_module_versions_print(ptr_struct, file, 0);
}

void connectib_image_size_pack(const struct connectib_image_size *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->log_step);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->max_size);

}

void connectib_image_size_unpack(struct connectib_image_size *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->log_step = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->max_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_image_size_print(const struct connectib_image_size *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_image_size ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_step             : "UH_FMT"\n", ptr_struct->log_step);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "max_size             : "U32H_FMT"\n", ptr_struct->max_size);

}

int connectib_image_size_size(void){
	 return 8;
}

void connectib_image_size_dump(const struct connectib_image_size *ptr_struct, FILE* file) {
	connectib_image_size_print(ptr_struct, file, 0);
}

void connectib_TRIPPLE_VERSION_pack(const struct connectib_TRIPPLE_VERSION *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MAJOR);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->SUBMINOR);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->MINOR);

}

void connectib_TRIPPLE_VERSION_unpack(struct connectib_TRIPPLE_VERSION *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->MAJOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	ptr_struct->SUBMINOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->MINOR = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_TRIPPLE_VERSION_print(const struct connectib_TRIPPLE_VERSION *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_TRIPPLE_VERSION ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MAJOR                : "UH_FMT"\n", ptr_struct->MAJOR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "SUBMINOR             : "UH_FMT"\n", ptr_struct->SUBMINOR);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "MINOR                : "UH_FMT"\n", ptr_struct->MINOR);

}

int connectib_TRIPPLE_VERSION_size(void){
	 return 8;
}

void connectib_TRIPPLE_VERSION_dump(const struct connectib_TRIPPLE_VERSION *ptr_struct, FILE* file) {
	connectib_TRIPPLE_VERSION_print(ptr_struct, file, 0);
}

void connectib_operation_key_pack(const struct connectib_operation_key *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->key_modifier);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->key);

}

void connectib_operation_key_unpack(struct connectib_operation_key *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->key_modifier = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->key = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_operation_key_print(const struct connectib_operation_key *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_operation_key ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key_modifier         : "UH_FMT"\n", ptr_struct->key_modifier);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key                  : "U64H_FMT"\n", ptr_struct->key);

}

int connectib_operation_key_size(void){
	 return 16;
}

void connectib_operation_key_dump(const struct connectib_operation_key *ptr_struct, FILE* file) {
	connectib_operation_key_print(ptr_struct, file, 0);
}

void connectib_toc_data_pack(const struct connectib_toc_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->address);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->size);

}

void connectib_toc_data_unpack(struct connectib_toc_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->address = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_toc_data_print(const struct connectib_toc_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_toc_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address              : "U32H_FMT"\n", ptr_struct->address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "U32H_FMT"\n", ptr_struct->size);

}

int connectib_toc_data_size(void){
	 return 8;
}

void connectib_toc_data_dump(const struct connectib_toc_data *ptr_struct, FILE* file) {
	connectib_toc_data_print(ptr_struct, file, 0);
}

void connectib_rst_api_ver_pack(const struct connectib_rst_api_ver *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 1024, 1);
	connectib_reset_level_info_pack(&(ptr_struct->reset[i]), ptr_buff + offset/8);
	}

}

void connectib_rst_api_ver_unpack(struct connectib_rst_api_ver *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 128, i, 1024, 1);
	connectib_reset_level_info_unpack(&(ptr_struct->reset[i]), ptr_buff + offset/8);
	}

}

void connectib_rst_api_ver_print(const struct connectib_rst_api_ver *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_rst_api_ver ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_%03d:\n", i);
	connectib_reset_level_info_print(&(ptr_struct->reset[i]), file, indent_level + 1);
	}

}

int connectib_rst_api_ver_size(void){
	 return 128;
}

void connectib_rst_api_ver_dump(const struct connectib_rst_api_ver *ptr_struct, FILE* file) {
	connectib_rst_api_ver_print(ptr_struct, file, 0);
}

void connectib_reset_capabilities_pack(const struct connectib_reset_capabilities *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->reset_ver_en);

}

void connectib_reset_capabilities_unpack(struct connectib_reset_capabilities *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->reset_ver_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_reset_capabilities_print(const struct connectib_reset_capabilities *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reset_capabilities ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_ver_en         : "UH_FMT"\n", ptr_struct->reset_ver_en);

}

int connectib_reset_capabilities_size(void){
	 return 4;
}

void connectib_reset_capabilities_dump(const struct connectib_reset_capabilities *ptr_struct, FILE* file) {
	connectib_reset_capabilities_print(ptr_struct, file, 0);
}

void connectib_icmd_get_pf_ctx_pack(const struct connectib_icmd_get_pf_ctx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->portid);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vport_num);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->pf_gvmi);

	offset=256;
	connectib_vport_shadow_pack(&(ptr_struct->vport_shadow), ptr_buff + offset/8);

	offset=512;
	connectib_vport_info_pack(&(ptr_struct->vport_info), ptr_buff + offset/8);

}

void connectib_icmd_get_pf_ctx_unpack(struct connectib_icmd_get_pf_ctx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->portid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->vport_num = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=48;
	ptr_struct->pf_gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=256;
	connectib_vport_shadow_unpack(&(ptr_struct->vport_shadow), ptr_buff + offset/8);

	offset=512;
	connectib_vport_info_unpack(&(ptr_struct->vport_info), ptr_buff + offset/8);

}

void connectib_icmd_get_pf_ctx_print(const struct connectib_icmd_get_pf_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_pf_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "portid               : "UH_FMT"\n", ptr_struct->portid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_num            : "UH_FMT"\n", ptr_struct->vport_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_gvmi              : "UH_FMT"\n", ptr_struct->pf_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_shadow:\n");
	connectib_vport_shadow_print(&(ptr_struct->vport_shadow), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_info:\n");
	connectib_vport_info_print(&(ptr_struct->vport_info), file, indent_level + 1);

}

int connectib_icmd_get_pf_ctx_size(void){
	 return 96;
}

void connectib_icmd_get_pf_ctx_dump(const struct connectib_icmd_get_pf_ctx *ptr_struct, FILE* file) {
	connectib_icmd_get_pf_ctx_print(ptr_struct, file, 0);
}

void connectib_icmd_gen_assert_pack(const struct connectib_icmd_gen_assert *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->value);

}

void connectib_icmd_gen_assert_unpack(struct connectib_icmd_gen_assert *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_gen_assert_print(const struct connectib_icmd_gen_assert *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_gen_assert ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "value                : "U32H_FMT"\n", ptr_struct->value);

}

int connectib_icmd_gen_assert_size(void){
	 return 4;
}

void connectib_icmd_gen_assert_dump(const struct connectib_icmd_gen_assert *ptr_struct, FILE* file) {
	connectib_icmd_gen_assert_print(ptr_struct, file, 0);
}

void connectib_icmd_general_fault_injector_pack(const struct connectib_icmd_general_fault_injector *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->type);

	offset=32;
	connectib_general_fault_injector_pair_pack(&(ptr_struct->config), ptr_buff + offset/8);

}

void connectib_icmd_general_fault_injector_unpack(struct connectib_icmd_general_fault_injector *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	connectib_general_fault_injector_pair_unpack(&(ptr_struct->config), ptr_buff + offset/8);

}

void connectib_icmd_general_fault_injector_print(const struct connectib_icmd_general_fault_injector *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_general_fault_injector ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "U32H_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config:\n");
	connectib_general_fault_injector_pair_print(&(ptr_struct->config), file, indent_level + 1);

}

int connectib_icmd_general_fault_injector_size(void){
	 return 8;
}

void connectib_icmd_general_fault_injector_dump(const struct connectib_icmd_general_fault_injector *ptr_struct, FILE* file) {
	connectib_icmd_general_fault_injector_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_pvlc_pack(const struct connectib_icmd_access_register_pvlc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_pvlc_reg_pack(&(ptr_struct->pvlc), ptr_buff + offset/8);

}

void connectib_icmd_access_register_pvlc_unpack(struct connectib_icmd_access_register_pvlc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_pvlc_reg_unpack(&(ptr_struct->pvlc), ptr_buff + offset/8);

}

void connectib_icmd_access_register_pvlc_print(const struct connectib_icmd_access_register_pvlc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_pvlc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pvlc:\n");
	connectib_pvlc_reg_print(&(ptr_struct->pvlc), file, indent_level + 1);

}

int connectib_icmd_access_register_pvlc_size(void){
	 return 20;
}

void connectib_icmd_access_register_pvlc_dump(const struct connectib_icmd_access_register_pvlc *ptr_struct, FILE* file) {
	connectib_icmd_access_register_pvlc_print(ptr_struct, file, 0);
}

void connectib_icmd_read_ste_pack(const struct connectib_icmd_read_ste *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_ste_pack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->index);

	offset=560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=544;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->locked_in_icmc);

}

void connectib_icmd_read_ste_unpack(struct connectib_icmd_read_ste *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_ste_unpack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=512;
	ptr_struct->index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=560;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=544;
	ptr_struct->locked_in_icmc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_read_ste_print(const struct connectib_icmd_read_ste *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_ste ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data:\n");
	connectib_hw_ste_print(&(ptr_struct->data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "index                : "U32H_FMT"\n", ptr_struct->index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "locked_in_icmc       : "UH_FMT"\n", ptr_struct->locked_in_icmc);

}

int connectib_icmd_read_ste_size(void){
	 return 80;
}

void connectib_icmd_read_ste_dump(const struct connectib_icmd_read_ste *ptr_struct, FILE* file) {
	connectib_icmd_read_ste_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_resources_list_pack(const union connectib_icmd_get_ste_resources_list *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_ste_resources_list_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ste_resources_list_unpack(union connectib_icmd_get_ste_resources_list *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_ste_resources_list_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ste_resources_list_print(const union connectib_icmd_get_ste_resources_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_resources_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_ste_resources_list_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_ste_resources_list_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_ste_resources_list_size(void){
	 return 256;
}

void connectib_icmd_get_ste_resources_list_dump(const union connectib_icmd_get_ste_resources_list *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_resources_list_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ste_open_resources_pack(const union connectib_icmd_get_ste_open_resources *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_ste_open_resources_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ste_open_resources_unpack(union connectib_icmd_get_ste_open_resources *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_ste_open_resources_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ste_open_resources_print(const union connectib_icmd_get_ste_open_resources *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ste_open_resources ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_ste_open_resources_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_ste_open_resources_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_ste_open_resources_size(void){
	 return 768;
}

void connectib_icmd_get_ste_open_resources_dump(const union connectib_icmd_get_ste_open_resources *ptr_struct, FILE* file) {
	connectib_icmd_get_ste_open_resources_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_pack(const union connectib_icmd_get_fte *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_fte_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fte_unpack(union connectib_icmd_get_fte *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_fte_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fte_print(const union connectib_icmd_get_fte *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_fte_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_fte_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_fte_size(void){
	 return 768;
}

void connectib_icmd_get_fte_dump(const union connectib_icmd_get_fte *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fte_list_pack(const union connectib_icmd_get_fte_list *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_fte_list_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fte_list_unpack(union connectib_icmd_get_fte_list *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_fte_list_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fte_list_print(const union connectib_icmd_get_fte_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fte_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_fte_list_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_fte_list_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_fte_list_size(void){
	 return 16;
}

void connectib_icmd_get_fte_list_dump(const union connectib_icmd_get_fte_list *ptr_struct, FILE* file) {
	connectib_icmd_get_fte_list_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_pack(const union connectib_icmd_get_fg *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_fg_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fg_unpack(union connectib_icmd_get_fg *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_fg_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fg_print(const union connectib_icmd_get_fg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_fg_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_fg_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_fg_size(void){
	 return 256;
}

void connectib_icmd_get_fg_dump(const union connectib_icmd_get_fg *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fg_list_pack(const union connectib_icmd_get_fg_list *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_fg_list_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fg_list_unpack(union connectib_icmd_get_fg_list *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_fg_list_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_fg_list_print(const union connectib_icmd_get_fg_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fg_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_fg_list_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_fg_list_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_fg_list_size(void){
	 return 16;
}

void connectib_icmd_get_fg_list_dump(const union connectib_icmd_get_fg_list *ptr_struct, FILE* file) {
	connectib_icmd_get_fg_list_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_info_pack(const union connectib_icmd_get_ft_info *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_ft_info_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ft_info_unpack(union connectib_icmd_get_ft_info *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_ft_info_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ft_info_print(const union connectib_icmd_get_ft_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_ft_info_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_ft_info_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_ft_info_size(void){
	 return 16;
}

void connectib_icmd_get_ft_info_dump(const union connectib_icmd_get_ft_info *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_info_print(ptr_struct, file, 0);
}

void connectib_icmd_get_ft_list_pack(const union connectib_icmd_get_ft_list *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_ft_list_out_pack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ft_list_unpack(union connectib_icmd_get_ft_list *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_ft_list_out_unpack(&(ptr_struct->out), ptr_buff);
}

void connectib_icmd_get_ft_list_print(const union connectib_icmd_get_ft_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_ft_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in:\n");
	connectib_icmd_get_ft_list_in_print(&(ptr_struct->in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "out:\n");
	connectib_icmd_get_ft_list_out_print(&(ptr_struct->out), file, indent_level + 1);

}

int connectib_icmd_get_ft_list_size(void){
	 return 16;
}

void connectib_icmd_get_ft_list_dump(const union connectib_icmd_get_ft_list *ptr_struct, FILE* file) {
	connectib_icmd_get_ft_list_print(ptr_struct, file, 0);
}

void connectib_icmd_set_get_port_cntr_pack(const struct connectib_icmd_set_get_port_cntr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->data);

	offset=95;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_0_1);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->set_get_);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->cntr_ix);

}

void connectib_icmd_set_get_port_cntr_unpack(struct connectib_icmd_set_get_port_cntr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->data = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=95;
	ptr_struct->port_0_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->set_get_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->cntr_ix = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_set_get_port_cntr_print(const struct connectib_icmd_set_get_port_cntr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_set_get_port_cntr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data                 : "U64H_FMT"\n", ptr_struct->data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_0_1             : "UH_FMT"\n", ptr_struct->port_0_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_get_             : "UH_FMT"\n", ptr_struct->set_get_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cntr_ix              : "UH_FMT"\n", ptr_struct->cntr_ix);

}

int connectib_icmd_set_get_port_cntr_size(void){
	 return 24;
}

void connectib_icmd_set_get_port_cntr_dump(const struct connectib_icmd_set_get_port_cntr *ptr_struct, FILE* file) {
	connectib_icmd_set_get_port_cntr_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_ppcnt_pack(const struct connectib_icmd_access_register_ppcnt *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_ppcnt_reg_pack(&(ptr_struct->ppcnt), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ppcnt_unpack(struct connectib_icmd_access_register_ppcnt *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_ppcnt_reg_unpack(&(ptr_struct->ppcnt), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ppcnt_print(const struct connectib_icmd_access_register_ppcnt *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_ppcnt ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppcnt:\n");
	connectib_ppcnt_reg_print(&(ptr_struct->ppcnt), file, indent_level + 1);

}

int connectib_icmd_access_register_ppcnt_size(void){
	 return 268;
}

void connectib_icmd_access_register_ppcnt_dump(const struct connectib_icmd_access_register_ppcnt *ptr_struct, FILE* file) {
	connectib_icmd_access_register_ppcnt_print(ptr_struct, file, 0);
}

void connectib_icmd_access_reg_ptys_pack(const struct connectib_icmd_access_reg_ptys *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_ptys_reg_pack(&(ptr_struct->ptys), ptr_buff + offset/8);

}

void connectib_icmd_access_reg_ptys_unpack(struct connectib_icmd_access_reg_ptys *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_ptys_reg_unpack(&(ptr_struct->ptys), ptr_buff + offset/8);

}

void connectib_icmd_access_reg_ptys_print(const struct connectib_icmd_access_reg_ptys *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_reg_ptys ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptys:\n");
	connectib_ptys_reg_print(&(ptr_struct->ptys), file, indent_level + 1);

}

int connectib_icmd_access_reg_ptys_size(void){
	 return 68;
}

void connectib_icmd_access_reg_ptys_dump(const struct connectib_icmd_access_reg_ptys *ptr_struct, FILE* file) {
	connectib_icmd_access_reg_ptys_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_pmtu_pack(const struct connectib_icmd_access_register_pmtu *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_pmtu_reg_pack(&(ptr_struct->pmtu), ptr_buff + offset/8);

}

void connectib_icmd_access_register_pmtu_unpack(struct connectib_icmd_access_register_pmtu *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_pmtu_reg_unpack(&(ptr_struct->pmtu), ptr_buff + offset/8);

}

void connectib_icmd_access_register_pmtu_print(const struct connectib_icmd_access_register_pmtu *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_pmtu ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pmtu:\n");
	connectib_pmtu_reg_print(&(ptr_struct->pmtu), file, indent_level + 1);

}

int connectib_icmd_access_register_pmtu_size(void){
	 return 20;
}

void connectib_icmd_access_register_pmtu_dump(const struct connectib_icmd_access_register_pmtu *ptr_struct, FILE* file) {
	connectib_icmd_access_register_pmtu_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_ppamp_pack(const struct connectib_icmd_access_register_ppamp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_pamp_reg_pack(&(ptr_struct->ppamp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ppamp_unpack(struct connectib_icmd_access_register_ppamp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_pamp_reg_unpack(&(ptr_struct->ppamp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ppamp_print(const struct connectib_icmd_access_register_ppamp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_ppamp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ppamp:\n");
	connectib_pamp_reg_print(&(ptr_struct->ppamp), file, indent_level + 1);

}

int connectib_icmd_access_register_ppamp_size(void){
	 return 48;
}

void connectib_icmd_access_register_ppamp_dump(const struct connectib_icmd_access_register_ppamp *ptr_struct, FILE* file) {
	connectib_icmd_access_register_ppamp_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_ptas_pack(const struct connectib_icmd_access_register_ptas *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_ptas_reg_pack(&(ptr_struct->ptas), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ptas_unpack(struct connectib_icmd_access_register_ptas *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_ptas_reg_unpack(&(ptr_struct->ptas), ptr_buff + offset/8);

}

void connectib_icmd_access_register_ptas_print(const struct connectib_icmd_access_register_ptas *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_ptas ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ptas:\n");
	connectib_ptas_reg_print(&(ptr_struct->ptas), file, indent_level + 1);

}

int connectib_icmd_access_register_ptas_size(void){
	 return 48;
}

void connectib_icmd_access_register_ptas_dump(const struct connectib_icmd_access_register_ptas *ptr_struct, FILE* file) {
	connectib_icmd_access_register_ptas_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_slrg_pack(const struct connectib_icmd_access_register_slrg *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_slrg_reg_pack(&(ptr_struct->slrg), ptr_buff + offset/8);

}

void connectib_icmd_access_register_slrg_unpack(struct connectib_icmd_access_register_slrg *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_slrg_reg_unpack(&(ptr_struct->slrg), ptr_buff + offset/8);

}

void connectib_icmd_access_register_slrg_print(const struct connectib_icmd_access_register_slrg *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_slrg ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrg:\n");
	connectib_slrg_reg_print(&(ptr_struct->slrg), file, indent_level + 1);

}

int connectib_icmd_access_register_slrg_size(void){
	 return 44;
}

void connectib_icmd_access_register_slrg_dump(const struct connectib_icmd_access_register_slrg *ptr_struct, FILE* file) {
	connectib_icmd_access_register_slrg_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_sltp_pack(const struct connectib_icmd_access_register_sltp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_sltp_reg_pack(&(ptr_struct->sltp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_sltp_unpack(struct connectib_icmd_access_register_sltp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_sltp_reg_unpack(&(ptr_struct->sltp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_sltp_print(const struct connectib_icmd_access_register_sltp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_sltp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sltp:\n");
	connectib_sltp_reg_print(&(ptr_struct->sltp), file, indent_level + 1);

}

int connectib_icmd_access_register_sltp_size(void){
	 return 24;
}

void connectib_icmd_access_register_sltp_dump(const struct connectib_icmd_access_register_sltp *ptr_struct, FILE* file) {
	connectib_icmd_access_register_sltp_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_slrp_pack(const struct connectib_icmd_access_register_slrp *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_slrp_reg_pack(&(ptr_struct->slrp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_slrp_unpack(struct connectib_icmd_access_register_slrp *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_slrp_reg_unpack(&(ptr_struct->slrp), ptr_buff + offset/8);

}

void connectib_icmd_access_register_slrp_print(const struct connectib_icmd_access_register_slrp *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_slrp ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slrp:\n");
	connectib_slrp_reg_print(&(ptr_struct->slrp), file, indent_level + 1);

}

int connectib_icmd_access_register_slrp_size(void){
	 return 48;
}

void connectib_icmd_access_register_slrp_dump(const struct connectib_icmd_access_register_slrp *ptr_struct, FILE* file) {
	connectib_icmd_access_register_slrp_print(ptr_struct, file, 0);
}

void connectib_icmd_access_register_paos_pack(const struct connectib_icmd_access_register_paos *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw);

	offset=32;
	connectib_paos_reg_pack(&(ptr_struct->paos), ptr_buff + offset/8);

}

void connectib_icmd_access_register_paos_unpack(struct connectib_icmd_access_register_paos *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->rw = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_paos_reg_unpack(&(ptr_struct->paos), ptr_buff + offset/8);

}

void connectib_icmd_access_register_paos_print(const struct connectib_icmd_access_register_paos *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_register_paos ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw                   : "UH_FMT"\n", ptr_struct->rw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "paos:\n");
	connectib_paos_reg_print(&(ptr_struct->paos), file, indent_level + 1);

}

int connectib_icmd_access_register_paos_size(void){
	 return 20;
}

void connectib_icmd_access_register_paos_dump(const struct connectib_icmd_access_register_paos *ptr_struct, FILE* file) {
	connectib_icmd_access_register_paos_print(ptr_struct, file, 0);
}

void connectib_icmd_get_gvmi_via_vsec_pack(const struct connectib_icmd_get_gvmi_via_vsec *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

}

void connectib_icmd_get_gvmi_via_vsec_unpack(struct connectib_icmd_get_gvmi_via_vsec *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_gvmi_via_vsec_print(const struct connectib_icmd_get_gvmi_via_vsec *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_gvmi_via_vsec ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

}

int connectib_icmd_get_gvmi_via_vsec_size(void){
	 return 16;
}

void connectib_icmd_get_gvmi_via_vsec_dump(const struct connectib_icmd_get_gvmi_via_vsec *ptr_struct, FILE* file) {
	connectib_icmd_get_gvmi_via_vsec_print(ptr_struct, file, 0);
}

void connectib_icmd_steering_table_info_pack(const struct connectib_icmd_steering_table_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_steering_table_info_pack(&(ptr_struct->table_info), ptr_buff + offset/8);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->steering_table);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->portid);

}

void connectib_icmd_steering_table_info_unpack(struct connectib_icmd_steering_table_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_steering_table_info_unpack(&(ptr_struct->table_info), ptr_buff + offset/8);

	offset=264;
	ptr_struct->steering_table = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=256;
	ptr_struct->portid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_steering_table_info_print(const struct connectib_icmd_steering_table_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_steering_table_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_info:\n");
	connectib_steering_table_info_print(&(ptr_struct->table_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "steering_table       : "UH_FMT"\n", ptr_struct->steering_table);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "portid               : "UH_FMT"\n", ptr_struct->portid);

}

int connectib_icmd_steering_table_info_size(void){
	 return 48;
}

void connectib_icmd_steering_table_info_dump(const struct connectib_icmd_steering_table_info *ptr_struct, FILE* file) {
	connectib_icmd_steering_table_info_print(ptr_struct, file, 0);
}

void connectib_icmd_access_steering_root_pack(const struct connectib_icmd_access_steering_root *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_ste_pack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=543;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_rx_);

	offset=542;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->portid);

	offset=541;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mc_uc_);

	offset=540;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->special_root);

	offset=512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

}

void connectib_icmd_access_steering_root_unpack(struct connectib_icmd_access_steering_root *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_hw_ste_unpack(&(ptr_struct->data), ptr_buff + offset/8);

	offset=543;
	ptr_struct->sx_rx_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=542;
	ptr_struct->portid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=541;
	ptr_struct->mc_uc_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=540;
	ptr_struct->special_root = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=512;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_access_steering_root_print(const struct connectib_icmd_access_steering_root *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_steering_root ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data:\n");
	connectib_hw_ste_print(&(ptr_struct->data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_rx_               : "UH_FMT"\n", ptr_struct->sx_rx_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "portid               : "UH_FMT"\n", ptr_struct->portid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mc_uc_               : "UH_FMT"\n", ptr_struct->mc_uc_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "special_root         : "UH_FMT"\n", ptr_struct->special_root);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

}

int connectib_icmd_access_steering_root_size(void){
	 return 68;
}

void connectib_icmd_access_steering_root_dump(const struct connectib_icmd_access_steering_root *ptr_struct, FILE* file) {
	connectib_icmd_access_steering_root_print(ptr_struct, file, 0);
}

void connectib_icmd_dcr_ll_next_dcr_list_pack(const struct connectib_icmd_dcr_ll_next_dcr_list *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->start_dcri);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->list_length);

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(2048, 32, i, 6144, 1);
	connectib_dcr_info_pack(&(ptr_struct->dcr_info[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_dcr_ll_next_dcr_list_unpack(struct connectib_icmd_dcr_ll_next_dcr_list *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->start_dcri = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->list_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(2048, 32, i, 6144, 1);
	connectib_dcr_info_unpack(&(ptr_struct->dcr_info[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_dcr_ll_next_dcr_list_print(const struct connectib_icmd_dcr_ll_next_dcr_list *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_dcr_ll_next_dcr_list ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_dcri           : "UH_FMT"\n", ptr_struct->start_dcri);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "list_length          : "U32H_FMT"\n", ptr_struct->list_length);

	for (i=0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_info_%03d:\n", i);
	connectib_dcr_info_print(&(ptr_struct->dcr_info[i]), file, indent_level + 1);
	}

}

int connectib_icmd_dcr_ll_next_dcr_list_size(void){
	 return 768;
}

void connectib_icmd_dcr_ll_next_dcr_list_dump(const struct connectib_icmd_dcr_ll_next_dcr_list *ptr_struct, FILE* file) {
	connectib_icmd_dcr_ll_next_dcr_list_print(ptr_struct, file, 0);
}

void connectib_icmd_dcr_ll_trvrs_pack(const struct connectib_icmd_dcr_ll_trvrs *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->start_dcri);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->list_length);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->last_dcri);

}

void connectib_icmd_dcr_ll_trvrs_unpack(struct connectib_icmd_dcr_ll_trvrs *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->start_dcri = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=32;
	ptr_struct->list_length = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->last_dcri = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_icmd_dcr_ll_trvrs_print(const struct connectib_icmd_dcr_ll_trvrs *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_dcr_ll_trvrs ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_dcri           : "UH_FMT"\n", ptr_struct->start_dcri);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "list_length          : "U32H_FMT"\n", ptr_struct->list_length);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_dcri            : "UH_FMT"\n", ptr_struct->last_dcri);

}

int connectib_icmd_dcr_ll_trvrs_size(void){
	 return 16;
}

void connectib_icmd_dcr_ll_trvrs_dump(const struct connectib_icmd_dcr_ll_trvrs *ptr_struct, FILE* file) {
	connectib_icmd_dcr_ll_trvrs_print(ptr_struct, file, 0);
}

void connectib_icmd_flr_debug_pack(const struct connectib_icmd_flr_debug *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->flow_id);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->flow_data_0);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->flow_data_1);

}

void connectib_icmd_flr_debug_unpack(struct connectib_icmd_flr_debug *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->flow_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->flow_data_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->flow_data_1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_flr_debug_print(const struct connectib_icmd_flr_debug *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_flr_debug ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_id              : "UH_FMT"\n", ptr_struct->flow_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_data_0          : "U32H_FMT"\n", ptr_struct->flow_data_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_data_1          : "U32H_FMT"\n", ptr_struct->flow_data_1);

}

int connectib_icmd_flr_debug_size(void){
	 return 32;
}

void connectib_icmd_flr_debug_dump(const struct connectib_icmd_flr_debug *ptr_struct, FILE* file) {
	connectib_icmd_flr_debug_print(ptr_struct, file, 0);
}

void connectib_icmd_push_db_pack(const struct connectib_icmd_push_db *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=39;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->req_res_);

}

void connectib_icmd_push_db_unpack(struct connectib_icmd_push_db *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=40;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=39;
	ptr_struct->req_res_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_push_db_print(const struct connectib_icmd_push_db *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_push_db ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "req_res_             : "UH_FMT"\n", ptr_struct->req_res_);

}

int connectib_icmd_push_db_size(void){
	 return 8;
}

void connectib_icmd_push_db_dump(const struct connectib_icmd_push_db *ptr_struct, FILE* file) {
	connectib_icmd_push_db_print(ptr_struct, file, 0);
}

void connectib_icmd_pcie_ver_data_pack(const struct connectib_icmd_pcie_ver_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_pcie_ver_device_pack(&(ptr_struct->device), ptr_buff + offset/8);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(128, 128, i, 512, 1);
	connectib_icmd_pcie_ver_cables_pack(&(ptr_struct->cables[i]), ptr_buff + offset/8);
	}

	offset=384;
	connectib_icmd_pcie_ver_frequency_pack(&(ptr_struct->frequency), ptr_buff + offset/8);

}

void connectib_icmd_pcie_ver_data_unpack(struct connectib_icmd_pcie_ver_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_pcie_ver_device_unpack(&(ptr_struct->device), ptr_buff + offset/8);

	for (i=0; i < 2; i++) {
	offset=adb2c_calc_array_field_address(128, 128, i, 512, 1);
	connectib_icmd_pcie_ver_cables_unpack(&(ptr_struct->cables[i]), ptr_buff + offset/8);
	}

	offset=384;
	connectib_icmd_pcie_ver_frequency_unpack(&(ptr_struct->frequency), ptr_buff + offset/8);

}

void connectib_icmd_pcie_ver_data_print(const struct connectib_icmd_pcie_ver_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_pcie_ver_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device:\n");
	connectib_icmd_pcie_ver_device_print(&(ptr_struct->device), file, indent_level + 1);

	for (i=0; i < 2; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cables_%03d:\n", i);
	connectib_icmd_pcie_ver_cables_print(&(ptr_struct->cables[i]), file, indent_level + 1);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "frequency:\n");
	connectib_icmd_pcie_ver_frequency_print(&(ptr_struct->frequency), file, indent_level + 1);

}

int connectib_icmd_pcie_ver_data_size(void){
	 return 64;
}

void connectib_icmd_pcie_ver_data_dump(const struct connectib_icmd_pcie_ver_data *ptr_struct, FILE* file) {
	connectib_icmd_pcie_ver_data_print(ptr_struct, file, 0);
}

void connectib_icmd_stress_testing_pack(const struct connectib_icmd_stress_testing *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->opcode);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->param);

}

void connectib_icmd_stress_testing_unpack(struct connectib_icmd_stress_testing *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->param = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_stress_testing_print(const struct connectib_icmd_stress_testing *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_stress_testing ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "param                : "U32H_FMT"\n", ptr_struct->param);

}

int connectib_icmd_stress_testing_size(void){
	 return 256;
}

void connectib_icmd_stress_testing_dump(const struct connectib_icmd_stress_testing *ptr_struct, FILE* file) {
	connectib_icmd_stress_testing_print(ptr_struct, file, 0);
}

void connectib_icmd_stop_toggler_pack(const struct connectib_icmd_stop_toggler *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->type);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mostly_working);

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_duty_cycle);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_stress);

}

void connectib_icmd_stop_toggler_unpack(struct connectib_icmd_stop_toggler *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=63;
	ptr_struct->mostly_working = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=91;
	ptr_struct->log_duty_cycle = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=123;
	ptr_struct->log_stress = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_icmd_stop_toggler_print(const struct connectib_icmd_stop_toggler *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_stop_toggler ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mostly_working       : "UH_FMT"\n", ptr_struct->mostly_working);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_duty_cycle       : "UH_FMT"\n", ptr_struct->log_duty_cycle);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_stress           : "UH_FMT"\n", ptr_struct->log_stress);

}

int connectib_icmd_stop_toggler_size(void){
	 return 256;
}

void connectib_icmd_stop_toggler_dump(const struct connectib_icmd_stop_toggler *ptr_struct, FILE* file) {
	connectib_icmd_stop_toggler_print(ptr_struct, file, 0);
}

void connectib_icmd_code_coverage_read_pack(const struct connectib_icmd_code_coverage_read *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2112, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=2064;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->start_dw);

	offset=2048;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->num_dw);

}

void connectib_icmd_code_coverage_read_unpack(struct connectib_icmd_code_coverage_read *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2112, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=2064;
	ptr_struct->start_dw = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=2048;
	ptr_struct->num_dw = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_code_coverage_read_print(const struct connectib_icmd_code_coverage_read *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_code_coverage_read ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_dw             : "UH_FMT"\n", ptr_struct->start_dw);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_dw               : "UH_FMT"\n", ptr_struct->num_dw);

}

int connectib_icmd_code_coverage_read_size(void){
	 return 264;
}

void connectib_icmd_code_coverage_read_dump(const struct connectib_icmd_code_coverage_read *ptr_struct, FILE* file) {
	connectib_icmd_code_coverage_read_print(ptr_struct, file, 0);
}

void connectib_icmd_code_coverage_control_pack(const struct connectib_icmd_code_coverage_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=32;
	connectib_code_coverage_control_pack(&(ptr_struct->code_coverage_control), ptr_buff + offset/8);

}

void connectib_icmd_code_coverage_control_unpack(struct connectib_icmd_code_coverage_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	connectib_code_coverage_control_unpack(&(ptr_struct->code_coverage_control), ptr_buff + offset/8);

}

void connectib_icmd_code_coverage_control_print(const struct connectib_icmd_code_coverage_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_code_coverage_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "code_coverage_control:\n");
	connectib_code_coverage_control_print(&(ptr_struct->code_coverage_control), file, indent_level + 1);

}

int connectib_icmd_code_coverage_control_size(void){
	 return 16;
}

void connectib_icmd_code_coverage_control_dump(const struct connectib_icmd_code_coverage_control *ptr_struct, FILE* file) {
	connectib_icmd_code_coverage_control_print(ptr_struct, file, 0);
}

void connectib_icmd_esw_pack(const struct connectib_icmd_esw *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_esw_pack(&(ptr_struct->fw_esw), ptr_buff + offset/8);

	offset=514;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_is_ib);

	offset=513;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->portid);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->gvmi);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_of_vport);

	offset=2048;
	connectib_vport_real_state_pack(&(ptr_struct->vport_real_state), ptr_buff + offset/8);

}

void connectib_icmd_esw_unpack(struct connectib_icmd_esw *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_fw_esw_unpack(&(ptr_struct->fw_esw), ptr_buff + offset/8);

	offset=514;
	ptr_struct->port_is_ib = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=513;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=512;
	ptr_struct->portid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=544;
	ptr_struct->gvmi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->num_of_vport = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=2048;
	connectib_vport_real_state_unpack(&(ptr_struct->vport_real_state), ptr_buff + offset/8);

}

void connectib_icmd_esw_print(const struct connectib_icmd_esw *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_esw ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_esw:\n");
	connectib_fw_esw_print(&(ptr_struct->fw_esw), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_is_ib           : "UH_FMT"\n", ptr_struct->port_is_ib);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "portid               : "UH_FMT"\n", ptr_struct->portid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "U32H_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_vport         : "U32H_FMT"\n", ptr_struct->num_of_vport);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vport_real_state:\n");
	connectib_vport_real_state_print(&(ptr_struct->vport_real_state), file, indent_level + 1);

}

int connectib_icmd_esw_size(void){
	 return 768;
}

void connectib_icmd_esw_dump(const struct connectib_icmd_esw *ptr_struct, FILE* file) {
	connectib_icmd_esw_print(ptr_struct, file, 0);
}

void connectib_icmd_rw_gvmix_pack(const struct connectib_icmd_rw_gvmix *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_gvmix_sub_structs_pack(&(ptr_struct->sub_structs), ptr_buff + offset/8);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->gvmi);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->node_type);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ix);

}

void connectib_icmd_rw_gvmix_unpack(struct connectib_icmd_rw_gvmix *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_gvmix_sub_structs_unpack(&(ptr_struct->sub_structs), ptr_buff + offset/8);

	offset=512;
	ptr_struct->gvmi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->node_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=576;
	ptr_struct->ix = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_rw_gvmix_print(const struct connectib_icmd_rw_gvmix *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_rw_gvmix ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sub_structs:\n");
	connectib_gvmix_sub_structs_print(&(ptr_struct->sub_structs), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "U32H_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "node_type            : "U32H_FMT"\n", ptr_struct->node_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ix                   : "U32H_FMT"\n", ptr_struct->ix);

}

int connectib_icmd_rw_gvmix_size(void){
	 return 128;
}

void connectib_icmd_rw_gvmix_dump(const struct connectib_icmd_rw_gvmix *ptr_struct, FILE* file) {
	connectib_icmd_rw_gvmix_print(ptr_struct, file, 0);
}

void connectib_icmd_gen_eqe_pack(const struct connectib_icmd_gen_eqe *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->eqn);

	offset=128;
	connectib_sw_eqe_pack(&(ptr_struct->eqe), ptr_buff + offset/8);

}

void connectib_icmd_gen_eqe_unpack(struct connectib_icmd_gen_eqe *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=56;
	ptr_struct->eqn = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=128;
	connectib_sw_eqe_unpack(&(ptr_struct->eqe), ptr_buff + offset/8);

}

void connectib_icmd_gen_eqe_print(const struct connectib_icmd_gen_eqe *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_gen_eqe ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqn                  : "UH_FMT"\n", ptr_struct->eqn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqe:\n");
	connectib_sw_eqe_print(&(ptr_struct->eqe), file, indent_level + 1);

}

int connectib_icmd_gen_eqe_size(void){
	 return 80;
}

void connectib_icmd_gen_eqe_dump(const struct connectib_icmd_gen_eqe *ptr_struct, FILE* file) {
	connectib_icmd_gen_eqe_print(ptr_struct, file, 0);
}

void connectib_pcie_tools_pointers_pack(const struct connectib_pcie_tools_pointers *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_endpoint_data_ptr);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_timestamps_ptr);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_transaction_ptr);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_debug_equalization_debug_ptr);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_debug_ts_debug_ptr);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_debug_internal_error_debug_ptr);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_gen3_equalization_ptr);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_pcie_eye_centering_ptr);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_first_calibration_results_ptr);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_pcie_rx_adaptation_ptr);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_pcie_tx_adaptation_ptr);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_phy_tracer_ptr);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->pcie_pfs_ptr);

}

void connectib_pcie_tools_pointers_unpack(struct connectib_pcie_tools_pointers *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->pcie_endpoint_data_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->pcie_timestamps_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->pcie_transaction_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->pcie_debug_equalization_debug_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->pcie_debug_ts_debug_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->pcie_debug_internal_error_debug_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->pcie_phy_gen3_equalization_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->pcie_phy_pcie_eye_centering_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->pcie_phy_first_calibration_results_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->pcie_phy_pcie_rx_adaptation_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->pcie_phy_pcie_tx_adaptation_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->pcie_phy_tracer_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->pcie_pfs_ptr = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_pcie_tools_pointers_print(const struct connectib_pcie_tools_pointers *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_pcie_tools_pointers ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_endpoint_data_ptr : "U32H_FMT"\n", ptr_struct->pcie_endpoint_data_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_timestamps_ptr  : "U32H_FMT"\n", ptr_struct->pcie_timestamps_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_transaction_ptr : "U32H_FMT"\n", ptr_struct->pcie_transaction_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_debug_equalization_debug_ptr : "U32H_FMT"\n", ptr_struct->pcie_debug_equalization_debug_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_debug_ts_debug_ptr : "U32H_FMT"\n", ptr_struct->pcie_debug_ts_debug_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_debug_internal_error_debug_ptr : "U32H_FMT"\n", ptr_struct->pcie_debug_internal_error_debug_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_gen3_equalization_ptr : "U32H_FMT"\n", ptr_struct->pcie_phy_gen3_equalization_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_pcie_eye_centering_ptr : "U32H_FMT"\n", ptr_struct->pcie_phy_pcie_eye_centering_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_first_calibration_results_ptr : "U32H_FMT"\n", ptr_struct->pcie_phy_first_calibration_results_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_pcie_rx_adaptation_ptr : "U32H_FMT"\n", ptr_struct->pcie_phy_pcie_rx_adaptation_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_pcie_tx_adaptation_ptr : "U32H_FMT"\n", ptr_struct->pcie_phy_pcie_tx_adaptation_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_phy_tracer_ptr  : "U32H_FMT"\n", ptr_struct->pcie_phy_tracer_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_pfs_ptr         : "U32H_FMT"\n", ptr_struct->pcie_pfs_ptr);

}

int connectib_pcie_tools_pointers_size(void){
	 return 64;
}

void connectib_pcie_tools_pointers_dump(const struct connectib_pcie_tools_pointers *ptr_struct, FILE* file) {
	connectib_pcie_tools_pointers_print(ptr_struct, file, 0);
}

void connectib_icmd_phy_ver_overwrite_pack(const struct connectib_icmd_phy_ver_overwrite *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port_id);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->field_id);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->field_value);

}

void connectib_icmd_phy_ver_overwrite_unpack(struct connectib_icmd_phy_ver_overwrite *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->port_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=8;
	ptr_struct->field_id = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	ptr_struct->field_value = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_phy_ver_overwrite_print(const struct connectib_icmd_phy_ver_overwrite *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_phy_ver_overwrite ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_id              : "UH_FMT"\n", ptr_struct->port_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_id             : "UH_FMT"\n", ptr_struct->field_id);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "field_value          : "U32H_FMT"\n", ptr_struct->field_value);

}

int connectib_icmd_phy_ver_overwrite_size(void){
	 return 8;
}

void connectib_icmd_phy_ver_overwrite_dump(const struct connectib_icmd_phy_ver_overwrite *ptr_struct, FILE* file) {
	connectib_icmd_phy_ver_overwrite_print(ptr_struct, file, 0);
}

void connectib_icmd_init_ocsd_pack(const struct connectib_icmd_init_ocsd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->addr_hi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->addr_low);

}

void connectib_icmd_init_ocsd_unpack(struct connectib_icmd_init_ocsd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	ptr_struct->addr_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->addr_low = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_init_ocsd_print(const struct connectib_icmd_init_ocsd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_init_ocsd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_hi              : "U32H_FMT"\n", ptr_struct->addr_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_low             : "U32H_FMT"\n", ptr_struct->addr_low);

}

int connectib_icmd_init_ocsd_size(void){
	 return 12;
}

void connectib_icmd_init_ocsd_dump(const struct connectib_icmd_init_ocsd *ptr_struct, FILE* file) {
	connectib_icmd_init_ocsd_print(ptr_struct, file, 0);
}

void connectib_itrace_pack(const struct connectib_itrace *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->unit_mask);

	offset=32;
	connectib_itrace_ctrl_pack(&(ptr_struct->ctrl), ptr_buff + offset/8);

}

void connectib_itrace_unpack(struct connectib_itrace *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->unit_mask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	connectib_itrace_ctrl_unpack(&(ptr_struct->ctrl), ptr_buff + offset/8);

}

void connectib_itrace_print(const struct connectib_itrace *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_itrace ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "unit_mask            : "U32H_FMT"\n", ptr_struct->unit_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctrl:\n");
	connectib_itrace_ctrl_print(&(ptr_struct->ctrl), file, indent_level + 1);

}

int connectib_itrace_size(void){
	 return 16;
}

void connectib_itrace_dump(const struct connectib_itrace *ptr_struct, FILE* file) {
	connectib_itrace_print(ptr_struct, file, 0);
}

void connectib_icmd_dc_config_pack(const struct connectib_icmd_dc_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->bitmask);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->initial_log_dcr_lifo_size);

	offset=155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_hash_size);

	offset=191;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->full_handshake_enable);

	offset=219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_max_dcrs);

	offset=251;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->inhale_en);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->inhale_threshold);

	offset=296;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->inhale_inc);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->force_no_dcrs_delay);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->current_max_lifo_size);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->available_lifo_size);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->available_lifo_size_inc);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->force_garbage_collection_fail_threshold);

	offset=480;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->number_of_active_ghost_busters);

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->cleanup_drop_n_connects);

	offset=544;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->cleanup_drop_n_disconnects);

	offset=607;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ghost_buster_enable);

}

void connectib_icmd_dc_config_unpack(struct connectib_icmd_dc_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->bitmask = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=63;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=123;
	ptr_struct->initial_log_dcr_lifo_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=155;
	ptr_struct->log_hash_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=191;
	ptr_struct->full_handshake_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=219;
	ptr_struct->log_max_dcrs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=251;
	ptr_struct->inhale_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=264;
	ptr_struct->inhale_threshold = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=296;
	ptr_struct->inhale_inc = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=320;
	ptr_struct->force_no_dcrs_delay = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->current_max_lifo_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->available_lifo_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->available_lifo_size_inc = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->force_garbage_collection_fail_threshold = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=480;
	ptr_struct->number_of_active_ghost_busters = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=512;
	ptr_struct->cleanup_drop_n_connects = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=544;
	ptr_struct->cleanup_drop_n_disconnects = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=607;
	ptr_struct->ghost_buster_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_dc_config_print(const struct connectib_icmd_dc_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_dc_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "bitmask              : "U32H_FMT"\n", ptr_struct->bitmask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "initial_log_dcr_lifo_size : "UH_FMT"\n", ptr_struct->initial_log_dcr_lifo_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_hash_size        : "UH_FMT"\n", ptr_struct->log_hash_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "full_handshake_enable : "UH_FMT"\n", ptr_struct->full_handshake_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_dcrs         : "UH_FMT"\n", ptr_struct->log_max_dcrs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inhale_en            : "UH_FMT"\n", ptr_struct->inhale_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inhale_threshold     : "UH_FMT"\n", ptr_struct->inhale_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inhale_inc           : "UH_FMT"\n", ptr_struct->inhale_inc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_no_dcrs_delay  : "U32H_FMT"\n", ptr_struct->force_no_dcrs_delay);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_max_lifo_size : "U32H_FMT"\n", ptr_struct->current_max_lifo_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "available_lifo_size  : "U32H_FMT"\n", ptr_struct->available_lifo_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "available_lifo_size_inc : "U32H_FMT"\n", ptr_struct->available_lifo_size_inc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_garbage_collection_fail_threshold : "U32H_FMT"\n", ptr_struct->force_garbage_collection_fail_threshold);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_of_active_ghost_busters : "U32H_FMT"\n", ptr_struct->number_of_active_ghost_busters);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cleanup_drop_n_connects : "U32H_FMT"\n", ptr_struct->cleanup_drop_n_connects);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cleanup_drop_n_disconnects : "U32H_FMT"\n", ptr_struct->cleanup_drop_n_disconnects);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ghost_buster_enable  : "UH_FMT"\n", ptr_struct->ghost_buster_enable);

}

int connectib_icmd_dc_config_size(void){
	 return 128;
}

void connectib_icmd_dc_config_dump(const struct connectib_icmd_dc_config *ptr_struct, FILE* file) {
	connectib_icmd_dc_config_print(ptr_struct, file, 0);
}

void connectib_icmd_dc_params_pack(const struct connectib_icmd_dc_params *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->full_handshake_enable);

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_hash_size);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->current_lifo_size);

}

void connectib_icmd_dc_params_unpack(struct connectib_icmd_dc_params *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=63;
	ptr_struct->full_handshake_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=91;
	ptr_struct->log_hash_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=96;
	ptr_struct->current_lifo_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_dc_params_print(const struct connectib_icmd_dc_params *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_dc_params ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "full_handshake_enable : "UH_FMT"\n", ptr_struct->full_handshake_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_hash_size        : "UH_FMT"\n", ptr_struct->log_hash_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "current_lifo_size    : "U32H_FMT"\n", ptr_struct->current_lifo_size);

}

int connectib_icmd_dc_params_size(void){
	 return 32;
}

void connectib_icmd_dc_params_dump(const struct connectib_icmd_dc_params *ptr_struct, FILE* file) {
	connectib_icmd_dc_params_print(ptr_struct, file, 0);
}

void connectib_icmd_access_icm_line_pack(const struct connectib_icmd_access_icm_line *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 640, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->addr);

}

void connectib_icmd_access_icm_line_unpack(struct connectib_icmd_access_icm_line *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 640, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=512;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=576;
	ptr_struct->addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_access_icm_line_print(const struct connectib_icmd_access_icm_line *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_icm_line ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr                 : "U64H_FMT"\n", ptr_struct->addr);

}

int connectib_icmd_access_icm_line_size(void){
	 return 80;
}

void connectib_icmd_access_icm_line_dump(const struct connectib_icmd_access_icm_line *ptr_struct, FILE* file) {
	connectib_icmd_access_icm_line_print(ptr_struct, file, 0);
}

void connectib_icmd_check_sqpc_status_pack(const struct connectib_icmd_check_sqpc_status *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->result_type);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->result_diff);

}

void connectib_icmd_check_sqpc_status_unpack(struct connectib_icmd_check_sqpc_status *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->result_type = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->result_diff = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_check_sqpc_status_print(const struct connectib_icmd_check_sqpc_status *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_check_sqpc_status ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "result_type          : "UH_FMT"\n", ptr_struct->result_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "result_diff          : "U32H_FMT"\n", ptr_struct->result_diff);

}

int connectib_icmd_check_sqpc_status_size(void){
	 return 16;
}

void connectib_icmd_check_sqpc_status_dump(const struct connectib_icmd_check_sqpc_status *ptr_struct, FILE* file) {
	connectib_icmd_check_sqpc_status_print(ptr_struct, file, 0);
}

void connectib_icmd_lock_unlock_resource_pack(const struct connectib_icmd_lock_unlock_resource *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_lock_tag_pack(&(ptr_struct->lock_tag), ptr_buff + offset/8);

	offset=127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock_unlock_);

	offset=117;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->irisc_ix);

	offset=116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spy_en);

}

void connectib_icmd_lock_unlock_resource_unpack(struct connectib_icmd_lock_unlock_resource *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_lock_tag_unpack(&(ptr_struct->lock_tag), ptr_buff + offset/8);

	offset=127;
	ptr_struct->lock_unlock_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=117;
	ptr_struct->irisc_ix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=116;
	ptr_struct->spy_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_lock_unlock_resource_print(const struct connectib_icmd_lock_unlock_resource *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_lock_unlock_resource ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_tag:\n");
	connectib_lock_tag_print(&(ptr_struct->lock_tag), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_unlock_         : "UH_FMT"\n", ptr_struct->lock_unlock_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "irisc_ix             : "UH_FMT"\n", ptr_struct->irisc_ix);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spy_en               : "UH_FMT"\n", ptr_struct->spy_en);

}

int connectib_icmd_lock_unlock_resource_size(void){
	 return 16;
}

void connectib_icmd_lock_unlock_resource_dump(const struct connectib_icmd_lock_unlock_resource *ptr_struct, FILE* file) {
	connectib_icmd_lock_unlock_resource_print(ptr_struct, file, 0);
}

void connectib_reg_access_ext_cmd_pack(const struct connectib_reg_access_ext_cmd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_cmd_pack(&(ptr_struct->reg_access), ptr_buff + offset/8);

	for (i=0; i < 24; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1280, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->more_data[i]);
	}

}

void connectib_reg_access_ext_cmd_unpack(struct connectib_reg_access_ext_cmd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reg_access_cmd_unpack(&(ptr_struct->reg_access), ptr_buff + offset/8);

	for (i=0; i < 24; i++) {
	offset=adb2c_calc_array_field_address(512, 32, i, 1280, 1);
	ptr_struct->more_data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_reg_access_ext_cmd_print(const struct connectib_reg_access_ext_cmd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reg_access_ext_cmd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reg_access:\n");
	connectib_reg_access_cmd_print(&(ptr_struct->reg_access), file, indent_level + 1);

	for (i=0; i < 24; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "more_data_%03d       : "U32H_FMT"\n", i, ptr_struct->more_data[i]);
	}

}

int connectib_reg_access_ext_cmd_size(void){
	 return 160;
}

void connectib_reg_access_ext_cmd_dump(const struct connectib_reg_access_ext_cmd *ptr_struct, FILE* file) {
	connectib_reg_access_ext_cmd_print(ptr_struct, file, 0);
}

void connectib_icmd_get_icm_ctx_addr_pack(const struct connectib_icmd_get_icm_ctx_addr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_res_type);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ctx_num_hi);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ctx_num_lo);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_addr_hi);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_addr_lo);

}

void connectib_icmd_get_icm_ctx_addr_unpack(struct connectib_icmd_get_icm_ctx_addr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->icm_res_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->ctx_num_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->ctx_num_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->icm_addr_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->icm_addr_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_icm_ctx_addr_print(const struct connectib_icmd_get_icm_ctx_addr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_icm_ctx_addr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_res_type         : "U32H_FMT"\n", ptr_struct->icm_res_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx_num_hi           : "U32H_FMT"\n", ptr_struct->ctx_num_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx_num_lo           : "U32H_FMT"\n", ptr_struct->ctx_num_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_addr_hi          : "U32H_FMT"\n", ptr_struct->icm_addr_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_addr_lo          : "U32H_FMT"\n", ptr_struct->icm_addr_lo);

}

int connectib_icmd_get_icm_ctx_addr_size(void){
	 return 24;
}

void connectib_icmd_get_icm_ctx_addr_dump(const struct connectib_icmd_get_icm_ctx_addr *ptr_struct, FILE* file) {
	connectib_icmd_get_icm_ctx_addr_print(ptr_struct, file, 0);
}

void connectib_phy_nego_ctrl_st_pack(const struct connectib_phy_nego_ctrl_st *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_link_up_port0);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->halt_fw_phy_fsm_port0);

	offset=29;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->force_link_up_port1);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->halt_fw_phy_fsm_port1);

}

void connectib_phy_nego_ctrl_st_unpack(struct connectib_phy_nego_ctrl_st *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->force_link_up_port0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->halt_fw_phy_fsm_port0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=29;
	ptr_struct->force_link_up_port1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->halt_fw_phy_fsm_port1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_phy_nego_ctrl_st_print(const struct connectib_phy_nego_ctrl_st *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_phy_nego_ctrl_st ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_link_up_port0  : "UH_FMT"\n", ptr_struct->force_link_up_port0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "halt_fw_phy_fsm_port0 : "UH_FMT"\n", ptr_struct->halt_fw_phy_fsm_port0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "force_link_up_port1  : "UH_FMT"\n", ptr_struct->force_link_up_port1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "halt_fw_phy_fsm_port1 : "UH_FMT"\n", ptr_struct->halt_fw_phy_fsm_port1);

}

int connectib_phy_nego_ctrl_st_size(void){
	 return 4;
}

void connectib_phy_nego_ctrl_st_dump(const struct connectib_phy_nego_ctrl_st *ptr_struct, FILE* file) {
	connectib_phy_nego_ctrl_st_print(ptr_struct, file, 0);
}

void connectib_eye_opening_read_st_pack(const struct connectib_eye_opening_read_st *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_num);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->lane_num);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amplitude_high);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->amplitude_low);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phase_high);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->phase_low);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->tx_set_chosen);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rx_set_chosen);

}

void connectib_eye_opening_read_st_unpack(struct connectib_eye_opening_read_st *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->port_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->lane_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=48;
	ptr_struct->amplitude_high = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->amplitude_low = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=80;
	ptr_struct->phase_high = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->phase_low = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=112;
	ptr_struct->tx_set_chosen = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->rx_set_chosen = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_eye_opening_read_st_print(const struct connectib_eye_opening_read_st *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eye_opening_read_st ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_num             : "UH_FMT"\n", ptr_struct->port_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lane_num             : "UH_FMT"\n", ptr_struct->lane_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amplitude_high       : "UH_FMT"\n", ptr_struct->amplitude_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "amplitude_low        : "UH_FMT"\n", ptr_struct->amplitude_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_high           : "UH_FMT"\n", ptr_struct->phase_high);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phase_low            : "UH_FMT"\n", ptr_struct->phase_low);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tx_set_chosen        : "UH_FMT"\n", ptr_struct->tx_set_chosen);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_set_chosen        : "UH_FMT"\n", ptr_struct->rx_set_chosen);

}

int connectib_eye_opening_read_st_size(void){
	 return 16;
}

void connectib_eye_opening_read_st_dump(const struct connectib_eye_opening_read_st *ptr_struct, FILE* file) {
	connectib_eye_opening_read_st_print(ptr_struct, file, 0);
}

void connectib_icmd_alloc_dealloc_resource_pack(const struct connectib_icmd_alloc_dealloc_resource *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->alloc_dealloc);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_res_type);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->res_num_hi);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->res_num_lo);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->return_status);

}

void connectib_icmd_alloc_dealloc_resource_unpack(struct connectib_icmd_alloc_dealloc_resource *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=15;
	ptr_struct->alloc_dealloc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->icm_res_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->res_num_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->res_num_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->return_status = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_alloc_dealloc_resource_print(const struct connectib_icmd_alloc_dealloc_resource *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_alloc_dealloc_resource ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alloc_dealloc        : "UH_FMT"\n", ptr_struct->alloc_dealloc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_res_type         : "U32H_FMT"\n", ptr_struct->icm_res_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "res_num_hi           : "U32H_FMT"\n", ptr_struct->res_num_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "res_num_lo           : "U32H_FMT"\n", ptr_struct->res_num_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "return_status        : "U32H_FMT"\n", ptr_struct->return_status);

}

int connectib_icmd_alloc_dealloc_resource_size(void){
	 return 24;
}

void connectib_icmd_alloc_dealloc_resource_dump(const struct connectib_icmd_alloc_dealloc_resource *ptr_struct, FILE* file) {
	connectib_icmd_alloc_dealloc_resource_print(ptr_struct, file, 0);
}

void connectib_icmd_get_icm_res_prop_pack(const struct connectib_icmd_get_icm_res_prop *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->input_icm_type);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->table_base_hi);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->table_base_lo);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->offset);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->log2_stride);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->log2_size);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->log2_table_size);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dummy_idx);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sw_type);

}

void connectib_icmd_get_icm_res_prop_unpack(struct connectib_icmd_get_icm_res_prop *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->input_icm_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->table_base_hi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->table_base_lo = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->offset = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->log2_stride = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->log2_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->log2_table_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->dummy_idx = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->sw_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_get_icm_res_prop_print(const struct connectib_icmd_get_icm_res_prop *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_icm_res_prop ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "input_icm_type       : "U32H_FMT"\n", ptr_struct->input_icm_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_base_hi        : "U32H_FMT"\n", ptr_struct->table_base_hi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "table_base_lo        : "U32H_FMT"\n", ptr_struct->table_base_lo);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset               : "U32H_FMT"\n", ptr_struct->offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_stride          : "U32H_FMT"\n", ptr_struct->log2_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_size            : "U32H_FMT"\n", ptr_struct->log2_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log2_table_size      : "U32H_FMT"\n", ptr_struct->log2_table_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dummy_idx            : "U32H_FMT"\n", ptr_struct->dummy_idx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_type              : "U32H_FMT"\n", ptr_struct->sw_type);

}

int connectib_icmd_get_icm_res_prop_size(void){
	 return 36;
}

void connectib_icmd_get_icm_res_prop_dump(const struct connectib_icmd_get_icm_res_prop *ptr_struct, FILE* file) {
	connectib_icmd_get_icm_res_prop_print(ptr_struct, file, 0);
}

void connectib_icmd_cable_info_pack(const struct connectib_icmd_cable_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->method);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 15, (u_int32_t)ptr_struct->status);

	offset=184;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->module);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lock_bit);

	offset=512;
	connectib_cable_info_pack(&(ptr_struct->data), ptr_buff + offset/8);

}

void connectib_icmd_cable_info_unpack(struct connectib_icmd_cable_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->method = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=33;
	ptr_struct->status = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 15);

	offset=184;
	ptr_struct->module = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=160;
	ptr_struct->lock_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=512;
	connectib_cable_info_unpack(&(ptr_struct->data), ptr_buff + offset/8);

}

void connectib_icmd_cable_info_print(const struct connectib_icmd_cable_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_cable_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "method               : "UH_FMT"\n", ptr_struct->method);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : "UH_FMT"\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module               : "UH_FMT"\n", ptr_struct->module);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_bit             : "UH_FMT"\n", ptr_struct->lock_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data:\n");
	connectib_cable_info_print(&(ptr_struct->data), file, indent_level + 1);

}

int connectib_icmd_cable_info_size(void){
	 return 128;
}

void connectib_icmd_cable_info_dump(const struct connectib_icmd_cable_info *ptr_struct, FILE* file) {
	connectib_icmd_cable_info_print(ptr_struct, file, 0);
}

void connectib_icmd_cable_plug_out_in_pack(const struct connectib_icmd_cable_plug_out_in *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->port);

	offset=23;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->plug_out_in);

}

void connectib_icmd_cable_plug_out_in_unpack(struct connectib_icmd_cable_plug_out_in *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=23;
	ptr_struct->plug_out_in = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_cable_plug_out_in_print(const struct connectib_icmd_cable_plug_out_in *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_cable_plug_out_in ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "plug_out_in          : "UH_FMT"\n", ptr_struct->plug_out_in);

}

int connectib_icmd_cable_plug_out_in_size(void){
	 return 4;
}

void connectib_icmd_cable_plug_out_in_dump(const struct connectib_icmd_cable_plug_out_in *ptr_struct, FILE* file) {
	connectib_icmd_cable_plug_out_in_print(ptr_struct, file, 0);
}

void connectib_icmd_standby_pack(const struct connectib_icmd_standby *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->exit_enter_);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->in_standby_mode);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->last_iron_down_time_usec);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->flow_id);

}

void connectib_icmd_standby_unpack(struct connectib_icmd_standby *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=63;
	ptr_struct->exit_enter_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->in_standby_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->last_iron_down_time_usec = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->flow_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_standby_print(const struct connectib_icmd_standby *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_standby ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "exit_enter_          : "UH_FMT"\n", ptr_struct->exit_enter_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "in_standby_mode      : "UH_FMT"\n", ptr_struct->in_standby_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "last_iron_down_time_usec : "U32H_FMT"\n", ptr_struct->last_iron_down_time_usec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_id              : "UH_FMT"\n", ptr_struct->flow_id);

}

int connectib_icmd_standby_size(void){
	 return 32;
}

void connectib_icmd_standby_dump(const struct connectib_icmd_standby *ptr_struct, FILE* file) {
	connectib_icmd_standby_print(ptr_struct, file, 0);
}

void connectib_icmd_grepper_pack(const struct connectib_icmd_grepper *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icmd_grepper_flow);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->read_addr);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->write_addr);

	offset=219;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_read_stride);

	offset=214;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->log_write_stride);

	offset=230;
	adb2c_push_bits_to_buff(ptr_buff, offset, 26, (u_int32_t)ptr_struct->line_start_offset);

	offset=262;
	adb2c_push_bits_to_buff(ptr_buff, offset, 26, (u_int32_t)ptr_struct->iterations);

	offset=294;
	adb2c_push_bits_to_buff(ptr_buff, offset, 26, (u_int32_t)ptr_struct->first_line_hit);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->number_of_hits);

	offset=352;
	connectib_grepper_dwords_pack(&(ptr_struct->write_data), ptr_buff + offset/8);

	offset=864;
	connectib_grepper_dwords_pack(&(ptr_struct->write_mask), ptr_buff + offset/8);

	offset=1376;
	connectib_grepper_dwords_pack(&(ptr_struct->compare_data), ptr_buff + offset/8);

	offset=2400;
	connectib_grepper_dwords_pack(&(ptr_struct->compare_mask), ptr_buff + offset/8);

}

void connectib_icmd_grepper_unpack(struct connectib_icmd_grepper *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->icmd_grepper_flow = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->read_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=128;
	ptr_struct->write_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=219;
	ptr_struct->log_read_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=214;
	ptr_struct->log_write_stride = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=230;
	ptr_struct->line_start_offset = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 26);

	offset=262;
	ptr_struct->iterations = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 26);

	offset=294;
	ptr_struct->first_line_hit = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 26);

	offset=320;
	ptr_struct->number_of_hits = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	connectib_grepper_dwords_unpack(&(ptr_struct->write_data), ptr_buff + offset/8);

	offset=864;
	connectib_grepper_dwords_unpack(&(ptr_struct->write_mask), ptr_buff + offset/8);

	offset=1376;
	connectib_grepper_dwords_unpack(&(ptr_struct->compare_data), ptr_buff + offset/8);

	offset=2400;
	connectib_grepper_dwords_unpack(&(ptr_struct->compare_mask), ptr_buff + offset/8);

}

void connectib_icmd_grepper_print(const struct connectib_icmd_grepper *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_grepper ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icmd_grepper_flow    : "U32H_FMT"\n", ptr_struct->icmd_grepper_flow);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_addr            : "U64H_FMT"\n", ptr_struct->read_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_addr           : "U64H_FMT"\n", ptr_struct->write_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_read_stride      : "UH_FMT"\n", ptr_struct->log_read_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_write_stride     : "UH_FMT"\n", ptr_struct->log_write_stride);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "line_start_offset    : "UH_FMT"\n", ptr_struct->line_start_offset);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iterations           : "UH_FMT"\n", ptr_struct->iterations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "first_line_hit       : "UH_FMT"\n", ptr_struct->first_line_hit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "number_of_hits       : "U32H_FMT"\n", ptr_struct->number_of_hits);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_data:\n");
	connectib_grepper_dwords_print(&(ptr_struct->write_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_mask:\n");
	connectib_grepper_dwords_print(&(ptr_struct->write_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data:\n");
	connectib_grepper_dwords_print(&(ptr_struct->compare_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_mask:\n");
	connectib_grepper_dwords_print(&(ptr_struct->compare_mask), file, indent_level + 1);

}

int connectib_icmd_grepper_size(void){
	 return 512;
}

void connectib_icmd_grepper_dump(const struct connectib_icmd_grepper *ptr_struct, FILE* file) {
	connectib_icmd_grepper_print(ptr_struct, file, 0);
}

void connectib_icmd_debug_fw_tracer_pack(const struct connectib_icmd_debug_fw_tracer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 384, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->arg[i]);
	}

	offset=284;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->num_of_args);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_of_iterations);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->iter_delay);

}

void connectib_icmd_debug_fw_tracer_unpack(struct connectib_icmd_debug_fw_tracer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 384, 1);
	ptr_struct->arg[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=284;
	ptr_struct->num_of_args = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->num_of_iterations = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->iter_delay = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_debug_fw_tracer_print(const struct connectib_icmd_debug_fw_tracer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_debug_fw_tracer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "arg_%03d             : "U32H_FMT"\n", i, ptr_struct->arg[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_args          : "UH_FMT"\n", ptr_struct->num_of_args);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_of_iterations    : "U32H_FMT"\n", ptr_struct->num_of_iterations);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "iter_delay           : "U32H_FMT"\n", ptr_struct->iter_delay);

}

int connectib_icmd_debug_fw_tracer_size(void){
	 return 48;
}

void connectib_icmd_debug_fw_tracer_dump(const struct connectib_icmd_debug_fw_tracer *ptr_struct, FILE* file) {
	connectib_icmd_debug_fw_tracer_print(ptr_struct, file, 0);
}

void connectib_icmd_get_open_resources_pack(const struct connectib_icmd_get_open_resources *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->icm_res_type);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->start_index);

	offset=159;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->more);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->output_size);

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(256, 128, i, 6144, 1);
	connectib_index_and_length_pack(&(ptr_struct->open_resources[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_open_resources_unpack(struct connectib_icmd_get_open_resources *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->icm_res_type = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->start_index = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=159;
	ptr_struct->more = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=160;
	ptr_struct->output_size = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 32; i++) {
	offset=adb2c_calc_array_field_address(256, 128, i, 6144, 1);
	connectib_index_and_length_unpack(&(ptr_struct->open_resources[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_get_open_resources_print(const struct connectib_icmd_get_open_resources *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_open_resources ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_res_type         : "U32H_FMT"\n", ptr_struct->icm_res_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "start_index          : "U64H_FMT"\n", ptr_struct->start_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "more                 : "UH_FMT"\n", ptr_struct->more);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "output_size          : "U32H_FMT"\n", ptr_struct->output_size);

	for (i=0; i < 32; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "open_resources_%03d:\n", i);
	connectib_index_and_length_print(&(ptr_struct->open_resources[i]), file, indent_level + 1);
	}

}

int connectib_icmd_get_open_resources_size(void){
	 return 768;
}

void connectib_icmd_get_open_resources_dump(const struct connectib_icmd_get_open_resources *ptr_struct, FILE* file) {
	connectib_icmd_get_open_resources_print(ptr_struct, file, 0);
}

void connectib_icmd_read_icm_dummy_addr_pack(const struct connectib_icmd_read_icm_dummy_addr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->dummy_idx);

	offset=93;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->hop_num);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->dummy_addr);

}

void connectib_icmd_read_icm_dummy_addr_unpack(struct connectib_icmd_read_icm_dummy_addr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=56;
	ptr_struct->dummy_idx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=93;
	ptr_struct->hop_num = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=128;
	ptr_struct->dummy_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_read_icm_dummy_addr_print(const struct connectib_icmd_read_icm_dummy_addr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_icm_dummy_addr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dummy_idx            : "UH_FMT"\n", ptr_struct->dummy_idx);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_num              : "UH_FMT"\n", ptr_struct->hop_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dummy_addr           : "U64H_FMT"\n", ptr_struct->dummy_addr);

}

int connectib_icmd_read_icm_dummy_addr_size(void){
	 return 32;
}

void connectib_icmd_read_icm_dummy_addr_dump(const struct connectib_icmd_read_icm_dummy_addr *ptr_struct, FILE* file) {
	connectib_icmd_read_icm_dummy_addr_print(ptr_struct, file, 0);
}

void connectib_icmd_read_icm_tlb_line_pack(const struct connectib_icmd_read_icm_tlb_line *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 640, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->data[i]);
	}

	offset=512;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->tlb_addr);

	offset=604;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hop_number);

}

void connectib_icmd_read_icm_tlb_line_unpack(struct connectib_icmd_read_icm_tlb_line *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 8; i++) {
	offset=adb2c_calc_array_field_address(0, 64, i, 640, 1);
	ptr_struct->data[i] = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);
	}

	offset=512;
	ptr_struct->tlb_addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=604;
	ptr_struct->hop_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_read_icm_tlb_line_print(const struct connectib_icmd_read_icm_tlb_line *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_icm_tlb_line ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 8; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U64H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tlb_addr             : "U64H_FMT"\n", ptr_struct->tlb_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_number           : "UH_FMT"\n", ptr_struct->hop_number);

}

int connectib_icmd_read_icm_tlb_line_size(void){
	 return 80;
}

void connectib_icmd_read_icm_tlb_line_dump(const struct connectib_icmd_read_icm_tlb_line *ptr_struct, FILE* file) {
	connectib_icmd_read_icm_tlb_line_print(ptr_struct, file, 0);
}

void connectib_icmd_config_cc_pack(const struct connectib_icmd_config_cc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->opcode);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->portid);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->cc_mode);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->sl_map);

	offset=56;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->base);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->num_entries);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(2048, 64, i, 6144, 1);
	connectib_ca_congestion_entry_pack(&(ptr_struct->ca_congestion_entry_list[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(4112, 16, i, 6144, 1);
	connectib_cc_table_entry_pack(&(ptr_struct->ccti_entry_list[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_config_cc_unpack(struct connectib_icmd_config_cc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=30;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=27;
	ptr_struct->portid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=22;
	ptr_struct->cc_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=0;
	ptr_struct->sl_map = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=56;
	ptr_struct->base = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=40;
	ptr_struct->num_entries = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(2048, 64, i, 6144, 1);
	connectib_ca_congestion_entry_unpack(&(ptr_struct->ca_congestion_entry_list[i]), ptr_buff + offset/8);
	}

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(4112, 16, i, 6144, 1);
	connectib_cc_table_entry_unpack(&(ptr_struct->ccti_entry_list[i]), ptr_buff + offset/8);
	}

}

void connectib_icmd_config_cc_print(const struct connectib_icmd_config_cc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_config_cc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "portid               : "UH_FMT"\n", ptr_struct->portid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cc_mode              : "UH_FMT"\n", ptr_struct->cc_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_map               : "UH_FMT"\n", ptr_struct->sl_map);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "base                 : "UH_FMT"\n", ptr_struct->base);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_entries          : "UH_FMT"\n", ptr_struct->num_entries);

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ca_congestion_entry_list_%03d:\n", i);
	connectib_ca_congestion_entry_print(&(ptr_struct->ca_congestion_entry_list[i]), file, indent_level + 1);
	}

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ccti_entry_list_%03d:\n", i);
	connectib_cc_table_entry_print(&(ptr_struct->ccti_entry_list[i]), file, indent_level + 1);
	}

}

int connectib_icmd_config_cc_size(void){
	 return 768;
}

void connectib_icmd_config_cc_dump(const struct connectib_icmd_config_cc *ptr_struct, FILE* file) {
	connectib_icmd_config_cc_print(ptr_struct, file, 0);
}

void connectib_icmd_write_dc_cnak_lid_pack(const struct connectib_icmd_write_dc_cnak_lid *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->gvmi);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->port);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lid);

}

void connectib_icmd_write_dc_cnak_lid_unpack(struct connectib_icmd_write_dc_cnak_lid *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->gvmi = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=62;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=80;
	ptr_struct->lid = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_write_dc_cnak_lid_print(const struct connectib_icmd_write_dc_cnak_lid *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_write_dc_cnak_lid ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "U32H_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lid                  : "UH_FMT"\n", ptr_struct->lid);

}

int connectib_icmd_write_dc_cnak_lid_size(void){
	 return 64;
}

void connectib_icmd_write_dc_cnak_lid_dump(const struct connectib_icmd_write_dc_cnak_lid *ptr_struct, FILE* file) {
	connectib_icmd_write_dc_cnak_lid_print(ptr_struct, file, 0);
}

void connectib_icmd_congestion_log_pack(const struct connectib_icmd_congestion_log *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->port);

	offset=128;
	connectib_congestion_log_event_entry_pack(&(ptr_struct->log_entry), ptr_buff + offset/8);

}

void connectib_icmd_congestion_log_unpack(struct connectib_icmd_congestion_log *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=62;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=128;
	connectib_congestion_log_event_entry_unpack(&(ptr_struct->log_entry), ptr_buff + offset/8);

}

void connectib_icmd_congestion_log_print(const struct connectib_icmd_congestion_log *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_congestion_log ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_entry:\n");
	connectib_congestion_log_event_entry_print(&(ptr_struct->log_entry), file, indent_level + 1);

}

int connectib_icmd_congestion_log_size(void){
	 return 64;
}

void connectib_icmd_congestion_log_dump(const struct connectib_icmd_congestion_log *ptr_struct, FILE* file) {
	connectib_icmd_congestion_log_print(ptr_struct, file, 0);
}

void connectib_icmd_get_port_sniffer_pack(const struct connectib_icmd_get_port_sniffer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sx_port1);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sx_port2);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_port1);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rx_port2);

}

void connectib_icmd_get_port_sniffer_unpack(struct connectib_icmd_get_port_sniffer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->sx_port1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=40;
	ptr_struct->sx_port2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=72;
	ptr_struct->rx_port1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->rx_port2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_icmd_get_port_sniffer_print(const struct connectib_icmd_get_port_sniffer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_port_sniffer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_port1             : "UH_FMT"\n", ptr_struct->sx_port1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_port2             : "UH_FMT"\n", ptr_struct->sx_port2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_port1             : "UH_FMT"\n", ptr_struct->rx_port1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rx_port2             : "UH_FMT"\n", ptr_struct->rx_port2);

}

int connectib_icmd_get_port_sniffer_size(void){
	 return 16;
}

void connectib_icmd_get_port_sniffer_dump(const struct connectib_icmd_get_port_sniffer *ptr_struct, FILE* file) {
	connectib_icmd_get_port_sniffer_print(ptr_struct, file, 0);
}

void connectib_icmd_set_port_sniffer_pack(const struct connectib_icmd_set_port_sniffer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->sx_rx_);

	offset=47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->attach_detach_);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->sniffer_qpn);

}

void connectib_icmd_set_port_sniffer_unpack(struct connectib_icmd_set_port_sniffer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=63;
	ptr_struct->sx_rx_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=47;
	ptr_struct->attach_detach_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=104;
	ptr_struct->sniffer_qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_icmd_set_port_sniffer_print(const struct connectib_icmd_set_port_sniffer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_set_port_sniffer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sx_rx_               : "UH_FMT"\n", ptr_struct->sx_rx_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "attach_detach_       : "UH_FMT"\n", ptr_struct->attach_detach_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sniffer_qpn          : "UH_FMT"\n", ptr_struct->sniffer_qpn);

}

int connectib_icmd_set_port_sniffer_size(void){
	 return 16;
}

void connectib_icmd_set_port_sniffer_dump(const struct connectib_icmd_set_port_sniffer *ptr_struct, FILE* file) {
	connectib_icmd_set_port_sniffer_print(ptr_struct, file, 0);
}

void connectib_icmd_special_qps_pack(const struct connectib_icmd_special_qps *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_special_qps_pack(&(ptr_struct->qps), ptr_buff + offset/8);

	offset=2064;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=2063;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->port);

}

void connectib_icmd_special_qps_unpack(struct connectib_icmd_special_qps *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_special_qps_unpack(&(ptr_struct->qps), ptr_buff + offset/8);

	offset=2064;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=2063;
	ptr_struct->port = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_special_qps_print(const struct connectib_icmd_special_qps *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_special_qps ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qps:\n");
	connectib_special_qps_print(&(ptr_struct->qps), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port                 : "UH_FMT"\n", ptr_struct->port);

}

int connectib_icmd_special_qps_size(void){
	 return 260;
}

void connectib_icmd_special_qps_dump(const struct connectib_icmd_special_qps *ptr_struct, FILE* file) {
	connectib_icmd_special_qps_print(ptr_struct, file, 0);
}

void connectib_eqn4type_pack(const struct connectib_eqn4type *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2080, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->eqn[i]);
	}

	offset=2064;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

}

void connectib_eqn4type_unpack(struct connectib_eqn4type *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2080, 1);
	ptr_struct->eqn[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=2064;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_eqn4type_print(const struct connectib_eqn4type *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_eqn4type ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqn_%03d             : "U32H_FMT"\n", i, ptr_struct->eqn[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

}

int connectib_eqn4type_size(void){
	 return 260;
}

void connectib_eqn4type_dump(const struct connectib_eqn4type *ptr_struct, FILE* file) {
	connectib_eqn4type_print(ptr_struct, file, 0);
}

void connectib_icmd_access_cmdq_pack(const struct connectib_icmd_access_cmdq *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_cmdif_hdr_pack(&(ptr_struct->cmdq), ptr_buff + offset/8);

	offset=528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=523;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->cmd_ix);

}

void connectib_icmd_access_cmdq_unpack(struct connectib_icmd_access_cmdq *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_cmdif_hdr_unpack(&(ptr_struct->cmdq), ptr_buff + offset/8);

	offset=528;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=523;
	ptr_struct->cmd_ix = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_icmd_access_cmdq_print(const struct connectib_icmd_access_cmdq *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_cmdq ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmdq:\n");
	connectib_cmdif_hdr_print(&(ptr_struct->cmdq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmd_ix               : "UH_FMT"\n", ptr_struct->cmd_ix);

}

int connectib_icmd_access_cmdq_size(void){
	 return 72;
}

void connectib_icmd_access_cmdq_dump(const struct connectib_icmd_access_cmdq *ptr_struct, FILE* file) {
	connectib_icmd_access_cmdq_print(ptr_struct, file, 0);
}

void connectib_icmd_read_sx_wq_buffer_pack(const struct connectib_icmd_read_sx_wq_buffer *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 576, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=539;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->ec);

	offset=571;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->wqe_idx);

}

void connectib_icmd_read_sx_wq_buffer_unpack(struct connectib_icmd_read_sx_wq_buffer *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 576, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=539;
	ptr_struct->ec = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=571;
	ptr_struct->wqe_idx = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

}

void connectib_icmd_read_sx_wq_buffer_print(const struct connectib_icmd_read_sx_wq_buffer *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_sx_wq_buffer ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ec                   : "UH_FMT"\n", ptr_struct->ec);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_idx              : "UH_FMT"\n", ptr_struct->wqe_idx);

}

int connectib_icmd_read_sx_wq_buffer_size(void){
	 return 72;
}

void connectib_icmd_read_sx_wq_buffer_dump(const struct connectib_icmd_read_sx_wq_buffer *ptr_struct, FILE* file) {
	connectib_icmd_read_sx_wq_buffer_print(ptr_struct, file, 0);
}

void connectib_icmd_header_capture_pack(const struct connectib_icmd_header_capture *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_header_capture_headers_pack(&(ptr_struct->headers), ptr_buff + offset/8);

	offset=1024;
	connectib_icmd_header_capture_checks_pack(&(ptr_struct->checks), ptr_buff + offset/8);

}

void connectib_icmd_header_capture_unpack(struct connectib_icmd_header_capture *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_header_capture_headers_unpack(&(ptr_struct->headers), ptr_buff + offset/8);

	offset=1024;
	connectib_icmd_header_capture_checks_unpack(&(ptr_struct->checks), ptr_buff + offset/8);

}

void connectib_icmd_header_capture_print(const struct connectib_icmd_header_capture *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_header_capture ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "headers:\n");
	connectib_icmd_header_capture_headers_print(&(ptr_struct->headers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "checks:\n");
	connectib_icmd_header_capture_checks_print(&(ptr_struct->checks), file, indent_level + 1);

}

int connectib_icmd_header_capture_size(void){
	 return 192;
}

void connectib_icmd_header_capture_dump(const struct connectib_icmd_header_capture *ptr_struct, FILE* file) {
	connectib_icmd_header_capture_print(ptr_struct, file, 0);
}

void connectib_print_icm_pack(const struct connectib_print_icm *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_specific_gvmi);

	offset=30;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->enable_specific_icm_type);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->icm_res_type);

}

void connectib_print_icm_unpack(struct connectib_print_icm *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->enable_specific_gvmi = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=30;
	ptr_struct->enable_specific_icm_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->icm_res_type = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_print_icm_print(const struct connectib_print_icm *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_print_icm ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_specific_gvmi : "UH_FMT"\n", ptr_struct->enable_specific_gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "enable_specific_icm_type : "UH_FMT"\n", ptr_struct->enable_specific_icm_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icm_res_type         : "UH_FMT"\n", ptr_struct->icm_res_type);

}

int connectib_print_icm_size(void){
	 return 8;
}

void connectib_print_icm_dump(const struct connectib_print_icm *ptr_struct, FILE* file) {
	connectib_print_icm_print(ptr_struct, file, 0);
}

void connectib_icmd_fw_reset_pack(const struct connectib_icmd_fw_reset *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->protection);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->reset_mode);

}

void connectib_icmd_fw_reset_unpack(struct connectib_icmd_fw_reset *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->protection = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=62;
	ptr_struct->reset_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

}

void connectib_icmd_fw_reset_print(const struct connectib_icmd_fw_reset *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_fw_reset ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "protection           : "U32H_FMT"\n", ptr_struct->protection);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_mode           : "UH_FMT"\n", ptr_struct->reset_mode);

}

int connectib_icmd_fw_reset_size(void){
	 return 8;
}

void connectib_icmd_fw_reset_dump(const struct connectib_icmd_fw_reset *ptr_struct, FILE* file) {
	connectib_icmd_fw_reset_print(ptr_struct, file, 0);
}

void connectib_icmd_read_g_rse_slice_desc_pack(const struct connectib_icmd_read_g_rse_slice_desc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_g_rse_hw_decoders_pack(&(ptr_struct->desc), ptr_buff + offset/8);

	offset=2075;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->slice);

	offset=2068;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->array_index);

	offset=2104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->desc_type);

}

void connectib_icmd_read_g_rse_slice_desc_unpack(struct connectib_icmd_read_g_rse_slice_desc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_g_rse_hw_decoders_unpack(&(ptr_struct->desc), ptr_buff + offset/8);

	offset=2075;
	ptr_struct->slice = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=2068;
	ptr_struct->array_index = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=2104;
	ptr_struct->desc_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_read_g_rse_slice_desc_print(const struct connectib_icmd_read_g_rse_slice_desc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_g_rse_slice_desc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "desc:\n");
	connectib_g_rse_hw_decoders_print(&(ptr_struct->desc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slice                : "UH_FMT"\n", ptr_struct->slice);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "array_index          : "UH_FMT"\n", ptr_struct->array_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "desc_type            : "UH_FMT"\n", ptr_struct->desc_type);

}

int connectib_icmd_read_g_rse_slice_desc_size(void){
	 return 264;
}

void connectib_icmd_read_g_rse_slice_desc_dump(const struct connectib_icmd_read_g_rse_slice_desc *ptr_struct, FILE* file) {
	connectib_icmd_read_g_rse_slice_desc_print(ptr_struct, file, 0);
}

void connectib_icmd_read_rx_slice_packet_pack(const struct connectib_icmd_read_rx_slice_packet *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4192, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=4116;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->packet_size);

	offset=4155;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->slice);

	offset=4180;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->size);

	offset=4164;
	adb2c_push_bits_to_buff(ptr_buff, offset, 12, (u_int32_t)ptr_struct->offset_dw);

}

void connectib_icmd_read_rx_slice_packet_unpack(struct connectib_icmd_read_rx_slice_packet *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4192, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=4116;
	ptr_struct->packet_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=4155;
	ptr_struct->slice = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=4180;
	ptr_struct->size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

	offset=4164;
	ptr_struct->offset_dw = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 12);

}

void connectib_icmd_read_rx_slice_packet_print(const struct connectib_icmd_read_rx_slice_packet *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_rx_slice_packet ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "packet_size          : "UH_FMT"\n", ptr_struct->packet_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slice                : "UH_FMT"\n", ptr_struct->slice);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "offset_dw            : "UH_FMT"\n", ptr_struct->offset_dw);

}

int connectib_icmd_read_rx_slice_packet_size(void){
	 return 524;
}

void connectib_icmd_read_rx_slice_packet_dump(const struct connectib_icmd_read_rx_slice_packet *ptr_struct, FILE* file) {
	connectib_icmd_read_rx_slice_packet_print(ptr_struct, file, 0);
}

void connectib_icmd_get_fw_info_pack(const struct connectib_icmd_get_fw_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_FW_VERSION_pack(&(ptr_struct->fw_version), ptr_buff + offset/8);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->hash_signature);

}

void connectib_icmd_get_fw_info_unpack(struct connectib_icmd_get_fw_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_FW_VERSION_unpack(&(ptr_struct->fw_version), ptr_buff + offset/8);

	offset=144;
	ptr_struct->hash_signature = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_get_fw_info_print(const struct connectib_icmd_get_fw_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_fw_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_version:\n");
	connectib_FW_VERSION_print(&(ptr_struct->fw_version), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hash_signature       : "UH_FMT"\n", ptr_struct->hash_signature);

}

int connectib_icmd_get_fw_info_size(void){
	 return 32;
}

void connectib_icmd_get_fw_info_dump(const struct connectib_icmd_get_fw_info *ptr_struct, FILE* file) {
	connectib_icmd_get_fw_info_print(ptr_struct, file, 0);
}

void connectib_icmd_get_link_leds_pack(const struct connectib_icmd_get_link_leds *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->port_number);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->physical_link);

	offset=55;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->logical_link);

}

void connectib_icmd_get_link_leds_unpack(struct connectib_icmd_get_link_leds *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->port_number = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=63;
	ptr_struct->physical_link = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=55;
	ptr_struct->logical_link = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_icmd_get_link_leds_print(const struct connectib_icmd_get_link_leds *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_link_leds ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "port_number          : "UH_FMT"\n", ptr_struct->port_number);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "physical_link        : "UH_FMT"\n", ptr_struct->physical_link);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "logical_link         : "UH_FMT"\n", ptr_struct->logical_link);

}

int connectib_icmd_get_link_leds_size(void){
	 return 8;
}

void connectib_icmd_get_link_leds_dump(const struct connectib_icmd_get_link_leds *ptr_struct, FILE* file) {
	connectib_icmd_get_link_leds_print(ptr_struct, file, 0);
}

void connectib_icmd_get_boot_stage_pack(const struct connectib_icmd_get_boot_stage *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->boot_stage);

}

void connectib_icmd_get_boot_stage_unpack(struct connectib_icmd_get_boot_stage *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->boot_stage = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_get_boot_stage_print(const struct connectib_icmd_get_boot_stage *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_boot_stage ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "boot_stage           : "UH_FMT"\n", ptr_struct->boot_stage);

}

int connectib_icmd_get_boot_stage_size(void){
	 return 4;
}

void connectib_icmd_get_boot_stage_dump(const struct connectib_icmd_get_boot_stage *ptr_struct, FILE* file) {
	connectib_icmd_get_boot_stage_print(ptr_struct, file, 0);
}

void connectib_icmd_get_irisc_heart_beat_pack(const struct connectib_icmd_get_irisc_heart_beat *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->irisc_heart_beat);

}

void connectib_icmd_get_irisc_heart_beat_unpack(struct connectib_icmd_get_irisc_heart_beat *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->irisc_heart_beat = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_icmd_get_irisc_heart_beat_print(const struct connectib_icmd_get_irisc_heart_beat *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_get_irisc_heart_beat ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "irisc_heart_beat     : "UH_FMT"\n", ptr_struct->irisc_heart_beat);

}

int connectib_icmd_get_irisc_heart_beat_size(void){
	 return 4;
}

void connectib_icmd_get_irisc_heart_beat_dump(const struct connectib_icmd_get_irisc_heart_beat *ptr_struct, FILE* file) {
	connectib_icmd_get_irisc_heart_beat_print(ptr_struct, file, 0);
}

void connectib_icmd_read_q_entry_pack(const struct connectib_icmd_read_q_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4192, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=4112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=4136;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->q_num);

	offset=4128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->q_type);

	offset=4160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->index);

}

void connectib_icmd_read_q_entry_unpack(struct connectib_icmd_read_q_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 128; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 4192, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=4112;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=4136;
	ptr_struct->q_num = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=4128;
	ptr_struct->q_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=4160;
	ptr_struct->index = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_read_q_entry_print(const struct connectib_icmd_read_q_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_read_q_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 128; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "q_num                : "UH_FMT"\n", ptr_struct->q_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "q_type               : "UH_FMT"\n", ptr_struct->q_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "index                : "U32H_FMT"\n", ptr_struct->index);

}

int connectib_icmd_read_q_entry_size(void){
	 return 524;
}

void connectib_icmd_read_q_entry_dump(const struct connectib_icmd_read_q_entry *ptr_struct, FILE* file) {
	connectib_icmd_read_q_entry_print(ptr_struct, file, 0);
}

void connectib_icmd_access_host_mem_pack(const struct connectib_icmd_access_host_mem *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2304, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->data[i]);
	}

	offset=2064;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=2048;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=2080;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->num_dwords);

	offset=2112;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->addr);

	offset=2176;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->key_or_ptr);

	offset=2270;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->addr_type);

	offset=2240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->l2_block_s);

}

void connectib_icmd_access_host_mem_unpack(struct connectib_icmd_access_host_mem *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 64; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 2304, 1);
	ptr_struct->data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=2064;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=2048;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=2080;
	ptr_struct->num_dwords = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=2112;
	ptr_struct->addr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=2176;
	ptr_struct->key_or_ptr = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=2270;
	ptr_struct->addr_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=2240;
	ptr_struct->l2_block_s = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_access_host_mem_print(const struct connectib_icmd_access_host_mem *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_host_mem ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 64; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "data_%03d            : "U32H_FMT"\n", i, ptr_struct->data[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "num_dwords           : "U32H_FMT"\n", ptr_struct->num_dwords);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr                 : "U64H_FMT"\n", ptr_struct->addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "key_or_ptr           : "U64H_FMT"\n", ptr_struct->key_or_ptr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "addr_type            : "UH_FMT"\n", ptr_struct->addr_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l2_block_s           : "UH_FMT"\n", ptr_struct->l2_block_s);

}

int connectib_icmd_access_host_mem_size(void){
	 return 288;
}

void connectib_icmd_access_host_mem_dump(const struct connectib_icmd_access_host_mem *ptr_struct, FILE* file) {
	connectib_icmd_access_host_mem_print(ptr_struct, file, 0);
}

void connectib_icmd_access_icm_ctx_pack(const struct connectib_icmd_access_icm_ctx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_golan_hw_fw_ctx_pack(&(ptr_struct->ctx), ptr_buff + offset/8);

	offset=528;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=512;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rw_);

	offset=560;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->ctx_type);

	offset=576;
	adb2c_push_integer_to_buff(ptr_buff, offset, 8, ptr_struct->ctx_num);

	offset=640;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ctx_num2);

}

void connectib_icmd_access_icm_ctx_unpack(struct connectib_icmd_access_icm_ctx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_golan_hw_fw_ctx_unpack(&(ptr_struct->ctx), ptr_buff + offset/8);

	offset=528;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=512;
	ptr_struct->rw_ = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=560;
	ptr_struct->ctx_type = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=576;
	ptr_struct->ctx_num = adb2c_pop_integer_from_buff(ptr_buff, offset, 8);

	offset=640;
	ptr_struct->ctx_num2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_icmd_access_icm_ctx_print(const struct connectib_icmd_access_icm_ctx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_access_icm_ctx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx:\n");
	connectib_golan_hw_fw_ctx_print(&(ptr_struct->ctx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_                  : "UH_FMT"\n", ptr_struct->rw_);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx_type             : %s ("UH_FMT")\n", (ptr_struct->ctx_type == 95 ? (" MTT") : ((ptr_struct->ctx_type == 1 ? ("SQ_QP_LIST_REQ") : ((ptr_struct->ctx_type == 2 ? (" SQ_QP_LIST_RES") : ((ptr_struct->ctx_type == 3 ? (" BSF") : ((ptr_struct->ctx_type == 4 ? (" RDB") : ((ptr_struct->ctx_type == 5 ? (" EXT_RDB") : ((ptr_struct->ctx_type == 6 ? ("ICM_CRC") : ((ptr_struct->ctx_type == 7 ? ("QP_COMMON") : ((ptr_struct->ctx_type == 8 ? ("REQUESTOR_QPC") : ((ptr_struct->ctx_type == 9 ? (" RESPONDER_QPC") : ((ptr_struct->ctx_type == 10 ? ("MKEY") : ((ptr_struct->ctx_type == 11 ? ("SRQ") : ((ptr_struct->ctx_type == 12 ? ("CQ") : ((ptr_struct->ctx_type == 13 ? ("TRANS_STATUS_BSF") : ((ptr_struct->ctx_type == 14 ? ("TRANS_STATUS_KLM") : ((ptr_struct->ctx_type == 15 ? ("PSV") : ((ptr_struct->ctx_type == 16 ? ("EXT_PSV") : ((ptr_struct->ctx_type == 17 ? ("SXDC") : ((ptr_struct->ctx_type == 18 ? ("PIPA") : ((ptr_struct->ctx_type == 19 ? (" TIMER") : ((ptr_struct->ctx_type == 21 ? ("EQ") : ((ptr_struct->ctx_type == 22 ? ("MSIX") : ((ptr_struct->ctx_type == 23 ? ("SXD_GVMI_RATE_LIMITER") : ((ptr_struct->ctx_type == 24 ? ("PORT0_PKEY") : ((ptr_struct->ctx_type == 25 ? ("PORT0_GUID") : ((ptr_struct->ctx_type == 26 ? ("PORT0_INFO") : ((ptr_struct->ctx_type == 27 ? ("PORT0_COUNTERS_GVMI_RX") : ((ptr_struct->ctx_type == 28 ? (" PORT1_PKEY") : ((ptr_struct->ctx_type == 29 ? ("PORT1_GUID") : ((ptr_struct->ctx_type == 30 ? ("PORT1_INFO") : ((ptr_struct->ctx_type == 31 ? ("PORT1_COUNTERS_GVMI_RX") : ((ptr_struct->ctx_type == 32 ? ("STEERING") : ((ptr_struct->ctx_type == 33 ? ("LDB_CACHE") : ((ptr_struct->ctx_type == 34 ? ("REQ_SL_CACHE") : ((ptr_struct->ctx_type == 35 ? ("IRISC") : ((ptr_struct->ctx_type == 36 ? (" SCRATCHPAD") : ((ptr_struct->ctx_type == 37 ? ("SQ_POINTERS") : ((ptr_struct->ctx_type == 38 ? ("SQ_TOKENS") : ((ptr_struct->ctx_type == 39 ? ("TOC") : ((ptr_struct->ctx_type == 40 ? ("FW_GVMI_CTX") : ((ptr_struct->ctx_type == 41 ? ("FW_QPC") : ((ptr_struct->ctx_type == 42 ? ("FW_MALLOC") : ((ptr_struct->ctx_type == 43 ? ("FW_PD") : ((ptr_struct->ctx_type == 44 ? ("FW_UAR") : ((ptr_struct->ctx_type == 45 ? ("FW_EQ") : ((ptr_struct->ctx_type == 46 ? (" FW_CQ") : ((ptr_struct->ctx_type == 47 ? ("FW_MKEY") : ((ptr_struct->ctx_type == 48 ? ("FW_SRQ") : ((ptr_struct->ctx_type == 49 ? ("FW_GLOBAL") : ((ptr_struct->ctx_type == 50 ? ("FW_SQ") : ((ptr_struct->ctx_type == 51 ? ("GLOBAL_FW_GVMI_CTX") : ((ptr_struct->ctx_type == 52 ? ("FW_ALT_PATH") : ((ptr_struct->ctx_type == 53 ? ("COUNTERS_QP_RX") : ((ptr_struct->ctx_type == 54 ? (" PORT0_COUNTERS_GVMI_SX") : ((ptr_struct->ctx_type == 55 ? ("PORT1_COUNTERS_GVMI_SX") : ((ptr_struct->ctx_type == 56 ? ("FW_LL_QP_REQ") : ((ptr_struct->ctx_type == 57 ? ("FW_LL_QP_RES") : ((ptr_struct->ctx_type == 58 ? ("FW_LL_CQ_OVERRUN") : ((ptr_struct->ctx_type == 59 ? ("FW_LL_EQ_OVERRUN_CQ") : ((ptr_struct->ctx_type == 60 ? (" FW_LL_EQ_OVERRUN_EQ") : ((ptr_struct->ctx_type == 61 ? ("EQ_OVERRUN_LIST_META") : ((ptr_struct->ctx_type == 62 ? ("ICM_RES_FW_XRCD") : ((ptr_struct->ctx_type == 63 ? ("ICM_RES_FW_FREE_LIST") : ((ptr_struct->ctx_type == 78 ? ("COUNTERS_QP_SX") : ("unknown")))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))), ptr_struct->ctx_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx_num              : "U64H_FMT"\n", ptr_struct->ctx_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctx_num2             : "U32H_FMT"\n", ptr_struct->ctx_num2);

}

int connectib_icmd_access_icm_ctx_size(void){
	 return 96;
}

void connectib_icmd_access_icm_ctx_dump(const struct connectib_icmd_access_icm_ctx *ptr_struct, FILE* file) {
	connectib_icmd_access_icm_ctx_print(ptr_struct, file, 0);
}

void connectib_icmd_cmd_as_dwords_pack(const struct connectib_icmd_cmd_as_dwords *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 192; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 6144, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dword[i]);
	}

}

void connectib_icmd_cmd_as_dwords_unpack(struct connectib_icmd_cmd_as_dwords *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 192; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 6144, 1);
	ptr_struct->dword[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_icmd_cmd_as_dwords_print(const struct connectib_icmd_cmd_as_dwords *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_cmd_as_dwords ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 192; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dword_%03d           : "U32H_FMT"\n", i, ptr_struct->dword[i]);
	}

}

int connectib_icmd_cmd_as_dwords_size(void){
	 return 768;
}

void connectib_icmd_cmd_as_dwords_dump(const struct connectib_icmd_cmd_as_dwords *ptr_struct, FILE* file) {
	connectib_icmd_cmd_as_dwords_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_64b_pack(const struct connectib_sw_cqe_64b *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_5);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_4);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->checksum);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rsvd_3);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ip_status);

	offset=144;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->slid_smac_47_32);

	offset=128;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vlan_ml_path);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->slid_smac_31_0);

	offset=200;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->rqpn);

	offset=196;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl_vlan_type);

	offset=194;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->g);

	offset=193;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fl);

	offset=192;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->rsvd_bit);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rss_val);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_num);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rsvd_1);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->imm_inv_key);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_0);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->byte_count);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_h);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_l);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swqe_opcode_drop_cntr);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->owner);

	offset=510;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->se);

	offset=508;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->inline_scatter);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_opcode);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wqe_counter);

}

void connectib_sw_cqe_64b_unpack(struct connectib_sw_cqe_64b *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rsvd_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rsvd_4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=80;
	ptr_struct->checksum = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->rsvd_3 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->ip_status = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=144;
	ptr_struct->slid_smac_47_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=128;
	ptr_struct->vlan_ml_path = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=160;
	ptr_struct->slid_smac_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=200;
	ptr_struct->rqpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=196;
	ptr_struct->sl_vlan_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=194;
	ptr_struct->g = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=193;
	ptr_struct->fl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=192;
	ptr_struct->rsvd_bit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=224;
	ptr_struct->rss_val = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=264;
	ptr_struct->srq_num = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=256;
	ptr_struct->rsvd_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->imm_inv_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->rsvd_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->byte_count = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->timestamp_h = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->timestamp_l = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=456;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=448;
	ptr_struct->swqe_opcode_drop_cntr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=511;
	ptr_struct->owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=510;
	ptr_struct->se = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=508;
	ptr_struct->inline_scatter = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=504;
	ptr_struct->rwqe_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=496;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->wqe_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_sw_cqe_64b_print(const struct connectib_sw_cqe_64b *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe_64b ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_5               : "U32H_FMT"\n", ptr_struct->rsvd_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_4               : "U32H_FMT"\n", ptr_struct->rsvd_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "checksum             : "UH_FMT"\n", ptr_struct->checksum);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_3               : "UH_FMT"\n", ptr_struct->rsvd_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ip_status            : "U32H_FMT"\n", ptr_struct->ip_status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid_smac_47_32      : "UH_FMT"\n", ptr_struct->slid_smac_47_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vlan_ml_path         : "UH_FMT"\n", ptr_struct->vlan_ml_path);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid_smac_31_0       : "U32H_FMT"\n", ptr_struct->slid_smac_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rqpn                 : "UH_FMT"\n", ptr_struct->rqpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl_vlan_type         : "UH_FMT"\n", ptr_struct->sl_vlan_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "g                    : "UH_FMT"\n", ptr_struct->g);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fl                   : "UH_FMT"\n", ptr_struct->fl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_bit             : "UH_FMT"\n", ptr_struct->rsvd_bit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rss_val              : "U32H_FMT"\n", ptr_struct->rss_val);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_num              : "UH_FMT"\n", ptr_struct->srq_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_1               : "UH_FMT"\n", ptr_struct->rsvd_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "imm_inv_key          : "U32H_FMT"\n", ptr_struct->imm_inv_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_0               : "U32H_FMT"\n", ptr_struct->rsvd_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_count           : "U32H_FMT"\n", ptr_struct->byte_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_h          : "U32H_FMT"\n", ptr_struct->timestamp_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_l          : "U32H_FMT"\n", ptr_struct->timestamp_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_opcode_drop_cntr : "UH_FMT"\n", ptr_struct->swqe_opcode_drop_cntr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner                : "UH_FMT"\n", ptr_struct->owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "se                   : "UH_FMT"\n", ptr_struct->se);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_scatter       : "UH_FMT"\n", ptr_struct->inline_scatter);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_opcode          : "UH_FMT"\n", ptr_struct->rwqe_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_counter          : "UH_FMT"\n", ptr_struct->wqe_counter);

}

int connectib_sw_cqe_64b_size(void){
	 return 64;
}

void connectib_sw_cqe_64b_dump(const struct connectib_sw_cqe_64b *ptr_struct, FILE* file) {
	connectib_sw_cqe_64b_print(ptr_struct, file, 0);
}

void connectib_grh_inline_data_pack(const struct connectib_grh_inline_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->grh_inline_data[i]);
	}

}

void connectib_grh_inline_data_unpack(struct connectib_grh_inline_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(0, 32, i, 512, 1);
	ptr_struct->grh_inline_data[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

}

void connectib_grh_inline_data_print(const struct connectib_grh_inline_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_grh_inline_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	for (i=0; i < 16; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_inline_data_%03d : "U32H_FMT"\n", i, ptr_struct->grh_inline_data[i]);
	}

}

int connectib_grh_inline_data_size(void){
	 return 64;
}

void connectib_grh_inline_data_dump(const struct connectib_grh_inline_data *ptr_struct, FILE* file) {
	connectib_grh_inline_data_print(ptr_struct, file, 0);
}

void connectib_wqe_eth_segment_pack(const struct connectib_wqe_eth_segment *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 14, (u_int32_t)ptr_struct->mss);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l3cs_inner);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l4cs_inner);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l3cs);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->l4cs);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->inline_headers);

	offset=102;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->inline_header_size);

}

void connectib_wqe_eth_segment_unpack(struct connectib_wqe_eth_segment *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=50;
	ptr_struct->mss = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 14);

	offset=35;
	ptr_struct->l3cs_inner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=34;
	ptr_struct->l4cs_inner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->l3cs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->l4cs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->inline_headers = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=102;
	ptr_struct->inline_header_size = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

}

void connectib_wqe_eth_segment_print(const struct connectib_wqe_eth_segment *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_eth_segment ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mss                  : "UH_FMT"\n", ptr_struct->mss);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l3cs_inner           : "UH_FMT"\n", ptr_struct->l3cs_inner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l4cs_inner           : "UH_FMT"\n", ptr_struct->l4cs_inner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l3cs                 : "UH_FMT"\n", ptr_struct->l3cs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "l4cs                 : "UH_FMT"\n", ptr_struct->l4cs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_headers       : "UH_FMT"\n", ptr_struct->inline_headers);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_header_size   : "UH_FMT"\n", ptr_struct->inline_header_size);

}

int connectib_wqe_eth_segment_size(void){
	 return 16;
}

void connectib_wqe_eth_segment_dump(const struct connectib_wqe_eth_segment *ptr_struct, FILE* file) {
	connectib_wqe_eth_segment_print(ptr_struct, file, 0);
}

void connectib_wqe_inline_header_pack(const struct connectib_wqe_inline_header *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 10, (u_int32_t)ptr_struct->byte_count);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wqe_inline);

}

void connectib_wqe_inline_header_unpack(struct connectib_wqe_inline_header *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=22;
	ptr_struct->byte_count = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 10);

	offset=0;
	ptr_struct->wqe_inline = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_wqe_inline_header_print(const struct connectib_wqe_inline_header *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_inline_header ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_count           : "UH_FMT"\n", ptr_struct->byte_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_inline           : "UH_FMT"\n", ptr_struct->wqe_inline);

}

int connectib_wqe_inline_header_size(void){
	 return 4;
}

void connectib_wqe_inline_header_dump(const struct connectib_wqe_inline_header *ptr_struct, FILE* file) {
	connectib_wqe_inline_header_print(ptr_struct, file, 0);
}

void connectib_wqe_gather_scatter_entry_pack(const struct connectib_wqe_gather_scatter_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	adb2c_push_bits_to_buff(ptr_buff, offset, 31, (u_int32_t)ptr_struct->byte_count);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wqe_inline);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->local_key);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->local_address_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->local_address_31_0);

}

void connectib_wqe_gather_scatter_entry_unpack(struct connectib_wqe_gather_scatter_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=1;
	ptr_struct->byte_count = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 31);

	offset=0;
	ptr_struct->wqe_inline = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->local_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->local_address_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->local_address_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_gather_scatter_entry_print(const struct connectib_wqe_gather_scatter_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_gather_scatter_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte_count           : "UH_FMT"\n", ptr_struct->byte_count);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_inline           : "UH_FMT"\n", ptr_struct->wqe_inline);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_key            : "U32H_FMT"\n", ptr_struct->local_key);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_address_63_32  : "U32H_FMT"\n", ptr_struct->local_address_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "local_address_31_0   : "U32H_FMT"\n", ptr_struct->local_address_31_0);

}

int connectib_wqe_gather_scatter_entry_size(void){
	 return 16;
}

void connectib_wqe_gather_scatter_entry_dump(const struct connectib_wqe_gather_scatter_entry *ptr_struct, FILE* file) {
	connectib_wqe_gather_scatter_entry_print(ptr_struct, file, 0);
}

void connectib_wqe_srq_next_pack(const struct connectib_wqe_srq_next *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->next_wqe_index);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

}

void connectib_wqe_srq_next_unpack(struct connectib_wqe_srq_next *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=16;
	ptr_struct->next_wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=32;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_wqe_srq_next_print(const struct connectib_wqe_srq_next *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_srq_next ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "next_wqe_index       : "UH_FMT"\n", ptr_struct->next_wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

}

int connectib_wqe_srq_next_size(void){
	 return 16;
}

void connectib_wqe_srq_next_dump(const struct connectib_wqe_srq_next *ptr_struct, FILE* file) {
	connectib_wqe_srq_next_print(ptr_struct, file, 0);
}

void connectib_wqe_signature_pack(const struct connectib_wqe_signature *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

}

void connectib_wqe_signature_unpack(struct connectib_wqe_signature *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=32;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

}

void connectib_wqe_signature_print(const struct connectib_wqe_signature *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_signature ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

}

int connectib_wqe_signature_size(void){
	 return 16;
}

void connectib_wqe_signature_dump(const struct connectib_wqe_signature *ptr_struct, FILE* file) {
	connectib_wqe_signature_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_fetch_add_pack(const union connectib_wqe_extended_atomic_fetch_add *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_wqe_extended_atomic_fetch_add_128byte_pack(&(ptr_struct->byte128), ptr_buff);
}

void connectib_wqe_extended_atomic_fetch_add_unpack(union connectib_wqe_extended_atomic_fetch_add *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_wqe_extended_atomic_fetch_add_128byte_unpack(&(ptr_struct->byte128), ptr_buff);
}

void connectib_wqe_extended_atomic_fetch_add_print(const union connectib_wqe_extended_atomic_fetch_add *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_fetch_add ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte4:\n");
	connectib_wqe_extended_atomic_fetch_add_4byte_print(&(ptr_struct->byte4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte8:\n");
	connectib_wqe_extended_atomic_fetch_add_8byte_print(&(ptr_struct->byte8), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte16:\n");
	connectib_wqe_extended_atomic_fetch_add_16byte_print(&(ptr_struct->byte16), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte32:\n");
	connectib_wqe_extended_atomic_fetch_add_32byte_print(&(ptr_struct->byte32), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte64:\n");
	connectib_wqe_extended_atomic_fetch_add_64byte_print(&(ptr_struct->byte64), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte128:\n");
	connectib_wqe_extended_atomic_fetch_add_128byte_print(&(ptr_struct->byte128), file, indent_level + 1);

}

int connectib_wqe_extended_atomic_fetch_add_size(void){
	 return 256;
}

void connectib_wqe_extended_atomic_fetch_add_dump(const union connectib_wqe_extended_atomic_fetch_add *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_fetch_add_print(ptr_struct, file, 0);
}

void connectib_wqe_atomic_fetch_add_pack(const struct connectib_wqe_atomic_fetch_add *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->add_data_63_32);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->add_data_31_0);

}

void connectib_wqe_atomic_fetch_add_unpack(struct connectib_wqe_atomic_fetch_add *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->add_data_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->add_data_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_atomic_fetch_add_print(const struct connectib_wqe_atomic_fetch_add *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_atomic_fetch_add ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_63_32       : "U32H_FMT"\n", ptr_struct->add_data_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "add_data_31_0        : "U32H_FMT"\n", ptr_struct->add_data_31_0);

}

int connectib_wqe_atomic_fetch_add_size(void){
	 return 16;
}

void connectib_wqe_atomic_fetch_add_dump(const struct connectib_wqe_atomic_fetch_add *ptr_struct, FILE* file) {
	connectib_wqe_atomic_fetch_add_print(ptr_struct, file, 0);
}

void connectib_wqe_extended_atomic_cmp_swap_pack(const union connectib_wqe_extended_atomic_cmp_swap *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_wqe_extended_atomic_cmp_swap_128byte_pack(&(ptr_struct->byte126), ptr_buff);
}

void connectib_wqe_extended_atomic_cmp_swap_unpack(union connectib_wqe_extended_atomic_cmp_swap *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_wqe_extended_atomic_cmp_swap_128byte_unpack(&(ptr_struct->byte126), ptr_buff);
}

void connectib_wqe_extended_atomic_cmp_swap_print(const union connectib_wqe_extended_atomic_cmp_swap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_extended_atomic_cmp_swap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte4:\n");
	connectib_wqe_extended_atomic_cmp_swap_4byte_print(&(ptr_struct->byte4), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte8:\n");
	connectib_wqe_extended_atomic_cmp_swap_8byte_print(&(ptr_struct->byte8), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte16:\n");
	connectib_wqe_extended_atomic_cmp_swap_16byte_print(&(ptr_struct->byte16), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte32:\n");
	connectib_wqe_extended_atomic_cmp_swap_32byte_print(&(ptr_struct->byte32), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte64:\n");
	connectib_wqe_extended_atomic_cmp_swap_64byte_print(&(ptr_struct->byte64), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "byte126:\n");
	connectib_wqe_extended_atomic_cmp_swap_128byte_print(&(ptr_struct->byte126), file, indent_level + 1);

}

int connectib_wqe_extended_atomic_cmp_swap_size(void){
	 return 512;
}

void connectib_wqe_extended_atomic_cmp_swap_dump(const union connectib_wqe_extended_atomic_cmp_swap *ptr_struct, FILE* file) {
	connectib_wqe_extended_atomic_cmp_swap_print(ptr_struct, file, 0);
}

void connectib_wqe_atomic_cmp_swap_pack(const struct connectib_wqe_atomic_cmp_swap *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_data_63_32);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->swap_data_31_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_data_63_32);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->compare_data_31_0);

}

void connectib_wqe_atomic_cmp_swap_unpack(struct connectib_wqe_atomic_cmp_swap *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->swap_data_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->swap_data_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->compare_data_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->compare_data_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_atomic_cmp_swap_print(const struct connectib_wqe_atomic_cmp_swap *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_atomic_cmp_swap ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_63_32      : "U32H_FMT"\n", ptr_struct->swap_data_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swap_data_31_0       : "U32H_FMT"\n", ptr_struct->swap_data_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_63_32   : "U32H_FMT"\n", ptr_struct->compare_data_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "compare_data_31_0    : "U32H_FMT"\n", ptr_struct->compare_data_31_0);

}

int connectib_wqe_atomic_cmp_swap_size(void){
	 return 16;
}

void connectib_wqe_atomic_cmp_swap_dump(const struct connectib_wqe_atomic_cmp_swap *ptr_struct, FILE* file) {
	connectib_wqe_atomic_cmp_swap_print(ptr_struct, file, 0);
}

void connectib_wqe_rdma_read_pack(const struct connectib_wqe_rdma_read *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->remote_virtual_address_63_32);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->remote_virtual_address_31_0);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->remote_key);

}

void connectib_wqe_rdma_read_unpack(struct connectib_wqe_rdma_read *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->remote_virtual_address_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->remote_virtual_address_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->remote_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_rdma_read_print(const struct connectib_wqe_rdma_read *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_rdma_read ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_virtual_address_63_32 : "U32H_FMT"\n", ptr_struct->remote_virtual_address_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_virtual_address_31_0 : "U32H_FMT"\n", ptr_struct->remote_virtual_address_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "remote_key           : "U32H_FMT"\n", ptr_struct->remote_key);

}

int connectib_wqe_rdma_read_size(void){
	 return 16;
}

void connectib_wqe_rdma_read_dump(const struct connectib_wqe_rdma_read *ptr_struct, FILE* file) {
	connectib_wqe_rdma_read_print(ptr_struct, file, 0);
}

void connectib_wqe_address_vector_ext_pack(const struct connectib_wqe_address_vector_ext *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->auto_1);

	offset=63;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->auto_2);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->hop_limit);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->tclass);

	offset=108;
	adb2c_push_bits_to_buff(ptr_buff, offset, 20, (u_int32_t)ptr_struct->flow_label);

	offset=100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->my_gid_index1);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->grh);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rgid_127_96);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rgid_95_64);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rgid_63_32);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rgid_31_0);

}

void connectib_wqe_address_vector_ext_unpack(struct connectib_wqe_address_vector_ext *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->auto_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=63;
	ptr_struct->auto_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->hop_limit = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=80;
	ptr_struct->tclass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=108;
	ptr_struct->flow_label = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 20);

	offset=100;
	ptr_struct->my_gid_index1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=97;
	ptr_struct->grh = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=128;
	ptr_struct->rgid_127_96 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->rgid_95_64 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->rgid_63_32 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->rgid_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_address_vector_ext_print(const struct connectib_wqe_address_vector_ext *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_address_vector_ext ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "auto_1               : "UH_FMT"\n", ptr_struct->auto_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "auto_2               : "UH_FMT"\n", ptr_struct->auto_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hop_limit            : "UH_FMT"\n", ptr_struct->hop_limit);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "tclass               : "UH_FMT"\n", ptr_struct->tclass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flow_label           : "UH_FMT"\n", ptr_struct->flow_label);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "my_gid_index1        : "UH_FMT"\n", ptr_struct->my_gid_index1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh                  : "UH_FMT"\n", ptr_struct->grh);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_127_96          : "U32H_FMT"\n", ptr_struct->rgid_127_96);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_95_64           : "U32H_FMT"\n", ptr_struct->rgid_95_64);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_63_32           : "U32H_FMT"\n", ptr_struct->rgid_63_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rgid_31_0            : "U32H_FMT"\n", ptr_struct->rgid_31_0);

}

int connectib_wqe_address_vector_ext_size(void){
	 return 32;
}

void connectib_wqe_address_vector_ext_dump(const struct connectib_wqe_address_vector_ext *ptr_struct, FILE* file) {
	connectib_wqe_address_vector_ext_print(ptr_struct, file, 0);
}

void connectib_wqe_address_vector_basic_pack(const struct connectib_wqe_address_vector_basic *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dca_key_63_32_qkey);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dca_key_31_0);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->destination_qp_dct);

	offset=68;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->reverse_sl);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ext);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rlid_15_0);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->slid);

	offset=100;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->static_rate);

}

void connectib_wqe_address_vector_basic_unpack(struct connectib_wqe_address_vector_basic *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->dca_key_63_32_qkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->dca_key_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=72;
	ptr_struct->destination_qp_dct = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=68;
	ptr_struct->reverse_sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->ext = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->rlid_15_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=104;
	ptr_struct->slid = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=100;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->static_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_address_vector_basic_print(const struct connectib_wqe_address_vector_basic *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_address_vector_basic ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dca_key_63_32_qkey   : "U32H_FMT"\n", ptr_struct->dca_key_63_32_qkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dca_key_31_0         : "U32H_FMT"\n", ptr_struct->dca_key_31_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destination_qp_dct   : "UH_FMT"\n", ptr_struct->destination_qp_dct);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reverse_sl           : "UH_FMT"\n", ptr_struct->reverse_sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext                  : "UH_FMT"\n", ptr_struct->ext);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rlid_15_0            : "UH_FMT"\n", ptr_struct->rlid_15_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slid                 : "UH_FMT"\n", ptr_struct->slid);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "static_rate          : "UH_FMT"\n", ptr_struct->static_rate);

}

int connectib_wqe_address_vector_basic_size(void){
	 return 16;
}

void connectib_wqe_address_vector_basic_dump(const struct connectib_wqe_address_vector_basic *ptr_struct, FILE* file) {
	connectib_wqe_address_vector_basic_print(ptr_struct, file, 0);
}

void connectib_wqe_xrc_pack(const struct connectib_wqe_xrc *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->xrc);

}

void connectib_wqe_xrc_unpack(struct connectib_wqe_xrc *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->xrc = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

}

void connectib_wqe_xrc_print(const struct connectib_wqe_xrc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_xrc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xrc                  : "UH_FMT"\n", ptr_struct->xrc);

}

int connectib_wqe_xrc_size(void){
	 return 16;
}

void connectib_wqe_xrc_dump(const struct connectib_wqe_xrc *ptr_struct, FILE* file) {
	connectib_wqe_xrc_print(ptr_struct, file, 0);
}

void connectib_wqe_mlx_pack(const struct connectib_wqe_mlx *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=44;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->sl);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->static_rate);

	offset=37;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fl);

	offset=36;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->ic);

	offset=35;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fc);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->slr);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->vl15);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->v);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->dmac_dlid_47_32);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vlan);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->dmac_dlid_31_0);

}

void connectib_wqe_mlx_unpack(struct connectib_wqe_mlx *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=44;
	ptr_struct->sl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=40;
	ptr_struct->static_rate = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=37;
	ptr_struct->fl = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=36;
	ptr_struct->ic = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=35;
	ptr_struct->fc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=34;
	ptr_struct->slr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=33;
	ptr_struct->vl15 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->v = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->dmac_dlid_47_32 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=64;
	ptr_struct->vlan = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=96;
	ptr_struct->dmac_dlid_31_0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_mlx_print(const struct connectib_wqe_mlx *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_mlx ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sl                   : "UH_FMT"\n", ptr_struct->sl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "static_rate          : "UH_FMT"\n", ptr_struct->static_rate);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fl                   : "UH_FMT"\n", ptr_struct->fl);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ic                   : "UH_FMT"\n", ptr_struct->ic);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fc                   : "UH_FMT"\n", ptr_struct->fc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "slr                  : "UH_FMT"\n", ptr_struct->slr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vl15                 : "UH_FMT"\n", ptr_struct->vl15);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "v                    : "UH_FMT"\n", ptr_struct->v);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmac_dlid_47_32      : "UH_FMT"\n", ptr_struct->dmac_dlid_47_32);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vlan                 : "UH_FMT"\n", ptr_struct->vlan);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dmac_dlid_31_0       : "U32H_FMT"\n", ptr_struct->dmac_dlid_31_0);

}

int connectib_wqe_mlx_size(void){
	 return 16;
}

void connectib_wqe_mlx_dump(const struct connectib_wqe_mlx *ptr_struct, FILE* file) {
	connectib_wqe_mlx_print(ptr_struct, file, 0);
}

void connectib_wqe_control_pack(const struct connectib_wqe_control *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->opcode);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wqe_index);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->opc_mod);

	offset=58;
	adb2c_push_bits_to_buff(ptr_buff, offset, 6, (u_int32_t)ptr_struct->ds);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=95;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->interrupt);

	offset=94;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->se);

	offset=92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->ce);

	offset=91;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->nop);

	offset=88;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->fm);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->immediate_invalidation_key);

}

void connectib_wqe_control_unpack(struct connectib_wqe_control *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=24;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=8;
	ptr_struct->wqe_index = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=0;
	ptr_struct->opc_mod = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=58;
	ptr_struct->ds = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 6);

	offset=32;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=95;
	ptr_struct->interrupt = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=94;
	ptr_struct->se = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=92;
	ptr_struct->ce = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=91;
	ptr_struct->nop = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=88;
	ptr_struct->fm = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=96;
	ptr_struct->immediate_invalidation_key = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

}

void connectib_wqe_control_print(const struct connectib_wqe_control *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_wqe_control ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_index            : "UH_FMT"\n", ptr_struct->wqe_index);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opc_mod              : "UH_FMT"\n", ptr_struct->opc_mod);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ds                   : "UH_FMT"\n", ptr_struct->ds);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "interrupt            : "UH_FMT"\n", ptr_struct->interrupt);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "se                   : "UH_FMT"\n", ptr_struct->se);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ce                   : "UH_FMT"\n", ptr_struct->ce);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nop                  : "UH_FMT"\n", ptr_struct->nop);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fm                   : "UH_FMT"\n", ptr_struct->fm);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "immediate_invalidation_key : "U32H_FMT"\n", ptr_struct->immediate_invalidation_key);

}

int connectib_wqe_control_size(void){
	 return 16;
}

void connectib_wqe_control_dump(const struct connectib_wqe_control *ptr_struct, FILE* file) {
	connectib_wqe_control_print(ptr_struct, file, 0);
}

void connectib_nv_data_pack(const struct connectib_nv_data *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_header_pack(&(ptr_struct->header), ptr_buff + offset/8);

}

void connectib_nv_data_unpack(struct connectib_nv_data *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_nv_config_header_unpack(&(ptr_struct->header), ptr_buff + offset/8);

}

void connectib_nv_data_print(const struct connectib_nv_data *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_nv_data ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header:\n");
	connectib_nv_config_header_print(&(ptr_struct->header), file, indent_level + 1);

}

int connectib_nv_data_size(void){
	 return 65536;
}

void connectib_nv_data_dump(const struct connectib_nv_data *ptr_struct, FILE* file) {
	connectib_nv_data_print(ptr_struct, file, 0);
}

void connectib_hw_boot_config_pack(const struct connectib_hw_boot_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->manufacture_info_address);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->ro_manufacture_info_address);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vpd_info_address_1);

	offset=104;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->vpd_info_address_2);

	offset=128;
	connectib_vpd_eeprom_info_pack(&(ptr_struct->vpd_eeprom), ptr_buff + offset/8);

	offset=192;
	connectib_code_coverage_control_pack(&(ptr_struct->code_coverage), ptr_buff + offset/8);

	offset=256;
	connectib_pcie_cfg_golan_pack(&(ptr_struct->pcie_cfg), ptr_buff + offset/8);

	offset=1792;
	connectib_fw_image_pack(&(ptr_struct->fw_image), ptr_buff + offset/8);

}

void connectib_hw_boot_config_unpack(struct connectib_hw_boot_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->manufacture_info_address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=40;
	ptr_struct->ro_manufacture_info_address = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=72;
	ptr_struct->vpd_info_address_1 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=104;
	ptr_struct->vpd_info_address_2 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=128;
	connectib_vpd_eeprom_info_unpack(&(ptr_struct->vpd_eeprom), ptr_buff + offset/8);

	offset=192;
	connectib_code_coverage_control_unpack(&(ptr_struct->code_coverage), ptr_buff + offset/8);

	offset=256;
	connectib_pcie_cfg_golan_unpack(&(ptr_struct->pcie_cfg), ptr_buff + offset/8);

	offset=1792;
	connectib_fw_image_unpack(&(ptr_struct->fw_image), ptr_buff + offset/8);

}

void connectib_hw_boot_config_print(const struct connectib_hw_boot_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_boot_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "manufacture_info_address : "UH_FMT"\n", ptr_struct->manufacture_info_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ro_manufacture_info_address : "UH_FMT"\n", ptr_struct->ro_manufacture_info_address);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_info_address_1   : "UH_FMT"\n", ptr_struct->vpd_info_address_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_info_address_2   : "UH_FMT"\n", ptr_struct->vpd_info_address_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vpd_eeprom:\n");
	connectib_vpd_eeprom_info_print(&(ptr_struct->vpd_eeprom), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "code_coverage:\n");
	connectib_code_coverage_control_print(&(ptr_struct->code_coverage), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_cfg:\n");
	connectib_pcie_cfg_golan_print(&(ptr_struct->pcie_cfg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_image:\n");
	connectib_fw_image_print(&(ptr_struct->fw_image), file, indent_level + 1);

}

int connectib_hw_boot_config_size(void){
	 return 256;
}

void connectib_hw_boot_config_dump(const struct connectib_hw_boot_config *ptr_struct, FILE* file) {
	connectib_hw_boot_config_print(ptr_struct, file, 0);
}

void connectib_hw_main_config_pack(const struct connectib_hw_main_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_port_serdes_pack(&(ptr_struct->ports_serdes), ptr_buff + offset/8);

	offset=14336;
	connectib_power_pack(&(ptr_struct->power), ptr_buff + offset/8);

	offset=14464;
	connectib_system_mng_pack(&(ptr_struct->system_mng), ptr_buff + offset/8);

	offset=14496;
	connectib_thermal_config_golan_pack(&(ptr_struct->thermal), ptr_buff + offset/8);

	offset=15360;
	connectib_module_config_pack(&(ptr_struct->module), ptr_buff + offset/8);

	offset=15424;
	connectib_i2c_devices_db_pack(&(ptr_struct->i2c), ptr_buff + offset/8);

	offset=16064;
	connectib_ini_gpios_golan_pack(&(ptr_struct->gpios), ptr_buff + offset/8);

}

void connectib_hw_main_config_unpack(struct connectib_hw_main_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_port_serdes_unpack(&(ptr_struct->ports_serdes), ptr_buff + offset/8);

	offset=14336;
	connectib_power_unpack(&(ptr_struct->power), ptr_buff + offset/8);

	offset=14464;
	connectib_system_mng_unpack(&(ptr_struct->system_mng), ptr_buff + offset/8);

	offset=14496;
	connectib_thermal_config_golan_unpack(&(ptr_struct->thermal), ptr_buff + offset/8);

	offset=15360;
	connectib_module_config_unpack(&(ptr_struct->module), ptr_buff + offset/8);

	offset=15424;
	connectib_i2c_devices_db_unpack(&(ptr_struct->i2c), ptr_buff + offset/8);

	offset=16064;
	connectib_ini_gpios_golan_unpack(&(ptr_struct->gpios), ptr_buff + offset/8);

}

void connectib_hw_main_config_print(const struct connectib_hw_main_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_hw_main_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ports_serdes:\n");
	connectib_port_serdes_print(&(ptr_struct->ports_serdes), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power:\n");
	connectib_power_print(&(ptr_struct->power), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "system_mng:\n");
	connectib_system_mng_print(&(ptr_struct->system_mng), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal:\n");
	connectib_thermal_config_golan_print(&(ptr_struct->thermal), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module:\n");
	connectib_module_config_print(&(ptr_struct->module), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c:\n");
	connectib_i2c_devices_db_print(&(ptr_struct->i2c), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpios:\n");
	connectib_ini_gpios_golan_print(&(ptr_struct->gpios), file, indent_level + 1);

}

int connectib_hw_main_config_size(void){
	 return 2816;
}

void connectib_hw_main_config_dump(const struct connectib_hw_main_config *ptr_struct, FILE* file) {
	connectib_hw_main_config_print(ptr_struct, file, 0);
}

void connectib_fw_boot_config_pack(const struct connectib_fw_boot_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_FW_VERSION_pack(&(ptr_struct->fw_version), ptr_buff + offset/8);

	offset=128;
	connectib_multi_function_pack(&(ptr_struct->multi_function), ptr_buff + offset/8);

	offset=224;
	connectib_pcie_transaction_pack(&(ptr_struct->pcie_transaction), ptr_buff + offset/8);

	offset=256;
	connectib_pci_cfg_pack(&(ptr_struct->pcie_cfg_data), ptr_buff + offset/8);

	offset=4352;
	connectib_pci_cfg_pack(&(ptr_struct->pcie_cfg_mask), ptr_buff + offset/8);

	offset=8448;
	connectib_pf_vf_cfg_space_pack(&(ptr_struct->pf_vf_cfg_data), ptr_buff + offset/8);

	offset=8672;
	connectib_pcie_power_management_pack(&(ptr_struct->pcie_power_management), ptr_buff + offset/8);

	offset=8704;
	connectib_nv_config_boot_pack(&(ptr_struct->nv_config), ptr_buff + offset/8);

}

void connectib_fw_boot_config_unpack(struct connectib_fw_boot_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_FW_VERSION_unpack(&(ptr_struct->fw_version), ptr_buff + offset/8);

	offset=128;
	connectib_multi_function_unpack(&(ptr_struct->multi_function), ptr_buff + offset/8);

	offset=224;
	connectib_pcie_transaction_unpack(&(ptr_struct->pcie_transaction), ptr_buff + offset/8);

	offset=256;
	connectib_pci_cfg_unpack(&(ptr_struct->pcie_cfg_data), ptr_buff + offset/8);

	offset=4352;
	connectib_pci_cfg_unpack(&(ptr_struct->pcie_cfg_mask), ptr_buff + offset/8);

	offset=8448;
	connectib_pf_vf_cfg_space_unpack(&(ptr_struct->pf_vf_cfg_data), ptr_buff + offset/8);

	offset=8672;
	connectib_pcie_power_management_unpack(&(ptr_struct->pcie_power_management), ptr_buff + offset/8);

	offset=8704;
	connectib_nv_config_boot_unpack(&(ptr_struct->nv_config), ptr_buff + offset/8);

}

void connectib_fw_boot_config_print(const struct connectib_fw_boot_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_boot_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_version:\n");
	connectib_FW_VERSION_print(&(ptr_struct->fw_version), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "multi_function:\n");
	connectib_multi_function_print(&(ptr_struct->multi_function), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_transaction:\n");
	connectib_pcie_transaction_print(&(ptr_struct->pcie_transaction), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_cfg_data:\n");
	connectib_pci_cfg_print(&(ptr_struct->pcie_cfg_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_cfg_mask:\n");
	connectib_pci_cfg_print(&(ptr_struct->pcie_cfg_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pf_vf_cfg_data:\n");
	connectib_pf_vf_cfg_space_print(&(ptr_struct->pf_vf_cfg_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_power_management:\n");
	connectib_pcie_power_management_print(&(ptr_struct->pcie_power_management), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_config:\n");
	connectib_nv_config_boot_print(&(ptr_struct->nv_config), file, indent_level + 1);

}

int connectib_fw_boot_config_size(void){
	 return 1152;
}

void connectib_fw_boot_config_dump(const struct connectib_fw_boot_config *ptr_struct, FILE* file) {
	connectib_fw_boot_config_print(ptr_struct, file, 0);
}

void connectib_fw_main_config_pack(const struct connectib_fw_main_config *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->log_max_num_rdbs);

	offset=128;
	connectib_static_config_pack(&(ptr_struct->static_config), ptr_buff + offset/8);

	offset=256;
	connectib_leds_blink_patterns_pack(&(ptr_struct->leds_blink_pattern), ptr_buff + offset/8);

	offset=1536;
	connectib_customization_pack(&(ptr_struct->customization), ptr_buff + offset/8);

	offset=2048;
	connectib_management_pack(&(ptr_struct->management), ptr_buff + offset/8);

	offset=4096;
	connectib_host_management_pack(&(ptr_struct->host_management), ptr_buff + offset/8);

	offset=6656;
	connectib_phy_fw_main_config_pack(&(ptr_struct->phy_fw_main_config), ptr_buff + offset/8);

	offset=12160;
	connectib_nv_config_main_pack(&(ptr_struct->nv_config), ptr_buff + offset/8);

}

void connectib_fw_main_config_unpack(struct connectib_fw_main_config *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=61;
	ptr_struct->log_max_num_rdbs = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=128;
	connectib_static_config_unpack(&(ptr_struct->static_config), ptr_buff + offset/8);

	offset=256;
	connectib_leds_blink_patterns_unpack(&(ptr_struct->leds_blink_pattern), ptr_buff + offset/8);

	offset=1536;
	connectib_customization_unpack(&(ptr_struct->customization), ptr_buff + offset/8);

	offset=2048;
	connectib_management_unpack(&(ptr_struct->management), ptr_buff + offset/8);

	offset=4096;
	connectib_host_management_unpack(&(ptr_struct->host_management), ptr_buff + offset/8);

	offset=6656;
	connectib_phy_fw_main_config_unpack(&(ptr_struct->phy_fw_main_config), ptr_buff + offset/8);

	offset=12160;
	connectib_nv_config_main_unpack(&(ptr_struct->nv_config), ptr_buff + offset/8);

}

void connectib_fw_main_config_print(const struct connectib_fw_main_config *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_fw_main_config ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "log_max_num_rdbs     : "UH_FMT"\n", ptr_struct->log_max_num_rdbs);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "static_config:\n");
	connectib_static_config_print(&(ptr_struct->static_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "leds_blink_pattern:\n");
	connectib_leds_blink_patterns_print(&(ptr_struct->leds_blink_pattern), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "customization:\n");
	connectib_customization_print(&(ptr_struct->customization), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "management:\n");
	connectib_management_print(&(ptr_struct->management), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "host_management:\n");
	connectib_host_management_print(&(ptr_struct->host_management), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_fw_main_config:\n");
	connectib_phy_fw_main_config_print(&(ptr_struct->phy_fw_main_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_config:\n");
	connectib_nv_config_main_print(&(ptr_struct->nv_config), file, indent_level + 1);

}

int connectib_fw_main_config_size(void){
	 return 1776;
}

void connectib_fw_main_config_dump(const struct connectib_fw_main_config *ptr_struct, FILE* file) {
	connectib_fw_main_config_print(ptr_struct, file, 0);
}

void connectib_mfg_info_pack(const struct connectib_mfg_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(24, 8, i, 2560, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->psid[i]);
	}

	offset=255;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->guids_override_en);

	offset=232;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->minor_version);

	offset=224;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->major_version);

	offset=256;
	connectib_guids_pack(&(ptr_struct->guids), ptr_buff + offset/8);

}

void connectib_mfg_info_unpack(struct connectib_mfg_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(24, 8, i, 2560, 1);
	ptr_struct->psid[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->psid[16] = '\0';
	offset=255;
	ptr_struct->guids_override_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=232;
	ptr_struct->minor_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=224;
	ptr_struct->major_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=256;
	connectib_guids_unpack(&(ptr_struct->guids), ptr_buff + offset/8);

}

void connectib_mfg_info_print(const struct connectib_mfg_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_mfg_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	fprintf(file, "psid                 : \"%s\"\n", ptr_struct->psid);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guids_override_en    : "UH_FMT"\n", ptr_struct->guids_override_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minor_version        : "UH_FMT"\n", ptr_struct->minor_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "major_version        : "UH_FMT"\n", ptr_struct->major_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guids:\n");
	connectib_guids_print(&(ptr_struct->guids), file, indent_level + 1);

}

int connectib_mfg_info_size(void){
	 return 320;
}

void connectib_mfg_info_dump(const struct connectib_mfg_info *ptr_struct, FILE* file) {
	connectib_mfg_info_print(ptr_struct, file, 0);
}

void connectib_image_info_pack(const struct connectib_image_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->minor_version);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->major_version);

	offset=32;
	connectib_FW_VERSION_pack(&(ptr_struct->FW_VERSION), ptr_buff + offset/8);

	offset=160;
	connectib_TRIPPLE_VERSION_pack(&(ptr_struct->mic_version), ptr_buff + offset/8);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(312, 8, i, 8192, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->psid[i]);
	}

	offset=432;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vsd_vendor_id);

	for (i=0; i < 208; i++) {
	offset=adb2c_calc_array_field_address(472, 8, i, 8192, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vsd[i]);
	}

	offset=2112;
	connectib_image_size_pack(&(ptr_struct->image_size), ptr_buff + offset/8);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(2240, 32, i, 8192, 1);
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->supported_hw_id[i]);
	}

	offset=2368;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->ini_file_num);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(3608, 8, i, 8192, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->prod_ver[i]);
	}

	offset=6144;
	connectib_module_versions_pack(&(ptr_struct->module_versions), ptr_buff + offset/8);

}

void connectib_image_info_unpack(struct connectib_image_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->minor_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=0;
	ptr_struct->major_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=32;
	connectib_FW_VERSION_unpack(&(ptr_struct->FW_VERSION), ptr_buff + offset/8);

	offset=160;
	connectib_TRIPPLE_VERSION_unpack(&(ptr_struct->mic_version), ptr_buff + offset/8);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(312, 8, i, 8192, 1);
	ptr_struct->psid[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->psid[16] = '\0';
	offset=432;
	ptr_struct->vsd_vendor_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i=0; i < 208; i++) {
	offset=adb2c_calc_array_field_address(472, 8, i, 8192, 1);
	ptr_struct->vsd[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vsd[208] = '\0';
	offset=2112;
	connectib_image_size_unpack(&(ptr_struct->image_size), ptr_buff + offset/8);

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(2240, 32, i, 8192, 1);
	ptr_struct->supported_hw_id[i] = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);
	}

	offset=2368;
	ptr_struct->ini_file_num = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	for (i=0; i < 16; i++) {
	offset=adb2c_calc_array_field_address(3608, 8, i, 8192, 1);
	ptr_struct->prod_ver[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->prod_ver[16] = '\0';
	offset=6144;
	connectib_module_versions_unpack(&(ptr_struct->module_versions), ptr_buff + offset/8);

}

void connectib_image_info_print(const struct connectib_image_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_image_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minor_version        : "UH_FMT"\n", ptr_struct->minor_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "major_version        : "UH_FMT"\n", ptr_struct->major_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "FW_VERSION:\n");
	connectib_FW_VERSION_print(&(ptr_struct->FW_VERSION), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mic_version:\n");
	connectib_TRIPPLE_VERSION_print(&(ptr_struct->mic_version), file, indent_level + 1);

	fprintf(file, "psid                 : \"%s\"\n", ptr_struct->psid);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vsd_vendor_id        : "UH_FMT"\n", ptr_struct->vsd_vendor_id);

	fprintf(file, "vsd                  : \"%s\"\n", ptr_struct->vsd);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "image_size:\n");
	connectib_image_size_print(&(ptr_struct->image_size), file, indent_level + 1);

	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "supported_hw_id_%03d : "U32H_FMT"\n", i, ptr_struct->supported_hw_id[i]);
	}

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ini_file_num         : "U32H_FMT"\n", ptr_struct->ini_file_num);

	fprintf(file, "prod_ver             : \"%s\"\n", ptr_struct->prod_ver);
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "module_versions:\n");
	connectib_module_versions_print(&(ptr_struct->module_versions), file, indent_level + 1);

}

int connectib_image_info_size(void){
	 return 1024;
}

void connectib_image_info_dump(const struct connectib_image_info *ptr_struct, FILE* file) {
	connectib_image_info_print(ptr_struct, file, 0);
}

void connectib_device_info_pack(const struct connectib_device_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature0);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature1);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature2);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature3);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->minor_version);

	offset=143;
	adb2c_push_bits_to_buff(ptr_buff, offset, 9, (u_int32_t)ptr_struct->major_version);

	offset=256;
	connectib_guids_pack(&(ptr_struct->guids), ptr_buff + offset/8);

	offset=880;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->vsd_vendor_id);

	for (i=0; i < 208; i++) {
	offset=adb2c_calc_array_field_address(920, 8, i, 4096, 1);
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vsd[i]);
	}

	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(2816, 128, i, 4096, 1);
	connectib_operation_key_pack(&(ptr_struct->keys[i]), ptr_buff + offset/8);
	}

}

void connectib_device_info_unpack(struct connectib_device_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->signature0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->signature1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->signature2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->signature3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=152;
	ptr_struct->minor_version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=143;
	ptr_struct->major_version = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 9);

	offset=256;
	connectib_guids_unpack(&(ptr_struct->guids), ptr_buff + offset/8);

	offset=880;
	ptr_struct->vsd_vendor_id = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	for (i=0; i < 208; i++) {
	offset=adb2c_calc_array_field_address(920, 8, i, 4096, 1);
	ptr_struct->vsd[i] = (char)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);
	}

	ptr_struct->vsd[208] = '\0';
	for (i=0; i < 4; i++) {
	offset=adb2c_calc_array_field_address(2816, 128, i, 4096, 1);
	connectib_operation_key_unpack(&(ptr_struct->keys[i]), ptr_buff + offset/8);
	}

}

void connectib_device_info_print(const struct connectib_device_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_device_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature0           : "U32H_FMT"\n", ptr_struct->signature0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature1           : "U32H_FMT"\n", ptr_struct->signature1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature2           : "U32H_FMT"\n", ptr_struct->signature2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature3           : "U32H_FMT"\n", ptr_struct->signature3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "minor_version        : "UH_FMT"\n", ptr_struct->minor_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "major_version        : "UH_FMT"\n", ptr_struct->major_version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guids:\n");
	connectib_guids_print(&(ptr_struct->guids), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vsd_vendor_id        : "UH_FMT"\n", ptr_struct->vsd_vendor_id);

	fprintf(file, "vsd                  : \"%s\"\n", ptr_struct->vsd);
	for (i=0; i < 4; i++) {
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "keys_%03d:\n", i);
	connectib_operation_key_print(&(ptr_struct->keys[i]), file, indent_level + 1);
	}

}

int connectib_device_info_size(void){
	 return 512;
}

void connectib_device_info_dump(const struct connectib_device_info *ptr_struct, FILE* file) {
	connectib_device_info_print(ptr_struct, file, 0);
}

void connectib_dtoc_pointers_pack(const union connectib_dtoc_pointers *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_toc_data_pack(&(ptr_struct->mfg_info), ptr_buff);
}

void connectib_dtoc_pointers_unpack(union connectib_dtoc_pointers *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_toc_data_unpack(&(ptr_struct->mfg_info), ptr_buff);
}

void connectib_dtoc_pointers_print(const union connectib_dtoc_pointers *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_dtoc_pointers ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_info_0:\n");
	connectib_toc_data_print(&(ptr_struct->device_info_0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_data_0:\n");
	connectib_toc_data_print(&(ptr_struct->nv_data_0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_data_1:\n");
	connectib_toc_data_print(&(ptr_struct->nv_data_1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_nv_log:\n");
	connectib_toc_data_print(&(ptr_struct->fw_nv_log), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfg_info:\n");
	connectib_toc_data_print(&(ptr_struct->mfg_info), file, indent_level + 1);

}

int connectib_dtoc_pointers_size(void){
	 return 256;
}

void connectib_dtoc_pointers_dump(const union connectib_dtoc_pointers *ptr_struct, FILE* file) {
	connectib_dtoc_pointers_print(ptr_struct, file, 0);
}

void connectib_reset_info_pack(const struct connectib_reset_info *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reset_capabilities_pack(&(ptr_struct->rst_cap_mask), ptr_buff + offset/8);

	offset=128;
	connectib_rst_api_ver_pack(&(ptr_struct->rst_api_ver), ptr_buff + offset/8);

}

void connectib_reset_info_unpack(struct connectib_reset_info *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_reset_capabilities_unpack(&(ptr_struct->rst_cap_mask), ptr_buff + offset/8);

	offset=128;
	connectib_rst_api_ver_unpack(&(ptr_struct->rst_api_ver), ptr_buff + offset/8);

}

void connectib_reset_info_print(const struct connectib_reset_info *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_reset_info ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rst_cap_mask:\n");
	connectib_reset_capabilities_print(&(ptr_struct->rst_cap_mask), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rst_api_ver:\n");
	connectib_rst_api_ver_print(&(ptr_struct->rst_api_ver), file, indent_level + 1);

}

int connectib_reset_info_size(void){
	 return 256;
}

void connectib_reset_info_dump(const struct connectib_reset_info *ptr_struct, FILE* file) {
	connectib_reset_info_print(ptr_struct, file, 0);
}

void connectib_boot_record_golan_pack(const struct connectib_boot_record_golan *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->flash_div);

	offset=27;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->hot_reset_enable);

	offset=26;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->wait_lock);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->perst_action);

	offset=17;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->core_f);

	offset=15;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->core_pd);

	offset=13;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->core_od);

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->core_r);

	offset=7;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->core_bypass);

	offset=6;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->core_from_pex);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->parity_reserved0);

	offset=47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->temp_gpio_mask);

	offset=43;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->temp_fatal_mask);

	offset=40;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->gpio_pull_en);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->pll_debug);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->parity_reserved1);

	offset=92;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->mbist_group_size);

	offset=89;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->mbist_unit_size);

	offset=87;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->mbist_en);

	offset=80;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lbist_capture_delay);

	offset=73;
	adb2c_push_bits_to_buff(ptr_buff, offset, 7, (u_int32_t)ptr_struct->i2c_slave_addr);

	offset=72;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->i2c_slave_en);

	offset=71;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->fuse_enable);

	offset=65;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->pll_stabilize);

	offset=64;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->parity_reserved2);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->lbist_pat_cnt_lsb);

	offset=106;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lbist_capture);

	offset=105;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lbist_capt_2);

	offset=102;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lbist_shift_clk_divider);

	offset=98;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->lbist_capture_last);

	offset=97;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->lbist_en);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->parity_reserved3);

}

void connectib_boot_record_golan_unpack(struct connectib_boot_record_golan *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=28;
	ptr_struct->flash_div = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=27;
	ptr_struct->hot_reset_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=26;
	ptr_struct->wait_lock = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=24;
	ptr_struct->perst_action = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=17;
	ptr_struct->core_f = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=15;
	ptr_struct->core_pd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=13;
	ptr_struct->core_od = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=8;
	ptr_struct->core_r = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=7;
	ptr_struct->core_bypass = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=6;
	ptr_struct->core_from_pex = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=0;
	ptr_struct->parity_reserved0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=47;
	ptr_struct->temp_gpio_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=43;
	ptr_struct->temp_fatal_mask = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=40;
	ptr_struct->gpio_pull_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=33;
	ptr_struct->pll_debug = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=32;
	ptr_struct->parity_reserved1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=92;
	ptr_struct->mbist_group_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=89;
	ptr_struct->mbist_unit_size = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=87;
	ptr_struct->mbist_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=80;
	ptr_struct->lbist_capture_delay = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=73;
	ptr_struct->i2c_slave_addr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 7);

	offset=72;
	ptr_struct->i2c_slave_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=71;
	ptr_struct->fuse_enable = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=65;
	ptr_struct->pll_stabilize = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=64;
	ptr_struct->parity_reserved2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->lbist_pat_cnt_lsb = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=106;
	ptr_struct->lbist_capture = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=105;
	ptr_struct->lbist_capt_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=102;
	ptr_struct->lbist_shift_clk_divider = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=98;
	ptr_struct->lbist_capture_last = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=97;
	ptr_struct->lbist_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=96;
	ptr_struct->parity_reserved3 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

}

void connectib_boot_record_golan_print(const struct connectib_boot_record_golan *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_boot_record_golan ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flash_div            : "UH_FMT"\n", ptr_struct->flash_div);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hot_reset_enable     : "UH_FMT"\n", ptr_struct->hot_reset_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wait_lock            : "UH_FMT"\n", ptr_struct->wait_lock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "perst_action         : "UH_FMT"\n", ptr_struct->perst_action);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_f               : "UH_FMT"\n", ptr_struct->core_f);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_pd              : "UH_FMT"\n", ptr_struct->core_pd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_od              : "UH_FMT"\n", ptr_struct->core_od);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_r               : "UH_FMT"\n", ptr_struct->core_r);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_bypass          : "UH_FMT"\n", ptr_struct->core_bypass);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "core_from_pex        : "UH_FMT"\n", ptr_struct->core_from_pex);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parity_reserved0     : "UH_FMT"\n", ptr_struct->parity_reserved0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_gpio_mask       : "UH_FMT"\n", ptr_struct->temp_gpio_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "temp_fatal_mask      : "UH_FMT"\n", ptr_struct->temp_fatal_mask);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gpio_pull_en         : "UH_FMT"\n", ptr_struct->gpio_pull_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_debug            : "UH_FMT"\n", ptr_struct->pll_debug);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parity_reserved1     : "UH_FMT"\n", ptr_struct->parity_reserved1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mbist_group_size     : "UH_FMT"\n", ptr_struct->mbist_group_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mbist_unit_size      : "UH_FMT"\n", ptr_struct->mbist_unit_size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mbist_en             : "UH_FMT"\n", ptr_struct->mbist_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_capture_delay  : "UH_FMT"\n", ptr_struct->lbist_capture_delay);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_slave_addr       : "UH_FMT"\n", ptr_struct->i2c_slave_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "i2c_slave_en         : "UH_FMT"\n", ptr_struct->i2c_slave_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fuse_enable          : "UH_FMT"\n", ptr_struct->fuse_enable);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pll_stabilize        : "UH_FMT"\n", ptr_struct->pll_stabilize);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parity_reserved2     : "UH_FMT"\n", ptr_struct->parity_reserved2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_pat_cnt_lsb    : "UH_FMT"\n", ptr_struct->lbist_pat_cnt_lsb);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_capture        : "UH_FMT"\n", ptr_struct->lbist_capture);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_capt_2         : "UH_FMT"\n", ptr_struct->lbist_capt_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_shift_clk_divider : "UH_FMT"\n", ptr_struct->lbist_shift_clk_divider);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_capture_last   : "UH_FMT"\n", ptr_struct->lbist_capture_last);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lbist_en             : "UH_FMT"\n", ptr_struct->lbist_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "parity_reserved3     : "UH_FMT"\n", ptr_struct->parity_reserved3);

}

int connectib_boot_record_golan_size(void){
	 return 16;
}

void connectib_boot_record_golan_dump(const struct connectib_boot_record_golan *ptr_struct, FILE* file) {
	connectib_boot_record_golan_print(ptr_struct, file, 0);
}

void connectib_icmd_ctrl_pack(const struct connectib_icmd_ctrl *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->destructive_op_unlock);

	offset=48;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->gvmi);

	offset=47;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->public_icmd);

	offset=127;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->busy);

	offset=112;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->status);

	offset=96;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->opcode);

}

void connectib_icmd_ctrl_unpack(struct connectib_icmd_ctrl *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->destructive_op_unlock = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=48;
	ptr_struct->gvmi = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=47;
	ptr_struct->public_icmd = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=127;
	ptr_struct->busy = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=112;
	ptr_struct->status = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=96;
	ptr_struct->opcode = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_icmd_ctrl_print(const struct connectib_icmd_ctrl *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_ctrl ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "destructive_op_unlock : "U32H_FMT"\n", ptr_struct->destructive_op_unlock);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gvmi                 : "UH_FMT"\n", ptr_struct->gvmi);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "public_icmd          : "UH_FMT"\n", ptr_struct->public_icmd);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "busy                 : "UH_FMT"\n", ptr_struct->busy);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "status               : "UH_FMT"\n", ptr_struct->status);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : %s ("UH_FMT")\n", (ptr_struct->opcode == 0 ? ("ICMD_NONE") : ((ptr_struct->opcode == 4096 ? ("OPCODE_MNG_MMINIT") : ((ptr_struct->opcode == 24577 ? ("ICMD_OPCODE_PHY_UC_DO_CONTINUE") : ((ptr_struct->opcode == 24578 ? (" ICMD_OPCODE_PHY_UC_DO_STEP") : ((ptr_struct->opcode == 24579 ? ("ICMD_OPCODE_PHY_UC_SET_DEL_BP") : ((ptr_struct->opcode == 24580 ? ("ICMD_OPCODE_PHY_UC_SET_GET_DATA") : ((ptr_struct->opcode == 24581 ? ("ICMD_OPCODE_PHY_UC_GET_ARRAY_PROP") : ((ptr_struct->opcode == 24582 ? ("ICMD_OPCODE_PHY_UC_GET_STATUS") : ((ptr_struct->opcode == 24583 ? ("ICMD_OPCODE_PHY_ACTIVATE_RX_ADAP") : ((ptr_struct->opcode == 24584 ? ("ICMD_OPCODE_PHY_UC_SET_GET_DATA_FIELD") : ((ptr_struct->opcode == 24585 ? ("ICMD_OPCODE_PHY_UC_ACTIVATE_UC") : ((ptr_struct->opcode == 24587 ? ("ICMD_OPCODE_PHY_GET_LINK_STATUS") : ((ptr_struct->opcode == 24588 ? ("ICMD_OPCODE_PHY_OPEN_CLOSE_PORT") : ((ptr_struct->opcode == 24589 ? ("ICMD_OPCODE_PHY_PLL_VARACTOR_CALIB") : ((ptr_struct->opcode == 24590 ? ("ICMD_OPCODE_PHY_HALT_FSM") : ((ptr_struct->opcode == 24591 ? ("ICMD_OPCODE_PHY_SET_GET_TX_SD") : ((ptr_struct->opcode == 24592 ? ("ICMD_OPCODE_PHY_SET_GET_RX_SD") : ((ptr_struct->opcode == 24593 ? ("ICMD_OPCODE_PHY_TRANS_OR_SYNC") : ((ptr_struct->opcode == 24595 ? ("ICMD_OPCODE_PHY_GET_CLEAR_COUNTERS") : ((ptr_struct->opcode == 24596 ? ("ICMD_OPCODE_PHY_UPDATE_CALIB_VALS") : ((ptr_struct->opcode == 24597 ? ("ICMD_OPCODE_PHY_GET_GRADE_INFO") : ((ptr_struct->opcode == 24598 ? ("ICMD_OPCODE_PHY_SET_GET_PTAS") : ((ptr_struct->opcode == 24599 ? ("ICMD_OPCODE_PHY_GET_PPAMP") : ((ptr_struct->opcode == 24600 ? ("ICMD_OPCODE_PHY_GET_PPLL") : ((ptr_struct->opcode == 24601 ? ("ICMD_OPCODE_PHY_GET_PPDDB") : ((ptr_struct->opcode == 32768 ? ("ACCESS_ICM_LINE") : ((ptr_struct->opcode == 32769 ? ("ACCESS_ICM_CTX") : ((ptr_struct->opcode == 32771 ? ("READ_Q_ENTRY") : ((ptr_struct->opcode == 32772 ? ("GET_IRISC_HEARTBEAT") : ((ptr_struct->opcode == 32773 ? ("GET_BOOT_STAGE") : ((ptr_struct->opcode == 32774 ? ("GET_LINK_LEDS") : ((ptr_struct->opcode == 32775 ? ("GET_FW_INFO") : ((ptr_struct->opcode == 32776 ? ("READ_RX_SLICE_PKT") : ((ptr_struct->opcode == 32777 ? ("READ_G_RSE_DESC") : ((ptr_struct->opcode == 32784 ? ("READ_SX_WQ_BUFFER") : ((ptr_struct->opcode == 32785 ? ("READ_ICM_TLB_LINE") : ((ptr_struct->opcode == 32786 ? ("READ_DUMMY_ADDRESS") : ((ptr_struct->opcode == 32787 ? ("DEBUG_FW_TRACER") : ((ptr_struct->opcode == 32788 ? ("CABLE_PLUG_OUT_IN") : ((ptr_struct->opcode == 32789 ? ("GET_ICM_RES_PROP") : ((ptr_struct->opcode == 32791 ? ("GET_ICM_CTX_ADDRESS") : ((ptr_struct->opcode == 32792 ? ("CHECK_SQPC_STATUS") : ((ptr_struct->opcode == 32793 ? ("ALLOC_DEALLOC_RESOURCE") : ((ptr_struct->opcode == 32794 ? ("LOCK_UNLOCK") : ((ptr_struct->opcode == 32795 ? ("DB_RECOVERY") : ((ptr_struct->opcode == 32796 ? ("READ_ICMC_TAG") : ((ptr_struct->opcode == 32797 ? ("DC_PARAMS") : ((ptr_struct->opcode == 32798 ? ("ACCESS_HOST_MEM_FULL") : ((ptr_struct->opcode == 32800 ? ("RW_GVMIX") : ((ptr_struct->opcode == 32801 ? ("ICMC_LOCKED_HISTOGRAM") : ((ptr_struct->opcode == 32802 ? ("DC_CONFIG") : ((ptr_struct->opcode == 32803 ? ("PUSH_DB") : ((ptr_struct->opcode == 32804 ? ("GET_OPEN_RESOURCES") : ((ptr_struct->opcode == 32805 ? ("RW_ESW") : ((ptr_struct->opcode == 32806 ? ("ACCESS_REG_PMTU") : ((ptr_struct->opcode == 32807 ? ("ICMD_OPCODE_ACCESS_REGISTER_PAOS") : ((ptr_struct->opcode == 32808 ? ("ACCESS_REG_PPCNT") : ((ptr_struct->opcode == 32809 ? ("ACCESS_REG_PTYS") : ((ptr_struct->opcode == 32816 ? ("ICMD_OPCODE_ACCESS_REGISTER_SLRP") : ((ptr_struct->opcode == 32817 ? ("ICMD_OPCODE_ACCESS_REGISTER_SLTP") : ((ptr_struct->opcode == 32818 ? ("ICMD_OPCODE_ACCESS_REGISTER_SLRG") : ((ptr_struct->opcode == 32819 ? ("ICMD_OPCODE_ACCESS_REGISTER_PTAS") : ((ptr_struct->opcode == 32820 ? ("ICMD_OPCODE_ACCESS_REGISTER_PPAMP") : ((ptr_struct->opcode == 32810 ? ("ACCESS_REG_PVLC") : ((ptr_struct->opcode == 33024 ? ("DEBUG_PRINT_ICM") : ((ptr_struct->opcode == 33025 ? ("GET_HEADER_CAPTURE") : ((ptr_struct->opcode == 33026 ? ("GEN_EQE") : ((ptr_struct->opcode == 33280 ? ("ICMD_OPCODE_SET_GET_PORT_CNTR") : ((ptr_struct->opcode == 33281 ? ("ICMD_OPCODE_GET_PF_CTX") : ((ptr_struct->opcode == 33536 ? ("GET_FT_LIST") : ((ptr_struct->opcode == 33537 ? ("GET_FT_INFO") : ((ptr_struct->opcode == 33538 ? ("GET_FG_LIST") : ((ptr_struct->opcode == 33539 ? ("GET_FG") : ((ptr_struct->opcode == 33540 ? ("GET_FTE_LIST") : ((ptr_struct->opcode == 33541 ? ("GET_FTE") : ((ptr_struct->opcode == 33542 ? ("GET_STE_OPEN_RESOURCES") : ((ptr_struct->opcode == 33543 ? ("GET_STE_RESOURCES_LIST") : ((ptr_struct->opcode == 33544 ? ("READ_STE") : ((ptr_struct->opcode == 36865 ? ("REG_ACCESS") : ((ptr_struct->opcode == 40961 ? ("FW_RESET") : ((ptr_struct->opcode == 40964 ? ("ICMD_OPCODE_PMAOS_WRITE") : ((ptr_struct->opcode == 40965 ? ("ICMD_OPCODE_PMAOS_QUERY") : ((ptr_struct->opcode == 45056 ? ("READ_COMMAND") : ((ptr_struct->opcode == 49152 ? ("READ_EQ4TYPE") : ((ptr_struct->opcode == 49153 ? ("READ_SPECIAL_QPS") : ((ptr_struct->opcode == 49154 ? ("SET_PORT_SNIFFER") : ((ptr_struct->opcode == 49155 ? ("GET_PORT_SNIFFER") : ((ptr_struct->opcode == 49156 ? ("WRITE_CC_LOG") : ((ptr_struct->opcode == 49157 ? ("CONFIG_CC") : ((ptr_struct->opcode == 49158 ? ("WRITE_DC_CNAK_LID") : ((ptr_struct->opcode == 61440 ? ("PHY_NEGO_CTRL") : ((ptr_struct->opcode == 61441 ? ("EYE_OPENER_READ") : ((ptr_struct->opcode == 61443 ? ("SET_ITRACE") : ((ptr_struct->opcode == 61444 ? ("INIT_OCSD") : ((ptr_struct->opcode == 61445 ? ("PHY_VER_OVERWRITE") : ((ptr_struct->opcode == 61446 ? ("PCIE_TOOLS_POINTERS") : ((ptr_struct->opcode == 61447 ? ("CODE_COVERAGE") : ((ptr_struct->opcode == 61448 ? ("CODE_COVERAGE_READ") : ((ptr_struct->opcode == 61449 ? ("PCIE_VER_DATA") : ((ptr_struct->opcode == 61450 ? ("STRESS_TEST") : ((ptr_struct->opcode == 61451 ? ("STOP_TOGGLER") : ((ptr_struct->opcode == 61456 ? ("GREPPER") : ((ptr_struct->opcode == 61457 ? ("STANDBY") : ((ptr_struct->opcode == 61458 ? ("FLR_DEBUG") : ((ptr_struct->opcode == 61459 ? ("DCR_LL_TRVRS") : ((ptr_struct->opcode == 61460 ? ("DCR_LL_NEXT_DCR") : ((ptr_struct->opcode == 61461 ? ("ICMD_OPCODE_GENERAL_FAULT_INJECTOR") : ((ptr_struct->opcode == 61462 ? ("ACCESS_STEERING_ROOT") : ((ptr_struct->opcode == 61463 ? ("STEERING_TABLE_INFO") : ((ptr_struct->opcode == 61464 ? ("GET_GVMI_VIA_VSEC") : ((ptr_struct->opcode == 41216 ? ("SMBUS_MASTER_ACCESS") : ((ptr_struct->opcode == 41218 ? ("SMBUS_GW_FREQ") : ((ptr_struct->opcode == 65376 ? ("ICMD_OPCODE_CABLE_INFO") : ((ptr_struct->opcode == 65377 ? ("ICMD_OPCODE_GEN_ASSERT") : ("unknown")))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))), ptr_struct->opcode);

}

int connectib_icmd_ctrl_size(void){
	 return 16;
}

void connectib_icmd_ctrl_dump(const struct connectib_icmd_ctrl *ptr_struct, FILE* file) {
	connectib_icmd_ctrl_print(ptr_struct, file, 0);
}

void connectib_icmd_cmd_pack(const union connectib_icmd_cmd *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_icmd_get_pf_ctx_pack(&(ptr_struct->get_pf_ctx), ptr_buff);
}

void connectib_icmd_cmd_unpack(union connectib_icmd_cmd *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_icmd_get_pf_ctx_unpack(&(ptr_struct->get_pf_ctx), ptr_buff);
}

void connectib_icmd_cmd_print(const union connectib_icmd_cmd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd_cmd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "as_dwords:\n");
	connectib_icmd_cmd_as_dwords_print(&(ptr_struct->as_dwords), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_icm_ctx:\n");
	connectib_icmd_access_icm_ctx_print(&(ptr_struct->access_icm_ctx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_icm_line:\n");
	connectib_icmd_access_icm_line_print(&(ptr_struct->access_icm_line), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_host_mem:\n");
	connectib_icmd_access_host_mem_print(&(ptr_struct->access_host_mem), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_q_entry:\n");
	connectib_icmd_read_q_entry_print(&(ptr_struct->read_q_entry), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_irisc_heart_beat:\n");
	connectib_icmd_get_irisc_heart_beat_print(&(ptr_struct->get_irisc_heart_beat), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_boot_stage:\n");
	connectib_icmd_get_boot_stage_print(&(ptr_struct->get_boot_stage), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_link_leds:\n");
	connectib_icmd_get_link_leds_print(&(ptr_struct->get_link_leds), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_fw_info:\n");
	connectib_icmd_get_fw_info_print(&(ptr_struct->get_fw_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_rx_slice_packet:\n");
	connectib_icmd_read_rx_slice_packet_print(&(ptr_struct->read_rx_slice_packet), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_g_rse_slice_desc:\n");
	connectib_icmd_read_g_rse_slice_desc_print(&(ptr_struct->read_g_rse_slice_desc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_reset:\n");
	connectib_icmd_fw_reset_print(&(ptr_struct->fw_reset), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "debug_print_icm:\n");
	connectib_print_icm_print(&(ptr_struct->debug_print_icm), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header_capture:\n");
	connectib_icmd_header_capture_print(&(ptr_struct->header_capture), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_sx_wq_buffer:\n");
	connectib_icmd_read_sx_wq_buffer_print(&(ptr_struct->read_sx_wq_buffer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icmd_access_cmdq:\n");
	connectib_icmd_access_cmdq_print(&(ptr_struct->icmd_access_cmdq), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eqn4type:\n");
	connectib_eqn4type_print(&(ptr_struct->eqn4type), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "special_qps:\n");
	connectib_icmd_special_qps_print(&(ptr_struct->special_qps), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_port_sniffer:\n");
	connectib_icmd_set_port_sniffer_print(&(ptr_struct->set_port_sniffer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_port_sniffer:\n");
	connectib_icmd_get_port_sniffer_print(&(ptr_struct->get_port_sniffer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "congestion_log:\n");
	connectib_icmd_congestion_log_print(&(ptr_struct->congestion_log), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "write_dc_cnak_lid:\n");
	connectib_icmd_write_dc_cnak_lid_print(&(ptr_struct->write_dc_cnak_lid), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "config_cc:\n");
	connectib_icmd_config_cc_print(&(ptr_struct->config_cc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_icm_tlb_line:\n");
	connectib_icmd_read_icm_tlb_line_print(&(ptr_struct->read_icm_tlb_line), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_icm_dummy_addr:\n");
	connectib_icmd_read_icm_dummy_addr_print(&(ptr_struct->read_icm_dummy_addr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_open_resources:\n");
	connectib_icmd_get_open_resources_print(&(ptr_struct->get_open_resources), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "debug_fw_tracer:\n");
	connectib_icmd_debug_fw_tracer_print(&(ptr_struct->debug_fw_tracer), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grepper:\n");
	connectib_icmd_grepper_print(&(ptr_struct->grepper), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "standby:\n");
	connectib_icmd_standby_print(&(ptr_struct->standby), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_plug_out_in:\n");
	connectib_icmd_cable_plug_out_in_print(&(ptr_struct->cable_plug_out_in), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cable_info:\n");
	connectib_icmd_cable_info_print(&(ptr_struct->cable_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_icm_res_prop:\n");
	connectib_icmd_get_icm_res_prop_print(&(ptr_struct->get_icm_res_prop), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "alloc_dealloc_resource:\n");
	connectib_icmd_alloc_dealloc_resource_print(&(ptr_struct->alloc_dealloc_resource), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eye_opening_read:\n");
	connectib_eye_opening_read_st_print(&(ptr_struct->eye_opening_read), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_nego_ctrl:\n");
	connectib_phy_nego_ctrl_st_print(&(ptr_struct->phy_nego_ctrl), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_icm_ctx_addr:\n");
	connectib_icmd_get_icm_ctx_addr_print(&(ptr_struct->get_icm_ctx_addr), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register:\n");
	connectib_reg_access_ext_cmd_print(&(ptr_struct->access_register), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "check_sqpc_status:\n");
	connectib_icmd_check_sqpc_status_print(&(ptr_struct->check_sqpc_status), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "lock_unlock_resource:\n");
	connectib_icmd_lock_unlock_resource_print(&(ptr_struct->lock_unlock_resource), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "db_recovery:\n");
	connectib_icmd_check_sqpc_status_print(&(ptr_struct->db_recovery), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_icmc_tag:\n");
	connectib_icmd_access_icm_line_print(&(ptr_struct->read_icmc_tag), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_params:\n");
	connectib_icmd_dc_params_print(&(ptr_struct->dc_params), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dc_config:\n");
	connectib_icmd_dc_config_print(&(ptr_struct->dc_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_itrace:\n");
	connectib_itrace_print(&(ptr_struct->set_itrace), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "init_ocsd:\n");
	connectib_icmd_init_ocsd_print(&(ptr_struct->init_ocsd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "phy_ver_overwrite:\n");
	connectib_icmd_phy_ver_overwrite_print(&(ptr_struct->phy_ver_overwrite), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_tools_pointers:\n");
	connectib_pcie_tools_pointers_print(&(ptr_struct->pcie_tools_pointers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_eqe:\n");
	connectib_icmd_gen_eqe_print(&(ptr_struct->gen_eqe), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_gvmix:\n");
	connectib_icmd_rw_gvmix_print(&(ptr_struct->rw_gvmix), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rw_esw:\n");
	connectib_icmd_esw_print(&(ptr_struct->rw_esw), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "code_coverage:\n");
	connectib_icmd_code_coverage_control_print(&(ptr_struct->code_coverage), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "code_coverage_read:\n");
	connectib_icmd_code_coverage_read_print(&(ptr_struct->code_coverage_read), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stop_toggler:\n");
	connectib_icmd_stop_toggler_print(&(ptr_struct->stop_toggler), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stress_testing:\n");
	connectib_icmd_stress_testing_print(&(ptr_struct->stress_testing), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pcie_ver_data:\n");
	connectib_icmd_pcie_ver_data_print(&(ptr_struct->pcie_ver_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "push_db:\n");
	connectib_icmd_push_db_print(&(ptr_struct->push_db), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flr_debug:\n");
	connectib_icmd_flr_debug_print(&(ptr_struct->flr_debug), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_ll_trvrs:\n");
	connectib_icmd_dcr_ll_trvrs_print(&(ptr_struct->dcr_ll_trvrs), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dcr_ll_next_dcr_list:\n");
	connectib_icmd_dcr_ll_next_dcr_list_print(&(ptr_struct->dcr_ll_next_dcr_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_steering_root:\n");
	connectib_icmd_access_steering_root_print(&(ptr_struct->access_steering_root), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_steering_table_info:\n");
	connectib_icmd_steering_table_info_print(&(ptr_struct->get_steering_table_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_gvmi_via_vsec:\n");
	connectib_icmd_get_gvmi_via_vsec_print(&(ptr_struct->get_gvmi_via_vsec), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_paos:\n");
	connectib_icmd_access_register_paos_print(&(ptr_struct->access_register_paos), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_slrp:\n");
	connectib_icmd_access_register_slrp_print(&(ptr_struct->access_register_slrp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_sltp:\n");
	connectib_icmd_access_register_sltp_print(&(ptr_struct->access_register_sltp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_slrg:\n");
	connectib_icmd_access_register_slrg_print(&(ptr_struct->access_register_slrg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_ptas:\n");
	connectib_icmd_access_register_ptas_print(&(ptr_struct->access_register_ptas), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_ppamp:\n");
	connectib_icmd_access_register_ppamp_print(&(ptr_struct->access_register_ppamp), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_pmtu:\n");
	connectib_icmd_access_register_pmtu_print(&(ptr_struct->access_register_pmtu), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_ptys:\n");
	connectib_icmd_access_reg_ptys_print(&(ptr_struct->access_register_ptys), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_ppcnt:\n");
	connectib_icmd_access_register_ppcnt_print(&(ptr_struct->access_register_ppcnt), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "set_get_port_counter:\n");
	connectib_icmd_set_get_port_cntr_print(&(ptr_struct->set_get_port_counter), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_ft_list:\n");
	connectib_icmd_get_ft_list_print(&(ptr_struct->get_ft_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_ft_info:\n");
	connectib_icmd_get_ft_info_print(&(ptr_struct->get_ft_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_fg_list:\n");
	connectib_icmd_get_fg_list_print(&(ptr_struct->get_fg_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_fg:\n");
	connectib_icmd_get_fg_print(&(ptr_struct->get_fg), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_fte_list:\n");
	connectib_icmd_get_fte_list_print(&(ptr_struct->get_fte_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_fte:\n");
	connectib_icmd_get_fte_print(&(ptr_struct->get_fte), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_ste_open_resources:\n");
	connectib_icmd_get_ste_open_resources_print(&(ptr_struct->get_ste_open_resources), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_ste_resources_list:\n");
	connectib_icmd_get_ste_resources_list_print(&(ptr_struct->get_ste_resources_list), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "read_ste:\n");
	connectib_icmd_read_ste_print(&(ptr_struct->read_ste), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "access_register_pvlc:\n");
	connectib_icmd_access_register_pvlc_print(&(ptr_struct->access_register_pvlc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "general_fault_injector:\n");
	connectib_icmd_general_fault_injector_print(&(ptr_struct->general_fault_injector), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gen_assert:\n");
	connectib_icmd_gen_assert_print(&(ptr_struct->gen_assert), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "get_pf_ctx:\n");
	connectib_icmd_get_pf_ctx_print(&(ptr_struct->get_pf_ctx), file, indent_level + 1);

}

int connectib_icmd_cmd_size(void){
	 return 768;
}

void connectib_icmd_cmd_dump(const union connectib_icmd_cmd *ptr_struct, FILE* file) {
	connectib_icmd_cmd_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_sigerr_pack(const struct connectib_sw_cqe_sigerr *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_9);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_8);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_7);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_6);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->expected_trans_sig);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->actual_trans_sig);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->expected_ref_tag);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->actual_ref_tag);

	offset=272;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rsvd_5);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->syndrome);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->mkey);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sig_err_byte_h);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->sig_err_byte_l);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_4);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_3);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rsvd_2);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->owner);

	offset=508;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rsvd_0);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rsvd_1);

}

void connectib_sw_cqe_sigerr_unpack(struct connectib_sw_cqe_sigerr *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rsvd_9 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rsvd_8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->rsvd_7 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->rsvd_6 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->expected_trans_sig = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->actual_trans_sig = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->expected_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->actual_ref_tag = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=272;
	ptr_struct->rsvd_5 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=256;
	ptr_struct->syndrome = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=288;
	ptr_struct->mkey = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->sig_err_byte_h = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->sig_err_byte_l = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->rsvd_4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->rsvd_3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=456;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=448;
	ptr_struct->rsvd_2 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=511;
	ptr_struct->owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=508;
	ptr_struct->rsvd_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=504;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=496;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->rsvd_1 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_sw_cqe_sigerr_print(const struct connectib_sw_cqe_sigerr *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe_sigerr ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_9               : "U32H_FMT"\n", ptr_struct->rsvd_9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_8               : "U32H_FMT"\n", ptr_struct->rsvd_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_7               : "U32H_FMT"\n", ptr_struct->rsvd_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_6               : "U32H_FMT"\n", ptr_struct->rsvd_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_trans_sig   : "U32H_FMT"\n", ptr_struct->expected_trans_sig);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "actual_trans_sig     : "U32H_FMT"\n", ptr_struct->actual_trans_sig);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "expected_ref_tag     : "U32H_FMT"\n", ptr_struct->expected_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "actual_ref_tag       : "U32H_FMT"\n", ptr_struct->actual_ref_tag);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_5               : "UH_FMT"\n", ptr_struct->rsvd_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrome             : "UH_FMT"\n", ptr_struct->syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mkey                 : "U32H_FMT"\n", ptr_struct->mkey);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sig_err_byte_h       : "U32H_FMT"\n", ptr_struct->sig_err_byte_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sig_err_byte_l       : "U32H_FMT"\n", ptr_struct->sig_err_byte_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_4               : "U32H_FMT"\n", ptr_struct->rsvd_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_3               : "U32H_FMT"\n", ptr_struct->rsvd_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_2               : "UH_FMT"\n", ptr_struct->rsvd_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner                : "UH_FMT"\n", ptr_struct->owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_0               : "UH_FMT"\n", ptr_struct->rsvd_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_1               : "UH_FMT"\n", ptr_struct->rsvd_1);

}

int connectib_sw_cqe_sigerr_size(void){
	 return 64;
}

void connectib_sw_cqe_sigerr_dump(const struct connectib_sw_cqe_sigerr *ptr_struct, FILE* file) {
	connectib_sw_cqe_sigerr_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_resize_pack(const struct connectib_sw_cqe_resize *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_14);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_13);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_12);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_11);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_10);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_9);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_8);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_7);

	offset=256;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_6);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_5);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_4);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_3);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_h);

	offset=416;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->timestamp_l);

	offset=448;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_2);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->owner);

	offset=508;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rsvd_1);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->opcode);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->rsvd_0);

}

void connectib_sw_cqe_resize_unpack(struct connectib_sw_cqe_resize *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rsvd_14 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rsvd_13 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->rsvd_12 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->rsvd_11 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->rsvd_10 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->rsvd_9 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->rsvd_8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->rsvd_7 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=256;
	ptr_struct->rsvd_6 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=288;
	ptr_struct->rsvd_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->rsvd_4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->rsvd_3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->timestamp_h = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->timestamp_l = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=448;
	ptr_struct->rsvd_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=511;
	ptr_struct->owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=508;
	ptr_struct->rsvd_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=504;
	ptr_struct->opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=496;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->rsvd_0 = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_sw_cqe_resize_print(const struct connectib_sw_cqe_resize *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe_resize ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_14              : "U32H_FMT"\n", ptr_struct->rsvd_14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_13              : "U32H_FMT"\n", ptr_struct->rsvd_13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_12              : "U32H_FMT"\n", ptr_struct->rsvd_12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_11              : "U32H_FMT"\n", ptr_struct->rsvd_11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_10              : "U32H_FMT"\n", ptr_struct->rsvd_10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_9               : "U32H_FMT"\n", ptr_struct->rsvd_9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_8               : "U32H_FMT"\n", ptr_struct->rsvd_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_7               : "U32H_FMT"\n", ptr_struct->rsvd_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_6               : "U32H_FMT"\n", ptr_struct->rsvd_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_5               : "U32H_FMT"\n", ptr_struct->rsvd_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_4               : "U32H_FMT"\n", ptr_struct->rsvd_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_3               : "U32H_FMT"\n", ptr_struct->rsvd_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_h          : "U32H_FMT"\n", ptr_struct->timestamp_h);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "timestamp_l          : "U32H_FMT"\n", ptr_struct->timestamp_l);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_2               : "U32H_FMT"\n", ptr_struct->rsvd_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner                : "UH_FMT"\n", ptr_struct->owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_1               : "UH_FMT"\n", ptr_struct->rsvd_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "opcode               : "UH_FMT"\n", ptr_struct->opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_0               : "UH_FMT"\n", ptr_struct->rsvd_0);

}

int connectib_sw_cqe_resize_size(void){
	 return 64;
}

void connectib_sw_cqe_resize_dump(const struct connectib_sw_cqe_resize *ptr_struct, FILE* file) {
	connectib_sw_cqe_resize_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_error_pack(const struct connectib_sw_cqe_error *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_14);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_13);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_12);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_11);

	offset=128;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_10);

	offset=160;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_9);

	offset=192;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_8);

	offset=224;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_7);

	offset=264;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->srq_num);

	offset=256;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->rsvd_6);

	offset=288;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_5);

	offset=320;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_4);

	offset=352;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_3);

	offset=384;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->rsvd_2);

	offset=440;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->syndrome);

	offset=432;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_error_syndrome);

	offset=428;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rsvd_1);

	offset=424;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->hw_syndrome_type);

	offset=416;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->vendor_hw_syndrome);

	offset=456;
	adb2c_push_bits_to_buff(ptr_buff, offset, 24, (u_int32_t)ptr_struct->qpn);

	offset=448;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->swqe_opcode_drop_cntr);

	offset=511;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->owner);

	offset=508;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->rsvd_0);

	offset=504;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->rwqe_opcode);

	offset=496;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->signature);

	offset=480;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->wqe_counter);

}

void connectib_sw_cqe_error_unpack(struct connectib_sw_cqe_error *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->rsvd_14 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->rsvd_13 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->rsvd_12 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->rsvd_11 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=128;
	ptr_struct->rsvd_10 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=160;
	ptr_struct->rsvd_9 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=192;
	ptr_struct->rsvd_8 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=224;
	ptr_struct->rsvd_7 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=264;
	ptr_struct->srq_num = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=256;
	ptr_struct->rsvd_6 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=288;
	ptr_struct->rsvd_5 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=320;
	ptr_struct->rsvd_4 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=352;
	ptr_struct->rsvd_3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=384;
	ptr_struct->rsvd_2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=440;
	ptr_struct->syndrome = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=432;
	ptr_struct->vendor_error_syndrome = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=428;
	ptr_struct->rsvd_1 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=424;
	ptr_struct->hw_syndrome_type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=416;
	ptr_struct->vendor_hw_syndrome = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=456;
	ptr_struct->qpn = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 24);

	offset=448;
	ptr_struct->swqe_opcode_drop_cntr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=511;
	ptr_struct->owner = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=508;
	ptr_struct->rsvd_0 = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=504;
	ptr_struct->rwqe_opcode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=496;
	ptr_struct->signature = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=480;
	ptr_struct->wqe_counter = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_sw_cqe_error_print(const struct connectib_sw_cqe_error *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe_error ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_14              : "U32H_FMT"\n", ptr_struct->rsvd_14);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_13              : "U32H_FMT"\n", ptr_struct->rsvd_13);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_12              : "U32H_FMT"\n", ptr_struct->rsvd_12);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_11              : "U32H_FMT"\n", ptr_struct->rsvd_11);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_10              : "U32H_FMT"\n", ptr_struct->rsvd_10);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_9               : "U32H_FMT"\n", ptr_struct->rsvd_9);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_8               : "U32H_FMT"\n", ptr_struct->rsvd_8);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_7               : "U32H_FMT"\n", ptr_struct->rsvd_7);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_num              : "UH_FMT"\n", ptr_struct->srq_num);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_6               : "UH_FMT"\n", ptr_struct->rsvd_6);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_5               : "U32H_FMT"\n", ptr_struct->rsvd_5);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_4               : "U32H_FMT"\n", ptr_struct->rsvd_4);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_3               : "U32H_FMT"\n", ptr_struct->rsvd_3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_2               : "U32H_FMT"\n", ptr_struct->rsvd_2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "syndrome             : "UH_FMT"\n", ptr_struct->syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_error_syndrome : "UH_FMT"\n", ptr_struct->vendor_error_syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_1               : "UH_FMT"\n", ptr_struct->rsvd_1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_syndrome_type     : "UH_FMT"\n", ptr_struct->hw_syndrome_type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "vendor_hw_syndrome   : "UH_FMT"\n", ptr_struct->vendor_hw_syndrome);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "qpn                  : "UH_FMT"\n", ptr_struct->qpn);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "swqe_opcode_drop_cntr : "UH_FMT"\n", ptr_struct->swqe_opcode_drop_cntr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "owner                : "UH_FMT"\n", ptr_struct->owner);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rsvd_0               : "UH_FMT"\n", ptr_struct->rsvd_0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rwqe_opcode          : "UH_FMT"\n", ptr_struct->rwqe_opcode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature            : "UH_FMT"\n", ptr_struct->signature);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "wqe_counter          : "UH_FMT"\n", ptr_struct->wqe_counter);

}

int connectib_sw_cqe_error_size(void){
	 return 64;
}

void connectib_sw_cqe_error_dump(const struct connectib_sw_cqe_error *ptr_struct, FILE* file) {
	connectib_sw_cqe_error_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_128b_pack(const struct connectib_sw_cqe_128b *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_grh_inline_data_pack(&(ptr_struct->grh_inline_data), ptr_buff + offset/8);

	offset=512;
	connectib_sw_cqe_64b_pack(&(ptr_struct->cqe_64b), ptr_buff + offset/8);

}

void connectib_sw_cqe_128b_unpack(struct connectib_sw_cqe_128b *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_grh_inline_data_unpack(&(ptr_struct->grh_inline_data), ptr_buff + offset/8);

	offset=512;
	connectib_sw_cqe_64b_unpack(&(ptr_struct->cqe_64b), ptr_buff + offset/8);

}

void connectib_sw_cqe_128b_print(const struct connectib_sw_cqe_128b *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe_128b ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "grh_inline_data:\n");
	connectib_grh_inline_data_print(&(ptr_struct->grh_inline_data), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_64b:\n");
	connectib_sw_cqe_64b_print(&(ptr_struct->cqe_64b), file, indent_level + 1);

}

int connectib_sw_cqe_128b_size(void){
	 return 128;
}

void connectib_sw_cqe_128b_dump(const struct connectib_sw_cqe_128b *ptr_struct, FILE* file) {
	connectib_sw_cqe_128b_print(ptr_struct, file, 0);
}

void connectib_itoc_entry_pack(const struct connectib_itoc_entry *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	adb2c_push_bits_to_buff(ptr_buff, offset, 22, (u_int32_t)ptr_struct->size);

	offset=0;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->type);

	offset=34;
	adb2c_push_bits_to_buff(ptr_buff, offset, 30, (u_int32_t)ptr_struct->param0);

	offset=33;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->cache_line_crc);

	offset=32;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->zipped_image);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->param1);

	offset=161;
	adb2c_push_bits_to_buff(ptr_buff, offset, 29, (u_int32_t)ptr_struct->flash_addr);

	offset=160;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->relative_addr);

	offset=208;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->section_crc);

	offset=207;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->no_crc);

	offset=206;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->device_data);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->itoc_entry_crc);

}

void connectib_itoc_entry_unpack(struct connectib_itoc_entry *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=8;
	ptr_struct->size = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 22);

	offset=0;
	ptr_struct->type = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=34;
	ptr_struct->param0 = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 30);

	offset=33;
	ptr_struct->cache_line_crc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=32;
	ptr_struct->zipped_image = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=64;
	ptr_struct->param1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=161;
	ptr_struct->flash_addr = (u_int32_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 29);

	offset=160;
	ptr_struct->relative_addr = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=208;
	ptr_struct->section_crc = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

	offset=207;
	ptr_struct->no_crc = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=206;
	ptr_struct->device_data = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=240;
	ptr_struct->itoc_entry_crc = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_itoc_entry_print(const struct connectib_itoc_entry *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_itoc_entry ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "size                 : "UH_FMT"\n", ptr_struct->size);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "type                 : "UH_FMT"\n", ptr_struct->type);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "param0               : "UH_FMT"\n", ptr_struct->param0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cache_line_crc       : "UH_FMT"\n", ptr_struct->cache_line_crc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "zipped_image         : "UH_FMT"\n", ptr_struct->zipped_image);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "param1               : "U32H_FMT"\n", ptr_struct->param1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "flash_addr           : "UH_FMT"\n", ptr_struct->flash_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "relative_addr        : "UH_FMT"\n", ptr_struct->relative_addr);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "section_crc          : "UH_FMT"\n", ptr_struct->section_crc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "no_crc               : "UH_FMT"\n", ptr_struct->no_crc);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_data          : "UH_FMT"\n", ptr_struct->device_data);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "itoc_entry_crc       : "UH_FMT"\n", ptr_struct->itoc_entry_crc);

}

int connectib_itoc_entry_size(void){
	 return 32;
}

void connectib_itoc_entry_dump(const struct connectib_itoc_entry *ptr_struct, FILE* file) {
	connectib_itoc_entry_print(ptr_struct, file, 0);
}

void connectib_itoc_header_pack(const struct connectib_itoc_header *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature0);

	offset=32;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature1);

	offset=64;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature2);

	offset=96;
	adb2c_push_integer_to_buff(ptr_buff, offset, 4, (u_int64_t)ptr_struct->signature3);

	offset=152;
	adb2c_push_bits_to_buff(ptr_buff, offset, 8, (u_int32_t)ptr_struct->version);

	offset=240;
	adb2c_push_bits_to_buff(ptr_buff, offset, 16, (u_int32_t)ptr_struct->itoc_entry_crc);

}

void connectib_itoc_header_unpack(struct connectib_itoc_header *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	ptr_struct->signature0 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=32;
	ptr_struct->signature1 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=64;
	ptr_struct->signature2 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=96;
	ptr_struct->signature3 = (u_int32_t)adb2c_pop_integer_from_buff(ptr_buff, offset, 4);

	offset=152;
	ptr_struct->version = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 8);

	offset=240;
	ptr_struct->itoc_entry_crc = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 16);

}

void connectib_itoc_header_print(const struct connectib_itoc_header *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_itoc_header ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature0           : "U32H_FMT"\n", ptr_struct->signature0);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature1           : "U32H_FMT"\n", ptr_struct->signature1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature2           : "U32H_FMT"\n", ptr_struct->signature2);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature3           : "U32H_FMT"\n", ptr_struct->signature3);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "version              : "UH_FMT"\n", ptr_struct->version);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "itoc_entry_crc       : "UH_FMT"\n", ptr_struct->itoc_entry_crc);

}

int connectib_itoc_header_size(void){
	 return 32;
}

void connectib_itoc_header_dump(const struct connectib_itoc_header *ptr_struct, FILE* file) {
	connectib_itoc_header_print(ptr_struct, file, 0);
}

void connectib_sw_wqe_pack(const struct connectib_sw_wqe *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_wqe_control_pack(&(ptr_struct->conrtol), ptr_buff + offset/8);

	offset=128;
	connectib_wqe_mlx_pack(&(ptr_struct->mlx), ptr_buff + offset/8);

	offset=256;
	connectib_wqe_xrc_pack(&(ptr_struct->xrc), ptr_buff + offset/8);

	offset=384;
	connectib_wqe_address_vector_basic_pack(&(ptr_struct->address_vector_basic), ptr_buff + offset/8);

	offset=512;
	connectib_wqe_address_vector_ext_pack(&(ptr_struct->address_vector_ext), ptr_buff + offset/8);

	offset=768;
	connectib_wqe_rdma_read_pack(&(ptr_struct->rdma_read), ptr_buff + offset/8);

	offset=896;
	connectib_wqe_atomic_cmp_swap_pack(&(ptr_struct->atomic_cmp_swap), ptr_buff + offset/8);

	offset=1024;
	connectib_wqe_extended_atomic_cmp_swap_pack(&(ptr_struct->ext_atom_cmp_swap), ptr_buff + offset/8);

	offset=5120;
	connectib_wqe_atomic_fetch_add_pack(&(ptr_struct->atomic_fetch_add), ptr_buff + offset/8);

	offset=5248;
	connectib_wqe_extended_atomic_fetch_add_pack(&(ptr_struct->ext_atom_fetch_add), ptr_buff + offset/8);

	offset=7296;
	connectib_wqe_signature_pack(&(ptr_struct->signature), ptr_buff + offset/8);

	offset=7424;
	connectib_wqe_srq_next_pack(&(ptr_struct->srq_next), ptr_buff + offset/8);

	offset=7552;
	connectib_wqe_gather_scatter_entry_pack(&(ptr_struct->gather_scatter_entry), ptr_buff + offset/8);

	offset=7680;
	connectib_wqe_inline_header_pack(&(ptr_struct->inline_header), ptr_buff + offset/8);

	offset=7808;
	connectib_wqe_eth_segment_pack(&(ptr_struct->eth_segment), ptr_buff + offset/8);

}

void connectib_sw_wqe_unpack(struct connectib_sw_wqe *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_wqe_control_unpack(&(ptr_struct->conrtol), ptr_buff + offset/8);

	offset=128;
	connectib_wqe_mlx_unpack(&(ptr_struct->mlx), ptr_buff + offset/8);

	offset=256;
	connectib_wqe_xrc_unpack(&(ptr_struct->xrc), ptr_buff + offset/8);

	offset=384;
	connectib_wqe_address_vector_basic_unpack(&(ptr_struct->address_vector_basic), ptr_buff + offset/8);

	offset=512;
	connectib_wqe_address_vector_ext_unpack(&(ptr_struct->address_vector_ext), ptr_buff + offset/8);

	offset=768;
	connectib_wqe_rdma_read_unpack(&(ptr_struct->rdma_read), ptr_buff + offset/8);

	offset=896;
	connectib_wqe_atomic_cmp_swap_unpack(&(ptr_struct->atomic_cmp_swap), ptr_buff + offset/8);

	offset=1024;
	connectib_wqe_extended_atomic_cmp_swap_unpack(&(ptr_struct->ext_atom_cmp_swap), ptr_buff + offset/8);

	offset=5120;
	connectib_wqe_atomic_fetch_add_unpack(&(ptr_struct->atomic_fetch_add), ptr_buff + offset/8);

	offset=5248;
	connectib_wqe_extended_atomic_fetch_add_unpack(&(ptr_struct->ext_atom_fetch_add), ptr_buff + offset/8);

	offset=7296;
	connectib_wqe_signature_unpack(&(ptr_struct->signature), ptr_buff + offset/8);

	offset=7424;
	connectib_wqe_srq_next_unpack(&(ptr_struct->srq_next), ptr_buff + offset/8);

	offset=7552;
	connectib_wqe_gather_scatter_entry_unpack(&(ptr_struct->gather_scatter_entry), ptr_buff + offset/8);

	offset=7680;
	connectib_wqe_inline_header_unpack(&(ptr_struct->inline_header), ptr_buff + offset/8);

	offset=7808;
	connectib_wqe_eth_segment_unpack(&(ptr_struct->eth_segment), ptr_buff + offset/8);

}

void connectib_sw_wqe_print(const struct connectib_sw_wqe *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_wqe ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "conrtol:\n");
	connectib_wqe_control_print(&(ptr_struct->conrtol), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mlx:\n");
	connectib_wqe_mlx_print(&(ptr_struct->mlx), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "xrc:\n");
	connectib_wqe_xrc_print(&(ptr_struct->xrc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address_vector_basic:\n");
	connectib_wqe_address_vector_basic_print(&(ptr_struct->address_vector_basic), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "address_vector_ext:\n");
	connectib_wqe_address_vector_ext_print(&(ptr_struct->address_vector_ext), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "rdma_read:\n");
	connectib_wqe_rdma_read_print(&(ptr_struct->rdma_read), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_cmp_swap:\n");
	connectib_wqe_atomic_cmp_swap_print(&(ptr_struct->atomic_cmp_swap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_atom_cmp_swap:\n");
	connectib_wqe_extended_atomic_cmp_swap_print(&(ptr_struct->ext_atom_cmp_swap), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "atomic_fetch_add:\n");
	connectib_wqe_atomic_fetch_add_print(&(ptr_struct->atomic_fetch_add), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ext_atom_fetch_add:\n");
	connectib_wqe_extended_atomic_fetch_add_print(&(ptr_struct->ext_atom_fetch_add), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "signature:\n");
	connectib_wqe_signature_print(&(ptr_struct->signature), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "srq_next:\n");
	connectib_wqe_srq_next_print(&(ptr_struct->srq_next), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "gather_scatter_entry:\n");
	connectib_wqe_gather_scatter_entry_print(&(ptr_struct->gather_scatter_entry), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "inline_header:\n");
	connectib_wqe_inline_header_print(&(ptr_struct->inline_header), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "eth_segment:\n");
	connectib_wqe_eth_segment_print(&(ptr_struct->eth_segment), file, indent_level + 1);

}

int connectib_sw_wqe_size(void){
	 return 1024;
}

void connectib_sw_wqe_dump(const struct connectib_sw_wqe *ptr_struct, FILE* file) {
	connectib_sw_wqe_print(ptr_struct, file, 0);
}

void connectib_ini_pack(const union connectib_ini *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_nv_data_pack(&(ptr_struct->fw_nv_log), ptr_buff);
}

void connectib_ini_unpack(union connectib_ini *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_nv_data_unpack(&(ptr_struct->fw_nv_log), ptr_buff);
}

void connectib_ini_print(const union connectib_ini *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_ini ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "boot_record:\n");
	connectib_boot_record_golan_print(&(ptr_struct->boot_record), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "reset_info:\n");
	connectib_reset_info_print(&(ptr_struct->reset_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dtoc_pointers:\n");
	connectib_dtoc_pointers_print(&(ptr_struct->dtoc_pointers), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "device_info:\n");
	connectib_device_info_print(&(ptr_struct->device_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "image_info:\n");
	connectib_image_info_print(&(ptr_struct->image_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "mfg_info:\n");
	connectib_mfg_info_print(&(ptr_struct->mfg_info), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_main_config:\n");
	connectib_fw_main_config_print(&(ptr_struct->fw_main_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_boot_config:\n");
	connectib_fw_boot_config_print(&(ptr_struct->fw_boot_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_main_config:\n");
	connectib_hw_main_config_print(&(ptr_struct->hw_main_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_boot_config:\n");
	connectib_hw_boot_config_print(&(ptr_struct->hw_boot_config), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_data_0:\n");
	connectib_nv_data_print(&(ptr_struct->nv_data_0), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "nv_data_1:\n");
	connectib_nv_data_print(&(ptr_struct->nv_data_1), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "fw_nv_log:\n");
	connectib_nv_data_print(&(ptr_struct->fw_nv_log), file, indent_level + 1);

}

int connectib_ini_size(void){
	 return 65536;
}

void connectib_ini_dump(const union connectib_ini *ptr_struct, FILE* file) {
	connectib_ini_print(ptr_struct, file, 0);
}

void connectib_a2d_pack(const struct connectib_a2d *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->power_up);

	offset=28;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->clock_div);

	offset=24;
	adb2c_push_bits_to_buff(ptr_buff, offset, 4, (u_int32_t)ptr_struct->probe_sel);

	offset=22;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->measure_mode);

	offset=19;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->clock_sel);

	offset=18;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->measure_polarity);

	offset=62;
	adb2c_push_bits_to_buff(ptr_buff, offset, 2, (u_int32_t)ptr_struct->pad_out_sel);

	offset=61;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spike_direction);

	offset=57;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->dynamic_range);

	offset=51;
	adb2c_push_bits_to_buff(ptr_buff, offset, 3, (u_int32_t)ptr_struct->measure_serdes_probe);

	offset=50;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->thermal_protect_en);

	offset=85;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->measure_value);

	offset=84;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->circuit_binary_done);

	offset=83;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->a2d_compare);

	offset=82;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->spike_detect);

	offset=123;
	adb2c_push_bits_to_buff(ptr_buff, offset, 5, (u_int32_t)ptr_struct->stabilization_time);

	offset=149;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->measure_min);

	offset=148;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->measure_compare);

	offset=181;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->measure_max);

	offset=213;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->protect_value);

	offset=212;
	adb2c_push_bits_to_buff(ptr_buff, offset, 1, (u_int32_t)ptr_struct->protect_polarity);

	offset=245;
	adb2c_push_bits_to_buff(ptr_buff, offset, 11, (u_int32_t)ptr_struct->calib_value);

}

void connectib_a2d_unpack(struct connectib_a2d *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=31;
	ptr_struct->power_up = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=28;
	ptr_struct->clock_div = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=24;
	ptr_struct->probe_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 4);

	offset=22;
	ptr_struct->measure_mode = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=19;
	ptr_struct->clock_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=18;
	ptr_struct->measure_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=62;
	ptr_struct->pad_out_sel = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 2);

	offset=61;
	ptr_struct->spike_direction = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=57;
	ptr_struct->dynamic_range = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=51;
	ptr_struct->measure_serdes_probe = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 3);

	offset=50;
	ptr_struct->thermal_protect_en = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=85;
	ptr_struct->measure_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=84;
	ptr_struct->circuit_binary_done = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=83;
	ptr_struct->a2d_compare = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=82;
	ptr_struct->spike_detect = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=123;
	ptr_struct->stabilization_time = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 5);

	offset=149;
	ptr_struct->measure_min = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=148;
	ptr_struct->measure_compare = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=181;
	ptr_struct->measure_max = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=213;
	ptr_struct->protect_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

	offset=212;
	ptr_struct->protect_polarity = (u_int8_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 1);

	offset=245;
	ptr_struct->calib_value = (u_int16_t)adb2c_pop_bits_from_buff(ptr_buff, offset, 11);

}

void connectib_a2d_print(const struct connectib_a2d *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_a2d ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "power_up             : "UH_FMT"\n", ptr_struct->power_up);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clock_div            : "UH_FMT"\n", ptr_struct->clock_div);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "probe_sel            : "UH_FMT"\n", ptr_struct->probe_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_mode         : "UH_FMT"\n", ptr_struct->measure_mode);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "clock_sel            : "UH_FMT"\n", ptr_struct->clock_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_polarity     : "UH_FMT"\n", ptr_struct->measure_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "pad_out_sel          : "UH_FMT"\n", ptr_struct->pad_out_sel);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spike_direction      : "UH_FMT"\n", ptr_struct->spike_direction);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "dynamic_range        : "UH_FMT"\n", ptr_struct->dynamic_range);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_serdes_probe : "UH_FMT"\n", ptr_struct->measure_serdes_probe);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "thermal_protect_en   : "UH_FMT"\n", ptr_struct->thermal_protect_en);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_value        : "UH_FMT"\n", ptr_struct->measure_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "circuit_binary_done  : "UH_FMT"\n", ptr_struct->circuit_binary_done);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a2d_compare          : "UH_FMT"\n", ptr_struct->a2d_compare);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "spike_detect         : "UH_FMT"\n", ptr_struct->spike_detect);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "stabilization_time   : "UH_FMT"\n", ptr_struct->stabilization_time);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_min          : "UH_FMT"\n", ptr_struct->measure_min);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_compare      : "UH_FMT"\n", ptr_struct->measure_compare);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "measure_max          : "UH_FMT"\n", ptr_struct->measure_max);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "protect_value        : "UH_FMT"\n", ptr_struct->protect_value);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "protect_polarity     : "UH_FMT"\n", ptr_struct->protect_polarity);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "calib_value          : "UH_FMT"\n", ptr_struct->calib_value);

}

int connectib_a2d_size(void){
	 return 32;
}

void connectib_a2d_dump(const struct connectib_a2d *ptr_struct, FILE* file) {
	connectib_a2d_print(ptr_struct, file, 0);
}

void connectib_icmd_pack(const struct connectib_icmd *ptr_struct, u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_cmd_pack(&(ptr_struct->cmd), ptr_buff + offset/8);

	offset=8064;
	connectib_icmd_ctrl_pack(&(ptr_struct->ctrl), ptr_buff + offset/8);

}

void connectib_icmd_unpack(struct connectib_icmd *ptr_struct, const u_int8_t* ptr_buff){
	u_int32_t offset;
	int i=0;
	u_int8_t val=0;
	(void)val;
	(void)offset;
	(void)i;
	(void)ptr_struct;
	(void)ptr_buff;

	offset=0;
	connectib_icmd_cmd_unpack(&(ptr_struct->cmd), ptr_buff + offset/8);

	offset=8064;
	connectib_icmd_ctrl_unpack(&(ptr_struct->ctrl), ptr_buff + offset/8);

}

void connectib_icmd_print(const struct connectib_icmd *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_icmd ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cmd:\n");
	connectib_icmd_cmd_print(&(ptr_struct->cmd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ctrl:\n");
	connectib_icmd_ctrl_print(&(ptr_struct->ctrl), file, indent_level + 1);

}

int connectib_icmd_size(void){
	 return 1024;
}

void connectib_icmd_dump(const struct connectib_icmd *ptr_struct, FILE* file) {
	connectib_icmd_print(ptr_struct, file, 0);
}

void connectib_sw_cqe_pack(const union connectib_sw_cqe *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_sw_cqe_sigerr_pack(&(ptr_struct->cqe_sigerr), ptr_buff);
}

void connectib_sw_cqe_unpack(union connectib_sw_cqe *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_sw_cqe_sigerr_unpack(&(ptr_struct->cqe_sigerr), ptr_buff);
}

void connectib_sw_cqe_print(const union connectib_sw_cqe *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_sw_cqe ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_64b:\n");
	connectib_sw_cqe_64b_print(&(ptr_struct->cqe_64b), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_128b:\n");
	connectib_sw_cqe_128b_print(&(ptr_struct->cqe_128b), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_error:\n");
	connectib_sw_cqe_error_print(&(ptr_struct->cqe_error), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_resize:\n");
	connectib_sw_cqe_resize_print(&(ptr_struct->cqe_resize), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "cqe_sigerr:\n");
	connectib_sw_cqe_sigerr_print(&(ptr_struct->cqe_sigerr), file, indent_level + 1);

}

int connectib_sw_cqe_size(void){
	 return 128;
}

void connectib_sw_cqe_dump(const union connectib_sw_cqe *ptr_struct, FILE* file) {
	connectib_sw_cqe_print(ptr_struct, file, 0);
}

void connectib_itoc_pack(const union connectib_itoc *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_itoc_entry_pack(&(ptr_struct->entry), ptr_buff);
}

void connectib_itoc_unpack(union connectib_itoc *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_itoc_entry_unpack(&(ptr_struct->entry), ptr_buff);
}

void connectib_itoc_print(const union connectib_itoc *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_itoc ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "header:\n");
	connectib_itoc_header_print(&(ptr_struct->header), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "entry:\n");
	connectib_itoc_entry_print(&(ptr_struct->entry), file, indent_level + 1);

}

int connectib_itoc_size(void){
	 return 32;
}

void connectib_itoc_dump(const union connectib_itoc *ptr_struct, FILE* file) {
	connectib_itoc_print(ptr_struct, file, 0);
}

void connectib_connectib_Nodes_pack(const union connectib_connectib_Nodes *ptr_struct, u_int8_t* ptr_buff)
{
	connectib_sw_eqe_pack(&(ptr_struct->sw_eqe), ptr_buff);
}

void connectib_connectib_Nodes_unpack(union connectib_connectib_Nodes *ptr_struct, const u_int8_t* ptr_buff)
{
	connectib_sw_eqe_unpack(&(ptr_struct->sw_eqe), ptr_buff);
}

void connectib_connectib_Nodes_print(const union connectib_connectib_Nodes *ptr_struct, FILE* file, int indent_level){
	adb2c_add_indentation(file, indent_level);
	fprintf(file, "======== connectib_connectib_Nodes ========\n");
	int i=0;
	(void)i;(void)ptr_struct;
	(void)file;
	(void)indent_level;

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "itoc:\n");
	connectib_itoc_print(&(ptr_struct->itoc), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "hw_hca_contexts:\n");
	connectib_hw_hca_contexts_print(&(ptr_struct->hw_hca_contexts), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "guids:\n");
	connectib_guids_print(&(ptr_struct->guids), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_cqe:\n");
	connectib_sw_cqe_print(&(ptr_struct->sw_cqe), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "icmd:\n");
	connectib_icmd_print(&(ptr_struct->icmd), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "a2d:\n");
	connectib_a2d_print(&(ptr_struct->a2d), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "ini:\n");
	connectib_ini_print(&(ptr_struct->ini), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_wqe:\n");
	connectib_sw_wqe_print(&(ptr_struct->sw_wqe), file, indent_level + 1);

	adb2c_add_indentation(file, indent_level);
	fprintf(file, "sw_eqe:\n");
	connectib_sw_eqe_print(&(ptr_struct->sw_eqe), file, indent_level + 1);

}

int connectib_connectib_Nodes_size(void){
	 return 65536;
}

void connectib_connectib_Nodes_dump(const union connectib_connectib_Nodes *ptr_struct, FILE* file) {
	connectib_connectib_Nodes_print(ptr_struct, file, 0);
}

